

require("config")
require("cocos.init")
require("framework.init")
require("app.data.GameData")
--DataEye
require("framework.DCLevels")
require("framework.DCAgent")
require("framework.DCEvent")
require("framework.DCTask")
require("framework.DCItem")
require("framework.DCCoin")
require("framework.DCVirtualCurrency")
require("framework.DCConfigParams")
--DataEye
import(".common.kkFunc")
GameState = require("framework.cc.utils.GameState")
GameData = {}
GAME_VERSION = 1.0

--全局变量
globalVar = {
    levelOpenNew = false,
    levelMapPos = cc.p(0,0),
    levelScene = nil,
}

local LoadingLayer = import(".views.LoadingLayer")

local MyApp = class("MyApp", cc.mvc.AppBase)
function MyApp:ctor()
    MyApp.super.ctor(self)

        --厦门--
    --海外版
    -- if device.platform == "android" and VERSION_REDUCE then
    --     local className = "org/cocos2dx/lua/AppActivity"
    --     local sig = "(I)V"
    --     local args = {kkFunc.CallBack}
    --     luaj.callStaticMethod(className, "RegisterLuaFunc",args,sig)
    -- end
    -- if device.platform == "android" and VERSION_REDUCE and not TEST_DEMO then
    --     local className = "org/cocos2dx/lua/AppActivity"
    --     local sig = "()Ljava/lang/String;"
    --     local args = {}
    --     local ok, hashCode = luaj.callStaticMethod(className, "getHashCode",args,sig)
    --     if not ok or hashCode ~= "1822362018" then
    --         cc.Director:getInstance():endToLua()
    --     end
    -- end
        --DataEye
    -- if device.platform == "ios" then 
    --     DCAgent.setReportMode(DC_DEFAULT)
    --     --设置上报模式，在onStart之前调用 
    --     DCAgent.setDebugMode(true)
    --     --YOUR_APPID与YOUR_CHANNELID需要更换为游戏自己的AppId和ChannelId 
    --     DCAgent.onStart("A99902CA205301D724981384B9323E30", "JIDI")
    -- end
    --     --[[在线参数更新接口，在进入游戏时调用，该接口会将参数更新到本地并保存起来，在需要获取参数时调用getParams获取即可]]
    -- if device.platform == "android" or device.platform == "ios" then
    --     DCConfigParams.update()
    -- end
        --厦门--

    --init GameState
    GameState.init(function(param)
        local returnValue=nil
        if param.errorCode then
            print("error")
        else
            --crypto
            if param.name=="save" then
                local str=json.encode(param.values)
                str=crypto.encryptXXTEA(str, "kk")--加密
                returnValue={data=str}
            elseif param.name=="load" then
                local str=crypto.decryptXXTEA(param.values.data, "kk") --解密
                returnValue=json.decode(str)
            end
            -- returnValue=param.values
        end
        return returnValue
    end, "data.txt","kk")
    if io.exists(GameState.getGameStatePath()) then--要检查的文件或目录的完全路径
        GameData = GameState.load()
    end
    self:initForGameData()
    --dump(GameData)
    --dump(GameData.achievement)
    local isMusicEnable =  kkFunc.isMusicEnable()

    if isMusicEnable == 0 then
        GameData.music = false
        GameData.sound = false
        GameState.save(GameData)
    end
    if OPEN_LEVEL then
        GameData.openlevel = 410
    end
    
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)
    --cc.Director:getInstance():setDepthTest(true)
    cc.Director:getInstance():setProjection(cc.DIRECTOR_PROJECTION2_D)
end


function MyApp:initForGameData()
    --GameData = {}
    --版本没变化直接返回
    if GameData.version == GAME_VERSION then 
        return 
    end
    --第一次运行。
    if GameData.version == nil then
        GameData.timer = {
            lastStartSystemTime = 0,
            timeDelta = 0,
        }
        GameData.version = GAME_VERSION
        GameData.energy = {
            value = 5, --无限体力是-1。
            startTime = 0,
            timeSec = 0,
        }
        GameData.openlevel = 101
        GameData.item = {}
        for i=1,4 do
            GameData.item["i"..i] = {
                number = 0,
                isUnLock = false,--未解锁
            }
            if i <= 2 then
                GameData.item["i"..i].isUnLock = true --12道具开始就解锁解锁
            end
        end
        GameData.diamond = 0
        GameData.carrot = 0
        GameData.rabbitHouse = {
            nestNumber = 2,
            n1 = {
                state = "free",
            },
            n2 = {
                state = "free",
            },
            n3 = {
                state = "lock",
            },
            n4 = {
                state = "lock",
            },
            n5 = {
                state = "lock",
            },
        }
        GameData.myRabbit = {}
        for i = 1, 23 do
            local isOpen = false
            if i <= 23 then isOpen = true end
            GameData.myRabbit["r"..i] = {
                open = isOpen,
                level = 1,
                upgrading = false,
            }
        end
        --任务记录
        --每关三个子任务
        GameData.levelTask = {}
        for k,v in pairs(LevelsData) do
            GameData.levelTask[""..k] = {}
            GameData.levelTask[""..k].star = 0
            for j = 1, 4 do
                GameData.levelTask[""..k][""..j] = false
                GameData.levelTask[""..k]["gift"..j] = false
            end 
        end
        --成就
        AchievementData:initAchieveAndDailyTaskData()
        --新手引导
        GameData.guide = {
            teachLevel = false,
            level1 = false,
            herohouse = false,
            level2 = false,
            level3 = false,
            level7 = false,
            level9 = false,
            level11 = false,
            level12 = false,   
            --levelScene = true,
            --step = 1 ,
        }
        --登录天数
        GameData.login = {
            loginDay = 1,
            year = 0,
            month = 0,
            day = 0,
        }
        --音乐音效
        GameData.music = true
        GameData.sound = true
        --英雄系统
        GameData.selectHero = 1
        GameData.skillPoints = {
            value = 5,
            startTime = 0,
        }
        GameData.heros = {
            h1 = {
                level = 1,
                skill = {
                    s1 = 1,
                    s2 = 0,
                    s3 = 0,
                }
            },
            h2 = {
                level = 0,
                skill = {
                    s1 = 1,
                    s2 = 0,
                    s3 = 0,
                    s4 = 0,
                }
            },
            h3 = {
                level = 0,
                skill = {
                    s1 = 1,
                    s2 = 0,
                    s3 = 0,
                    s4 = 0,
                }
            },
            h4 = {
                level = 0,
                skill = {
                    s1 = 1,
                    s2 = 0,
                    s3 = 0,
                    s4 = 0,
                }
            }
        }
        --体感技能首次提示
        GameData.tips = {
            skill1 = false,
            skill4 = false,
            skill8 = false,
            skill12 = false,
            cloud = false,
            ice = false,
        }
        GameData.giftBag = {
            timeLimit = false,
            freshman = false,
            item = false,
        }
        --每关卡失败次数
        GameData.failNumber = {}
        for k,v in pairs(LevelsData) do
            GameData.failNumber["level"..k] = 0
        end
    end
    --之后的补充数据
    
    GameState.save(GameData)
end

function MyApp:getTotalStarNumber()
    local starNumber = 0
    for i = 1, 4 do
        for j = 1, 10 do
            local l = i*100+j
            if l > GameData.openlevel then
                return starNumber
            end
            starNumber = starNumber + GameData.levelTask[""..l].star
        end
    end
end

function MyApp:run()
    math.randomseed(os.time())
    cc.FileUtils:getInstance():addSearchPath("res/")
    cc.FileUtils:getInstance():addSearchPath("res/ccb/")

    --加载音效，最多三层表结构。
    for k, v in pairs(GAME_SOUND) do
        if type(v) == "table" then
            for k1, v1 in pairs(v) do
                if type(v1) == "table" then
                    for k2, v2 in pairs(v1) do
                        audio.preloadSound(v2)
                    end
                else
                    audio.preloadSound(v1)
                end                
            end
        else
            audio.preloadSound(v)
        end
    end
    --UI背景音乐
    audio.preloadMusic(GAME_MUSIC.BGM1)

    self.res = {"UI_COMMON", "UI_PLAY", "ROLE", "UI_PUBLIC1", "UI_SHOP"}
    for k,v in pairs(self.res) do
        ResData.loadRes(v)
    end

    --厦门
    -- if AIGAME_SERVICE or AIQIYI or KUWO then
    --     self:enterScene("FlashScene")
    -- else
    --     self:enterScene("MainScene")
    -- end  
    self:enterScene("FlashScene")
end

function MyApp:main()
    self:enterScene("MainScene", nil, "fade", 0.1, display.COLOR_BLACK)
end

function MyApp:level(params)
    params = params or {}
    params.loadType = "level"
    if LOADING_CLOUD then
        local loadLayer = LoadingLayer.new(params)
        display.getRunningScene():addChild(loadLayer, 500)
    else
        self:loading(params)
    end
end

function MyApp:realLevel(params)
    self:enterScene("LevelScene", {params}, nil, 0.1, display.COLOR_BLACK)
end

function MyApp:loading(params)
    --临时用，因为565要同步加载，所以不会马上跳到loading页。
    local scene = display.getRunningScene()
    local bg = display.newSprite("pic/loadingBg.png", display.cx, display.cy):addTo(scene,500)
    --display.newSprite("pic/loadingLabel.png", display.cx, display.cy):addTo(scene,500)
    scene:performWithDelay(function()
        self:enterScene("LoadingScene", {params}, nil)
    end, 0.1)
end

function MyApp:play(params)
    params.loadType = "play"
    if LOADING_CLOUD then
        local loadLayer = LoadingLayer.new(params)
        display.getRunningScene():addChild(loadLayer, 500)
    else
        self:loading(params)
    end
end

function MyApp:realPlay(params)
    kkFunc.LogCat("realPlay")
    self:enterScene("PlayScene", {params}, nil, 0.1, display.COLOR_BLACK)
end

function MyApp:rabbitHouse()
    self:enterScene("RabbitHouse", nil, nil, 0.1, display.COLOR_BLACK)
end

function MyApp:heroHouse()
    params = params or {}
    params.loadType = "hero"
    self:loading(params)
end

function MyApp:realHeroHouse()
    self:enterScene("HeroHouse", nil, nil, 0.1, display.COLOR_BLACK)
end

function MyApp:achievement()
    params = params or {}
    params.loadType = "achievement"
    self:loading(params)
end

function MyApp:realAchievement()
    self:enterScene("AchievementScene", nil, nil, 0.1, display.COLOR_BLACK)
end

function MyApp:handbook()
    params = params or {}
    params.loadType = "handbook"
    self:loading(params)
end

function MyApp:realHandbook()
    self:enterScene("Handbook", nil, nil, 0.1, display.COLOR_BLACK)
end

function MyApp:levelbuttonscene(params)
    self:enterScene("LevelButtonScene", {params}, "fade", 0.1, display.COLOR_BLACK)
end

function MyApp:onEnterBackground()
    if display.getRunningScene().onEnterBackground ~= nil then
        display.getRunningScene():onEnterBackground()
    end
end

function MyApp:onEnterForeground()
    if display.getRunningScene().onEnterForeground ~= nil then
        display.getRunningScene():onEnterForeground()
    end
end

return MyApp