--
-- Author: Wangzhihao
-- Date: 2014-12-08 17:34:16
--
--成就
--[[
1	一	完成教学关
2	一	购买1次道具
3	一	购买1个英雄
4	一	升级1次英雄
5	一	升级1次英雄技能
6	二	将任意英雄的任意技能升至X级
7	二	将任意英雄升至X级
8	二	累积获得X个金币
9	二	累积消灭X只怪物
10	二	累积消费X个金币
11	二	累加消费X个钻石
12	二	累积登陆X天
13	二	累积进行X局游戏
14	二	完成第X关
15	二	拥有X个英雄
16	二	将X个英雄升至满级
17	二	累积获得X个星星
]]
AchievementData = {
	[1] = {
		type = 1,
		idx = 1,
	},
	[2] = {
		type = 1,
		idx = 2,
	},
	[3] = {
		type = 1,	
		idx = 3,
	},
	[4] = {
		type = 1,
		idx = 4,
	},
	[5] = {
		type = 1,
		idx = 5,
	},
	[6] = {
		type = 1,
		idx = 6,
		skilllevel = 30,
	},
	[7] = {
		type = 1,
		idx = 7,
		herolevel = 30,
	},
	[8] = {
		type = 2,
		idx = 8,
		needNum = {
			[1] = 2000,
			[2] = 3000,
			[3] = 5000,
		},
	},
	[9] = {
		type = 2,
		idx = 9,
		needNum = {
			[1] = 1000,
			[2] = 2000,
			[3] = 3000,
		},
	},
	[10] = {
		type = 2,
		idx = 10,
		needNum = {
			[1] = 2000,
			[2] = 3000,
			[3] = 5000,
		},
	},
	[11] = {
		type = 2,
		idx = 11,
		needNum = {
			[1] = 100,
			[2] = 200,
			[3] = 300,
		},
	},
	[12] = {
		type = 2,
		idx = 12,
		needNum = {
			[1] = 2,
			[2] = 3,
			[3] = 7,
		},
	},
	[13] = {
		type = 2,
		idx = 13,
		needNum = {
			[1] = 10,
			[2] = 20,
			[3] = 30,
		},
	},
	[14] = {
		type = 1,
		idx = 14,
		level = 10,
	},
	[15] = {
		type = 1,
		idx = 15,
		heroNum = 3,
	},
	[16] = {
		type = 1,
		idx = 16,
		heroNum = 1,
	},
	[17] = {
		type = 2,
		idx = 17,
		needNum = {
			[1] = 50,
			[2] = 100,
			[3] = 120,
		},
	},
}
DailyTask = {
	[1] = {
    	text = "使用2次道具",
    	textEnglish = "Use any prop 2 times",
    	needNum = 2,
    },
    [2] = {
    	text = "升级2次英雄",
    	textEnglish = "Upgrade any hero 2 times",
    	needNum = 2,
    },
    [3] = {
    	text = "升级2次英雄技能",
    	textEnglish = "Upgrade any skill of hero 2 times ",
    	needNum = 2,
    },
    [4] = {
    	text = "累积获得200个金币",
    	textEnglish = "Earn 200 gold coins cumulatively ",
    	needNum = 200,
    },
    [5] = {
    	text = "累积消灭10只怪物",
    	textEnglish = "Kill 10 enemies",
    	needNum = 10,
    },
    [6] = {
    	text = "累积消费200个金币",
    	textEnglish = "Spend 200 gold coins cumulatively",
    	needNum = 200,
    },
    [7] = {
    	text = "累积消费10个钻石",
    	textEnglish = "Spend 10 diamonds cumulatively ",
    	needNum = 10,
    },
    [8] = {
    	text = "累积进行2局游戏",
    	textEnglish = "Play any level 2 times cumulatively ",
    	needNum = 2,
    },
    [9] = {
    	text = "英雄累积消灭2个怪物",
    	textEnglish = "Kill 2 enemies by using any hero",
    	needNum = 2,
    },
    [10] = {
    	text = "女性英雄累积消灭2个怪物",
    	textEnglish = "Kill 2 enemies by using any female hero",
    	needNum = 2,
    },
    [11] = {
    	text = "累积使用2次技能",
    	textEnglish = "Use any skills 2 times",
    	needNum = 2,
    },
}

function AchievementData:initAchieveAndDailyTaskData()
    GameData.achievement = {}
    for i = 1,#AchievementData do
        local t = {
            idx = i,
            recordNum = 0,
        }
        if AchievementData[i].type == 2 then
            for j = 1, #AchievementData[i].needNum do
                t.type = 2
            	t.num = #AchievementData[i].needNum
            	t.openlevel = 1
                t[""..j] = {
                    needNum = AchievementData[i].needNum[j],
                    complete = false,
                    isGifted = false,
                }
            end
        else
            t.complete = false
            t.isGifted = false
        	for k,v in pairs(AchievementData[i]) do
                t[k] = v
            end
        end 
        if i == 12 then
            t.year = 0
            t.month = 0
            t.day = 0
        end
        GameData.achievement[""..i] = t
    end
    --
    GameData.dailytask = {}
    GameData.dailytask.open = 1
    for i =1,3 do
        GameData.dailytask[""..i] = {
            complete = false,
            recordNum = 0,
            type = 1,
        }
    end
end

function AchievementData.getAchieveText(idx,achievement)
	if idx == 1 then
		text = "完成教学关"
		textEnglish = "Complete the teaching level"
	elseif idx == 2 then
		text = "购买1次道具"
		textEnglish = "Buy any prop 1 time"
	elseif idx == 3 then
		text = "购买1个英雄"
		textEnglish = "Buy a hero"
	elseif idx == 4 then
		text = "升级1次英雄"
		textEnglish = "Upgrade the level of any hero 1 time"
	elseif idx == 5 then
		text = "升级1次英雄技能"
		textEnglish = "Upgrade the skill of any hero 1 time"
	elseif idx == 6 then
		text = "将任意英雄的任意技能升至"..achievement.skilllevel.."级"
		textEnglish = "Upgrade the skill of any hero to level "..achievement.skilllevel
	elseif idx == 7 then
		text = "将任意英雄升至"..achievement.herolevel.."级"
		textEnglish = "Upgrade any hero to level "..achievement.herolevel
	elseif idx == 8 then
		text = "累积获得"..achievement.needNum.."个金币"
		textEnglish = "Earn "..achievement.needNum.." gold coins"
	elseif idx == 9 then
		text = "累积消灭"..achievement.needNum.."只怪物"
		textEnglish = "Kill "..achievement.needNum.." enemies"
	elseif idx == 10 then
		text = "累积消费"..achievement.needNum.."个金币"
		textEnglish = "Spend "..achievement.needNum.." gold coins cumulatively"
	elseif idx == 11 then
		text = "累加消费"..achievement.needNum.."个钻石"
		textEnglish = "Spend "..achievement.needNum.." diamonds cumulatively"
	elseif idx == 12 then
		text = "累积登陆"..achievement.needNum.."天"
		textEnglish = "Login the game "..achievement.needNum.." days cumulatively"
	elseif idx == 13 then
		text = "累积进行"..achievement.needNum.."局游戏"
		textEnglish = "Play any level "..achievement.needNum.." times cumulatively"
	elseif idx == 14 then
		text = "完成第"..achievement.level.."关"
		textEnglish = "Complete level "..achievement.level
	elseif idx == 15 then
		text = "拥有"..achievement.heroNum.."个英雄"
		textEnglish = "Own "..achievement.heroNum.." hero"
	elseif idx == 16 then
		text = "将"..achievement.heroNum.."个英雄升至满级"
		textEnglish = "Upgrade the level of "..achievement.heroNum.." heroes to the top"
	elseif idx == 17 then
		text = "累积获得"..achievement.needNum.."个星星"
		textEnglish = "Get "..achievement.needNum.." stars cumulatively"
	end
	if VERSION_REDUCE then
		return textEnglish
	else
		return text
	end	
end

function AchievementData.checkType2Achievement(idx, add)
	if GameData.achievement[idx].type ~= 2 then return end
	if GameData.achievement[idx].openlevel <= GameData.achievement[idx].num then
		GameData.achievement[idx].recordNum = GameData.achievement[idx].recordNum + add
		for i = GameData.achievement[idx].openlevel, GameData.achievement[idx].num do
			if not GameData.achievement[idx][""..i].complete 
					and GameData.achievement[idx].recordNum >= GameData.achievement[idx][""..i].needNum then
				GameData.achievement[idx][""..i].complete = true
				if GameData.achievement[idx].openlevel < GameData.achievement[idx].num then
					GameData.achievement[idx].openlevel = GameData.achievement[idx].openlevel + 1
				end
				printf("%s号成就第%d个完成！",idx,i)
				GameState.save(GameData)
			end
		end
	end
end

function AchievementData.checkCommonDailytask(typeNum,money)
	if GameData.dailytask.open == 4 then return end
	if GameData.dailytask[""..GameData.dailytask.open].type == typeNum
			and not GameData.dailytask[""..GameData.dailytask.open].complete then
		GameData.dailytask[""..GameData.dailytask.open].recordNum = GameData.dailytask[""..GameData.dailytask.open].recordNum + money
		if GameData.dailytask[""..GameData.dailytask.open].recordNum >= DailyTask[typeNum].needNum then
			GameData.dailytask[""..GameData.dailytask.open].complete = true
			print(typeNum.."号每日任务完成！")
			GameState.save(GameData)
		end	
	end
end

function AchievementData.checklevelAchievement(level)
	--1 14
	local change = false
	if level == 1 and GameData.achievement["1"].complete == false then
		change = true
		GameData.achievement["1"].complete = true
		print("1号成就完成！")
	elseif level == AchievementData[14].level and GameData.achievement["14"].complete == false then
		change = true
		GameData.achievement["14"].complete = true
		print("14号成就完成！")
	end
	if change then
		GameState.save(GameData)
	end
end
function AchievementData.checkItem()
	if GameData.achievement["2"].complete == false then
		GameData.achievement["2"].complete = true
		print("2号成就完成！")
	end
end
function AchievementData.checkHero()
	if GameData.achievement["3"].complete == false then
		GameData.achievement["3"].complete = true
		print("3号成就完成！")
		--GameState.save(GameData)
	end
end
function AchievementData.checkHeroUpgrade(hero)
	-- 4 7 16
	if GameData.achievement["4"].complete == false then
		GameData.achievement["4"].complete = true
		print("4号成就完成！")
	end
	if GameData.achievement["7"].complete == false then
		if GameData.heros["h"..hero].level >= AchievementData[7].herolevel then
			GameData.achievement["7"].complete = true
			print("7号成就完成！")
		end
	end 
	if GameData.achievement["16"].complete == false then
		local maxLevlHeroNum = 0
		if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
			maxLevlHeroNum = maxLevlHeroNum + 1
		end
		if maxLevlHeroNum >= AchievementData[16].heroNum then
			GameData.achievement["16"].complete = true
			print("16号成就完成！")
		end
	end
	--每日任务
	AchievementData.checkCommonDailytask(2,1)
	--[[if GameData.dailytask[""..GameData.dailytask.open].type == 2 then
		GameData.dailytask[""..GameData.dailytask.open].recordNum = GameData.dailytask[""..GameData.dailytask.open].recordNum + 1
		if GameData.dailytask[""..GameData.dailytask.open].recordNum >= DailyTask[2].needNum then
			GameData.dailytask[""..GameData.dailytask.open].complete = true
			print("2号任务完成！")
		end	
	end]]
end
function AchievementData.checkHeroSkillUpgrade(hero)
	if GameData.achievement["5"].complete == false then
		GameData.achievement["5"].complete = true
		print("5号成就完成！")
	end
	if GameData.achievement["6"].complete == false then
		local num = #HeroData[hero].skill - 1
		for i = 1, num do 
			if GameData.heros["h"..hero].skill["s"..i] == AchievementData[6].skilllevel then
				GameData.achievement["6"].complete = true
				print("6号成就完成！")
				GameState.save(GameData)
			end
		end
	end
	--每日任务
	AchievementData.checkCommonDailytask(3,1)
end
function AchievementData.checkGetMoney(money)
	AchievementData.checkType2Achievement("8", money)
	--每日任务
	AchievementData.checkCommonDailytask(4,money)
end
function AchievementData.checkEnemies()
	AchievementData.checkType2Achievement("9", 1)
	--每日任务
	AchievementData.checkCommonDailytask(5,1)
end
function AchievementData.checkUseMoney(money)
	AchievementData.checkType2Achievement("10", money)
	--每日任务
	AchievementData.checkCommonDailytask(6,money)
end
function AchievementData.checkDiamond(diamond)
	AchievementData.checkType2Achievement("11",diamond)
	--每日任务
	AchievementData.checkCommonDailytask(7,diamond)
end
--12
function AchievementData.checkDays()
	if GameData.achievement["12"].openlevel <= GameData.achievement["12"].num then
		local y = tonumber(os.date("%Y", os.time())) 
	    local m = tonumber(os.date("%m", os.time()))
	    local d = tonumber(os.date("%d", os.time()))

	    if d-GameData.achievement["12"].day == 1 then                
	    elseif (d == 1 and GameData.achievement["12"].day == 31 and  (GameData.achievement["12"].month == 1 or 3 or 5 or 7 or 8 or 10 or 12))  then
	    elseif (d == 1 and GameData.achievement["12"].day == 30 and  (GameData.achievement["12"].month == 4 or 6 or 9 or 11))  then
	    elseif (d == 1 and GameData.achievement["12"].day == 29 and  GameData.achievement["12"].month == 2 and ((GameData.achievement["12"].year % 4 == 0 and GameData.achievement["12"].year % 100 ~= 0 ) or GameData.achievement["12"].year%400 == 0)) then
	    elseif (d == 1 and GameData.achievement["12"].day == 28 and  GameData.achievement["12"].month == 2 and not ((GameData.achievement["12"].year % 4 == 0 and GameData.achievement["12"].year % 100 ~= 0 ) or GameData.achievement["12"].year%400 == 0)) then	                               
	    else 
	        GameData.achievement["12"].recordNum = 0
	    end
		GameData.achievement["12"].recordNum = GameData.achievement["12"].recordNum + 1
		for i = GameData.achievement["12"].openlevel, GameData.achievement["12"].num do
			if not GameData.achievement["12"][""..i].complete 
					and GameData.achievement["12"].recordNum >= GameData.achievement["12"][""..i].needNum then
				GameData.achievement["12"][""..i].complete = true
				if GameData.achievement["12"].openlevel < GameData.achievement["12"].num then
					GameData.achievement["12"].openlevel = GameData.achievement["12"].openlevel + 1
				end
				printf("12号成就第%d个完成！",i)
				GameState.save(GameData)
			end
		end
		GameData.achievement["12"].year = y
	    GameData.achievement["12"].month = m
	    GameData.achievement["12"].day = d
	end
end
function AchievementData.checkGameRound()
	AchievementData.checkType2Achievement("13",1)
	--每日任务
	AchievementData.checkCommonDailytask(8,1)
end
function AchievementData.checkOwenHero()
	if GameData.achievement["15"].complete == false then
		local heroNum = 0
		for i =1,4 do
			if GameData.heros["h"..i].level > 0 then
				heroNum = heroNum + 1
			end
		end
		if heroNum >= AchievementData[15].heroNum then
			GameData.achievement["15"].complete = true
			print("15号成就完成！")
		end
		--GameState.save(GameData)
	end
end
function AchievementData.checkStarNum(starNum)
	AchievementData.checkType2Achievement("17",starNum)
end

--每日任务
function AchievementData.checkUseItem()
	AchievementData.checkCommonDailytask(1,1)
end
function AchievementData.checkHeroKillEnemy()
	if GameData.dailytask.open == 4 then return end
	if GameData.dailytask[""..GameData.dailytask.open].type == 9 then
		GameData.dailytask[""..GameData.dailytask.open].recordNum = GameData.dailytask[""..GameData.dailytask.open].recordNum + 1
		if GameData.dailytask[""..GameData.dailytask.open].recordNum >= DailyTask[9].needNum then
			GameData.dailytask[""..GameData.dailytask.open].complete = true
			print("9号每日任务完成！")
		end
		GameState.save(GameData)
	end
	--女英雄
	if GameData.dailytask[""..GameData.dailytask.open].type == 10 then
		if g_playScene.hero.idx == 2 or g_playScene.hero.idx == 3 then
			GameData.dailytask[""..GameData.dailytask.open].recordNum = GameData.dailytask[""..GameData.dailytask.open].recordNum + 1
			if GameData.dailytask[""..GameData.dailytask.open].recordNum >= DailyTask[10].needNum then
				GameData.dailytask[""..GameData.dailytask.open].complete = true
				print("10号每日任务完成！")
			end
			GameState.save(GameData)
		end	
	end
end
function AchievementData.checkUseSkill()
	AchievementData.checkCommonDailytask(11,1)
end