--
-- Author: KK
-- Date: 2014-04-16 14:30:07
--

ResData = {}

ResData.TEXTURES_PIXEL_FORMAT = {}
function ResData.setTexturePixelFormat(filename, format)
    ResData.TEXTURES_PIXEL_FORMAT[filename] = format
end

local Res565 = {
	"map/LevelTheme/themeMap1.png",
	"map/LevelTheme/themeMap2.png",
	"map/LevelTheme/themeMap3.png",
	"map/LevelTheme/themeMap4.png",
	"map/Theme1/theme1DialogScene.png",
	"map/Theme2/theme2DialogScene.png",
	"map/Theme3/theme3DialogScene.png",
	"map/Theme4/theme4DialogScene.png",
	"map/Theme1/theme1Map.png",
	"map/Theme2/theme2Map.png",
	"map/Theme3/theme3Map.png",
	"map/Theme4/theme4Map.png",
	"pic/mainCover.png",
	"pic/heroAchieveBG.png",
	"pic/loadingBg.png",
	"pic/heroHouseBg.png",
}

for k, v in pairs(Res565) do
	ResData.setTexturePixelFormat(v, cc.TEXTURE2_D_PIXEL_FORMAT_RG_B565)
end

ResData["MAINSCENE"] = {
	plist = {
		{"ui_settings.png","ui_settings.plist"},
	},
	pic = {
		"pic/mainCover.png",
		"pic/mainStartButton.png",
		"pic/eye.png",
		"pic/eye2.png",
	}
}

ResData["LEVELMAP"] = {
---[[
	plist = {
		{"map/LevelTheme/levelThemeElements.png", "map/LevelTheme/levelThemeElements.plist"},
	},
--]]
	pic = {
	    "map/LevelTheme/themeMap1.png",
	    "map/LevelTheme/themeMap2.png",
	    "map/LevelTheme/themeMap3.png",
	    "map/LevelTheme/themeMap4.png",
	},
	animation = {
		--map1_zombie = {"map1_zombie%d.png",17,1.7},
		--map1_lizard = {"map1_lizard%d.png",23,2.3},
		map1_bubble = {"map1_bubble%d.png",3,0.6},
		map2_penguin1 = {"map2_penguin1_%d.png",12,1.2},
		--map2_flag = {"map2_flag%d.png",7,0.7},
		--map2_mouth = {"map2_mouth%d.png",2,0.2},
		--map2_hand = {"map2_hand%d.png",7,0.7},
		map3_eye = {"map3_eye%d.png",2,0.4},
		--map3_drop = {"map3_drop%d.png",16,1.6},
		map3_fountain = {"map3_fountain%d.png",18,1.6},
		map4_mermaid = {"map4_mermaid%d.png",4,0.4},
		map2_fountain = {"map2_fountain%d.png",4,0.4}
	}
}

ResData["UI_PUBLIC1"] = {
	plist = {
		[1] = {"ui_public1.png","ui_public1.plist"},
	},
}

ResData["UI_HEROHOUSEUI"] = {
	plist = {
		[1] = {"ui_herohouseUI.png","ui_herohouseUI.plist"},
	},
	pic = {
		"pic/heroHouseBg.png",
	}
}

ResData["UI_HEROHOUSEANI"] = {
	plist = {
		[1] = {"ui_herohouseAni.png","ui_herohouseAni.plist"},
		-- [1] = {"ui_hero1.png","ui_hero1.plist"},
		-- [2] = {"ui_hero2.png","ui_hero2.plist"},
		-- [3] = {"ui_hero3.png","ui_hero3.plist"},
		-- [4] = {"ui_hero4.png","ui_hero4.plist"},
	},
	animation = {
		ui_hero1 = {"hero1_%d.png", 10, 1.0},
		ui_hero2 = {"hero2_%d.png", 10, 1.0},
		ui_hero3 = {"hero3_%d.png", 10, 1.0},
		ui_hero4 = {"hero4_%d.png", 10, 1.0},
	}
}

ResData["UI_HANDBOOK"] = {
	plist = {
		[1] = {"ui_handbook.png","ui_handbook.plist"},
	},
	pic = {
		"pic/heroAchieveBG.png",
	}
}

ResData["UI_DAILYLOGIN"] = {
	plist = {
		[1] = {"ui_dailyLogin.png","ui_dailyLogin.plist"},
	},
}

ResData["UI_SHOP"] = {
	plist = {
		[1] = {"ui_shop.png","ui_shop.plist"},
	},
}

ResData["UI_ACHIEVEMENT"] = {
	plist = {
		[1] = {"ui_achievement.png","ui_achievement.plist"},
	},
	pic = {
		"pic/heroAchieveBG.png",
	}
}

ResData["UI_DAILYTASK"] = {
	plist = {
		[1] = {"ui_dailytask.png","ui_dailytask.plist"},
	},
}

ResData["UI_NEWBIEGUIDE"] = {
	plist = {
		[1] = {"ui_newbieguide.png","ui_newbieguide.plist"},
	},
}

ResData["UI_GIFTBAG"] = {
	plist = {
		[1] = {"ui_giftbag.png","ui_giftbag.plist"},
	},
}

ResData["UI_FIRSTPAY"] = {
	plist = {
		[1] = {"ui_firstpay.png","ui_firstpay.plist"},
	},
}

ResData["UI_COMMON"] = {
	pic = {
	    "pic/whiteCloud.png",
	    "pic/loadingBg.png",
	    "fontMoney.png",
	    "fontMoney2.png",
	    "fontBlood.png",
	    "fontTitleNumber.png",
	    "fontFortMoney.png",
	},
	plist = {
		[1] = {"ui_prepare.png","ui_prepare.plist"},
	},
}

ResData["UI_SEAWAVE"] = {
	plist = {
		[1]	= {"ui_seaWave.png", "ui_seaWave.plist"},
	},
}

ResData["UI_PLAY"] = {
	plist = {
		[1] = {"ui_play.png","ui_play.plist"},
	},
	animation = {
		TowerEnhance = {"tower_enhance%d.png", 8, 0.5},
		HeroReborn = {"hero_reborn%d.png", 7 , 0.7}
	}
}

ResData["UI_RESULT"] = {
	plist = {{"ui_result.png","ui_result.plist"}},
}

--对话场景
ResData["DIALOG"] = {
	plist = {
		[1]	= {"ui_dialog.png", "ui_dialog.plist"},
	},
	pic = {
	}
}
ResData["DIALOG1"] = {
	plist = {
		[1]	= {"map/Theme1/ui_dialog1.png", "map/Theme1/ui_dialog1.plist"},
	},
	pic = {
		"map/Theme1/theme1DialogScene.png",
	}
}
ResData["DIALOG2"] = {
	plist = {
		[1]	= {"map/Theme2/ui_dialog2.png", "map/Theme2/ui_dialog2.plist"},
	},
	pic = {
		"map/Theme2/theme2DialogScene.png",
	}
}
ResData["DIALOG3"] = {
	plist = {
		[1]	= {"map/Theme3/ui_dialog3.png", "map/Theme3/ui_dialog3.plist"},
	},
	pic = {
		"map/Theme3/theme3DialogScene.png",
	}
}
ResData["DIALOG4"] = {
	plist = {
		[1]	= {"map/Theme4/ui_dialog.png4", "map/Theme4/ui_dialog4.plist"},
	},
	pic = {
		"map/Theme4/theme4DialogScene.png",
	}
}

--主题场景、地图元素。
ResData["THEME1"] = {
	plist = {
		[1]	= {"map/Theme1/theme1Scene.png", "map/Theme1/theme1Scene.plist"},
	},
	pic = {
		"map/Theme1/theme1Tiles.png",
		"map/Theme1/theme1Map.png",
	},
}
ResData["THEME2"] = {
	plist = {
		[1]	= {"map/Theme2/theme2Scene.png", "map/Theme2/theme2Scene.plist"},
	},
	pic = {
		"map/Theme2/theme2Tiles.png",
		"map/Theme2/theme2Map.png",
	},
}
ResData["THEME3"] = {
	plist = {
		[1]	= {"map/Theme3/theme3Scene.png", "map/Theme3/theme3Scene.plist"},
	},
	pic = {
		"map/Theme3/theme3Tiles.png",
		"map/Theme3/theme3Map.png",
	},
}
ResData["THEME4"] = {
	plist = {
		[1]	= {"map/Theme4/theme4Scene.png", "map/Theme4/theme4Scene.plist"},
	},
	pic = {
		"map/Theme4/theme4Tiles.png",
		"map/Theme4/theme4Map.png",
	},
}

ResData["SHAKE_ICE"] = {
	plist = {
		[1]	= {"shakeIce.png", "shakeIce.plist"},
	},
}

ResData["HERO1"] = {
	plist = {
		[1] = {"hero1.png", "hero1.plist"}
	},
	animation = {
		h01_attack = {"h01_attack_%d.png", 8, 0.6},
		h01_dead = {"h01_dead_%d.png", 7, 0.6},
		h01_hurt = {"h01_hurt_%d.png", 4, 0.3},
		h01_move = {"h01_move_%d.png", 8, 0.6},
		h01_magic = {"h01_magic_%d.png", 12, 1},
		h01_magic2 = {"h01_magic2_%d.png", 28, 2.2},
		h01_wait = {"h01_wait_%d.png", 17, 1.4},
		h01_focusPre = {"h01_focusPre_%d.png", 2, 0.2},
		h01_focus = {"h01_focus_%d.png", 2, 0.2},
	}
}

ResData["HERO2"] = {
	plist = {
		[1] = {"hero2.png", "hero2.plist"}
	},
	animation = {
		h02_attack = {"h02_attack_%d.png", 12, 0.9},
		h02_dead = {"h02_dead_%d.png", 9, 0.7},
		h02_hurt = {"h02_hurt_%d.png", 4, 0.3},
		h02_move = {"h02_move_%d.png", 4, 0.3},
		h02_magic = {"h02_magic_%d.png", 20, 1.7},
		h02_magic2 = {"h02_magic2_%d.png", 4, 0.33},
		h02_wait = {"h02_wait_%d.png", 8, 0.6},
		h02_wait2 = {"h02_wait2_%d.png", 3, 0.2},
		h02_focusPre = {"h02_focusPre_%d.png", 2, 0.2},
		h02_focus = {"h02_focus_%d.png", 4, 0.4},
		h02_s01 = {"h02_s01_%d.png", 6, 0.5},
		h02_s05_move = {"s05_move_%d.png", 7, 0.6},
		h02_s05_explode = {"s05_explode_%d.png", 7, 0.6},
		h02_s06 = {"s06_%d.png", 10, 0.9},
		--h02_skillBuff = {"h02_skillBuff_%d.png", 8, 0.66},
	}
}

ResData["HERO3"] = {
	plist = {
		[1] = {"hero3.png", "hero3.plist"}
	},
	animation = {
		h03_dead = {"h03_dead_%d.png", 6, 0.5},
		h03_hurt = {"h03_hurt_%d.png", 4, 0.3},
		h03_wait = {"h03_wait_%d.png", 8, 0.6},
		h03_move = {"h03_move_%d.png", 8, 0.6},
		h03_attack = {"h03_attack_%d.png", 10, 0.8},
		h03_magic = {"h03_magic_%d.png", 12, 1},
		h03_magic2 = {"h03_magic2_%d.png", 6, 0.5},
		h03_focusPre = {"h03_focusPre_%d.png", 2, 0.2},
		h03_focus = {"h03_focus_%d.png", 6, 0.6},
		--h03_s09 = {"h03_s09_%d.png", 8, 0.8},
	}
}
ResData["HERO4"] = {
	plist = {
		[1] = {"hero4.png", "hero4.plist"}
	},
	animation = {
		h04_dead = {"h04_dead_%d.png", 6, 0.5},
		h04_hurt = {"h04_hurt_%d.png", 4, 0.3},
		h04_wait = {"h04_wait_%d.png", 10, 0.8},
		h04_move = {"h04_move_%d.png", 8, 0.6},
		h04_attack = {"h04_attack_%d.png", 7, 0.5},
		h04_magic = {"h04_magic_%d.png", 20, 1.6},
		h04_focusPre = {"h04_focusPre_%d.png", 2, 0.2},
		h04_focus = {"h04_focus_%d.png", 4, 0.4},
		h04_s12_heaven = {"s12_heaven_%d.png", 6, 0.5},
		h04_s12_dropout = {"s12_dropout_%d.png", 9, 0.75},
		h04_s12_fly = {"s12_fly_%d.png", 6, 0.5},
		h04_s12_light = {"ufolight%d.png",2,0.16},
	}
}

ResData["E41"] = {
	plist = {{"E41.png","E41.plist"}},
	animation = {
		E41_move = {"E41_%d.png", 6, 0.5},
		E41_attack = {"E41_attack_%d.png", 6, 0.5},
		E41_whistle = {"E41_whistle_%d.png", 8, 0.8},
		--E41b_move = {"E41b_%d.png", 6, 0.5},
		--E41b_attack = {"E41b_attack_%d.png", 6, 0.5},
	}
}

ResData["E42"] = {
	plist = {{"E42.png","E42.plist"}},
	animation = {
		E42_move = {"E42_%d.png", 8, 0.6},
		E42_attack = {"E42_attack_%d.png", 8, 0.6},
		--E42_magic = {"E42_magic_%d.png", 8, 0.6},
	}
}

ResData["E43"] = {
	plist = {{"E43.png","E43.plist"}},
	animation = {
		E43_fly = {"E43_%d.png", 4, 0.4},
		E43_attack = {"E43_attack_%d.png", 4, 0.33},
		--E43b_move = {"E43b_%d.png", 4, 0.4},
		--E43b_attack = {"E43b_attack_%d.png", 4, 0.4},
	}
}

ResData["E44"] = {
	plist = {{"E44.png","E44.plist"}},
	animation = {
		E44_move = {"E44_%d.png", 6, 0.5},
		E44_attack = {"E44_attack_%d.png", 6, 0.5},
		E44_magic = {"E44_magic_%d.png", 12, 1},
	}
}

ResData["E46"] = {
	plist = {{"E46.png","E46.plist"}},
	animation = {
		E46_move = {"E46_%d.png", 6, 0.5},
		E46_attack = {"E46_attack_%d.png", 6, 0.5},
		E46_explode = {"E46_explode_%d.png", 35, 3},
		--E46b_move = {"E46_b_%d.png", 6, 0.5},
		--E46b_attack = {"E46_b_attack_%d.png", 6, 0.5},
		--E46_move = {"E46_%d.png", 3, 0.3},
	}
}
ResData["E47"] = {
	plist = {{"E47.png","E47.plist"}},
	animation = {
		E47_move = {"E47_%d.png", 6, 0.5},
		E47_attack = {"E47_attack_%d.png", 4, 0.3},
		E47_jump = {"E47_jump_%d.png", 12, 1},
		--E47b_move = {"E47b_%d.png", 6, 0.5},
		--E47b_attack = {"E47b_attack_%d.png", 4, 0.3},
		--E47b_jump = {"E47b_jump_%d.png", 12, 1},
	}
}
ResData["E48"] = {
	plist = {{"E48.png","E48.plist"}},
	animation = {
		E48_move1 = {"E48_under%d.png", 3, 0.25},
		E48_offWater = {"E48_under%d.png", 3, 0.25},
		E48_move2 = {"E48_%d.png", 4, 0.33},
	}
}

ResData["E61"] = {
	plist = {{"E61.png","E61.plist"}},
	animation = {
		E61_move = {"E61_%d.png", 8, 0.8},
		E61_magic = {"E61_magic_%d.png", 8, 2},
		E61_attack = {"E61_attack_%d.png", 8, 0.6},
		--E61b_move = {"E61b_%d.png", 8, 0.8},
		--E61b_magic = {"E61b_magic_%d.png", 8, 0.8},
	}	
}

ResData["E62"] = {
	plist = {{"E62.png","E62.plist"}},
	animation = {
		E62_move = {"E62_%d.png", 12, 1},
		E62_magic = {"E62_magic_%d.png", 17, 1.4},
		E62_attack = {"E62_attack_%d.png", 9, 0.8},
		--E62b_move = {"E62b_%d.png", 12, 1},
		--E62b_magic = {"E62b_magic_%d.png", 17, 1.4},
	}	
}

ResData["E63"] = {
	plist = {{"E63.png","E63.plist"}},
	animation = {
		E63_move = {"E63_%d.png", 8, 0.6},
		E63_magic = {"E63_magic_%d.png", 28, 2.5},
		E63_attack = {"E63_attack_%d.png", 10, 0.8},
		--E63b_move = {"E63_b_%d.png", 8, 0.6},
		--E63b_magic = {"E63_b_magic_%d.png", 28, 2.5},
	}	
}

ResData["E64"] = {
	plist = {{"E64.png","E64.plist"}},
	animation = {
		E64_move = {"E64_%d.png", 8, 0.6},
		E64_magic = {"E64_magic_%d.png", 18, 1.5},
		E64_attack = {"E64_attack_%d.png", 8, 0.6},
		--E64b_move = {"E64b_%d.png", 8, 0.6},
		--E64b_magic = {"E64b_magic_%d.png", 18, 1.5},
	}	
}

--海外版加上城堡玩法资源
if not VERSION_MONSTER then
	ResData["E64"].animation.E64_wait = {"E64_wait_%d.png", 8, 0.6}
	ResData["E64"].animation.E64_hurt = {"E64_hurt_%d.png", 4, 0.32}
end

ResData["T1"] = {
	plist = {{"T01.png","T01.plist"}},
	animation = {
		T01_1 = {"T01_1_%d.png", 6, 0.3},
		T01_2 = {"T01_2_%d.png", 5,	0.2},
		T01_3 = {"T01_3_%d.png", 4,	0.1},
		B01_explode = {"B01_%d.png", 2,0.15},
	}	
}

ResData["T2"] = {
	plist = {{"T02.png","T02.plist"}},
	animation = {
		B02_explode = {"B02_%d.png", 4, 0.3},
		T02_1 = {"T02_1_%d.png", 9, 0.6},
		T02_2 = {"T02_2_%d.png", 7,	0.5},
		T02_3 = {"T02_3_%d.png", 6,	0.4},
	}	
}

ResData["T3"] = {
	plist = {{"T03.png","T03.plist"}},
	animation = {
		B03_bomb = {"B03_%d.png", 2, 0.15},
		T03_1 = {"T03_1_%d.png", 10, 0.6},
		T03_2 = {"T03_2_%d.png", 8, 0.5},
		T03_3 = {"T03_3_%d.png", 6, 0.4},
	}	
}

ResData["T7"] = {
	plist = {{"T07.png","T07.plist"}},
	animation = {
		B07_bomb = {"B07_%d.png", 2, 0.15},
		T07_1 = {"T07_1_%d.png", 9, 0.8},
		T07_2 = {"T07_2_%d.png", 8, 0.6},
		T07_3 = {"T07_3_%d.png", 7, 0.4},
	}	
}

ResData["T11"] = {
	plist = {{"T11.png","T11.plist"}},
	animation = {
		T11_1 = {"T11_1_%d.png", 4, 0.3},
		T11_2 = {"T11_2_%d.png", 16, 1.3},
		T11_3 = {"T11_3_%d.png", 16, 1.3},
		B11_Ani = {"B11_%d.png", 4, 0.3},
		B11_Bomb = {"B11_bomb_%d.png", 4, 0.3},
		T11_BP = {"T11_bp_%d.png", 4, 0.3},
	}	
}

ResData["T16"] = {
	plist = {{"T16.png","T16.plist"}},
	animation = {
		T16_1 = {"T16_1_%d.png", 11, 0.8},
		T16_2 = {"T16_2_%d.png", 11, 0.8},
		T16_3 = {"T16_3_%d.png", 11, 0.8},
		B16_Ani = {"B16_%d.png", 6, 0.4},
		B16_Bomb = {"B16_bomb_%d.png", 2, 0.15},
	}
}

ResData["T18"] = {
	plist = {{"T18.png","T18.plist"}},
	animation = {
		B18_Ani = {"B18_%d.png", 8, 0.4},
	}	
}

ResData["ROLE"] = {
	plist = {
		{"enemyCommon.png","enemyCommon.plist"},
		{"fight.png","fight.plist"},
		{"bullet.png","bullet.plist"},
		{"E45.png","E45.plist"},
	},
	pic = {
	},
	animation = {
		--通用
		upgradeAni = {"towerUpgrade%d.png", 8, 0.6},
		explosion = {"explosion_died_demotion_%d.png", 6, 0.5},
		firing = {"firing%d.png", 6, 0.5},
		--子弹
		B01_bomb = {"B01_%03d.png", 3, 0.25},
		B103_bomb = {"B103_%d.png", 5, 0.5},
		bullet142_bomb = {"bullet142_%d.png", 6, 0.5},
		bullet_Connect_1Ani = {"bullet-Connect-1%04d.png", 4, 0.33},
		--所有塔
		--T04_1_2 = {"T04_1_2_%d.png", 5, 0.4},
		--T06_1_2 = {"calabash_attack_2_2_1_%d.png", 4, 0.33},
		--T06_1_3 = {"calabash_attack_2_2_2_%d.png", 4, 0.33},
		--T09_1_2 = {"calabash_attack_2_3_1_%d.png", 4, 0.33},
		--T09_1_3 = {"calabash_attack_2_3_2_%d.png", 4, 0.33},
		--T10_1_1 = {"T10_1_1_%d.png", 3, 0.3},
		--T12_1_2 = {"T12_1_2_%d.png", 4, 0.4},
		--T12_1_3 = {"T12_1_3_%d.png", 4, 0.4},
		--T14_1_2 = {"T14_1_2_%d.png", 3, 0.3},
		--T18_1 = {"T18_1_%d.png", 9, 0.7},
		--T18_2 = {"T18_2_%d.png", 3, 0.3},
		--T18_3 = {"T18_3_%d.png", 3, 0.3},
		--[[不用的塔
		R1_b_attack = {"R-1-b_attack_%02d.png", 8, 0.66},
		R1_f_attack = {"R-1-f_attack_%02d.png", 8, 0.66},
		B06_bomb = {"bigwalker_died%d.png", 3, 0.25},
		r1_attack_front = {"corn_attack_1_1_1_%d.png", 4, 0.33},
		r1_attack_back = {"corn_attack_1_1_2_%d.png", 4, 0.33},
		peanut_1_front = {"peanut_attack_1_1_1_%d.png", 4, 0.33},
		peanut_1_back = {"peanut_attack_1_1_2_%d.png", 4, 0.33},
		peanut_2_front = {"peanut_attack_2_3_1_%d.png", 4, 0.33},
		peanut_2_back = {"peanut_attack_2_3_2_%d.png", 4, 0.33},
		peanut_3_front = {"peanut_attack_3_3_1_%d.png", 4, 0.33},
		peanut_3_back = {"peanut_attack_3_3_2_%d.png", 4, 0.33},
		peanut_4_front = {"peanut_attack_3_2_1_%d.png", 4, 0.33},
		peanut_4_back = {"peanut_attack_3_2_2_%d.png", 4, 0.33},
		--]]
		--普通小怪
		E01_move = {"E01_%d.png", 6, 0.6},
		E01_attack = {"E01_attack_%d.png", 6, 0.5},
		E02_move = {"E02_%d.png", 8, 0.6},
		E02_attack = {"E02_attack_%d.png", 8, 0.6},
		E03_move = {"E03_%d.png", 8, 1},
		E03_attack = {"E03_attack_%d.png", 8, 1},
		E04_move = {"E04_%d.png", 4, 0.33},
		E04_attack = {"E04_attack_%d.png", 4, 0.33},
		E05_move = {"E05_%d.png", 3, 0.3},
		E05_attack = {"E05_attack_%d.png", 6, 0.6},
		E06_move = {"E06_%d.png", 3, 0.3},
		E06_attack = {"E06_attack_%d.png", 6, 0.6},
		--南极洲小怪
		E07_move = {"E07_%d.png", 6, 0.5},
		E07_attack = {"E07_attack_%d.png", 6, 0.5},
		E08_move = {"E08_%d.png", 8, 0.7},
		E09_move = {"E09_%d.png", 8, 0.7},
		E09_attack = {"E09_attack_%d.png", 8, 0.7},
		E10_move = {"E10_%d.png", 6, 0.5},
		E10_attack = {"E10_attack_%d.png", 6, 0.5},
		E11_move = {"E11_%d.png", 6, 0.5},
		E11_attack = {"E11_attack_%d.png", 6, 0.5},
		--非洲小怪
		E12_move = {"E12_%d.png", 6, 0.6},
		E12_attack = {"E12_attack_%d.png", 6, 0.6},
		E13_move = {"E13_%d.png", 8, 0.8},
		E13_attack = {"E13_attack_%d.png", 8, 0.6},
		E14_move = {"E14_%d.png", 3, 0.3},
		E14_attack = {"E14_attack_%d.png", 8, 0.8},
		E15_move = {"E15_%d.png", 6, 0.6},
		E15_attack = {"E15_attack_%d.png", 6, 0.6},
		--大洋洲小怪
		E16_move = {"E16_%d.png", 6, 0.5},
		E16_attack = {"E16_attack_%d.png", 6, 0.5},
		E17_move = {"E17_%d.png", 8, 0.6},
		E17_attack = {"E17_attack_%d.png", 8, 0.6},
		E18_move = {"E18_%d.png", 4, 0.3},
		E18_attack = {"E18_attack_%d.png", 4, 0.3},
		E19_move = {"E19_%d.png", 6, 0.5},
		E19_attack = {"E19_attack_%d.png", 6, 0.5},
		E20_move = {"E20_%d.png", 6, 0.5},
		E20_attack = {"E20_attack_%d.png", 6, 0.5},
		--中型怪
		E45_move = {"E45_%d.png", 8, 0.8},
		E45_attack = {"E45_attack_%d.png", 8, 0.8},
		E45_grow = {"E45_grow_%d.png", 22, 2.2},
		E45_under = {"E45_under_%d.png", 6, 0.5},
		E50_move = {"E50_%d.png", 4, 0.33},
	}
}

function ResData.resCount(type)
	local count = 0
	if ResData[type].plist ~= nil then
		count = count + #ResData[type].plist
	end
	if ResData[type].pic ~= nil then
		count = count + #ResData[type].pic
	end
	return count
end

function ResData.loadRes(type)
	if ResData[type].plist ~= nil then
		for i = 1, #ResData[type].plist do
			display.addSpriteFrames(ResData[type].plist[i][2], ResData[type].plist[i][1])
			--cc.Director:getInstance():getTextureCache():addImage(ResData[type].plist[i][1])
		end
	end
	if ResData[type].pic ~= nil then
		for i = 1, #ResData[type].pic do
			if ResData.TEXTURES_PIXEL_FORMAT[ResData[type].pic[i]] ~= nil then
				cc.Texture2D:setDefaultAlphaPixelFormat(ResData.TEXTURES_PIXEL_FORMAT[ResData[type].pic[i]])
				cc.Director:getInstance():getTextureCache():addImage(ResData[type].pic[i])
				cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
			else
				cc.Director:getInstance():getTextureCache():addImage(ResData[type].pic[i])
			end
		end
	end
	if ResData[type].animation ~= nil then
		for k,v in pairs(ResData[type].animation) do
			local name = k
			local fileName = v[1]
			local num = v[2]
			local time = v[3]
		    local frames = display.newFrames(fileName, 1, num)
		    local animation = display.newAnimation(frames, time / num)
		    display.setAnimationCache(name, animation)
		end
	end
end

function ResData.loadResAsync(type, handler)
	if ResData[type].plist ~= nil then
		for i = 1, #ResData[type].plist do
			display.addSpriteFrames(ResData[type].plist[i][2], ResData[type].plist[i][1], handler)
			--cc.Director:getInstance():getTextureCache():addImage(ResData[type].plist[i][1])
		end
	end
	if ResData[type].pic ~= nil then
		for i = 1, #ResData[type].pic do
			if ResData.TEXTURES_PIXEL_FORMAT[ResData[type].pic[i]] ~= nil then
				cc.Texture2D:setDefaultAlphaPixelFormat(ResData.TEXTURES_PIXEL_FORMAT[ResData[type].pic[i]])
				cc.Director:getInstance():getTextureCache():addImage(ResData[type].pic[i])
				cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
				handler()
			else
				display.addImageAsync(ResData[type].pic[i], handler)--异步加载图片，等待一定时间再执行代码
			end
		end
	end
end

function ResData.loadAnimationForAsync(type)
	--kkFunc.LogCat(type)
	if ResData[type].animation ~= nil then
		--kkFunc.LogCat(type)
		for k,v in pairs(ResData[type].animation) do
			local name = k
			local fileName = v[1]
			local num = v[2]
			local time = v[3]
		    local frames = display.newFrames(fileName, 1, num)
		    local animation = display.newAnimation(frames, time / num)
		    display.setAnimationCache(name, animation)
		end
	end
end

function ResData.removeRes(type)
	if ResData[type].plist ~= nil then
		for i = 1, #ResData[type].plist do
			display.removeSpriteFramesWithFile(ResData[type].plist[i][2], ResData[type].plist[i][1])
		end
	end
	if ResData[type].pic ~= nil then
		for i = 1, #ResData[type].pic do
			display.removeSpriteFrameByImageName(ResData[type].pic[i])
		end
	end
	if ResData[type].animation ~= nil then
		for k,v in pairs(ResData[type].animation) do
			local name = k			
		    display.removeAnimationCache(name)
		end
	end
end

function ResData.getResFromLevelData(levelData)
	local res = {"THEME"..levelData.theme,
        "HERO"..GameData.selectHero}
    if levelData.ice ~= nil then
        table.insert(res, "SHAKE_ICE")
    end
    local enRes = {}
    for i = 41,48 do
    	enRes[i] = false
    end
    for i = 61,64 do
    	enRes[i] = false
    end
    local e61,e62,e63,e64 = false,false,false,false
    for i = 1, #levelData.waves do
    	for j = 1, #levelData.waves[i] do
    		local waves = levelData.waves[i][j]
    		local enemys
    		if not VERSION_MONSTER then
    			if waves.enemyAttCity ~= nil then
    				enemys = waves.enemyAttCity
    			else
    				enemys = waves.enemy
    			end
    		else
    			enemys = waves.enemy
    		end
    		for k = 1, #enemys do
				local en = enemys[k]
				if en > 40 and enRes[en] ~= nil then
					enRes[en]  = true
				end
    		end
    	end
    end
    for k,v in pairs(enRes) do
    	if v then
    		table.insert(res, "E"..k)
    	end
    end
    local towers = levelData.useTowers or levelData.selectedTowers
    for i = 1, #towers do
    	local idx = towers[i]
    	if idx == 1 or idx == 2 or idx == 3 or idx == 7 
    			or idx == 11 or idx == 16 or idx == 18 then
    		table.insert(res, "T"..idx)
    	end
    end
    return res
end
