--
-- Author: KK
-- Date: 2014-10-17 10:16:22
--音乐音效
import("..common.kkFunc")

SoundManager = {}

function SoundManager.setMusic(isPlay)
	GameData.music = isPlay
	GameState.save(GameData)
	if not isPlay then
		SoundManager.stopMusic(false)
	end
end

function SoundManager.setSound(isPlay)
	GameData.sound = isPlay
	GameState.save(GameData)
	if not isPlay then
		audio.stopAllSounds()
	end
end

function SoundManager.playSound(sound,isLoop)
	if not GameData.sound then return nil end
	if not sound then return nil end
	if isLoop ~= nil then
		return audio.playSound(sound,isLoop)
	end
	audio.playSound(sound)
	return nil
end

function SoundManager.stopSound(soundHandler)
	if soundHandler then
		audio.stopSound(soundHandler)
	end
end

function SoundManager.playMusic(music)
	if not GameData.music then return end
	if SoundManager.music ~= music then
		if SoundManager.music ~= nil then
			audio.stopMusic(true)
		end
		audio.playMusic(music)
		SoundManager.music = music
	end
end

function SoundManager.pauseMusic()
	if not GameData.music then return end
    audio.pauseMusic()
end

function SoundManager.resumeMusic()
	if not GameData.music then return end
    audio.resumeMusic()
end

function SoundManager.stopMusic(b)
	if not GameData.music then return end
    audio.stopMusic(b)
    SoundManager.music = nil
end
--攻击音效，通常是子弹发出时
function SoundManager.playTowerAttack1Sound(idx)
	if not GameData.sound then return end
	if GAME_SOUND.Tower[idx] == nil
			or GAME_SOUND.Tower[idx].attack1 == nil then
		return
	end
	audio.playSound(GAME_SOUND.Tower[idx].attack1)
end
function SoundManager.playTowerAttack2Sound(idx)
	if not GameData.sound then return end
	if GAME_SOUND.Tower[idx] == nil
			or GAME_SOUND.Tower[idx].attack2 == nil then
		return
	end
	audio.playSound(GAME_SOUND.Tower[idx].attack2)
end
--技能释放音效
function SoundManager.playTowerSkill1Sound(idx)
	if not GameData.sound then return end
	if GAME_SOUND.Tower[idx] == nil
			or GAME_SOUND.Tower[idx].skill1 == nil then
		return
	end
	audio.playSound(GAME_SOUND.Tower[idx].skill1)
end
--技能效果音效
function SoundManager.playTowerSkill2Sound(idx)
	if not GameData.sound then return end
	if GAME_SOUND.Tower[idx] == nil
			or GAME_SOUND.Tower[idx].skill2 == nil then
		return
	end
	audio.playSound(GAME_SOUND.Tower[idx].skill2)
end

function SoundManager.playEnemyDieSound(idx)
	if not GameData.sound then return end
	if GAME_SOUND.Enemy[idx] == nil then return end
	--1~6小怪有三种音效随机
	if idx >= 1 and idx <= 20 then
		audio.playSound(GAME_SOUND.Enemy[idx][math.random(1,3)])
	elseif GAME_SOUND.Enemy[idx].die ~= nil then
		audio.playSound(GAME_SOUND.Enemy[idx].die)
	end
end

--背景音乐
GAME_MUSIC = {
	BGM1 = "sound/Bgm1.mp3",
	BGM2 = "sound/Bgm2.mp3",
}

GAME_SOUND = {
	--界面
	Button1 = "sound/Button1.mp3",
	Button2 = "sound/Button2.mp3",
	CarrotCount = "sound/CarrotCount.mp3",
	--事件
	TowerUpgrade = "sound/TowerUpgrade.mp3",
	TowerBuild = "sound/TowerBuild.mp3",
	TowerSell = "sound/TowerSell.mp3",
	TowerSelect = "sound/TowerSelect.mp3",
	TowerDeselect = "sound/TowerDeselect.mp3",
	ShootSelect = "sound/ShootSelect.mp3",
	Forbidden = "sound/Forbidden.mp3",
	Clock = "sound/Clock.mp3",
	GO = "sound/GO.mp3",
	Object = "sound/Object.mp3",
	EnemyAppear = "sound/EnemyAppear.mp3",
	Drop = "sound/Drop.mp3",
	FinalWave = "sound/FinalWave.mp3",
	Frozen = "sound/Frozen.mp3",
	Lose = "sound/Lose.mp3",
	Win = "sound/Win.mp3",
	Menu = "sound/Menu.mp3",
	NewTower = "sound/NewTower.mp3",
	Star = "sound/Star.mp3",
	SkillRelease = "sound/SkillRelease.mp3",
	Unlock = "sound/Unlock.mp3",
	waring = "sound/waring.mp3",
	weatherwarning = "sound/weatherwarning.mp3",
	Iceroad = {
		[1] = "sound/Iceroad1.mp3",
		[2] = "sound/Iceroad2.mp3",
	},
	IceBreak = {
		[1] = "sound/IceBreak1.mp3",
		[2] = "sound/IceBreak2.mp3",
		[3] = "sound/IceBreak3.mp3",
	},
	BabyRabbit = {
		[1] = "sound/Role1.mp3",
		[2] = "sound/Role2.mp3",
		[3] = "sound/Role3.mp3",
		[4] = "sound/Role4.mp3",
	},
	--兔子
	Tower = {
		[1] = {
			attack1 = "sound/T01_attack_1.mp3",
			skill2 = "sound/T01_skill_2.mp3",
		},
		[2] = {
			attack1 = "sound/T02_attack_1.mp3",
		},
		[3] = {
			attack1 = "sound/T03_attack_1.mp3",
		},
		[4] = {
			attack1 = "sound/T04_attack_2.mp3",--护士效果就在开始时。
		},
		[7] = {
			attack1 = "sound/T07_attack_1.mp3",		
		},
		[11] = {
			attack1 = "sound/T11_attack_1."..kkFunc.Format(),
		},
		[16] = {
			attack1 = "sound/T16_attack_1.mp3",
		},
		[18] = {
			attack1 = "sound/T18_attack_1.mp3",
		},
	},
	--怪
	EnemyAttack = "sound/E_attack.mp3",
	Enemy = {
		[1] = {
			[1] = "sound/CarrotDie1.mp3",
			[2] = "sound/CarrotDie2.mp3",
			[3] = "sound/CarrotDie3.mp3",
		},
		[2] = {
			[1] = "sound/TomatoDie1.mp3",
			[2] = "sound/TomatoDie2.mp3",
			[3] = "sound/TomatoDie3.mp3",
		},
		[3] = {
			[1] = "sound/BroccoliDie1.mp3",
			[2] = "sound/BroccoliDie2.mp3",
			[3] = "sound/BroccoliDie3.mp3",
		},
		[4] = {
			[1] = "sound/PeaDie1.mp3",
			[2] = "sound/PeaDie2.mp3",
			[3] = "sound/PeaDie3.mp3",
		},
		[5] = {
			[1] = "sound/PotatoDie1.mp3",
			[2] = "sound/PotatoDie2.mp3",
			[3] = "sound/PotatoDie3.mp3",
		},
		[6] = {
			[1] = "sound/CabbageDie1.mp3",
			[2] = "sound/CabbageDie2.mp3",
			[3] = "sound/CabbageDie3.mp3",
		},
		[7] = {
			[1] = "sound/CarrotDie1.mp3",
			[2] = "sound/CarrotDie2.mp3",
			[3] = "sound/CarrotDie3.mp3",
		},
		[8] = {
			[1] = "sound/TomatoDie1.mp3",
			[2] = "sound/TomatoDie2.mp3",
			[3] = "sound/TomatoDie3.mp3",
		},
		[9] = {
			[1] = "sound/BroccoliDie1.mp3",
			[2] = "sound/BroccoliDie2.mp3",
			[3] = "sound/BroccoliDie3.mp3",
		},
		[10] = {
			[1] = "sound/PotatoDie1.mp3",
			[2] = "sound/PotatoDie2.mp3",
			[3] = "sound/PotatoDie3.mp3",
		},
		[11] = {
			[1] = "sound/CabbageDie1.mp3",
			[2] = "sound/CabbageDie2.mp3",
			[3] = "sound/CabbageDie3.mp3",
		},
		[12] = {
			[1] = "sound/CarrotDie1.mp3",
			[2] = "sound/CarrotDie2.mp3",
			[3] = "sound/CarrotDie3.mp3",
		},
		[13] = {
			[1] = "sound/TomatoDie1.mp3",
			[2] = "sound/TomatoDie2.mp3",
			[3] = "sound/TomatoDie3.mp3",
		},
		[14] = {
			[1] = "sound/BroccoliDie1.mp3",
			[2] = "sound/BroccoliDie2.mp3",
			[3] = "sound/BroccoliDie3.mp3",
		},
		[15] = {
			[1] = "sound/PotatoDie1.mp3",
			[2] = "sound/PotatoDie2.mp3",
			[3] = "sound/PotatoDie3.mp3",
		},
		[16] = {
			[1] = "sound/CarrotDie1.mp3",
			[2] = "sound/CarrotDie2.mp3",
			[3] = "sound/CarrotDie3.mp3",
		},
		[17] = {
			[1] = "sound/TomatoDie1.mp3",
			[2] = "sound/TomatoDie2.mp3",
			[3] = "sound/TomatoDie3.mp3",
		},
		[19] = {
			[1] = "sound/PotatoDie1.mp3",
			[2] = "sound/PotatoDie2.mp3",
			[3] = "sound/PotatoDie3.mp3",
		},
		[20] = {
			[1] = "sound/CabbageDie1.mp3",
			[2] = "sound/CabbageDie2.mp3",
			[3] = "sound/CabbageDie3.mp3",
		},
		[41] = {
			skill1 = "sound/E41_skill_1.mp3",
			skill2 = "sound/E41_skill_2.mp3",
			die = "sound/PepperDie.mp3",
		},
		[42] = {
			die = "sound/OnionDie.mp3",
		},
		[43] = {
			die = "sound/MushroomDie.mp3",
		},
		[44] = {
			die = "sound/CucumberDie.mp3",
		},
		[45] = {
			skill1 = "sound/E45_skill_1.mp3",
			die = "sound/BambooDie.mp3",
		},
		[46] = {
			skill1 = "sound/E46_skill_1.mp3",
			die = "sound/CornDie.mp3",
		},
		[47] = {
			die = "sound/ScallionDie.mp3",
		},
		[48] = {
			die = "sound/RadishDie.mp3",
		},
		[61] = {
			skill1 = "sound/E61_skill_1.mp3",
			die = "sound/VampireDie.mp3",
		},
		[62] = {
			skill1 = "sound/E61_skill_1.mp3",
			die = "sound/SnowmanDie.mp3",
		},
		[63] = {
			skill1 = "sound/E63_skill_1.mp3",
			die = "sound/PharaohDie.mp3",
		},
		[64] = {
			die = "sound/PoseidonDie.mp3",
		},
	},
	--英雄
	Hero = {
		[1] = {
			attack = "sound/H01_attack_1.mp3",
			skill1 = "sound/H01_skill_1."..kkFunc.Format(),
			skill2 ="sound/H01_skill_2.mp3",
		},
		[2] = {
			attack = "sound/H02_attack_1.mp3",
			skill1 = "sound/H02_skill_1.mp3",
			skill2 = "sound/H02_skill_2.mp3",
			skill3 = "sound/H02_skill_3.mp3",
		},
		[3] = {
			attack = "sound/H03_attack_1.mp3",
			skill1 = "sound/H03_skill_1."..kkFunc.Format(),
			skill2 = "sound/H03_skill_2.mp3",
		},
		[4] = {
			attack = "sound/H04_attack_1.mp3",
			skill1 = "sound/H04_skill_1."..kkFunc.Format(),
			skill2 = "sound/H04_skill_2.mp3",
		},
	},
}
