--
-- Author: KK
-- Date: 2014-07-04 10:13:26
--

--[[
--塔的数据
TowersData[1] = {
	fortType = 2, --1是原地动画，2是旋转的，3是多面的。
	showPic = "T01_1_1.png", --选塔时的图片
	pic = "R1_f_attack_01.png", --普通图片
	cd = 5, --造塔冷却时间。
	bulletIdx = 1, --对应的子弹id
	towerAnchor = {0.5, 0.3}, --炮塔的锚点
	seatAnchor = {0.5, 0.6}, --底座的锚点
	noAttackAnimation = true, --冰霜塔没有攻击动画。
	waitAnimation = false, --火焰、雷电只有持续等待动画没有攻击动画。
	level = {
		--每一级数值不一样。
		[1] = {
			hp = 50, --血量。
			speed = 0.5, --子弹间隔时间。
			range = 1.3, --攻击范围，格子数，实际要乘以地图每格长度。
			money = 80, --造塔的钱。
			removeMoney = 80, --拆塔的钱
			attack = 70, --伤害
			front = { --正面攻击动画。
				frame = "R1_f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = { --背面攻击动画。
				frame = "R1_b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[2] = {
			...
		},
		[3] = {
			...
		},
		--怒气技能
		anger = {
			angerReadyTime = 20, --怒气积攒时间
			angerTime = 5, --怒气状态持续多久。0或者不写就是单次怒气释放。
			...
		},
	},
	--attackDelay = 0.5, --攻击动画延时多久出子弹
	--attackDx = 10, --子弹出现位置偏移。
	--attackDy = 10,
}
--]]

-- tower
TowersData = {}

--跟踪弹
TowersData[1] = {
	name = "小炮",
	nameEnglish = "Cannon Tower",
	fortType = 2,
	showPic = "T_select_1.png",
	pic = "T01_1_1.png",
	handbookPic = "ui_T01_1_1.png",
	cd = 5,
	bulletIdx = 1,
	towerAnchor = {0.5, 0.3},
	seatAnchor = {0.5, 0.56},
	text = "发射一枚炮弹攻击\n怪物，攻击速度快\n但攻击力较低。",
	textEnglish = "Fire at single targets, medium damage range",
	level = {
		[1] = {
			seat = "T01_seat1.png",
			animationAttack = {
				frame = "T01_1_1.png",
				animation = "T01_1",
			},
		},
		[2] = {
			seat = "T01_seat2.png",
			animationAttack = {
				frame = "T01_2_1.png",
				animation = "T01_2",
			},
		},
		[3] = {
			seat = "T01_seat3.png",
			animationAttack = {
				frame = "T01_3_1.png",
				animation = "T01_3",
			},
		},
		anger = {
			seat = "T01_seat1.png",
			angerReadyTime = 60,
			angerTime = 5,
			animationAttack = {
				frame = "T01_3_1.png",
				animation = "T01_3",
			},
		},
	},
}

--牙膏兔，跟踪减速弹
TowersData[2] = {
	name = "牙膏塔",
	nameEnglish = "Slime Tower",
	fortType = 2,
	showPic = "T_select_2.png",
	pic = "T02_1_1.png",
	handbookPic = "ui_T02_1_1.png",
	cd = 10,
	bulletIdx = 2,
	towerAnchor = {0.5, 0.4},
	seatAnchor = {0.5, 0.6},
	text = "向单个怪物射出一\n段牙膏，使其减速",
	textEnglish = "Slow down enemies, last 1-2 seconds",
	level = {
		[1] = {
			seat = "T02_seat1.png",
			animationAttack = {
				frame = "T02_1_1.png",
				animation = "T02_1",
			},
		},
		[2] = {
			seat = "T02_seat2.png",
			animationAttack = {
				frame = "T02_2_1.png",
				animation = "T02_2",
			},
		},
		[3] = {
			seat = "T02_seat3.png",
			animationAttack = {
				frame = "T02_3_1.png",
				animation = "T02_3",
			},
		},
		anger = {
			angerReadyTime = 60,
			animationAttack = {
				frame = "T02_3_1.png",
				animation = "T02_3",
			},
		},
	},
}

--风扇兔，穿透弹
TowersData[3] = {
	name = "风扇塔",
	nameEnglish = "Fan Tower",
	fortType = 1,
	showPic = "T_select_3.png",
	pic = "T03_1_1.png",
	handbookPic = "ui_T03_1_1.png",
	cd = 10,
	bulletIdx = 3,
	towerAnchor = {0.5, 0.4},
	text = "攻击一条直线上的\n所有怪物。",
	textEnglish = "Attack multiple monsters on the straight line.",
	level = {
		[1] = {
			animationAttack = {
				frame = "T03_1_1.png",
				animation = "T03_1",
			},
		},
		[2] = {
			animationAttack = {
				frame = "T03_2_1.png",
				animation = "T03_2",
			},
		},
		[3] = {
			animationAttack = {
				frame = "T03_3_1.png",
				animation = "T03_3",
			},
		},
		anger = {
			angerReadyTime = 60,
			animationAttack = {
				frame = "T03_3_1.png",
				animation = "T03_3",
			},
		},
	},
}

--护士兔
TowersData[4] = {
	name = "风扇塔",
	showPic = "T04_1_2_1.png",
	pic = "T04_1_2_1.png",
	cd = 10,
	level = {
		[1] = {
			hp = 100,
			speed = 3,
			range = 4.68,
			money = 100,
			removeMoney = 80,
			heal = 5,
			front = {
				frame = "T04_1_2_1.png",
				attack = "T04_1_2",
			},
		},
		[2] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 80,
			removeMoney = 80,
			heal = 10,
			front = {
				frame = "T04_1_2_1.png",
				attack = "T04_1_2",
			},
		},
		[3] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			heal = 10,
			front = {
				frame = "T04_1_2_1.png",
				attack = "T04_1_2",
			},
		},
		[4] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			heal = 10,
			front = {
				frame = "T04_1_2_1.png",
				attack = "T04_1_2",
			},
		},
	},
}

--泳圈兔
TowersData[5] = {
	name = "风扇塔",
	showPic = "corn_attack_1_1_1_1.png",
	pic = "corn_attack_1_1_1_1.png",
	cd = 10,
	bulletIdx = 5,
	onWater = true,--只能放在水上。
	level = {
		[1] = {
			front = {
				frame = "corn_attack_1_1_1_1.png",
				attack = "r1_attack_front",
			},
			back = {
				frame = "corn_attack_1_1_2_1.png",
				attack = "r1_attack_back",
			},
		},
		[2] = {
			front = {
				frame = "corn_attack_1_1_1_1.png",
				attack = "r1_attack_front",
			},
			back = {
				frame = "corn_attack_1_1_2_1.png",
				attack = "r1_attack_back",
			},
		},
		[3] = {
			front = {
				frame = "corn_attack_1_1_1_1.png",
				attack = "r1_attack_front",
			},
			back = {
				frame = "corn_attack_1_1_2_1.png",
				attack = "r1_attack_back",
			},
		},
		anger = {
			angerReadyTime = 5,
			hp = 100,
			speed = 0.8,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "corn_attack_1_1_1_1.png",
				attack = "r1_attack_front",
			},
			back = {
				frame = "corn_attack_1_1_2_1.png",
				attack = "r1_attack_back",
			},
		},
	},
}

--渔网兔
TowersData[6] = {
	name = "风扇塔",
	showPic = "calabash_attack_2_2_1_1.png",
	pic = "calabash_attack_2_2_1_1.png",
	cd = 10,
	bulletIdx = 6,
	onWater = true,
	level = {
		[1] = {
			front = {
				frame = "calabash_attack_2_2_1_1.png",
				attack = "T06_1_2",
			},
			back = {
				frame = "calabash_attack_2_2_2_1.png",
				attack = "T06_1_3",
			},
		},
		[2] = {
			front = {
				frame = "calabash_attack_2_2_1_1.png",
				attack = "T06_1_2",
			},
			back = {
				frame = "calabash_attack_2_2_2_1.png",
				attack = "T06_1_3",
			},
		},
		[3] = {
			front = {
				frame = "calabash_attack_2_2_1_1.png",
				attack = "T06_1_2",
			},
			back = {
				frame = "calabash_attack_2_2_2_1.png",
				attack = "T06_1_3",
			},
		},
		anger = {
			angerReadyTime = 5,
			hp = 100,
			speed = 0.5,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "calabash_attack_2_2_1_1.png",
				attack = "T06_1_2",
			},
			back = {
				frame = "calabash_attack_2_2_2_1.png",
				attack = "T06_1_3",
			},
		},
	},
}
--弓箭塔",
TowersData[7] = {
	name = "弓箭塔",
	nameEnglish = "Arrow Tower",
	fortType = 2,
	showPic = "T_select_7.png",
	pic = "T07_1_1.png",
	handbookPic = "ui_T07_1_1.png",
	cd = 10,
	bulletIdx = 7,
	towerAnchor = {0.5, 0.4},
	seatAnchor = {0.5, 0.6},
	text = "可以同时攻击多个\n怪物，伤害高。",
	textEnglish = "Attack multiple enemies simultaneously.",	
	level = {
		[1] = {
			seat = "T07_seat1.png",
			attackDelay = 0.5,
			number = 1,
			animationAttack = {
				frame = "T07_1_1.png",
				animation = "T07_1",
			},
		},
		[2] = {
			seat = "T07_seat2.png",
			attackDelay = 0.3,
			number = 2,
			animationAttack = {
				frame = "T07_2_1.png",
				animation = "T07_2",
			},
		},
		[3] = {
			seat = "T07_seat3.png",
			attackDelay = 0.2,
			number = 3,
			animationAttack = {
				frame = "T07_3_1.png",
				animation = "T07_3",
			},
		},
		anger = {
			angerReadyTime = 10,
			angerTime = 5,
			hp = 100,
			speed = 0.8,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			number = 5,
			animationAttack = {
				frame = "T07_3_1.png",
				animation = "T07_3",
			},
		},
	},
}

--吸尘兔
TowersData[8] = {
	name = "弹弓塔",
	showPic = "box-R-1.png",
	pic = "R-1-f_attack_01.png",
	cd = 10,
	level = {
		[1] = {
			hp = 200,
			speed = 1,
			money = 100,
			range = 2.34,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[2] = {
			hp = 200,
			speed = 1,
			money = 80,
			range = 2.34,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[3] = {
			hp = 200,
			speed = 1,
			money = 100,
			range = 2.34,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[4] = {
			hp = 200,
			speed = 1,
			money = 100,
			range = 2.34,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
	},
}


--消防兔
TowersData[9] = {
	name = "弹弓塔",
	showPic = "calabash_attack_2_3_1_1.png",
	pic = "calabash_attack_2_3_1_1.png",
	bulletIdx = 9,
	level = {
		[1] = {
			front = {
				frame = "calabash_attack_2_3_1_1.png",
				attack = "T09_1_2",
			},
			back = {
				frame = "calabash_attack_2_3_2_1.png",
				attack = "T09_1_3",
			},
		},
		[2] = {
			front = {
				frame = "calabash_attack_2_3_1_1.png",
				attack = "T09_1_2",
			},
			back = {
				frame = "calabash_attack_2_3_2_1.png",
				attack = "T09_1_3",
			},
		},
		[3] = {
			front = {
				frame = "calabash_attack_2_3_1_1.png",
				attack = "T09_1_2",
			},
			back = {
				frame = "calabash_attack_2_3_2_1.png",
				attack = "T09_1_3",
			},
		},
	},
}


--铁锹兔
TowersData[10] = {
	name = "弹弓塔",
	showPic = "T10_1_1_1.png",
	pic = "T10_1_1_1.png",
	onE45 = true,
	level = {
		[1] = {
			front = {
				frame = "T10_1_1_1.png",
				attack = "T10_1_1",
			},
		},
		[2] = {
			front = {
				frame = "T10_1_1_1.png",
				attack = "T10_1_1",
			},
		},
		[3] = {
			front = {
				frame = "T10_1_1_1.png",
				attack = "T10_1_1",
			},
		},
	},
}

--雷电塔，链接弹
TowersData[11] = {
	name = "雷电塔",
	nameEnglish = "Thunder Tower",
	fortType = 1,
	showPic = "T_select_11.png",
	pic = "T11_1_1.png",
	handbookPic = "ui_T11_1_1.png",
	cd = 15,
	bulletIdx = 11,
	waitAnimation = true,
	text = "拥有持续攻击敌人\n的能力，升级后可\n攻击多个敌人。",
	textEnglish = "High damage and range.",
	level = {
		[1] = {
			animationAttack = {
				frame = "T11_1_1.png",
				animation = "T11_1",
			}
		},
		[2] = {
			animationAttack = {
				frame = "T11_2_1.png",
				animation = "T11_2",
			}
		},
		[3] = {
			animationAttack = {
				frame = "T11_3_1.png",
				animation = "T11_3",
			}
		},
		anger = {
			angerReadyTime = 1,
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			number = 4,
			animationAttack = {
				frame = "T11_3_1.png",
				animation = "T11_3",
			}
		},
	},
}

--兔女郎
TowersData[12] = {
	name = "雷电塔",
	showPic = "T12_1_2_1.png",
	pic = "T12_1_2_1.png",
	bulletIdx = 12,
	onRoad = true,
	level = {
		[1] = {
			front = {
				frame = "T12_1_2_1.png",
				attack = "T12_1_2",
			},
			back = {
				frame = "T12_1_3_1.png",
				attack = "T12_1_3",
			},
		},
		[2] = {
			front = {
				frame = "T12_1_2_1.png",
				attack = "T12_1_2",
			},
			back = {
				frame = "T12_1_3_1.png",
				attack = "T12_1_3",
			},
		},
		[3] = {
			front = {
				frame = "T12_1_2_1.png",
				attack = "T12_1_2",
			},
			back = {
				frame = "T12_1_3_1.png",
				attack = "T12_1_3",
			},
		},
	},
}

--回旋镖兔
TowersData[13] = {
	name = "雷电塔",
	showPic = "peanut_attack_1_1_1_1.png",
	pic = "peanut_attack_1_1_1_1.png",
	cd = 10,
	bulletIdx = 13,
	level = {
		[1] = {
			front = {
				frame = "peanut_attack_1_1_1_1.png",
				attack = "peanut_1_front",
			},
			back = {
				frame = "peanut_attack_1_1_2_1.png",
				attack = "peanut_1_back",
			},
		},
		[2] = {
			front = {
				frame = "peanut_attack_2_3_1_1.png",
				attack = "peanut_2_front",
			},
			back = {
				frame = "peanut_attack_2_3_2_1.png",
				attack = "peanut_2_back",
			},
		},
		[3] = {
			front = {
				frame = "peanut_attack_3_3_1_1.png",
				attack = "peanut_3_front",
			},
			back = {
				frame = "peanut_attack_3_3_2_1.png",
				attack = "peanut_3_back",
			},
		},
		anger = {
			angerReadyTime = 10,
			angerTime = 5,
			hp = 100,
			speed = 0.8,
			range = 4.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "peanut_attack_3_2_1_1.png",
				attack = "peanut_4_front",
			},
			back = {
				frame = "peanut_attack_3_2_2_1.png",
				attack = "peanut_4_back",
			},
		},
	},
}

--潜水兔
TowersData[14] = {
	name = "雷电塔",
	showPic = "T14_1_2_1.png",
	pic = "T14_1_2_1.png",
	onWaterWay = true,
	level = {
		[1] = {
			front = {
				frame = "T14_1_2_1.png",
				attack = "T14_1_2",
			},
		},
		[2] = {
			front = {
				frame = "T14_1_2_1.png",
				attack = "T14_1_2",
			},
		},
		[3] = {
			front = {
				frame = "T14_1_2_1.png",
				attack = "T14_1_2",
			},
		},
	},
}

--拦路兔
TowersData[15] = {
	name = "雷电塔",
	showPic = "R-1-b.png",
	pic = "R-block-1.png",
	cd = 10,
	level = {
		[1] = {
			hp = 100,
			speed = 8,
			range = 1,
			money = 100,
			removeMoney = 80
		}
	},
	blockTime = 3,
	onRoad = true,--可以放在路上的塔，拦路。
	leftRight = {
		frame = "R-block-1.png",
		block = "R-block-2.png"
	},
	upDown = {
		frame = "R-block-3.png",
		block = "R-block-4.png"
	},
}

--火焰塔
TowersData[16] = {
	name = "火焰塔",
	nameEnglish = "Fire Tower",
	fortType = 1,
	showPic = "T_select_16.png",
	pic = "T16_1_1.png",
	handbookPic = "ui_T16_1_1.png",
	bulletIdx = 16,
	waitAnimation = true,
	text = "以自身为中心扩散\n出火焰，对周围的\n敌人造成巨大伤害。",
	textEnglish = "Attack to the circled surrounding monsters.",
	level = {
		[1] = {
			animationAttack = {
				frame = "T16_1_1.png",
				animation = "T16_1",
			}
		},
		[2] = {
			animationAttack = {
				frame = "T16_2_1.png",
				animation = "T16_2",
			}
		},
		[3] = {
			animationAttack = {
				frame = "T16_3_1.png",
				animation = "T16_3",
			}
		},
		anger = {
			angerReadyTime = 2,
			angerTime = 10,
            speed = 3,
            range = 8,
            attack = 190,
            bulletSpeed = 6,
            money = 400,
            removeMoney = 320,
            hp = 200,
			animationAttack = {
				frame = "T16_3_1.png",
				animation = "T16_3",
			}
		},
	},
}

--井盖兔
TowersData[17] = {
	name = "火焰塔",
	showPic = "box-R-1.png",
	pic = "R-1-f_attack_01.png",
	cd = 10,
	level = {
		[1] = {
			hp = 200,
			speed = 3,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[2] = {
			hp = 200,
			speed = 3,
			money = 80,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[3] = {
			hp = 200,
			speed = 3,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[4] = {
			hp = 200,
			speed = 3,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
	},
	onRoad = true,--只能放在路上。
}

--冰霜塔
TowersData[18] = {
	name = "冰霜塔",
	nameEnglish = "Snow Tower",
	fortType = 1,
	showPic = "T_select_18.png",
	pic = "T18_seat1.png",
	handbookPic = "ui_T18_1_1.png",
	towerAnchor = {0.5, 0.7},
	cd = 10,
	bulletIdx = 18,
	noAttackAnimation = true,
	text = "放出寒气，使周围\n一圈的怪物减速。",
	textEnglish = "Decelerate the monsters around it.",
	level = {
		[1] = {
			sprite = "T18_1.png",
			pic = "T18_seat1.png",
			ball = "T18_1_ball.png",
			a = 22,
			b = 10,
			h = 40,
			animationAttack = {
				frame = "T18_1_1.png",
				animation = "T18_1",
			}
		},
		[2] = {
			sprite = "T18_2.png",
			pic = "T18_seat2.png",
			ball = "T18_2_ball.png",
			a = 28,
			b = 12,
			h = 45,
			animationAttack = {
				frame = "T18_2_1.png",
				animation = "T18_2",
			}
		},
		[3] = {
			sprite = "T18_3.png",
			pic = "T18_seat3.png",
			ball = "T18_3_ball.png",
			a = 32,
			b = 15,
			h = 50,
			animationAttack = {
				frame = "T18_3_1.png",
				animation = "T18_3",
			}
		},
		anger = {
			angerReadyTime = 3,
			animationAttack = {
				frame = "T18_3_1.png",
				animation = "T18_3",
			}
		},
	},
}

--跟踪溅射弹
TowersData[19] = {
	name = "冰霜塔",
	showPic = "box-R-1.png",
	pic = "R-1-f_attack_01.png",
	cd = 10,
	bulletIdx = 15,
	level = {
		[1] = {
			hp = 100,
			speed = 0.8,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[2] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 80,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[3] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[4] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
	}
}

--跟踪眩晕弹
TowersData[20] = {
	name = "冰霜塔",
	showPic = "box-R-1.png",
	pic = "R-1-f_attack_01.png",
	cd = 10,
	bulletIdx = 20,
	level = {
		[1] = {
			hp = 100,
			speed = 0.8,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[2] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 80,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[3] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[4] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
	},
}


--机器兔，自爆的塔
TowersData[23] = {
	name = "冰霜塔",
	showPic = "box-R-1.png",
	pic = "R-1-f_attack_01.png",
	cd = 15,
	--bulletIdx = 3,
	level = {
		[1] = {
			hp = 100,
			speed = 0.7,
			range = 4.68,
			money = 100,
			attack = 70,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
		},
		[2] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 80,
			attack = 80,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
		},
		[3] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			attack = 90,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
		},
		[4] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			attack = 100,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
		},
	},
	onRoad = true,--可以放在路上的塔，自爆。
}

--不用的
--跟踪炸弹片伤
TowersData[24] = {
	name = "冰霜塔",
	showPic = "box-R-1.png",
	pic = "R-1-f_attack_01.png",
	cd = 10,
	bulletIdx = 24,
	level = {
		[1] = {
			hp = 100,
			speed = 0.8,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[2] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			attack = 70,
			money = 80,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[3] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
		[4] = {
			hp = 100,
			speed = 1,
			range = 2.34,
			money = 100,
			removeMoney = 80,
			front = {
				frame = "R-1-f_attack_01.png",
				attack = "R1_f_attack",
			},
			back = {
				frame = "R-1-b_attack_01.png",
				attack = "R1_b_attack",
			},
		},
	},
}
