--
-- Author: KK
-- Date: 2014-05-12 13:25:37
--
--普通跟踪弹，好多子弹的基类

local MapInfo = import("..views.MapInfo")
local Bullet = import(".Bullet")

local Bullet01 = class("Bullet01", Bullet)

function Bullet01:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet01.super.ctor(self, params)
end

function Bullet01:updateForTarget(dt)
	if self.target then
		self.targetPos = self.target:getPositionCenter()
		self:changeSpeed(self.targetPos)
		if self:checkCrash(cc.p(self:getPosition()), self.targetPos) then
			if self.level == 4 then
				self:angerHit()
			else
				self:hit()
			end
		end
	else
		self:hit()
	end
end

--一种可点击爆炸的气泡。
function Bullet01:angerHit()
	if self.target then
		local bomb = display.newSprite("#"..self.levelData.angerPic)
		bomb:setScale(3)
		self.target:addBuffer({
			bufferType == EnemyBuffer.BUFFER_BUBBLE,
			pic = bomb,
			attack = self.attack,
			effect = self.levelData.slowEffect,
			time = self.levelData.slowTime
		})
	end
	g_fightLayer:removeBullet(self)
	--技能音效
	SoundManager.playSound(GAME_SOUND.Tower[1].skill2)
end

function Bullet01:hit()
	if self.target then
		self.target:updateHp(-self.attack, self.idx)
	end

	local x,y = self:getPosition()
	--[[
	if self.target ~= nil then
		x,y = self.targetPos.x, self.targetPos.y
	end
	--]]

	local bomb = display.newSprite("#"..self.pic,x,y)
	g_fightLayer:addChild(bomb, BaseZOrder.bullet)
	local bombAni = display.getAnimationCache(self.bombAniName)
	bomb:playAnimationOnce(bombAni, true)
	g_fightLayer:removeBullet(self)
end
return Bullet01