--
-- Author: kk
-- Date: 2014-05-15 14:59:29
--
--牙膏兔子弹

local MapInfo = import("..views.MapInfo")
local Bullet01 = import(".Bullet01")
local Bullet02 = class("Bullet02", Bullet01)

function Bullet02:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet02.super.ctor(self, params)
end

function Bullet02:angerHit()
	local x,y = self:getPosition()
	if self.target ~= nil then
		x,y = self.target:getPosition()
	end
	local bomb = display.newSprite("#"..self.pic,x,y)
	bomb:setScale(7)
	g_fightLayer:addChild(bomb)
	local bombAni = display.getAnimationCache(self.bombAniName)
	bomb:runAction(transition.sequence({
		cc.Animate:create(bombAni),
		cc.CallFunc:create(function()
			--半径两格，无伤害，定身5秒。
			local enemies = g_fightLayer:getEnimiesAroundPos(cc.p(x,y), math.pow(MapInfo.tileSize*2,2))
			for i = 1, #enemies do
				local pic = display.newSprite("#"..self.data.slowPic)
				pic:setScale(3)
				enemies[i]:addBuffer({
					bufferType = EnemyBuffer.BUFFER_DIZZY,
					pic = pic,
					attack = 0,
					chance = 1,
					time = self.levelData.slowTime,
				})
			end
			bomb:removeFromParent()
			g_fightLayer:removeBullet(self)
		end)
	}))
	self.needUpdate = false
end

function Bullet02:hit()
	if self.target then
		local enPt = self.target:getPositionCenter()
		local pic = display.newSprite("#B02_1.png",enPt.x,enPt.y)
		g_fightLayer:addChild(pic, BaseZOrder.bullet)
		local bombAni = display.getAnimationCache(self.bombAniName)
		pic:playAnimationOnce(bombAni, true)
		local buffer = display.newSprite("#"..self.data.slowPic)
		buffer:setAnchorPoint(cc.p(0.5,0.5))
		local frames = display.newFrames("B02_slowBuffer_%d.png", 1, 3)
    	local animation = display.newAnimation(frames, 0.1)
    	buffer:playAnimationForever(animation)
		self.target:addBuffer({
			bufferType = EnemyBuffer.BUFFER_SLOW,
			pic = buffer,
			attack = self.excelLevelData.attack,
			effect = self.levelData.slowEffect,
			time = self.levelData.slowTime,
		})
	end
	g_fightLayer:removeBullet(self)
end

return Bullet02