--
-- Author: KK
-- Date: 2014-05-13 15:56:28
--
--风扇兔穿透弹

local MapInfo = import("..views.MapInfo")
local Bullet = import(".Bullet")

local Bullet03 = class("Bullet03", Bullet)

function Bullet03:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet03.super.ctor(self, params)
    self.touchedEnemy = {}
    self.touchedThing = {}
    self.rangeSq = math.pow(MapInfo.tileSize*0.5, 2)
    self:runAction(cc.RepeatForever:create(cc.RotateBy:create(0.5+self.level*0.1, -360)))
    --减少计算
    self.intervalSpeed = 0
    self:GetMapThingsInPath()
end

function Bullet03:updateForTarget(dt)
	if self.PosOld == nil then--用于碰撞检测，防止穿过敌人没造成伤害
		self.PosOld = cc.p(self:getPosition())
	end

	self.intervalSpeed = self.intervalSpeed + dt
	if self.intervalSpeed < 0.1 then return end
	self.intervalSpeed = 0

	--打怪
	local pos = cc.p(self:getPosition())
	for k,v in pairs(g_fightLayer.enemies) do
		local hurted = false
		for i = 1, #self.touchedEnemy do
			if self.touchedEnemy[i] == v then
				hurted = true
				break
			end
		end
		if not hurted then
			local enPt = v:getPositionCenter()
			local enemySize = v.enemySize
			if v.idx == 4 then
				enemySize.width = enemySize.width*1.03
				enemySize.height = enemySize.height*1.03
			end
			local r1 = Bullet.getObjRect(enPt, enemySize)--cc.size(35,35))
			--local r2 = Bullet.getObjRect(pos, cc.size(5,5))--self:getContentSize())
			--if cc.rectIntersectsRect(r1, r2) then--旧碰撞检测
			if self:IsLineIntersectRect(self.PosOld,cc.p(self:getPosition()),r1) then--新
				v:updateHp(-self.attack, self.idx)
				local bomb = display.newSprite("#B03_1.png",enPt.x,enPt.y)
				g_fightLayer:addChild(bomb, BaseZOrder.bullet)
				local bombAni = display.getAnimationCache(self.bombAniName)
				bomb:playAnimationOnce(bombAni, true)
				if v ~= nil then
					self.touchedEnemy[#self.touchedEnemy+1] = v
				end
			end
		end
	end
	--打怪穿过后还得打道具
	for i = 1, #self.thingsInPath do
		local thing = self.thingsInPath[i]
		if thing ~= nil and thing.part == false then
			local hurted = false
			for j = 1, #self.touchedThing do
				if self.touchedThing[j] == thing then
					hurted = true
					break
				end
			end
			if not hurted then
				local w = self.thingsInPath[i].width*MapInfo.tileSize
				local h = self.thingsInPath[i].height*MapInfo.tileSize
				local r1 = Bullet.getObjRect(self.thingsInPath[i].pos, cc.size(w, h))
				--local r2 = Bullet.getObjRect(pos, cc.size(25,25))
				--if cc.rectIntersectsRect(r1, r2) then--旧碰撞检测
				if self:IsLineIntersectRect(self.PosOld,cc.p(self:getPosition()),r1) then--新
					local bomb = display.newSprite("#B03_1.png",self:getPosition())
					g_fightLayer:addChild(bomb, BaseZOrder.bullet)
					local bombAni = display.getAnimationCache(self.bombAniName)
					bomb:playAnimationOnce(bombAni, true)
					g_fightLayer:hitThing(thing,self.attack,self.towerIdx)
					if thing ~= nil then
						self.touchedThing[#self.touchedThing+1] = thing
					end
				end
			end
		end
	end
	self.PosOld = cc.p(self:getPosition())
end

return Bullet03