--
-- Author: KK
-- Date: 2014-07-23 16:50:30
--
--渔网兔，减速

local MapInfo = import("..views.MapInfo")
local Bullet01 = import(".Bullet01")
local Bullet06 = class("Bullet06", Bullet01)

function Bullet06:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet06.super.ctor(self, params)
end

function Bullet06:angerHit()
	local x,y = self:getPosition()
	if self.target ~= nil then
		x,y = self.target:getPosition()
	end
	local bomb = display.newSprite("#"..self.pic,x,y)
	bomb:setScale(5)
	g_fightLayer:addChild(bomb,BaseZOrder.bullet)
	local bombAni = display.getAnimationCache(self.bombAniName)
	bomb:runAction(transition.sequence({
		cc.Animate:create(bombAni),
		cc.CallFunc:create(function()
			local enemies = g_fightLayer:getEnimiesAroundPos(cc.p(x,y), math.pow(MapInfo.tileSize*3,2))
			for i = 1, #enemies do
				local pic = display.newSprite("#"..self.data.slowPic)
				enemies[i]:addBuffer({
					bufferType = EnemyBuffer.BUFFER_DIZZY,
					pic = pic,
					attack = self.levelData.attack,
					chance = 1,
					time = self.levelData.slowTime,
				})
			end
			bomb:removeFromParent()
			g_fightLayer:removeBullet(self)
		end)
	}))
	self.needUpdate = false
end

function Bullet06:hit()
	if self.target then
		local bomb = display.newSprite("#"..self.data.slowPic)
		self.target:addBuffer({
			bufferType = EnemyBuffer.BUFFER_SLOW,
			pic = bomb,
			attack = self.attack,
			effect = self.levelData.slowEffect,
			time = self.levelData.slowTime,
		})
	end
	g_fightLayer:removeBullet(self)
end

return Bullet06