--
-- Author: KK
-- Date: 2014-07-11 10:39:22
--
--弹弓弹一发

local MapInfo = import("..views.MapInfo")
local Bullet = import(".Bullet")
local Bullet07 = class("Bullet07", Bullet)

function Bullet07:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    self.angle = params.angle
    Bullet07.super.ctor(self, params)
    --减少计算
    self.intervalSpeed = 0
    self:GetMapThingsInPath()
end

function Bullet07:initSpeed()
	local px, py = self:getPosition()
	local dest
	if self.targetType == 2 then
		--self:setRotation(self:getRotation()-90)
		self.thingPos = MapInfo:getCenterOfThing(self.thingTarget)
		dest = cc.p(self.thingPos.x - px,
				 	self.thingPos.y - py)
		local z = math.sqrt(dest.x*dest.x +dest.y*dest.y)
		self.xSpeed = self.speed * dest.x / z
		self.ySpeed = self.speed * dest.y / z
		self.time = z / self.speed
	elseif self.targetType == 1 then
		self:setRotation(self:getRotation()-90)
		self.targetPos = self.target:getPositionCenter()
		dest = cc.p(self.targetPos.x - px,
				 	self.targetPos.y - py)
		local z = math.sqrt(dest.x*dest.x +dest.y*dest.y)
		self.xSpeed = self.speed * dest.x / z
		self.ySpeed = self.speed * dest.y / z
		self.time = z / self.speed
	elseif self.targetType == 3 then
		--self:setRotation(self:getRotation()-90)
		self.fortPos = self.fortTarget:getPositionCenter()
		dest = cc.p(self.fortPos.x - px,
				 	self.fortPos.y - py)
		local z = math.sqrt(dest.x*dest.x +dest.y*dest.y)
		self.xSpeed = self.speed * dest.x / z
		self.ySpeed = self.speed * dest.y / z
		self.time = z / self.speed
	elseif self.targetType == 4 then
		self:setRotation(self:getRotation()-90)
		self.cityTargetPos = self.cityTarget:getPositionCenter()
		dest = cc.p(self.cityTargetPos.x - px,
				 	self.cityTargetPos.y - py)
		local z = math.sqrt(dest.x*dest.x +dest.y*dest.y)
		self.xSpeed = self.speed * dest.x / z
		self.ySpeed = self.speed * dest.y / z
		self.time = z / self.speed
	end
	if self.data.rotate then
		local rt = kkFunc.getLineRotation(cc.p(0,0), dest)
		self:setRotation(rt)
	end
	--左右两边箭要重算速度。
    --2dx的Rotation是顺时针的，子弹0度朝向其实是90度。
    if self.angle ~= 0 then
	    local angle = (90+360-self:getRotation()+self.angle)/180*3.1416
		self.xSpeed = self.speed*math.cos(angle)
		self.ySpeed = self.speed*math.sin(angle)
		self:setRotation(self:getRotation()-self.angle)
	end
	--出塔一小段距离开始放子弹
	local startDist = 45
	local t = startDist/self.speed
	self:setPosition(px + t*self.xSpeed, py + t*self.ySpeed)
	self.time = self.time - t
end

--不好用。
function Bullet07:getAngleSpeed(angle)
	--这是向量(x,y)逆时针转θ角度后的值(xcosθ−ysinθ，xsinθ+ycosθ)
	self.xSpeed = self.xSpeed*math.cos(angle)-self.ySpeed*math.sin(angle)
	self.ySpeed = self.xSpeed*math.sin(angle)+self.ySpeed*math.cos(angle)
end

function Bullet07:update(dt)
	if self.PosOld == nil then--用于碰撞检测，防止穿过敌人没造成伤害
		self.PosOld = cc.p(self:getPosition())
	end

	self.passTime = self.passTime + dt
	if not self:updatePos(dt) then return end
	
	self.intervalSpeed = self.intervalSpeed + dt
	if self.intervalSpeed < 0.1 then return end
	self.intervalSpeed = 0

	--旧的碰撞检测
	-- local pos = cc.p(self:getPosition())
	-- local r2 = Bullet.getObjRect(pos, cc.size(5,5))--self:getContentSize())
	-- self:CheckCollision(pos,r2)

	if not self:CheckCollision(nil,nil,true) then--打中敌人后子弹会移除，所以未打中时再记录坐标
		self.PosOld = cc.p(self:getPosition())
	end
end

function Bullet07:CheckCollision(pos,r2,isLine)
	--city
	if self.cityTarget ~= nil then
		local cityPt = self.cityTarget:getPositionCenter()
		local size = cc.size(60,70)
		local c1 = Bullet.getObjRect(cityPt, size)--cc.size(25,25))
		if isLine then
			if self:IsLineIntersectRect(self.PosOld,cc.p(self:getPosition()),c1) then
				self:CityHurt(self.cityTarget,cityPt)
				return true
			end
		elseif cc.rectIntersectsRect(c1, r2) then
			self:CityHurt(self.cityTarget)
			return true
		end
	end

	for k,v in pairs(g_fightLayer.enemies) do
		local enPt = v:getPositionCenter()
		local r1 = Bullet.getObjRect(enPt, v.enemySize)--cc.size(25,25))
		if isLine then
			if self:IsLineIntersectRect(self.PosOld,cc.p(self:getPosition()),r1) then
				self:EnemyHurt(v,enPt)
				return true
			end
		elseif cc.rectIntersectsRect(r1, r2) then
			self:EnemyHurt(v)
			return true
		end
	end

	for i = 1, #self.thingsInPath do
		local thing = self.thingsInPath[i]
		if thing ~= nil then
			--打完的浮冰不打。
			local hideIce = thing.thingType == 1 and not thing.sprite:isVisible()
			if not hideIce and not thing.part then
				local r1 = MapInfo:getThingRect(thing)
				if isLine then
					if self:IsLineIntersectRect(self.PosOld,cc.p(self:getPosition()),r1) then
						self:ThingHurt(thing)
						return true
					end
				elseif cc.rectIntersectsRect(r1, r2) then
					self:ThingHurt(thing)
					return true
				end
			end
		end
	end
 
	return false
end

function Bullet07:CityHurt(city,pos)
	city:updateHp(-self.attack, self.idx)
	local bomb = display.newSprite("#B07_1.png",pos.x,pos.y)
	g_fightLayer:addChild(bomb, BaseZOrder.bullet)
	local bombAni = display.getAnimationCache(self.bombAniName)
	bomb:playAnimationOnce(bombAni, true)
	g_fightLayer:removeBullet(self)
end

function Bullet07:EnemyHurt(enemy,pos)
	if self.level == 4 then
		local r = math.random(1,10)
		if r == 1 then --秒杀！
			enemy:secKill()
			return true
		end
	end
	enemy:updateHp(-self.attack, self.idx)
	local bomb = display.newSprite("#B07_1.png",pos.x,pos.y)
	g_fightLayer:addChild(bomb, BaseZOrder.bullet)
	local bombAni = display.getAnimationCache(self.bombAniName)
	bomb:playAnimationOnce(bombAni, true)
	g_fightLayer:removeBullet(self)
end

function Bullet07:ThingHurt(thing)
	g_fightLayer:hitThing(thing, self.attack)
	local bomb = display.newSprite("#B07_1.png",(self.PosOld.x+self:getPositionX())/2,(self.PosOld.y+self:getPositionY())/2)--取中间点避免爆炸过偏
	g_fightLayer:addChild(bomb, BaseZOrder.bullet)
	local bombAni = display.getAnimationCache(self.bombAniName)
	bomb:playAnimationOnce(bombAni, true)
	g_fightLayer:removeBullet(self)
end

return Bullet07