--
-- Author: KK
-- Date: 2014-05-13 17:36:47
--
--链接弹

local MapInfo = import("..views.MapInfo")
local Bullet = import(".Bullet")
local Bullet11 = class("Bullet11", Bullet)

function Bullet11:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet11.super.ctor(self, params)

	self.size = self:getContentSize()
    self.fort = params.fort
	self:setAnchorPoint(cc.p(0.5,0.05))
    if self.thingTarget ~= nil then
		local pt = MapInfo:getCenterOfThing(self.thingTarget)
		local rt = kkFunc.getLineRotation(cc.p(self:getPosition()), pt)
		self:setRotation(rt)
    	self:setScaleByTarget(pt)
	elseif self.target ~= nil then
		local enPt = cc.p(self.target:getPosition())
		local rt = kkFunc.getLineRotation(cc.p(self:getPosition()),enPt)
		self:setRotation(rt)
    	self:setScaleByTarget(enPt)
	end
	local bombAni = display.getAnimationCache(self.bombAniName)
	self:playAnimationForever(bombAni)

	self.time = 0.5
end

function Bullet11:setScaleByTarget(enPt)
	local px, py = self:getPosition()
	local dest = cc.p(enPt.x - px,
			 	enPt.y - py)
	local z = math.sqrt(dest.x*dest.x +dest.y*dest.y)
	self:setScaleY(z/self.size.height)
end

function Bullet11:update(dt)
	self.time = self.time + dt
	local attack = self.attack*10*dt
	if self.thingTarget then
		g_fightLayer:hitThing(self.thingTarget, attack)
		if self.thingTarget == nil then
			self.fort:removeBullet(self)
			return
		end
		if self.time > 0.5 then
			self.time = self.time - 0.5
			local pt = MapInfo:getCenterOfThing(self.thingTarget)
			local bomb = display.newSprite("#B11_bomb_1.png",pt.x,pt.y)
			g_fightLayer:addChild(bomb, BaseZOrder.bullet)
			local bombAni = display.getAnimationCache("B11_Bomb")
			bomb:playAnimationOnce(bombAni, true)
		end
	elseif self.target then
		if not self.fort:isEnemyInRange(self.target) then
			self.fort:removeBullet(self)
			return
		end
		local enPt = cc.p(self.target:getPositionCenter())
		local rt = kkFunc.getLineRotation(cc.p(self:getPosition()), enPt)
		self:setRotation(rt)
    	self:setScaleByTarget(enPt)
		if self.time > 0.5 then
			self.time = self.time - 0.5
			local y = self.target:getPositionCenterDy()
			local bomb = display.newSprite("#B11_bomb_1.png",0,y)
			self.target:addChild(bomb)
			local bombAni = display.getAnimationCache("B11_Bomb")
			bomb:playAnimationOnce(bombAni, true)
		end
    	--[[
    	--溅射伤害。
    	local aroundEnemies = g_fightLayer:getEnimiesAroundPos(enPt, math.pow(MapInfo.tileSize*0.8,2))
    	for i = 1, #aroundEnemies do
    		if self.target ~= aroundEnemies[i] then
    			if aroundEnemies[i].__cname == "Enemy46" then
    				aroundEnemies[i]:updateHpForFireCorn(-attack*0.5)
    			else
					aroundEnemies[i]:updateHp(-attack*0.5, self.idx)
				end
			end
    	end
    	if self.target.__cname == "Enemy46" then
    		self.target:updateHpForFireCorn(-attack)
    	else
			self.target:updateHp(-attack, self.idx)
		end
    	--]]
		self.target:updateHp(-attack, self.idx)
		if self.target == nil then
			--g_fightLayer:removeBullet(self)
			self.fort:removeBullet(self)
		end
	else--怪死后
		self.fort:removeBullet(self)
	end
end

return Bullet11