--
-- Author: KK
-- Date: 2014-07-10 11:04:49
--
--回旋镖

local MapInfo = import("..views.MapInfo")
local Bullet = import(".Bullet")
local Bullet13 = class("Bullet13", Bullet)

function Bullet13:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet13.super.ctor(self, params)
    self.endTime = self.levelData.dist*MapInfo.tileSize/self.speed
    self.backTurn = false
    self.touchedEnemy = {}
    self.rangeSq = math.pow(MapInfo.tileSize*0.5,2)
end

function Bullet13:update(dt)
	self.passTime = self.passTime + dt
	if self.passTime > self.endTime then
		if not self.backTurn then
			self.xSpeed = -self.xSpeed
			self.ySpeed = -self.ySpeed
			self.touchedEnemy = {}
			self.backTurn = true
			self.passTime = 0
		else
			g_fightLayer:removeBullet(self)
			return
		end
	end
	if not self:updatePos(dt) then return end

	if self.thingTarget then
		self:updateForThing(dt)
	else--if self.target then
		for k,v in pairs(g_fightLayer.enemies) do
			local hurted = false
			for i = 1, #self.touchedEnemy do
				if self.touchedEnemy[i] == v then
					hurted = true
					break
				end
			end
			if not hurted then
				local enPt = v:getPositionCenter()
				local dist2 = cc.pDistanceSQ(enPt, cc.p(self:getPosition()))
				if dist2 < self.rangeSq then
					self:attackEnemy(v)
				end
			end
		end
	end
end

function Bullet13:attackEnemy(en)
	local enPt = en:getPositionCenter()
	local enPos = cc.p(en:getPosition())
	en:updateHp(-self.attack, self.idx)
	local bomb = display.newSprite("#"..self.pic,enPt.x,enPt.y)
	g_fightLayer:addChild(bomb, BaseZOrder.bullet)
	local bombAni = display.getAnimationCache(self.bombAniName)
	bomb:playAnimationOnce(bombAni, true)
	if en ~= nil then
		self.touchedEnemy[#self.touchedEnemy+1] = en
	end
	--怒气子弹在这里！有溅射效果！
	if self.level == 4 then
		bomb:setScale(2)
		local d2 = math.pow(MapInfo.tileSize,2)
		for k,v in pairs(g_fightLayer.enemies) do
			if v ~= en then
				local dist2 = cc.pDistanceSQ(enPos, cc.p(v:getPosition()))
				if dist2 <= d2 then
					v:updateHp(-self.attack*0.5, self.idx)
				end
			end
		end
	end
end

--[[没用吧？
function Bullet13:hit()
	for k,v in pairs(g_fightLayer.enemies) do
		local enPt = v:getPositionCenter()
		local dist2 = cc.pDistanceSQ(enPt, self.pos)
		if dist2 < self.rangeSq then
			v:updateHp(-self.levelData.attack)
		end
	end
	local things = g_fightLayer:getThingsAroundPos(self.pos, self.rangeSq)
	for i = 1, #things do
		g_fightLayer:hitThing(things[i],self.levelData.attack)
	end
end
--]]

return Bullet13