--
-- Author: KK
-- Date: 2014-11-19 16:18:58
--
--火焰塔光圈弹

local MapInfo = import("..views.MapInfo")
local Bullet = import(".Bullet")
local Bullet16 = class("Bullet16", Bullet)

function Bullet16:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet16.super.ctor(self, params)
	self.rangeSq = math.pow(params.range+MapInfo.tileSize*0.5,2)
	self.pos = cc.p(self:getPosition())
	--[[
	self.scale = 0
	self:setScale(self.scale)
	self:setAnchorPoint(cc.p(0.5,0.5))
	--]]
	--print(self.pos.x,self.pos.y)

	local scale = 1.4+self.level*0.15
	self:setScale(scale)
	self:setRotation(math.random(0,360))
	
	local bombAni = display.getAnimationCache(self.bombAniName)
	self:playAnimationOnce(bombAni, true, function()
		self:hit()
		g_fightLayer:removeBullet(self)
	end)
	--音效
	SoundManager.playSound(GAME_SOUND.Tower[16].attack1)
end

function Bullet16:update(dt)
--[[
	self.passTime = self.passTime + dt
	if self.passTime > 0.1 then
		self.scale = self.scale + 0.3
		if self.scale >= 1.2 then
			self:hit()
			g_fightLayer:removeBullet(self)
			return
		end
		self:setScale(self.scale)
		self.passTime = self.passTime - 0.1
	end
--]]
end

function Bullet16:hit()
	if g_playScene.mode == "attackCityMode" then
		if g_playScene.cityHome ~= nil then
			local dist2 = cc.pDistanceSQ(self.pos, g_playScene.cityHome:getPositionCenter())
			if dist2 <= self.rangeSq then
				g_playScene.cityHome:updateHp(-self.attack)
			end
		end
	end
	local enemies = g_fightLayer:getEnimiesAroundPos(self.pos, self.rangeSq,true)
	for i = 1, #enemies do
		local y = enemies[i]:getPositionCenterDy()
		local bomb = display.newSprite("#B16_bomb_1.png",0,y)
		enemies[i]:addChild(bomb)
		local bombAni = display.getAnimationCache("B16_Bomb")
		bomb:playAnimationOnce(bombAni, true)
		enemies[i]:updateHp(-self.attack,self.towerIdx)
	end
	local things = g_fightLayer:getThingsAroundPos(self.pos, self.rangeSq)
	for i = 1, #things do
		local pt = MapInfo:getCenterOfThing(things[i])
		local bomb = display.newSprite("#B16_bomb_1.png",pt.x,pt.y)
		g_fightLayer:addChild(bomb, BaseZOrder.bullet)
		local bombAni = display.getAnimationCache("B16_Bomb")
		bomb:playAnimationOnce(bombAni, true)
		g_fightLayer:hitThing(things[i],self.attack)
	end
end

return Bullet16