--
-- Author: KK
-- Date: 2014-07-04 09:46:34
--
--吉它光圈弹

local MapInfo = import("..views.MapInfo")
local Bullet = import(".Bullet")
local Bullet18 = class("Bullet18", Bullet)

function Bullet18:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet18.super.ctor(self, params)
	self.rangeSq = math.pow(params.range+MapInfo.tileSize*0.5,2)
	self.scale = 0
	self:setAnchorPoint(cc.p(0.47,0.5))
	self:setRotation(math.random(0,360))
	self.pos = cc.p(self:getPosition())
	--print(self.pos.x,self.pos.y)

	--local bomb = display.newSprite("#"..self.pic,self:getPosition())
	--g_fightLayer:addChild(bomb, BaseZOrder.bullet)
	local scale = 1.4+self.level*0.15
	self:setScale(scale)
	local bombAni = display.getAnimationCache(self.bombAniName)
	self:playAnimationOnce(bombAni, true, function()
		self:hit()
		g_fightLayer:removeBullet(self)
	end)
	--音效
	SoundManager.playSound(GAME_SOUND.Tower[18].attack1)
end

function Bullet18:update(dt)
	--[[
	self.passTime = self.passTime + dt
	if self.passTime > 0.1 then
		self.scale = self.scale + 2
		if self.scale == 8 then
			self:hit()
			g_fightLayer:removeBullet(self)
			return
		end
		self:setScale(self.scale)
		self.passTime = self.passTime - 0.1
	end
	--]]
end

function Bullet18:update(dt)
end

function Bullet18:hit()
	if g_playScene.mode == "attackCityMode" then
		if g_playScene.cityHome ~= nil then
			local dist2 = cc.pDistanceSQ(self.pos, g_playScene.cityHome:getPositionCenter())
			if dist2 <= self.rangeSq then
				g_playScene.cityHome:updateHp(-self.attack)
			end
		end
	end
	local enemies = g_fightLayer:getEnimiesAroundPos(self.pos, self.rangeSq,true)
	for i = 1, #enemies do
		--怒气技能
		if self.level == 4 then
			local pic = display.newSprite("#"..self.data.weakPic)
			pic:setAnchorPoint(cc.p(0.5,0.8))
			enemies[i]:addBuffer({
				bufferType == EnemyBuffer.BUFFER_WEAK,
				pic = pic,
				attack = self.attack,
				towerIdx = self.towerIdx,
				hurtEffect = self.levelData.hurtEffect,
				slowEffect = self.levelData.slowEffect,
				time = self.levelData.weakTime,
			})
		else
			local pic = display.newSprite("#"..self.data.slowPic)
			pic:setAnchorPoint(cc.p(0.5,0.8))
			enemies[i]:addBuffer({
				bufferType = EnemyBuffer.BUFFER_SLOW,
				pic = pic,
				attack = self.attack,
				towerIdx = self.towerIdx,
				effect = self.levelData.slowEffect,
				time = self.levelData.slowTime,
			})
		end
	end
	local things = g_fightLayer:getThingsAroundPos(self.pos, self.rangeSq)
	for i = 1, #things do
		g_fightLayer:hitThing(things[i],self.attack)
	end
end

return Bullet18