--
-- Author: kk
-- Date: 2014-05-15 10:05:56
--
--跟踪溅射弹

local MapInfo = import("..views.MapInfo")
local Bullet01 = import(".Bullet01")
local Bullet4 = class("Bullet4", Bullet01)

function Bullet4:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet4.super.ctor(self, params)
end

function Bullet4:hit()
	self.target:updateHp(-self.attack, self.idx)
	if self.target ~= nil then
		local x,y = self.target:getPosition()
		local bomb = display.newSprite("#"..self.pic,x,y)
		g_fightLayer:addChild(bomb)
		local bombAni = display.getAnimationCache(self.bombAniName)
		bomb:playAnimationOnce(bombAni, true)
		self:splitAttack()
		g_fightLayer:removeBullet(self)
	end
end

function Bullet4:splitAttack()
	local pos = cc.p(self:getPosition())
	for k,v in pairs(g_fightLayer.enemies) do
		local enPt = v:getPositionCenter()
		local dest = cc.pGetDistance(enPt, pos)
		if self.target ~= v and dest < 100 then
			--1是跟踪弹
			local bullet = Bullet01.new({
					idx = 1,
					fortPos = pos,
					target = v,
					thingTarget = nil,
					level = 1,
				});
			g_fightLayer:addBullet(bullet)
		end
	end
end

return Bullet4