--
-- Author: kk
-- Date: 2014-05-15 14:08:36
--
--跟踪炸弹片伤

local MapInfo = import("..views.MapInfo")
local Bullet01 = import(".Bullet01")
local Bullet5 = class("Bullet5", Bullet01)

function Bullet5:ctor(params)    
	-- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Bullet5.super.ctor(self, params)
end

function Bullet5:hit()
	local x,y = self.target:getPosition()
	Bullet5.bomb(cc.p(x,y))
	g_fightLayer:removeBullet(self)
end

function Bullet5.bomb(pos)
	local bomb = display.newSprite("#"..self.pic,pos.x,pos.y)
	g_fightLayer:addChild(bomb,20)
	bomb:runAction(transition.sequence({
		cc.ScaleTo:create(0.1,3),
		cc.CallFunc:create(function()
			for k,v in pairs(g_fightLayer.enemies) do
				local enPt = v:getPositionCenter()
				local dest = cc.pGetDistance(enPt, pos)
				if dest < 100 then
					v:updateHp(-self.levelData.attack, self.idx)
				end
			end
		end),
		cc.ScaleTo:create(0.1,1),
		cc.CallFunc:create(function()
			bomb:removeFromParent()
		end)
	}))
end

return Bullet5