--
-- Author: Wangzhihao
-- Date: 2015-07-08 10:13:30
--
local HpBar = import("..sprites.HpBar")
local City = class("City", function(params)
    return display.newSprite("#cityBottom.png")
end)

function City:ctor(params)
	ResData.loadRes("E64")
	self:setPosition(params.posX,params.posY)
	--self:setSclae(2)
	local up = display.newSprite("#cityUp.png",self:getContentSize().width/2,-7):addTo(self,5)
	up:setAnchorPoint(cc.p(0.5,0))
	self.bossIdx = 64 
	self.localData = EnemyData[self.bossIdx]
	self.waitAct = display.getAnimationCache(self.localData.waitAct)
	self.hurtAct = display.getAnimationCache(self.localData.hurtAct)
	self.bossPic = display.newSprite("#"..self.localData.pic2,self:getContentSize().width/2,10):addTo(self,2)
	self.bossPic:setAnchorPoint(cc.p(0.5,0))
	self.bossPic:playAnimationForever(self.waitAct)
	
	--[[self.bossPic:stopAllActions()
	self.bossPic:playAnimationOnce(self.magicAct, false, function()
		self.bossPic:setSpriteFrame(display.newSpriteFrame("E64_hurt_1.png"))
		self.bossPic:playAnimationForever(self.waitAct)
	end)]]
	--HP
	self.needUpdate = true
	local theme = LevelsData[g_playScene.level].theme
	self.hpMax = LevelsData.cityHp[theme] --暂定，策划来修改
	self.hp = self.hpMax
	g_playScene.cityHpBar = HpBar.new(HPBAR_TYPE_City, cc.size(0, 0), self.hpMax,cc.p(display.width*0.45,display.height-40))
	g_playScene:addChild(g_playScene.cityHpBar,PlaySceneOrder.setting-1)
end
function City:getPositionCenter()
	local enPt = cc.p(self:getPosition())
	return enPt
end
function City:updateHp(hpAdd, towerIdx, isHero)	
	if not self.needUpdate then return end
	
	if hpAdd ~= nil then
		self.hp = self.hp + hpAdd
	end
	--[[self.bossPic:stopAllActions()
	self.bossPic:playAnimationOnce(self.hurtAct, false, function()
		self.bossPic:setSpriteFrame(display.newSpriteFrame("E64_hurt_1.png"))
		self.bossPic:playAnimationForever(self.waitAct)
	end)]]
	g_playScene.cityHpBar:updateHp(self.hp)
	if self.hp<=0 then
		self:playAnimationAfterDead()
		--音效
		--SoundManager.playEnemyDieSound(self.idx)
		g_fightLayer:removeCity(self)
		if VERSION_REDUCE then
			g_playScene:showResult(true)
		else
			if g_playScene:isPopGiftBox() then
				g_playScene:popGiftBox()
			else
				if g_playScene:isPopNewElementTips() then
		            g_playScene:unLockNewElement()
		        else
		            g_playScene:showResult(true)
		        end
			end
	    end
	end
end

function City:playAnimationAfterDead()
	--怪死后动画
	local px,py = self:getPosition()
	local dead = display.newSprite(EnemyData.common.deadPic,px,py)
	g_fightLayer:addChild(dead,300)
	local deadAni = display.getAnimationCache(EnemyData.common.deadAni)
	dead:playAnimationOnce(deadAni, true)
end
return City