--
-- Author: KK
-- Date: 2014-06-17 10:50:24
--

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy2 = class("Enemy2", Enemy)

function Enemy2:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy2.super.ctor(self, params)
end

function Enemy2:doSomething()
	if 1 then return end --小怪不攻击
	--数值为0也不攻击
	if ExcelEnemyData[self.idx].attack == nil or 
		ExcelEnemyData[self.idx].attack == 0 then
		return
	end
	local fort = nil
	fort = self:getNearFort(self.rangeSq)
	if fort == nil then return end

	local bulletIdx = self.localData.bulletIdx or 103
	--音效
	SoundManager.playSound(GAME_SOUND.EnemyAttack)
	if self.attackAct == nil then --没有攻击动画，将来无用。
		local bullet = Bullets[bulletIdx].new({
				idx = bulletIdx,
				fortPos = self:getPositionCenter(),
				fortTarget = fort,
				level = 1,
				fromEnemy = self.idx,
			})
		g_fightLayer:addBullet(bullet)
		return
	end
	self.enemyPic:playAnimationOnce(self.attackAct, false, function()
		local bullet = Bullets[bulletIdx].new({
				idx = bulletIdx,
				fortPos = self:getPositionCenter(),
				fortTarget = fort,
				level = 1,
				fromEnemy = self.idx,
			})
		g_fightLayer:addBullet(bullet)
	end)
end

return Enemy2