--
-- Author: KK
-- Date: 2014-07-15 14:09:38
--
--辣椒加速怪

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy41 = class("Enemy41", Enemy)

function Enemy41:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy41.super.ctor(self, params)
    self.offEquipment = false
end

function Enemy41:speedUp()
	local enimies = g_fightLayer:getEnimiesAroundPos(
		cc.p(self:getPosition()), self.rangeSq)
	for i = 1, #enimies do
		if enimies[i] ~= self then
			enimies[i]:addBuffer({
				bufferType = EnemyBuffer.BUFFER_FIRE,
				time = 5,
			})
		end
	end
	if #enimies > 0 then
		SoundManager.playSound(GAME_SOUND.Enemy[41].skill2)
	end
end

function Enemy41:doSomething()
	if self.offEquipment == true then
	else
		local ani = display.getAnimationCache(self.localData.actWhistle)
		self.enemyPic:stopAllActions()
		self.enemyPic:playAnimationOnce(ani, false, function()
			self.enemyPic:setSpriteFrame(display.newSpriteFrame(self.localData.pic))
			self:speedUp()
			self.moveAct = display.getAnimationCache(self.localData.actMove)
			self.enemyPic:playAnimationForever(self.moveAct)
		end)
		--音效
		SoundManager.playSound(GAME_SOUND.Enemy[41].skill1)
	end
end

function Enemy41:takeOffEquipment()
	self.offEquipment = true
	self.enemyPic:stopAllActions()
	self.moveAct = display.getAnimationCache(self.localData.actMove2)
	self.enemyPic:playAnimationForever(self.moveAct)
	if self.localData.attackAct2 ~= nil then
		self.attackAct = display.getAnimationCache(self.localData.attackAct2)
	end
end

return Enemy41