--
-- Author: KK
-- Date: 2014-08-01 10:02:58
--
--黄瓜怪

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy44 = class("Enemy44", Enemy)

function Enemy44:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy44.super.ctor(self, params)
    self.fillFloatWays = {}
    self.filled = false
end

function Enemy44:fillPit()
	local tilePt = MapInfo:getTilePositionInCCP(cc.p(self:getPosition()))
	local floatWay = MapInfo:checkFloatWay(tilePt)
	if floatWay ~= nil and floatWay.fill then
		return
	end
	self:dropPit()
end

--掉坑里，它要填坑
function Enemy44:dropPit()
	self.filled = true
	--黄瓜怪计数，判断一波小怪是否走完时用到。
	g_playScene.E44num = g_playScene.E44num + 1
	self.needUpdate = false
	--self:setRotation(90)

	local tilePt = MapInfo:getTilePositionInCCP(cc.p(self:getPosition()))
	self.enemyPic:stopAllActions()
	self.hpBar:setVisible(false)
	self.buffers.skill = true
	local px,py = self.enemyPic:getPosition()
	self.enemyPic:setSpriteFrame(display.newSpriteFrame("E44_magic_1.png"))
	self.enemyPic:setPosition(px,py-15)
	self.enemyPic:playAnimationOnce(self.magicAct, false, function()
		--self.enemyPic:setSpriteFrame(display.newSpriteFrame("E44_magic_12.png"))
		self:setLocalZOrder(BaseZOrder.enemy-1)

		local x,y = self:getPosition()
		local px,py = self.enemyPic:getPosition()

		local orient = MapInfo.ways[self.wayIdx].wayOrient[self.wayPoint]
		if orient == "right" then
			self:setPosition(cc.p(x+35,y))
			--self.enemyPic:setAnchorPoint(cc.p(0.9,0.1))
			self.enemyPic:setPosition(cc.p(px-35,py))
		else
			self:setPosition(cc.p(x-35,y))
			--self.enemyPic:setAnchorPoint(cc.p(0.1,0.1))
			self.enemyPic:setPosition(cc.p(px+35,py))
		end

		self.enemySize = cc.size(120, 50)
		self.footHigh = 5
		if g_fightLayer.selectedEnemy == self then
			g_fightLayer:setSelectDot(self, cc.p(0,self.enemySize.height))
		end
		self.hpBar:setPosition(cc.p(0,self.enemySize.height))

		MapInfo:fillFloatWay(self, tilePt, orient)
	end)

end

--死时要更新浮冰状态
function Enemy44:die(towerIdx)
	--黄瓜怪计数，填坑的才计数。判断一波小怪是否走完时用到。
	if self.filled then
		g_playScene.E44num = g_playScene.E44num - 1
	end
	for i = 1, #self.fillFloatWays do
		self.fillFloatWays[i].fill = false
		self.fillFloatWays[i].fillEnemy = nil
		if not self.fillFloatWays[i].sprite:isVisible() then
			self:pullEnemies(self.fillFloatWays[i].tilePt)
		end
	end
	Enemy44.super.die(self, towerIdx)
end

--被打掉后把身上的怪拉下水。
function Enemy44:pullEnemies(tilePt)
	for i = 1, #g_fightLayer.enemies do
		local en = g_fightLayer.enemies[i]
		local tp = MapInfo:getTilePositionInCCP(cc.p(en:getPosition()))
		if tp.x == tilePt.x and tp.y == tilePt.y then
			en:runAction(transition.sequence({
				cc.JumpBy:create(0.5, cc.p(0,0), MapInfo.tileSize, 1),
				cc.CallFunc:create(function()
					en:die()
				end)
			}))
		end
	end
end

return Enemy44