--
-- Author: KK
-- Date: 2014-08-12 09:51:04
--
--竹笋怪

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy45 = class("Enemy45", Enemy)

function Enemy45:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy45.super.ctor(self, params)
    self.E45 = true --用于判断竹笋怪类型。
    self:setPosition(params.pos)
    self.wayPoint = MapInfo:getWayPointByPos(params.wayIdx, params.pos)
    self:getMoveDist()
    self.needUpdate = false
    self.hasChanged = false
    self.growTime = params.growTime or 20 --定时长出
    self.enemyPic:stopAllActions()
	local actUnder = display.getAnimationCache(self.localData.actUnder)
	self.canHit = false
	local frames = display.newFrames("E45_underGrow_%d.png", 1, 4)
    local animation = display.newAnimation(frames, 0.1)
	self.enemyPic:playAnimationOnce(animation, false, function()
		self.canHit = true
		self.enemyPic:playAnimationForever(actUnder)
	end)
end

function Enemy45:init()
	--[[local px,py = self:getPosition()
	local pic = display.newSprite("#"..self.localData.actPic,px,py)
	g_fightLayer:addChild(pic, 200)
	local actChange = display.getAnimationCache(self.localData.actChange)
	pic:playAnimationOnce(actChange, true, function()
		self:setVisible(true)
	end)]]
end

--竹笋怪定时长出
function Enemy45:updateForSpecial(dt)
	if self.hasChanged then return end
	self.growTime = self.growTime - dt
	if self.growTime < 0 then
		self:changeEnemy()
		self:removeMapInfoE45()
	end
end

--血少于1/3时长出来。
function Enemy45:updateHp(hpAdd, towerIdx, isHero)
	if hpAdd ~= nil then
		self.hp = self.hp + hpAdd
	end
	self.hpBar:updateHp(self.hp)
	if self.hp<=0 then
		self:removeMapInfoE45()
		self:playAnimationAfterDead()
		g_playScene:changeMoney(self.earn)
		g_fightLayer:moneyShow(self.earn, cc.p(self:getPosition()))
		self:die(towerIdx, isHero)
	elseif self.hp<self.hpMax/3*2 and not self.hasChanged then
		self:changeEnemy()
		self:removeMapInfoE45()
	else
		--self:hurt()
	end
end

--变身
function Enemy45:changeEnemy()
	self.enemyPic:stopAllActions()
	self.hasChanged = true
	self.enemyPic:setSpriteFrame(display.newSpriteFrame("E45_grow_1.png"))
	--选中点和血条位置变化
	self.enemySize = cc.size(100,120)
	self.anchorPt = cc.p(0.6, self.footHigh/self.enemySize.height)
	self:setFlip(self.enemyPic:isFlippedX())
	if g_fightLayer.selectedEnemy == self then
		g_fightLayer:setSelectDot(self, cc.p(0,self.enemySize.height))
	end
	self.hpBar:setPosition(cc.p(0,self.enemySize.height))

	--print("changeEnemy")
	local px,py = self:getPosition()
	local actGrow = display.getAnimationCache(self.localData.actGrow)
	self.enemyPic:playAnimationOnce(actGrow, false, function()
		self.enemyPic:playAnimationForever(self.moveAct)
		self.needUpdate = true
	end)
	--音效
	SoundManager.playSound(GAME_SOUND.Enemy[45].skill1)
end

function Enemy45:removeMapInfoE45()
	for i = 1, #MapInfo.E45 do
		if MapInfo.E45[i].enemy == self then
			--要能重建e45。
			MapInfo.E45[i].created = false
			MapInfo.E45[i].enemy = nil
			--table.remove(MapInfo.E45, i)
			break
		end
	end
end

return Enemy45