--
-- Author: KK
-- Date: 2014-08-21 10:22:19
--
--水萝卜

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy48 = class("Enemy48", Enemy)

function Enemy48:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy48.super.ctor(self, params)
    self.underWater = true
end

--上岸
function Enemy48:offWater()
	self.moveAct = display.getAnimationCache(self.localData.actMove2)
	self.enemyPic:playAnimationForever(self.moveAct)
	self.needUpdate = true
end

--水萝卜不走浮冰路不会掉坑。重写这个方法来判断上岸。
function Enemy48:gofloatWay(dt)
	--在水下时检查有没有上岸
	if not self.underWater then return end
	local tilePt = MapInfo:getTilePositionInCCP(cc.p(self:getPosition()))
	local typeName = MapInfo.tileType[MapInfo:getTileIdx(tilePt)].name 
	if MapInfo:checkTileRoadValid(tilePt) then
		self.underWater = nil
		self.needUpdate = false
		self.enemyPic:stopAllActions()
		local ani = display.getAnimationCache(self.localData.actOffWater)
		self.enemyPic:playAnimationOnce(ani, false, function()
			self:offWater()
		end)
	end
end

function Enemy48:takeOffEquipment()
	--被8号吸尘兔杀死
	self:die(8)
end

return Enemy48