--
-- Author: KK
-- Date: 2014-12-22 16:49:09
--
--幽灵怪

local MapInfo = import("..views.MapInfo")
local Enemy = import(".Enemy")

local Enemy50 = class("Enemy50", Enemy)

function Enemy50:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy50.super.ctor(self, params)
    self.firstHurt = false
    self.hideTime = 5
end

function Enemy50:inVisible()
	self.enemyPic:setOpacity(128)
    self.canHit = false
end

function Enemy50:updateForSpecial(dt)
    if self.canHit then return end
    self.hideTime = self.hideTime - dt
    if self.hideTime < 0 then
        self.hideTime = 5
        self.enemyPic:setOpacity(255)
        self.canHit = true
    end
end

function Enemy50:updateHp(hpAdd, towerIdx, isHero)
    if not self.firstHurt then
        self.firstHurt = true
        self:inVisible()
        if g_fightLayer.selectedEnemy == self then
            g_fightLayer.selectedEnemy = nil 
            g_fightLayer.selectDot:setVisible(false)
        end
        if self.buffers.hero ~= nil then
            self.buffers.hero:lostEnemy()
            self:unlockByHero()
        end
    end
    Enemy50.super.updateHp(self, hpAdd, towerIdx, isHero)
end

return Enemy50