--
-- Author: KK
-- Date: 2014-07-22 10:40:30
--
--吸血鬼怪

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy61 = class("Enemy61", Enemy)

function Enemy61:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy61.super.ctor(self, params)
    self.isHurtState = false
end

function Enemy61:coop()
	local forts = g_fightLayer:getFortsAroundPos(cc.p(self:getPosition()), self.rangeSq)
	local randomForts = kkFunc.getRandomFromTable(forts, 3)

	for i = 1, #randomForts do
		randomForts[i]:addFortBuffer({
			bufferType = FortBuffer.BUFFER_COOP,
		})
	end
	--音效
	if #randomForts > 0 then
		SoundManager.playSound(GAME_SOUND.Enemy[61].skill1)
	end
end

function Enemy61:doSomething()
	self.enemyPic:stopAllActions()
	self.buffers.skill = true
	self.enemyPic:playAnimationOnce(self.magicAct, false, function()
		self.enemyPic:setSpriteFrame(display.newSpriteFrame(self.pic))
		self:coop()
		self.buffers.skill = false
		self.enemyPic:playAnimationForever(self.moveAct)
	end)
end

--[[
--不要残血状态了
function Enemy61:updateHp(hpAdd, towerIdx)
	if not self.isHurtState and self.hp < self.hpMax*1/2 then
		self.isHurtState = true
		self.moveAct = display.getAnimationCache(self.localData.actMove2)
		self.magicAct = display.getAnimationCache(self.localData.magicAct2)
    	self.pic = self.localData.pic2
		if not self.buffers.skill then
			self.enemyPic:stopAllActions()
			self.enemyPic:playAnimationForever(self.moveAct)
		end
	end
	Enemy61.super.updateHp(self, hpAdd, towerIdx)
end
--]]


return Enemy61