--
-- Author: KK
-- Date: 2014-07-30 10:07:51
--
--雪人怪

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy62 = class("Enemy62", Enemy)

function Enemy62:ctor(params)
	Enemy62.super.ctor(self, params)
    self.isHurtState = false
end

function Enemy62:doSomething()
	self.enemyPic:stopAllActions()
	self.buffers.skill = true
	self.enemyPic:playAnimationOnce(self.magicAct, false, function()
		--self.enemyPic:setSpriteFrame(display.newSpriteFrame(self.localData.pic))
		self.buffers.skill = false
		self.enemyPic:playAnimationForever(self.moveAct)
	end)
	self:performWithDelay(function() 
		self:throwSnowBall()
	end, 1)
end

function Enemy62:throwSnowBall()
	local forts = g_fightLayer:getFortsAroundPos(cc.p(self:getPosition()), self.rangeSq)
	local randomForts = kkFunc.getRandomFromTable(forts, 4)

	local x,y = self:getPosition()
	for i = 1, #randomForts do
		local bullet = Bullets[162].new({
				idx = 162,
				fortPos = cc.p(x, y+100),
				fortTarget = randomForts[i],
				level = 1,
				fromEnemy = self.idx
			})
		g_fightLayer:addBullet(bullet)
	end
	--音效
	SoundManager.playSound(GAME_SOUND.Enemy[62].skill1)
end

--[[
--不要残血状态了
function Enemy62:updateHp(hpAdd, towerIdx)
	if not self.isHurtState and self.hp < self.hpMax*1/2 then
		self.isHurtState = true
		self.moveAct = display.getAnimationCache(self.localData.actMove2)
		self.magicAct = display.getAnimationCache(self.localData.magicAct2)
    	self.pic = self.localData.pic2
		if not self.buffers.skill then
			self.enemyPic:stopAllActions()
			self.enemyPic:playAnimationForever(self.moveAct)
		end
	end
	Enemy62.super.updateHp(self, hpAdd, towerIdx)
end
--]]

return Enemy62