--
-- Author: KK
-- Date: 2014-06-09 10:09:36
--
--法老怪

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Enemy = import(".Enemy")

local Enemy63 = class("Enemy63", Enemy)

function Enemy63:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy63.super.ctor(self, params)

    self.lockedForts = {}
	self.isHurtState = false
end

function Enemy63:wrap()
	local forts = g_fightLayer:getFortsAroundPos(cc.p(self:getPosition()), self.rangeSq)
	local randomForts = kkFunc.getRandomFromTable(forts, 3)

	for i = 1, #randomForts do
		randomForts[i]:addFortBuffer({
			bufferType = FortBuffer.BUFFER_WRAP,
		})
	end
	--音效
	SoundManager.playSound(GAME_SOUND.Enemy[63].skill1)
end

function Enemy63:doSomething()
	self.enemyPic:stopAllActions()
	self.buffers.skill = true
	self.enemyPic:playAnimationOnce(self.magicAct, false, function()
		self.enemyPic:setSpriteFrame(display.newSpriteFrame(self.pic))
		self.buffers.skill = false
		self.enemyPic:playAnimationForever(self.moveAct)
	end)
	self:performWithDelay(function() 
		self:wrap()
	end, 1)
end

--[[
--不要残血状态了
function Enemy63:updateHp(hpAdd, towerIdx)
	if not self.isHurtState and self.hp < self.hpMax*1/2 then
		self.isHurtState = true
		self.moveAct = display.getAnimationCache(self.localData.actMove2)
		self.magicAct = display.getAnimationCache(self.localData.magicAct2)
    	self.pic = self.localData.pic2
		if not self.buffers.skill then
			self.enemyPic:stopAllActions()
			self.enemyPic:playAnimationForever(self.moveAct)
		end
	end
	Enemy63.super.updateHp(self, hpAdd, towerIdx)
end
--]]

return Enemy63