--
-- Author: KK
-- Date: 2014-09-04 10:19:33
--
--波塞冬

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")
local Forts = import("..obj.Forts")
local Enemy = import(".Enemy")

local Enemy64 = class("Enemy64", Enemy)

function Enemy64:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Enemy64.super.ctor(self, params)
	self.isHurtState = false
end

function Enemy64:swirl()
	--[[self.rangeSq = math.pow(MapInfo.tileSize*5,2)
	local forts = g_fightLayer:getFortsAroundPos(cc.p(self:getPosition()), self.rangeSq)
	local waterForts = {}
	for i = 1, #forts do
		if forts[i].data.onWater or forts[i].data.onWaterWay then
			waterForts[#waterForts+1] = forts[i]
		end
	end
	local randomForts = kkFunc.getRandomFromTable(waterForts, 3)

	for i = 1, #randomForts do
		randomForts[i]:addFortBuffer({
			bufferType = FortBuffer.BUFFER_SWIRL,
		})
	end]]
	self.randomForts = {}
	self.rangeSq = math.pow(MapInfo.tileSize*3,2)
	local forts = g_fightLayer:getFortsAroundPos(cc.p(self:getPosition()), self.rangeSq)
	self.randomForts = kkFunc.getRandomFromTable(forts, 3)
	self.randomFortsNature = {}
	self.randomFortsNatureTowerIdx = {}
	self.randomFortsNatureTowerLevel = {}
	self.randomFortsNatureTilePt = {}
	for i = 1, #self.randomForts do
		self.randomForts[i]:addFortBuffer({
			bufferType = FortBuffer.BUFFER_SWIRL,
		})	
		self.randomFortsNatureTowerIdx[i] = self.randomForts[i].idx
		self.randomFortsNatureTowerLevel[i] = self.randomForts[i].level	
		self.randomFortsNatureTilePt[i] = self.randomForts[i].tilePt
	end
	--移到FighterLayer处理原因：怪物死亡技能中断，炮塔无法出现。
	g_fightLayer:skillE64(cc.p(self:getPosition()),self.randomForts,self.randomFortsNatureTowerIdx,self.randomFortsNatureTowerLevel,self.randomFortsNatureTilePt)
	--[[self:performWithDelay(function()
		--随机出几个建造塔的位置坐标
		self:randomTowerTitlePt()
		--在随机出的地方造塔
		for i = 1, #self.randomForts do
			self:createNewTower(i)
		end
	end, 2.9)]]
end

--[[function Enemy64:randomTowerTitlePt()
	self.randomTitlePt = {}
	for x=0,12 do
		for y=0,6 do
			local fort = g_playScene:getTileFort(cc.p(x,y))
			if fort == nil and g_playScene:checkTileNormalCreateTower(cc.p(x,y)) and MapInfo:checkTileBlank(cc.p(x,y)) then
            	self.randomTitlePt[#self.randomTitlePt+1] = cc.p(x,y)
	            if #self.randomTitlePt == #self.randomForts then
            		return  
            	end      
            end		
		end
	end

	if #self.randomTitlePt < #self.randomForts then
		local num = #self.randomForts - #self.randomTitlePt
		for i=1, num do
			self.randomTitlePt[#self.randomTitlePt+1] = self.randomFortsNatureTilePt[num-i+1]
		end
	end
end
function Enemy64:createNewTower(TOWERIDX)
	if g_playScene.towerCreateLayer.blank:isVisible() then
		g_playScene.towerCreateLayer.blank:setVisible(false)
		g_playScene.towerCreateLayer.showLayer:setVisible(false)
	end
	local sprite = display.newSprite("#swrilWater1.png")
	local pt = MapInfo:getCenterOfTile(self.randomTitlePt[TOWERIDX])
	sprite:setPosition(pt.x,pt.y+15)
	g_fightLayer:addChild(sprite,BaseZOrder.fort+1)
	local frames = display.newFrames("swrilWater%d.png", 1, 6)
	local animation = display.newAnimation(frames, 0.1)
	g_playScene:createFort(self.randomFortsNatureTowerIdx[TOWERIDX], self.randomTitlePt[TOWERIDX], self.randomFortsNatureTowerLevel[TOWERIDX], true)
	sprite:playAnimationOnce(animation, true, function()		
		--更新塔的可升级状态
	    for i = 1, #g_playScene.fightLayer.forts do
	        g_playScene.fightLayer.forts[i]:updateForChangeMoney(g_playScene.money)
	    end
	end)
end]]

function Enemy64:doSomething()
	self.enemyPic:stopAllActions()
	self.buffers.skill = true
	self.enemyPic:playAnimationOnce(self.magicAct, false, function()
		self.enemyPic:setSpriteFrame(display.newSpriteFrame(self.pic))
		self.buffers.skill = false
		self.enemyPic:playAnimationForever(self.moveAct)
	end)
	self:performWithDelay(function() 
		self:swirl()
	end, 1)
end

--[[
--不要残血状态了
function Enemy64:updateHp(hpAdd, towerIdx)
	if not self.isHurtState and self.hp < self.hpMax*1/2 then
		self.isHurtState = true
		self.moveAct = display.getAnimationCache(self.localData.actMove2)
		self.magicAct = display.getAnimationCache(self.localData.magicAct2)
    	self.pic = self.localData.pic2
		if not self.buffers.skill then
			self.enemyPic:stopAllActions()
			self.enemyPic:playAnimationForever(self.moveAct)
		end
	end
	Enemy64.super.updateHp(self, hpAdd, towerIdx)
end
--]]

return Enemy64