--
-- Author: Hao
-- Date: 2015-04-01
--

local FireFly = class("FireFly", function(params)
    return display.newSprite("pic/firefly.png")
end)

function FireFly:ctor(params)
	--移动范围
	self.range={}
	-- self.range.left = idsplay.left
	-- self.range.right = display.right
	-- self.range.bottom = display.bottom
	-- self.range.top = display.top/5.0*2.0
	self.range.left = params.range.left
	self.range.right = params.range.right
	self.range.bottom = params.range.bottom
	self.range.top = params.range.top
	--移动速度
	self.SpeedMax = 5
	self.SpeedMin = 1
	self.SpeedFactor = 10--将速度变为浮点数，使移动时具有更多方向
	--单次移动时间
	self.TimeMax = 200
	self.TimeMin = 50
	--移动初始化
	self:MoveInit()
end

function FireFly:update()
	self:setPositionX(self:getPositionX()+self.speedX)
	self:setPositionY(self:getPositionY()+self.speedY)
	self.MoveDuration = self.MoveDuration-1
	if self:IsOutOfRange() then
		self:MoveAwayFromEdge()
	elseif self.MoveDuration <0 then
		self:MoveInit()
	end
end

function FireFly:MoveInit()
	self.MoveDuration = math.random(self.TimeMin,self.TimeMax)
	repeat
		self.speedX = math.random(-self.SpeedMax,self.SpeedMax)/self.SpeedFactor
		self.speedY = math.random(-self.SpeedMax,self.SpeedMax)/self.SpeedFactor
	until (math.abs(self.speedX)>self.SpeedMin/self.SpeedFactor) or (math.abs(self.speedY)>self.SpeedMin/self.SpeedFactor)
end

function FireFly:IsOutOfRange()
	local IsOut = false
	if self:getPositionX()<self.range.left or self:getPositionX()>self.range.right then
		IsOut = true
	end
	if self:getPositionY()<self.range.bottom or self:getPositionY()>self.range.top then
		IsOut = true
	end
	return IsOut
end

function FireFly:MoveAwayFromEdge()
	if self:getPositionX()<self.range.left then
		self.speedX = math.random(1,self.SpeedMax)/self.SpeedFactor
	elseif self:getPositionX()>self.range.right then
		self.speedX = math.random(-self.SpeedMax,-1)/self.SpeedFactor
	else
		self.speedX = math.random(-self.SpeedMax,self.SpeedMax)/self.SpeedFactor
	end
	if self:getPositionY()<self.range.bottom then
		self.speedY = math.random(1,self.SpeedMax)/self.SpeedFactor
	elseif self:getPositionY()>self.range.top then
		self.speedY = math.random(-self.SpeedMax,-1)/self.SpeedFactor
	else
		self.speedY = math.random(-self.SpeedMax,self.SpeedMax)/self.SpeedFactor
	end
	self.MoveDuration = math.random(self.TimeMin,self.TimeMax)
end

return FireFly