--
-- Author: KK
-- Date: 2014-07-11 10:22:44
--
--弹弓兔


local MapInfo = import("..views.MapInfo")

local Bullets = import(".Bullets")
local Fort = import(".Fort")

local Fort07 = class("Fort07", Fort)

function Fort07:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Fort07.super.ctor(self, params)
end

function Fort07:createAngerBullet()
	if self.cityTarget == nil and self.target == nil and self.thingTarget == nil then 
		self.isShooting = false
		return 
	end

	--夹角20度。
	local num = self.data.level.anger.number
	local delta = 60
	local angle = -(num-1)/2*delta
	for i = 1, num do
		--最普通的直线碰撞弹
		local bullet = Bullets[self.bulletIdx].new({
				idx = self.bulletIdx,
				--fortPos = cc.p(px,py),
				fortPos = cc.p(self:getPosition()),
				target = self.target,
				thingTarget = self.thingTarget,
				cityTarget = self.cityTarget,
				level = 4,
				range = self.range,
				angle = angle,
			});
		g_fightLayer:addBullet(bullet)
		angle = angle + delta
	end
	self.isShooting = false
end

function Fort07:createBullet()
	--音效
	SoundManager.playSound(GAME_SOUND.Tower[7].attack1)
	
	if self.cityTarget == nil and self.target == nil and self.thingTarget == nil then 
		self.isShooting = false
		return 
	end

	--夹角20度。
	local num = 3 --self.data.level[self.level].number --1、2、3级全是三发子弹
	local delta = 30
	local angle = -(num-1)/2*delta
	local px,py = self:getPosition()
	--[[
	local dest
	local z
	if self.target ~= nil then		
		local targetPos = self.target:getPositionCenter()
		dest = cc.p(targetPos.x - px,
				 	targetPos.y - py)
		z = math.sqrt(dest.x*dest.x +dest.y*dest.y) 
	elseif self.thingTarget ~= nil then
		local thingPos = MapInfo:getCenterOfThing(self.thingTarget)
		dest = cc.p(thingPos.x - px,
				 	thingPos.y - py)
		z = math.sqrt(dest.x*dest.x +dest.y*dest.y)
	end
	local px = px - dest.x*5/z
	local py = py - dest.y*5/z 
	--]]
	if self.cityTarget ~= nil then
		self.target = nil
	end
	for i = 1, num do
		--最普通的直线碰撞弹
		local bullet = Bullets[self.bulletIdx].new({
			idx = self.bulletIdx,
			fortPos = cc.p(px,py),
			target = self.target,
			thingTarget = self.thingTarget,
			cityTarget = self.cityTarget,
			level = self.level,
			range = self.range,
			angle = angle,
		})
		g_fightLayer:addBullet(bullet)
		angle = angle + delta
	end
	self.isShooting = false
end


return Fort07