--
-- Author: KK
-- Date: 2014-04-11 10:39:27
--
--雷电塔。之前脸谱兔不用了。

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Fort = import(".Fort")

local Fort11 = class("Fort11", Fort)

local BullePointHeight = {
	[1] = 44,
	[2] = 45,
	[3] = 52,
}
function Fort11:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    self.bullets = {}
    self.attackThing = nil
    Fort11.super.ctor(self, params)
    self:setNodeEventEnabled(true)

	--[[
    local x,y = self:getPosition()
    self.bp = display.newSprite("#T11_bp_1.png",x,y-30+BullePointHeight[self.level])
    g_fightLayer:addChild(self.bp,BaseZOrder.bullet+1)
	local bpAni = display.getAnimationCache("T11_BP")
	self.bp:playAnimationForever(bpAni)
    self.bp:setVisible(false)

    self.bulletPoint = display.newSprite("#T11_bulletPoint.png",40,BullePointHeight[self.level])
    self:addChild(self.bulletPoint)
    self.bulletPoint:runAction(cc.RepeatForever:create(transition.sequence({
		cc.ScaleTo:create(0.5,1),
		cc.ScaleTo:create(0.5,0.8),
	})))
    self.bulletPoint:setVisible(false)
    --]]
end

function Fort11:getLevelInfo()
    Fort11.super.getLevelInfo(self)
    self:stopAllActions()
	self:playAnimationForever(self.animation)
	self.attackThing = nil
	self:stopAttack()
end

function Fort11:updateInterval()
	self:getTargetThing()
	if self.thingTarget ~= nil and self.attackThing ~= self.thingTarget then
		self.attackThing = self.thingTarget
		self:stopAttack()
		self:createBullet()
		return
	elseif self.thingTarget == nil and self.attackThing ~= nil then
		self:stopAttack()
		self.attackThing = nil
	end

	--优先打选中怪
	if g_fightLayer.selectedEnemy ~= nil then
		local hasSelectedEnemy = false
		for i = 1, #self.bullets do
			if self.bullets[i].target == g_fightLayer.selectedEnemy then
				hasSelectedEnemy = true
				break
			end
		end
		if not hasSelectedEnemy
				and Fort11.super.checkTargetEnemy(self, g_fightLayer.selectedEnemy)
				and self:isEnemyInRange(g_fightLayer.selectedEnemy) then
			--如果打满了取消最后一个攻击目标，改打选中怪
			if #self.bullets == self.level then
				self:removeBullet(self.bullets[#self.bullets])
			end
			self.target = g_fightLayer.selectedEnemy
			self:createBullet()
			self.bullets[#self.bullets].target = g_fightLayer.selectedEnemy
		end
	end
	if self.thingTarget == nil then
		local findEnemyNum = self.level - #self.bullets
		for i = 1, findEnemyNum do
			local en = self:getTargetEnemy()
			if en ~= nil then
				self.target = en
				self:createBullet()
				self.bullets[#self.bullets].target = en
			end
		end
	end
end

function Fort11:updateSelf(dt)
	self.interval = self.interval + dt
	if self.interval > 0.1 then
		self:updateInterval()
		self.interval = 0
	end
end

function Fort11:stopAttack()
	for i = 1, #self.bullets do
		g_fightLayer:removeBullet(self.bullets[i])
	end
	self.bullets = {}
	--self:stopAllActions()
	--self:setSpriteFrame(display.newSpriteFrame(self.localLevelData.animationAttack.frame))

	--[[
	if self.bp ~= nil then
		self.bp:setVisible(false)
	end

	if self.bulletPoint ~= nil then
		self.bulletPoint:setVisible(false)
	end
	--]]
	--音效
	if self.soundEffect then
		SoundManager.stopSound(self.soundEffect)
		self.soundEffect = nil
	end
end

function Fort11:angerStart()
	self:createAngerBullet()
	self:angerEnd()
end

function Fort11:createAngerBullet()
	g_fightLayer:createFireball()
end

function Fort11:createBullet()
	if #self.bullets == 0 then
		--self:playAnimationForever(self.animation)
		--self.bp:setVisible(true)
		--self.bulletPoint:setVisible(true)
	end
	local x,y = self:getPosition()
	self.bullets[#self.bullets+1] = Bullets[self.bulletIdx].new({
		idx = self.bulletIdx,
		fortPos = cc.p(x,y+BullePointHeight[self.level]-32),
		target = self.target,
		thingTarget = self.thingTarget,
		cityTarget = self.cityTarget,
		level = self.level,
		fort = self,
	})
	g_fightLayer:addBullet(self.bullets[#self.bullets])
	--音效
	if not self.soundEffect then
		self.soundEffect = SoundManager.playSound(GAME_SOUND.Tower[11].attack1,true)
	end
end

function Fort11:callBeforRemove()
	Fort11.super.callBeforRemove(self)
	for i = 1, #self.bullets do
		g_fightLayer:removeBullet(self.bullets[i])
	end
	if self.bp ~= nil then
		self.bp:removeFromParent()
	end
end

function Fort11:checkTargetEnemy(en)
	--水萝卜不能打
	if en.underWater then return false end
	--正在打的怪不能打

	for i = 1, #self.bullets do
		if en == self.bullets[i].target then
			return false
		end
	end
	return true
end

function Fort11:removeBullet(bullet)
	for i = 1, #self.bullets do
		if self.bullets[i] == bullet then
			table.remove(self.bullets,i)
			g_fightLayer:removeBullet(bullet)
			break
		end
	end
	if #self.bullets == 0 then
		self:stopAttack()
	end
end

function Fort11:onExit()
	--音效
	if self.soundEffect then
		SoundManager.stopSound(self.soundEffect)
		self.soundEffect = nil
	end
end

return Fort11