--
-- Author: KK
-- Date: 2014-11-28 18:06:45
--
--冰霜塔

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Fort = import(".Fort")

local Fort18 = class("Fort18", Fort)

local ELLIPSE_TIME = 3
function Fort18:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Fort18.super.ctor(self, params)

	self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt) self:onEnterFrame(dt) end)
	self:scheduleUpdate()
end

function Fort18:getLevelInfo()
    Fort18.super.getLevelInfo(self)

    self.ELLIPSE_A = self.localLevelData.a
    self.ELLIPSE_B = self.localLevelData.b
    self.H = self.localLevelData.h
    if self.sprite ~= nil then
    	--底座
		self:setSpriteFrame(display.newSpriteFrame(self.localLevelData.pic))
		--浮动大球
		self.sprite:setSpriteFrame(display.newSpriteFrame(self.localLevelData.sprite))
		self.sprite:setPosition(self:getContentSize().width*0.5, self.H)
	else
    	--底座
		self:setSpriteFrame(display.newSpriteFrame(self.localLevelData.pic))
		--浮动大球
    	self.sprite = display.newSprite("#"..self.localLevelData.sprite)
    	self.sprite:setPosition(self:getContentSize().width*0.5, self.H)
	    self:addChild(self.sprite,1)
	    self.sprite:runAction(cc.RepeatForever:create(
	    	transition.sequence({
	    	cc.MoveBy:create(1,cc.p(0,3)),
	    	cc.MoveBy:create(1,cc.p(0,-3)),
	    })))
	end
    self.size = self:getContentSize()

    --旋转小球
    if self.ball ~= nil then
	    for i = 1, #self.ball do
	    	self.ball[i]:removeFromParent()
	    end
	end
    self.ball = {}
    local time = 0
    local ballNum = self.level
    for i = 1, ballNum do
		self.ball[i] = display.newSprite("#"..self.localLevelData.ball)
		time = (i-1) * (ELLIPSE_TIME/ballNum)
	    self.ball[i].ballTime = time 
		local x, y = self:getEllipseXandY(self.ball[i].ballTime)
		self.ball[i]:setPosition(self.size.width*0.5+x, self.H+y)
	    self:addChild(self.ball[i], 0)
		if self.ball[i].ballTime > ELLIPSE_TIME/2 then
			self.ball[i]:setLocalZOrder(2)
		end
	end
end

function Fort18:getEllipseXandY(t)
	local x = -self.ELLIPSE_A * math.cos(2*3.1415926*t/ELLIPSE_TIME)
	local y = self.ELLIPSE_B * math.sin(2*3.1415926*t/ELLIPSE_TIME)
    return x,y
end

function Fort18:onEnterFrame(dt)
	for i = 1, #self.ball do
		self.ball[i].ballTime = self.ball[i].ballTime + dt
		local x, y = self:getEllipseXandY(self.ball[i].ballTime)
		self.ball[i]:setPosition(self.size.width*0.5+x, self.H+y)
		if self.ball[i].ballTime > ELLIPSE_TIME then
			self.ball[i].ballTime = self.ball[i].ballTime - ELLIPSE_TIME
			self.ball[i]:setLocalZOrder(0)
		elseif self.ball[i].ballTime > ELLIPSE_TIME/2 then
			self.ball[i]:setLocalZOrder(2)
		end
	end
end

function Fort18:callBeforRemove()
	Fort18.super.callBeforRemove(self)
	self:unscheduleUpdate()
end

return Fort18