--
-- Author: KK
-- Date: 2014-05-14 12:05:24
--
--机器兔，自爆的塔

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")

local Fort = import(".Fort")

local Fort23 = class("Fort23", Fort)

function Fort23:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Fort23.super.ctor(self, params)
    self.ready = false
end

function Fort23:getLevelInfo()
	Fort23.super.getLevelInfo(self)
	self.attack = self.data.level[self.level].attack
end

function Fort23:updateSelf(dt)
	if self.ready then return end
	local pos = cc.p(self:getPosition())
	for k,v in pairs(g_fightLayer.enemies) do
		local enPt = v:getPositionCenter()
		local dest = cc.pGetDistance(enPt, pos)
		if dest < 30 then
			self:playAnimationOnce(self.frontAttack, false,
					function()
						self:performWithDelay(function()
							self:bomb()
						end, 0.5)
					end)
			self.ready = true
			return
		end
	end
end

function Fort23:bomb()
	local pos = self:getPositionCenter()
	for k,v in pairs(g_fightLayer.enemies) do
		local enPt = v:getPositionCenter()
		local dest = cc.pGetDistance(enPt, pos)
		if dest < 100 then
			v.hp = v.hp - self.attack
			v:updateHp()
		end
	end
	g_fightLayer:removeFort(self)
end

return Fort23