--
-- Author: KK
-- Date: 2014-06-30 11:32:19
--
--拦路兔

local MapInfo = import("..views.MapInfo")
local Bullets = import(".Bullets")
local HpBar = import("..sprites.HpBar")

local Fort = import(".Fort")

local Fort3 = class("Fort3", Fort)

function Fort3:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Fort3.super.ctor(self, params)
    self.passTime = self.speed
    self.blockTime = self.data.blockTime
    self.isBlock = false
    self.leftRight = true
    if not params.leftRight then self.leftRight = false end
	if not self.leftRight then
		self:setSpriteFrame(display.newSpriteFrame(self.data.upDown.frame))
		self:setAnchorPoint(cc.p(0.5,0.3))
	else
		self:setAnchorPoint(cc.p(0.5,0.2))
	end

    self.pos = cc.p(self:getPosition())
    self.wayDist = MapInfo.tileType[MapInfo:getTileIdx(self.tilePt)].wayDist

    self.interval = 0
    --防止重复拦
    self.stopEnemies = {}
    --拦在几米之外，怪要排开
    self.stopDist = MapInfo.tileSize

    --两边都有血条
	self.hpBar:removeFromParent()
	self.hpBar1 = HpBar.new(HPBAR_TYPE_FORT, cc.size(MapInfo.tileSize,MapInfo.tileSize), self.hpMax)
	self.hpBar2 = HpBar.new(HPBAR_TYPE_FORT, cc.size(MapInfo.tileSize,MapInfo.tileSize), self.hpMax)
	if self.leftRight then
		self.hpBar1:setPosition(cc.p(0,0))
		self.hpBar2:setPosition(cc.p(MapInfo.tileSize*2,0))
	else
		self.hpBar1:setPosition(cc.p(0,0))
		self.hpBar2:setPosition(cc.p(0,MapInfo.tileSize*2))
	end
	self:addChild(self.hpBar1)
	self:addChild(self.hpBar2)
	self.hpBar1:setVisible(false)
	self.hpBar2:setVisible(false)
end

function Fort3:select(tilePt)
    g_fightLayer.selectedFort = self
	local pos
	if self.leftRight then
		if self.tilePt.x-1 == tilePt.x then
			pos = cc.p(MapInfo.tileSize*0.5,MapInfo.tileSize*0.5)
		elseif self.tilePt.x+1 == tilePt.x then
			pos = cc.p(MapInfo.tileSize*0.5,MapInfo.tileSize*0.5)
		end
	else
		if self.tilePt.y-1 == tilePt.y then
			pos = cc.p(MapInfo.tileSize*0.5,MapInfo.tileSize*2.5)
		elseif self.tilePt.y+1 == tilePt.y then
			pos = cc.p(MapInfo.tileSize*0.5,MapInfo.tileSize*2.5)
		end
	end

	self:showSelectNode()
	self.selectNode:setPosition(pos.x, pos.y)
end

function Fort3:updateHp(hpAdd)
	if hpAdd ~= nil then
		self.hp = self.hp + hpAdd
	end
	self.hpBar1:updateHp(self.hp)
	self.hpBar2:updateHp(self.hp)
	if self.hp<=0 then
		g_fightLayer:removeFort(self)
	else
		--self:hurt()
	end
end

function Fort3:lock()
	self:unBlock()
	self.isLocked = true
	self.needClick = 2
	self.jingu1 = display.newSprite("#jingu.png")
	self.jingu2 = display.newSprite("#jingu.png")
	if self.leftRight then
		self.jingu1:setPosition(cc.p(MapInfo.tileSize*0.5,MapInfo.tileSize*0.5))
		self.jingu2:setPosition(cc.p(MapInfo.tileSize*2.5,MapInfo.tileSize*0.5))
	else
		self.jingu1:setPosition(cc.p(MapInfo.tileSize*0.5,MapInfo.tileSize*0.5))
		self.jingu2:setPosition(cc.p(MapInfo.tileSize*0.5,MapInfo.tileSize*2.5))
	end
	self.jingu1:setOpacity(0)
	self.jingu2:setOpacity(0)
	self:addChild(self.jingu1)
	self:addChild(self.jingu2)
	self.jingu1:runAction(cc.FadeIn:create(1))
	self.jingu2:runAction(cc.FadeIn:create(1))
end

function Fort3:unlock()
	self.needClick = self.needClick - 1
	if self.needClick <= 0 then
		self.isLocked = false
		self.jingu1:removeFromParent()
		self.jingu2:removeFromParent()
		self.unlockTime = g_playScene.gamePassTime
	else
		if self.needClick == 2 then
			self.jingu1:setOpacity(165)
			self.jingu2:setOpacity(165)
		elseif self.needClick == 1 then 
			self.jingu1:setOpacity(80)
			self.jingu2:setOpacity(80)
		end
	end
end

function Fort3:updateInterval()
	if not self.isBlock then
		if self.passTime > self.speed then
			for k,v in pairs(g_fightLayer.enemies) do
				--拦路兔之前的怪
				if self.wayDist[v.wayIdx] ~= nil and
					self.wayDist[v.wayIdx]*MapInfo.tileSize > v.moveDist and
					self.wayDist[v.wayIdx]*MapInfo.tileSize - v.moveDist < self.stopDist then
					self:block()
					break
				end
			end
		end
	else
		for k,v in pairs(g_fightLayer.enemies) do
			--拦路兔之前的怪
			if self.wayDist[v.wayIdx] ~= nil and
				self.wayDist[v.wayIdx]*MapInfo.tileSize > v.moveDist and
				self.wayDist[v.wayIdx]*MapInfo.tileSize - v.moveDist < self.stopDist then
				local hasStoped = false
				for i = 1, #self.stopEnemies do
					if self.stopEnemies[i] == v then 
						hasStoped = true
						break
					end
				end
				if not hasStoped then
					v:addBuffer({
						bufferType = EnemyBuffer.BUFFER_STOP,
						time = self.blockTime-self.passTime,
					})
					self.stopDist = self.stopDist + 0.1*MapInfo.tileSize
					self.stopEnemies[#self.stopEnemies+1] = v
				end
			end
		end

		if self.passTime > self.blockTime then
			self:unBlock()
		end
	end
end

function Fort3:block()
	if self.leftRight then
		self:setSpriteFrame(display.newSpriteFrame(self.data.leftRight.block))
	else
		self:setSpriteFrame(display.newSpriteFrame(self.data.upDown.block))
	end
	self.isBlock = true
	self.stopEnemies = {}
	self.stopDist = MapInfo.tileSize
	self.passTime = 0
end

function Fort3:unBlock()
	if not self.isBlock then return end
	if self.leftRight then
		self:setSpriteFrame(display.newSpriteFrame(self.data.leftRight.frame))
	else
		self:setSpriteFrame(display.newSpriteFrame(self.data.upDown.frame))
	end			
	self.isBlock = false
	self.passTime = 0
end

function Fort3:updateSelf(dt)
	if self.isLocked then return end

	self.passTime = self.passTime + dt
	self.interval = self.interval + dt
	if self.interval > 0.1 then
		self:updateInterval()
		self.interval = self.interval - 0.1
	end
end

return Fort3