--
-- Author: KK
-- Date: 2014-12-16 09:58:49
--
--安妮

local Hero = import(".Hero")

local Hero2 = class("Hero2", Hero)

function Hero2:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Hero2.super.ctor(self, params)
	self.magicAni2 = display.getAnimationCache(self.data.actMagic2)

	self.attackAnchor = cc.p(0.5, 0.11)
	self.moveAnchor = cc.p(0.5, 0.11)
	self.waitAnchor = cc.p(0.5, 0.11)
end    

--放技能前摇
function Hero2:showBeforeSkill(skill)
	if skill.idx == 4 then
		g_playScene:changeSpeedNormal()
		g_playScene:suspend(true)
		g_playScene:setCanTouch(false)
		self:setLocalZOrder(BaseZOrder.bullet+2)
		local layer = cc.LayerColor:create(cc.c4b(0,0,0,200))
		g_fightLayer:addChild(layer, BaseZOrder.bullet+1)
		layer:setOpacity(0)
		layer:runAction(cc.FadeTo:create(0.2,200))
		self.heroPic:runAction(transition.sequence({
			cc.ScaleTo:create(0.2,1.2),
			cc.CallFunc:create(function()
				self:setAnchor(cc.p(0.5,0.15))
			end),
			cc.Animate:create(self.magicAni),
		}))
		--放在上面的动作里会被打断出Bug。单独拿出来做。
		self:performWithDelay(function()
			self.heroPic:setSpriteFrame(display.newSpriteFrame(self.data.pic))
			layer:removeFromParent()
			g_playScene:suspend(true)
			skill:execute()
		end, 1.9)
	elseif skill.idx == 5 then
		skill:execute()
		self.heroPic:playAnimationOnce(self.magicAni, false, function()
			self.heroPic:setSpriteFrame(display.newSpriteFrame(self.data.pic))
		end)	
	else
		self.heroPic:playAnimationOnce(self.magicAni, false, function()
			self.heroPic:setSpriteFrame(display.newSpriteFrame(self.data.pic))
			skill:execute()
		end)
	end
end

--安妮技能放完要加Buff
function Hero2:endSkill()
	Hero2.super.endSkill(self)
	--被动技能，不用。
	--self:speedUp()
end

--安妮被动技能
function Hero2:speedUp()
	if self.speedUpInfo ~= nil then return end
	local buffPic = display.newSprite("#h02_skillBuff_1.png",0,10)
	self:addChild(buffPic)
	local ani = display.getAnimationCache("h02_skillBuff")
	buffPic:playAnimationForever(ani)
	self.speedUpInfo = {
		buff = buffPic,
		time = 8,
	}
	self.speed = self.speed * 2
	self.attackSpeed = self.attackSpeed / 2
end

function Hero2:cancelSpeedUp()
	self.speed = self.speed / 2
	self.attackSpeed = self.attackSpeed * 2
	self.speedUpInfo.buff:removeFromParent()
	self.speedUpInfo = nil
end

function Hero2:updateSub(dt)
	if self.speedUpInfo ~= nil then
		self.speedUpInfo.time = self.speedUpInfo.time - dt
		if self.speedUpInfo.time <= 0 then
			self:cancelSpeedUp()
		end
	end
end

function Hero2:showLightEffect()
	local x,y = self:getPosition()
	local dx,rotation
	if self.heroPic:isFlippedX() then
		dx = 50
		rotation = -40
	else
		dx = -50
		rotation = 40
	end
	local effect = display.newSprite("#h02_attackLight.png",x,y+70):addTo(g_fightLayer,BaseZOrder.hero)
	effect:setAnchorPoint(0.5,0.7)
	effect:setRotation(rotation)
	effect:setVisible(false)
	effect:runAction(transition.sequence({
		cc.DelayTime:create(0.5),
		cc.CallFunc:create(function()
			effect:setVisible(true)
		end),
		cc.MoveBy:create(0.2, cc.p(dx,-40)),
		cc.CallFunc:create(function()
			effect:removeFromParent()
		end)
	}))
end

return Hero2