--
-- Author: Wangzhihao
-- Date: 2015-01-26 18:52:39
--
--Timo

local Hero = import(".Hero")

local Hero4 = class("Hero4", Hero)

function Hero4:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Hero4.super.ctor(self, params)
    
    self.attackAnchor = cc.p(0.38, 0.2)
	self.moveAnchor = cc.p(0.38, 0.2)
	self.waitAnchor = cc.p(0.38, 0.2)
	--self.deadAnchor = cc.p(0.23, 0.24)
	--self.hurtAnchor = cc.p(0.45, 0.1)
	
end

--放技能前摇
function Hero4:showBeforeSkill(skill)
	if skill.idx == 12 then
		g_playScene:changeSpeedNormal()
		g_playScene:suspend(true)
		g_playScene:setCanTouch(false)
		self:setLocalZOrder(BaseZOrder.bullet+2)
		local layer = cc.LayerColor:create(cc.c4b(0,0,0,200))
		g_fightLayer:addChild(layer, BaseZOrder.bullet+1)
		layer:setOpacity(0)
		layer:runAction(cc.FadeTo:create(0.2,200))
		self.heroPic:runAction(transition.sequence({
			cc.ScaleTo:create(0.2,1.2),
			cc.CallFunc:create(function()
				self:setAnchor(cc.p(0.67,0.15))
			end),
			cc.Animate:create(self.magicAni),
		}))
		--放在上面的动作里会被打断出Bug。单独拿出来做。
		self:performWithDelay(function()
			self.heroPic:setSpriteFrame(display.newSpriteFrame(self.data.pic))
			layer:removeFromParent()
			g_playScene:suspend(true)
			skill:execute()
		end, 1.8)
	elseif skill.idx == 13 then
		skill:execute()
	else
	    self.heroPic:setSpriteFrame(display.newSpriteFrame("h04_magic_1.png"))
		self:setAnchor(cc.p(0.67,0.15))
		local frames = display.newFrames("h04_magic_%d.png", 1, 10)
		local animation = display.newAnimation(frames, 0.1)
		self.heroPic:playAnimationOnce(animation, false, function()
			self.heroPic:setSpriteFrame(display.newSpriteFrame(self.data.pic))
			self:setAnchor(cc.p(0.38,0.2))
		end)
		self:performWithDelay(function()
			skill:execute()
		end, 0.6)	
		--[[self.heroPic:runAction(transition.sequence({
			cc.CallFunc:create(function()
				self:setAnchor(cc.p(0.67,0.15))
			end),
			cc.Animate:create(self.magicAni),
			cc.CallFunc:create(function()
				self.heroPic:setSpriteFrame(display.newSpriteFrame(self.data.pic))
				skill:execute()
			end),
		}))]]
	end
end

return Hero4