--
-- Author: KK
-- Date: 2014-11-05 12:15:22
--
--审判

local MapInfo = import("..views.MapInfo")
local Skill = import(".Skill")
local Skill01 = class("Skill01", Skill)

local USE_TORNADO = true

function Skill01:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Skill01.super.ctor(self, params)

    self.lasting = ExcelHeroSkillData[self.idx][GameData.heros["h1"].skill["s1"]].time

    self.vx = 0
    self.vy = 0
    self.enemies = {}

end

function Skill01:execute()
    --提示语
    self.tip = g_playScene:getTip({type = "skill1"})
    g_fightLayer:addChild(self.tip,BaseZOrder.tornado+1)
    --提示手 首次显示
    self.tipFinger = g_playScene:getTipFinger({type = "skill1"})
    if self.tipFinger then
        g_fightLayer:addChild(self.tipFinger,BaseZOrder.tornado+1)
    end
    if USE_TORNADO then
        --龙卷风
        g_fightLayer:createTornado({
            from = cc.p(self.hero:getPosition()),
            time = self.lasting
        })
        g_fightLayer:addSkill(self)
        self.heroPic:playAnimationForever(self.hero.waitAni)
    else
        --英雄旋转
        g_fightLayer:addSkill(self)

        cc.Device:setAccelerometerEnabled(true)
        local function didAccelerate(event,x,y,z,timestamp)
            self.vx = x*600
            self.vy = y*600
        end
        local listener = cc.EventListenerAcceleration:create(didAccelerate)
        cc.Director:getInstance():getEventDispatcher():addEventListenerWithSceneGraphPriority(listener, self)
        self.heroPic:playAnimationForever(self.hero.attackAni)
    end
    self.cover = cc.LayerColor:create(cc.c4b(0,0,0,200))
    self.cover:runAction(cc.FadeTo:create(0.2,100))
    g_fightLayer:addChild(self.cover, BaseZOrder.bullet+1)
    --音效
    self.soundHandler = SoundManager.playSound(GAME_SOUND.Hero[1].skill1,true)
end

function Skill01:update(dt)
	self.lasting = self.lasting - dt
    if self.lasting <= 0.2 then
        g_fightLayer:removeSkill(self)
        self.heroPic:runAction(transition.sequence({
            --英雄恢复原大小
            cc.ScaleTo:create(0.2,1),
            cc.CallFunc:create(function()
                self:endSkill()
            end)
        }))
    end

    if not USE_TORNADO then
    	local x,y = self.hero:getPosition()
        x = x + self.vx*dt
        y = y + self.vy*dt
        local pt = cc.p(x,y)
        MapInfo:adjustPosInMapRange(pt)
    	self.hero:setPosition(pt)

        self:hitEnemy(pt)
        for i = #self.enemies, 1, -1 do
            if self.enemies[i] == 0 then --怪死时设的
                table.remove(self.enemies, i)
            elseif self.enemies[i].time then
                self.enemies[i].time = self.enemies[i].time + dt
                if self.enemies[i].time > 0.1 then
                    table.remove(self.enemies, i)
                end
            end
        end
    end
end

function Skill01:endSkill()
    --恢复怪物移动
    for i = 1 , #g_fightLayer.enemies do
        local en = g_fightLayer.enemies[i]
        en.pause = false
    end
    self.hero:setLocalZOrder(BaseZOrder.hero)
    self.cover:runAction(cc.FadeOut:create(0.2))
    cc.Device:setAccelerometerEnabled(false)
    --移除提示
    self.tip:runAction(cc.FadeOut:create(0.5)) 
    --移除手
    if self.tipFinger then
        self.tipFinger:removeFromParent()
    end
    self.hero:endSkill()
    g_playScene:setCanTouch(true)
    g_playScene:changeSpeedUser()
    self:performWithDelay(function()
        self:removeFromParent()
    end, 1)
    --音效
    SoundManager.stopSound(self.soundHandler)
end

function Skill01:hitEnemy(p)
    local heroRect = self.heroPic:getCascadeBoundingBox()
    for i = 1, #g_fightLayer.enemies do
        local en = g_fightLayer.enemies[i]
        if en ~= nil then
            local enRect = en:getCascadeBoundingBox()
            local hasAttacked = false
            if cc.rectIntersectsRect(heroRect, enRect) then
            --if cc.rectContainsPoint(enRect, p) then
                for j = 1,#self.enemies do
                    if en == self.enemies[j] then
                        hasAttacked = true
                        break
                    end
                end
                if not hasAttacked then
                    en:updateHp(-5)
                    if en ~= nil then
                        self.enemies[#self.enemies+1] = en
                        local idx = #self.enemies --直接索引有问题。
                        self.enemies[idx].time = 0
                    end
                end
            end
        end
    end
end

return Skill01
