--
-- Author: KK
-- Date: 2014-11-05 12:19:59
--
--大地震颤

local Skill = import(".Skill")
local Skill02 = class("Skill02", Skill)

function Skill02:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Skill02.super.ctor(self, params)
end

function Skill02:shakeEarth()
	g_playScene:runAction(transition.sequence({
        cc.MoveBy:create(0.04, cc.p(0,4)),
        cc.MoveBy:create(0.08, cc.p(0,-8)),
        cc.MoveBy:create(0.08, cc.p(0,8)),
        cc.MoveBy:create(0.08, cc.p(0,-8)),
        cc.MoveBy:create(0.08, cc.p(0,8)),
        cc.MoveBy:create(0.04, cc.p(0,-4)),
    }))
	local enemies = g_fightLayer:getEnimiesAroundPos(cc.p(self.hero:getPosition()), math.pow(s_mapTileSize*10,2))
	for i = 1, #enemies do
		local pic = display.newSprite("#dizzy_1.png")
		local frames = display.newFrames("dizzy_%d.png", 1, 4)
    	local animation = display.newAnimation(frames, 0.1)
    	pic:playAnimationForever(animation)
		pic:setAnchorPoint(cc.p(0.5,0.2))
		enemies[i]:addBuffer({
			bufferType = EnemyBuffer.BUFFER_DIZZY,
			pic = pic,
			attack = self.attack,
			chance = 1,
			time = 3,
		})
	end
end

function Skill02:execute()
	local ani = display.getAnimationCache("h01_magic2")
	self.hero:setAnchor(cc.p(0.5,0.18))
	self.heroPic:runAction(transition.sequence({
		cc.Animate:create(ani),
		cc.CallFunc:create(function()
			self.hero:setAnchor(cc.p(0.4,0.1))
			self.heroPic:setSpriteFrame(display.newSpriteFrame(self.hero.data.pic))
			self:endSkill()
		end),
	}))
	self:performWithDelay(function()
		--音效
	    SoundManager.playSound(GAME_SOUND.Hero[1].skill2)	
		self:shakeEarth()
	end, 1.5)
end

return Skill02
