--
-- Author: KK
-- Date: 2014-11-06 12:36:31
--
--雷神之怒

local Skill = import(".Skill")
local Skill04 = class("Skill04", Skill)

function Skill04:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Skill04.super.ctor(self, params)

	self.skillAni = display.getAnimationCache(self.data.ani)

    self.lasting = ExcelHeroSkillData[self.idx][GameData.heros["h2"].skill["s1"]].time
end

function Skill04:execute()
    --提示语
    self.tip = g_playScene:getTip({type = "skill4"})
    self:addChild(self.tip,1)
    --提示手 首次显示
    self.tipFinger = g_playScene:getTipFinger({type = "skill4"})
    if self.tipFinger then
        g_fightLayer:addChild(self.tipFinger,BaseZOrder.heroSkill+1)
    end

    self.touchLayer = display.newLayer()
    g_playScene:addChild(self.touchLayer,201)
	self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
		return self:onTouch(event.name, event.x, event.y)
    end)
	self.touchLayer:setTouchEnabled(true)

	self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
        self:update(dt) 
    end)
    self:scheduleUpdate()
    self.heroPic:playAnimationForever(self.hero.magicAni2)

	self.cover = cc.LayerColor:create(cc.c4b(0,0,0,200))
	self.cover:runAction(cc.FadeTo:create(0.2,100))
	g_fightLayer:addChild(self.cover, BaseZOrder.bullet+1)
end

function Skill04:update(dt)
	self.lasting = self.lasting - dt
	if self.lasting <= 0.2 then
		self:unscheduleUpdate()
		self.heroPic:runAction(transition.sequence({
			--英雄恢复原大小
			cc.ScaleTo:create(0.2,1),
			cc.CallFunc:create(function()
				self:endSkill()
			end)
		}))
	end
end

function Skill04:onTouch(event, x, y)
	if event == "began" then
		return true
	elseif event == "ended" then
		local sprite = display.newSprite("#h02_s01_1.png")
		--sprite:setScale(0.5)
		sprite:setAnchorPoint(cc.p(0.5,0.2))
		sprite:setPosition(cc.p(x,y))
		self:hitEnemy(cc.p(x,y))
		sprite:playAnimationOnce(self.skillAni, true)
		--[[self:performWithDelay(function()
			self:hitEnemy(cc.p(x,y))
		end, 0.1)]]
		g_fightLayer:addChild(sprite, BaseZOrder.bullet+2)
		if self.tipFinger then
			self.tipFinger:removeFromParent()
        	self.tipFinger = nil
		end

		--音效
    	SoundManager.playSound(GAME_SOUND.Hero[2].skill1)
	end
end

function Skill04:hitEnemy(p)
	for i = 1, #g_fightLayer.enemies do
		local en = g_fightLayer.enemies[i]
		if en ~= nil then
			local enRect = en:getCascadeBoundingBox()
			local posRect = cc.rect(p.x - 20, p.y - 20, 40, 40)
			if cc.rectIntersectsRect(enRect, posRect) then
				en:updateHp(-self.attack)
			end
		end
	end
end

function Skill04:endSkill()
	--恢复怪物移动
    for i = 1 , #g_fightLayer.enemies do
        local en = g_fightLayer.enemies[i]
        en.pause = false
    end
    self.hero:setLocalZOrder(BaseZOrder.hero)
    self.cover:runAction(cc.FadeOut:create(0.2))
	--[[
	local whiteLayer = cc.LayerColor:create(cc.c4b(255,255,255,255))
	g_fightLayer:addChild(whiteLayer)
	whiteLayer:setOpacity(0)
	whiteLayer:runAction(transition.sequence({
		cc.FadeIn:create(0.2),
		cc.FadeOut:create(0.2),
		cc.CallFunc:create(function()
			whiteLayer:removeFromParent()
		end)
	}))
	--]]
    --移除提示
    self.tip:runAction(cc.FadeOut:create(0.5)) 
    --移除手
    if self.tipFinger then
        self.tipFinger:removeFromParent()
        self.tipFinger = nil
    end
	self.hero:endSkill()
	self.touchLayer:setTouchEnabled(false)
	--self.touchLayer:removeNodeEventListenersByEvent(cc.NODE_TOUCH_EVENT)
	--self.touchLayer:removeFromParent()
	g_playScene:setCanTouch(true)
    g_playScene:changeSpeedUser()
	self:performWithDelay(function()
		self.touchLayer:removeFromParent()
		self:removeFromParent()
	end, 1)
end

return Skill04
