--
-- Author: KK
-- Date: 2014-11-11 14:42:51
--
--火雨

local Skill = import(".Skill")
local Skill05 = class("Skill05", Skill)

function Skill05:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Skill05.super.ctor(self, params)
    self.pos = params.pos
	--self.skillAni = display.getAnimationCache(self.data.ani)
end

function Skill05:execute()
	g_playScene:setCanTouch(false)
	g_playScene:changeSpeedNormal()
	for i = 1, 3 do
		self:performWithDelay(function()
			g_fightLayer:createFireball({
				pos = self.pos,
				range = 70,
				interval = 0.1,
				num = 5,
				onlyShow = true, --不算伤害。
			})			
		end, (i-1)*0.6)
	end
	self:performWithDelay(function()
		self:hitEnemy(self.pos)
	end, 0.2)
	self:performWithDelay(function()
		self:hitEnemy(self.pos)
	end, 0.8)
	self:performWithDelay(function()
		self:hitEnemy(self.pos)
	end, 1.4)
	self:performWithDelay(function()
		self:endSkill()
	end, 1.7)

	--[[
	self.skillAni = display.getAnimationCache(self.data.ani)
	local sprite = display.newSprite()
	sprite:setScale(0.5)
	sprite:setAnchorPoint(cc.p(0.5,0.15))
	sprite:setPosition(self.pos)
	self:addChild(sprite)
	sprite:playAnimationOnce(self.skillAni, true, function()
		self:endSkill()
	end)
	self:hitEnemy(self.pos)
	--]]
	--音效
    SoundManager.playSound(GAME_SOUND.Hero[2].skill2)
end

function Skill05:endSkill()
	--恢复怪物移动
    for i = 1 , #g_fightLayer.enemies do
        local en = g_fightLayer.enemies[i]
        en.pause = false
    end
    self.hero:endSkill()
    g_playScene:setCanTouch(true)
    g_playScene:changeSpeedUser()
	self:removeFromParent()
end

function Skill05:hitEnemy(p)
	for i = 1, #g_fightLayer.enemies do
		local en = g_fightLayer.enemies[i]
		if en ~= nil then
			local enRect = en:getCascadeBoundingBox()
			local posRect = cc.rect(p.x - 70, p.y - 70, 140, 140)
			if cc.rectIntersectsRect(enRect, posRect) then
				en:updateHp(-self.attack)
			end
		end
	end
end

return Skill05
