--
-- Author: Wangzhihao
-- Date: 2014-11-28 10:24:08
--
--剑刃风暴
local Skill = import(".Skill")
local Skill08 = class("Skill08", Skill)

function Skill08:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Skill08.super.ctor(self, params)
    self.lasting = ExcelHeroSkillData[8][GameData.heros["h3"].skill["s1"]].time
    self.attackHp = math.floor(ExcelHeroSkillData[8][GameData.heros["h3"].skill["s1"]].value)
	self.enemyattackAgain = {}
	self.enemies = {}
end

function Skill08:execute()
	self.contrastCount = 0
    --提示语
    self.tip = g_playScene:getTip({type = "skill8"})
    self:addChild(self.tip,1)
    --提示手 首次显示
    self.tipFinger = g_playScene:getTipFinger({type = "skill8"})
    if self.tipFinger then
        self:addChild(self.tipFinger,1)
    end

	self.heroPic:playAnimationForever(self.hero.magic2Ani)
	g_playScene:setCanTouch(true)

    self.touchLayer = display.newLayer()
    g_playScene:addChild(self.touchLayer,201)
	self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
		return self:onTouch(event.name, event.x, event.y)
    end)
	self.touchLayer:setTouchEnabled(true)

	self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
        self:update(dt) 
    end)
    self:scheduleUpdate()

    self.cover = cc.LayerColor:create(cc.c4b(0,0,0,200))
	self.cover:runAction(cc.FadeTo:create(0.2,100))
	g_fightLayer:addChild(self.cover, BaseZOrder.bullet+1)
end
function Skill08:update(dt)
	self.lasting = self.lasting - dt
	if self.lasting <= 0 then
		self:unscheduleUpdate()
		self.heroPic:runAction(transition.sequence({
			--英雄恢复原大小
			cc.ScaleTo:create(0.2,1),
			cc.CallFunc:create(function()
				self:endSkill()
			end)
		}))
	end
	for i =1,#self.enemies do
		self.enemyattackAgain[i] = self.enemyattackAgain[i] + dt
		if self.enemyattackAgain[i] > 0.1 then
			table.remove(self.enemies,i)
		end
	end
	--音效
	if self.lastPos ~= self.contrastPos then--在手指静止时停掉音效
		self.contrastPos = self.lastPos
		self.contrastCount = 0
	else
		self.contrastCount = self.contrastCount + 1
		if self.contrastCount == 20 and self.soundHandler then
			SoundManager.stopSound(self.soundHandler)
    		self.soundHandler = nil
		end
	end
end
function Skill08:onTouch(event, x, y)
	if event == "began" then
		--例子特效
		self.emitter = cc.ParticleSystemQuad:create("particle/skill8particle.plist")
	    --self.emitter:setStartColor({ r = 80/255, g = 0.86, b = 1, a = 1.0 })
    	--self.emitter:setEndColor({ r = 80/255, g = 0.86, b = 1, a = 1.0 })
	    self.emitter:setBlendAdditive(true)
	    self.emitter:setVisible(false)
	    self.emitter:setEmissionRate(32)
	    g_fightLayer:addChild(self.emitter, BaseZOrder.bullet+2)
		self.emitter:setPosition(cc.p(x,y))
		self.emitter:setVisible(true)
		self.streak = cc.MotionStreak:create(0.3,3,20,cc.c3b(80,220,255),"pic/heroPPP.png")
		self.streak:setPosition(cc.p(x,y))
		--self.streak:setColor(cc.c3b(200,0,0))
		g_fightLayer:addChild(self.streak, BaseZOrder.bullet+2)
		self.lastPos = cc.p(x,y)
		self.contrastPos = self.lastPos
		return true
	elseif event == "moved" then
		self.emitter:setPosition(cc.p(x,y))
		local movedPos = cc.p(x,y)
		self.streak:setPosition(cc.p(x,y))
		local dist = cc.pGetDistance(self.lastPos, movedPos)
		if dist >= 30 then
			--音效
			if not self.soundHandler then
				self.soundHandler =	SoundManager.playSound(GAME_SOUND.Hero[3].skill1,true)
			end
			local midPoints = {} 
		    local n = math.ceil(dist/30)
		    local sub = cc.pSub(self.lastPos,movedPos)
		    local dx = sub.x/n
		    local dy = sub.y/n
		    for i = 1, n do
		        local midPos = cc.p(self.lastPos.x+dx*(i-1),movedPos.y+dy*(i-1))
		        self:hitEnemy(midPos)
		    end 			
			self.lastPos = cc.p(x,y)
		end
		if self.tipFinger and self.tipFinger.isCompleteOnce then
			self.tipFinger:removeFromParent()
			self.tipFinger = nil
		end
	elseif event == "ended" then
		self.emitter:removeFromParent()
		self.emitter = nil
		--音效
		if self.soundHandler then
			SoundManager.stopSound(self.soundHandler)
    		self.soundHandler = nil
		end
	end
end
function Skill08:hitEnemy(p)
	for i = 1, #g_fightLayer.enemies do
		local en = g_fightLayer.enemies[i]
		if en ~= nil then
			local enRect = en:getCascadeBoundingBox()
			local enemyControl = false
			if cc.rectContainsPoint(enRect, p) then
				for j = 1,#self.enemies do
					if g_fightLayer.enemies[i] ~= self.enemies[j] then
					else
						enemyControl = true
					end
				end
				if enemyControl then
				else
					en:updateHp(-self.attackHp)
					self.enemies[#self.enemies+1] = g_fightLayer.enemies[i]
					self.enemyattackAgain[#self.enemyattackAgain+1] = 0
				end
			end
		end
	end
end
function Skill08:endSkill()
	--恢复怪物移动
    for i = 1 , #g_fightLayer.enemies do
        local en = g_fightLayer.enemies[i]
        en.pause = false
    end
	--音效
	if self.soundHandler then
		SoundManager.stopSound(self.soundHandler)
		self.soundHandler = nil
	end

	self.cover:runAction(cc.FadeOut:create(0.2))
	if self.emitter ~= nil then
		self.emitter:removeFromParent()
	end
    --移除提示
    self.tip:runAction(cc.FadeOut:create(0.5)) 
    --移除手
    if self.tipFinger then
        self.tipFinger:removeFromParent()
    end
	self:stopAllActions()
	
	self.hero:endSkill()
    self.touchLayer:removeNodeEventListenersByEvent(cc.NODE_TOUCH_EVENT)
	self.touchLayer:removeFromParent()
    g_playScene:changeSpeedUser()
	self:removeFromParent()
end
return Skill08