--
-- Author: Wangzhihao
-- Date: 2014-11-25 10:11:36
--
local Skill = import(".Skill")
local Skill09 = class("Skill09", Skill)
function Skill09:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Skill09.super.ctor(self, params)
    self.pos = params.pos
    self.hx = self.hero:getPositionX()
    self.hy = self.hero:getPositionY()
end

function Skill09:execute()
    self.cover = cc.LayerColor:create(cc.c4b(0,0,0,200))
    g_fightLayer:addChild(self.cover, BaseZOrder.bullet+1)
    self.hero:setPosition(self.pos)
	self:hitEnemy()
    self.pos.y = self.pos.y + 30
    self.heroPic:setSpriteFrame(display.newSpriteFrame("h03_skill09_stop1.png"))
    local frames = display.newFrames("h03_skill09_stop%d.png", 1, 12)
    local animation = display.newAnimation(frames, 0.1)
    self.heroPic:playAnimationOnce(animation, false, function()
        self.heroPic:setSpriteFrame(display.newSpriteFrame(self.data.pic))
        --self.hero:setPosition(self.hx,self.hy)
    end)
    --[[local dist = cc.pGetDistance(self.pos, cc.p(self.hx,self.hy))
    local light = display.newSprite("#h03_lightLine.png", self.hx, self.hy)
	:addTo(g_fightLayer, BaseZOrder.hero)
    light:setScaleY((dist-20)/430)
    light:setAnchorPoint(cc.p(0.5,0))
	local rt = kkFunc.getLineRotation(cc.p(self.hx, self.hy), self.pos)
		light:setRotation(rt)
		light:runAction(transition.sequence({
        cc.ScaleTo:create(0.5,0,(dist-20)/430),
        cc.CallFunc:create(function()
            light:removeFromParent()
        end)
    }))]]
    ----
    local dist = cc.pGetDistance(self.pos, cc.p(self.hx,self.hy))
    local light = display.newSprite("#h03_lightLine1.png", (self.hx+self.pos.x)/2, (self.hy+self.pos.y)/2)
    :addTo(g_fightLayer, BaseZOrder.bullet+1)
    light:setScaleX((dist-20)*2/462)
    light:setScaleY(2)
    light:setAnchorPoint(cc.p(0.5,0.5))
    local rt = kkFunc.getLineRotation(cc.p(self.hx, self.hy), self.pos)
    light:setRotation(rt+90)
    local frames = display.newFrames("h03_lightLine%d.png", 1, 6)
    local animation = display.newAnimation(frames, 0.15)
    light:playAnimationOnce(animation,true)
    self.hero:performWithDelay(function()
        self:endSkill()
    end, 0.5)
    --音效
    SoundManager.playSound(GAME_SOUND.Hero[3].skill2)
end

function Skill09:hitEnemy()
	local newPos = self.pos
    local oldPos = cc.p(self.hx,self.hy)
    local dist = cc.pGetDistance(newPos, oldPos)
    local n = math.ceil(dist/20)
    local sub = cc.pSub(newPos,oldPos)
    local dx = sub.x/n
    local dy = sub.y/n
    local rect = {}
    for i = 1, n-1 do
        local midPos = cc.p(oldPos.x+dx*i,oldPos.y+dy*i)
        rect[i] = cc.rect(midPos.x-50,midPos.y-50,100,100)
    end
    local enemies = {}
    for i = 1, #g_fightLayer.enemies do
	    local en = g_fightLayer.enemies[i]
	    enemies[#enemies+i]=en
    end
    for i = 1,#rect do
	    for j = 1, #enemies do
	        local en = enemies[j]
	        if en ~= nil then
		        local enRect = en:getCascadeBoundingBox()
		        if cc.rectIntersectsRect(enRect, rect[i]) then	
                    --攻击动画
                    local bombPic = display.newSprite("#h03_skill09_bomb1.png",en:getPositionCenter().x,en:getPositionCenter().y)
                    g_fightLayer:addChild(bombPic, BaseZOrder.bullet+2)	
                    local frames = display.newFrames("h03_skill09_bomb%d.png", 1, 3)
                    local animation = display.newAnimation(frames, 0.1)
                    bombPic:playAnimationOnce(animation,true)			
  					en:updateHp(-self.attack)
  					enemies[j] = nil                   
		        end
	        end	
	    end
    end	
end
function Skill09:endSkill()
    --恢复怪物移动
    for i = 1 , #g_fightLayer.enemies do
        local en = g_fightLayer.enemies[i]
        en.pause = false
    end
    self.cover:runAction(cc.FadeOut:create(0.2))
    self:stopAllActions()
    self.hero:endSkill()

    g_playScene:setCanTouch(true)
    g_playScene:changeSpeedUser()
    self:performWithDelay(function()
        self:removeFromParent()
    end, 1)
end
return Skill09