--
-- Author: Wangzhihao
-- Date: 2014-11-27 11:36:12
--
local MapInfo = import("..views.MapInfo")
local Skill = import(".Skill")
local Skill14 = class("Skill14", Skill)

function Skill14:ctor(params)
    -- 如果继承类覆盖了 ctor() 构造函数，那么必须手动调用父类构造函数
    -- 类名.super 可以访问指定类的父类
    Skill14.super.ctor(self, params)
    self.lasting = ExcelHeroSkillData[self.idx][GameData.heros["h4"].skill["s3"]].time
end

function Skill14:execute()
	--[[self.rangeSq = math.pow(5*MapInfo.tileSize,2)
	local enemies = g_fightLayer:getEnimiesAroundPos(cc.p(self.hero:getPosition()), self.rangeSq)
	local randomForts = kkFunc.getRandomFromTable(enemies, 3)
	for i = 1, #enemies do
		local dizzyPic = display.newSprite("#slowBuffer.png")
		enemies[i]:addBuffer({
			bufferType = EnemyBuffer.BUFFER_DIZZY,
			pic = dizzyPic,
			attack = 30,
			chance = 1,
			time = 3,
		})
	end
	self:endSkill()]]
	self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
        self:update(dt) 
    end)
    self:scheduleUpdate()

    self.heroWing = display.newSprite("#s14_wing_1.png",7 ,120)
    g_playScene.hero:addChild(self.heroWing,2)
	local frames = display.newFrames("s14_wing_%d.png", 1, 8)
	local animation = display.newAnimation(frames, 0.1)
	self.heroWing:playAnimationForever(animation)
	self:changeHeroSpeed()
	self:performWithDelay(function()
		self.hero:endSkill()
	end, 0.4)
end
function Skill14:changeHeroSpeed()
	g_playScene.hero.speed = g_playScene.hero.speed*1.2
	g_playScene.hero.attack = g_playScene.hero.attack*1.2
	--g_playScene.hero.attackSpeed = g_playScene.hero.attackSpeed/1.2
end
function Skill14:cancleHeroSpeed()
	g_playScene.hero.speed = g_playScene.hero.speed/1.2
	g_playScene.hero.attack = g_playScene.hero.attack/1.2
	--g_playScene.hero.attackSpeed = g_playScene.hero.attackSpeed*1.2
end
function Skill14:update(dt)
	self.lasting = self.lasting - dt
	if not self.heroPic:isFlippedX() then
		self.heroWing:setPosition(7,120)
	else
		self.heroWing:setPosition(-3,120)
	end
	if self.lasting <= 0 then
		self:unscheduleUpdate()
		--攻击，移动，攻速提成消失
		self:cancleHeroSpeed()
		self.heroWing:runAction(transition.sequence({
			cc.FadeOut:create(0.5),
			cc.CallFunc:create(function()
				self:endSkill()
			end)
		}))		
	end
end
function Skill14:endSkill()
	--恢复怪物移动
    for i = 1 , #g_fightLayer.enemies do
        local en = g_fightLayer.enemies[i]
        en.pause = false
    end
	--翅膀消失
	self.heroWing:removeFromParent()
	self:performWithDelay(function()
		self:removeFromParent()
	end, 0.5)
end
return Skill14