--
-- Author: Wangzhihao
-- Date: 2014-12-05 11:27:38
--
local LevelInfoLayer = import(".LevelInfoLayer")
local AchievementScene = class("AchievementScene", function()
    return display.newScene("AchievementScene")
end)

function AchievementScene:ctor()
    --ResData.loadRes("UI_ACHIEVEMENT")--在loading中完成
    local pic
    if VERSION_REDUCE then
        pic = "pic/heroHouseBg.png"
    else
        pic = "pic/heroAchieveBG.png"
    end
    local achievementBg = display.newSprite(pic,display.cx,display.cy)
    self:addChild(achievementBg)
    --触摸层
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,5)    
    --体力萝卜钻石
    self.infoLayer = LevelInfoLayer.new(3)
    self:addChild(self.infoLayer,20)
    --return
    self.achievementButon = cc.ui.UIPushButton.new({
        normal = "#returnNew.png",
        pressed = "#returnNew.png",
        disabled = "#returnNew.png",
        })
        :onButtonPressed(function()
            self.achievementButon:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.achievementButon:setScale(1)
        end)
        :onButtonClicked(function(event)
            app:level()   
        end)
        :pos(display.cx-380, display.height-50)
        :addTo(self)
    --
    local emitter5 = cc.ParticleSystemQuad:create("particle/piaoluo.plist")
    --emitter5:setStartSize(100)
    emitter5:setPosition(cc.p(display.cx,display.cy))
    emitter5:setEmissionRate(2)
    self:addChild(emitter5)
    --
    self.achievementBg = display.newScale9Sprite("#achieveBg.png", display.cx, display.cy - 40,cc.size(855,500))
    self:addChild(self.achievementBg)
    self.achievetitleBg = display.newSprite("#achievetitleBg.png",display.cx,display.cy+205)
    self:addChild(self.achievetitleBg)
    local achievetitle = display.newSprite("#achievetitle.png",self.achievetitleBg:getContentSize().width/2,self.achievetitleBg:getContentSize().height/2)
    self.achievetitleBg:addChild(achievetitle)
    self:getContent()
    self:getScrollView()     
end

function AchievementScene:getContent()
    self.achieveup = display.newSprite("#achieve_Up.png",426,450)
    self.achievementBg:addChild(self.achieveup)
    self.achieveup:setVisible(false)
    self.achievedown = display.newSprite("#achieve_Down.png",426,20)
    self.achievementBg:addChild(self.achievedown)
    self.contentLayer = display.newLayer()
    self.contentLayer:setContentSize(cc.size(self.achievementBg:getContentSize().width*9/10, 400))
    self.achieveBar = {}
    self.achieveButton = {}
    --local achievementNum = 0
    local giftNum = 0
    --local sortTable = self:sortAchievement()
    for i = 1, 17 do
        local v = GameData.achievement[""..i]
        if v.type == 1 then
            if v.complete and not v.isGifted then
                giftNum = giftNum + 1
                self:getSingleAchievementBar(giftNum, v.idx, v.recordNum, v)
            end
        elseif v.type == 2 then
            for j = 1, v.openlevel do
                if v[""..j].complete and not v[""..j].isGifted then
                    giftNum = giftNum + 1
                    self:getSingleAchievementBar(giftNum, v.idx, v.recordNum, v[""..j],j)
                end
            end
        end
    end
    local achievementNum = giftNum
    for i = 1, 17 do
        local v = GameData.achievement[""..i]
        if v.type == 1 then
            if not v.complete and not v.isGifted then
                achievementNum = achievementNum + 1
                self:getSingleAchievementBar(achievementNum, v.idx, v.recordNum, v)
            end
        elseif v.type == 2 then
            for j = 1, v.openlevel do
                if not v[""..j].complete and not v[""..j].isGifted then
                    achievementNum = achievementNum + 1
                    self:getSingleAchievementBar(achievementNum, v.idx, v.recordNum, v[""..j],j)
                end
            end
        end
    end
    for i = 1, 17 do
        local v = GameData.achievement[""..i]
        if v.type == 1 then
            if v.complete and v.isGifted then
                achievementNum = achievementNum + 1
                self:getSingleAchievementBar(achievementNum, v.idx, v.recordNum, v)
            end
        elseif v.type == 2 then
            for j = 1, v.openlevel do
                if v[""..j].complete and v[""..j].isGifted then
                    achievementNum = achievementNum + 1
                    self:getSingleAchievementBar(achievementNum, v.idx, v.recordNum, v[""..j],j)
                end
            end
        end
    end
    self.achievementNum = achievementNum
    --[[for i = 1, 17 do
        if GameData.achievement[""..i].type == 1 then
            achievementNum = achievementNum + 1
            local v = GameData.achievement[""..i]
            self:getSingleAchievementBar(achievementNum, v.idx, v.recordNum, v)
        elseif GameData.achievement[""..i].type == 2 then
            for j = 1, GameData.achievement[""..i].openlevel do
                achievementNum = achievementNum + 1
                local v = GameData.achievement[""..i]
                self:getSingleAchievementBar(achievementNum, v.idx, v.recordNum, v[""..j])
            end
        end
    end]]
    --GameState.save(GameData)
end

function AchievementScene:getSingleAchievementBar(i,idx,recordNum,v,Jdx)
    if idx == 12 then
        AchievementData.checkOwenHero()
    end
    if not v.isGifted then
        self.achieveBar[i] = display.newSprite("#achieveBar.png",self.achievementBg:getContentSize().width/2-20,468 - (self.achievementBg:getContentSize().height/4+5)*i-(i-1)*6)
    else
        self.achieveBar[i] = display.newSprite("#achieveBarGift.png",self.achievementBg:getContentSize().width/2-20,468 - (self.achievementBg:getContentSize().height/4+5)*i-(i-1)*6)
        local highLight = display.newSprite("#achieveBarGiftLight.png",self.achieveBar[i]:getContentSize().width/3,self.achieveBar[i]:getContentSize().height-12)
        self.achieveBar[i]:addChild(highLight)
    end  
    self.contentLayer:addChild(self.achieveBar[i])

    local diamondSprite = display.newSprite("#achieveDiamond.png",85,79)
    self.achieveBar[i]:addChild(diamondSprite)
    local fontType
    if VERSION_REDUCE then
        fontType = "fontEasy.ttf"
    else
        fontType = "fontCommon.TTF"
    end
    local giftNum = cc.ui.UILabel.new({
        UILabelType = 2,
        font = fontType,
        text = "×5",
        size = 22,
        color = cc.c3b(255,255,255),
        x = 84,
        y = 43,
    }):align(display.CENTER)
    self.achieveBar[i]:addChild(giftNum)
    --local bl = display.newSprite("#achieveline.png",self.achieveBar[i]:getContentSize().width/2+10,self.achieveBar[i]:getContentSize().height/2)
    --self.achieveBar[i]:addChild(bl)
    local l1
    if VERSION_REDUCE then
        l1 = cc.ui.UILabel.new({
            UILabelType = 2,
            text = AchievementData.getAchieveText(idx,v),
            font = "fontEasy.ttf",
            size = 24,
            color = cc.c3b(12,88,119),
            x = self.achieveBar[i]:getContentSize().width*1/5-25,
            y = self.achieveBar[i]:getContentSize().height*2/3,
        })
    else
        l1 = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = AchievementData.getAchieveText(idx,v),
            size = 24,
            color = cc.c3b(12,88,119),
            x = self.achieveBar[i]:getContentSize().width*1/5-2,
            y = self.achieveBar[i]:getContentSize().height*2/3,
        })
    end
    -- local l1 = cc.ui.UILabel.new({
    --     text = AchievementData.getAchieveText(idx,v),
    --     size = 24,
    --     color = cc.c3b(12,88,119),
    --     x = self.achieveBar[i]:getContentSize().width*1/5-2,
    --     y = self.achieveBar[i]:getContentSize().height*2/3,
    -- })
    if v.isGifted then
        l1:setColor(cc.c3b(119,62,12))
    end
    self.achieveBar[i]:addChild(l1)
    local addY = 21
    if VERSION_REDUCE then
        addY = 20
    end
    local progressBarUp = display.newSprite("#achieve_bar2.png",self.achieveBar[i]:getContentSize().width*1/4 +38,self.achieveBar[i]:getContentSize().height/4+addY)
    local progressBarUpRight = display.newSprite("#achieve_barRight.png")
    progressBarUp:setAnchorPoint(cc.p(0,0.5))
    progressBarUpRight:setAnchorPoint(cc.p(0,0.5))
    self.achieveBar[i]:addChild(progressBarUp)
    self.achieveBar[i]:addChild(progressBarUpRight)
    local rect = progressBarUp:getTextureRect()
    local rect1 = rect
    local rect2 = rect
    progressBarUp:setVisible(false)
    progressBarUpRight:setVisible(false)
    if v.isGifted then
        progressBarUp:setPosition(self.achieveBar[i]:getContentSize().width*1/4 +38,self.achieveBar[i]:getContentSize().height/4+21.5)
    end
    local scalex = 0              
    if v.needNum ~= nil then
        progressBarUp:setVisible(true)
        progressBarUpRight:setVisible(true)
        if recordNum > v.needNum then
            recordNum = v.needNum
            scalex = 1
        else
            scalex = recordNum/v.needNum
        end
        if scalex == 0 or scalex == 1 then
            progressBarUpRight:setVisible(false)
        elseif scalex < 0.1 then
            scalex = 0.1
        elseif scalex > 0.9 then
            scalex = 0.9
        end
        rect1.width = scalex*rect1.width
        progressBarUpRight:setPosition(self.achieveBar[i]:getContentSize().width*1/4 +37+rect1.width,self.achieveBar[i]:getContentSize().height/4+addY)
        progressBarUp:setTextureRect(rect1,progressBarUp:isTextureRectRotated(),cc.size(rect1.width, rect1.height))
        local fontType
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
        else
            fontType = "fontCommon.TTF"
        end
        local percent = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = ""..recordNum.."/"..v.needNum,
            size = 24,
            color = cc.c3b(255,255,255),
            x = 170 + progressBarUp:getPositionX(),
            y = self.achieveBar[i]:getContentSize().height/4+18,
        }):align(display.CENTER)
        self.achieveBar[i]:addChild(percent) 
    end
    
    if v.complete == true then
        --非累积成就完成后进度条直接满
        if v.needNum == nil then
            --local rect = progressBarUp:getTextureRect() 
            progressBarUp:setVisible(true)
            rect2.width = 1*rect2.width
            progressBarUp:setTextureRect(rect2,progressBarUp:isTextureRectRotated(),cc.size(rect2.width, rect2.height))
            --progressBarUp:setScaleX(1)
        end
        if v.isGifted == false then
            self.achieveButton[i] = cc.ui.UIPushButton.new({
                normal = "#achieveGift_normal.png",
                disabled = "#achieveGift_normal.png",
                pressed = "#achieveGift_normal.png",
            })
            :onButtonClicked(function() 
                progressBarUp:setPosition(self.achieveBar[i]:getContentSize().width*1/4 +38,self.achieveBar[i]:getContentSize().height/4+22) 
                progressBarUpRight:setPosition(self.achieveBar[i]:getContentSize().width*1/4 +37+rect1.width,self.achieveBar[i]:getContentSize().height/4+22)
                v.isGifted = true
                self.achieveBar[i]:setSpriteFrame(display.newSpriteFrame("achieveBarGift.png"))
                l1:setColor(cc.c3b(119,62,12))
                local highLight = display.newSprite("#achieveBarGiftLight.png",self.achieveBar[i]:getContentSize().width/3,self.achieveBar[i]:getContentSize().height-12)
                self.achieveBar[i]:addChild(highLight)
                GameData.diamond = GameData.diamond + 5 --每个成就的奖励均为五个钻石
                GameState.save(GameData)
                self:showDiamondAdd(i) 
                self:refreshButton(i)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
                --DataEye
                    --厦门
                -- if device.platform == "android" or device.platform == "ios" then
                --     local i = idx
                --     if idx < 10 then
                --         i = "0"..idx
                --     end 
                --     DCTask.begin(i.."/0"..Jdx, DC_Other)
                --     DCTask.complete(i.."/0"..Jdx)
                --     DCCoin.gain("完成成就奖励获得", "钻石", 5, GameData.diamond)
                -- end
                    --厦门
            end)
            :align(display.CENTER,self.achieveBar[i]:getContentSize().width*6/7,self.achieveBar[i]:getContentSize().height/2-5)
            :addTo(self.achieveBar[i])
        else
            self:refreshButton(i)
        end
    elseif v.complete == false then
        local sprite = display.newSprite("#running.png",self.achieveBar[i]:getContentSize().width*6/7,self.achieveBar[i]:getContentSize().height/2-5)
        self.achieveBar[i]:addChild(sprite)
    end
end

function AchievementScene:createNewAchievement(v)
    --print("ff",achieveidx,#AchievementData[v.idx].needNum)
    if v.openlevel < #AchievementData[v.idx].needNum then
        GameData.achievement[v.idx.."_"..v.openlevel+1] = {
            idx = v.idx,
            complete = false,
            type = 2,
            openlevel = v.openlevel + 1,
            isGifted = false,
            recordNum = AchievementData[v.idx].needNum[v.openlevel],
            needNum = AchievementData[v.idx].needNum[v.openlevel+1],
        }
        GameData.achievement.num = GameData.achievement.num + 1
        GameState.save(GameData)
    end
end

--[[
function AchievementScene:sortAchievement()
    local tmp = {}
    for i = 1, GameData.achievement.num do
        table.insert(tmp,GameData.achievement[""..i])
    end
    local function comps(a,b)
        if a.idx ~= b.idx then
            return a.idx < b.idx
        else
            return a.openlevel < b.openlevel
        end
    end
    table.sort(tmp,comps)
    dump(tmp)
    return tmp
end
--]]

function AchievementScene:getScrollView()
    self.scrollView = cc.ui.UIScrollView.new({})   
    self.scrollView:setColor(cc.c3b(230,143,233))
    self.scrollView:setTouchSwallowEnabled(true)
    local screenSize = cc.Director:getInstance():getWinSize()
    local function scrollView1DidScroll(event)
       --local cp = self.scrollView:getContentOffset()
        if event.name == "moved" then
            --self.preChoose = nil
        end
    end
    local function scrollView1DidZoom()
        --print("scrollView1DidZoom")
    end
    local csize = self.contentLayer:getContentSize()
    if nil ~= self.scrollView then
        local scrollSize = self.contentLayer:getBoundingBox()
        scrollSize.width = self.achievementBg:getContentSize().width - 45
        scrollSize.height = 408
        self.scrollView:setViewRect(scrollSize)
        self.scrollView:setPosition(cc.p(20,34))
        self.scrollView:setScale(1.0)
        --self.scrollView:setAnchorPoint(cc.p(0.5,0.5))
        --self.scrollView:ignoreAnchorPointForPosition(false)
        self.scrollView:addScrollNode(self.contentLayer)
        self.scrollView:setDirection(1)
        --self.scrollView:scrollTo(cc.p(0,csize.height - scrollSize.height))
        self.scrollView:setBounceable(true)
        self.scrollView:onScroll(scrollView1DidScroll)
    end
    self.achievementBg:addChild(self.scrollView,1)
end 
function AchievementScene:refreshButton(idx)
    if self.achieveButton[idx] ~= nil then
        self.achieveButton[idx]:removeFromParent()
        self.achieveButton[idx] = nil
    end
    local finishLabel = display.newSprite("#achieveHasFinish.png",self.achieveBar[idx]:getContentSize().width*6/7-10,self.achieveBar[idx]:getContentSize().height/2-5)
    self.achieveBar[idx]:addChild(finishLabel)
end
function AchievementScene:showDiamondAdd(idx)
    kkFunc.ObtainEffect(self,cc.p(self.achieveBar[idx]:convertToWorldSpace(cc.p(self.achieveBar[idx]:getContentSize().width*6/7-25,self.achieveBar[idx]:getContentSize().height/2-5))),nil,0.5)
    -- local diamondLabel = cc.ui.UILabel.new({
    --         text = "+5",
    --         size = 24,
    --         color = cc.c3b(255,255,255),
    --         x = self.achieveBar[idx]:getContentSize().width*6/7,
    --         y = self.achieveBar[idx]:getContentSize().height/2-5,
    --     }):align(display.CENTER)
    -- self.achieveBar[idx]:addChild(diamondLabel)
    -- diamondLabel:runAction(transition.sequence({
    --     cc.MoveBy:create(0.2,cc.p(0,40)),
    --     cc.FadeOut:create(0.5),
    --     cc.CallFunc:create(function()
    --         diamondLabel:removeFromParent()
    --     end)
    -- }))
end
function AchievementScene:refresh()
    if self.scrollView ~= nil then
        self.recordScrollView = self.scrollView  
    end
    self:getContent()
    self:getScrollView()
    if self.recordScrollView ~= nil then
        self.recordScrollView:removeFromParent()
        self.recordScrollView = nil
    end
end
function AchievementScene:onTouch(event, x, y)
    if event == "began" then
        return true
    elseif event == "moved" then
        if self.contentLayer:getPositionY() >= 5 and self.contentLayer:getPositionY() < self.achievementNum*150-730 then
            self.achieveup:setVisible(true)
            self.achievedown:setVisible(true)
        elseif self.contentLayer:getPositionY() < 5 then
            self.achieveup:setVisible(false)
        elseif self.contentLayer:getPositionY() >= self.achievementNum*150-730 then 
            self.achievedown:setVisible(false)      
        end
    elseif event == "ended" then        
    end
end
function AchievementScene:onEnter()
    --安卓返回键
    
        --厦门返回键
    if device.platform == "android" then
        local layer = display.newLayer()
        layer:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
            if event.key == "back" then
                if g_infoLayer.poplayer ~=nil then
                    g_infoLayer:RemovePop()
                elseif g_infoLayer.shopLayer ~= nil then
                    g_infoLayer.shopLayer:Remove()
                else
                    app:level()
                end
            end
        end)
        self:addChild(layer)
        layer:setTouchSwallowEnabled(false)
        layer:setKeypadEnabled(true)
    end
         --厦门返回键

    -- 注册touch事件处理函数
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)
end
function AchievementScene:onExit()
    ResData.removeRes("UI_ACHIEVEMENT")
end
return AchievementScene