--
-- Author: 
-- Date: 2014-09-15 10:35:35
--
--图鉴
local TowerMes = {
    [1] = {
        openLevel = 101,
        towerIdx = 1,
        pic = "ui_T01_1_1.png",
    },
    [2] = {
        openLevel = 102,
        towerIdx = 2,
        pic = "ui_T02_1_1.png",
    },
    [3] = {
        openLevel = 104,
        towerIdx = 16,
        pic = "ui_T16_1_1.png",
    },
    [4] = {
        openLevel = 106,
        towerIdx = 3,
        pic = "ui_T03_1_1.png",
    },
    [5] = {
        openLevel = 203,
        towerIdx = 11,
        pic = "ui_T11_1_1.png",
    },
    [6] = {
        openLevel = 205,
        towerIdx = 18,
        pic = "ui_T18_1_1.png",
    },
    [7] = {
        openLevel = 207,
        towerIdx = 7,
        pic = "ui_T07_1_1.png",
    },
}
local LevelInfoLayer = import(".LevelInfoLayer")
local Handbook = class("Handbook", function()
    return display.newScene("Handbook")
end)

function Handbook:ctor(selectCallback)
    --ResData.loadRes("UI_HANDBOOK")]
    local pic
    if VERSION_REDUCE then
        pic = "pic/heroHouseBg.png"
    else
        pic = "pic/heroAchieveBG.png"
    end
    local handbookBg = display.newSprite(pic,display.cx,display.cy)
    self:addChild(handbookBg)
    self.infoLayer = LevelInfoLayer.new(3)
    self:addChild(self.infoLayer,20)
    --触摸层
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,18)
    --返回按钮
    self.returnLayerControl = 1
    
    self.handbookButon = cc.ui.UIPushButton.new({
        normal = "#returnNew.png",
        pressed = "#returnNew.png",
        disabled = "#returnNew.png",
        })
        :onButtonPressed(function()
            self.handbookButon:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.handbookButon:setScale(1)
        end)
        :onButtonClicked(function(event)
            app:level()   
        end)
        :pos(display.cx-380, display.height-50)
        :addTo(self)
    local emitter5 = cc.ParticleSystemQuad:create("particle/piaoluo.plist")
    --emitter5:setStartSize(100)
    emitter5:setPosition(cc.p(display.cx,display.cy))
    emitter5:setEmissionRate(2)
    self:addChild(emitter5)

    self.towerSelectBg = display.newSprite("#handbookBg.png", display.cx, display.cy - 50)
    self:addChild(self.towerSelectBg)

    local heroLabel = display.newSprite("#handbookTitle.png",448,500)
    self.towerSelectBg:addChild(heroLabel)      
    --scrollView
    self:getContent()
    self:getScrollView(self.contentLayer)

end
function Handbook:getContent()
    --左右箭头
    self.handbookLeft = display.newSprite("#handbookLeft.png")
    self:addChild(self.handbookLeft)
    self.handbookLeft:setPosition(display.cx-self.towerSelectBg:getContentSize().width/2,display.cy)
    self.handbookRight = display.newSprite("#handbookRight.png")
    self:addChild(self.handbookRight)
    self.handbookRight:setPosition(self.towerSelectBg:getContentSize().width+display.cx-self.towerSelectBg:getContentSize().width/2,display.cy)
    --contentLayer
    self.contentLayer=display.newLayer()
    self.contentLayer:setAnchorPoint(cc.p(0,0))
    self.towerBg = {}
    for i=1,#TowerMes do 
        self.towerBg[i] = display.newSprite("#hero_card.png")
        local size = self.towerBg[i]:getContentSize()
        self.towerBg[i]:setPosition(210*(i-0.5)-2,237)
        self.contentLayer:addChild(self.towerBg[i])
        local towerSprite = "#"..TowerMes[i].pic
        if GameData.openlevel >= TowerMes[i].openLevel then  
            towerSprite = "#"..TowerMes[i].pic
        else
            towerSprite = "#unKnowTower.png"
        end
        local towerPic = display.newSprite(towerSprite)
        self.towerBg[i]:addChild(towerPic)
        towerPic:setPosition(size.width*0.5, 335)
        if GameData.openlevel >= TowerMes[i].openLevel then
            local nature = {
                text = {
                    [1] = "攻击",
                    [2] = "攻速",
                    [3] = "射程",
                },
                textEnglish = {
                    [1] = " ATK",
                    [2] = "AS",
                    [3] = "AR",
                }               
            }
            local naturepercent = {
                [1] = math.floor(ExcelTowersData[TowerMes[i].towerIdx].level[1].attack)/math.floor(ExcelTowersData[TowerMes[i].towerIdx].level[3].attack),
                [2] = math.floor(ExcelTowersData[TowerMes[i].towerIdx].level[3].speed*70)/math.floor(ExcelTowersData[TowerMes[i].towerIdx].level[1].speed*70),
                [3] = math.floor(ExcelTowersData[TowerMes[i].towerIdx].level[1].range*70)/math.floor(ExcelTowersData[TowerMes[i].towerIdx].level[3].range*70),  
            }
            local natureBarUpMes = {
                [1] = "#natureBarRed_Up.png",
                [2] = "#natureBarBlue_Up.png",
                [3] = "#natureBarGre_Up.png",
            } 
            for j=1,3 do
                local text,fontType 
                if VERSION_REDUCE then
                    text = nature.textEnglish[j]
                     fontType = "fontEasy.ttf"
                else
                    text = nature.text[j]
                    fontType = "fontCommon.TTF"
                end
                local nature = display.newSprite("#handbookNatureBar.png",50,230-(j-1)*30)
                self.towerBg[i]:addChild(nature)
                local natureTitle = cc.ui.UILabel.new({
                    UILabelType = 2,
                    font = fontType,
                    text = text,
                    size = 20,
                    color = cc.c3b(255,255,255),
                    x = nature:getContentSize().width/2,
                    y = nature:getContentSize().height/2,
                    }):align(display.CENTER)
                nature:addChild(natureTitle)
                local natureBarBottom = display.newSprite("#natureBar_Bottom.png",80,230-(j-1)*30)
                natureBarBottom:setAnchorPoint(cc.p(0,0.5))
                self.towerBg[i]:addChild(natureBarBottom)

                if naturepercent[j] < 0.4 then
                    naturepercent[j] = 0.4
                end
                local natureBarUp = display.newScale9Sprite(natureBarUpMes[j],80,230-(j-1)*30,cc.size(naturepercent[j]*106,22))
                natureBarUp:setAnchorPoint(cc.p(0,0.5))
                self.towerBg[i]:addChild(natureBarUp)
            end
            local towerIntro
            if VERSION_REDUCE then
                towerIntro = cc.ui.UILabel.new({
                    UILabelType = 2,
                    text = kkFunc.getVersionText("图鉴",TowerMes[i].towerIdx),
                    size = 16,
                    font = "fontEasy.ttf",
                    color = cc.c3b(177,105,57),
                    x = 20,
                    y = 135,
                    dimensions = cc.size(180, 150),
                    }):align(display.LEFT_TOP)
            else
                towerIntro = cc.ui.UILabel.new({
                    UILabelType = 2,
                    font = "fontCommon.TTF",
                    text = kkFunc.getVersionText("图鉴",TowerMes[i].towerIdx),
                    size = 20,
                    color = cc.c3b(177,105,57),
                    x = 20,
                    y = 135,
                    }):align(display.LEFT_TOP)
            end
            self.towerBg[i]:addChild(towerIntro)
        else
            local graylayer = display.newSprite("#hero_cardGray.png",size.width/2,size.height/2)
            self.towerBg[i]:addChild(graylayer)
            local mesBg = display.newScale9Sprite("#openTextBg.png",size.width/2,215)
            mesBg:setScaleX(1.3)
            self.towerBg[i]:addChild(mesBg,2)
            local fontType
            if VERSION_REDUCE then
                fontType = "fontEasy.ttf" 
            else
                fontType = "fontCommon.TTF"
            end
            local openMes = cc.ui.UILabel.new({
                UILabelType = 2,
                font = fontType,
                text = kkFunc.getVersionText("图鉴开启炮塔",LevelsData.getRealLevel(TowerMes[i].openLevel)),--"第"..LevelsData.getRealLevel(TowerMes[i].openLevel).."关开启",
                size = 22,
                color = cc.c3b(255,254,227),
                x = mesBg:getContentSize().width/2,
                y = mesBg:getContentSize().height/2,
                }):align(display.CENTER)
            mesBg:addChild(openMes)
            openMes:setScale(0.75)
        end
    end
end

function Handbook:getScrollView(contentLayer)
    self.scrollView = cc.ui.UIScrollView.new({})   
    self.scrollView:setTouchSwallowEnabled(false)
    local function scrollView1DidScroll(event)
    end
    local function scrollView1DidZoom()
    end
    if nil ~= self.scrollView then
        local scrollSize = contentLayer:getBoundingBox()
        scrollSize.width = 836
        scrollSize.height = 465
        self.scrollView:setViewRect(scrollSize)
        self.scrollView:setPosition(cc.p(29,10))
        self.scrollView:setScale(1.0)
        self.scrollView:setAnchorPoint(cc.p(0,0))
        self.scrollView:addScrollNode(contentLayer)
        self.scrollView:setDirection(2)
        self.scrollView:setBounceable(true)
        self.scrollView:onScroll(scrollView1DidScroll)
    end
    self.towerSelectBg:addChild(self.scrollView,1)
end
function Handbook:onTouch(event, x, y)
    if event == "began" then
        return true
    elseif event == "moved" then
        --左右箭头
        --if self.scrollView:isVisible() then
        if self.contentLayer:getPositionX() <= -10 and self.contentLayer:getPositionX() > -660 then
            self.handbookLeft:setVisible(true)
            self.handbookRight:setVisible(true)
        elseif self.contentLayer:getPositionX() <= -660 then
            self.handbookRight:setVisible(false)
        elseif self.contentLayer:getPositionX() > -10 then 
            self.handbookLeft:setVisible(false)   
        end
        --end
    elseif event == "ended" then
    end
end

function Handbook:onEnter()
    --安卓返回键

        --厦门返回键
    if device.platform == "android" then
        local layer = display.newLayer()
        layer:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
            if event.key == "back" then
                if g_infoLayer.poplayer ~=nil then
                    g_infoLayer:RemovePop()
                elseif g_infoLayer.shopLayer ~= nil then
                    g_infoLayer.shopLayer:Remove()
                else
                    app:level()
                end
            end
        end)
        self:addChild(layer)
        layer:setTouchSwallowEnabled(false)
        layer:setKeypadEnabled(true)
    end
         --厦门返回键
         
    -- 注册touch事件处理函数
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)
end

function Handbook:onExit()
    ResData.removeRes("UI_HANDBOOK")
end
return Handbook