--
-- Author: KK
-- Date: 2014-11-06 15:29:13
--
--英雄养成

local NewbieGuideLayer = import("..views.NewbieGuideLayer")
local LevelInfoLayer = import(".LevelInfoLayer")
local HeroHouse = class("HeroHouse", function()
    return display.newScene("HeroHouse")
end)

function HeroHouse:ctor()
    --display.newColorLayer(cc.c4b(140,100,100,255))
        --:addTo(self,-1)
    local herohouseBg = display.newSprite("pic/heroHouseBg.png",display.cx,display.cy)
    self:addChild(herohouseBg)
    --触摸层
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,18)
    --体力萝卜钻石
    self.infoLayer = LevelInfoLayer.new(3)
    self:addChild(self.infoLayer,20)
	--返回按钮
    self.returnLayerControl = 1
    
    self.menu = cc.ui.UIPushButton.new({
        normal = "#returnNew.png",
        pressed = "#returnNew.png",
        disabled = "#returnNew.png",
        })
        :onButtonPressed(function()
            self.menu:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.menu:setScale(1)
        end)
        :onButtonClicked(function(event)
            self:ReturnBack()
        end)
        :pos(display.cx-380, display.height-50)
        :addTo(self,1)
    if self.scrollView == nil then
    	self:showSelectHero()
        self:getScrollView(self.heroSelectBg)
        self:showStarAndParticle()
    end      
end

function HeroHouse:ReturnBack()
    if self.returnLayerControl == 1 then
        app:level()
    else
        self.returnLayerControl = 1
        self.nextScene = false
        if self.skillTextBg ~= nil then
            self.skillTextBg:removeFromParent()
            self.skillTextBg = nil
        end
        self.bg:removeFromParent()
        self.bg = nil
        self:unscheduleUpdate()
        self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
        --[[if self.state == "left" then
            self.leftMove:setVisible(true)
        elseif self.state == "right" then
            self.rightMove:setVisible(true)
        end]]
        self.hero = nil--海外版延迟到账时，当self.hero与所升级英雄对应则调用LevelFull()否则只存档
        for i=1,4 do
            self:showNodeMes(i)
        end
        --self:showNodeMes(self.hero)
        self.scrollView:setVisible(true)
        self.titleBg:setVisible(true)
        self.herohouseWhiteBg:setVisible(true)
        self.scrollView:setTouchCaptureEnabled(true)
        --self.touchLayer:setTouchEnabled(true)
    end
end

function HeroHouse:showStarAndParticle()
    local moveStarX = {
        [1] = display.cx,
        [2] = display.width+100,
        [3] = display.width+100,
    }
    local moveStarY = {
        [1] = display.height+80,
        [2] = display.height/3,
        [3] = display.height*2/3,
    }
    --local emitter = {}
    for i =1,3 do
        self:performWithDelay(function()
            local movestarhead = display.newSprite("#moveStarHead.png",moveStarX[i],moveStarY[i])
            local rt = kkFunc.getLineRotation(cc.p(moveStarX[i]-display.width-50,moveStarY[i]-display.cy),cc.p(moveStarX[i],moveStarY[i]))
            movestarhead:setRotation(rt)
            self:addChild(movestarhead)
            local emitter = cc.ParticleSystemQuad:create("particle/lizi02.plist")
            emitter:setStartColor({ r = 1, g = 1, b = 1, a = 1 })
            emitter:setEndColor({ r = 1, g = 1, b = 1, a = 1 })
            emitter:setBlendAdditive(true)
            --emitter[i]:setPosition(moveStarX[i],moveStarY[i])
            emitter:setPosition(15,15)
            emitter:setEmissionRate(30)
            emitter:setStartSize(10)
            movestarhead:addChild(emitter)
            movestarhead:runAction(cc.RepeatForever:create(
                transition.sequence({
                    cc.MoveBy:create(2.5,cc.p(-display.width-50,-display.cy)),
                    cc.CallFunc:create(function()
                        --emitter[i]:removeFromParent()
                        --movestarhead:removeFromParent()
                        movestarhead:setPosition(moveStarX[i],moveStarY[i])
                    end),
                    cc.DelayTime:create(math.random(3,8)),
                })
            ))
                
        end, 0.5*(i-1))    
    end
    local herohouseStar = {}
    for i = 1, 12 do
        herohouseStar[i] = display.newSprite("#heroHouseStar.png")
        self:addChild(herohouseStar[i])
        if i == 1 then
            herohouseStar[i]:setPosition(math.random(10,display.cx-self.titleBg:getContentSize().width/2),math.random(display.cy,display.cy+100))
        elseif i == 10 then
            herohouseStar[i]:setPosition(math.random(display.cx+self.titleBg:getContentSize().width/2,display.width-10),math.random(display.cy,display.cy+100))
        elseif i == 2 or i == 3 or i == 4 then
            herohouseStar[i]:setPosition(math.random(0,display.width/3),math.random(self.titleBg:getPositionY()+20,display.height))
        elseif i == 5 or i == 6 or i == 7 then
            herohouseStar[i]:setPosition(math.random(display.width/3+50,display.width*2/3),math.random(self.titleBg:getPositionY()+20,display.height))
        elseif i == 8 or i == 9 then
            herohouseStar[i]:setPosition(math.random(display.width*2/3+50,display.width),math.random(self.titleBg:getPositionY()+20,display.height))
        elseif i == 11 or i == 12 then
            herohouseStar[i]:setPosition(math.random(100,display.width/3),math.random(self.titleBg:getPositionY()+20,self.titleBg:getPositionY()+70))
        end
        herohouseStar[i]:setScale(0.1*math.random(1,3))
        herohouseStar[i]:runAction(cc.RepeatForever:create(
            transition.sequence({
                cc.DelayTime:create(0.1*math.random(5,20)),
                cc.ScaleTo:create(0.3,0),
                --cc.DelayTime:create(0.1*math.random(5,30)),
                cc.ScaleTo:create(0.3,0.1*math.random(1,3))
            })
        ))
    end
end
function HeroHouse:showSelectHero()
    if NEW_GUIDE and GameData.guide.level1 == true and GameData.guide.herohouse == false then
        GameData.selectHero = 0
    end
    self.herohouseNode = display.newNode()
    self:addChild(self.herohouseNode,2)
    self.herohouseWhiteBg = display.newScale9Sprite("#herohouseBg.png", display.cx, display.cy - 55,cc.size(850,500))
    self.herohouseNode:addChild(self.herohouseWhiteBg)
    local herohouseBgLightPointLeft = display.newSprite("#herohouseBgLightPoint.png",15,15)
    self.herohouseWhiteBg:addChild(herohouseBgLightPointLeft)
    local herohouseBgLightPointRight = display.newSprite("#herohouseBgLightPoint.png",842,18)
    self.herohouseWhiteBg:addChild(herohouseBgLightPointRight)
    self.titleBg = display.newSprite("#titleBg.png",423,515)
    self.herohouseWhiteBg:addChild(self.titleBg)
    local title = display.newSprite("#herohousetitle.png",self.titleBg:getContentSize().width/2,self.titleBg:getContentSize().height/2-9)
    self.titleBg:addChild(title)
    self.heroSelectBg = cc.LayerColor:create(cc.c4b(0,0,0,0),430,display.height)--display.newLayer()
    --self.heroSelectBg:setContentSize(cc.size(450,display.height))
    self.heroBg = {}
    self.war = {}
    self.heroMoney = {}
    self.buyheroControl = {}
    self.warControl = {}
    self.heroNode = {}
    for i = 1, 4 do
        self.buyheroControl[i] = true
        if GameData.selectHero == i then
            self.heroBg[i] = display.newScale9Sprite("#hero_haswarBg.png",display.cx+(i-2.5)*205-(display.cx-411),display.cy-40,cc.size(213, 450))
        else
            self.heroBg[i] = display.newScale9Sprite("#hero_bg.png",display.cx+(i-2.5)*205-(display.cx-411),display.cy-40,cc.size(213, 450))
        end        
        self.heroSelectBg:addChild(self.heroBg[i],-1)
        --nodeMes
        self:showNodeMes(i)        
        --
        if GameData.heros["h"..i].level ~= 0 then 
            local wartext = "" 
            if GameData.selectHero == i then 
                if not VERSION_REDUCE then
                    if GameData.heros["h"..i].level ~= HeroData[i].maxLevel then
                        wartext = "#hero_haswar.png" 
                    else
                        wartext = "#heroMaxLevel.png"
                    end
                else
                    wartext = "#hero_haswar.png"
                end               
                -- wartext = "#hero_haswar.png"
                self.warControl[i] = false
                if VERSION_REDUCE then
                    self.selected = display.newSprite("#selected.png",180,415)
                    self.heroBg[i]:addChild(self.selected,5)
                else
                    self.selected = display.newSprite("#selected.png",160,425)
                    self.heroBg[i]:addChild(self.selected,5)
                end
            else
                self.warControl[i] = true
                wartext = "#hero_war.png"
            end
            self.war[i] = cc.ui.UIPushButton.new({
                    normal = wartext,
                    disabled = wartext,
                    pressed = wartext,
                })
                :onButtonClicked(function(event)
                    if self.warControl[i] == true then
                        self.heroBg[i]:setSpriteFrame(display.newSpriteFrame("hero_haswarBg.png"))
                        if self.selected ~= nil then
                            self.selected:removeFromParent()
                        end
                        if VERSION_REDUCE then
                            self.selected = display.newSprite("#selected.png",180,415)
                            self.heroBg[i]:addChild(self.selected)
                        else
                            self.selected = display.newSprite("#selected.png",160,425)
                            self.heroBg[i]:addChild(self.selected,5)
                        end
                        if not VERSION_REDUCE then
                            if  GameData.heros["h"..i].level == HeroData[i].maxLevel then
                                self.war[i]:setButtonImage("normal", "#heroMaxLevel.png")
                                self.war[i]:setButtonImage("disabled", "#heroMaxLevel.png")
                                self.war[i]:setButtonImage("pressed", "#heroMaxLevel.png")
                            else
                                self.war[i]:setButtonImage("normal", "#hero_haswar.png")
                                self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
                                self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
                            end
                        else
                            self.war[i]:setButtonImage("normal", "#hero_haswar.png")
                            self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
                            self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
                        end
                        -- self.war[i]:setButtonImage("normal", "#hero_haswar.png")
                        -- self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
                        -- self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
                        self.warControl[i] = false
                        if GameData.selectHero ~= 0 then
                            self.heroBg[GameData.selectHero]:setSpriteFrame(display.newSpriteFrame("hero_bg.png"))
                            self.warControl[GameData.selectHero] = true
                            self.war[GameData.selectHero]:setButtonImage("normal", "#hero_war.png")
                            self.war[GameData.selectHero]:setButtonImage("disabled", "#hero_war.png")
                            self.war[GameData.selectHero]:setButtonImage("pressed", "#hero_war.png")
                        end
                        local temp = GameData.selectHero
                        GameData.selectHero = i
                        if temp ~= 0 then 
                            self:showNodeMes(temp)
                        end
                        self:showNodeMes(GameData.selectHero)
                        GameState.save(GameData) 
                        if not VERSION_REDUCE then
                            if self.cuePoint ~= nil then
                                self.cuePoint:removeFromParent()
                                self.cuePoint = nil
                            end
                            if GameData.carrot >= ExcelHeroData[i][GameData.heros["h"..GameData.selectHero].level].money or GameData.skillPoints.value >= 5 then --bbbbbb
                                if GameData.heros["h"..i].level ~= HeroData[i].maxLevel then
                                    self.cuePoint = display.newSprite("#achievementTipPoint.png",58,22)
                                    self.cuePoint:setScale(0.7)
                                    self.war[GameData.selectHero]:addChild(self.cuePoint)
                                end
                            end
                        end
                        if NEW_GUIDE and GameData.guide.level1 == true and GameData.guide.herohouse == false then
                            self.newbieguidelayer:goHeroHouse(5)
                        end   
                    end
                end)
                :pos(self.heroBg[i]:getPositionX(),display.cy-248)
                :addTo(self.heroSelectBg)
                if not VERSION_REDUCE then
                    if GameData.heros["h"..i].level ~= HeroData[i].maxLevel and GameData.selectHero == i then
                        if self.cuePoint ~= nil then
                            self.cuePoint:removeFromParent()
                            self.cuePoint = nil
                        end
                        if GameData.carrot >= ExcelHeroData[i][GameData.heros["h"..i].level].money or GameData.skillPoints.value >= 5 then --bbbbbb
                            self.cuePoint = display.newSprite("#achievementTipPoint.png",58,22)
                            self.cuePoint:setScale(0.7)
                            self.war[i]:addChild(self.cuePoint)
                        end 
                    end
                end 
        else
            --pcmoney
            local buyButtonPic = "#buttonGet.png"
            if VERSION_REDUCE then
                buyButtonPic = "#buttonGetHero.png"
            else
            end
            self.war[i] = cc.ui.UIPushButton.new({
                    normal = buyButtonPic,
                    disabled = buyButtonPic,
                    pressed = buyButtonPic,
                })
                :onButtonClicked(function()                    
                    if self.buyheroControl[i] == true then
                        if i == 2 then
                            if GameData.diamond >= HeroData[i].money then
                                --self:popPurchaseHeroLayer(i,1)--之前弹出框方法暂时屏蔽掉
                                ---------------------------------去掉购买英雄弹出框
                                GameData.diamond = GameData.diamond - HeroData[i].money
                                g_infoLayer.diamondLabel:setString(""..GameData.diamond)
                                self:BuyHeroButtonMethod(i)
                                AchievementData.checkHero()
                                AchievementData.checkDiamond(HeroData[i].money)
                                --removeMoney
                                if self.heroMoney[i] ~= nil then
                                    self.heroMoney[i]:removeFromParent()
                                    self.heroMoney[i] = nil
                                end
                                ---------------------------------
                            else
                                if VERSION_REDUCE then
                                    g_infoLayer:popLayer("钻石")
                                else
										--厦门萝莉安妮计费点
                                        g_infoLayer:popLayer("钻石")
                                    -- if kkFunc.simplifyPurchaseSwitch() then
                                    --     kkFunc.simplifyPurchaseSdkCallBack(5)										
                                    -- else
                                    --     g_infoLayer:popLayer("钻石")
                                    -- end
										--厦门萝莉安妮计费点
                                end  
                            end
                        else
                            --self:popPurchaseHeroLayer(i,1)--之前弹出框方法暂时屏蔽掉
                            ---------------------------------去掉购买英雄弹出框
                            local function paycallback(result)
                                if result == "success" then
                                    self:paySuccessCallback(i,1)
                                    --[[self:BuyHeroButtonMethod(i)
                                    AchievementData.checkHero()
                                    --removeMoney
                                    if self.heroMoney[i] ~= nil then
                                        self.heroMoney[i]:removeFromParent()
                                        self.heroMoney[i] = nil
                                    end
                                    --DataEye
                                    if device.platform == "android" or device.platform == "ios" then
                                        --DCCoin.gain("玩家付费", "CNY", HeroData[i].money, HeroData[i].money)
                                        --DCCoin.lost("获得英雄希维尔", "CNY", HeroData[i].money, 0)
                                        DCVirtualCurrency.paymentSuccess("","获得英雄希维尔",HeroData[i].money,"CNY",CHANLE_NAME)
                                    end
                                    kkFunc.popPaySuccessLayer()]]
                                end          
                            end
                            --购买希维尔计费点为1，提莫为2
                            --[[if TEST_DEMO then
                                paycallback("success")
                            else
                                kkFunc.Pay(i-2,paycallback)
                            end]]
                            if VERSION_REDUCE then
                                if TEST_DEMO then
                                    paycallback("success")
                                else
                                    kkFunc.Pay(i-2,paycallback)
                                end
                            else
									--厦门希维尔和提莫计费点
                                if TEST_DEMO then
                                    paycallback("success")
                                else
                                    --kkFunc.Pay(5+i,paycallback)
                                    kkFunc.xmPay(i+1)
                                end
									--厦门希维尔和提莫计费点
                            end
                            ---------------------------------
                        end             
                    else
                        if self.warControl[i] == true then
                            self.heroBg[i]:setSpriteFrame(display.newSpriteFrame("hero_haswarBg.png"))
                            if self.selected ~= nil then
                                self.selected:removeFromParent()
                            end
                            if VERSION_REDUCE then
                                self.selected = display.newSprite("#selected.png",180,415)
                                self.heroBg[i]:addChild(self.selected)
                            end
                            if not VERSION_REDUCE then
                                self.selected = display.newSprite("#selected.png",160,425)
                                self.heroBg[i]:addChild(self.selected)
                                if GameData.heros["h"..i].level ~= HeroData[i].maxLevel then
                                    self.war[i]:setButtonImage("normal", "#hero_haswar.png")
                                    self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
                                    self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
                                else
                                    self.war[i]:setButtonImage("normal", "#heroMaxLevel.png")
                                    self.war[i]:setButtonImage("disabled", "#heroMaxLevel.png")
                                    self.war[i]:setButtonImage("pressed", "#heroMaxLevel.png")
                                end
                            else
                                self.war[i]:setButtonImage("normal", "#hero_haswar.png")
                                self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
                                self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
                            end
                            self.warControl[i] = false
                            if GameData.selectHero ~= 0 then
                                self.heroBg[GameData.selectHero]:setSpriteFrame(display.newSpriteFrame("hero_bg.png"))
                                self.warControl[GameData.selectHero] = true
                                self.war[GameData.selectHero]:setButtonImage("normal", "#hero_war.png")
                                self.war[GameData.selectHero]:setButtonImage("disabled", "#hero_war.png")
                                self.war[GameData.selectHero]:setButtonImage("pressed", "#hero_war.png")
                            end
                            local temp = GameData.selectHero
                            GameData.selectHero = i 
                            if temp ~= 0 then 
                                self:showNodeMes(temp)
                            end
                            if not VERSION_REDUCE then  
                                --[[for j = 1 ,4 do
                                    if GameData.heros["h"..j].level == HeroData[j].maxLevel and GameData.selectHero == j then
                                        self.war[j]:setButtonImage("normal", "#heroMaxLevel.png")
                                        self.war[j]:setButtonImage("disabled", "#heroMaxLevel.png")
                                        self.war[j]:setButtonImage("pressed", "#heroMaxLevel.png")
                                    end
                                end  ]]
                                if self.cuePoint ~= nil then
                                    self.cuePoint:removeFromParent()
                                    self.cuePoint = nil
                                end
                                if GameData.carrot >= ExcelHeroData[i][GameData.heros["h"..GameData.selectHero].level].money or GameData.skillPoints.value >= 5 then --bbbbbb
                                    if GameData.heros["h"..i].level ~= HeroData[i].maxLevel then
                                        self.cuePoint = display.newSprite("#achievementTipPoint.png",58,22)
                                        self.cuePoint:setScale(0.7)
                                        self.war[GameData.selectHero]:addChild(self.cuePoint)
                                    end
                                end 
                            end
                            self:showNodeMes(GameData.selectHero)                   
                        end
                    end
                    GameState.save(GameData) 
                    
                end)
                :pos(self.heroBg[i]:getPositionX(),display.cy-248)
                :addTo(self.heroSelectBg)
            -- --heroMoneyShow
            if VERSION_REDUCE then
                if i == 3 or i == 4 then             
                    local money = {
                        [1] = 0.99,
                        [2] = 1.59,
                    }
                    self.heroMoney[i] = cc.ui.UILabel.new({
                        UILabelType = 2,
                        text = money[i-2].."$",
                        size = 25,
                        font = "fontEasy.ttf",
                        color = cc.c3b(255,255,255),
                        x = -25,
                        y = 0,
                        }):align(display.CENTER)     
                else
                    self.heroMoney[i] = display.newSprite("#heroMoney"..i..".png",-32,3)
                    self.heroMoney[i]:setScale(1.0)
                end
                self.war[i]:addChild(self.heroMoney[i]) 
            end
        end
    end    
end
function HeroHouse:popPurchaseHeroLayer(hero,page,label)
    self.poplayer = display.newLayer()
    self:addChild(self.poplayer,22)
    self.poplayer:setTouchSwallowEnabled(true)
    local layercolor = cc.LayerColor:create(cc.c4b(0,0,0,128),display.width,display.height)
    self.poplayer:addChild(layercolor,-1)
    local popBg = display.newSprite("#poplayer.png",display.cx,display.cy)
    self.poplayer:addChild(popBg)
    local fontSize = 28
    if VERSION_REDUCE then
        fontSize = 24
    end
    local title
    if VERSION_REDUCE then
        title = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionHeroMesText("购买英雄标题"),
            size = 28,
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = 182,
            y = 239,
            }):align(display.CENTER)
    else
        title = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionHeroMesText("购买英雄标题"),
            size = 28,
            color = cc.c3b(255,255,255),
            x = 182,
            y = 239,
            }):align(display.CENTER)
    end
    -- local title = cc.ui.UILabel.new({
    --     text = kkFunc.getVersionHeroMesText("购买英雄标题"),
    --     size = 28,
    --     color = cc.c3b(255,255,255),
    --     x = 182,
    --     y = 239,
    --     }):align(display.CENTER)
    popBg:addChild(title)
    local textMess
    if VERSION_REDUCE then
        textMess = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionHeroMesText("购买英雄"),
            size = fontSize,
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = 45,
            y = 190,
            }):align(display.LEFT_TOP)
    else
        textMess = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionHeroMesText("购买英雄"),
            size = fontSize,
            color = cc.c3b(255,255,255),
            x = 182,
            y = 150,
            }):align(display.CENTER)
    end
    -- local textMess = cc.ui.UILabel.new({
    --     text = kkFunc.getVersionHeroMesText("购买英雄"),
    --     size = fontSize,
    --     color = cc.c3b(255,255,255),
    --     x = 182,
    --     y = 150,
    --     }):align(display.CENTER)
    popBg:addChild(textMess)
    self.sure = cc.ui.UIPushButton.new({
        normal = "#poplayerSure.png",
        disabled = "#poplayerSure.png",
        pressed = "#poplayerSure.png",
        })
        :onButtonPressed(function()
            self.sure:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(1)
        end)
        :onButtonClicked(function()
            if page == 1 then
                if hero == 2 then
                    GameData.diamond = GameData.diamond - HeroData[hero].money
                    g_infoLayer.diamondLabel:setString(""..GameData.diamond)
                    self:BuyHeroButtonMethod(hero)
                    AchievementData.checkHero()
                    AchievementData.checkDiamond(HeroData[hero].money)
                    self.poplayer:removeFromParent()
                    --removeMoney
                    if self.heroMoney[hero] ~= nil then
                        self.heroMoney[hero]:removeFromParent()
                        self.heroMoney[hero] = nil
                    end
                else
                    local function paycallback(result)
                        if result == "success" then
                            self:BuyHeroButtonMethod(hero)
                            AchievementData.checkHero()
                            self.poplayer:removeFromParent()
                            --removeMoney
                            if self.heroMoney[hero] ~= nil then
                                self.heroMoney[hero]:removeFromParent()
                                self.heroMoney[hero] = nil
                            end
                            --DataEye
                                 --厦门
                            -- if device.platform == "android" or device.platform == "ios" then
                            --     --DCCoin.gain("玩家付费", "CNY", HeroData[hero].money, HeroData[hero].money)
                            --     --DCCoin.lost("获得英雄希维尔", "CNY", HeroData[hero].money, 0)
                            --     DCVirtualCurrency.paymentSuccess("","获得英雄希维尔",HeroData[hero].money,"CNY",CHANLE_NAME)
                            -- end
                                 --厦门
                            kkFunc.popPaySuccessLayer()
                        end
                    end
                    --购买希维尔计费点为1，提莫为2
                    --[[if TEST_DEMO then
                        paycallback("success")
                    else
                        kkFunc.Pay(hero-2,paycallback)
                    end]]
                    if VERSION_REDUCE then
                        if TEST_DEMO then
                            paycallback("success")
                        else
                            kkFunc.Pay(hero-2,paycallback)
                        end
                    else
							--厦门计费点
                        if TEST_DEMO then
                            --paycallback("success")
                        else
                            --kkFunc.Pay(5+hero,paycallback)
                        end
							--厦门计费点
                    end
                end
            elseif page == 2 then
                if hero == 2 then
                    GameData.diamond = GameData.diamond - HeroData[hero].money
                    g_infoLayer.diamondLabel:setString(""..GameData.diamond)            
                    GameData.heros["h"..hero].level = 1
                    self.war[hero]:setButtonImage("normal", "#hero_war.png")
                    self.war[hero]:setButtonImage("disabled", "#hero_war.png")
                    self.war[hero]:setButtonImage("pressed", "#hero_war.png")
                    self.purchaseHero:setButtonImage("normal", "#skillUpgradeButton.png")
                    self.purchaseHero:setButtonImage("disabled", "#skillUpgradeButton.png")
                    self.purchaseHero:setButtonImage("pressed", "#skillUpgradeButton.png")
                    label:setVisible(true)
                    label:setString(""..ExcelHeroData[hero][GameData.heros["h"..hero].level].money)
                    for j=1,#HeroData[hero].skill do
                        if GameData.heros["h"..hero].level >= SkillData[HeroData[hero].skill[j]].heroLevel then
                            GameData.heros["h"..hero].skill["s"..j] = 1
                        end
                    end
                    self:refreshSkillBar(hero)
                    self:refreshSkillPointLabel(hero)     
                    self.purchaseControl = false
                    AchievementData.checkHero()
                    AchievementData.checkDiamond(HeroData[hero].money)
                    self:BuyHeroButtonMethod(hero)
                    GameState.save(GameData)
                    self.poplayer:removeFromParent()
                    --位置改变,增加12元购买按钮
                    self.purchaseHero:setPosition(740,70)
                    self:EightPurchaseButton(hero)
                    --removeMoney
                    if VERSION_REDUCE then
                        if self.heroMoneyTwo[hero] ~= nil then
                            self.heroMoneyTwo[hero]:removeFromParent()
                            self.heroMoneyTwo[hero] = nil
                        end
                        if self.heroMoney[hero] ~= nil then
                            self.heroMoney[hero]:removeFromParent()
                            self.heroMoney[hero] = nil
                        end
                    end
                else
                    local function paycallback(result)
                        if result == "success" then
                            GameData.heros["h"..hero].level = 1
                            self.war[hero]:setButtonImage("normal", "#hero_war.png")
                            self.war[hero]:setButtonImage("disabled", "#hero_war.png")
                            self.war[hero]:setButtonImage("pressed", "#hero_war.png")
                            self.purchaseHero:setButtonImage("normal", "#skillUpgradeButton.png")
                            self.purchaseHero:setButtonImage("disabled", "#skillUpgradeButton.png")
                            self.purchaseHero:setButtonImage("pressed", "#skillUpgradeButton.png")
                            label:setVisible(true)
                            label:setString(""..ExcelHeroData[hero][GameData.heros["h"..hero].level].money)
                            for j=1,#HeroData[hero].skill do
                                if GameData.heros["h"..hero].level >= SkillData[HeroData[hero].skill[j]].heroLevel then
                                    GameData.heros["h"..hero].skill["s"..j] = 1
                                end
                            end
                            self:refreshSkillBar(hero)
                            self:refreshSkillPointLabel(hero)     
                            self.purchaseControl = false
                            AchievementData.checkHero()
                            self:BuyHeroButtonMethod(hero)
                            GameState.save(GameData)
                            self.poplayer:removeFromParent()
                            --位置改变,增加12元购买按钮
                            self.purchaseHero:setPosition(740,70)
                            self:EightPurchaseButton(hero)
                            --removeMoney
                            if VERSION_REDUCE then
                                if self.heroMoneyTwo[hero] ~= nil then
                                    self.heroMoneyTwo[hero]:removeFromParent()
                                    self.heroMoneyTwo[hero] = nil
                                end
                                if self.heroMoney[hero] ~= nil then
                                    self.heroMoney[hero]:removeFromParent()
                                    self.heroMoney[hero] = nil
                                end
                            end
                            --DataEye
                                 --厦门
                            -- if device.platform == "android" or device.platform == "ios" then
                            --     --DCCoin.gain("玩家付费", "CNY", HeroData[hero].money, HeroData[hero].money)
                            --     --DCCoin.lost("获得英雄希维尔", "CNY", HeroData[hero].money, 0)
                            --     DCVirtualCurrency.paymentSuccess("","获得英雄希维尔",HeroData[hero].money,"CNY",CHANLE_NAME)
                            -- end
                                 --厦门
                            kkFunc.popPaySuccessLayer()
                        end
                    end
                    --[[if TEST_DEMO then
                        paycallback("success")
                    else
                        kkFunc.Pay(hero-2,paycallback)
                    end]] 
                    if VERSION_REDUCE then
                        if TEST_DEMO then
                            paycallback("success")
                        else
                            kkFunc.Pay(hero-2,paycallback)
                        end
                    else
							--厦门计费点
                        if TEST_DEMO then
                            --paycallback("success")
                        else
                            --kkFunc.Pay(5+hero,paycallback)
                        end
							--厦门计费点
                    end                                    
                end        
            end                        
        end)
        :pos(275, 55)
        :addTo(popBg)
    self.cancle = cc.ui.UIPushButton.new({
        normal = "#poplayerCancle.png",
        disabled = "#poplayerCancle.png",
        pressed = "#poplayerCancle.png",
        })
        :onButtonPressed(function()
            self.cancle:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.cancle:setScale(1)
        end)
        :onButtonClicked(function()
            self.poplayer:removeFromParent()
        end)
        :pos(90, 55)
        :addTo(popBg)
end
function HeroHouse:addParticle()
    --粒子效果
    --[[local emitter1 = cc.ParticleSystemQuad:create("particle/lizi01.plist")
    emitter1:setStartColor({ r = 200/255, g = 0, b = 1, a = 1.0 })
    emitter1:setEndColor({ r = 180/255, g = 0, b = 1, a = 1.0 })
    emitter1:setStartSize(10)
    emitter1:setPosition(cc.p(60,70))
    emitter1:setEmissionRate(18)
    self.heroNode[2]:addChild(emitter1)
    local emitter2 = cc.ParticleSystemQuad:create("particle/lizi02.plist")
    emitter2:setBlendAdditive(true)
    emitter2:setPosition(cc.p(-78,-45))
    emitter2:setEmissionRate(33)
    self.heroNode[2]:addChild(emitter2)
    local emitter3 = cc.ParticleSystemQuad:create("particle/denglong.plist")
    emitter3:setBlendAdditive(true)
    emitter3:setPosition(cc.p(55,-15))
    emitter3:setEmissionRate(5)
    self.heroNode[3]:addChild(emitter3)]]
    local emitter4 = cc.ParticleSystemQuad:create("particle/yinyueshi.plist")
    emitter4:setBlendAdditive(true)
    emitter4:setPosition(cc.p(10,-60))
    emitter4:setEmissionRate(33)
    self.heroNode[1]:addChild(emitter4)
end
function HeroHouse:BuyHeroButtonMethod(i)
    self.heroBg[i]:setSpriteFrame(display.newSpriteFrame("hero_haswarBg.png"))
    if self.selected ~= nil then
        self.selected:removeFromParent()
    end
    if VERSION_REDUCE then
        self.selected = display.newSprite("#selected.png",180,415)
        self.heroBg[i]:addChild(self.selected)
    end
    if not VERSION_REDUCE then
        self.selected = display.newSprite("#selected.png",160,425)
        self.heroBg[i]:addChild(self.selected)
        if GameData.heros["h"..i].level ~= HeroData[i].maxLevel then
            self.war[i]:setButtonImage("normal", "#hero_haswar.png")
            self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
            self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
        else
            self.war[i]:setButtonImage("normal", "#heroMaxLevel.png")
            self.war[i]:setButtonImage("disabled", "#heroMaxLevel.png")
            self.war[i]:setButtonImage("pressed", "#heroMaxLevel.png")
        end
    else
        self.war[i]:setButtonImage("normal", "#hero_haswar.png")
        self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
        self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
    end
    -- self.war[i]:setButtonImage("normal", "#hero_haswar.png")
    -- self.war[i]:setButtonImage("disabled", "#hero_haswar.png")
    -- self.war[i]:setButtonImage("pressed", "#hero_haswar.png")
    self.warControl[i] = false
    if GameData.selectHero ~= 0 then
        self.heroBg[GameData.selectHero]:setSpriteFrame(display.newSpriteFrame("hero_bg.png"))
        self.warControl[GameData.selectHero] = true
        self.war[GameData.selectHero]:setButtonImage("normal", "#hero_war.png")
        self.war[GameData.selectHero]:setButtonImage("disabled", "#hero_war.png")
        self.war[GameData.selectHero]:setButtonImage("pressed", "#hero_war.png")
    end
    GameData.heros["h"..i].level = 1
    local temp = GameData.selectHero
    GameData.selectHero = i 
    if temp ~= 0 then 
        self:showNodeMes(temp)
    end
    self:showNodeMes(GameData.selectHero)
    for j=1,#HeroData[i].skill do
        if GameData.heros["h"..i].level >= SkillData[HeroData[i].skill[j]].heroLevel then
            GameData.heros["h"..i].skill["s"..j] = 1
        end
    end    
    if not VERSION_REDUCE then  
        --[[for j = 1 ,4 do
            if GameData.heros["h"..j].level == HeroData[j].maxLevel and GameData.selectHero == j then
                self.war[j]:setButtonImage("normal", "#hero_haswar.png")
                self.war[j]:setButtonImage("disabled", "#hero_haswar.png")
                self.war[j]:setButtonImage("pressed", "#hero_haswar.png")
            end
        end ]]
        if self.cuePoint ~= nil then
            self.cuePoint:removeFromParent()
            self.cuePoint = nil
        end  
        if GameData.carrot >= ExcelHeroData[i][GameData.heros["h"..GameData.selectHero].level].money or GameData.skillPoints.value >= 5 then --bbbbbb
            self.cuePoint = display.newSprite("#achievementTipPoint.png",58,22)
            self.cuePoint:setScale(0.7)
            self.war[GameData.selectHero]:addChild(self.cuePoint)
        end
    end 
    self.buyheroControl[i] = false
end
function HeroHouse:showNodeMes(idx)
    if self.heroNode[idx] ~= nil then
        self.heroNode[idx]:removeFromParent()
        self.heroNode[idx] = nil
    end
    --print("gg",GameData.heros["h"..idx].level,self.heroMoney[idx])
    --[[if GameData.heros["h"..idx].level ~= 0 then
        if self.heroMoney[idx] ~= nil then
            self.heroMoney[idx]:removeFromParent()
            self.heroMoney[idx] = nil
        end
    end]]
    self.heroNode[idx] = display.newNode()
    self.heroNode[idx]:setPosition(self.heroBg[idx]:getPositionX(),display.cy-40)
    self.heroSelectBg:addChild(self.heroNode[idx])
    self.heroNode[idx].label1 = cc.c3b(17,162,211)
    self.heroNode[idx].label2 = cc.c3b(17,115,211)
    if idx == GameData.selectHero then
        self.heroNode[idx].label1 = cc.c3b(175,105,52)
        self.heroNode[idx].label2 = cc.c3b(175,105,52) 
    end
    local nameMes,heroName
    if VERSION_REDUCE then
        nameMes = {
            [1] = "#gailun.png",
            [2] = "#anni.png",
            [3] = "#xiweier.png",
            [4] = "#timo.png",
        }
        heroName = display.newSprite(nameMes[idx],2,173) 
    else
        nameMes = {
            [1] = "英雄盖伦",
            [2] = "萝莉安妮",
            [3] = "女神希维尔",
            [4] = "法师提莫",
        }
        heroName = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",    
                text = nameMes[idx],
                size = 20,
                color = cc.c3b(255,255,255),
                x = 2,
                y = 173,
            }):align(display.CENTER)
    end
    self.heroNode[idx]:addChild(heroName)
    --heroName:setColor(self.heroNode[idx].label1)
    local heroRole = display.newSprite("#hero"..idx.."_1.png",0,30)
    self.heroNode[idx]:addChild(heroRole)
    heroRole:setScale(1.2)
    local animation = display.getAnimationCache("ui_hero"..idx)
    heroRole:playAnimationForever(animation)
    if idx == 1 then
        heroRole:setPosition(15,20)
    elseif idx == 3 then
        heroRole:setPosition(0,10)
    elseif idx == 4 then
        heroRole:setPosition(-5,25)
        heroRole:setScale(1.05)
    end
    if VERSION_REDUCE then
        if idx == GameData.selectHero then
            heroTextEnglish = HeroData[idx].textEnglish2
        else
            heroTextEnglish = HeroData[idx].textEnglish1
        end
        local heroIntro = display.newSprite(heroTextEnglish,-3,-125)
        self.heroNode[idx]:addChild(heroIntro)
    else
        local heroIntro = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionHeroMesText("英雄简介",idx),
            size = 18,
            color = self.heroNode[idx].label2,
            x = -83,
            y = -90,
            }):align(display.LEFT_TOP)
        self.heroNode[idx]:addChild(heroIntro)
    end
    -- --heroMoneyShow
    if not VERSION_REDUCE then
        if GameData.heros["h"..idx].level == 0 then
            local y
            if idx == 2 then
                y = -154
            else
                y = -157
            end
            local heroMoney
            heroMoney = display.newSprite("#heroMoney"..idx..".png",0,y)
            if idx == 2 then
                heroMoney:setScale(1.2)
            end
            self.heroNode[idx]:addChild(heroMoney)
            --[[if idx == 3 or idx == 4 then
                if VERSION_REDUCE then
                    local money = {
                        [1] = 0.99,
                        [2] = 1.59,
                    }
                    heroMoney = cc.ui.UILabel.new({
                        text = money[idx-2].."$",
                        size = 24,
                        color = cc.c3b(255,0,0),
                        x = -5,
                        y = y-25,
                        }):align(display.CENTER)
                else
                    heroMoney = display.newSprite("#heroMoney"..idx..".png",0,y)     
                end
            else
                heroMoney = display.newSprite("#heroMoney"..idx..".png",0,y)
            end]] 
        end
    end
    if GameData.heros["h"..idx].level ~= 0 then
        local fontType
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
        else
            fontType = "fontCommon.TTF"
        end
        local LV = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = "LV"..GameData.heros["h"..idx].level,
            size = 22,
            color = self.heroNode[idx].label1,
            x = -55,
            y = 135,
            }):align(display.CENTER)
        self.heroNode[idx]:addChild(LV)

        local percent = GameData.heros["h"..idx].level/HeroData[idx].maxLevel
        if percent < 1/10 then
            percent = 1/10
        elseif percent > 29/30 then
            percent = 29/30
        end
        local levelBarDown = display.newSprite("#upgrade_bottom.png",-22,135)
        local levelBarUp = display.newSprite("#upgrade_up.png",-22,135)
        local levelBarUpRight = display.newSprite("#upgrade_upright.png")
        local rect = levelBarUp:getTextureRect()
        rect.width = percent*rect.width
        levelBarUpRight:setPosition(-23+rect.width,135)
        levelBarUp:setTextureRect(rect,levelBarUp:isTextureRectRotated(),cc.size(rect.width, rect.height))
        levelBarUpRight:setAnchorPoint(cc.p(0,0.5))
        levelBarUp:setAnchorPoint(cc.p(0,0.5))
        levelBarDown:setAnchorPoint(cc.p(0,0.5))
        self.heroNode[idx]:addChild(levelBarDown)
        self.heroNode[idx]:addChild(levelBarUp)
        self.heroNode[idx]:addChild(levelBarUpRight)
    else
        local level
        if VERSION_REDUCE then
            level = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontEasy.ttf",
                text = kkFunc.getVersionHeroMesText("英雄最高等级",idx),
                size = 20,
                color = self.heroNode[idx].label1,
                x = 0,
                y = 135,
                }):align(display.CENTER)
            self.heroNode[idx]:addChild(level)
        else
            level = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",
                text = kkFunc.getVersionHeroMesText("英雄最高等级",idx),
                size = 20,
                color = self.heroNode[idx].label1,
                x = 0,
                y = 135,
                }):align(display.CENTER)
            self.heroNode[idx]:addChild(level)
        end
    end
    if idx == 1 then
        self:addParticle()
    end
    --可升级提示
    local canUpgradeSkill = false
    for i = 1,#HeroData[idx].skill-1 do
        if GameData.heros["h"..idx].level >= 1 and GameData.heros["h"..idx].skill["s"..i] >= 1 then
            if GameData.heros["h"..idx].skill["s"..i] < GameData.heros["h"..idx].level
                and GameData.heros["h"..idx].skill["s"..i] < #ExcelHeroSkillData[HeroData[idx].skill[i]]
                and GameData.carrot >= ExcelHeroSkillData[HeroData[idx].skill[i]][GameData.heros["h"..idx].skill["s"..i]].money 
                and GameData.skillPoints.value >= 1 then
                canUpgradeSkill = true
                break
            end
        end 
    end
    if (GameData.heros["h"..idx].level >= 1 
        and GameData.heros["h"..idx].level < HeroData[idx].maxLevel
        and GameData.carrot >= ExcelHeroData[idx][GameData.heros["h"..idx].level].money)
        or canUpgradeSkill then
        local heroUpgradeTip = {}
        if VERSION_REDUCE then
            for i=1,3 do
                if i == 3 then
                    heroUpgradeTip[i] = display.newSprite("#heroUpgrateEnglishTip3.png")
                    heroUpgradeTip[i]:setPosition(-5+(i-3)*10,200)
                elseif i == 1 then
                    heroUpgradeTip[i] = display.newSprite("#heroUpgrateEnglishTip"..i..".png")
                    heroUpgradeTip[i]:setPosition(-70+22*(i-1),200)
                else
                    heroUpgradeTip[i] = display.newSprite("#heroUpgrateEnglishTip"..i..".png")
                    heroUpgradeTip[i]:setPosition(-55+22*(i-1),200)
                end
                self.heroNode[idx]:addChild(heroUpgradeTip[i])
                heroUpgradeTip[i]:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.DelayTime:create(0.1*(i-1)),
                    cc.MoveBy:create(0.06,cc.p(0,-5)),
                    cc.MoveBy:create(0.06,cc.p(0,20)),
                    cc.MoveBy:create(0.06,cc.p(0,-15)),
                    cc.DelayTime:create(1.8-0.1*(i-1)),
                })))
            end
        else
            -- for i=1,6 do
            --     if i == 4 or i == 5 or i == 6 then
            --         heroUpgradeTip[i] = display.newSprite("#heroUpgradeTip4.png")
            --         heroUpgradeTip[i]:setPosition(-30+(i-3)*10,200)
            --     else
            --         heroUpgradeTip[i] = display.newSprite("#heroUpgradeTip"..i..".png")
            --         heroUpgradeTip[i]:setPosition(-80+22*(i-1),200)
            --     end
            --     self.heroNode[idx]:addChild(heroUpgradeTip[i])
            --     heroUpgradeTip[i]:runAction(cc.RepeatForever:create(transition.sequence({
            --         cc.DelayTime:create(0.1*(i-1)),
            --         cc.MoveBy:create(0.06,cc.p(0,-5)),
            --         cc.MoveBy:create(0.06,cc.p(0,20)),
            --         cc.MoveBy:create(0.06,cc.p(0,-15)),
            --         cc.DelayTime:create(1.8-0.1*(i-1)),
            --     })))
            -- end  
        end
    end
end

function HeroHouse:getScrollView(contentLayer)
    --[[if self.leftMove == nil then
        self.leftMove = cc.ui.UIPushButton.new({
            normal = "#leftMove.png",
            disabled = "#leftMove.png",
            pressed = "#leftMovePress.png",
            })
            :onButtonClicked(function() 
                self.leftMove:setVisible(false)
                self.rightMove:setVisible(true) 
                transition.moveTo(self.heroSelectBg,
                    {x = 0, y = 0, time = 0.3,
                    easing = "sineOut",
                    onComplete = function()
                    end})
            end)
            :pos(display.cx-self.titleBg:getContentSize().width/2-20,display.cy)
            :addTo(self)
        self.leftMove:setVisible(false)
    end
    if self.rightMove == nil then
        self.rightMove = cc.ui.UIPushButton.new({
            normal = "#rightMove.png",
            disabled = "#rightMove.png",
            pressed = "#rightMovePress.png",
            })
            :onButtonClicked(function()
                self.rightMove:setVisible(false)
                self.leftMove:setVisible(true)
                transition.moveTo(self.heroSelectBg,
                    {x = -210, y = 0, time = 0.3,
                    easing = "sineOut",
                    onComplete = function()
                    end})  
            end)
            :pos(display.cx+self.titleBg:getContentSize().width/2+20,display.cy)
            :addTo(self)
    end]]
    self.scrollView = cc.ui.UIScrollView.new({})   
    self.scrollView:setColor(cc.c3b(230,143,233))
    self.scrollView:setTouchSwallowEnabled(false)
    local screenSize = cc.Director:getInstance():getWinSize()
    local function scrollView1DidScroll(event)
    end
    local function scrollView1DidZoom()
    end
    local csize = contentLayer:getContentSize()
    if nil ~= self.scrollView then
        local scrollSize = contentLayer:getBoundingBox()
        scrollSize.width = 825
        scrollSize.height = 540
        self.scrollView:setViewRect(scrollSize)
        self.scrollView:setPosition(cc.p((display.width-self.titleBg:getContentSize().width)/2+23,-15))
        self.scrollView:setScale(1.0)
        self.scrollView:setAnchorPoint(cc.p(0,0))
        self.scrollView:addScrollNode(contentLayer)
        self.scrollView:setDirection(2)
        self.scrollView:setBounceable(true)
    end
    self.herohouseNode:addChild(self.scrollView,1)
end

function HeroHouse:HeroUpgrade(hero)
    self.hero = hero
    self.bg = display.newSprite("#herohouseSkillBg.png",display.cx,display.cy-40)
    self:addChild(self.bg,2)
    --left
    self.skillBg = {}
    self.addSkillMoney = {}
    self.coinSprite = {}
    self.skillLevel = {}
    self:refreshSkillBar(hero)
    if GameData.skillPoints.startTime ~= 0 then
        local num = math.floor((kkFunc.getSystime() - GameData.skillPoints.startTime)/300) 
        if num > 0 then
            GameData.skillPoints.value = GameData.skillPoints.value + num
            if GameData.skillPoints.value >= 5 then
                GameData.skillPoints.value = 5
            end
            GameState.save(GameData)
        end
    end
    self:refreshSkillPointLabel(hero)
    --right
    local nameMes,heroName,fontType
    if VERSION_REDUCE then
        heroName = display.newSprite(kkFunc.getVersionHeroMesText("英雄名字",hero),635,467)
        fontType = "fontEasy.ttf"
    else
        fontType = "fontCommon.TTF"
        nameMes = {
            [1] = "英雄盖伦",
            [2] = "萝莉安妮",
            [3] = "女神希维尔",
            [4] = "法师提莫",
        }
        heroName = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",    
                text = nameMes[hero],
                size = 20,
                color = cc.c3b(255,255,255),
                x = 635,
                y = 467,
            }):align(display.CENTER) 
    end
    self.bg:addChild(heroName)
    --herolevel
    local levelText = nil
    if GameData.heros["h"..hero].level == 0 then
        levelText = 1
    else
        levelText = GameData.heros["h"..hero].level
    end
    self.herolevel = cc.ui.UILabel.new({
        UILabelType = 2,
        font = fontType,
        text = "LV."..levelText,
        size = 20,
        color = cc.c3b(255,255,255),
        x = 635,
        y = 432,
        }):align(display.CENTER)
    self.bg:addChild(self.herolevel)
    --heroPic and heroWing
    self.heroPic = display.newSprite("#hero"..hero..".png",590,270)
    self.bg:addChild(self.heroPic)
    --[[self.heroPic = display.newSprite("#hero"..hero.."_1.png",590,270)
    self.bg:addChild(self.heroPic)
    local frames = display.newFrames("hero"..hero.."_%d.png", 1, 10)
    local animation = display.newAnimation(frames, 0.1)
    self.heroPic:playAnimationForever(animation)]]
    if hero == 1 then
        self.heroPic:setPosition(610,265)
    elseif hero == 3 then
        self.heroPic:setPosition(590,265)
    elseif hero == 4 then 
        self.heroPic:setPosition(595,265)
    end 
    self.heroPic:setScale(1.3) 
    --natureBg
    local natureBg = display.newSprite("#skillUpgradeExchange.png",775,190)
    self.bg:addChild(natureBg,2)
    --life attack speed  
    local text = nil
    local uptext = nil
    if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
        text = GameData.heros["h"..hero].level
        uptext = GameData.heros["h"..hero].level
    elseif GameData.heros["h"..hero].level == 0 then
        text = 1
        uptext = 2
    else
        text = GameData.heros["h"..hero].level
        uptext = GameData.heros["h"..hero].level + 1
    end
    local natureText = {
        [1] = math.floor(ExcelHeroData[hero][text].hp),
        [2] = math.floor(ExcelHeroData[hero][text].attack),
        [3] = math.floor(ExcelHeroData[hero][text].speed*70),
    }
    local natureUpText = {
        [1] = math.floor(ExcelHeroData[hero][uptext].hp),
        [2] = math.floor(ExcelHeroData[hero][uptext].attack),
        [3] = math.floor(ExcelHeroData[hero][uptext].speed*70),
    }
    self.nature = {}
    self.natureUp = {}
    --箭头
    self.upgradeTo = {}
    --[[local naturepercent = {
        [1] = math.floor(ExcelHeroData[hero][text].hp)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].hp),
        [2] = math.floor(ExcelHeroData[hero][text].attack)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].attack),
        [3] = math.floor(ExcelHeroData[hero][text].speed*70)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].speed*70),
    }]]
    self.natureBarUp = {}
    self.natureRect = {}
    for i=1,3 do
        self.nature[i] = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,    
            text = ""..natureText[i],
            size = 20,
            color = cc.c3b(255,255,255),
            x = 55,
            y = 62 + (2-i)*35,
            }):align(display.LEFT_TOP)
        natureBg:addChild(self.nature[i])
        self.natureUp[i] = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,    
            text = ""..natureUpText[i],
            size = 20,
            color = cc.c3b(0,255,36),
            x = 130,
            y = 62 + (2-i)*35,
            }):align(display.LEFT_TOP)
        natureBg:addChild(self.natureUp[i])
        self.upgradeTo[i] = display.newSprite("#upgradeTo.png",115,50 + (2-i)*35)
        natureBg:addChild(self.upgradeTo[i])
    end
    if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
        --英雄满级属性增加消失
        for j = 1, 3 do
            self.natureUp[j]:removeFromParent()
            self.upgradeTo[j]:removeFromParent()
            self.nature[j]:setColor(cc.c3b(0,255,36))
            self.nature[j]:setPosition(80,62 + (2-j)*35)
        end      
    end
    --heroMoney
    --[[if GameData.heros["h"..hero].level == 0 then
        if not VERSION_REDUCE then
            local heroMoney2 = display.newSprite("#moneyHero"..self.hero..".png",775,340)
            self.bg:addChild(heroMoney2,2)
        end
    end]]
    --UpgradeButton
    self.purchaseControl = true   
    self:showUpgradeButton(hero)       
    --
    if GameData.skillPoints.value < 5 and GameData.skillPoints.value >= 0 then
       local timeOK = kkFunc.checkTimer()
       if  timeOK then
           self:showSkillPointTime()
       end
    end
end
function HeroHouse:showUpgradeEffect()
    --wing
    local heroWing = display.newSprite("#heroWing1.png",600,270)
    self.bg:addChild(heroWing,-1)
    heroWing:setScale(1.5)
    local frames = display.newFrames("heroWing%d.png", 1, 8)
    local animation = display.newAnimation(frames, 0.1)
    heroWing:playAnimationOnce(animation,true)
    if self.hero == 1 then
        heroWing:setPosition(603,280)
    elseif self.hero == 3 then
        heroWing:setPosition(610,280)
    elseif self.hero == 4 then 
        heroWing:setPosition(610,280)
    end
    --upgrade
    local helY,num
    if VERSION_REDUCE then
        helY = 45
        num = 8
    else
        helY = 0
        num = 7
    end
    local heroUpgradeEffect = display.newSprite("#herohouseUpgradeffect1.png",self.heroPic:getContentSize().width/2,self.heroPic:getContentSize().height/2+helY)
    self.heroPic:addChild(heroUpgradeEffect)
    if self.hero == 4 then
       heroUpgradeEffect:setPosition(self.heroPic:getContentSize().width/2+10,self.heroPic:getContentSize().height/2+helY) 
    end
    local framesUpgrade = display.newFrames("herohouseUpgradeffect%d.png", 1, num)
    local animationUpgrade = display.newAnimation(framesUpgrade, 0.08)
    heroUpgradeEffect:playAnimationOnce(animationUpgrade,true)
end
function HeroHouse:showUpgradeButton(hero)
    local textNum
    if GameData.heros["h"..hero].level == 0 then
        textNum = ExcelHeroData[hero][GameData.heros["h"..hero].level+1].money
    else
        textNum = ExcelHeroData[hero][GameData.heros["h"..hero].level].money
    end
    local labelX 
    if VERSION_REDUCE then
        labelX = -28
    else
        labelX = -10
    end
    local label = cc.ui.UILabel.new({
            UILabelType = 1,
            font = "fontTitleNumber.fnt",
            text = ""..textNum,
            x = labelX,
            y = 0,
            color = cc.c3b(255,255,255),
        }):align(display.CENTER)
    label:setScale(0.8)
    if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
        local heroMaxLevel = display.newSprite("#heroMaxLevel.png",640,70)
        self.bg:addChild(heroMaxLevel)
    elseif GameData.heros["h"..hero].level == 0 then
        --pcmoney
        local buyButtonPic = "#buttonGet.png"
        if VERSION_REDUCE then
            buyButtonPic = "#buttonGetHero.png"
        else
        end
        self.purchaseHero = cc.ui.UIPushButton.new({
            normal = buyButtonPic,
            pressed = buyButtonPic,
            disabled = buyButtonPic,
            })
            :onButtonPressed(function()
                self.purchaseHero:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.purchaseHero:setScale(1)
            end)
            :setButtonLabel("normal", cc.ui.UILabel.new({
                UILabelType = 1,
                font = "fontTitleNumber.fnt",
                text = "",
                size = 24,
                color = cc.c3b(255,255,255),
            })):align(display.CENTER)
            :onButtonClicked(function(event)
                if self.purchaseControl == true then
                    if hero == 2 then
                        if GameData.diamond >= HeroData[hero].money then
                            --self:popPurchaseHeroLayer(hero,2,label)--之前弹出框方法暂时屏蔽掉
                            ---------------------------------去掉购买英雄弹出框
                            GameData.diamond = GameData.diamond - HeroData[hero].money
                            g_infoLayer.diamondLabel:setString(""..GameData.diamond)            
                            GameData.heros["h"..hero].level = 1
                            self.war[hero]:setButtonImage("normal", "#hero_war.png")
                            self.war[hero]:setButtonImage("disabled", "#hero_war.png")
                            self.war[hero]:setButtonImage("pressed", "#hero_war.png")
                            self.purchaseHero:setButtonImage("normal", "#skillUpgradeButton.png")
                            self.purchaseHero:setButtonImage("disabled", "#skillUpgradeButton.png")
                            self.purchaseHero:setButtonImage("pressed", "#skillUpgradeButton.png")
                            label:setVisible(true)
                            label:setString(""..ExcelHeroData[hero][GameData.heros["h"..hero].level].money)
                            for j=1,#HeroData[hero].skill do
                                if GameData.heros["h"..hero].level >= SkillData[HeroData[hero].skill[j]].heroLevel then
                                    GameData.heros["h"..hero].skill["s"..j] = 1
                                end
                            end
                            self:refreshSkillBar(hero)
                            self:refreshSkillPointLabel(hero)     
                            self.purchaseControl = false
                            AchievementData.checkHero()
                            AchievementData.checkDiamond(HeroData[hero].money)
                            self:BuyHeroButtonMethod(hero)
                            GameState.save(GameData)
                            --位置改变,增加12元购买按钮
                            self.purchaseHero:setPosition(740,70)
                            self:EightPurchaseButton(hero)
                            --removeMoney
                            if VERSION_REDUCE then
                                if self.heroMoneyTwo[hero] ~= nil then
                                    self.heroMoneyTwo[hero]:removeFromParent()
                                    self.heroMoneyTwo[hero] = nil
                                end
                                if self.heroMoney[hero] ~= nil then
                                    self.heroMoney[hero]:removeFromParent()
                                    self.heroMoney[hero] = nil
                                end
                            end
                            ---------------------------------               
                        else
                            if VERSION_REDUCE then
                                g_infoLayer:popLayer("钻石")
                            else
                                    --厦门修改
                                    g_infoLayer:popLayer("钻石")
                                -- if kkFunc.simplifyPurchaseSwitch() then
                                --     kkFunc.simplifyPurchaseSdkCallBack(5)
                                -- else
                                --     g_infoLayer:popLayer("钻石")
                                -- end
                                    --厦门修改
                            end
                        end
                    else
                        --self:popPurchaseHeroLayer(hero,2,label)--之前弹出框方法暂时屏蔽掉
                        ---------------------------------去掉购买英雄弹出框
                        local function paycallback(result)
                            if result == "success" then
                                self:paySuccessCallback(hero,2,label)
                                --[[GameData.heros["h"..hero].level = 1
                                self.war[hero]:setButtonImage("normal", "#hero_war.png")
                                self.war[hero]:setButtonImage("disabled", "#hero_war.png")
                                self.war[hero]:setButtonImage("pressed", "#hero_war.png")
                                self.purchaseHero:setButtonImage("normal", "#skillUpgradeButton.png")
                                self.purchaseHero:setButtonImage("disabled", "#skillUpgradeButton.png")
                                self.purchaseHero:setButtonImage("pressed", "#skillUpgradeButton.png")
                                label:setVisible(true)
                                label:setString(""..ExcelHeroData[hero][GameData.heros["h"..hero].level].money)
                                for j=1,#HeroData[hero].skill do
                                    if GameData.heros["h"..hero].level >= SkillData[HeroData[hero].skill[j]]--[[.heroLevel then--zheli
                                        GameData.heros["h"..hero].skill["s"..j] = 1
                                    end
                                end
                                self:refreshSkillBar(hero)
                                self:refreshSkillPointLabel(hero)     
                                self.purchaseControl = false
                                AchievementData.checkHero()
                                self:BuyHeroButtonMethod(hero)
                                GameState.save(GameData)
                                --位置改变,增加12元购买按钮
                                self.purchaseHero:setPosition(740,70)
                                self:EightPurchaseButton(hero)
                                --removeMoney
                                if VERSION_REDUCE then
                                    if self.heroMoneyTwo[hero] ~= nil then
                                        self.heroMoneyTwo[hero]:removeFromParent()
                                        self.heroMoneyTwo[hero] = nil
                                    end
                                    if self.heroMoney[hero] ~= nil then
                                        self.heroMoney[hero]:removeFromParent()
                                        self.heroMoney[hero] = nil
                                    end
                                end
                                --DataEye
                                if device.platform == "android" or device.platform == "ios" then
                                    --DCCoin.gain("玩家付费", "CNY", HeroData[hero].money, HeroData[hero].money)
                                    --DCCoin.lost("获得英雄希维尔", "CNY", HeroData[hero].money, 0)
                                    DCVirtualCurrency.paymentSuccess("","获得英雄希维尔",HeroData[hero].money,"CNY",CHANLE_NAME)
                                end
                                --支付成功后获得道具弹出框
                                kkFunc.popPaySuccessLayer()]]
                            end
                        end
                        --[[if TEST_DEMO then
                            paycallback("success")
                        else
                            kkFunc.Pay(hero-2,paycallback)
                        end]]
                        if VERSION_REDUCE then
                            if TEST_DEMO then
                                paycallback("success")
                            else
                                kkFunc.Pay(hero-2,paycallback)
                            end
                        else
								--厦门计费点
                            if TEST_DEMO then
                                --paycallback("success")
                            else
                                --kkFunc.Pay(5+hero,paycallback)
                            end
								--厦门计费点
                        end 
                        ---------------------------------   
                    end     
                else
                    if GameData.heros["h"..hero].level < HeroData[hero].maxLevel and GameData.carrot >=ExcelHeroData[hero][GameData.heros["h"..hero].level].money then 
                        GameData.heros["h"..hero].level = GameData.heros["h"..hero].level + 1
                        GameData.carrot = GameData.carrot - ExcelHeroData[hero][GameData.heros["h"..hero].level-1].money
                        g_infoLayer.carrotLabel:setString(""..GameData.carrot)
                        self.herolevel:setString("LV."..GameData.heros["h"..hero].level)
                        self.nature[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp))
                        self.nature[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack))
                        self.nature[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70))
                        if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
                            self.natureUp[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp))
                            self.natureUp[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack))
                            self.natureUp[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70))
                        else
                            self.natureUp[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level+1].hp))
                            self.natureUp[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level+1].attack))
                            self.natureUp[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level+1].speed*70))
                        end          
                        --[[self.natureRect[1].width = 183*math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].hp)
                        self.natureBarUp[1]:setTextureRect(self.natureRect[1],self.natureBarUp[1]:isTextureRectRotated(),cc.size(self.natureRect[1].width, self.natureRect[1].height))
                        self.natureRect[2].width = 183*math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].attack)
                        self.natureBarUp[2]:setTextureRect(self.natureRect[2],self.natureBarUp[2]:isTextureRectRotated(),cc.size(self.natureRect[2].width, self.natureRect[2].height))
                        self.natureRect[3].width = 183*math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].speed*70)
                        self.natureBarUp[3]:setTextureRect(self.natureRect[3],self.natureBarUp[3]:isTextureRectRotated(),cc.size(self.natureRect[3].width, self.natureRect[3].height))]]
                        for i = 1,#HeroData[hero].skill do
                            if GameData.heros["h"..hero].skill["s"..i] == 0 and GameData.heros["h"..hero].level >= SkillData[HeroData[hero].skill[i]].heroLevel then   
                                GameData.heros["h"..hero].skill["s"..i] = 1     
                                self:refreshSkillBar(hero)
                            end
                        end
                        self.purchaseHero:setButtonImage("normal", "#skillUpgradeButton.png")
                        self.purchaseHero:setButtonImage("disabled", "#skillUpgradeButton.png")
                        self.purchaseHero:setButtonImage("pressed", "#skillUpgradeButton.png")                                 
                        label:setString(""..ExcelHeroData[hero][GameData.heros["h"..hero].level].money)
                        AchievementData.checkHeroUpgrade(hero)
                        AchievementData.checkUseMoney(ExcelHeroData[hero][GameData.heros["h"..hero].level-1].money)
                        GameState.save(GameData)
                        if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
                            self.purchaseHero:removeFromParent()
                            local heroMaxLevel = display.newSprite("#heroMaxLevel.png",640,70)
                            self.bg:addChild(heroMaxLevel)
                            --一键满级按钮消失
                            if self.levelFull ~= nil then
                               self.levelFull:removeFromParent()
                               self.levelFull = nil 
                            end
                            --英雄满级属性增加消失
                            for j = 1, 3 do
                                self.natureUp[j]:removeFromParent()
                                self.upgradeTo[j]:removeFromParent()
                                self.nature[j]:setColor(cc.c3b(0,255,36))
                                self.nature[j]:setPosition(80,62 + (2-j)*35)
                            end 
                            if not VERSION_REDUCE then
                                if GameData.selectHero == hero then
                                    self.war[hero]:setButtonImage("normal", "#heroMaxLevel.png")
                                    self.war[hero]:setButtonImage("disabled", "#heroMaxLevel.png")
                                    self.war[hero]:setButtonImage("pressed", "#heroMaxLevel.png")
                                    if self.cuePoint ~= nil then
                                        self.cuePoint:removeFromParent()
                                        self.cuePoint = nil 
                                    end
                                end
                            end     
                        end
                        self:showUpgradeEffect()
                    elseif GameData.carrot < ExcelHeroData[hero][GameData.heros["h"..hero].level].money then --bbbbbb
                        if VERSION_REDUCE then
                            g_infoLayer:popLayer("钻石")
                        else
                                --厦门修改
                                g_infoLayer:popLayer("钻石")
                            -- if kkFunc.simplifyPurchaseSwitch() then
                            --     kkFunc.simplifyPurchaseSdkCallBack(5)
                            -- else
                            --     g_infoLayer:popLayer("钻石")
                            -- end
                               --厦门修改
                        end
                    end
                    --yichu
                    if not VERSION_REDUCE then
                        for k = 1,4 do
                            if GameData.heros["h"..k].level ~= 0 then
                                local money = ExcelHeroData[k][GameData.heros["h"..k].level].money
                                if  GameData.skillPoints.value < 5 and GameData.selectHero == k and GameData.carrot < money then 
                                    if self.cuePoint ~= nil then
                                        self.cuePoint:removeFromParent()
                                        self.cuePoint = nil
                                    end
                                end
                            end
                        end
                    end
                end
            end)
            :pos(640, 70)
            :addTo(self.bg)
        label:setVisible(false)
        if VERSION_REDUCE then
            self.heroMoneyTwo = {}
            if hero == 3 or hero == 4 then
                    local money = {
                        [1] = 0.99,
                        [2] = 1.59,
                    }
                    self.heroMoneyTwo[hero] = cc.ui.UILabel.new({
                        UILabelType = 2,
                        text = money[hero-2].."$",
                        size = 25,
                        font = "fontEasy.ttf",
                        color = cc.c3b(255,255,255),
                        x = -25,
                        y = 0,
                        }):align(display.CENTER)    
            else
                self.heroMoneyTwo[hero] = display.newSprite("#heroMoney"..hero..".png",-32,3)
                self.heroMoneyTwo[hero]:setScale(1.0)
            end
            self.purchaseHero:addChild(self.heroMoneyTwo[hero])
        end
        self.purchaseHero:addChild(label)
    elseif GameData.heros["h"..hero].level < HeroData[hero].maxLevel then
        self.purchaseHero = cc.ui.UIPushButton.new({
            normal = "#skillUpgradeButton.png",
            pressed = "#skillUpgradeButton.png",
            disabled = "#skillUpgradeButton.png",
            })
            :onButtonPressed(function()
                self.purchaseHero:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.purchaseHero:setScale(1)
            end)
            :onButtonClicked(function(event)
                if GameData.heros["h"..hero].level < HeroData[hero].maxLevel and GameData.carrot >=ExcelHeroData[hero][GameData.heros["h"..hero].level].money then 
                    GameData.heros["h"..hero].level = GameData.heros["h"..hero].level + 1
                    GameData.carrot = GameData.carrot - ExcelHeroData[hero][GameData.heros["h"..hero].level-1].money
                    g_infoLayer.carrotLabel:setString(""..GameData.carrot)
                    self.herolevel:setString("LV."..GameData.heros["h"..hero].level)
                    self.nature[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp))
                    self.nature[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack))
                    self.nature[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70))
                    if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
                        self.natureUp[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp))
                        self.natureUp[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack))
                        self.natureUp[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70))
                    else
                        self.natureUp[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level+1].hp))
                        self.natureUp[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level+1].attack))
                        self.natureUp[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level+1].speed*70))
                    end
                    --[[self.natureRect[1].width = 183*math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].hp)
                    self.natureBarUp[1]:setTextureRect(self.natureRect[1],self.natureBarUp[1]:isTextureRectRotated(),cc.size(self.natureRect[1].width, self.natureRect[1].height))
                    self.natureRect[2].width = 183*math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].attack)
                    self.natureBarUp[2]:setTextureRect(self.natureRect[2],self.natureBarUp[2]:isTextureRectRotated(),cc.size(self.natureRect[2].width, self.natureRect[2].height))
                    self.natureRect[3].width = 183*math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70)/math.floor(ExcelHeroData[hero][HeroData[hero].maxLevel].speed*70)
                    self.natureBarUp[3]:setTextureRect(self.natureRect[3],self.natureBarUp[3]:isTextureRectRotated(),cc.size(self.natureRect[3].width, self.natureRect[3].height))]]
                    for i = 1,#HeroData[hero].skill do
                        if GameData.heros["h"..hero].skill["s"..i] == 0 and GameData.heros["h"..hero].level >= SkillData[HeroData[hero].skill[i]].heroLevel then   
                            GameData.heros["h"..hero].skill["s"..i] = 1     
                            self:refreshSkillBar(hero)
                        end
                    end                                 
                    label:setString(""..ExcelHeroData[hero][GameData.heros["h"..hero].level].money)
                    AchievementData.checkHeroUpgrade(hero)
                    AchievementData.checkUseMoney(ExcelHeroData[hero][GameData.heros["h"..hero].level-1].money)
                    GameState.save(GameData)
                    if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
                        self.purchaseHero:removeFromParent()
                        local heroMaxLevel = display.newSprite("#heroMaxLevel.png",640,70)
                        self.bg:addChild(heroMaxLevel)
                        if not VERSION_REDUCE then
                            if GameData.selectHero == hero then
                                self.war[hero]:setButtonImage("normal", "#heroMaxLevel.png")
                                self.war[hero]:setButtonImage("disabled", "#heroMaxLevel.png")
                                self.war[hero]:setButtonImage("pressed", "#heroMaxLevel.png")
                                if self.cuePoint ~= nil then
                                    self.cuePoint:removeFromParent()
                                    self.cuePoint = nil 
                                end
                            end
                        end
                        --一键满级按钮消失
                        if self.levelFull ~= nil then
                           self.levelFull:removeFromParent()
                           self.levelFull = nil 
                        end
                        --英雄属性增加消失
                        for j = 1, 3 do
                            self.natureUp[j]:removeFromParent()
                            self.upgradeTo[j]:removeFromParent()
                            self.nature[j]:setColor(cc.c3b(0,255,36))
                            self.nature[j]:setPosition(80,62 + (2-j)*35)
                        end
                    end
                    self:showUpgradeEffect()
                elseif GameData.carrot < ExcelHeroData[hero][GameData.heros["h"..hero].level].money then--bbbbbbb
                    if VERSION_REDUCE then
                        g_infoLayer:popLayer("金币")
                    else
                            --厦门升级英雄金币不够
                            g_infoLayer:popLayer("金币")
                        -- if kkFunc.simplifyPurchaseSwitch() then
                        --     kkFunc.simplifyPurchaseSdkCallBackCoin(7)
                        -- else
                        --     g_infoLayer:popLayer("金币")
                        -- end
                            --厦门升级英雄金币不够
                    end
                end
                --yichu
                if not VERSION_REDUCE then
                    for k = 1,4 do
                        if GameData.heros["h"..k].level ~= 0 then
                            local money = ExcelHeroData[k][GameData.heros["h"..k].level].money
                            if  GameData.skillPoints.value < 5 and GameData.selectHero == k and GameData.carrot < money then 
                                if self.cuePoint ~= nil then
                                    self.cuePoint:removeFromParent()
                                    self.cuePoint = nil
                                end
                            end
                        end
                    end
                end
            end)
            --:pos(640, 70)
            :pos(740, 70)
            :addTo(self.bg)
        self.purchaseHero:addChild(label)

        self:EightPurchaseButton(hero)
    end
end

function HeroHouse:paySuccessCallback(heroIdx,step,label)

    print("--step--",step)
    print("--heroIdx--",heroIdx)
    print("--label--",label)

    if step == 1 then
        self:BuyHeroButtonMethod(heroIdx)
        AchievementData.checkHero()
        --removeMoney
        if self.heroMoney[heroIdx] ~= nil then
            self.heroMoney[heroIdx]:removeFromParent()
            self.heroMoney[heroIdx] = nil
        end
        --DataEye

           --厦门
        -- if device.platform == "android" or device.platform == "ios" then
        --     --DCCoin.gain("玩家付费", "CNY", HeroData[heroIdx].money, HeroData[heroIdx].money)
        --     --DCCoin.lost("获得英雄希维尔", "CNY", HeroData[heroIdx].money, 0)
        --     DCVirtualCurrency.paymentSuccess("","获得英雄希维尔",HeroData[heroIdx].money,"CNY",CHANLE_NAME)
        -- end
           --厦门

    elseif step == 2 then
        GameData.heros["h"..heroIdx].level = 1
        self.war[heroIdx]:setButtonImage("normal", "#hero_war.png")
        self.war[heroIdx]:setButtonImage("disabled", "#hero_war.png")
        self.war[heroIdx]:setButtonImage("pressed", "#hero_war.png")
        self.purchaseHero:setButtonImage("normal", "#skillUpgradeButton.png")
        self.purchaseHero:setButtonImage("disabled", "#skillUpgradeButton.png")
        self.purchaseHero:setButtonImage("pressed", "#skillUpgradeButton.png")
        label:setVisible(true)
        label:setString(""..ExcelHeroData[heroIdx][GameData.heros["h"..heroIdx].level].money)
        for j=1,#HeroData[heroIdx].skill do
            if GameData.heros["h"..heroIdx].level >= SkillData[HeroData[heroIdx].skill[j]].heroLevel then--zheli
                GameData.heros["h"..heroIdx].skill["s"..j] = 1
            end
        end
        self:refreshSkillBar(heroIdx)
        self:refreshSkillPointLabel(heroIdx)     
        self.purchaseControl = false
        AchievementData.checkHero()
        self:BuyHeroButtonMethod(heroIdx)
        GameState.save(GameData)
        --位置改变,增加12元购买按钮
        self.purchaseHero:setPosition(740,70)
        self:EightPurchaseButton(heroIdx)
        --removeMoney
        if VERSION_REDUCE then
            if self.heroMoneyTwo[heroIdx] ~= nil then
                self.heroMoneyTwo[heroIdx]:removeFromParent()
                self.heroMoneyTwo[heroIdx] = nil
            end
            if self.heroMoney[heroIdx] ~= nil then
                self.heroMoney[heroIdx]:removeFromParent()
                self.heroMoney[heroIdx] = nil
            end
        end
        --DataEye
             --厦门
        -- if device.platform == "android" or device.platform == "ios" then
        --     --DCCoin.gain("玩家付费", "CNY", HeroData[heroIdx].money, HeroData[heroIdx].money)
        --     --DCCoin.lost("获得英雄希维尔", "CNY", HeroData[heroIdx].money, 0)
        --     DCVirtualCurrency.paymentSuccess("","获得英雄希维尔",HeroData[heroIdx].money,"CNY",CHANLE_NAME)
        -- end
             --厦门
    end
    --支付成功后获得道具弹出框
    kkFunc.popPaySuccessLayer()
end

function HeroHouse:getPositionX(  )
    -- body
end
function HeroHouse:EightPurchaseButton(hero)
    --[[if self.levelFull ~= nil then
        self.levelFullRecvord = self.levelFull
    end]]
    self.levelFull = cc.ui.UIPushButton.new({
        normal = "#levelFull.png",
        pressed = "#levelFull.png",
        disabled = "#levelFull.png",
        })
        :onButtonPressed(function()
            self.levelFull:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.levelFull:setScale(1)
        end)
        :onButtonClicked(function(event)
            --一键满级
            local function paycallback(result)
                if result == "success" then
                    self:LevelFull(hero)
                    AchievementData.checkHeroUpgrade(hero)
                    if not VERSION_REDUCE then
                        --[[if GameData.selectHero == hero then
                            if GameData.heros["h"..GameData.selectHero].level ~= HeroData[GameData.selectHero].maxLevel then
                                self.war[hero]:setButtonImage("normal", "#hero_haswar.png")
                                self.war[hero]:setButtonImage("disabled", "#hero_haswar.png")
                                self.war[hero]:setButtonImage("pressed", "#hero_haswar.png")
                            end
                        end]]
                        if GameData.selectHero == hero then
                            self.war[hero]:setButtonImage("normal", "#heroMaxLevel.png")
                            self.war[hero]:setButtonImage("disabled", "#heroMaxLevel.png")
                            self.war[hero]:setButtonImage("pressed", "#heroMaxLevel.png")
                            if self.cuePoint ~= nil then
                                self.cuePoint:removeFromParent()
                                self.cuePoint = nil 
                            end
                        end
                    end
                    GameState.save(GameData)
                    --DataEye
                         --厦门
                    if device.platform == "android" or device.platform == "ios" then
                        --DCCoin.gain("玩家付费", "CNY", 12, 12)
                        --DCCoin.lost("英雄满级", "CNY", 12, 0)
                        DCVirtualCurrency.paymentSuccess("","英雄满级",12,"CNY",CHANLE_NAME)
                        -- if not VERSION_REDUCE then
                        --     -- self.war[hero]:setButtonImage("normal", "#heroMaxLevel.png")
                        --     -- self.war[hero]:setButtonImage("disabled", "#heroMaxLevel.png")
                        --     -- self.war[hero]:setButtonImage("pressed", "#heroMaxLevel.png")
                        -- end
                    end
                         --厦门
                         
                    -- kkFunc.popPaySuccessLayer()
                end
            end
            GameData.lastFullHeroID = hero--海外版支付可能延迟，故记录英雄ID
            GameState.save(GameData)           
            --[[if TEST_DEMO then
                paycallback("success")
            else
                kkFunc.Pay(3,paycallback)
            end]]
            if VERSION_REDUCE then
                if TEST_DEMO then
                    paycallback("success")
                else
                    kkFunc.Pay(3,paycallback)
                end
            else
					--厦门一键满级计费点
                if TEST_DEMO then
                    paycallback("success")
                else
                    --kkFunc.Pay(0,paycallback)
                    kkFunc.xmPay(6)
                end
					--厦门一键满级计费点
            end
        end)
        :pos(520, 71)
        :addTo(self.bg) 
    if VERSION_REDUCE then
        local money = cc.ui.UILabel.new({
            UILabelType = 2,
            text = "2.59$",
            size = 25,
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = -90,
            y = 3,
            }):align(display.CEMTER)
        self.levelFull:addChild(money)
        self.levelFull:setPositionX(520)
    end       
end
function HeroHouse:refreshSkillBar(hero)
    for i = 1,#HeroData[hero].skill do
        if self.skillBg[i] ~= nil then
            self.skillBg[i]:removeFromParent()
            self.skillBg[i] = nil
        end
    end
    self.addSkillPonitButton = {}
    self.achievePoint = {}
    for i = 1,#HeroData[hero].skill do
        if hero == 1 then
            if i == 3 then
                self.skillBg[i] = display.newSprite("#unactiveSkillBar.png") --cc.LayerColor:create(cc.c4b(0,0,0,150),320,80)
            else
                self.skillBg[i] = display.newSprite("#activeSkillBar.png")
            end
        else
            if i == 4 then
                self.skillBg[i] = display.newSprite("#unactiveSkillBar.png")
            else
                self.skillBg[i] = display.newSprite("#activeSkillBar.png")
            end
        end
        self.skillBg[i]:setPosition(220,390 -(i-1)*95)
        self.bg:addChild(self.skillBg[i])
        --dump(self.skillBg[i]:getCascadeBoundingBox())
        --skillname and skillNameBg
        if HeroData[hero].skill[i] == 3 or HeroData[hero].skill[i] == 7 or HeroData[hero].skill[i] == 11 or HeroData[hero].skill[i] ==15 then
            colorC3b = cc.c3b(242,255,134)
        else
            colorC3b = cc.c3b(82,255,249)
        end
        local fontType,posY
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
            posY = 15
        else
            fontType = "fontCommon.TTF"
            posY = 16
        end
        local skillNamePic = cc.ui.UILabel.new({
            UILabelType = 2,    
            text = kkFunc.getVersionSkillName("技能名称",HeroData[hero].skill[i]),
            size = 18,
            font = fontType,
            color = colorC3b,
            x = 4,
            y = posY,
            }):align(display.LEFT_TOP)
        -- local skillNamePic = display.newSprite("#"..SkillData[HeroData[hero].skill[i]].name,4,16)
        skillNamePic:setAnchorPoint(cc.p(0,0.5))
        -- if HeroData[hero].skill[i] > 3 then
        --     skillNamePic:setPosition(4,19)
        -- end
        --[[if HeroData[hero].skill[i] > 3 then
            skillNamePic:setPosition(4,19)
        end--]]
        local skillNameBg = display.newScale9Sprite("#skillTextBar.png", 85, 63,cc.size(skillNamePic:getContentSize().width+9,skillNamePic:getContentSize().height+9))
        skillNameBg:setAnchorPoint(cc.p(0,0.5))
        self.skillBg[i]:addChild(skillNameBg)
        skillNameBg:addChild(skillNamePic)
        --skillpic
        local skillPic = display.newSprite("#"..SkillData[HeroData[hero].skill[i]].pic2,45,43)
        self.skillBg[i]:addChild(skillPic)
        --
        --[[if hero == 1 then
            if i == 3 then
                local unactiveIcon = display.newSprite("#unactiveIcon.png",280,45)
                self.skillBg[i]:addChild(unactiveIcon)
            end
        else
            if i == 4 then
                local unactiveIcon = display.newSprite("#unactiveIcon.png",280,45)
                self.skillBg[i]:addChild(unactiveIcon)
            end
        end]]
        if GameData.heros["h"..hero].level >= SkillData[HeroData[hero].skill[i]].heroLevel then  
            if SkillData[HeroData[hero].skill[i]].passive == nil then
                local fontType
                if VERSION_REDUCE then
                    fontType = "fontEasy.ttf"
                else
                    fontType = "fontCommon.TTF"
                end
                self.skillLevel[i] = cc.ui.UILabel.new({
                    UILabelType = 2,
                    font = fontType,
                    text = "lv."..GameData.heros["h"..hero].skill["s"..i],
                    size = 20,
                    color = cc.c3b(255,255,255),
                    x = 90,
                    y = 19,
                    })
                self.skillBg[i]:addChild(self.skillLevel[i])
                --addSkillPoint
                local text = "#skillAddButton.png"
                if GameData.heros["h"..hero].skill["s"..i] == #ExcelHeroSkillData[HeroData[hero].skill[i]] then
                    text = "#skillMaxLevel.png"
                end
                self.addSkillPonitButton[i] = cc.ui.UIPushButton.new({
                    normal = text,
                    pressed = text,
                    disabled = text,
                    })
                    :onButtonPressed(function()
                        self.addSkillPonitButton[i]:setScale(1.1)
                        --音效
                        SoundManager.playSound(GAME_SOUND.Button2)
                    end)
                    :onButtonRelease(function()
                        self.addSkillPonitButton[i]:setScale(1)
                    end)
                    :onButtonClicked(function(event)
                        if GameData.heros["h"..hero].skill["s"..i] < #ExcelHeroSkillData[HeroData[hero].skill[i]] then
                            if GameData.heros["h"..hero].skill["s"..i] < GameData.heros["h"..hero].level then
                                if GameData.carrot >= ExcelHeroSkillData[HeroData[hero].skill[i]][GameData.heros["h"..hero].skill["s"..i]].money then              
                                    if GameData.skillPoints.value == 0 then
                                        self:PurchaseSkillPoint(self.hero)
                                    else
                                        if GameData.skillPoints.value > 1 and GameData.skillPoints.value < 5 then
                                            GameData.heros["h"..hero].skill["s"..i] = GameData.heros["h"..hero].skill["s"..i] + 1
                                            self.skillLevel[i]:setString("lv."..GameData.heros["h"..hero].skill["s"..i])
                                            GameData.skillPoints.value = GameData.skillPoints.value - 1
                                            if self.leftSkillPoint ~= nil then
                                                self.timeStrLabel:setString("("..self.timeStr..")")
                                                self.leftSkillPoint:setString(kkFunc.getVersionHeroMesText("技能点未满"))
                                            end
                                        elseif GameData.skillPoints.value == 1 then
                                            GameData.skillPoints.value = GameData.skillPoints.value - 1
                                            GameData.heros["h"..hero].skill["s"..i] = GameData.heros["h"..hero].skill["s"..i] + 1
                                            self.skillLevel[i]:setString("lv."..GameData.heros["h"..hero].skill["s"..i])
                                            self:refreshSkillPointLabel(hero) 
                                            if self.purchaseSkillPointLabel ~= nil then
                                                self.purchaseSkillPointLabel:setString(kkFunc.getVersionHeroMesText("技能点不足",self.timeStr))
                                            end        
                                        elseif GameData.skillPoints.value == 5 then
                                            --移除点
                                            for j = 1,#HeroData[hero].skill do
                                                if self.achievePoint[j] ~= nil then
                                                self.achievePoint[j]:removeFromParent()
                                                self.achievePoint[j] = nil 
                                                end
                                            end
                                            GameData.skillPoints.value = GameData.skillPoints.value - 1
                                            GameData.heros["h"..hero].skill["s"..i] = GameData.heros["h"..hero].skill["s"..i] + 1
                                            self.skillLevel[i]:setString("lv."..GameData.heros["h"..hero].skill["s"..i])
                                            self:refreshSkillPointLabel(hero)
                                            local timeOK = kkFunc.checkTimer()
                                            if timeOK then
                                               GameData.skillPoints.startTime = kkFunc.getSystime()
                                               self:showSkillPointTime() 
                                            end
                                        end
                                        if GameData.heros["h"..hero].skill["s"..i] == #ExcelHeroSkillData[HeroData[hero].skill[i]] then
                                            self.addSkillPonitButton[i]:setButtonImage("normal", "#skillMaxLevel.png")
                                            self.addSkillPonitButton[i]:setButtonImage("disabled", "#skillMaxLevel.png")
                                            self.addSkillPonitButton[i]:setButtonImage("pressed", "#skillMaxLevel.png")   
                                            self.addSkillMoney[i]:removeFromParent()
                                            self.coinSprite[i]:removeFromParent()
                                            self.addSkillPonitButton[i]:setPosition(280,45)
                                        else
                                            self.addSkillMoney[i]:setString(""..ExcelHeroSkillData[HeroData[hero].skill[i]][GameData.heros["h"..hero].skill["s"..i]].money)
                                        end
                                        GameData.carrot = GameData.carrot - ExcelHeroSkillData[HeroData[hero].skill[i]][GameData.heros["h"..hero].skill["s"..i]-1].money
                                                                --yichu
                                        if not VERSION_REDUCE then
                                            for k = 1,4 do
                                                if GameData.heros["h"..k].level ~= 0 then
                                                    local money = ExcelHeroData[k][GameData.heros["h"..k].level].money
                                                    if  GameData.skillPoints.value < 5 and GameData.selectHero == k and GameData.carrot < money then 
                                                        if self.cuePoint ~= nil then
                                                            self.cuePoint:removeFromParent()
                                                            self.cuePoint = nil
                                                        end
                                                    end
                                                end
                                            end
                                        end
                                        g_infoLayer.carrotLabel:setString(""..GameData.carrot)
                                        AchievementData.checkUseMoney(ExcelHeroSkillData[HeroData[hero].skill[i]][GameData.heros["h"..hero].skill["s"..i]-1].money)
                                        AchievementData.checkHeroSkillUpgrade(hero)
                                        --技能全满级后技能点隐掉
                                        self:setSkillPointsVisible(hero)
                                        GameState.save(GameData)
                                    end           
                                else
                                    if VERSION_REDUCE then
                                        g_infoLayer:popLayer("金币")
                                    else
                                           --厦门修改
                                            g_infoLayer:popLayer("金币")
                                        -- if kkFunc.simplifyPurchaseSwitch() then
                                        --     kkFunc.simplifyPurchaseSdkCallBackCoin(7)
                                        -- else
                                        --     g_infoLayer:popLayer("金币")
                                        -- end
                                             --厦门修改
                                    end
                                end
                            else
                                self:skillLevelLessThanHeroLevel(hero)
                            end
                        end
                    end)
                    :pos(280, 53)
                    :addTo(self.skillBg[i])
                if not VERSION_REDUCE then
                    if GameData.skillPoints.value >= 5 and GameData.heros["h"..hero].skill["s"..i] ~= #ExcelHeroSkillData[HeroData[hero].skill[i]] then
                        self.achievePoint[i] = display.newSprite("#achievementTipPoint.png",22,22)
                        self.achievePoint[i]:setScale(0.7)
                        self.addSkillPonitButton[i]:addChild(self.achievePoint[i])
                    end
                end
                --addskillNeedMoney
                if GameData.heros["h"..hero].skill["s"..i] ~= #ExcelHeroSkillData[HeroData[hero].skill[i]] then
                    self.coinSprite[i] = display.newSprite("#skillUpgradeCoin.png",260,15) 
                    self.skillBg[i]:addChild(self.coinSprite[i])
                    local fontType
                    if VERSION_REDUCE then
                        fontType = "fontEasy.ttf"
                    else
                        fontType = "fontCommon.TTF"
                    end
                    self.addSkillMoney[i] = cc.ui.UILabel.new({
                        UILabelType = 2,
                        font = fontType,
                        text = ""..ExcelHeroSkillData[HeroData[hero].skill[i]][GameData.heros["h"..hero].skill["s"..i]].money,
                        size = 19,
                        color = cc.c3b(255,255,255),
                        x = 272,
                        y = 16,
                        })
                    self.skillBg[i]:addChild(self.addSkillMoney[i])
                else
                    self.addSkillPonitButton[i]:setPosition(280,45)
                end
            else
                local fontType
                if VERSION_REDUCE then
                    fontType = "fontEasy.ttf"
                else
                    fontType = "fontCommon.TTF"
                end
                local unactiveSkillLabel = cc.ui.UILabel.new({
                    UILabelType = 2,
                    font = fontType,
                    text = kkFunc.getVersionHeroMesText("天赋技能"),
                    size = 20,
                    color = cc.c3b(84,72,53),
                    x = 90,
                    y = 22,
                    })
                self.skillBg[i]:addChild(unactiveSkillLabel)
                local unactiveIcon = display.newSprite("#unactiveIcon.png",280,45)
                self.skillBg[i]:addChild(unactiveIcon)
            end
        else
            local fontSize = 20
            if VERSION_REDUCE then
                fontSize = 18
            end
            local fontType
            if VERSION_REDUCE then
                fontType = "fontEasy.ttf"
            else
                fontType = "fontCommon.TTF"
            end
            local skillLevel = cc.ui.UILabel.new({
                UILabelType = 2,
                font = fontType,    
                text = kkFunc.getVersionHeroMesText("英雄技能开启",SkillData[HeroData[hero].skill[i]].heroLevel),
                size = fontSize,
                color = cc.c3b(255,255,255),
                x = 90,
                y = 19,
                })
            self.skillBg[i]:addChild(skillLevel)
        end
    end
end
function HeroHouse:setSkillPointsVisible(hero)
    local skillNum = 0
    for i = 1,#HeroData[hero].skill-1 do
        if GameData.heros["h"..hero].skill["s"..i] == #ExcelHeroSkillData[HeroData[hero].skill[i]] then
            skillNum = skillNum + 1
        end
    end
    if skillNum == #HeroData[hero].skill-1 then
        if self.fullSkillPoint ~= nil then
            self.fullSkillPoint:setVisible(false)
        end
        if self.buyButton ~= nil then
            self.buyButton:setVisible(false)
            self.purchaseSkillPointLabel:setVisible(false)
        end
        if self.leftSkillPoint ~= nil then
            self.leftSkillPoint:setVisible(false)
            self.timeStrLabel:setVisible(false)
        end
    end
end
function HeroHouse:skillLevelLessThanHeroLevel(hero)
    self.MaxLevelLayer = display.newLayer()
    self:addChild(self.MaxLevelLayer,21)
    self.MaxLevelLayer:setTouchSwallowEnabled(true)
    local grayBg = display.newColorLayer(cc.c4b(0,0,0,180)):addTo(self.MaxLevelLayer)
    local text,textTitle,sureButton,popBg
    if VERSION_REDUCE then
        sureButton = "#poplayerSure.png"
        popBg = display.newSprite("#poplayer.png",display.cx,display.cy):addTo(self.MaxLevelLayer)
        text = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionHeroMesText("技能等级上限"),
            size = 25,
            font = "fontEasy.ttf",
            dimensions = cc.size(280, 150),
            color = cc.c3b(255,255,255),
            x = popBg:getContentSize().width/2-135,
            y = 190,
        }):align(display.LEFT_TOP):addTo(popBg)  
    else
        sureButton = "#sureBuy.png"
        popBg = display.newSprite("#heroFun.png",display.cx,display.cy):addTo(self.MaxLevelLayer)
        text = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",    
            text = kkFunc.getVersionHeroMesText("技能等级上限"),
            size = 25,
            color = cc.c3b(255,255,255),
            x = popBg:getContentSize().width/2-160,
            y = 247,
        }):align(display.LEFT_TOP):addTo(popBg)
        -- textTitle = cc.ui.UILabel.new({
        --     text = "英雄一键满级",
        --     size = 25,
        --     color = cc.c3b(255,255,255),
        --     x = popBg:getContentSize().width/2,
        --     y = 240,
        -- }):align(display.CENTER):addTo(popBg)
    end
    self.sure = cc.ui.UIPushButton.new({
        normal = sureButton,
        disabled = sureButton,
        pressed = sureButton,
        })
        :onButtonPressed(function()
            self.sure:setScale(0.8)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(0.7)
        end)
        :onButtonClicked(function() 
            self.MaxLevelLayer:setVisible(false)
            if not VERSION_REDUCE then
                local function paycallback(result)
                    if result == "success" then
                        if GameData.heros["h"..hero].level < HeroData[hero].maxLevel then
                            GameData.heros["h"..hero].level = HeroData[hero].maxLevel
                            if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
                                if GameData.selectHero == hero then 
                                    self.war[hero]:setButtonImage("normal", "#heroMaxLevel.png")
                                    self.war[hero]:setButtonImage("disabled", "#heroMaxLevel.png")
                                    self.war[hero]:setButtonImage("pressed", "#heroMaxLevel.png")
                                    if self.cuePoint ~= nil then
                                        self.cuePoint:removeFromParent()
                                        self.cuePoint = nil 
                                    end
                                end
                                self.levelFull:setVisible(false)
                                self:performWithDelay(function()
                                    self.levelFull:removeFromParent()
                                    self.levelFull = nil        
                                end, 0.3) 
                                self.purchaseHero:removeFromParent()
                                local heroMaxLevel = display.newSprite("#heroMaxLevel.png",640,70)
                                self.bg:addChild(heroMaxLevel)
                                --英雄属性增加消失
                                for j = 1, 3 do
                                    self.natureUp[j]:removeFromParent()
                                    self.upgradeTo[j]:removeFromParent()
                                    self.nature[j]:setColor(cc.c3b(0,255,36))
                                    self.nature[j]:setPosition(80,62 + (2-j)*35)
                                end
                            end
                            self.herolevel:setString("LV."..GameData.heros["h"..hero].level)
                            self.nature[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp))
                            self.nature[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack))
                            self.nature[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70))
                            for i = 1,#HeroData[hero].skill do
                                if GameData.heros["h"..hero].skill["s"..i] == 0 then   
                                    GameData.heros["h"..hero].skill["s"..i] = 1     
                                end
                            end
                            self:refreshSkillBar(hero)
                            AchievementData.checkHeroUpgrade(hero)
                            GameState.save(GameData)
                            --DataEye
                                 --厦门
                            -- if device.platform == "android" or device.platform == "ios" then
                            --     --DCCoin.gain("玩家付费", "CNY", 12, 12)
                            --     --DCCoin.lost("英雄满级", "CNY", 12, 0)
                            --     DCVirtualCurrency.paymentSuccess("","英雄满级",12,"CNY",CHANLE_NAME)
                            -- end
                                 --厦门
                            kkFunc.popPaySuccessLayer()
                            self.MaxLevelLayer:removeFromParent()
                            self.MaxLevelLayer = nil
                        end
                    end
                end     
					--厦门计费点                 
                if TEST_DEMO then
                    --paycallback("success")
                else
                    --kkFunc.Pay(0,paycallback)
                end
					--厦门计费点	
            end          
        end)
        -- :pos(popBg:getContentSize().width/2, 55)
        :addTo(popBg)
    if not VERSION_REDUCE then
        self.sure:setScale(0.7)
        self.sure:setPosition(popBg:getContentSize().width/2+110, 57)
        self.buttonBack = cc.ui.UIPushButton.new({
        normal = "#buttonCancel.png",
        pressed = "#buttonCancel.png",
        disabled = "#buttonCancel.png",
        })
        :onButtonPressed(function()
            self.buttonBack:setScale(0.9)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.buttonBack:setScale(0.8)
        end)
        :onButtonClicked(function(event)
            --self:removeFromParent()
            self.MaxLevelLayer:removeFromParent()
            self.MaxLevelLayer = nil 
        end)
        :pos(popBg:getContentSize().width-25,popBg:getContentSize().height-60)
        :addTo(popBg)
        --:setScale(0.8)
        self.buttonBack:setScale(0.8)
    else
        self.sure:setPosition(popBg:getContentSize().width/2, 55)
    end
end

function HeroHouse:refreshSkillPointLabel(hero)
    if self.leftSkillPoint ~= nil then
        self.leftSkillPoint:removeFromParent()      
        self.leftSkillPoint = nil
    end
    if self.timeStrLabel ~= nil then
        self.timeStrLabel:removeFromParent()
        self.timeStrLabel = nil
    end
    if self.buyButton ~= nil then
        self.buyButton:removeFromParent()
        self.buyButton = nil
    end
    if self.purchaseSkillPointLabel ~= nil then
        self.purchaseSkillPointLabel:removeFromParent()
        self.purchaseSkillPointLabel = nil
    end
    if self.fullSkillPoint ~= nil then
        self.fullSkillPoint:removeFromParent()
        self.fullSkillPoint = nil
    end
    if GameData.skillPoints.value >= 5 then
        local fontType
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
        else
            fontType = "fontCommon.TTF"
        end
        self.fullSkillPoint = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = kkFunc.getVersionHeroMesText("技能点满"),
            size = 20,
            color = cc.c3b(157,125,74),
            x = 110,
            y = 455,
            })
        self.bg:addChild(self.fullSkillPoint)
    elseif GameData.skillPoints.value == 0 then
        self.buyButton = cc.ui.UIPushButton.new({
            normal = "#PurchaseSkillPoint.png",
            pressed = "#PurchaseSkillPoint.png",
            disabled = "#PurchaseSkillPoint.png",
            })
            :onButtonPressed(function()
                self.buyButton:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.buyButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                self:PurchaseSkillPoint(hero)
            end)
            :pos(130, 452)
            :addTo(self.bg)
        local fontType
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
        else
            fontType = "fontCommon.TTF" 
        end
        self.purchaseSkillPointLabel = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = kkFunc.getVersionHeroMesText("技能点不足",1),--"后获得一点技能"
            size = 20,
            color = cc.c3b(157,125,74),
            x = 170,
            y = 455,
            })
        self.bg:addChild(self.purchaseSkillPointLabel)
    else
        local fontType
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
        else
            fontType = "fontCommon.TTF" 
        end
        self.leftSkillPoint = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = kkFunc.getVersionHeroMesText("技能点未满"),
            size = 20,
            color = cc.c3b(157,125,74),
            x = 110,
            y = 455,
            })
        self.bg:addChild(self.leftSkillPoint)
        self.timeStrLabel = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = "",
            size = 20,
            color = cc.c3b(255,255,255),
            x = 290,
            y = 455,
            })
        self.bg:addChild(self.timeStrLabel)
        if GameData.skillPoints.startTime == 0 then
            GameData.skillPoints.startTime = kkFunc.getSystime()
            GameState.save(GameData)
        else
        end
    end
    --如果技能全满技能点隐掉
    self:setSkillPointsVisible(hero)
    --
    if GameData.heros["h"..self.hero].level == 0 then
        if self.fullSkillPoint ~= nil then
            self.fullSkillPoint:setVisible(false)
        end
        if self.buyButton ~= nil then
            self.buyButton:setVisible(false)
            self.purchaseSkillPointLabel:setVisible(false)
        end
        if self.leftSkillPoint ~= nil then
            self.leftSkillPoint:setVisible(false)
            self.timeStrLabel:setVisible(false)
        end
    end
end
--buySkillPoint
function HeroHouse:PurchaseSkillPoint(hero)
    self.purchaseSkillPointLayer = display.newLayer()
    self:addChild(self.purchaseSkillPointLayer,8)
    display.newColorLayer(cc.c4b(0,0,0,128)):addTo(self.purchaseSkillPointLayer,-1)
    self.purchaseSkillPointLayer:setTouchSwallowEnabled(true)
    local whiteBg = display.newSprite("#skillPointBg.png",display.cx,display.cy)
    self.purchaseSkillPointLayer:addChild(whiteBg)
    --diamond
    --local diamondPic= display.newSprite("#skillPointDiamond.png",290,170)
    --whiteBg:addChild(diamondPic)
    local titleMesTwo
    if VERSION_REDUCE then
        titleMesTwo = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionHeroMesText("购买技能点"),
            size = 22,
            dimensions = cc.size(320, 120),
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = 45,
            y = 170,
            })
    else
        titleMesTwo = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionHeroMesText("购买技能点"),
            size = 22,
            color = cc.c3b(255,255,255),
            x = 30,
            y = 200,
            })
    end
    -- local titleMesTwo = cc.ui.UILabel.new({
    --     text = kkFunc.getVersionHeroMesText("购买技能点"),
    --     size = 22,
    --     color = cc.c3b(255,255,255),
    --     x = 30,
    --     y = 170,
    --     })
    whiteBg:addChild(titleMesTwo)
    --[[local titleMesTwo = cc.ui.UILabel.new({
        text = "×6",
        size = 22,
        color = cc.c3b(255,202,58),
        x = 310,
        y = 168,
        })
    whiteBg:addChild(titleMesTwo)]]
    --
    self.sure = cc.ui.UIPushButton.new({
        normal = "#poplayerSure.png",
        disabled = "#poplayerSure.png",
        pressed = "#poplayerSure.png",
        })
        :onButtonPressed(function()
            self.sure:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(1)
        end)
        :onButtonClicked(function() 
            if GameData.diamond >= 6 then
                GameData.diamond = GameData.diamond - 6
                GameData.skillPoints.value = 5
                g_infoLayer.diamondLabel:setString(""..GameData.diamond)
                GameState.save(GameData)
                self:refreshSkillPointLabel(hero)
                self.purchaseSkillPointLayer:removeFromParent()
                self.purchaseSkillPointLayer = nil
                AchievementData.checkDiamond(6)
                --DataEye
                     --厦门
                -- if device.platform == "android" or device.platform == "ios" then
                --     --DCCoin.gain("花钻石购买技能点", "技能点", 5, 5)
                --     DCCoin.lost("花钻石购买技能点", "钻石", 6, GameData.diamond)
                -- end
                     --厦门
                if not VERSION_REDUCE then
                    for i = 1,#HeroData[hero].skill do
                        if self.addSkillPonitButton[i] ~= nil then
                            if GameData.skillPoints.value >= 5 and GameData.heros["h"..hero].skill["s"..i] ~= #ExcelHeroSkillData[HeroData[hero].skill[i]] then
                                self.achievePoint[i] = display.newSprite("#achievementTipPoint.png",22,22)
                                self.achievePoint[i]:setScale(0.7)
                                self.addSkillPonitButton[i]:addChild(self.achievePoint[i])
                            end
                        end
                    end
                end
            else
                if VERSION_REDUCE then
                    g_infoLayer:popLayer("钻石")
                else
                    --厦门修改
                     g_infoLayer:popLayer("钻石")
                    -- if kkFunc.simplifyPurchaseSwitch() then
                    --     kkFunc.simplifyPurchaseSdkCallBack(5)
                    -- else
                    --     g_infoLayer:popLayer("钻石")
                    -- end
                    --厦门修改
                end
            end
        end)
        :pos(286, 50)
        :addTo(whiteBg)
    self.cancle = cc.ui.UIPushButton.new({
        normal = "#poplayerCancle.png",
        disabled = "#poplayerCancle.png",
        pressed = "#poplayerCancle.png",
        })
        :onButtonPressed(function()
            self.cancle:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.cancle:setScale(1)
        end)
        :onButtonClicked(function()
            self.purchaseSkillPointLayer:removeFromParent()
            self.purchaseSkillPointLayer = nil
        end)
        :pos(98, 50)
        :addTo(whiteBg)
end
function HeroHouse:showSkillPointTime()
    self.timeSec = 300  --111111
    local Sub = math.floor((kkFunc.getSystime() - GameData.skillPoints.startTime)%300)
	self.timeSec = 300 - Sub
    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
        self:update(dt) 
    end)
    self:scheduleUpdate()
end

function HeroHouse:refresh()
    GameData.skillPoints.value = GameData.skillPoints.value + 1
    self:unscheduleUpdate()
    self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
    if GameData.skillPoints.value >= 5 then
        if not VERSION_REDUCE then
            for i = 1,#HeroData[self.hero].skill do
                if self.addSkillPonitButton[i] ~= nil then
                    if GameData.heros["h"..self.hero].skill["s"..i] ~= #ExcelHeroSkillData[HeroData[self.hero].skill[i]] then
                        self.achievePoint[i] = display.newSprite("#achievementTipPoint.png",22,22)
                        self.achievePoint[i]:setScale(0.7)
                        self.addSkillPonitButton[i]:addChild(self.achievePoint[i])
                    end
                end
            end
        end 
        if self.timeStrLabel ~= nil then
            self.timeStrLabel:removeFromParent()
            self.timeStrLabel = nil
            self:refreshSkillPointLabel(self.hero)
        end
    elseif GameData.skillPoints.value == 1 then
        self:refreshSkillPointLabel(self.hero)
        GameData.skillPoints.startTime = kkFunc.getSystime()
        self:showSkillPointTime()
    else 
        if self.timeStrLabel ~= nil then
            self.leftSkillPoint :setString(kkFunc.getVersionHeroMesText("技能点未满"))
            GameData.skillPoints.startTime = kkFunc.getSystime()
            self:showSkillPointTime()
        end
    end   
    GameState.save(GameData)
end

function HeroHouse:update(dt)
    local timeNow = self.timeSec - dt
    if math.floor(timeNow) < math.floor(self.timeSec) then
        self.timeStr = kkFunc.getTimeLabelFromSecond(math.floor(timeNow))
        if self.timeStrLabel ~= nil then
            self.timeStrLabel:setString("("..self.timeStr..")")
        end
        if self.purchaseSkillPointLabel ~= nil then
           self.purchaseSkillPointLabel:setString(kkFunc.getVersionHeroMesText("技能点不足",self.timeStr))
        end
    end
    self.timeSec = timeNow
    if self.timeSec <= 0 then
        self:refresh()
    end
end
function HeroHouse:showSkillIntroduce(idx)
    if self.skillTextBg ~= nil and self.skillTextBg:isVisible() then
        self.skillTextBg:setVisible(false)
    elseif self.skillTextBg ~= nil and not self.skillTextBg:isVisible() then
        self.skillTextBg:setVisible(true)
    end
    self.skillTextBgIdx = idx
    self.touchLayer:setTouchSwallowEnabled(true)
    local heroSkillLevel = GameData.heros["h"..self.hero].skill["s"..idx]
    if heroSkillLevel == 0 then
        heroSkillLevel = heroSkillLevel + 1
    end
    if self.skillTextBg == nil then
        self.skillTextBg = display.newScale9Sprite("#skillDialogBg.png",380,380-90*(idx-1),cc.size(300,150))
        self.bg:addChild(self.skillTextBg,5)
        self.skillTextBg:setAnchorPoint(cc.p(0,0.5))
        if VERSION_REDUCE then
            self.skillIntroMes = cc.ui.UILabel.new({
                UILabelType = 2,
                text = kkFunc.getVersionHeroMesText("英雄技能介绍",HeroData[self.hero].skill[idx]),
                size = 17,
                font = "fontEasy.ttf",
                dimensions = cc.size(260, 150),
                color = cc.c3b(255,255,255),
                x = 35,
                y = 135,
                }):align(display.LEFT_TOP)
        else
            self.skillIntroMes = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",
                text = kkFunc.getVersionHeroMesText("英雄技能介绍",HeroData[self.hero].skill[idx]),
                size = 20,
                color = cc.c3b(255,255,255),
                x = 35,
                y = 135,
                }):align(display.LEFT_TOP)
        end
        -- self.skillIntroMes = cc.ui.UILabel.new({
        --     text = kkFunc.getVersionHeroMesText("英雄技能介绍",HeroData[self.hero].skill[idx]),
        --     size = 20,
        --     color = cc.c3b(255,255,255),
        --     x = 35,
        --     y = 135,
        --     }):align(display.LEFT_TOP)
        self.skillTextBg:addChild(self.skillIntroMes)
        --主动技能有数据
        if SkillData[HeroData[self.hero].skill[idx]].passive == nil then
            if VERSION_REDUCE then
                self.skillIntroMes2 = cc.ui.UILabel.new({
                    UILabelType = 2,
                    text = string.format(tostring(kkFunc.showVersionSkillIntroduce("主动技能介绍",HeroData[self.hero].skill[idx])), ExcelHeroSkillData[HeroData[self.hero].skill[idx]][heroSkillLevel].value),
                    font = "fontEasy.ttf",
                    size = 17,
                    color = cc.c3b(253,211,69),
                    x = 35,
                    y = 40,
                    }):align(display.LEFT_TOP)
            else
                self.skillIntroMes2 = cc.ui.UILabel.new({
                    UILabelType = 2,
                    font = "fontCommon.TTF",
                    text = string.format(tostring(kkFunc.showVersionSkillIntroduce("主动技能介绍",HeroData[self.hero].skill[idx])), ExcelHeroSkillData[HeroData[self.hero].skill[idx]][heroSkillLevel].value),
                    size = 18,
                    color = cc.c3b(253,211,69),
                    x = 35,
                    y = 40,
                    }):align(display.LEFT_TOP)
            end
            -- self.skillIntroMes2 = cc.ui.UILabel.new({
            --     text = string.format(tostring(kkFunc.showVersionSkillIntroduce("主动技能介绍",HeroData[self.hero].skill[idx])), ExcelHeroSkillData[HeroData[self.hero].skill[idx]][heroSkillLevel].value),
            --     size = 18,
            --     color = cc.c3b(253,211,69),
            --     x = 35,
            --     y = 40,
            --     }):align(display.LEFT_TOP)
            --self.skillIntroMes2:setVisible(false)
            self.skillTextBg:addChild(self.skillIntroMes2)
        end
    else
        self.skillTextBg:setPosition(380,380-90*(idx-1))
        self.skillIntroMes:setString(kkFunc.getVersionHeroMesText("英雄技能介绍",HeroData[self.hero].skill[idx]))
        if SkillData[HeroData[self.hero].skill[idx]].passive == nil then
            if self.skillIntroMes2 ~= nil then
                self.skillIntroMes2:removeFromParent()
                self.skillIntroMes2 = nil
            end
            if VERSION_REDUCE then
                self.skillIntroMes2 = cc.ui.UILabel.new({
                    UILabelType = 2,
                    text = string.format(tostring(kkFunc.showVersionSkillIntroduce("主动技能介绍",HeroData[self.hero].skill[idx])), ExcelHeroSkillData[HeroData[self.hero].skill[idx]][heroSkillLevel].value),
                    font = "fontEasy.ttf",
                    size = 17,
                    color = cc.c3b(253,211,69),
                    x = 35,
                    y = 40,
                    }):align(display.LEFT_TOP)
            else
                self.skillIntroMes2 = cc.ui.UILabel.new({
                    UILabelType = 2,
                    font = "fontCommon.TTF",
                    text = string.format(tostring(kkFunc.showVersionSkillIntroduce("主动技能介绍",HeroData[self.hero].skill[idx])), ExcelHeroSkillData[HeroData[self.hero].skill[idx]][heroSkillLevel].value),
                    size = 18,
                    color = cc.c3b(253,211,69),
                    x = 35,
                    y = 40,
                    }):align(display.LEFT_TOP)
            end
            -- self.skillIntroMes2 = cc.ui.UILabel.new({
            --     text = string.format(tostring(kkFunc.showVersionSkillIntroduce("主动技能介绍",HeroData[self.hero].skill[idx])), ExcelHeroSkillData[HeroData[self.hero].skill[idx]][heroSkillLevel].value),
            --     size = 18,
            --     color = cc.c3b(253,211,69),
            --     x = 35,
            --     y = 40,
            --     }):align(display.LEFT_TOP)
            --self.skillIntroMes2:setVisible(false)
            self.skillTextBg:addChild(self.skillIntroMes2)
        else
            if self.skillIntroMes2 ~= nil then
                self.skillIntroMes2:removeFromParent()
                self.skillIntroMes2 = nil
            end
        end
    end
end
function HeroHouse:showTouchTip(x,y)
    if self.skillTextBg ~= nil and self.skillTextBg:isVisible() then
        self.skillTextBg:setVisible(false)
    end
    local recordnum = 0
    if self.bg ~= nil then 
        for i=1,4 do
            if self.skillBg[i] ~= nil then
                local touchRect = self.skillBg[i]:getCascadeBoundingBox()
                if self.addSkillPonitButton[i] ~= nil then
                    local buttonRect = self.addSkillPonitButton[i]:getCascadeBoundingBox()
                    if cc.rectContainsPoint(buttonRect, cc.p(x,y)) then
                        self:performWithDelay(function()
                            self.touchLayer:setTouchSwallowEnabled(false)
                        end, 0.2)
                        return
                    end
                end
                if cc.rectContainsPoint(touchRect, cc.p(x,y)) then
                    if self.skillTextBgIdx == i then
                        self.touchLayer:setTouchSwallowEnabled(false)
                        self.skillTextBgIdx = 5
                    else
                        self:showSkillIntroduce(i)
                    end
                else
                    recordnum = recordnum + 1
                end
            end
        end
        if recordnum == #self.skillBg then
            self.skillTextBgIdx = 5
            self:performWithDelay(function()
                self.touchLayer:setTouchSwallowEnabled(false)
            end, 0.2)
        end      
    end
end
function HeroHouse:LevelFull(hero)
    if GameData.heros["h"..hero].level < HeroData[hero].maxLevel then
        GameData.heros["h"..hero].level = HeroData[hero].maxLevel
        if GameData.heros["h"..hero].level == HeroData[hero].maxLevel then
            self.levelFull:setVisible(false)
            self:performWithDelay(function()
                self.levelFull:removeFromParent()
                self.levelFull = nil        
            end, 0.3) 
            self.purchaseHero:removeFromParent()
            local heroMaxLevel = display.newSprite("#heroMaxLevel.png",640,70)
            self.bg:addChild(heroMaxLevel)
            --英雄属性增加消失
            for j = 1, 3 do
                self.natureUp[j]:removeFromParent()
                self.upgradeTo[j]:removeFromParent()
                self.nature[j]:setColor(cc.c3b(0,255,36))
                self.nature[j]:setPosition(80,62 + (2-j)*35)
            end
        end
        self.herolevel:setString("LV."..GameData.heros["h"..hero].level)
        self.nature[1]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].hp))
        self.nature[2]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].attack))
        self.nature[3]:setString(""..math.floor(ExcelHeroData[hero][GameData.heros["h"..hero].level].speed*70))
        for i = 1,#HeroData[hero].skill do
            if GameData.heros["h"..hero].skill["s"..i] == 0 then   
                GameData.heros["h"..hero].skill["s"..i] = 1     
            end
        end
        self:refreshSkillBar(hero)
        kkFunc.popPaySuccessLayer()
    end
end
function HeroHouse:onTouch(event, x, y)
    --print(event, x, y)
    if event == "began" then
        if self.bg then
            if self.purchaseSkillPointLayer ~= nil then return end
            self:showTouchTip(x,y)
        end
        self.moved = false
        self.beginX = x
        return true
    elseif event == "moved" then
        if math.abs(x-self.beginX) < 5 then
            self.moved = false
        else
            self.moved = true
        end
    elseif event == "ended" then
        if self.moved or self.nextScene then return end 
        for i = 1,4 do
            if self.scrollView ~= nil then
                local rect = self.heroBg[i]:getCascadeBoundingBox()
                local buttonRect = self.war[i]:getCascadeBoundingBox()
                if (cc.rectContainsPoint(buttonRect, cc.p(x,y)) and GameData.selectHero ~= i)
                    or (cc.rectContainsPoint(buttonRect, cc.p(x,y)) and GameData.heros["h"..i].level == HeroData[i].maxLevel) then
                    return
                end
                if cc.rectContainsPoint(rect, cc.p(x,y)) then 
                    self.returnLayerControl = 2
                    self.nextScene = true
                    self.scrollView:setVisible(false)
                    self.titleBg:setVisible(false)
                    self.herohouseWhiteBg:setVisible(false)
                    self.scrollView:setTouchCaptureEnabled(false)
                    --self.touchLayer:setTouchEnabled(false)                        
                    self.fullSkillPoint = nil
                    self.leftSkillPoint = nil
                    self.timeStrLabel = nil
                    self.buyButton = nil
                    self.purchaseSkillPointLabel = nil
                    self:HeroUpgrade(i)
                    return
                end
            end
        end  
    end
end
function HeroHouse:onEnter()
    --安卓返回键

         --厦门返回键
    if device.platform == "android" then
        local layer = display.newLayer()
        layer:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
            if event.key == "back" then
                if self.purchaseSkillPointLayer ~= nil then
                    self.purchaseSkillPointLayer:removeFromParent()
                    self.purchaseSkillPointLayer = nil
                elseif self.MaxLevelLayer ~= nil then
                    self.MaxLevelLayer:removeFromParent()
                    self.MaxLevelLayer = nil
                elseif g_infoLayer.poplayer ~=nil then
                    g_infoLayer:RemovePop()
                elseif g_infoLayer.shopLayer ~= nil then
                    g_infoLayer.shopLayer:Remove()
                else
                    self:ReturnBack()
                end
            end
        end)
        self:addChild(layer)
        layer:setTouchSwallowEnabled(false)
        layer:setKeypadEnabled(true)
    end
         --厦门返回键

    -- 注册touch事件处理函数
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)
    if NEW_GUIDE and GameData.guide.level1 == true and GameData.guide.herohouse == false then
        self.newbieguidelayer = NewbieGuideLayer.new()
        self:addChild(self.newbieguidelayer,21)
    end
end
function HeroHouse:onExit()
    ResData.removeRes("UI_HEROHOUSEUI")
    ResData.removeRes("UI_HEROHOUSEANI")
end
return HeroHouse