--
-- Author: Wangzhihao
-- Date: 2015-06-17 14:21:16
--
local LevelInfoLayer = import(".LevelInfoLayer")
local LevelButtonScene = class("LevelButtonScene", function()
    return display.newScene("LevelButtonScene")
end)
function LevelButtonScene:ctor(params)
	self.themeNum = params.themeNum
	self.infoLayer = LevelInfoLayer.new(3)
    self:addChild(self.infoLayer,20)
    --
    self.levelBackButton = cc.ui.UIPushButton.new({
        normal = "#returnNew.png",
        pressed = "#returnNew.png",
        disabled = "#returnNew.png",
        })
        :onButtonPressed(function()
            self.levelBackButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.levelBackButton:setScale(1)
        end)
        :onButtonClicked(function(event)
            app:level()
        end)
        :pos(display.cx-380, display.height-50)
        :addTo(self)
    self:createButtons(self.themeNum)
end

function LevelButtonScene:createButtons(themeNum)
	local col = 5
    for i = 1, 10 do
        local dd = i - math.floor((i-1)/col)*col
        local x = display.cx - ((col+1)/2-dd)*130
        local y = display.height-90-70*math.floor((i+col-1)/col)
        cc.ui.UIPushButton.new({})
            :setButtonLabel("normal", cc.ui.UILabel.new({
                UILabelType = 2,
                text = ""..themeNum*100+i,
                align = ui.TEXT_ALIGN_CENTER,
                size = 30,
            }))
            :onButtonClicked(function()
                app:play({level = themeNum*100+i})               
            end)
            :pos(x, y)
            :addTo(self)
    end
end

return LevelButtonScene