--
-- Author: KK
-- Date: 2014-09-01 10:55:47
--

g_infoLayer = nil
local ShopLayer = import("..views.ShopLayer")
local LevelInfoLayer = class("LevelInfoLayer", function()
    return display.newLayer()
end)

--type == 1 选关页面
--type == 2 兔子家页面
function LevelInfoLayer:ctor(type)
    --用于记录上方图标坐标
    self.TopPic = {Coin = cc.p(0,0),Energy = cc.p(0,0),Diamond = cc.p(0,0)}
    -- 注册touch事件处理函数
    self:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self:setTouchEnabled(true)
    self:setTouchSwallowEnabled(false)
	self:showTopInfo(type)
    g_infoLayer = self
    self.shopLayer = nil
end

--星星不够弹出框
function LevelInfoLayer:popNeedStarLayer(num)
    self.poplayer = display.newLayer()
    self:getParent():addChild(self.poplayer,19)
    self.poplayer:setTouchSwallowEnabled(true)
    local popBg = display.newSprite("#poplayer.png",display.cx,display.cy)
    self.poplayer:addChild(popBg)
    local textMess = cc.ui.UILabel.new({
        text = "获得"..num.."颗星星才能开启。",
        size = 30,
        color = cc.c3b(36,75,91),
        x = 200,
        y = 170,
        }):align(display.CENTER)
    popBg:addChild(textMess)
    self.sure = cc.ui.UIPushButton.new({
        normal = "#poplayerSure.png",
        disabled = "#poplayerSure.png",
        pressed = "#poplayerSure.png",
        })
        :onButtonPressed(function()
            self.sure:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(1)
        end)
        :onButtonClicked(function() 
            self.poplayer:removeFromParent()
        end)
        :pos(190, 70)
        :addTo(popBg)
    --音效
    SoundManager.playSound(GAME_SOUND.Menu)
end

--弹出框
function LevelInfoLayer:popLayer(text)
    local number
    local titlePic 
    local textChange = kkFunc.getVersionPrepareText(text)
    if text == "金币" then
        number = 1
        titlePic = "#coinNotEnough.png"
    elseif text == "体力" then
        number = 3
        titlePic = "#energyNotEnough.png"
    elseif text == "钻石" then
        number = 2
        titlePic = "#diamondNotEnough.png"
	else
		return
    end
    self.poplayer = display.newLayer()
    self:getParent():addChild(self.poplayer,22)
    self.poplayer:setTouchSwallowEnabled(true)
    local layercolor = cc.LayerColor:create(cc.c4b(0,0,0,128),display.width,display.height)
    self.poplayer:addChild(layercolor,-1)
    local popBg = display.newSprite("#poplayer.png",display.cx,display.cy)
    self.poplayer:addChild(popBg)
    local title = display.newSprite(titlePic,182,239)
    if text == "体力" then
        title:setScale(0.85)
    end
    popBg:addChild(title)
    local fontSize = 28
    if VERSION_REDUCE then 
        fontSize = 20
    end
    local textMess
    if VERSION_REDUCE then
        textMess = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionPrepareText("游戏币不足",textChange),
            font = "fontEasy.ttf",
            size = fontSize,
            dimensions = cc.size(260, 150),
            color = cc.c3b(255,255,255),
            x = 60,
            y = 190,
            }):align(display.LEFT_TOP)
    else
        textMess = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionPrepareText("游戏币不足",textChange),
            size = fontSize,
            color = cc.c3b(255,255,255),
            x = 182,
            y = 150,
            }):align(display.CENTER)
    end

    popBg:addChild(textMess)
    self.sure = cc.ui.UIPushButton.new({
        normal = "#poplayerSure.png",
        disabled = "#poplayerSure.png",
        pressed = "#poplayerSure.png",
        })
        :onButtonPressed(function()
            self.sure:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(1)
        end)
        :onButtonClicked(function()
            if g_infoLayer.shopLayer == nil then
                self.shopLayer = ShopLayer.new(number)
                self:getParent():addChild(self.shopLayer,19)
            elseif number == 1 then
                g_infoLayer.shopLayer:getCarrotContent()
            elseif number == 2 then
                g_infoLayer.shopLayer:getDiamondContent()
            elseif number == 3 then
                g_infoLayer.shopLayer:getEnergyContent()
            end
            self:RemovePop()
        end)
        :pos(275, 55)
        :addTo(popBg)
    self.cancle = cc.ui.UIPushButton.new({
        normal = "#poplayerCancle.png",
        disabled = "#poplayerCancle.png",
        pressed = "#poplayerCancle.png",
        })
        :onButtonPressed(function()
            self.cancle:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.cancle:setScale(1)
        end)
        :onButtonClicked(function()
            self:RemovePop()
        end)
        :pos(90, 55)
        :addTo(popBg)
    --音效
    SoundManager.playSound(GAME_SOUND.Menu)
end

function LevelInfoLayer:RemovePop()
    self.poplayer:removeFromParent()
    self.poplayer = nil--返回键判断用
end

--体力、萝卜、钻石
function LevelInfoLayer:showTopInfo(type)
    if type == 3 then
        self:addInfos({
            barOne = cc.p(display.cx -220,display.height-50),
            barTwo = cc.p(display.cx+35,display.height-50),
            barThree = cc.p(display.cx+290,display.height-50),
        })        
    end
end

function LevelInfoLayer:addInfos(params)
    self.control = true
    if params.barOne ~= nil then
        local carrotBar = display.newScale9Sprite("#buttonBg.png", params.barTwo.x,params.barTwo.y, cc.size(180, 46))
        --local carrotBar = display.newSprite("#ui_moneyBar.png",params.barTwo.x,params.barTwo.y)
        self:addChild(carrotBar)
        --
        local fontType
        local fontType2
        local uiLabelType
        local uiLabelType2
        if VERSION_MONSTER then
            uiLabelType = 2
            uiLabelType2 = 2
            fontType = "fontCommon.TTF" 
            fontType2 = "fontCommon.TTF"       
        else
            uiLabelType = 1
            uiLabelType2 = ((GameData.energy.value == -1) and 2) or 1
            fontType = "fontTitleNumber.fnt"
            fontType2 = ((GameData.energy.value == -1) and "fontCommon.TTF" ) or "fontTitleNumber.fnt"            
        end
        self.carrotLabel = cc.ui.UILabel.new({
            UILabelType = uiLabelType,
            text = GameData.carrot,
            font = fontType,
            size = 28,
            align = ui.TEXT_ALIGN_LEFT,
            x = carrotBar:getContentSize().width/2,
            y = carrotBar:getContentSize().height/2,
        }):align(display.CENTER)
        carrotBar:addChild(self.carrotLabel)
        local carrotPic = display.newSprite("#coinNew.png",0,25)
        carrotBar:addChild(carrotPic)
        self.TopPic.Coin = carrotPic:convertToWorldSpace(cc.p(carrotPic:getPosition()))
        self.TopPic.Coin.x = self.TopPic.Coin.x + carrotPic:getContentSize().width/2
        --[[local coinLight = display.newSprite("#ui_coinLight.png",18,55)
        carrotPic:addChild(coinLight)
        coinLight:setScale(0)
        coinLight:runAction(cc.RepeatForever:create(transition.sequence({
            cc.DelayTime:create(math.random(2,5)),                       
            cc.Spawn:create(
                cc.RotateBy:create(0.5,-360),
                cc.ScaleTo:create(0.5,0.6)
            ),
            cc.RotateBy:create(0.25,-180),
            cc.Spawn:create(
                cc.RotateBy:create(1,-640),
                cc.ScaleTo:create(1,0)
            )
        })))]]
        self.addCoinButton = cc.ui.UIPushButton.new({
            normal = "#addNew.png",
            disabled = "#addNew.png",
            pressed = "#addNew.png",
            })
            :onButtonPressed(function()
                self.addCoinButton:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.addCoinButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                if self.shopLayer == nil then
                    self.shopLayer = ShopLayer.new(1)
                    self:getParent():addChild(self.shopLayer,19)
                else
                    self.shopLayer:getCarrotContent()
                end
                --[[if self.shopLayer ~= nil then
                    self.shopLayer:removeFromParent()
                    self.shopLayer = nil 
                end
                self:performWithDelay(function()
                    self.shopLayer = ShopLayer.new(1)
                    self:getParent():addChild(self.shopLayer,19)
                end, 0.1)]]             
            end)
            :pos(carrotBar:getContentSize().width, 25)
            :addTo(carrotBar)
        --
        -- local num = math.floor((kkFunc.getSystime() - GameData.energy.startTime)/300) 
        -- GameData.energy.value = GameData.energy.value + num
        -- if GameData.energy.value > 5 then
        --     GameData.energy.value = 5
        --     GameState.save(GameData)
        -- end
        local bloodBar = display.newScale9Sprite("#buttonBg.png", params.barOne.x,params.barOne.y, cc.size(160, 46))
        --local bloodBar = display.newSprite("#ui_lifeBar.png",params.barOne.x,params.barOne.y)
        self:addChild(bloodBar)
        ---------------------------------
		local fontSize
		if VERSION_REDUCE then
			fontSize = 40
		else
			fontSize = 22
		end
        self.energyLabel = cc.ui.UILabel.new({
            UILabelType = uiLabelType2,
            text = self:GetEnergyLabel(),
            font = fontType2,
            size = fontSize,
            x = bloodBar:getContentSize().width/2,
            y = bloodBar:getContentSize().height/2,
        }):align(display.CENTER)
        bloodBar:addChild(self.energyLabel)
        local bloodPic = display.newSprite("#bloodNew.png",0,25)
        bloodBar:addChild(bloodPic)
        self.TopPic.Energy = bloodPic:convertToWorldSpace(cc.p(bloodPic:getPosition()))
        self.TopPic.Energy.x = self.TopPic.Energy.x + bloodPic:getContentSize().width/2
        self.addEnergyButton = cc.ui.UIPushButton.new({
            normal = "#addNew.png",
            disabled = "#addNew.png",
            pressed = "#addNew.png",
            })
            :onButtonPressed(function()
                self.addEnergyButton:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.addEnergyButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                if GameData.energy.value == -1 then
                    self.FullEnergy = display.newLayer()
                    self:addChild(self.FullEnergy)
                    self.FullEnergy:setTouchSwallowEnabled(true)
                    local grayBg = display.newColorLayer(cc.c4b(0,0,0,180)):addTo(self.FullEnergy)
                    local popBg = display.newSprite("#poplayer.png",display.cx,display.cy):addTo(self.FullEnergy)
                    --local title = display.newSprite("#energyNotEnough.png",popBg:getContentSize().width/2,240):addTo(popBg)
                    local text
                    if VERSION_REDUCE then
                        text = cc.ui.UILabel.new({
                            UILabelType = 2,
                            text = kkFunc.getVersionPrepareText("无限体力"),
                            size = 24,
                            font = "fontEasy.ttf",
                            color = cc.c3b(255,255,255),
                            dimensions = cc.size(290, 150),
                            x = popBg:getContentSize().width/2-140,
                            y = 190,
                            }):align(display.LEFT_TOP):addTo(popBg)
                    else
                        text = cc.ui.UILabel.new({
                            UILabelType = 2,
                            font = "fontCommon.TTF",
                            text = kkFunc.getVersionPrepareText("无限体力"),
                            size = 28,
                            color = cc.c3b(255,255,255),
                            x = popBg:getContentSize().width/2+10,
                            y = 150,
                            }):align(display.CENTER):addTo(popBg)
                    end
                    -- local text = cc.ui.UILabel.new({
                    -- text = kkFunc.getVersionPrepareText("无限体力"),
                    -- size = 28,
                    -- color = cc.c3b(255,255,255),
                    -- x = popBg:getContentSize().width/2+10,
                    -- y = 150,
                    -- }):align(display.CENTER):addTo(popBg)           
                    self.sure = cc.ui.UIPushButton.new({
                    normal = "#poplayerSure.png",
                    disabled = "#poplayerSure.png",
                    pressed = "#poplayerSure.png",
                    })
                    :onButtonPressed(function()
                        self.sure:setScale(1.1)
                        --音效
                        SoundManager.playSound(GAME_SOUND.Button2)
                    end)
                    :onButtonRelease(function()
                        self.sure:setScale(1)
                    end)
                    :onButtonClicked(function()           
                        self.FullEnergy:removeFromParent()
                        self.FullEnergy = nil
                    end)
                    :pos(popBg:getContentSize().width/2, 55)
                    :addTo(popBg)
                    --音效
                    SoundManager.playSound(GAME_SOUND.Menu)
                elseif self.shopLayer == nil then
                    self.shopLayer = ShopLayer.new(3)
                    self:getParent():addChild(self.shopLayer,19)
                else
                    self.shopLayer:getEnergyContent()
                end
                --[[if self.shopLayer ~= nil then
                    self.shopLayer:removeFromParent()
                    self.shopLayer = nil 
                end
                self:performWithDelay(function()
                    self.shopLayer = ShopLayer.new(3)
                    self:getParent():addChild(self.shopLayer,19)
                end, 0.1)]]
            end)
            :pos(bloodBar:getContentSize().width, 25)
            :addTo(bloodBar)
        --体力时间
        self.timePos = cc.p(params.barOne)
        if GameData.energy.value < 5 and GameData.energy.value ~= -1 then
            local timeOK = kkFunc.checkTimer()
            if timeOK then
                self:showEnergyTime(self.timePos)
            end
        end
        local diamondBar = display.newScale9Sprite("#buttonBg.png", params.barThree.x,params.barThree.y, cc.size(160, 46))
        --local diamondBar = display.newSprite("#ui_moneyBar.png",params.barThree.x,params.barThree.y)
        self:addChild(diamondBar)
        self.diamondLabel = cc.ui.UILabel.new({
            UILabelType = uiLabelType,
            text = GameData.diamond,
            font = fontType,
            size = 28,
            x = diamondBar:getContentSize().width/2,
            y = diamondBar:getContentSize().height/2,
        }):align(display.CENTER)
        diamondBar:addChild(self.diamondLabel)
        local diamondPic = display.newSprite("#diamondNew.png",0,25)
        diamondBar:addChild(diamondPic)
        self.TopPic.Diamond = diamondPic:convertToWorldSpace(cc.p(diamondPic:getPosition()))
        self.TopPic.Diamond.x = self.TopPic.Diamond.x + diamondPic:getContentSize().width/2
        self.addDiamondButton = cc.ui.UIPushButton.new({
            normal = "#addNew.png",
            disabled = "#addNew.png",
            pressed = "#addNew.png",
            })
            :onButtonPressed(function()
                self.addDiamondButton:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.addDiamondButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                if self.shopLayer == nil then
                    self.shopLayer = ShopLayer.new(2)
                    self:getParent():addChild(self.shopLayer,19)
                else
                    self.shopLayer:getDiamondContent()
                end
                --[[if self.shopLayer ~= nil then
                    self.shopLayer:removeFromParent()
                    self.shopLayer = nil 
                end
                self:performWithDelay(function()
                    self.shopLayer = ShopLayer.new(2)
                    self:getParent():addChild(self.shopLayer,19)
                end, 0.1)]]
            end)
            :pos(diamondBar:getContentSize().width, 25)
            :addTo(diamondBar)
        
    end
end
function LevelInfoLayer:showEnergyTime(position)
    if GameData.energy.value == -1 then
        return
    end
    self.timeSec = 300
    local Sub = math.floor((kkFunc.getSystime() - GameData.energy.startTime)%300)
    self.timeSec = ((Sub>0) and (300 - Sub)) or 300--防止由于手机初始时间不正确导致bug
    local timeStr = kkFunc.getTimeLabelFromSecond(self.timeSec)
    self.num = math.floor((kkFunc.getSystime() - GameData.energy.startTime)/300)
    if (self.num<=5) and (self.num>0) then--防止由于手机初始时间不正确导致bug
        GameData.energy.value = GameData.energy.value + self.num
    elseif self.num >5 then
        GameData.energy.value = GameData.energy.value + 5
    end
    if self.num > 0 then
        GameData.energy.startTime = kkFunc.getSystime()
        GameState.save(GameData)
    end

    if GameData.energy.value > 5 then 
        GameData.energy.value = 5
        GameState.save(GameData)
        
    end
    self.energyLabel:setString(""..GameData.energy.value)
    local fontType
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
        else
            fontType = "fontCommon.TTF"
        end
    if GameData.energy.value < 5 then--避免体力小于5还有时间显示
        --时间
        self.timeLabel = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = timeStr,
            size = 20,
            align = ui.TEXT_ALIGN_CENTER,
            x = position.x + 26,
            y = position.y-32,
        })
        self:addChild(self.timeLabel)

         
        if self.control == true then
            self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
                self:update(dt) 
            end)
            self:scheduleUpdate()
        end
    end
end

function LevelInfoLayer:refresh()
    self.diamondLabel:setString(""..GameData.diamond)
    self.carrotLabel:setString(""..GameData.carrot)
    self.energyLabel:setString(self:GetEnergyLabel())
    if GameData.energy.value >= 5 or GameData.energy.value == -1 then
        self:unscheduleUpdate()
        self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
        if self.timeLabel ~= nil then
            self.timeLabel:removeFromParent()
            self.timeLabel = nil
        end
    else 
        if self.timeLabel ~= nil then
            self:unscheduleUpdate()
            self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
            self.timeLabel:removeFromParent()
            GameData.energy.startTime = kkFunc.getSystime()
            self:showEnergyTime(self.timePos) 
        end
    end
    
    GameState.save(GameData)
end

function LevelInfoLayer:update(dt)
    local timeNow = self.timeSec - dt
    if math.floor(timeNow) < math.floor(self.timeSec) then
        local timeStr = kkFunc.getTimeLabelFromSecond(math.floor(timeNow))
        self.timeLabel:setString(timeStr)
    end
    self.timeSec = timeNow
    if self.timeSec <= 0 then
        GameData.energy.value = GameData.energy.value + 1       
        self:refresh()
    end
end

function LevelInfoLayer:GetEnergyLabel(label)
    if VERSION_REDUCE then
        return (GameData.energy.value ~= -1 and GameData.energy.value) or "∞"
    else
        return (GameData.energy.value ~= -1 and GameData.energy.value) or "无限"
    end
end

function LevelInfoLayer:EnergyLabelChange()
    local parent = self.energyLabel:getParent()
    self.energyLabel:removeFromParent()
    self.energyLabel = nil
    local fontType
    if VERSION_MONSTER then
        fontType = "fontCommon.TTF"
    else
        fontType = "fontCommon.TTF"
    end
    local fontSize
    if VERSION_REDUCE then
        fontSize = 40
    else
        fontSize = 22
    end
    self.energyLabel = cc.ui.UILabel.new({
        UILabelType = 2,
        font = fontType,
        text = self:GetEnergyLabel(),
        --font = "黑体",
        size = fontSize,
        x = parent:getContentSize().width/2,
        y = parent:getContentSize().height/2,
    }):align(display.CENTER)
    parent:addChild(self.energyLabel)
end

-- function LevelInfoLayer:useEnergy()
--     GameData.energy.value = GameData.energy.value - 1
--     self.energyLabel:setString(""..GameData.energy.value)
--     if not self.timeLabel then
--         GameData.energy.startTime = kkFunc.getSystime()
--     end
--     GameState.save(GameData)
-- end
function LevelInfoLayer:setInvalid()
     if self.timeLabel ~= nil then
        self.timeLabel:removeFromParent()
        self.timeLabel = nil
        self:unscheduleUpdate()
        self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
    end
    self.checkTimeLabel = cc.ui.UILabel.new({
            text = "计时器错误",
            size = 20,
            align = ui.TEXT_ALIGN_CENTER,
            x = self.timePos.x + 30,
            y = self.timePos.y - 50,
    })
    self:addChild(self.checkTimeLabel)
end
function LevelInfoLayer:onTouch(event, x, y)
    if event == "began" then
        return true
    elseif event == "moved" then
    elseif event == "ended" then
    end  
end
return LevelInfoLayer
