--
-- Author: KK
-- Date: 2014-04-16 11:47:48
--

local http = require("socket.socket.http")
--local server = "http://211.151.176.56:8080/tower/gettime.php"
local server = "http://211.151.176.54/tower/gettime.php"
local ServiceLayer = import("..views.ServiceLayer")
local DailyLoginLayer = import("..views.DailyLoginLayer")
local ShopLayer = import("..views.ShopLayer")
local PrepareLayer = import("..views.PrepareLayer")
local LevelInfoLayer = import(".LevelInfoLayer")
local GuideLayer = import("..views.GuideLayer")
local NewbieGuideLayer = import("..views.NewbieGuideLayer")
local LoadingLayer = import("..views.LoadingLayer")
local DailyTaskLayer = import("..views.DailyTaskLayer")
local GiftBagLayer = import("..views.GiftBagLayer")
local LevelScene = class("LevelScene", function()
    return display.newScene("LevelScene")
end)

function LevelScene:ctor(params)
    --背景音乐
    self.success = params.success
    self.isNext = params.isNext
    SoundManager.playMusic(GAME_MUSIC.BGM1)
    self.res = {"LEVELMAP"}
    if LOADING_ASYNC == false then
        for k,v in pairs(self.res) do
            ResData.loadRes(v)
        end
    end
    globalVar.levelScene = self

    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,3)
    self.selectLevel = 1

    --体力、萝卜、钻石
    self.infoLayer = LevelInfoLayer.new(3)
    self:addChild(self.infoLayer,20)

    --返回按钮
    self.homeButton = cc.ui.UIPushButton.new({
        normal = "#returnNew.png",
        pressed = "#returnNew.png",
        disabled = "#returnNew.png",
        })
        :onButtonPressed(function()
            self.homeButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.homeButton:setScale(1)
        end)
        :onButtonClicked(function(event)
            app:main()
        end)
        :pos(display.cx-380, display.height-50)
        :addTo(self,1)
    
    --系统按钮
    self:getSystemLayer()

    --关卡列表放在levelLayer上
    self.levelLayer = display.newLayer()
    if self.success == true then
    else
        --self.levelLayer:setPosition(globalVar.levelMapPos)
    end
    self.levelLayer:setTouchEnabled(false)
    --大地图
	if VERSION_MONSTER then
		self:createMap()
        --self:createNewMap()
	else
        self:createMap()
	end
    self.levelLayer:setContentSize(cc.size(self.bigThemeWidth,display.height))
    self:getScrollView(self.levelLayer)
    --移动
    if VERSION_MONSTER then
        --self:moveAnimation()
    else
        self:moveAnimation()
    end

    --会动的一些东西
    --self:createLevelThemeElements()

    --教学关
    -- cc.ui.UIPushButton.new({})
    --     :setButtonLabel("normal", cc.ui.UILabel.new({
    --         UILabelType = 2,
    --         text = "教学关",
    --         align = ui.TEXT_ALIGN_CENTER,
    --         size = 30,
    --     }))
    --     :onButtonClicked(function()
    --         app:play({level = 100})
    --     end)
    --     :pos(display.cx - 340, display.height-160)
    --     :addTo(self.levelLayer)

    --测试关卡页
    --self:createTestThings()

    --计时器检查
    self.timeOK = kkFunc.checkTimer()
    if not self.timeOK then
        self:timerWrong()
    end
    if self.timeOK then 
        local y = tonumber(os.date("%Y", os.time())) 
        local m = tonumber(os.date("%m", os.time()))
        local d = tonumber(os.date("%d", os.time()))
        if GameData.login.day ~= d then
            --每日登陆
            if DAILY_LOGIN and GameData.guide.level2 then
                self.loginLayer = DailyLoginLayer.new()
                self:addChild(self.loginLayer,20)
                --每日随机任务
                self:randomTasks()
           	end
        end
        if not (GameData.achievement["12"].year == y and GameData.achievement["12"].month == m and GameData.achievement["12"].day == d) then
            AchievementData.checkDays()
        end
    end
    
    if LOADING_CLOUD then
        --盖住云
        self.loadCloudLayer = LoadingLayer.new({
            loadType = "out",
            callback = nil,
        })
        self:addChild(self.loadCloudLayer,500)
    end
    --新手引导
    if (NEW_GUIDE and GameData.guide.teachLevel == false)
        or (NEW_GUIDE and GameData.guide.teachLevel == true and GameData.guide.level1 == false)
        or (NEW_GUIDE and GameData.guide.level1 == true and GameData.guide.herohouse == false) 
        or (NEW_GUIDE and GameData.guide.herohouse == true and GameData.guide.level2 == false) then
        self.newbieguidelayer = NewbieGuideLayer.new()
        self:addChild(self.newbieguidelayer,21)
    end

    if self.isNext then
        self:goLevel(GameData.openlevel)
    end

    --厦门 暗扣礼包
    --if (GameData.guide.teachLevel == true and GameData.guide.herohouse == true and GameData.guide.level2 == true) then
        -- if device.platform == "android" then
        --     local className = "org/cocos2dx/lua/PayTool"
        --     local method = 'getIndex'
        --     local args = nil
        --     local sig = "()I"
        --     local ok, t = luaj.callStaticMethod(className,method,args,sig)

        --     if t == 0 then
        --         self.newBag = GiftBagLayer.new(4)
        --         self:addChild(self.newBag,1000)

        --         self.newBag = GiftBagLayer.new(5)
        --         self:addChild(self.newBag,999)
        --     end
        -- else
        --         self.newBag = GiftBagLayer.new(4)
        --         self:addChild(self.newBag,1000)

        --         self.newBag = GiftBagLayer.new(5)
        --         self:addChild(self.newBag,999)
        -- end
        if ANKOU then
            self.newBag = GiftBagLayer.new(4)
            self:addChild(self.newBag,1000)

            self.newBag = GiftBagLayer.new(5)
            self:addChild(self.newBag,999)        
         end
    --end
end

--系统按钮
function LevelScene:getSystemLayer()
    --客服
        --厦门
    -- if not TEST_DEMO and not VERSION_REDUCE then
    --     self.helpButton = cc.ui.UIPushButton.new({
    --         normal = "#helpButton.png",
    --         pressed = "#helpButton.png",
    --         disabled = "#helpButton.png",
    --         })
    --         :onButtonPressed(function()
    --             self.helpButton:setScale(1.1)
    --             --音效
    --             SoundManager.playSound(GAME_SOUND.Button2)
    --         end)
    --         :onButtonRelease(function()
    --             self.helpButton:setScale(1)
    --         end)
    --         :onButtonClicked(function() 
    --             if not VERSION_REDUCE then
    --                 local serviceLayer = ServiceLayer.new()
    --                 self:addChild(serviceLayer,21)
    --             end
    --         end):align(display.CENTER,display.cx + 390, 80)
    --     self:addChild(self.helpButton,1)
    -- end
        --厦门
    --英雄家
    self.systemlayer = display.newLayer()
    self:addChild(self.systemlayer,4)
    self.systemlayer:setTouchSwallowEnabled(false)    
    local heroY
    if VERSION_REDUCE then
        if GameData.selectHero == 1 then
            heroY = 80
        elseif GameData.selectHero == 2 or GameData.selectHero == 3 then
            heroY = 90
        elseif GameData.selectHero == 4 then
            heroY = 73
        end  
    else
        if GameData.selectHero == 1 then
            heroY = 85
        elseif GameData.selectHero == 2 or GameData.selectHero == 3 then
            heroY = 85
        elseif GameData.selectHero == 4 then
            heroY = 85
        end
    end
    self.MenuHero = cc.ui.UIPushButton.new({
        normal = "#MenuHero"..GameData.selectHero..".png",
        pressed = "#MenuHero"..GameData.selectHero..".png",
        disabled = "#MenuHero"..GameData.selectHero..".png",
        })
        :onButtonPressed(function()
            self.MenuHero:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button1)
        end)
        :onButtonRelease(function()
            self.MenuHero:setScale(1)
        end)
        :onButtonClicked(function()
            app:heroHouse()                
        end):align(display.CENTER,display.cx + 100, heroY)
        :addTo(self.systemlayer,1)
    self:herohouseExecuteTip()
    self.MenuAchievement = cc.ui.UIPushButton.new({
        normal = "#MenuAchievement.png",
        pressed = "#MenuAchievement.png",
        disabled = "#MenuAchievement.png",
        })
        :onButtonPressed(function()
            self.MenuAchievement:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button1)
        end)
        :onButtonRelease(function()
            self.MenuAchievement:setScale(1)
        end)
        :onButtonClicked(function()
            app:achievement()                
        end):align(display.CENTER,display.cx-35, 75)
        :addTo(self.systemlayer,1)
    self:newAchievementTip()
    self.MenuHandbook = cc.ui.UIPushButton.new({
        normal = "#MenuHandbook.png",
        pressed = "#MenuHandbook.png",
        disabled = "#MenuHandbook.png",
        })
        :onButtonPressed(function()
            self.MenuHandbook:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button1)
        end)
        :onButtonRelease(function()
            self.MenuHandbook:setScale(1)
        end)
        :onButtonClicked(function()
            app:handbook()                
        end)
        :align(display.CENTER, display.cx + 250,75)
        :addTo(self.systemlayer,1)
    --self.MenuHandbook:setColor(cc.c3b(128,128,128))
    --self.MenuHandbook:setTouchEnabled(false)
    --大礼包
    if not GameData.giftBag.timeLimit then
        self.GiftBag = cc.ui.UIPushButton.new({
            normal = "#giftBag.png",
            pressed = "#giftBag.png",
            disabled = "#giftBag.png",
            })
            :onButtonPressed(function()
                self.GiftBag:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.GiftBag:setScale(1)
            end)
            :onButtonClicked(function()
                self.giftBag = GiftBagLayer.new(1)
                self:addChild(self.giftBag,21)  
            end)
            :align(display.CENTER, display.width-70,display.cy)
            :addTo(self.systemlayer,1)

            self.GiftBag:runAction(cc.RepeatForever:create(transition.sequence({
                        cc.DelayTime:create(1.0),
                        cc.CallFunc:create(function ()
                            local params = {maxScale = 1.20,times = 3,time = 0.25,difference = 3}
                            kkFunc.ActionElasticity(self.GiftBag,params)
                        end)
                    })
                )
            )
    end
    if not GameData.giftBag.freshman then
        self.NewBag = cc.ui.UIPushButton.new({
            normal = "#newBag.png",
            pressed = "#newBag.png",
            disabled = "#newBag.png",
            })
            :onButtonPressed(function()
                self.NewBag:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.NewBag:setScale(1)
            end)
            :onButtonClicked(function()
                self.newBag = GiftBagLayer.new(2)
                self:addChild(self.newBag,21)  
            end)
            :align(display.CENTER, display.width-70,display.cy+125)
            :addTo(self.systemlayer,1)

            self.NewBag:runAction(cc.RepeatForever:create(transition.sequence({
                        cc.DelayTime:create(1.0),
                        cc.CallFunc:create(function ()
                            local params = {maxScale = 1.20,times = 3,time = 0.25,difference = 3}
                            kkFunc.ActionElasticity(self.NewBag,params)
                        end)
                    })
                )
            )
    end
    --关卡失败后弹出限时礼包,关卡界面引导结束后再弹
    if GameData.guide.level3 and self.success == false and not GameData.giftBag.timeLimit then 
        if not MI_SERVICE then
            self.giftBag = GiftBagLayer.new(1)
            self:addChild(self.giftBag,21) 
        end 
    end
    --道具礼包
    if not VERSION_REDUCE then
        self.itemBag = cc.ui.UIPushButton.new({
                normal = "#propBag.png",
                pressed = "#propBag.png",
                disabled = "#propBag.png",
                })
                :onButtonPressed(function()
                    self.itemBag:setScale(1.1)
                    --音效
                    SoundManager.playSound(GAME_SOUND.Button2)
                end)
                :onButtonRelease(function()
                    self.itemBag:setScale(1)
                end)
                :onButtonClicked(function()
                    self.newBag = GiftBagLayer.new(3)
                    self:addChild(self.newBag,21)  
                end)
                :align(display.CENTER, display.width-70,display.cy-125)
                :addTo(self.systemlayer,1)

                self.itemBag:runAction(cc.RepeatForever:create(transition.sequence({
                            cc.DelayTime:create(1.0),
                            cc.CallFunc:create(function ()
                                local params = {maxScale = 1.20,times = 3,time = 0.25,difference = 3}
                                kkFunc.ActionElasticity(self.itemBag,params)
                            end)
                        })
                    )
                )
    end
    --每日任务
    self.MenuDailyTask = cc.ui.UIPushButton.new({
        normal = "#MenuDailyTask.png",
        pressed = "#MenuDailyTask.png",
        disabled = "#MenuDailyTask.png",
        })
        :onButtonPressed(function()
            self.MenuDailyTask:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.MenuDailyTask:setScale(1)
        end)
        :onButtonClicked(function()
            local dailytasklayer = DailyTaskLayer.new()
            self:addChild(dailytasklayer,21)           
        end)
        --:align(display.CENTER, display.width-60,display.cy)
        :align(display.CENTER, display.cx-180,75)
        :addTo(self.systemlayer,1)
    if GameData.dailytask.open <4 and GameData.dailytask[""..GameData.dailytask.open].complete == true then
        self.DailyTaskRedPoint = display.newSprite("#achievementTipPoint.png",40,35)
        self.MenuDailyTask:addChild(self.DailyTaskRedPoint)
    end

    if GameData.dailytask.open < 4 then
        self.MenuDailyTaskTip = display.newSprite("#MenuDailyTaskTip.png",-20,0)
        self.MenuDailyTaskTip:setAnchorPoint(cc.p(1,0))
        self.MenuDailyTaskTip:setScale(0)
        self.MenuDailyTask:addChild(self.MenuDailyTaskTip)
        self.MenuDailyTaskTip:runAction(cc.RepeatForever:create(transition.sequence({
            cc.DelayTime:create(3),
            cc.ScaleTo:create(0.3,1),
            cc.DelayTime:create(1),
            cc.ScaleTo:create(0.3,0),
        })))
    end
end

function LevelScene:randomTasks()
    GameData.dailytask = {}
    local random = {1,2,3,4,5,6,7,8,9,10,11}
    local randomDailyTasks = kkFunc.getRandomFromTable(random, 3)
    GameData.dailytask.open = 1
    for i =1,3 do
        GameData.dailytask[""..i] = {
            type = randomDailyTasks[i],
            complete = false,
            recordNum = 0,
        }
    end
    local d = tonumber(os.date("%d", os.time()))
    --GameData.login.day = d
    GameState.save(GameData)   
end

function LevelScene:herohouseExecuteTip()
    local money
    for i=2,4 do
        if i == 2 then
            money = GameData.carrot
        else
            money = GameData.diamond
        end
        if GameData.heros["h"..i].level == 0 and money >= HeroData[i].money then
            local herohousePoint = display.newSprite("#achievementTipPoint.png",40,35)
            self.MenuHero:addChild(herohousePoint)
            return
        end
        --可升级提示
        local canUpgradeSkill = false
        for idx = 1,4 do
            for i = 1,#HeroData[idx].skill-1 do
                if GameData.heros["h"..idx].level >= 1 and GameData.heros["h"..idx].skill["s"..i] >= 1 then
                    if GameData.heros["h"..idx].skill["s"..i] < GameData.heros["h"..idx].level 
                        and GameData.heros["h"..idx].skill["s"..i] < #ExcelHeroSkillData[HeroData[idx].skill[i]]
                        and GameData.carrot >= ExcelHeroSkillData[HeroData[idx].skill[i]][GameData.heros["h"..idx].skill["s"..i]].money                      
                        and GameData.skillPoints.value >= 1 then
                        local herohousePoint = display.newSprite("#achievementTipPoint.png",40,35)
                        self.MenuHero:addChild(herohousePoint)
                        return
                    end
                end 
            end
            if (GameData.heros["h"..idx].level >= 1 
                and GameData.heros["h"..idx].level < HeroData[idx].maxLevel
                and GameData.carrot >= ExcelHeroData[idx][GameData.heros["h"..idx].level].money) then
                local herohousePoint = display.newSprite("#achievementTipPoint.png",40,35)
                self.MenuHero:addChild(herohousePoint)
                return      
            end
        end
    end  
end

function LevelScene:newAchievementTip()
    for i = 1, 17 do
        local v = GameData.achievement[""..i]
        if v.type == 1 then
            if v.complete and not v.isGifted then
                local achievePoint = display.newSprite("#achievementTipPoint.png",40,40)
                self.MenuAchievement:addChild(achievePoint)
                return
            end
        elseif v.type == 2 then
            for j = 1, v.openlevel do
                if v[""..j].complete and not v[""..j].isGifted then
                    local achievePoint = display.newSprite("#achievementTipPoint.png",40,40)
                    self.MenuAchievement:addChild(achievePoint)
                    return
                end
            end
        end
    end
end

function LevelScene:setCanTouch(b)
    self.levelLayer:setTouchCaptureEnabled(b)
    self.touchLayer:setTouchEnabled(b)
    self.systemlayer:setTouchCaptureEnabled(b)
end

function LevelScene:levelBack()
    self.MenuHero:runAction(cc.MoveBy:create(0.2,cc.p(0,180)))
    self.MenuAchievement:runAction(cc.MoveBy:create(0.2,cc.p(0,180)))
    self.MenuHandbook:runAction(cc.MoveBy:create(0.2,cc.p(0,180)))
    self.MenuDailyTask:runAction(cc.MoveBy:create(0.2,cc.p(0,180)))
    self:performWithDelay(function()
        self.preparelayer:removeFromParent()
        self.preparelayer = nil
        g_infoLayer.prepareLayer = nil--返回键判断用
        self.homeButton:setVisible(true)
        self:setCanTouch(true)
    end, 0.2)
end

function LevelScene:goLevel(idx)
    --体力不足
    if GameData.energy.value == 0 then
        g_infoLayer:popLayer("体力")
        return
    end
    --主题首关需够星星
    if idx == GameData.openlevel then
        if idx == 201 then
            if app.getTotalStarNumber() < 25 then
                return self:popNeedStarNumLayer()
                --return
            end
        elseif idx == 301 then
            if app.getTotalStarNumber() < 50 then
                return self:popNeedStarNumLayer()
                --return
            end
        elseif idx == 401 then
            if app.getTotalStarNumber() < 75 then
                return self:popNeedStarNumLayer()
                --return
            end
        end
    end
    if NEW_GUIDE and GameData.guide.teachLevel == true and GameData.guide.level1 == false 
        or NEW_GUIDE and GameData.guide.level1 == true and GameData.guide.level2 == false then
        if idx == 101 then
            self.newbieguidelayer:goLevel1(2)
        elseif idx == 102 then
            self.newbieguidelayer:goLevel2(7)
        end
    end
    self.MenuHero:runAction(cc.MoveBy:create(0.2,cc.p(0,-180)))
    self.MenuAchievement:runAction(cc.MoveBy:create(0.2,cc.p(0,-180)))
    self.MenuHandbook:runAction(cc.MoveBy:create(0.2,cc.p(0,-180)))
    self.MenuDailyTask:runAction(cc.MoveBy:create(0.2,cc.p(0,-180)))
    if self.preparelayer == nil then
        self.selectLevel = idx
        self.homeButton:setVisible(false)
        self:setCanTouch(false)
        self.preparelayer = PrepareLayer.new(self.selectLevel)
        self:addChild(self.preparelayer,5)
        g_infoLayer.prepareLayer=self.preparelayer--返回键判断用
    end
end
function LevelScene:createNewMap()
    local mapBg = display.newSprite("map/LevelTheme/levelSceneMap.png",0,display.cy):addTo(self.levelLayer,20)
    mapBg:setAnchorPoint(0,0.5)
    self.themeMap = {}
    for i = 1, 5 do
        self.themeMap[i] = display.newSprite("map/LevelTheme/levelTheme"..i..".png",0,display.cy) 
        self.themeMap[i]:setAnchorPoint(0,0.5)
        self.levelLayer:addChild(self.themeMap[i],20)
    end
     
end
function LevelScene:createMap()
    --大地图
    self.theme = {}
    self.bigThemeWidth = 0
    --cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RG_B565)
    for i = 1, 4 do
        self.theme[i] = display.newSprite("map/LevelTheme/themeMap"..i..".png")
        self.theme[i]:setPosition(self.bigThemeWidth,display.cy)
        self.theme[i]:setAnchorPoint(0,0.5)
        self.levelLayer:addChild(self.theme[i])
        self.bigThemeWidth = self.bigThemeWidth + self.theme[i]:getContentSize().width
    end
    self.levelButtonDy = (self.theme[1]:getContentSize().height-display.height)/2
    --cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
    self.map = cc.TMXTiledMap:create("map/LevelTheme/levelMap.tmx")
    --[[
    self.map:setAnchorPoint(cc.p(0,0.5))
    self.map:setPosition(cc.p(0,display.cy))
    self:addChild(self.map)
    --]]

    self.levelButton = {}
    local group = self.map:getObjectGroup("objs")
    local array = group:getObjects()
    for k,v in pairs(array) do
        if v.name == "level" then
            local x = tonumber(v.x)
            local y = tonumber(v.y)
            local level = tonumber(v.level)
            self:createLevelButton(level,x,y)
        end
    end
    --开启新关卡按钮抖动
    --[[self:runAction(cc.RepeatForever:create(
        transition.sequence({
            cc.DelayTime:create(2),    
            cc.CallFunc:create(function()
                kkFunc.bubbleButton(self.levelButton[GameData.openlevel])
            end)
        })))]]
	 
    --
    local groupAnimation = self.map:getObjectGroup("widget")
    local arrayAnimation = groupAnimation:getObjects()
    for k,v in pairs(arrayAnimation) do
        local sprite = display.newSprite()
        sprite:setPosition(tonumber(v.x), tonumber(v.y)-self.levelButtonDy)
        self.levelLayer:addChild(sprite)
        if v.name == "balloon" then
            sprite:setSpriteFrame("map1_balloon.png")
            sprite:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.MoveBy:create(1.0,cc.p(0,20)),
                    cc.MoveBy:create(1.0,cc.p(0,-20))
                })))
        elseif  v.name == "balloon2" then
            sprite:setSpriteFrame("map4_balloon.png")
            sprite:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.MoveBy:create(1.5,cc.p(0,20)),
                    cc.MoveBy:create(1.5,cc.p(0,-20))
                })))
        elseif v.name == "balloon3" then
            sprite:setSpriteFrame("map3_balloon2.png")
            sprite:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.MoveBy:create(0.7,cc.p(0,-7)),
                    cc.MoveBy:create(0.7,cc.p(0,7))
                })))
        elseif v.name == "balloon4" then
            sprite:setSpriteFrame("map3_balloon1.png")
            sprite:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.MoveBy:create(1.5,cc.p(0,40)),
                    cc.MoveBy:create(1.5,cc.p(0,-40))
                })))      
        -- elseif v.name == "boat" then
        --     sprite:setSpriteFrame("map4_boat.png")
        --     sprite:setAnchorPoint(cc.p(0.8,0))
        --     sprite:runAction(cc.RepeatForever:create(transition.sequence({
        --             cc.RotateBy:create(0.7, 5),
        --             cc.RotateBy:create(0.7, -5),
        --         })))
        -- elseif v.name == "water" then
        --     sprite:setSpriteFrame("map2_water.png")
        --     self.levelLayer:reorderChild(sprite,1)
        -- elseif v.name == "penguin2" then
        --     sprite:setSpriteFrame("map2_penguin2.png")
        --     sprite:runAction(cc.RepeatForever:create(transition.sequence({
        --             cc.MoveBy:create(0.5,cc.p(0,-3)),
        --             cc.MoveBy:create(0.5,cc.p(0,3)),
        --         })))
        elseif v.name == "hand" then
            sprite:setAnchorPoint(cc.p(0.13,0.1))
            sprite:setRotation(-15)
            sprite:setSpriteFrame("map1_hand.png")
            sprite:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.RotateBy:create(0.7,20),
                    cc.RotateBy:create(0.7,-20),
                })))
        elseif v.name == "duck" then
            sprite:setSpriteFrame("map2_duck.png")
            self.duck = sprite
            self.duck.CenterPos = cc.p(self.duck:getPosition())
            self.duck.a = 80
            self.duck.b = 32
            self.duck.cycle = 16
            self.duck.time = 0
            self.duck:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.DelayTime:create(self.duck.cycle/2),
                    cc.CallFunc:create(function ()
                        self.duck:setFlippedX(true)
                    end),
                    cc.DelayTime:create(self.duck.cycle/2),
                    cc.CallFunc:create(function ()
                        self.duck:setFlippedX(false)
                    end)
                })))
        else
            local animation = display.getAnimationCache(v.animation)
            -- if v.name == "zombie" then
            --     sprite:runAction(cc.RepeatForever:create(transition.sequence({
            --             cc.CallFunc:create(function ()
            --                 sprite:playAnimationOnce(animation,false)
            --             end),
            --             cc.DelayTime:create(2.5)
            --         })))
            --elseif v.name == "eye" then
            if v.name == "eye" then
                local delay = 4.0
                sprite:runAction(cc.RepeatForever:create(transition.sequence({
                        transition.playAnimationOnce(sprite, animation, false, function ()
                            sprite:setVisible(false)
                        end, delay),
                    })
                ))    
            else
                sprite:playAnimationForever(animation)
            end
        end
    end
    --盖住未开启主题
    self:coverLockTheme()
end

function LevelScene:createLevelButton(level,x,y)
    self.DailyFinishNum = 0
    for j = 1, 4 do
        if GameData.levelTask[""..level][""..j] == true then
            self.DailyFinishNum = self.DailyFinishNum + 1
        end
    end
    local buttonPicName
    if level > GameData.openlevel then
        if VERSION_MONSTER then
            buttonPicName = "#levelButtonLock.png"
        else
            buttonPicName = "#levelButton.png"
        end    
    elseif level == GameData.openlevel then
        if VERSION_MONSTER then
            buttonPicName = "#levelButtonLock.png"
        else
            buttonPicName = "#levelButton.png"
        end
        if (not globalVar.levelOpenNew) and  self:isStarsEnough(level) then
            if self.DailyFinishNum == 4 then
                buttonPicName = "#levelButton2.png"
            else
                buttonPicName = "#levelButton.png"
            end
        end
    elseif self.DailyFinishNum == 4 then
        buttonPicName = "#levelButton2.png"
    else
        buttonPicName = "#levelButton.png"
    end
    local starSprite
    self.levelButton[level] = cc.ui.UIPushButton.new({
        normal = buttonPicName,
        disabled = buttonPicName,
        pressed = buttonPicName,
    })
        :onButtonPressed(function()
            self.levelButton[level]:setScale(1.1)
            if starSprite ~= nil then
                starSprite:setScale(1.1)
                starSprite:setPosition(self.levelButton[level]:getPositionX(),self.levelButton[level]:getPositionY()+43)
            end
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.levelButton[level]:setScale(1)
            if starSprite ~= nil then
                starSprite:setScale(1)
                starSprite:setPosition(self.levelButton[level]:getPositionX(),self.levelButton[level]:getPositionY()+40)
            end
        end)
        :onButtonClicked(function(event)
            self:goLevel(level)
        end)
        :pos(x, y-self.levelButtonDy)
        :addTo(self.levelLayer,2)
    --
    if level >= GameData.openlevel and GameData.openlevel == 101 and not VERSION_MONSTER then
        if level == GameData.openlevel then
            self.levelButton[level]:setColor(cc.c3b(255,255,255))
        else
            self.levelButton[level]:setColor(cc.c3b(128,128,128))
        end     
    elseif level >= GameData.openlevel and GameData.openlevel ~= 101 and not VERSION_MONSTER then
        if globalVar.levelOpenNew then            
            self.levelButton[level]:setColor(cc.c3b(128,128,128))
        else 
            self.levelButton[level]:setColor(cc.c3b(128,128,128))
            self:performWithDelay(function()
                self.levelButton[GameData.openlevel]:setColor(cc.c3b(255,255,255))
            end, 0.2)
        end
    end
    --if level > GameData.openlevel or (level == GameData.openlevel and (globalVar.levelOpenNew or not self:isStarsEnough(level))) then
    if level > GameData.openlevel or (level == GameData.openlevel and globalVar.levelOpenNew) then
        self.levelButton[level]:setTouchEnabled(false)
    else
        if GameData.levelTask[""..level].star ~= 0 then
            starSprite = display.newSprite("#levelButtonStar"..GameData.levelTask[""..level].star..".png",
                self.levelButton[level]:getPositionX(),self.levelButton[level]:getPositionY()+40)
            self.levelLayer:addChild(starSprite,10)
        end       
    end
    local numberY
    if VERSION_MONSTER then
        numberY = 8
    else
        numberY = 0
    end
    local number = cc.ui.UILabel.new({
        UILabelType = 1,
        font = "fontLevelButton.fnt",
        text = ""..LevelsData.getRealLevel(level),
        x = 3,
        y = numberY,
    })
        :align(display.CENTER)
        :addTo(self.levelButton[level])
        :setScale(0.8)
end
function LevelScene:popNeedStarNumLayer()
    local themeNum = LevelsData.getThemeOfLevel(GameData.openlevel)
    local themeNeedStar
    if themeNum == 2 then
        themeNeedStar = 25
    elseif themeNum == 3 then
        themeNeedStar = 50
    elseif themeNum == 4 then
        themeNeedStar = 75
    end
    local num = themeNeedStar - app.getTotalStarNumber()
    local text = "您还需要获得"..num.."个星星才能开启第"..themeNum.."主题"
    self.poplayer = display.newSprite("#poplayer.png",display.cx,display.cy):addTo(self,30)
    local number = cc.ui.UILabel.new({
        text = text,
        size = 30,
        x = self.poplayer:getContentSize().width/2,
        y = 115,
        dimensions = cc.size(290, 150),
    })
    :align(display.CENTER)
    :addTo(self.poplayer)
    self.sure = cc.ui.UIPushButton.new({
        normal = "#poplayerSure.png",
        disabled = "#poplayerSure.png",
        pressed = "#poplayerSure.png",
        })
        :onButtonPressed(function()
            self.sure:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(1)
        end)
        :onButtonClicked(function() 
            self.poplayer:removeFromParent()
        end)
        :pos(self.poplayer:getContentSize().width/2, 50)
        :addTo(self.poplayer)
end
--盖住未开启主题
function LevelScene:coverLockTheme()
    --通关前一主题开启关卡
    -- local levelNum = LevelsData.getRealLevel(GameData.openlevel)
    -- local startCloudThemeNum = math.floor((levelNum + 9)/10)+1
    self.themeCloud = {}
    --未达到所指定星数依然覆盖云层
    if app.getTotalStarNumber() then
        local Temp
        if app.getTotalStarNumber() < 25 then
            Temp = 2
        elseif app.getTotalStarNumber() < 50 then
            Temp = 3
        elseif app.getTotalStarNumber() < 75 then
            Temp = 4
        end
        --startCloudThemeNum = math.min(startCloudThemeNum,Temp)
        startCloudThemeNum = Temp--不考虑是否前一关卡通关
    end
    -----------------------------
    if startCloudThemeNum == nil or OPEN_LEVEL then--开启所有关卡功能有app.getTotalStarNumber()==nil的情况
        return
    end

    --if GameData.openlevel == 201 or GameData.openlevel == 301 or GameData.openlevel == 401 then     
    local themeNum = LevelsData.getThemeOfLevel(GameData.openlevel)
    local themeNeedStar = nil
    if themeNum == 2 then
        themeNeedStar = 25
    elseif themeNum == 3 then
        themeNeedStar = 50
    elseif themeNum == 4 then
        themeNeedStar = 75
    end
    --print("ffffj",themeNeedStar)
    if themeNeedStar ~= nil then
        if app.getTotalStarNumber() < themeNeedStar then
            if startCloudThemeNum ~= 4 then
                startCloudThemeNum = startCloudThemeNum + 1 --星星不够本主题云散去
            end --弹出提示框
            --print("jjjjj",globalVar.levelOpenNew)
            if globalVar.levelOpenNew  and (GameData.openlevel == 201 or GameData.openlevel == 301 or GameData.openlevel == 401) then
                self:popNeedStarNumLayer()
            end
        end
    end
    --end

    for i = startCloudThemeNum, 4 do
        local px,py = self.theme[i]:getPosition()
        local size = self.theme[i]:getContentSize()
        self.themeCloud[i] = display.newSprite("pic/whiteCloud.png", px+size.width*0.5,display.cy)
        --self.themeCloud[i]:setScaleX(1.8)
        --self.themeCloud[i]:setScaleY(1.5)
        self.themeCloud[i]:setScale(2.4)
        self.levelLayer:addChild(self.themeCloud[i],10)
        if i == 2 then
            local rainbow = display.newSprite("pic/whiteCloudRainbow.png",px+size.width*0.5,display.cy)
            self.levelLayer:addChild(rainbow,11)
            self.themeCloud[i]:setPosition(px+size.width*0.5-30,display.cy)
        elseif i == 3 then
            local ballon = display.newSprite("pic/whiteCloudBallon.png",px+size.width*0.5,display.cy)
            self.levelLayer:addChild(ballon,11)
            self.themeCloud[i]:setPosition(px+size.width*0.5-70,display.cy)
        elseif i == 4 then
            local fly = display.newSprite("pic/whiteCloudFly.png",px+size.width*0.5,display.cy)
            self.levelLayer:addChild(fly,11)
            self.themeCloud[i]:setPosition(px+size.width*0.5-70,display.cy)
        end
        --加入锁头和所需星数显示
        if app.getTotalStarNumber() then
            if i == startCloudThemeNum then
                local pic
                if app.getTotalStarNumber() >= (startCloudThemeNum-1)*20 then
                    pic = "pic/starCount_bg3.png"
                elseif app.getTotalStarNumber() >= (startCloudThemeNum-1)*10 then
                    pic = "pic/starCount_bg2.png"
                else
                    pic = "pic/starCount_bg1.png"
                end
                local sprite = display.newSprite(pic, self.themeCloud[i]:getPositionX(),self.themeCloud[i]:getPositionY())
                self.levelLayer:addChild(sprite,11)
                local NeedNum
                if startCloudThemeNum == 2 then
                    NeedNum = 25
                elseif startCloudThemeNum == 3 then
                    NeedNum = 50
                elseif startCloudThemeNum == 4 then
                    NeedNum = 75
                end
                local Label = cc.ui.UILabel.new({
                            text = app.getTotalStarNumber().." / "..NeedNum,
                            size = 17,
                        })
                Label:setColor(cc.c3b(251,220,2))
                Label:setAnchorPoint(cc.p(0.5,0))
                Label:setPosition(sprite:getContentSize().width/2,9)
                sprite:addChild(Label)
            end
        end
        -------------------------------
    end
end

function LevelScene:moveAnimation()
    --[[测试效果
    globalVar.levelOpenNew = true
    GameData.openlevel = 201
    --]]
    self.levelButtonCircle = nil
    --关卡间小点
    self:LevelPoints(globalVar.levelOpenNew)

    if globalVar.levelOpenNew == true then
        --[[
        local sprite = display.newSprite("pic/bloodNewTest.png",self.levelButton[LevelsData.getLastLevel(GameData.openlevel)]:getPositionX(),self.levelButton[LevelsData.getLastLevel(GameData.openlevel)]:getPositionY()+60)
        self.levelLayer:addChild(sprite)
        sprite:runAction(cc.MoveTo:create(2,cc.p(self.levelButton[GameData.openlevel]:getPositionX(),self.levelButton[GameData.openlevel]:getPositionY()+60)))
        --]]
        globalVar.levelOpenNew = false
        --按钮圈
        -- levelButtonCircle = display.newSprite("#levelButtonCircle.png",self.levelButton[LevelsData.getLastLevel(GameData.openlevel)]:getPosition())
        -- self.levelLayer:addChild(levelButtonCircle)
        --开新主题时去掉云
        local function CloudMove()
            self.themeCloud[theme]:runAction(transition.sequence({
                --cc.DelayTime:create(1),
                cc.Spawn:create(
                    cc.FadeOut:create(1),
                    cc.ScaleTo:create(1,2.2)
                ),
                cc.CallFunc:create(function()
                    self.themeCloud[theme]:removeFromParent()
                end)
            }))
        end
        local theme = LevelsData.getThemeOfLevel(GameData.openlevel)
        if self.themeCloud[theme] ~= nil then
            if theme == 2 and app.getTotalStarNumber()>=25 then
                CloudMove()
            elseif theme == 3 and app.getTotalStarNumber()>=50 then
                CloudMove()
            elseif theme == 4 and app.getTotalStarNumber()>=75 then
                CloudMove()
            end
        end
    else
        --[[
        local sprite = display.newSprite("pic/bloodNewTest.png",self.levelButton[GameData.openlevel]:getPositionX(),self.levelButton[GameData.openlevel]:getPositionY()+60)
        self.levelLayer:addChild(sprite)
        --]]
        if self:isStarsEnough(GameData.openlevel) then
            self:ButtonCircle()
        end
        --地图位置
        if GameData.openlevel >= 104 and GameData.openlevel < 406 then 
            self.scrollView:scrollTo(cc.p(display.cx-self.levelButton[GameData.openlevel]:getPositionX(),0))
        elseif GameData.openlevel >= 406 then
            self.scrollView:scrollTo(cc.p(display.width-self.bigThemeWidth,0))
        end
    end
    
end

function LevelScene:ButtonCircle()--按钮圈及圈动画
    self.levelButtonCircle = display.newSprite("#levelButtonCircle.png",self.levelButton[GameData.openlevel]:getPosition())
    self.levelLayer:addChild(self.levelButtonCircle)
    self.levelButtonCircle:runAction(cc.RepeatForever:create(transition.sequence({
        cc.Spawn:create(
            cc.ScaleTo:create(1,3),
            cc.FadeTo:create(1,0)
        ),
        cc.CallFunc:create(function()
           self.levelButtonCircle:setOpacity(255)
           self.levelButtonCircle:setScale(1)
        end)
    })))
end

function LevelScene:createLevelThemeElements()
    self.cloud = {}
    local cloudPic = {
        [1] = "#lt_cloud5.png",
        [2] = "#lt_cloud6.png",
        --[[posX = {
            [1] = math.random(display.cx,display.width*3/4),
            [2] = math.random(display.width*3/4+100,display.width),
        },]]
        posX = {
            [1] = display.width,
            [2] = display.width+200,
        },
    }
    for i=1,2 do
        self.cloud[i] = display.newSprite(cloudPic[i]):addTo(self.levelLayer,10)
        self.cloud[i]:setOpacity(0)
        --[[self.cloud[i]:runAction(cc.RepeatForever:create(
            transition.sequence({
                cc.CallFunc:create(function()
                    self.cloud[i]:setPosition(cloudPic.posX[i],math.random(display.height-150,display.height-50))
                end),
                cc.Spawn:create(
                    cc.FadeIn:create(1),
                    cc.MoveBy:create(1, cc.p(cloudSpeed, 0))),
                cc.MoveBy:create(10, cc.p(cloudSpeed*10, 0)),
                cc.Spawn:create(
                    cc.FadeOut:create(1),
                    cc.MoveBy:create(1, cc.p(cloudSpeed, 0))),
                cc.DelayTime:create(math.random(1,5)),
            })
        ))]]
        local cloudSpeed = math.random(50,60)
        self.cloud[i]:runAction(cc.RepeatForever:create(
            transition.sequence({
                cc.CallFunc:create(function()
                    self.cloud[i]:setPosition(cloudPic.posX[i],math.random(display.height-150,display.height-50))
                end),
                cc.Spawn:create(
                    --cc.FadeIn:create(1),
                    cc.FadeTo:create(1,200),
                    cc.MoveBy:create(1, cc.p(-50, 0))),
                cc.MoveBy:create((cloudPic.posX[i]-220)/cloudSpeed, cc.p(220-cloudPic.posX[i], 0)),
                cc.Spawn:create(
                    --cc.FadeOut:create(1),
                    cc.FadeTo:create(1,0),
                    cc.MoveBy:create(1, cc.p(-50, 0))),
                cc.DelayTime:create(math.random(1,5)),
            })
        ))
    end
    --[[
    local cloud2 = display.newSprite("#lt_cloud4.png", 100,display.height-100):addTo(self.levelLayer)
    cloud2:runAction(cc.RepeatForever:create(
        transition.sequence({
            cc.MoveBy:create(30,cc.p(self.bigThemeWidth-200,0)),
            cc.MoveBy:create(30,cc.p(-self.bigThemeWidth+200,0)),            
        })
    ))
    local cloud3 = display.newSprite("#lt_cloud3.png", 100,display.height-200):addTo(self.levelLayer)
    cloud3:runAction(cc.RepeatForever:create(
        transition.sequence({
            cc.MoveBy:create(30,cc.p(self.bigThemeWidth-200,0)),
            cc.MoveBy:create(30,cc.p(-self.bigThemeWidth+200,0)),            
        })
    ))
    local cloud4 = display.newSprite("#lt_cloud4.png", 100,150):addTo(self.levelLayer)
    cloud4:runAction(cc.RepeatForever:create(
        transition.sequence({
            cc.MoveBy:create(30,cc.p(self.bigThemeWidth-200,0)),
            cc.MoveBy:create(30,cc.p(-self.bigThemeWidth+200,0)),            
        })
    ))
    --]]
end

function LevelScene:showTestLevel(b)
    self.testLevelLayer:setVisible(b)
    self.testButton:setVisible(not b)
    self.levelLayer:setVisible(not b)
end

function LevelScene:timerWrong()
    if GameData.energy.value == -1 then
        return
    end
    g_infoLayer:setInvalid()
    self:checkNetTime()
end

function LevelScene:checkNetTime()
    local netOK = network.isLocalWiFiAvailable() or network.isInternetConnectionAvailable()
    if netOK then
        local body,code = http.request(server)
        --print("net ok...",code)
        if code == 200 then
            kkFunc.fixTimer(body)
            g_infoLayer.checkTimeLabel:removeFromParent()
            if GameData.energy.value < 5 then
                g_infoLayer:showEnergyTime(g_infoLayer.timePos)
            end
            self.timeOK = true
        end
    end
end

function LevelScene:startGame()
    app:play({level = self.selectLevel})
end

function LevelScene:getScrollView(contentlayer)
    self.scrollView = cc.ui.UIScrollView.new({})
    self.scrollView:setTouchSwallowEnabled(false)
    local function scrollView1DidScroll(event)
    end
    local function scrollView1DidZoom()
    end
    if nil ~= self.scrollView then
        local scrollSize = contentlayer:getBoundingBox()
        scrollSize.width = display.width
        scrollSize.height = display.height
        self.scrollView:setViewRect(scrollSize)
        self.scrollView:setPosition(cc.p(0,0))
        self.scrollView:setScale(1.0)
        self.scrollView:setAnchorPoint(cc.p(0,0))
        self.scrollView:addScrollNode(contentlayer)
        self.scrollView:setDirection(2)
        self.scrollView:setBounceable(false)
        self.scrollView:onScroll(scrollView1DidScroll)
    end
    self:addChild(self.scrollView)
end

function LevelScene:onTouch(event,x,y)
    if VERSION_MONSTER then
        if event == "began" then
            self.moved = false
            self.beginX = x
            return true
        elseif event == "moved" then
            if math.abs(x-self.beginX) < 5 then
                self.moved = false
            else
                self.moved = true
            end
        elseif event == "ended" then
            if self.moved then return end
            --[[for i = 1, 1 do
                local rect = self.themeMap[i]:getCascadeBoundingBox()
                if cc.rectContainsPoint(rect, cc.p(x,y)) then 
                    app:levelbuttonscene({themeNum = i})
                end
            end]]  
        end
    end
end

function LevelScene:onEnter()
    --安卓返回键

         --厦门返回键
    if device.platform == "android" then
        local layer = display.newLayer()
        layer:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
            if event.key == "back" then
                if g_infoLayer.firstPayLayer then
                    if g_infoLayer.firstPayLayer.isReminder then
                        g_infoLayer.firstPayLayer:Remove()
                    end
                elseif g_infoLayer.FullEnergy ~= nil then
                    g_infoLayer.FullEnergy:removeFromParent()
                    g_infoLayer.FullEnergy = nil
                elseif g_infoLayer.poplayer ~=nil then
                    g_infoLayer:RemovePop()
                elseif g_DailyTaskLayer ~=nil then
                    g_DailyTaskLayer:Remove()
                elseif g_infoLayer.shopLayer ~= nil then
                    g_infoLayer.shopLayer:Remove()
                elseif g_infoLayer.prepareLayer ~=nil then
                    g_infoLayer.prepareLayer:Remove()
                else
                    app:main()
                end
            end
        end)
        self:addChild(layer)
        layer:setTouchSwallowEnabled(false)
        layer:setKeypadEnabled(true)
    end
         --厦门返回键
         
    -- 注册touch事件处理函数
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)
    --更新
    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
        self:update(dt) 
    end)
    if VERSION_MONSTER then
        --self:scheduleUpdate()
    else  
        self:scheduleUpdate()
    end  
end

function LevelScene:update(dt)
    local x = self.duck.a * math.cos(2*math.pi*self.duck.time/self.duck.cycle)
    local y = self.duck.b * math.sin(2*math.pi*self.duck.time/self.duck.cycle)
    self.duck.time = self.duck.time+dt
    self.duck:setPosition(cc.pAdd(self.duck.CenterPos, cc.p(x,y)))
end

function LevelScene:onExit()
    local px,py = self.levelLayer:getPosition()
    GameData.levelMapPos = cc.p(px,py)
    --释放资源
    for k,v in pairs(self.res) do
        ResData.removeRes(v)
    end
    GameState.save(GameData)
end

function LevelScene:onEnterForeground()
    self.timeOK = kkFunc.checkTimer()
    if not self.timeOK then
        self:timerWrong()
    else--从后台切回来重置体力时间显示
        if g_infoLayer.timeLabel ~= nil then
            g_infoLayer.timeLabel:removeFromParent()
            g_infoLayer.timeLabel = nil
            g_infoLayer:unscheduleUpdate()
            g_infoLayer:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
            g_infoLayer:showEnergyTime(g_infoLayer.timePos)
        end
    end

    -- local timeOK = kkFunc.checkTimer()
    -- if timeOK then 
    --     if GameData.energy.value < 5 then
    --         g_infoLayer.control = false
    --         if g_infoLayer.timeLabel ~= nil then
    --             g_infoLayer.timeLabel:removeFromParent()
    --             g_infoLayer.timeLabel = nil
    --         end
    --         g_infoLayer:showEnergyTime(g_infoLayer.timePos)
    --     end
    -- elseif not timeOK then
    --     self:timerWrong()
    -- end
end

function LevelScene:createTestThings()
    --测试关卡按钮
    self.testButton = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "测试关卡页",
            align = ui.TEXT_ALIGN_CENTER,
            size = 30,
        }))
        :onButtonClicked(function()
            self:showTestLevel(true)             
        end)
        :pos(120, 100)
        :addTo(self)
    --测试列表页
    self.testLevelLayer = display.newLayer()
    self:addChild(self.testLevelLayer)
    self.testLevelLayer:setVisible(false)
    --测试返回
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "返回",
            align = ui.TEXT_ALIGN_CENTER,
            size = 30,
        }))
        :onButtonClicked(function()
            self:showTestLevel(false)             
        end)
        :pos(120, 100)
        :addTo(self.testLevelLayer)
    --十五个测试关关
    local col = 5
    local testLevelItems = {}
    for i = 1, 15 do
        local dd = i - math.floor((i-1)/col)*col
        local x = display.cx - ((col+1)/2-dd)*130
        local y = display.height-90-70*math.floor((i+col-1)/col)
        cc.ui.UIPushButton.new({})
            :setButtonLabel("normal", cc.ui.UILabel.new({
                UILabelType = 2,
                text = "Test-"..i,
                align = ui.TEXT_ALIGN_CENTER,
                size = 30,
            }))
            :onButtonClicked(function()
                self.selectLevel = 700 + i
                self:startGame()               
            end)
            :pos(x, y)
            :addTo(self.testLevelLayer)
    end

    --支线玩法测试
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "支线测试1",
            align = ui.TEXT_ALIGN_CENTER,
            size = 30,
        }))
        :onButtonClicked(function()
            self.selectLevel = 12
            self:startGame()             
        end)
        :pos(display.cx + 150, display.cy-90)
        :addTo(self.testLevelLayer)
    --"支线测试2"   
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "支线测试2",
            align = ui.TEXT_ALIGN_CENTER,
            size = 30,
        }))
        :onButtonClicked(function()
            self.selectLevel = 13
            self:startGame()             
        end)
        :pos(display.cx + 150, display.cy-160)
        :addTo(self.testLevelLayer)

    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "Level floatWay",
            align = ui.TEXT_ALIGN_CENTER,
            size = 40,
        }))
        :onButtonClicked(function()
            self.selectLevel = 10
            self:startGame()             
        end)
        :pos(display.cx-80, display.cy-90)
        :addTo(self.testLevelLayer)
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "Level Water",
            align = ui.TEXT_ALIGN_CENTER,
            size = 40,
        }))
        :onButtonClicked(function()
            self.selectLevel = 11
            self:startGame()             
        end)
        :pos(display.cx-80, display.cy-160)
        :addTo(self.testLevelLayer)
    --self.levelMenu:setPosition(cc.p(display.cx,display.cy-100))
    --self.levelMenu:alignItemsVertically()
end

function LevelScene:LevelPoints(isFirstTime)
    local BatchPoint = nil
    local OpenLevelPoints = {}
    local PointCount = 1--开启新关卡的point计数
    local PicPath = "map/LevelTheme/point.png"
    if GameData.openlevel<=1 then
        return
    else
        BatchPoint = display.newBatchNode(PicPath)
        self.levelLayer:addChild(BatchPoint)
    end
    local group = self.map:getObjectGroup("points")
    local array = group:getObjects()
    for k,v in pairs(array) do
        if tonumber(v.level) < GameData.openlevel then
            BatchPoint:addChild(display.newSprite(PicPath,tonumber(v.x),tonumber(v.y)-self.levelButtonDy))
        elseif tonumber(v.level) == GameData.openlevel then
            if isFirstTime then
                OpenLevelPoints[PointCount] = v
                for i=PointCount,1 do
                    if OpenLevelPoints[i-1] then
                        if OpenLevelPoints[i-1].step >OpenLevelPoints[i].step then
                            OpenLevelPoints[i-1],OpenLevelPoints[i] = OpenLevelPoints[i],OpenLevelPoints[i-1]
                        end
                    end
                end
                PointCount = PointCount+1
            else
                BatchPoint:addChild(display.newSprite(PicPath,tonumber(v.x),tonumber(v.y)-self.levelButtonDy))
            end
        elseif isFirstTime and tonumber(v.level)%10 == 2 then--当是主题首关时，不满足星数不开启
            if tonumber(v.level)-1 == GameData.openlevel and (not self:isStarsEnough(GameData.openlevel)) then
                self:MapMove()
                return
            end
        end
    end
    for k,v in pairs(OpenLevelPoints) do
        self:performWithDelay(function ()
            BatchPoint:addChild(display.newSprite(PicPath,tonumber(v.x),tonumber(v.y)-self.levelButtonDy))
        end, 0.5*k)
    end
    if isFirstTime then
        local delay = 0--先移动地图再亮点
        if self:MapMove() then--移动地图
            delay = 1
        end
        for k,v in pairs(OpenLevelPoints) do
            self:performWithDelay(function ()
                BatchPoint:addChild(display.newSprite(PicPath,tonumber(v.x),tonumber(v.y)-self.levelButtonDy))
            end, 0.5*(k+delay))
        end
        local StarSprite = display.newSprite()
        local x = self.levelButton[GameData.openlevel]:getContentSize().width/2
        local y = self.levelButton[GameData.openlevel]:getContentSize().height/2
        StarSprite:setPosition(x+5,y+15)
        self.levelButton[GameData.openlevel]:addChild(StarSprite,-1)          
        local frames = display.newFrames("countdownEffect%d.png", 1, 6)
        local animation = display.newAnimation(frames, 0.1)
        StarSprite:playAnimationOnce(animation,true,function()
            --按钮变亮
            local buttonPicName
            if self.DailyFinishNum == 4 then
                buttonPicName = "#levelButton2.png"
            else
                buttonPicName = "#levelButton.png"
            end
            self.levelButton[GameData.openlevel]:setTouchEnabled(true)
            if VERSION_MONSTER then
                self.levelButton[GameData.openlevel]:setButtonImage("normal",buttonPicName)
                self.levelButton[GameData.openlevel]:setButtonImage("pressed",buttonPicName)
            else
                --globalVar.AfterNewLevelAni = true
                self.levelButton[GameData.openlevel]:setColor(cc.c3b(255,255,255))
            end
            --音效
            SoundManager.playSound(GAME_SOUND.Unlock)
            --按钮光圈
            self:ButtonCircle()
        end,0.5*PointCount)
    end   
end

function LevelScene:MapMove()
    local isMove = false
    if GameData.openlevel >= 104 and GameData.openlevel < 406 then
        local x = display.cx-self.levelButton[LevelsData.getLastLevel(GameData.openlevel)]:getPositionX()
        if x > 0 then x = 0 end
        self.scrollView:scrollTo(cc.p(x,0))
        self.levelLayer:runAction(transition.sequence({
            --cc.DelayTime:create(2),
            cc.MoveTo:create(0.5,cc.p(display.cx-self.levelButton[GameData.openlevel]:getPositionX(),0)),
            -- cc.CallFunc:create(function()
            --     self.levelButtonCircle:setPosition(self.levelButton[GameData.openlevel]:getPosition())
            -- end)
        }))
        isMove = true
    -- elseif GameData.openlevel >= 406 then
    --     self:performWithDelay(function()
    --         self.levelButtonCircle:setPosition(self.levelButton[GameData.openlevel]:getPosition())
    --     end, 0)
    -- else
    --     self:performWithDelay(function()
    --         self.levelButtonCircle:setPosition(self.levelButton[GameData.openlevel]:getPosition())
    --     end, 0)
    end
    return isMove
end

function LevelScene:RemoveTaskRedPoint()
    if not self.DailyTaskRedPoint then return end
    self.DailyTaskRedPoint:removeFromParent()
    self.DailyTaskRedPoint = nil
end

function LevelScene:isStarsEnough(level)--开启的关卡是否满足星星数
    if level == 201 then
        if app.getTotalStarNumber() < 25 then
            return false
        end
    elseif level == 301 then
        if app.getTotalStarNumber() < 50 then
            return false
        end
    elseif level == 401 then
        if app.getTotalStarNumber() < 75 then
            return false
        end
    end
    return true
end

return LevelScene
