--
-- Author: KK
-- Date: 2015-01-09 10:23:03
--
--Loading页面，进入LevelScene和PlayScene时会先Loading。


local LoadingScene = class("LoadingScene", function()
    return display.newScene("LoadingScene")
end)

function LoadingScene:ctor(params)
    if LOADING_CLOUD then
        local cloud1 = display.newSprite("pic/whiteCloud.png",display.cx,display.cy+200)
        cloud1:setScale(2.2)
        self:addChild(cloud1)
        local cloud2 = display.newSprite("pic/whiteCloud.png",display.cx,display.cy-200)
        cloud2:setScale(2.2)
        self:addChild(cloud2)
    else
        local bg = display.newSprite("pic/loadingBg.png", display.cx, display.cy):addTo(self)
        --display.newSprite("pic/loadingLabel.png", display.cx, display.cy):addTo(self)
    end
    self.params = params
    --[[
    self.running = true
    self.level = params.level
    self.params = params
    self:cloudComeIn(params)
    --local bg = display.newColorLayer(cc.c4b(128,128,128,255))
    --self:addChild(bg)

    --self:labelLoading(params)
    --]]
end

function LoadingScene:onEnter()
    if LOADING_ASYNC == false then --新场景自己加载
    	if self.params.loadType == "play" then
        	app:realPlay(self.params)
        elseif self.params.loadType == "level" then
            app:realLevel(self.params)
        end
    else --异步加载
        if self.params.loadType == "play" then
            self:loadPlaySceneAsync()
        elseif self.params.loadType == "level" then
            self:loadLevelSceneAsync()
        elseif self.params.loadType == "hero" then
            self:loadHeroSceneAsync()
        elseif self.params.loadType == "achievement" then
            self:loadAchievementSceneAsync()
        elseif self.params.loadType == "handbook" then
            self:loadHandbookAsync()
        end
    end
end

function LoadingScene:loadAchievementSceneAsync()
    self.res = {"UI_ACHIEVEMENT"}
    self.resCount = 0
    for k,v in pairs(self.res) do
        self.resCount = self.resCount + ResData.resCount(v)
    end
    self.loadNum = 0
    for k,v in pairs(self.res) do
        ResData.loadResAsync(v, handler(self,self.addImageCallback5))
    end
    self.ok = true
end
function LoadingScene:addImageCallback5()
    self.loadNum = self.loadNum + 1
    if self.loadNum >= self.resCount and self.ok then
        self:goAchievementScene()
    end
end

function LoadingScene:loadHandbookAsync()
    self.res = {"UI_HANDBOOK"}
    self.resCount = 0
    for k,v in pairs(self.res) do
        self.resCount = self.resCount + ResData.resCount(v)
    end
    self.loadNum = 0
    for k,v in pairs(self.res) do
        ResData.loadResAsync(v, handler(self,self.addImageCallback4))
    end
    self.ok = true
end
function LoadingScene:addImageCallback4()
    self.loadNum = self.loadNum + 1
    if self.loadNum >= self.resCount and self.ok then
        self:goHandbook()
    end
end

function LoadingScene:loadHeroSceneAsync()
    self.res = {"UI_HEROHOUSEANI","UI_HEROHOUSEUI"}
    self.resCount = 0
    for k,v in pairs(self.res) do
        self.resCount = self.resCount + ResData.resCount(v)
    end
    self.loadNum = 0
    for k,v in pairs(self.res) do
        ResData.loadResAsync(v, handler(self,self.addImageCallback3))
    end
    self.ok = true
end

function LoadingScene:addImageCallback3()
    self.loadNum = self.loadNum + 1
    if self.loadNum >= self.resCount and self.ok then
        self:goHeroHouse()
    end
end

function LoadingScene:loadLevelSceneAsync()
    self.res = {"LEVELMAP"}
    --[[
    self.LoadingLabel = cc.ui.UILabel.new({
            text = "Loading...",
            size = 150,
            x = display.cx,
            y = display.cy,
            color = display.COLOR_BLACK,
        }):align(display.CENTER)
    self:addChild(self.LoadingLabel)
    self.countLabel = cc.ui.UILabel.new({
            text = "0/0",
            size = 50,
            align = ui.TEXT_ALIGN_CENTER,
            x = display.cx,
            y = display.cy+100,
            color = display.COLOR_BLACK,
        })
    self:addChild(self.countLabel)
    --]]
    self.resCount = 0
    for k,v in pairs(self.res) do
        self.resCount = self.resCount + ResData.resCount(v)
    end
    self.loadNum = 0
    for k,v in pairs(self.res) do
        ResData.loadResAsync(v, handler(self,self.addImageCallback2))
    end
    self.ok = true
end

function LoadingScene:addImageCallback2()
    self.loadNum = self.loadNum + 1
    --self.countLabel:setString(self.loadNum.."/"..self.resCount)
    if self.loadNum >= self.resCount and self.ok then
        for k,v in pairs(self.res) do
            ResData.loadAnimationForAsync(v)
        end
        app:realLevel(self.params)
    end
end

function LoadingScene:loadPlaySceneAsync()
	self.res = ResData.getResFromLevelData(LevelsData[self.params.level])
    --[[
    self.LoadingLabel = cc.ui.UILabel.new({
            text = "Loading...",
            size = 150,
            x = display.cx,
            y = display.cy,
            color = display.COLOR_BLACK,
        }):align(display.CENTER)
    self:addChild(self.LoadingLabel)
    self.countLabel = cc.ui.UILabel.new({
            text = "0/0",
            size = 50,
            align = ui.TEXT_ALIGN_CENTER,
            x = display.cx,
            y = display.cy+100,
            color = display.COLOR_BLACK,
        })
    self:addChild(self.countLabel)
    --]]

    --[[
    local themeNum = LevelsData[self.level].theme
    local theme = "map/Theme"..themeNum.."/theme"..themeNum.."Scene.png"
    MapInfo.mapBg = display.newSprite(theme)
    local width = MapInfo.mapBg:getContentSize().width
    MapInfo.mapBg:setPosition(cc.p(width/2,display.cy))
    --MapInfo.mapBg:setPosition(cc.p(display.width - width/2,display.cy))
    self:addChild(MapInfo.mapBg,-10)
    --]]

    self.resCount = 0
    for k,v in pairs(self.res) do
        self.resCount = self.resCount + ResData.resCount(v)
    end
    self.loadNum = 0
    for k,v in pairs(self.res) do
        ResData.loadResAsync(v, handler(self,self.addImageCallback))
    end
    self.ok = true
    --[[
    self.ok = false
    self:performWithDelay(function()
        self.ok = true
        if self.loadNum >= self.resCount then
            self:goPlay()
        end
    end, 2) --最少等待时间。
    --]]
end

function LoadingScene:addImageCallback()
	self.loadNum = self.loadNum + 1
    --self.countLabel:setString(self.loadNum.."/"..self.resCount)
	if self.loadNum >= self.resCount and self.ok then
        self:goPlay()
    end
end

function LoadingScene:goHeroHouse()
    for k,v in pairs(self.res) do
        ResData.loadAnimationForAsync(v)
    end
    app:realHeroHouse()
end

function LoadingScene:goAchievementScene()
    for k,v in pairs(self.res) do
        ResData.loadAnimationForAsync(v)
    end
    app:realAchievement()
end

function LoadingScene:goHandbook()
    for k,v in pairs(self.res) do
        ResData.loadAnimationForAsync(v)
    end
    app:realHandbook()
end

function LoadingScene:goPlay()
    --kkFunc.LogCat("goPlay")
    for k,v in pairs(self.res) do
        ResData.loadAnimationForAsync(v)
    end
    audio.preloadMusic(GAME_MUSIC.BGM2)
    app:realPlay(self.params)
end

function LoadingScene:onExit()
    cc.Director:getInstance():getTextureCache():removeTextureForKey("pic/loadingBg.png")
    --cc.Director:getInstance():getTextureCache():removeTextureForKey("pic/loadingLabel.png")
end

return LoadingScene