
local AdminLayer = import("..views.AdminLayer")
local ServiceLayer = import("..views.ServiceLayer")
local scheduler = require("framework.scheduler")
local FireFly = import("..obj.FireFly")
local MainScene = class("MainScene", function()
    return display.newScene("MainScene")
end)

function MainScene:ctor()
    --版本号
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,201)
    self.version = cc.ui.UILabel.new({
        text = "1.0.1",
        size = 22,
        color = cc.c3b(255,255,255),
        x = display.cx,
        y = 50,
        })
    self:addChild(self.version,20)
    self.version:setVisible(false)
    self.labelTime = nil
    --UI背景音乐
    SoundManager.playMusic(GAME_MUSIC.BGM1)
    self.res = {"MAINSCENE"}
    for k,v in pairs(self.res) do
        ResData.loadRes(v)
    end
    local bg = display.newSprite("pic/mainCover.png")
    bg:setPosition(cc.p(display.cx,display.cy))
    self:addChild(bg)
    --self:showAccelerEyes()
    local DropTime = 0.13
    local OpeningDelay1 = 0.5
    local OpeningDelay2 = 1.2
    --绳子
    self:performWithDelay(function ()
        self.rope1 = display.newSprite("#rope.png",display.cx-150,display.top+140)
        self.rope1:setAnchorPoint(cc.p(0.5,1))
        self:addChild(self.rope1)
        self.rope2 = display.newSprite("#rope.png",display.cx+150,display.top+140)
        self.rope2:setAnchorPoint(cc.p(0.5,1))
        self:addChild(self.rope2)
        transition.moveTo(self.rope1, {y = display.top+3,time = DropTime})
        transition.moveTo(self.rope2, {y = display.top+3,time = DropTime})
        local function UpdateRope()
            local rotate = math.asin((self.rope1:getPositionX()-(self.logoPic:getPositionX()-150))/250)*180
            self.rope1:setRotation(rotate)
            self.rope2:setRotation(rotate)
        end
        self.handleRope = scheduler.scheduleUpdateGlobal(UpdateRope)
    end, OpeningDelay1)                     
    --logo
    self:performWithDelay(function ()
        self.logoPic = display.newSprite("#mainLogo.png")
        self.logoPic:setPosition(display.cx, display.top+self.logoPic:getContentSize().height/2)
        self:addChild(self.logoPic,1)
        self.logoPic:runAction(transition.sequence({
            cc.MoveTo:create(DropTime,cc.p(display.cx,display.top-140)),
            cc.Spawn:create(cc.MoveTo:create(0.1,cc.p(display.cx-20,display.top-140)),cc.RotateTo:create(0.1, 5)),
            cc.Spawn:create(cc.MoveTo:create(0.2,cc.p(display.cx+20,display.top-140)),cc.RotateTo:create(0.2, -5)),
            cc.Spawn:create(cc.MoveTo:create(0.2,cc.p(display.cx-10,display.top-140)),cc.RotateTo:create(0.2, 2.5)),
            cc.Spawn:create(cc.MoveTo:create(0.2,cc.p(display.cx+10,display.top-140)),cc.RotateTo:create(0.2, -2.5)),
            cc.Spawn:create(cc.MoveTo:create(0.2,cc.p(display.cx-5,display.top-140)),cc.RotateTo:create(0.2, 1.2)),
            cc.Spawn:create(cc.MoveTo:create(0.2,cc.p(display.cx+2,display.top-140)),cc.RotateTo:create(0.2, 0.6)),
            cc.Spawn:create(cc.MoveTo:create(0.2,cc.p(display.cx,display.top-140)),cc.RotateTo:create(0.2, 0)),
        })
    )
    end, OpeningDelay1)
    --牌子隔一会一晃效果
    -- self:performWithDelay(function ()
    --     self.logoPic:runAction(cc.RepeatForever:create(transition.sequence({
    --             cc.Spawn:create(cc.MoveTo:create(0.2,cc.p(display.cx-10,display.top-140)),cc.RotateTo:create(0.1, 2.5)),
    --             cc.Spawn:create(cc.MoveTo:create(0.4,cc.p(display.cx+10,display.top-140)),cc.RotateTo:create(0.2, -2.5)),
    --             cc.Spawn:create(cc.MoveTo:create(0.4,cc.p(display.cx-5,display.top-140)),cc.RotateTo:create(0.2, 1.2)),
    --             cc.Spawn:create(cc.MoveTo:create(0.4,cc.p(display.cx+5,display.top-140)),cc.RotateTo:create(0.2, -1.2)),
    --             cc.Spawn:create(cc.MoveTo:create(0.4,cc.p(display.cx-2,display.top-140)),cc.RotateTo:create(0.2, 0.6)),
    --             cc.Spawn:create(cc.MoveTo:create(0.4,cc.p(display.cx,display.top-140)),cc.RotateTo:create(0.2, 0)),
    --             cc.DelayTime:create(3)
    --         })
    --     ))
    -- end, 4)
    --开始按钮
    self:performWithDelay(function ()
        self.playButton = cc.ui.UIPushButton.new({
            normal = "#playButoon.png",
            pressed = "#playButoon.png",
            disabled = "#playButoon.png",
        })
        :onButtonPressed(function()
            self.playButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button1)
        end)
        :onButtonRelease(function()
            self.playButton:setScale(1)
        end)
        :onButtonClicked(function()
            self:startGame()      
        end)
        :pos(display.cx, display.cy -50)
        self.playButton:setScale(0.05)    
        self:addChild(self.playButton,1)
        self.playButton:runAction(transition.sequence({
                cc.ScaleTo:create(0.25,1),
                cc.CallFunc:create(function ()
                    local params = {maxScale = 1.20,times = 3,time = 0.25,difference = 3}
                    kkFunc.ActionElasticity(self.playButton,params)
                end)
            })
        )
        self.playButton:runAction(cc.RepeatForever:create(transition.sequence({
                    cc.DelayTime:create(3.5),
                    cc.CallFunc:create(function ()
                        local params = {maxScale = 1.20,times = 3,time = 0.25,difference = 3}
                        kkFunc.ActionElasticity(self.playButton,params)
                    end)
                })
            )
        )
    end, OpeningDelay2)
    --萤火虫
    local FireFlies = {}
    for i=1,15 do
        local leftTemp = display.left
        local rightTemp = display.right
        local bottomTemp = display.bottom
        local topTemp = display.top/4.0
        local params = {
                        range = {
                                left = leftTemp,
                                right = rightTemp,
                                top = topTemp,
                                bottom = bottomTemp,
                                }
                        }
        local fireFly = FireFly.new(params)
        fireFly:setPosition(math.random(leftTemp,rightTemp), math.random(bottomTemp,topTemp))
        self:addChild(fireFly)
        FireFlies[#FireFlies+1] = fireFly
    end
    local function UpdateFireFly()
        for i=1,#FireFlies do
            FireFlies[i]:update()
        end
    end
    self.handleFireFly = scheduler.scheduleUpdateGlobal(UpdateFireFly)
    --按钮光效，试验
    --[[local emitter1 = cc.ParticleSystemQuad:create("particle/UIlizi03.plist")
    --emitter1:setStartColor(cc.c4f(1,0,0,1))
    emitter1:setBlendAdditive(true)
    emitter1:setPosition(cc.p(display.cx-70,display.cy-118-36))
    emitter1:setEmissionRate(32)
    self:addChild(emitter1)
    local act = kkFunc.getButtonCircleAction(40,72,140,0.5)
    emitter1:runAction(act)

    --管理员页
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "管理",
            align = cc.TEXT_ALIGNMENT_CENTER,
            size = 50,
            color = display.COLOR_BLUE,
        }))
        :onButtonClicked(function()
            local adminLayer = AdminLayer.new()
            self:addChild(adminLayer,100)         
        end)
        :align(display.CENTER,display.cx, 100)
        :addTo(self)
    --]]

    self.updateButton = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "更新",
            size = 100,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            --package.loaded = {} 
            --package.loaded["..update"] = nil
            require("..update")         
        end)
        :pos(display.cx, display.cy-200)
        :addTo(self)
    self.updateButton:setVisible(false)    

    self:showMainButton()

    self.vx = 0
    self.vy = 0
    --self.ball = display.newSprite("pic/bloodNewTest.png", display.cx, display.cy)
    --self:addChild(self.ball)

    --self:testEffect()
    --self:testParticle()
    --self:testAcceler()
    --self:testClearCloud()
    if device.platform == "ios" then
        --self:testMike()
    else
        --[[
        local filterData = {
            "CUSTOM",
            json.encode({frag = "shader/outline.fsh",
                shaderName = "outlineShader",
                u_outlineColor = {249/255, 100/255, 100/255},
                u_radius = 0.005,
                u_threshold = 2.75,
            })
        } 
        local filter, param = unpack(filterData)
        self.mikeCloud = display.newFilteredSprite("res/pic/bloodNewTest.png", filter, param)
            :pos(display.cx, display.cy+100)
            :addTo(self)
        --]]
    end
    --self:testClippingNode()
end
function MainScene:showMainButton()
    --更多游戏
    if AIGAME_SERVICE then
        self.moreGame = cc.ui.UIPushButton.new({
            normal = "#moreGames.png",
            pressed = "#moreGames.png",
            disabled = "#moreGames.png",
            })
            :onButtonPressed(function()
                self.moreGame:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.moreGame:setScale(1)
            end)
            :onButtonClicked(function() 
                --厦门--
                -- if device.platform == "android" then
                --     local className = "org/cocos2dx/lua/AppActivity"
                --     local sig = "()V"
                --     luaj.callStaticMethod(className, "moreGames",nil,sig)               
                -- end
                --厦门--
            end):align(display.CENTER,display.width-100, display.height-100)
        self:addChild(self.moreGame,1)
    end
    --音乐音效设置
    self.SoundButton = cc.ui.UIPushButton.new({
        normal = "#soundButton.png",
        pressed = "#soundButton.png",
        disabled = "#soundButton.png",
        })
        :onButtonPressed(function()
            self.SoundButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.SoundButton:setScale(1)
        end)
        :onButtonClicked(function()
            self:popSoundSetLayer()                
        end):align(display.CENTER,100, 100)
    self:addChild(self.SoundButton,1)

    --厦门--
    -- if TEST_DEMO then
    --     self.testButton = cc.ui.UIPushButton.new({
    --         normal = "#helpButton.png",
    --         pressed = "#helpButton.png",
    --         disabled = "#helpButton.png",
    --         })
    --         :onButtonPressed(function()
    --             self.testButton:setScale(1.1)
    --             --音效
    --             SoundManager.playSound(GAME_SOUND.Button2)
    --         end)
    --         :onButtonRelease(function()
    --             self.testButton:setScale(1)
    --         end)
    --         :onButtonClicked(function() 
    --             local adminLayer = AdminLayer.new()
    --             self:addChild(adminLayer,100)
    --         end):align(display.CENTER,display.width-220, 100)
    --     self:addChild(self.testButton,1)
    --     --self.testButton:setButtonEnabled(false)
    -- else
    --     --客服
    --     if not VERSION_REDUCE then
    --         self.helpButton = cc.ui.UIPushButton.new({
    --             normal = "#helpButton.png",
    --             pressed = "#helpButton.png",
    --             disabled = "#helpButton.png",
    --             })
    --             :onButtonPressed(function()
    --                 self.helpButton:setScale(1.1)
    --                 --音效
    --                 SoundManager.playSound(GAME_SOUND.Button2)
    --             end)
    --             :onButtonRelease(function()
    --                 self.helpButton:setScale(1)
    --             end)
    --             :onButtonClicked(function()
    --                 if not VERSION_REDUCE then 
    --                     local serviceLayer = ServiceLayer.new()
    --                     self:addChild(serviceLayer,5)
    --                 end
    --             end):align(display.CENTER,display.width-100, 100)
    --         self:addChild(self.helpButton,1)
    --     end
    -- end
     --厦门--

   
end
function MainScene:popSoundSetLayer()
    self.soundTouchLayer = display.newLayer()
    self:addChild(self.soundTouchLayer,5)
    self.soundTouchLayer:setTouchSwallowEnabled(true)
    local soundlayer = display.newSprite("#soundSetBg.png",display.cx,display.cy)
    self.soundTouchLayer:addChild(soundlayer)
    local closeY
    if VERSION_REDUCE then
        closeY = 270
        closeX = 540
    else
        closeY = 255
        closeX = 520
    end 
    self.closebutton = cc.ui.UIPushButton.new({
        normal = "#setCloseButton.png",
        pressed = "#setCloseButton.png",
        disabled = "#setCloseButton.png",
        })
        :onButtonPressed(function()
            self.closebutton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.closebutton:setScale(1)
        end)
        :onButtonClicked(function()
            self.soundTouchLayer:removeFromParent()
            self.soundTouchLayer = nil            
        end):align(display.CENTER,closeX, closeY)
        :addTo(soundlayer)
    local musicX,musicY,soundX,soundY,resetY
    if VERSION_REDUCE then
        musicX = 200
        musicY = 175
        soundX = 440
        soundY = 175
        resetY = 70
    else
        musicX = 185
        musicY = 160
        soundX = 420
        soundY = 160
        resetY = 60
    end 
    local text = "#sound_setOpen.png"
    if not GameData.music then
        text = "#sound_setClose.png"
    end
    self.musicControlButton = cc.ui.UIPushButton.new({
        normal = text,
        disabled = text,
        pressed = text,
        })
        :onButtonClicked(function(event)
            if GameData.music then    
                audio.stopMusic()
                GameData.music = false
                GameState.save(GameData)
                self.musicControlButton:setButtonImage("normal", "#sound_setClose.png")
                self.musicControlButton:setButtonImage("disabled", "#sound_setClose.png")
                self.musicControlButton:setButtonImage("pressed", "#sound_setClose.png") 
            else
                GameData.music = true
                GameState.save(GameData)
                audio.playMusic(GAME_MUSIC.BGM1)
                self.musicControlButton:setButtonImage("normal", "#sound_setOpen.png")
                self.musicControlButton:setButtonImage("disabled", "#sound_setOpen.png")
                self.musicControlButton:setButtonImage("pressed", "#sound_setOpen.png")
            end
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :pos(musicX, musicY)
        :addTo(soundlayer)
    local textEffect = "#sound_setOpen.png"
    if not GameData.sound then
        textEffect = "#sound_setClose.png"
    end
    self.soundControlButton = cc.ui.UIPushButton.new({
        normal = textEffect,
        disabled = textEffect,
        pressed = textEffect,
        })
        :onButtonClicked(function(event)
            if GameData.sound then     
                audio.stopAllSounds()
                GameData.sound = false
                GameState.save(GameData)
                self.soundControlButton:setButtonImage("normal", "#sound_setClose.png")
                self.soundControlButton:setButtonImage("disabled", "#sound_setClose.png")
                self.soundControlButton:setButtonImage("pressed", "#sound_setClose.png") 
            else
                GameData.sound = true
                GameState.save(GameData)
                self.soundControlButton:setButtonImage("normal", "#sound_setOpen.png")
                self.soundControlButton:setButtonImage("disabled", "#sound_setOpen.png")
                self.soundControlButton:setButtonImage("pressed", "#sound_setOpen.png")
            end
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :pos(soundX, soundY)
        :addTo(soundlayer)
    --清空数据
    self.cleardata = cc.ui.UIPushButton.new({
        normal = "#setAgainButton.png",
        disabled = "#setAgainButton.png",
        pressed = "#setAgainButton.png",
        })
        :onButtonPressed(function()
            self.cleardata:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.cleardata:setScale(1)
        end)
        :onButtonClicked(function(event)
            self:popLayer()
        end)
        :pos(soundlayer:getContentSize().width/2, resetY)
        :addTo(soundlayer)
    --教学
    --[[self.teachButton = cc.ui.UIPushButton.new({
        normal = "#setTeachButton.png",
        disabled = "#setTeachButton.png",
        pressed = "#setTeachButton.png",
        })
        :onButtonPressed(function()
            self.teachButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.teachButton:setScale(1)
        end)
        :onButtonClicked(function(event)
            app:play({level = 100,isTeach = true})
            --DataEye
        end)
        :pos(272, 60)
        :addTo(soundlayer)
    --about
    self.aboutButton = cc.ui.UIPushButton.new({
        normal = "#setAboutButton.png",
        disabled = "#setAboutButton.png",
        pressed = "#setAboutButton.png",
        })
        :onButtonPressed(function()
            self.aboutButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.aboutButton:setScale(1)
        end)
        :onButtonClicked(function(event)
        end)
        :pos(435, 60)
        :addTo(soundlayer)  
    --]]
end
--弹出框
function MainScene:popLayer()
    self.poplayer = display.newLayer()
    self:addChild(self.poplayer,22)
    self.poplayer:setTouchSwallowEnabled(true)
    local layercolor = cc.LayerColor:create(cc.c4b(0,0,0,128),display.width,display.height)
    self.poplayer:addChild(layercolor,-1)
    local popBg = display.newSprite("#poplayer.png",display.cx,display.cy)
    self.poplayer:addChild(popBg)
    local title
    if VERSION_REDUCE then
        title = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionText("重置数据标题"),
            size = 28,
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = 182,
            y = 239,
            }):align(display.CENTER)
    else
        title = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionText("重置数据标题"),
            size = 28,
            color = cc.c3b(255,255,255),
            x = 182,
            y = 239,
            }):align(display.CENTER)
    end
    -- local title = cc.ui.UILabel.new({
    --     text = kkFunc.getVersionText("重置数据标题"),
    --     size = 28,
    --     color = cc.c3b(255,255,255),
    --     x = 182,
    --     y = 239,
    --     }):align(display.CENTER)
    popBg:addChild(title)
    local textMess
    if VERSION_REDUCE then
        textMess = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionText("重置数据"),
            size = 24,
            font = "fontEasy.ttf",
            dimensions = cc.size(250, 200),
            color = cc.c3b(255,255,255),
            x = 45,
            y = 195,
            }):align(display.LEFT_TOP)
    else
        textMess = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionText("重置数据"),
            size = 24,
            color = cc.c3b(255,255,255),
            x = 182,
            y = 150,
            }):align(display.CENTER)
    end
    -- local textMess = cc.ui.UILabel.new({
    --     text = kkFunc.getVersionText("重置数据"),
    --     size = 24,
    --     color = cc.c3b(255,255,255),
    --     x = 182,
    --     y = 150,
    --     }):align(display.CENTER)
    popBg:addChild(textMess)
    self.sure = cc.ui.UIPushButton.new({
        normal = "#restartPopSure.png",
        disabled = "#restartPopSure.png",
        pressed = "#restartPopSure.png",
        })
        :onButtonPressed(function()
            self.sure:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(1)
        end)
        :onButtonClicked(function()           
            GameData = {}
            app:initForGameData() --data
            self:restartSoundButton()--按钮
            --初始化全局变量
            globalVar.levelOpenNew = false
            globalVar.levelMapPos = cc.p(0,0)
            globalVar.levelScene = nil
            
            self.soundTouchLayer:removeFromParent()
            self.soundTouchLayer = nil
            self.poplayer:removeFromParent()
            self.poplayer = nil
        end)
        :pos(275, 55)
        :addTo(popBg)
    self.cancle = cc.ui.UIPushButton.new({
        normal = "#restartPopCancle.png",
        disabled = "#restartPopCancle.png",
        pressed = "#restartPopCancle.png",
        })
        :onButtonPressed(function()
            self.cancle:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.cancle:setScale(1)
        end)
        :onButtonClicked(function()
            self.poplayer:removeFromParent()
            self.poplayer = nil
        end)
        :pos(90, 55)
        :addTo(popBg)
end
function MainScene:restartSoundButton()
    audio.playMusic(GAME_MUSIC.BGM1)
    self.musicControlButton:setButtonImage("normal", "#sound_setOpen.png")
    self.musicControlButton:setButtonImage("disabled", "#sound_setOpen.png")
    self.musicControlButton:setButtonImage("pressed", "#sound_setOpen.png")
    self.soundControlButton:setButtonImage("normal", "#sound_setOpen.png")
    self.soundControlButton:setButtonImage("disabled", "#sound_setOpen.png")
    self.soundControlButton:setButtonImage("pressed", "#sound_setOpen.png")
end
function MainScene:showAccelerEyes()
    self.eyes = {
        [1] = {
            name = "pic/eye.png",
            x = display.cx+344,
            y = display.cy-177,
            dist = 15,
        },
        [2] = {
            name = "pic/eye.png",
            x = display.cx+433,
            y = display.cy-173,
            dist = 15,
        },
        [3] = {
            name = "pic/eye2.png",
            x = display.cx+12,
            y = display.cy-26,
            dist = 17,
        },
        [4] = {
            name = "pic/eye2.png",
            x = display.cx+136,
            y = display.cy-32,
            dist = 17,
        },
    }
    for i = 1, #self.eyes do
        self.eyes[i].sprite = display.newSprite(self.eyes[i].name, self.eyes[i].x,self.eyes[i].y):addTo(self)
        if i == 4 then
            self.eyes[i].sprite:setScale(0.9)
        end
    end

    cc.Device:setAccelerometerEnabled(true)
    cc.Device:setAccelerometerInterval(0.03)
    local function didAccelerate(event,x,y,z,timestamp)
        self.vx = x*300
        self.vy = (y+0.2)*300
        --print(x,y)
    end
    local listener = cc.EventListenerAcceleration:create(didAccelerate)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithSceneGraphPriority(listener, self)

    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt)
        self:updateEyes(dt)
    end)
    self:scheduleUpdate()
end

function MainScene:updateEyes(dt)
    for i = 1, #self.eyes do
        eye = self.eyes[i]
        local px,py = eye.sprite:getPosition()
        px = px + self.vx*dt
        py = py + self.vy*dt
        local dist = cc.pGetDistance(cc.p(eye.x,eye.y), cc.p(px,py))
        if dist > eye.dist then
            local sub = cc.pSub(cc.p(eye.x,eye.y),cc.p(px,py))
            local pcent = eye.dist/dist
            local dx = sub.x*pcent
            local dy = sub.y*pcent
            px,py = eye.x-dx,eye.y-dy
        end
        eye.sprite:setPosition(px,py)
    end        
end

function MainScene:testEffect()
    local sprite = cc.Sprite:create("/res/pic/whiteCloud.png")
    sprite:setPosition(cc.p(display.cx,display.cy))
    local node = cc.NodeGrid:create()
    node:addChild(sprite)
    self:addChild(node)
    local st3D = cc.ShatteredTiles3D:create(4, cc.size(16,12), 25, true)
    node:runAction(st3D)
end

function MainScene:testClippingNode()
    local shape = display.newPolygon({
        [1] = {-100, -100},
        [2] = {100, -100},
        [3] = {0, 100},
    },
    {
        fillColor = cc.c4f(0, 1, 0, 1)
    })
    shape:setPosition(cc.p(50,50))
    shape:runAction(cc.RepeatForever:create(cc.RotateBy:create(1.0, 90.0)))

    local clip = cc.ClippingNode:create()
    clip:setAnchorPoint(cc.p(0.5, 0.5));
    clip:setPosition(cc.p(display.cx-50,display.cy-50))
    clip:setInverted(false)
    clip:setAlphaThreshold(0.5) 
    clip:setStencil(shape)
    self:addChild(clip)

    local content = display.newSprite("res/role/enemy/E61_1.png")
    local scale = cc.ScaleBy:create(1.33, 1.5)
    content:runAction(cc.RepeatForever:create(
        cc.Sequence:create(scale, scale:reverse())))
    content:setPosition(50,50)
    clip:addChild(content)
end

function MainScene:testMike()
    luaoc.callStaticMethod("AppController", "regMikeCallback", {callback = function()
            self:mike()
        end})
    self.sx = math.random(-100,100)
    self.sy = math.random(-100,100)
    self.mikeCloud = display.newSprite("res/pic/bloodNewTest.png", display.cx, display.cy+100):addTo(self,100)
end

function MainScene:mike()
    --print("mike...")
    local size = self.mikeCloud:getContentSize()
    local x,y = self.mikeCloud:getPosition()
    x = x + self.sx*0.1
    y = y + self.sy*0.1
    self.mikeCloud:runAction(cc.MoveTo:create(0.1, cc.p(x,y)))
    --self.render:setPosition(cc.p(x,y))
    if x < size.width*0.5 then 
        self.sx = math.random(0,100)
    elseif x > display.width - size.width*0.5 then
        self.sx = math.random(-100,0)
    end
    if y < size.height*0.5 then 
        self.sy = math.random(0,100)
    elseif y > display.height - size.height*0.5 then
        self.sy = math.random(-100,0)
    end

    --[[
    luaoc.callStaticMethod("AppController", "regMikeCallback", {callback = function()
            self:mike()
        end})
        ]]
end

function MainScene:clearPoint(x,y,midPoints)
    local rect = self.render:getCascadeBoundingBox()
    local px = rect.origin.x
    local py = rect.origin.y
    local subPos = cc.pSub(cc.p(x,y),cc.p(px,py))
    if subPos.x < 0 or subPos.x > self.matrix.picSize.width then return end
    if subPos.y < 0 or subPos.y > self.matrix.picSize.height then return end


    self.render:begin()
    if USE_PIC_PEN then
        self.finger:setPosition(subPos)
        self.finger:visit()
        if midPoints ~= nil then
            for i = 1, #midPoints do
                local pos = cc.pSub(midPoints[i],cc.p(px,py))
                if subPos.x >= 0 and subPos.x <= self.matrix.picSize.width 
                        and subPos.y >= 0 or subPos.y <= self.matrix.picSize.height then
                    local finger = display.newSprite("pic/pen.png")
                    finger:setScale(1.2)
                    finger:setBlendFunc(gl.ZERO, gl.ONE_MINUS_SRC_ALPHA)
                    finger:setPosition(pos)
                    finger:visit()
                end
            end
        end
    else
        self.pen:setPosition(subPos)
        self.pen:visit()
        if midPoints ~= nil then
            for i = 1, #midPoints do
                local pos = cc.pSub(midPoints[i],cc.p(px,py))
                if subPos.x >= 0 and subPos.x <= self.matrix.picSize.width 
                        and subPos.y >= 0 or subPos.y <= self.matrix.picSize.height then
                    local pen = cc.DrawNode:create()
                    pen:drawDot(cc.p(0,0), 30, cc.c4f(1,0,0,1))
                    pen:setBlendFunc(gl.ONE_MINUS_SRC_COLOR, gl.ONE_MINUS_SRC_ALPHA)
                    pen:setPosition(pos)
                    pen:visit()
                end
            end
        end
    end
    self.render:endToLua()

    local ry = math.ceil(subPos.x / self.matrix.colUnit)
    local rx = math.ceil(subPos.y / self.matrix.rowUnit)
    --print(rx,ry)
    local idx = (rx-1)*self.matrix.col+ry
    --print(idx)
    if self.matrix[idx] == 1 then
        self.matrix[idx] = 0
        --print("clear "..idx)
        local notclear = 0
        for i = 1, self.matrix.size do
            if self.matrix[i] == 1 then
                notclear = notclear + 1
            end
        end
        if notclear < 6 then
            self:cloudGone()
            --self.touchLayer:removeFromParent()
            --[[
            self.render:runAction(transition.sequence({
                cc.Blink:create(1, 2),
                --cc.MoveBy:create(1, cc.p(0,100)),
                --cc.FadeOut:create(1),
                cc.CallFunc:create(function()
                    self.render:removeFromParent()
                    if USE_PIC_PEN then
                        self.finger:release()
                    else
                        self.pen:release()
                    end
                    self.render = nil
                end)
            }))
            --]]
            --[[
            self.render:runAction(transition.sequence({
                cc.CallFunc:create(function()
                    self.render:setOpacity(200)--(cc.c3b(100,100,100))
                end),
                cc.DelayTime:create(0.2),
                cc.CallFunc:create(function()
                    self.render:getSprite():setOpacity(150)
                    --self.render:getSprite():setColor(cc.c3b(200,200,200))
                end)
                cc.CallFunc:create(function()
                    self.render:removeFromParent()
                    self.pen:removeFromParent()
                    self.finger:removeFromParent()
                    self.render = nil
                end)
            }))
            --]]
            --print("all clear...")
        end
    end
end

function MainScene:updateLeftCloud(dt)
    self.colorNum = self.colorNum - dt*100
    if self.colorNum < 0 then 
        --self:removeNodeEventListener(cc.NODE_ENTER_FRAME_EVENT)
        self:unscheduleUpdate()
        if USE_PIC_PEN then
            self.finger:removeFromParent()
        else
            self.pen:removeFromParent()
        end
        self.render:removeFromParent()
        self.render = nil
        return
    end
    self.render:getSprite():setColor(cc.c3b(self.colorNum,self.colorNum,self.colorNum))
    self.render:getSprite():setOpacity(self.colorNum)
    self.scale = self.scale + dt*(1/2.5)
    if self.scale < 1 then return end
    self.render:getSprite():setFlippedY(true)
    self.render:getSprite():setScale(self.scale)
end

function MainScene:cloudGone()
    --self.couldTouchLayer:removeNodeEventListener(cc.NODE_TOUCH_EVENT)
    --self.couldTouchLayer:removeFromParent()
    if self.gone then return end
    self.gone = true

    --文字提示
    --self:getParent():cloudHasGone()

    self.colorNum = 255
    self.scale = 0.9
    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt)
        self:updateLeftCloud(dt)
    end)
    self:scheduleUpdate()
end

function MainScene:onTouch(event, x, y)
    --if self.gone then return end
    if event == "began" then
        --[[local rect = self.render:getCascadeBoundingBox()
        if not cc.rectContainsPoint(rect, cc.p(event.x,event.y)) then return end
        self:clearPoint(event.x,event.y)
        self.lastX = event.x
        self.lastY = event.y]]
        --touchlabel
        local rect2 = cc.rect(display.width-50,display.height-50,100,100)
        if cc.rectContainsPoint(rect2, cc.p(x,y)) then
            self.labelTime = 0
            self.moved = false
        end
        return true
    elseif event == "moved" then
        self.moved = true
        --[[local midPoints = {}
        if self.lastX ~= nil and self.lastY ~= nil then
            local newPos = cc.p(event.x,event.y)
            local oldPos = cc.p(self.lastX,self.lastY)
            local dist = cc.pGetDistance(newPos, oldPos)
            local n = math.ceil(dist/20)
            local sub = cc.pSub(newPos,oldPos)
            local dx = sub.x/n
            local dy = sub.y/n
            for i = 1, n-1 do
                local midPos = cc.p(oldPos.x+dx*i,oldPos.y+dy*i)
                midPoints[#midPoints+1] = midPos
            end
        end
        self:clearPoint(event.x,event.y, midPoints)
        self.lastX = event.x
        self.lastY = event.y]]
    elseif event == "ended" then
        --[[self.lastX = nil
        self.lastY = nil]]
        if self.version:isVisible() then
            self.version:setVisible(false)
        end
    end
end
function MainScene:updateTouchLabel(dt)
     --touchLabel
    if not self.moved and self.labelTime ~= nil then
        self.labelTime = self.labelTime + dt
        if self.labelTime > 4 then
            self.labelTime = nil
            self.version:setVisible(true)
        end
    end 
end
function MainScene:testClearCloud()
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer)
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)

    if USE_PIC_PEN then
        self.finger = display.newSprite("pic/pen.png")
        self.finger:setScale(1.2)
        self.finger:retain()
        self.finger:setBlendFunc(gl.ZERO, gl.ONE_MINUS_SRC_ALPHA)
    else
        self.pen = cc.DrawNode:create()
        self.pen:drawDot(cc.p(0,0), 30, cc.c4f(1,0,0,1))
        self.pen:retain()
        self.pen:setBlendFunc(gl.ONE_MINUS_SRC_COLOR, gl.ONE_MINUS_SRC_ALPHA)
    end

    local cloud = display.newSprite("pic/whiteCloud.png")
    self:addChild(cloud)
    cloud:setVisible(false)
    local size = cloud:getContentSize()
    --擦除分块记录
    self.matrix = {}
    local unitSize = 80
    self.matrix.row = math.ceil(size.height/unitSize)
    self.matrix.col = math.ceil(size.width/unitSize)
    self.matrix.picSize = size
    self.matrix.size = self.matrix.row *self.matrix.col
    self.matrix.rowUnit = size.height/self.matrix.row
    self.matrix.colUnit = size.width/self.matrix.col
    --print("row,col:",self.matrix.row,self.matrix.col)
    for i = 1,self.matrix.size do    
        self.matrix[i] = 1
    end

    cloud:setPosition(size.width*0.5,size.height*0.5)
    self.render = cc.RenderTexture:create(
        size.width, size.height,
        cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
    self.render:setPosition(display.cx,display.height - size.height*0.5)
    self.render:begin()
    cloud:setVisible(true)
    cloud:visit()
    cloud:setVisible(false)
    self.render:endToLua()
    self:addChild(self.render)

    --[[
    local sx = math.random(-100,100)
    local sy = math.random(-100,100)
    self:scheduleUpdate(function(dt)
        local x,y = render:getPosition()
        x = x + sx*dt
        y = y + sy*dt
        render:setPosition(cc.p(x,y))
        if x < size.width*0.5 then 
            sx = math.random(0,100)
        elseif x > display.width - size.width*0.5 then
            sx = math.random(-100,0)
        end
        if y < size.height*0.5 then 
            sy = math.random(0,100)
        elseif y > display.height - size.height*0.5 then
            sy = math.random(-100,0)
        end
    end)
    --]]
end

function MainScene:testParticle()
    --local emitter1 = cc.ParticleSystemQuad:create("particle/particlestar.plist")
    --local emitter1 = cc.ParticleSystemQuad:create("particle/lizi01.plist")
    local emitter1 = cc.ParticleSystemQuad:create("particle/lizi02.plist")
    --emitter1:setStartColor(cc.c4f(1,0,0,1))
    emitter1:setBlendAdditive(true)
    emitter1:setPosition(cc.p(display.cx,display.cy+150))
    emitter1:setEmissionRate(20)
    self:addChild(emitter1)
end

function MainScene:testAcceler()
    local pLayer = cc.Layer:create()
    self:addChild(pLayer)
    cc.Device:setAccelerometerEnabled(true)
    cc.Device:setAccelerometerInterval(0.03)
    local function didAccelerate(event,x,y,z,timestamp)
        self.vx = x*300
        self.vy = y*300
        --print(x,y)
    end
    local listener = cc.EventListenerAcceleration:create(didAccelerate)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithSceneGraphPriority(listener, pLayer)

    pLayer:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt) 
        local px,py = self.ball:getPosition()
        px = px + self.vx*dt
        py = py + self.vy*dt
        local size = self.ball:getContentSize()
        if px < size.width*0.5 then 
            px = size.width*0.5
        elseif px > display.width - size.width*0.5 then
            px = display.width - size.width*0.5
        end
        if py < size.height*0.5 then 
            py = size.height*0.5
        elseif py > display.height - size.height*0.5 then
            py = display.height - size.height*0.5
        end
        self.ball:setPosition(cc.p(px,py))
    end)
    pLayer:scheduleUpdate()
end

function MainScene:startGame()
    app:level()
end

function MainScene:box()
    self.rectLayer = display.newBatchNode("GreenButton.png")
    --self.rectLayer = display.newNode()
    self:addChild(self.rectLayer)
    self.sprite = {}
    local picSize = 50
    local startX,startY = display.cx - picSize*2.5, display.cy - picSize*2.5
    for row = 1, 4 do
        for col = 1, 4 do
            local x = startX + picSize*col
            local y = startY + picSize*row
            self.sprite[#self.sprite+1] = display.newSprite("UI/GreenButton.png", x, y)
            self.rectLayer:addChild(self.sprite[#self.sprite])
        end
    end
    for i = 1, 16 do
        --local shaky3D = cc.Shaky3D:create(5, cc.size(10, 10), 5, false)
        local shaky3D = cc.RotateBy:create(3, 360)
        self.sprite[i]:runAction(shaky3D)
    end
end

function MainScene:onEnter()
        
    if device.platform == "android" then
        local layer = display.newLayer()
        layer:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
            if event.key == "back" then 
                if device.platform == "android" then
                    if self.poplayer ~= nil then
                        self.poplayer:removeFromParent()
                        self.poplayer = nil
                    elseif self.soundTouchLayer ~= nil then
                        self.soundTouchLayer:removeFromParent()
                        self.soundTouchLayer = nil
                    else--安卓退出

                        --厦门返回键
						if device.platform == "android" then
							local ok, t = luaj.callStaticMethod("org/cocos2dx/lua/PayTool", "ExitGame", nil, "()V")
							return t
						else--windows上防作弊无效
							cc.Director:getInstance():endToLua()
						end
                        -- if TEST_DEMO then
                        --     cc.Director:getInstance():endToLua()
                        -- elseif BAIDU_ADS then
                        --     local className = "org/cocos2dx/lua/AppActivity"
                        --     local sig = "()V"
                        --     luaj.callStaticMethod(className, "AdsGameExit",nil,sig)
                        -- else
                        --     local className = "org/cocos2dx/lua/AppActivity"
                        --     local sig = "()V"
                        --     luaj.callStaticMethod(className, "ExitGame",nil,sig)
                        -- end  
                        --厦门返回键
                        
                    end
                end 
            end
        end)
        self:addChild(layer)
        layer:setTouchSwallowEnabled(false)
        layer:setKeypadEnabled(true)
    end       
         
    -- 注册touch事件处理函数
    ---[[
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)
    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt)
        self:updateTouchLabel(dt)
    end)
    self:scheduleUpdate()
    --]]
end

function MainScene:onExit()
    scheduler.unscheduleGlobal(self.handleRope)
    scheduler.unscheduleGlobal(self.handleFireFly)
    cc.Device:setAccelerometerEnabled(false)
    ResData.removeRes("MAINSCENE")
end
function MainScene:onEnterBackground()
    if not GameData.music then
        audio.stopMusic()
    end
    if not GameData.sound then
        audio.stopAllSounds()
    end
end

function MainScene:onEnterForeground() 
end

return MainScene
