
local scheduler = require("framework.scheduler")
local ResultLayer = import("..views.ResultLayer")
local Task = import("..common.Task")
local GiftManager = import("..sprites.GiftManager")
local Enemys = import("..obj.Enemys")
local City = import("..obj.City")
local Forts = import("..obj.Forts")
local Heros = import("..obj.Heros")
local HeroSkillLayer = import("..views.HeroSkillLayer")
local MapInfo = import("..views.MapInfo")
local TowerCreateLayer = import("..views.TowerCreateLayer")
local TowerLayer = import("..views.TowerLayer")
local FightLayer = import("..views.FightLayer")
local CloudLayer = import("..views.CloudLayer")
local IceLayer = import("..views.IceLayer")
local WaveProgress = import("..views.WaveProgress")
local PropSelectLayer = import("..views.PropSelectLayer")
local SelectTowerLayer = import("..views.SelectTowerLayer")
local GuideLayer = import("..views.GuideLayer")
local NewbieGuideLayer = import("..views.NewbieGuideLayer")
local DialogLayer = import("..views.DialogLayer")
local StormLayer = import("..views.StormLayer")
local StarfishLayer = import("..views.StarfishLayer")
local LoadingLayer = import("..views.LoadingLayer")
local RebornLayer = import("..views.RebornLayer")
local HpBar = import("..sprites.HpBar")
local gameState = ""

PlaySceneOrder = {
    towerLayer = 2,
    skillLayer = 3,
    fightLayer = 3,
    towerCreateLayer = 4,
    selectLayer = 4,
    prop = 210,
    ice = 202,
    cloud = 202,
    storm = 202,
    starfish = 202,
    touchLayer = 100,
    ui = 200,
	resultLayer = 203,
    setting = 200,
}

local PlayScene = class("PlayScene", function()
    --为什么是newNode见文件末尾
    local scene = display.newNode("PlayScene")
    scene:ignoreAnchorPointForPosition(false)
    scene:setNodeEventEnabled(true)
    return scene
end)

g_fightLayer = nil
g_playScene = nil
function PlayScene:ctor(params)
    g_playScene = self
    --[[if NEW_GUIDE and GameData.guide.step < 48 then
        if GameData.guide.step == 4 then
            --防止第一关未引导完玩家进入第二关也可引导
            self.guidelayer = GuideLayer.new(5)        
            self:addChild(self.guidelayer,5)
        elseif GameData.guide.step == 15 then
               self.guidelayer = GuideLayer.new(19)
               self:addChild(self.guidelayer,5)
        elseif GameData.guide.step == 38 or GameData.guide.step == 40 then
            if level == 102 then
               self.guidelayer = GuideLayer.new(40)        
               self:addChild(self.guidelayer,5)
            end
        elseif GameData.guide.step > 21 and GameData.guide.step < 38 then
        else
            self.guidelayer = GuideLayer.new(GameData.guide.step)        
            self:addChild(self.guidelayer,5)
        end
    end]]

    self.level = params.level
    if VERSION_REDUCE then
        self.items = params.items or {}
    end
    self.isTeach = params.isTeach
    
    --加载资源
    self.res = ResData.getResFromLevelData(LevelsData[self.level])
    if LOADING_ASYNC == false then
        for k,v in pairs(self.res) do
            ResData.loadRes(v)
        end
    end
    --游戏模式
    self.mode = self:getGameMode()
    if VERSION_MONSTER then
        self.mode = nil --只有怪物版没有新玩法
    end
    self.loopNum = 0--攻城模式控制循环波的次数
    self.timeCount = LevelsData.bossTime--BOSS模式计时器用到
    if self.mode == "bossMode" then
        self.bossHpBar = HpBar.new(HPBAR_TYPE_City, cc.size(0, 0), LevelsData.bossHp,cc.p(display.cx-185,display.height-40))
        self:addChild(self.bossHpBar,PlaySceneOrder.setting-1)
    end
    -- touchLayer 用于接收触摸事件
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer, PlaySceneOrder.touchLayer)

    --local layer = PlayLayer:new()
    --self:addChild(layer)

    --一些初始化
    self.levelData = LevelsData[self.level]
    if not VERSION_REDUCE then
        self.levelOtherData = LevelsOtherData.newEnemy[self.level]
    end
    self.wave = #LevelsData[self.level].waves
    self.waves = LevelsData[self.level].waves
    self.initMoney = LevelsData[self.level].initMoney
    self.money = self.initMoney
    self.actSprites = {} --一些需要暂停的动作
    self.isRestart = false --重玩用
    --支线玩法关
    self.giftLevel = LevelsData[self.level].giftLevel or false
    if self.giftLevel then
        self.giftManager = GiftManager.new(self.level)
    end
    self.needSelectTower = true
    --if not CHOOSE_TOWER and LevelsData[self.level].selectedTowers ~= nil then
    if LevelsData[self.level].selectedTowers ~= nil then
        self.needSelectTower = false
    end
    --战斗层，要先于地图创建。
    self.fightLayer = FightLayer.new()
    g_fightLayer = self.fightLayer
    self:addChild(self.fightLayer, PlaySceneOrder.fightLayer)

    --加载地图
    self:loadMap()

    if not VERSION_REDUCE then
        self:randomThingItem()
    end
    --加载UI
    self.ui = display.newNode()
    self:addChild(self.ui, PlaySceneOrder.ui)
    self.ui:setTouchEnabled(true)
    self.ui:setTouchSwallowEnabled(false)
    self:initUInew()
    --kkFunc.LogCat("initUInew")
    --关卡内测试按钮 体感技能，刷新英雄技能。
    if GAME_TEST then
        self:addGameTestLayer()
    end

    --游戏开始
    self:startGame(true)
    --kkFunc.LogCat("startGame")
    if self.levelData.dialog then
        --关键关卡有场景对话
        self:showSceneDialog()
    end
    if LOADING_CLOUD then
        --盖住云
        self.coverWhiteCloud = true
        self.loadCloudLayer = LoadingLayer.new({
            loadType = "out",
            callback = function() 
                self.coverWhiteCloud = false
                if not self.levelData.dialog then
                    self:startReal()
                end
            end,
        })
        self:addChild(self.loadCloudLayer,500)
    else
        if not self.levelData.dialog then
            self:startReal()
        end
    end
end
--随机从关卡内全部障碍物id中（除去打碎变为炮塔的障碍物）抽取2个，这两个均有5%的概率掉4种中任何一种道具
function PlayScene:randomThingItem()
    --先随机两个障碍
    local randomThings = {}
    for i = 1,#MapInfo.things do
        if #MapInfo.openTowers > 0 then
            for j = 1,#MapInfo.openTowers do
                if not (MapInfo.things[i].tilePt.x == MapInfo.openTowers[j].tilePt.x 
                    and MapInfo.things[i].tilePt.y == MapInfo.openTowers[j].tilePt.y) then
                    randomThings[#randomThings+1]= i
                end
            end
        else
            randomThings[#randomThings+1]= i
        end
    end
    if #randomThings >= 2 then 
        local randomThing1 = math.random(1,#randomThings) 
        local randomThing2
        repeat
            randomThing2 = math.random(1,#randomThings)
        until randomThing1 ~= randomThing2
        self.randomFinalThing1 = randomThings[randomThing1]
        self.randomFinalThing2 = randomThings[randomThing2]
    end
    
end
--游戏模式判定
function PlayScene:getGameMode()
    local mode,level
    level = self.level
    if level == 710 then
        mode = "oneWaveMode"
    elseif level == 109 or level == 204 or level == 303 or level == 403 then
        mode = "randomTowerMode"
    elseif level == 107  or level == 208 or level == 306 or level == 408 then
        mode = "attackCityMode"
    elseif level == 702 then 
        mode = "bossMode"
    else
        mode = nil
    end 
    return mode  
end
--主题场景对话界面
function PlayScene:showSceneDialog()
    gameState = "DIALOG"
    self.ui:setVisible(false)
    self.dialog = DialogLayer.new(self.levelData.dialog)
    self:addChild(self.dialog,21)
    self.dialogCanClick = true
end
function PlayScene:clearDialog()
    self.dialogCanClick = false
    local cloud1 = display.newSprite("pic/whiteCloud.png",display.cx-1600,display.cy+200)
    cloud1:setScale(4.4)
    self:addChild(cloud1,600)
    local cloud2 = display.newSprite("pic/whiteCloud.png",display.cx+1600,display.cy-200)
    cloud2:setScale(4.4)
    self:addChild(cloud2,600)
    cloud1:runAction(transition.sequence({
        cc.MoveBy:create(1,cc.p(1600,0)),
        cc.DelayTime:create(0.7),
        cc.MoveBy:create(2,cc.p(-1600,0)),
    }))
    cloud2:runAction(transition.sequence({
        cc.MoveBy:create(1,cc.p(-1600,0)),
        cc.CallFunc:create(function()
            self.dialog:removeFromParent()
            self.ui:setVisible(true)
            ResData.removeRes("DIALOG")
            ResData.removeRes("DIALOG"..self.levelData.theme)
        end),
        cc.DelayTime:create(0.7),
        cc.MoveBy:create(2,cc.p(1600,0)),
        cc.CallFunc:create(function()
            self:startReal()
        end),
        cc.DelayTime:create(1),
        cc.CallFunc:create(function()        
            cloud1:removeFromParent()
            cloud2:removeFromParent()
        end),
    }))
end

function PlayScene:loadMap()
    if MOVE_CAMERA then
        local themeNum = LevelsData[self.level].theme    
        local theme = "map/Theme"..themeNum.."/theme"..themeNum..".png"
        MapInfo.mapBg = display.newSprite(theme)
        local width = MapInfo.mapBg:getContentSize().width
        self.cameraMoveDist = width - display.width
        self.cameraBargin = (1136-display.width)/2
        MapInfo.mapBg:setAnchorPoint(cc.p((width-self.cameraBargin-display.cx)/width,0.5))
        MapInfo.mapBg:setPosition(cc.p(display.cx,display.cy))
        self:addChild(MapInfo.mapBg,-10)
    else
        local themeNum = LevelsData[self.level].theme
        local theme = "map/Theme"..themeNum.."/theme"..themeNum.."Map.png"
        MapInfo.mapBg = display.newSprite(theme,display.cx,display.cy)
        self:addChild(MapInfo.mapBg,-10)
    end

    MapInfo.map = cc.TMXTiledMap:create(LevelsData[self.level].map)
    MapInfo.map:setAnchorPoint(cc.p(0.5,0.5))
    MapInfo.map:setPosition(cc.p(display.cx,display.cy))

    self:addChild(MapInfo.map,-1)
    self.map = MapInfo.map
    
    MapInfo.mapPos = cc.p(MapInfo.map:getContentSize().width*0.5 - display.cx,
                          MapInfo.map:getContentSize().height*0.5 - display.cy)
    MapInfo:init()

    --宝藏、红心、出怪点。。
    self:initOther()
end

function PlayScene:initOther()
    local themeNum = LevelsData[self.level].theme
    --出怪点
    self.enemyHome = {}
    self.enemyHomePos = {}
    for i = 1, #MapInfo.ways do
        local pos = MapInfo:getCenterOfTile(MapInfo.ways[i].startPt)
        --print(pos.x,pos.y)
        local cityZOrder
        if self.mode == "attackCityMode" then
            cityZOrder = BaseZOrder.enemy+1
            self.enemyHome[i] = City.new({posX = pos.x, posY = pos.y+45})
            self.cityHome = self.enemyHome[i]
        else
            cityZOrder = BaseZOrder.fort+1
            self.enemyHome[i] = display.newSprite("#Theme"..themeNum.."_EnemyHome.png", pos.x, pos.y+30)
        end
        self.fightLayer:addChild(self.enemyHome[i], cityZOrder)
        if themeNum == 2 then
            self.enemyHome[i]:setPosition(pos.x+15, pos.y+30)
        elseif themeNum == 3 or themeNum == 4 then
            local orient = MapInfo.ways[i].wayOrient[1]
            if orient == "left" then
                self.enemyHome[i]:setFlippedX(true)
            end
        end
        if self.mode == "bossMode" then
            self.enemyHome[i]:setVisible(false)
        end
        --出怪点漩涡
        self.enemyHomePos[i] = display.newSprite("#enemyHomePos.png",pos.x-2,pos.y+15)
        self.fightLayer:addChild(self.enemyHomePos[i],BaseZOrder.fort+1)
        self.enemyHomePos[i]:runAction(cc.RepeatForever:create(cc.RotateBy:create(1, -360)))
        self.enemyHomePos[i]:setVisible(false)
        self.enemyHomePos[i]:setScale(0)
        if MapInfo.hitableStrangePoint ~= nil then
            if MapInfo.hitableStrangePoint.wayIdx == i then
                self.enemyHome[i]:setVisible(false)
                self.enemyHome[i].buffer = true
            end
        end
    end
    --护守点
    local endPos = MapInfo.endPos
    --local treasureName = "#Theme"..themeNum.."_home-R.png"
    local treasureName = "#protectPoint.png"
     
    self.treaPic = display.newSprite(treasureName, endPos.x, endPos.y+30)
    self.fightLayer:addChild(self.treaPic, BaseZOrder.fort+1)
    --红心
    self.heartPic = display.newSprite("#blood-1.png", endPos.x, endPos.y+70)
    if MapInfo.heartPos ~= nil then
        self.heartPic:setPosition(MapInfo.heartPos)
    end
    self.fightLayer:addChild(self.heartPic,BaseZOrder.fort+1)
    self.heartNum = MAX_HEART
    self.heartLabel = cc.ui.UILabel.new({
        UILabelType = 1,
        text = ""..self.heartNum,
        font = "fontTitleNumber.fnt",
        x = 48,
        y = 17,
    }):align(display.CENTER)
    self.heartLabel:setScale(0.8)
    --self.heartLabel:setColor(cc.c3b(255,115,96))
    self.heartPic:addChild(self.heartLabel)
    if self.mode == "bossMode" then
       self.heartLabel:setVisible(false)
       self.heartPic:setVisible(false) 
       self.treaPic:setVisible(false) 
    end
end

function PlayScene:initUInew()
    local localY = display.top - 40
    local localX = display.cx - 460
    --钱背景
    local moneyBg1 = display.newSprite("#ui_moneyBg.png",
        localX, localY)
    moneyBg1:setAnchorPoint(cc.p(0,0.5))
    self.ui:addChild(moneyBg1,1)
    local size = moneyBg1:getContentSize()

    --钱
    self.moneyLabel = cc.ui.UILabel.new({
        UILabelType = 1,
        text = self.money,
        font = "fontTitleNumber.fnt",
        x = 70,
        y = size.height*0.5-3,
    }):align(display.CENTER_LEFT)
    --self.moneyLabel:setColor(cc.c3b(124,171,215))
    moneyBg1:addChild(self.moneyLabel)

    --波
    self.waveBg = display.newSprite("#ui_waveBg.png",
        display.width*0.45, localY)
    self.ui:addChild(self.waveBg)
    
    --波数
    self.waveLabel = cc.ui.UILabel.new({
            UILabelType = 1,
            text = "1",
            font = "fontTitleNumber.fnt",
            x = 55,
            y = self.waveBg:getContentSize().height*0.5-2
        }):align(display.CENTER_RIGHT)
    self.waveBg:addChild(self.waveLabel)
    local posX = 83
    if VERSION_REDUCE then
        posX = 95
    else
    end
    self.waveLabel2 = cc.ui.UILabel.new({
        UILabelType = 1,
        text = ""..self.wave,
        font = "fontTitleNumber.fnt",
        x = posX,
        y = self.waveBg:getContentSize().height*0.5-2
        }):align(display.CENTER_LEFT)
    self.waveBg:addChild(self.waveLabel2)
    if self.mode == "attackCityMode" then
        self.waveBg:setVisible(false)
    elseif self.mode == "bossMode" then
        self.waveBg:setVisible(false)
        --time
        local timeLabelBg = display.newSprite("#timeLabelBg.png",
        display.width*0.5+30, localY)
        self.ui:addChild(timeLabelBg)
        self.timeCountLabel = cc.ui.UILabel.new({
                UILabelType = 2,
                text = ""..self.timeCount,
                x = timeLabelBg:getContentSize().width/2-40,
                y = timeLabelBg:getContentSize().height/2,
            }):align(display.CENTER_LEFT)
        timeLabelBg:addChild(self.timeCountLabel)
        --奖牌
        self.timeMedal = display.newSprite("#timeGoldMedal.png",timeLabelBg:getContentSize().width-60, timeLabelBg:getContentSize().height/2-2)
        timeLabelBg:addChild(self.timeMedal)
    end
    
    --暂停中
    self.waveSuspend = display.newSprite("#ui_waveSuspend.png",
        display.width*0.45, localY)
    self.ui:addChild(self.waveSuspend)
    self.waveSuspend:setVisible(false)

    local buttonX3 = display.cx + 433
    --倍速
    self.speed = 1
    self.speedButton = cc.ui.UIPushButton.new({
        normal = "#ui_speed1x.png",
        disabled = "#ui_speed1x.png",
        pressed = "#ui_speed1x.png",
        })
        :onButtonClicked(function(event)
            self:speedChange()
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :pos(buttonX3-210, localY-2)
        :addTo(self.ui)

    --暂停
    self.suspendButton = cc.ui.UIPushButton.new({
        normal = "#ui_stop.png",
        disabled = "#ui_stop.png",
        pressed = "#ui_stop.png",
        })
        :onButtonClicked(function(event)
            self:suspend()
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :pos(buttonX3-95, localY-4)
        :addTo(self.ui)
    --设置
    self.setButton = cc.ui.UIPushButton.new({
        normal = "#ui_setting.png",
        disabled = "#ui_setting.png",
        pressed = "#ui_setting.png",
        })
        :onButtonPressed(function()
            self.setButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.setButton:setScale(1)
        end)
        :onButtonClicked(function(event)
            self:setting()
            --[[
            g_fightLayer:createFireball({
                pos = cc.p(display.cx,display.cy),
                range = 70,
                interval = 0.3,
                num = 5,
            })
            --]]
            --测试雾、冰
            --self:showCloudLabel()
            --self:showIceLabel()
            --测试龙卷风
            --[[
            self.fightLayer:createTornado({
                from = cc.p(400,300),
                time = 5,
            })
            --]]
        end)
        :pos(buttonX3-15, localY-4)
        :addTo(self.ui)
    if NEW_GUIDE and self.level == 100 then
        self.ui:setVisible(false)
        self.backBtn = cc.ui.UIPushButton.new({
            normal = "#ui_setting.png",
            disabled = "#ui_setting.png",
            pressed = "#ui_setting.png",
            })
            :onButtonPressed(function()
                self.backBtn:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.backBtn:setScale(1)
            end)
            :onButtonClicked(function(event)
                GameData.guide.teachLevel = true
                GameState.save(GameData)
                app:level()
            end)
            :pos(buttonX3-15, localY-4)
            :addTo(self,301)
    end
end

--[[不用的UI
function PlayScene:initUI()
    local localY = display.top - 48
    local localX = 90
    --钱背景
    local moneyBg1 = display.newSprite("#money-1.png",
        localX, localY)
    moneyBg1:setAnchorPoint(cc.p(0,0.5))
    self.ui:addChild(moneyBg1,1)
    local size = moneyBg1:getContentSize()
    local moneyBg2 = display.newSprite("#money-2.png")
    moneyBg2:setPosition(cc.p(-20,size.height*0.5))
    moneyBg1:addChild(moneyBg2)
    local moneyBg3 = display.newSprite("#add-1.png")
    moneyBg3:setPosition(cc.p(localX-2+size.width,localY))
    moneyBg3:setAnchorPoint(cc.p(0,0.5))
    self.ui:addChild(moneyBg3)

    --加钱
    cc.ui.UIPushButton.new({
        normal = "#add-2.png",
        disabled = "#add-2.png",
        pressed = "#add-3.png",
        })
        :onButtonClicked(function(event)
            --测试雾、冰
            --self:showCloudLabel()
            --self:showIceLabel()
            --测试龙卷风
            --local wayPoint = MapInfo:getWayPointByPos(1,cc.p(550,230))
            --print(wayPoint)
            self.fightLayer:createTornado({
                from = cc.p(400,300)
            })
            --测试火球
            －－self.fightLayer:createFireball()
        end)
        :pos(44,moneyBg3:getContentSize().height*0.5)
        :addTo(moneyBg3)

    --钱
    self.moneyLabel = cc.ui.UILabel.new({
        UILabelType = 1,
        text = self.money,
        font = "fontMoney.fnt",
        align = ui.TEXT_ALIGN_LEFT,
        x = 30,
        y = size.height*0.5,
    })
    self.moneyLabel:setColor(cc.c3b(124,171,215))
    moneyBg1:addChild(self.moneyLabel)

    --波
    local waveBg = display.newSprite("#wavebg.png",
        display.width*0.55, localY)
    waveBg:setAnchorPoint(cc.p(0.5,0.5))
    self.ui:addChild(waveBg)
    local waveBg2 = display.newSprite("#wave-2.png")
    waveBg2:setPosition(waveBg:getContentSize().width*0.5,waveBg:getContentSize().height*0.4)
    waveBg:addChild(waveBg2)

    --波进度条
    self.waveProcess = display.newSprite("ui_scene/wave-1.png")
    self.waveProcess:setAnchorPoint(cc.p(0,0))
    local waveSize = self.waveProcess:getContentSize()
    self.waveSize = waveSize.width
    self.wavePos = 0
    local rect = cc.rect(0,0,self.wavePos,waveSize.height)
    self.waveProcess:setTextureRect(rect)
    waveBg2:addChild(self.waveProcess)
    self.waveCarrot = display.newSprite("#waveC.png")
    self.waveCarrot:setPosition(cc.p(self.wavePos,waveSize.height*0.5+8))
    waveBg2:addChild(self.waveCarrot)
    
    --波数
    self.waveLabel = cc.ui.UILabel.new({
            UILabelType = 1,
            text = "0",
            font = "fontMoney.fnt",
            align = ui.TEXT_ALIGN_CENTER,
            x = 27,
            y = waveBg:getContentSize().height*0.5
        })
    self.waveLabel:setColor(cc.c3b(222,171,215))
    waveBg:addChild(self.waveLabel)
    self.waveLabel2 = cc.ui.UILabel.new({
            UILabelType = 1,
            text = ""..self.wave,
            font = "fontMoney.fnt",
            align = ui.TEXT_ALIGN_CENTER,
            x = 190,
            y = waveBg:getContentSize().height*0.5
        })
    self.waveLabel2:setColor(cc.c3b(124,171,215))
    waveBg:addChild(self.waveLabel2)

    local buttonX3 = display.right - 47
    local buttonDist = 80
    --倍速
    self.speed = 1
    self.speedButton = cc.ui.UIPushButton.new({
        normal = "#x1.png",
        disabled = "#x1.png",
        pressed = "#x1.png",
        })
        :onButtonClicked(function(event)
            self:speedChange()
        end)
        :pos(buttonX3-buttonDist*2 , localY)
        :addTo(self.ui)

    --暂停
    self.suspendButton = cc.ui.UIPushButton.new({
        normal = "#stop.png",
        disabled = "#stop.png",
        pressed = "#stop.png",
        })
        :onButtonClicked(function(event)
            self:suspend()
        end)
        :pos(buttonX3-buttonDist, localY)
        :addTo(self.ui)

    --设置
    cc.ui.UIPushButton.new({
        normal = "#set.png",
        disabled = "#set.png",
        pressed = "#set.png",
        })
        :onButtonClicked(function(event)
            self:unscheduleUpdate()
            self:removeFromParent()
            cc.Director:getInstance():getScheduler():setTimeScale(1)  
            app:main()
        end)
        :pos(buttonX3, localY)
        :addTo(self.ui)
end

function PlayScene:initUIByCCS()
    self._uiLayer = TouchGroup:create()
    --self._uiLayer:setPosition(display.cx,display.cy)
    self.ui:addChild(self._uiLayer)
    self._uiLayer:setTouchEnabled(true)
    self._uiLayer:setTouchSwallowEnabled(false)

    self._widget = GUIReader:shareReader():widgetFromJsonFile("ccs/TowerUI/TowerUI.json")
    self._uiLayer:addWidget(self._widget)

    local cloud1 = self._widget:getChildByName("Image_2")
    local moneyBg = cloud1:getChildByName("moneyBg")
    self.moneyLabel = moneyBg:getChildByName("moneyLabel")
    --self.moneyLabel = self._uiLayer:getWidgetByName("moneyLabel")
    self.moneyLabel:setText(""..self.money)

    local cloud2 = self._widget:getChildByName("Image_4")
    self.waveLabel = cloud2:getChildByName("waveLabel")
    self.waveLabel2 = cloud2:getChildByName("waveLabel2")

    local cloud3 = self._widget:getChildByName("Image_3")
    self.speedButton = cloud3:getChildByName("speedButton")
    self.speedButton:setTouchEnabled(true)

    local function onSpeedChange(sender, eventType)
        if eventType == 2 then
            self:speedChange()
        end
    end
    self.speedButton:addTouchEventListener(onSpeedChange)
    self.speedButton:setTouchSwallowEnabled(true)

    local function onSuspend(sender, eventType)
        if eventType == 2 then
            self:suspend()
        end
    end
    self.suspendButton = cloud3:getChildByName("speedButton")
    --self.suspendButton = tolua.cast(self._uiLayer:getWidgetByName("suspendButton"),"CCMenuItemImage")
    self.suspendButton:addTouchEventListener(onSuspend)

    local function onSetting(sender, eventType)
        if eventType == 2 then
            self:removeFromParent()
            app:level()
        end
    end
    self.setting = cloud3:getChildByName("setting")
    --self.setting = tolua.cast(self._uiLayer:getWidgetByName("setting"),"CCMenuItemImage")
    self.setting:addTouchEventListener(onSetting)
end

function PlayScene:initUIByCCB()
    local  proxy = LuaProxy:create()  --使用luaproxy 库  新建一个proxy对象
    local n = proxy:readCCBFromFile("FightUI.ccbi") -- 加载你设置的ccbi文件
    local l = tolua.cast(n, "CCLayer") -- 把ccbi 转换对cclayer对象
    self.ui:addChild(l)

    --绑定
    self.moneyLabel = tolua.cast(proxy:getNode"moneyLabel","CCLabelBMFont")
    self.moneyLabel:setColor(cc.c3b(124,171,215))
    self.moneyLabel:setString(""..self.money)
    self.waveLabel = tolua.cast(proxy:getNode"waveLabel","CCLabelBMFont")
    self.waveLabel2 = tolua.cast(proxy:getNode"waveLabel2","CCLabelBMFont")
    self.waveLabel:setColor(cc.c3b(222,171,215))
    self.waveLabel2:setColor(cc.c3b(124,171,215))
    self.speed = 1
    self.speedMenu = tolua.cast(proxy:getNode"speedMenu","CCMenu")
    self.speedButton = tolua.cast(proxy:getNode"speedButton","CCMenuItemImage")
    self.suspendMenu = tolua.cast(proxy:getNode"suspendMenu","CCMenu")
    self.suspendButton = tolua.cast(proxy:getNode"suspend","CCMenuItemImage")
    self.settingMenu = tolua.cast(proxy:getNode"settingMenu","CCMenu")
    self.setting = tolua.cast(proxy:getNode"setting","CCMenuItemImage")
    
    proxy:handleMenuEvent(self.speedButton,function()  
        self:speedChange()
    end)
    proxy:handleMenuEvent(self.suspendButton,function()  
        self:suspend()
    end)
    proxy:handleMenuEvent(self.setting,function()  
        self:removeFromParent()
        app:level()
    end)
end
--]]

--设置
function PlayScene:setting()
    if gameState ~= "NORMAL" then return end
    SoundManager.pauseMusic() --暂停音乐
    self.settingPause = self.pause
    if not self.settingPause then
        self:suspend(true)
    end
    self:setCanTouch(false)
    
    gameState = "SETTING"
    if self.settingLayer == nil then
        self.settingLayer = display.newLayer()
        self:addChild(self.settingLayer, PlaySceneOrder.setting)
        local grayBg = display.newColorLayer(cc.c4b(0,0,0,128))
        self.settingLayer:addChild(grayBg)
        self.settingBg = display.newSprite("#settingBg.png", display.cx, display.cy)
        self.settingLayer:addChild(self.settingBg)

        local size = self.settingBg:getContentSize()

		local labelX
		local labelY
		local flag
		local fontType
		if VERSION_MONSTER then
			labelX = 88
			labelY = 380
			fontType = "fontNewLayer.fnt"
		else
			--关卡标
			flag = display.newSprite("#settingFlag.png", 66,size.height-43)
			self.settingBg:addChild(flag)
			labelX = 40
			labelY = 48
			fontType = "fontTitleNumber.fnt"
		end
        local levelLabel = cc.ui.UILabel.new({
            UILabelType = 1,
            text = LevelsData.getRealLevel(self.level),
            font = fontType,
            x = labelX,
            y = labelY,
        }):align(display.CENTER)
		if VERSION_MONSTER then
        	self.settingBg:addChild(levelLabel)
		else
			flag:addChild(levelLabel)
		end
        --继续
        self.settingResume = cc.ui.UIPushButton.new({
            normal = "#settingResume.png",
            })
            :onButtonPressed(function()
                self.settingResume:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.settingResume:setScale(1)
            end)
            :onButtonClicked(function(event)
                self:SettingContinue()
            end)
            :pos(size.width*0.5, 260)
            :addTo(self.settingBg)
        --重新开始
        self.settingRestart = cc.ui.UIPushButton.new({
            normal = "#settingRestart.png",
            })
            :onButtonPressed(function()
                self.settingRestart:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.settingRestart:setScale(1)
            end)
            :onButtonClicked(function(event)
                --self:showIceLabel()
                --[[ 改为切场景
                SoundManager.resumeMusic()
                gameState = "NORMAL"
                if not self.settingPause then
                    self:suspend(true)
                else
                    self:suspend()
                end
                self:setCanTouch(true)
                self.settingLayer:setVisible(false)
                self:startGame()
                --]]
                --DataEye

                    --厦门
                -- if device.platform == "android" or device.platform == "ios" then
                --     local level = LevelsData.getRealLevel(self.level)
                --     if level < 10 then
                --         level = "0"..level
                --     end
                --     DCLevels.fail("第"..level.."关","玩家重新开始")
                -- end
                    --厦门
                self:Restart()
            end)
            :pos(size.width*0.5, 173)
            :addTo(self.settingBg)
        --返回
        self.settingReturn = cc.ui.UIPushButton.new({
            normal = "#settingReturn.png",
            })
            :onButtonPressed(function()
                self.settingReturn:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.settingReturn:setScale(1)
            end)
            :onButtonClicked(function(event)
                --DataEye

                    --厦门
                -- if device.platform == "android" or device.platform == "ios" then
                --     local level = LevelsData.getRealLevel(self.level)
                --     if level < 10 then
                --         level = "0"..level
                --     end
                --     DCLevels.fail("第"..level.."关","玩家中途退出")
                -- end
                    --厦门
                app:level()
            end)
            :pos(size.width*0.5, 86)
            :addTo(self.settingBg)
        self.settingLayer:setVisible(false)
    end

    self.settingBg:setPosition(display.cx, display.height+200)
    self.settingLayer:setVisible(true)
    self.settingBg:runAction(
        cc.EaseInOut:create(cc.MoveTo:create(0.3,cc.p(display.cx,display.cy)),0.65))
    
end

function PlayScene:SettingContinue()
    gameState = "NORMAL"
    SoundManager.resumeMusic()
    if not self.settingPause then
        self:suspend(true)
    end
    self:setCanTouch(true)
    self.settingLayer:setVisible(false)
    --[[移动消失
    self.settingLayer:setTouchEnabled(false)
    self.settingBg:runAction(transition.sequence({
        cc.EaseInOut:create(cc.MoveTo:create(0.3,cc.p(display.cx,display.height+200)),0.65),
        cc.CallFunc:create(function()
            self.settingLayer:setTouchEnabled(true)
            if not self.settingPause then
                self:suspend(true)
            end
            self:setCanTouch(true)
            self.settingLayer:setVisible(false)
        end)
    }))]]
end

--体感和技能等要回到1倍速
function PlayScene:changeSpeedNormal()
    if self.speed == 2 then
        self.doubleSpeed = true
        self:speedChange()
    end
end

--如果自动调过速，最后要还原
function PlayScene:changeSpeedUser()
    if self.doubleSpeed then
        self:speedChange()
        self.doubleSpeed = nil
    end
end

function PlayScene:speedChange()
    if gameState ~= "NORMAL" and gameState ~= "START" then return end
    if self.speed == 1 then
        self.speed = 2
        --self.speedLabel:setString(self.speed)
        self.speedButton:setButtonImage("normal", "#ui_speed2x.png")
        self.speedButton:setButtonImage("disabled", "#ui_speed2x.png")
        self.speedButton:setButtonImage("pressed", "#ui_speed2x.png")
        cc.Director:getInstance():getScheduler():setTimeScale(2)        
    else
        self.speed = 1
        --self.speedLabel:setString(self.speed)
        self.speedButton:setButtonImage("normal", "#ui_speed1x.png")
        self.speedButton:setButtonImage("disabled", "#ui_speed1x.png")
        self.speedButton:setButtonImage("pressed", "#ui_speed1x.png")
        cc.Director:getInstance():getScheduler():setTimeScale(1) 
    end
end

function PlayScene:suspend(dontChangePic)
    if gameState ~= "NORMAL" then return end
    if self.pause then 
        self.pause = false
        if not dontChangePic then
            self.suspendButton:setButtonImage("normal", "#ui_stop.png")
            self.suspendButton:setButtonImage("disabled", "#ui_stop.png")
            self.suspendButton:setButtonImage("pressed", "#ui_stop.png")
            if self.mode == "attackCityMode" then
                self.waveSuspend:setVisible(false)
                self.cityHpBar:setVisible(true)
            else
                self.waveSuspend:setVisible(false)
                self.waveBg:setVisible(true)
            end
        end
        if self.towerLayer then
            self.towerLayer:resume()
        end
        if self.waveProgress then
            self.waveProgress:resume()
        end
        if self.skillLayer then
            self.skillLayer:resumeProgress()
        end
        --各自处理暂停继续，其实可以放到一起。
        MapInfo:resume()
        self.fightLayer:resume()
        for i = 1, #self.actSprites do --Boss怪、大波怪、出怪提示。
            cc.Director:getInstance():getActionManager():resumeTarget(self.actSprites[i])
        end
    else
        --print(cc.FileUtils:getInstance():getWritablePath())
        --[[截图
        local render = CCRenderTexture:create(display.width, display.height, kTexture2DPixelFormat_RGBA8888)
        render:begin()
        display.getRunningScene():visit()
        render:endToLua()
        if not render:saveToFile("screenshot.png", kCCImageFormatPNG) then
            print "not save..."
        end
        --]]
        self.pause = true
        if not dontChangePic then
            self.suspendButton:setButtonImage("normal", "#ui_continue.png")
            self.suspendButton:setButtonImage("disabled", "#ui_continue.png")
            self.suspendButton:setButtonImage("pressed", "#ui_continue.png")
            if self.mode == "attackCityMode" then
                self.waveSuspend:setVisible(true)
                self.cityHpBar:setVisible(false)
            else
                self.waveSuspend:setVisible(true)
                self.waveBg:setVisible(false)
            end
        end
        if self.towerLayer then
            self.towerLayer:suspendProgress()
        end
        if self.waveProgress then
            self.waveProgress:suspend()
        end
        if self.skillLayer then
            self.skillLayer:suspendProgress()
        end
        --各自处理暂停继续
        MapInfo:suspend()
        self.fightLayer:suspend()
        for i = 1, #self.actSprites do --Boss怪、大波怪、出怪提示。
            cc.Director:getInstance():getActionManager():pauseTarget(self.actSprites[i])
        end
        --百度品宣广告暂停
        kkFunc.pauseAds()
    end
end

function PlayScene:startGame(firstTime)
    --DataEye
        --厦门
    -- if device.platform == "android" or device.platform == "ios" then
    --     local level = LevelsData.getRealLevel(self.level)
    --     if level < 10 then
    --         level = "0"..level
    --     end
    --     DCLevels.begin("第"..level.."关")
    -- end
        --厦门

    --kkFunc.LogCat("firstTime")
    self.gamePassTime = 0
    self.E44num = 0 --黄瓜怪计数，判断清完一波怪。
    self.waveNow = 0
    --提前出一波怪的功能，需要单独管理出怪信息，不能直接用关卡定义了。
    self.waveInfo = {}
    self.firstCome = true
    self.startBlink = false
    self.waveLabel:setString("1") --波数改成1

    if MOVE_CAMERA then
        self:setPosition(cc.p(self.cameraMoveDist-self.cameraBargin,0))
    end

    gameState = "START"
    --重来时要先调速。
    if self.speed == 2 then
        self:speedChange()
    end
    self.pause = true
    --清理雾
    if self.cloudShowed and self.cloudLayer then
        self.cloudLayer:removeFromParent()
        self.cloudLayer = nil
        self.cloudShowed = false
    end
    --清理冰
    if self.iceShowed and self.iceLayer then
        self.iceLayer:removeFromParent()
        self.iceLayer = nil
        self.iceShowed = false
    end
    --清理临时动作精灵
    self:stopAllActions()
    for k,v in pairs(self.actSprites) do
        v:removeFromParent()
    end
    self.actSprites = {}
    if self.actNode ~= nil then --出怪点闪烁
        self.actNode:removeAllChildren()
    else
        self.actNode = display.newNode()
        self:addChild(self.actNode)
    end
    if self.actNode2 ~= nil then --Boss和大波怪提示
        self.actNode2:removeAllChildren()
    else
        self.actNode2 = display.newNode()
        self:addChild(self.actNode2,5)
    end

    -- fightLayer 处理核心内容
    if not firstTime and self.fightLayer ~= nil then
        self.fightLayer:clear()
    end

    if self.giftLevel then
        self.giftManager:init()
    end
    
    --地图还得重新加载，道具值被修改了。
    if not firstTime and MapInfo.map ~= nil then
        MapInfo.map:removeFromParent()
        self:loadMap()
    end
    --kkFunc.LogCat("TaskData")
    --初始化任务
    if TaskData[self.level] ~= nil then
        local oldTaskLayer
        if self.task ~= nil then
            oldTaskLayer = self.task.taskLayer
            self.task:clear()
        end
        self.task = Task.new(self, TaskData[self.level])
        if oldTaskLayer ~= nil then
            oldTaskLayer:removeFromParent()
        end
    end
    --kkFunc.LogCat("showHeroBOTTOM")
    --出英雄和技能
    if self.level ~= 100 then --教学关不出英雄
        if self.skillLayer ~= nil then
            self.skillLayer:removeFromParent()
        end
        self:showHero()
    end
    --kkFunc.LogCat("showHero")
    self.pause = false
    if CLICK_GROUND then
        if self.towerCreateLayer ~= nil then 
            self.towerCreateLayer:removeFromParent()
        end
        self.towerCreateLayer = TowerCreateLayer.new(LevelsData[self.level].selectedTowers)
        self:addChild(self.towerCreateLayer, PlaySceneOrder.towerCreateLayer)
    else
        if self.towerLayer ~= nil then 
            self.towerLayer:removeFromParent()
        end
        self.towerLayer = TowerLayer.new(self.towersFromSelectTowerLayer, self.giftLevel)
        self:addChild(self.towerLayer, PlaySceneOrder.towerLayer)
    end
    local heartNum = MAX_HEART
    if VERSION_REDUCE then
        if self.items[2] == true then --守护点加血道具
            heartNum = heartNum + 2
        end
    end
    if GameData.selectHero == 4 then --第四个英雄另一个被动技能，守护点多3血。
        heartNum = heartNum + 3
    end
    self:setHeart(heartNum, true)
    if VERSION_REDUCE then
        if self.items[1] == true then
            self:changeMoney(LevelsData[self.level].initMoney - self.money+500, true)
        else
            self:changeMoney(LevelsData[self.level].initMoney - self.money, true)
        end
    else
        self:changeMoney(LevelsData[self.level].initMoney - self.money, true)
    end
    --给出预设塔
    self:createPreTowers()
    --kkFunc.LogCat("createPreTowers")
    --一开始就更新塔的可升级状态
    for i = 1, #self.fightLayer.forts do
        self.fightLayer.forts[i]:updateForChangeMoney(self.money)
    end

    --getNewFort
    if LevelsData[self.level].newTowerIdx ~= nil and self.level == GameData.openlevel then
        self:getNewFort()
        --SoundManager.stopMusic(true)
        audio.stopMusic(true)
        self:performWithDelay(function ()
            --背景音乐
            --SoundManager.playMusic(GAME_MUSIC.BGM2)
            if GameData.music then
                audio.playMusic(GAME_MUSIC.BGM2)
            end
        end,3.0)
    else
        --背景音乐
        --SoundManager.playMusic(GAME_MUSIC.BGM2)
        if GameData.music then
            audio.playMusic(GAME_MUSIC.BGM2)
        end
    end
    if not firstTime then
        self:startReal() --第一次交给对话或loading完云散去后调用。
    end

    --self:startReady()
    --不选塔，不移镜头了。
    --选塔页
    --self:showSelectTower(true)
    if NEW_GUIDE and self.newbieguidelayer ~= nil then
        if self.level == 100 then
            self:suspend()
        end
    end
end
function PlayScene:isPopNewElementTips()
    if (LevelsData.getRealLevel(self.level) == 4 
        or LevelsData.getRealLevel(self.level) == 6
        or LevelsData.getRealLevel(self.level) == 8) 
        and self.level == GameData.openlevel then
        return true
    end
    return false
end
function PlayScene:isPopGiftBox()
    if ((LevelsData.getRealLevel(self.level) == 5 and not GameData.item["i3"].isUnLock) 
        or (LevelsData.getRealLevel(self.level) == 7 and not GameData.item["i4"].isUnLock))
        and self.level == GameData.openlevel then
        return true
    end
    return false
end
function PlayScene:popGiftBox()
    self:changeSpeedNormal()
    self.pause = true
    display.newColorLayer(cc.c4b(0,0,0,128)):addTo(self,4)
    local giftBox = display.newSprite("#GiftBox1.png",display.cx,display.cy)
    giftBox:setScale(0)
    self:addChild(giftBox,5)
    local frames = display.newFrames("GiftBox%d.png", 1, 12)
    local ani = display.newAnimation(frames, 0.1)
    giftBox:runAction(transition.sequence({
            cc.ScaleTo:create(0.2,1),
            cc.DelayTime:create(1.5),
            cc.Animate:create(ani),
            cc.CallFunc:create(function()
                self:unLockNewElement()
                giftBox:removeFromParent()
            end)
        })) 
end
function PlayScene:unLockNewElement()
    self.pause = true
    local newElementLayer = display.newLayer()
    self:addChild(newElementLayer,300)
    display.newColorLayer(cc.c4b(0,0,0,128)):addTo(newElementLayer,-2)
    --丝带
    local getNewElementTitle = display.newSprite("#newElementTitle.png",display.cx,display.cy+170)
    newElementLayer:addChild(getNewElementTitle)
    --新元素图标
    local newElementPic = "#cityShow.png"
    if LevelsData.getRealLevel(self.level) == 4 then
        newElementPic = "#newElementEnemy.png"
    elseif LevelsData.getRealLevel(self.level) == 5 then
        newElementPic = "#"..ItemData[3].pic2
    elseif LevelsData.getRealLevel(self.level) == 6 then
        newElementPic = "#cityShow.png"
    elseif LevelsData.getRealLevel(self.level) == 7 then
        newElementPic = "#"..ItemData[4].pic2
    elseif LevelsData.getRealLevel(self.level) == 8 then
        newElementPic = "#lock.png"
    end
    local picY = display.cy+70
    if LevelsData.getRealLevel(self.level) == 4 then
        picY = display.cy+80
    end
    local getNewElementPic = display.newSprite(newElementPic,display.cx,picY)
    newElementLayer:addChild(getNewElementPic,5)
    if LevelsData.getRealLevel(self.level) == 6 then
        getNewElementPic:setScale(0.8)
    end
    --tips
    local tipsBg = display.newSprite("#tipsUnLockBg.png",display.cx,display.cy-70)
    newElementLayer:addChild(tipsBg,5)
    local tips = cc.ui.UILabel.new({
        UILabelType = 2,
        text = ""..LevelsData[self.level].tipsNextlevel,
        size = 20,
        dimensions = cc.size(230, 150),
        font = "fontCommon.TTF",
        color = cc.c3b(255,255,255),
        x = 20,
        y = 85,
        }):align(display.LEFT_TOP)
    tipsBg:addChild(tips)
    --button
    self.getNewElementButton = cc.ui.UIPushButton.new({
        normal = "#getNewFortButton.png",
        pressed = "#getNewFortButton.png",
        disabled = "#getNewFortButton.png",
        })
        :onButtonPressed(function()
            self.getNewElementButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.getNewElementButton:setScale(1)
        end)
        :onButtonClicked(function()
            self.pause = false
            gameState = "NORMAL"
            if LevelsData.getRealLevel(self.level) == 5 then
                GameData.item["i3"].isUnLock = true
                GameData.item["i3"].number = GameData.item["i3"].number + 3
                GameState.save(GameData)
            elseif LevelsData.getRealLevel(self.level) == 7 then
                GameData.item["i4"].isUnLock = true
                GameData.item["i4"].number = GameData.item["i4"].number + 3
                GameState.save(GameData)
            end
            self:showResult(true)
            newElementLayer:removeFromParent()                
        end):align(display.CENTER,display.cx,display.cy-190)
        :addTo(newElementLayer)
end
--获得新炮塔
function PlayScene:getNewFort()
    self.pause = true
    self:suspend()
    local getFortLayer = display.newLayer()
    self:addChild(getFortLayer,300)
    display.newColorLayer(cc.c4b(0,0,0,128)):addTo(getFortLayer,-2)
    --button
    self.getNewFortButton = cc.ui.UIPushButton.new({
        normal = "#getNewFortButton.png",
        pressed = "#getNewFortButton.png",
        disabled = "#getNewFortButton.png",
        })
        :onButtonPressed(function()
            self.getNewFortButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.getNewFortButton:setScale(1)
        end)
        :onButtonClicked(function()
            self.pause = false
            gameState = "NORMAL"
            if self.levelOtherData == nil or self.levelOtherData[1] == nil then--若第一波有新怪提示则把321放在提示后
                self.propSelectLayer = PropSelectLayer.new()
                self:addChild(self.propSelectLayer, PlaySceneOrder.prop)
            end
            getFortLayer:removeFromParent()                
        end):align(display.CENTER,display.cx,display.cy)
        :addTo(getFortLayer)
    self.getNewFortButton:setOpacity(0)
    --背景光
    local getNewFortLight = display.newSprite("#getNewFortLight.png",display.cx,display.cy)
    getFortLayer:addChild(getNewFortLight,-1)
    getNewFortLight:setVisible(false)
    self:performWithDelay(function()
        getNewFortLight:setVisible(true)
        getNewFortLight:runAction(cc.RepeatForever:create(cc.RotateBy:create(10, -180)))
    end, 0.9)
    --背景
    local getNewFortBg = display.newSprite("#getNewFortBg.png",display.cx,display.cy)
    getFortLayer:addChild(getNewFortBg)
    getNewFortBg:setScale(0)
    getNewFortBg:runAction(transition.sequence({
        cc.ScaleTo:create(0.3,1.1),
        cc.ScaleTo:create(0.1,1),
        cc.DelayTime:create(0.1),
        cc.RotateBy:create(0.05,25),
        cc.RotateBy:create(0.05,-25),
        cc.RotateBy:create(0.05,25),
        cc.RotateBy:create(0.05,-25),
    })) 
    --标题
    local getNewFortTitle = display.newSprite("#getNewFortTitle.png",display.cx,display.cy+170)
    getFortLayer:addChild(getNewFortTitle)
    getNewFortTitle:setScale(0)
    getNewFortTitle:runAction(transition.sequence({    
        cc.ScaleTo:create(0.3,1.1),
        cc.ScaleTo:create(0.1,1),
    }))
    local getNewFortPic = display.newSprite("#"..TowersData[LevelsData[self.level].newTowerIdx].handbookPic,110,200)
    getNewFortBg:addChild(getNewFortPic,5)
    local towerIntro
    if VERSION_REDUCE then
        towerIntro = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionText("图鉴",LevelsData[self.level].newTowerIdx),
            size = 16,
            font = "fontEasy.ttf",
            color = cc.c3b(177,105,57),
            x = 25,
            y = 110,
            dimensions = cc.size(180, 150),
            }):align(display.LEFT_TOP)
    else
        towerIntro = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionText("图鉴",LevelsData[self.level].newTowerIdx),
            size = 20,
            color = cc.c3b(177,105,57),
            x = 25,
            y = 110,
            }):align(display.LEFT_TOP)
    end
    getNewFortBg:addChild(towerIntro)
    -- local towerIntro = cc.ui.UILabel.new({
    -- text = kkFunc.getVersionText("图鉴",LevelsData[self.level].newTowerIdx),
    -- size = 20,
    -- color = cc.c3b(177,105,57),
    -- x = 25,
    -- y = 110,
    -- }):align(display.LEFT_TOP)
    -- getNewFortBg:addChild(towerIntro)
    --buttonAction
    transition.execute(self.getNewFortButton, transition.sequence({    
            cc.Spawn:create(
                cc.FadeIn:create(0.1),
                cc.MoveBy:create(0.1,cc.p(0,-190))
            ),
            cc.CallFunc:create(function()
                kkFunc.bubbleButton(self.getNewFortButton,true)
            end)
        }) , {delay = 1.1})
    --音效
    SoundManager.playSound(GAME_SOUND.NewTower)
end
function PlayScene:startReal()
    if COUNT_DOWN then
        if LevelsData[self.level].newTowerIdx ~= nil and self.level == GameData.openlevel then
            --这里的操作在startGame()里面完成
            --self:getNewFort()
        else
            self.propSelectLayer = PropSelectLayer.new()
            self:addChild(self.propSelectLayer, PlaySceneOrder.prop)
        end
    else
        self:start()
    end
end

function PlayScene:showSelectTower()
    if MOVE_CAMERA then
        self.ui:setPosition(cc.p(0,100))
    end
    if self.needSelectTower then
        self.selectLayer = SelectTowerLayer.new(LevelsData[self.level].towers)
        self:addChild(self.selectLayer, PlaySceneOrder.selectLayer)
        self.selectLayer:setPosition(cc.p(self.cameraBargin, 0))
    end
    if MOVE_CAMERA then
        ---[[
        --self.cameraMoveDist = width - display.width
        --]]
        --[[
        local width1 = MapInfo.mapBg:getContentSize().width
        local width2 = MapInfo.mapBg2:getContentSize().width
        self.cameraMoveDist = width1*0.5+width2-display.cx
        --]]
        --self.selectLayer:setPosition(cc.p(-self.cameraMoveDist,0))
        if self.needSelectTower then
            self.selectLayer:setVisible(false)
        end
        self:runAction(transition.sequence({
            cc.MoveBy:create(1.5, cc.p(-self.cameraMoveDist,0)),
            cc.CallFunc:create(function()
                if self.needSelectTower then
                    self.selectLayer:setVisible(true)
                    --[[
                    self.selectLayer:setScale(0)
                    self.selectLayer:runAction(transition.sequence({
                        cc.ScaleTo:create(0.3, 1.1),
                        cc.ScaleTo:create(0.1, 1),
                    }))]]
                else
                    self:performWithDelay(handler(self,self.startReady), 1)
                end
            end)
        }))
    else
        if self.needSelectTower then
            self.selectLayer:setPosition(cc.p(self.cameraBargin-100, 0))
        else
            self:startReady()
        end
    end
end

function PlayScene:startReady()
    self.towersFromSelectTowerLayer = LevelsData[self.level].selectedTowers
    --self.towersFromSelectTowerLayer = {1,2,3,4,5,6,7,8}
    if self.needSelectTower then
        if self.selectLayer ~= nil and self.selectLayer:isVisible() then
            self.towersFromSelectTowerLayer = self.selectLayer:getSelected()
        end
        if self.selectLayer ~= nil then
            self.selectLayer:removeFromParent()
            self.selectLayer = nil
        end
    end

    if MOVE_CAMERA then
        if self.cameraBargin > 0 then
            self:runAction(transition.sequence({
                --cc.MoveBy:create(1, cc.p(-self.cameraMoveDist,0)),
                cc.MoveBy:create(1, cc.p(self.cameraBargin,0)),
                cc.CallFunc:create(function()
                    self.ui:runAction(cc.MoveBy:create(0.5, cc.p(0,-100)))
                    if COUNT_DOWN then
                        self.propSelectLayer = PropSelectLayer.new()
                        self:addChild(self.propSelectLayer, PlaySceneOrder.prop)
                    else
                        self:start()
                    end
                end)
            }))
        else
            self.ui:runAction(cc.MoveBy:create(0.5, cc.p(0,-100)))
            if COUNT_DOWN then
                self.propSelectLayer = PropSelectLayer.new()
                self:addChild(self.propSelectLayer, PlaySceneOrder.prop)
            else
                self:start()
            end
        end
    else
        if COUNT_DOWN then
            self.propSelectLayer = PropSelectLayer.new()
            self:addChild(self.propSelectLayer, PlaySceneOrder.prop)
        else
            self:start()
        end
    end
end

function PlayScene:showBlankArea()
    local c1,c2,r1,r2 = MapInfo:getMapForNumbers()
    for col = c1, c2 do
        for row = r1, r2 do
            local tilePt = cc.p(col,row)
            local a = self:canCreateFortOnTile(1, tilePt)
            if self:canCreateFortOnTile(1, tilePt)
                    and self:getTileFort(tilePt) == nil then
                local pt = MapInfo:getCenterOfTile(tilePt)
                local blank = display.newSprite("#blankArea.png", pt.x, pt.y)
                g_fightLayer:addChild(blank)
                blank:setOpacity(0)
                blank:runAction(transition.sequence({
                   cc.FadeIn:create(0.4),
                   cc.FadeOut:create(0.4),
                   cc.FadeIn:create(0.4),
                   cc.FadeOut:create(0.4),
                   cc.CallFunc:create(function() 
                       blank:removeFromParent()
                   end)
                }))
            end
        end
    end
end

function PlayScene:start()
    gameState = "NORMAL" 
    --闪一下空白格
    self:showBlankArea()
    if NEW_GUIDE then
        if self.level == 100  
            or (GameData.guide.level1 == false and self.level == 101) 
            or (GameData.guide.level2 == false and self.level == 102) 
            --or (GameData.guide.level11 == false and self.level == 201) 
            --or (GameData.guide.level12 == false and self.level == 202)
            or (GameData.guide.level7 == false and self.level == 107 and self.mode ~= nil)
            or (GameData.guide.level9 == false and self.level == 109 and self.mode ~= nil) then
            self.newbieguidelayer = NewbieGuideLayer.new()
            self:addChild(self.newbieguidelayer,300)
        end
    elseif self.isTeach then
        self.newbieguidelayer = NewbieGuideLayer.new(true)
        self:addChild(self.newbieguidelayer,300)
    end
end

function PlayScene:showHero()
    self.skillLayer = HeroSkillLayer.new(GameData.selectHero,self.items)
    self:addChild(self.skillLayer, PlaySceneOrder.skillLayer)
    local pos = MapInfo.heroPos or cc.p(display.cx, display.cy)
    if (NEW_GUIDE and GameData.guide.level1 == true and self.level == 101) then
        pos = cc.p(display.cx, display.cy)
    end
    self.hero = Heros[GameData.selectHero].new({
        idx = GameData.selectHero,
        pos = pos,
    })
    g_fightLayer:addChild(self.hero, BaseZOrder.hero)
    if NEW_GUIDE and GameData.guide.level1 == false and self.level == 101 then
        self.hero:setVisible(false)
    end
end

function PlayScene:setHeart(num, notHurt)
    if self.heartNum == num then return end
    self.heartNum = num
    local text = ""..self.heartNum
    self.heartLabel:setString(text)
    if num <= 0 then
        self.heartLabel:setString("0")
        --弹出复活
        self.pause = true
        self:suspend()
        gameState = "GAMEOVER"
        self.rebornLayer = RebornLayer.new()
        self:addChild(self.rebornLayer,PlaySceneOrder.resultLayer)
    end
    if notHurt then return end
    if num <= 5 then
        local frame = display.newSpriteFrame("protectPointHurt.png")
        self.treaPic:setSpriteFrame(frame)
    else
        local frame = display.newSpriteFrame("protectPointHurt.png")
        self.treaPic:setSpriteFrame(frame)
        self.treaPic:runAction(transition.sequence({
            cc.DelayTime:create(0.3),
            cc.CallFunc:create(function()
                local frame = display.newSpriteFrame("protectPoint.png")
                self.treaPic:setSpriteFrame(frame)
            end)
        }))
    end
    if num <= 3 then
        if device.platform == "ios" then
            cc.Native:vibrate()
        elseif device.platform == "android" then

            --厦门--
            -- local className = "org/cocos2dx/lua/AppActivity"
            -- local sig = "()V"
            -- luaj.callStaticMethod(className, "Vibrate",nil,sig)
            --厦门--
        end
    end
end

--主动设置钱数不做任务处理
function PlayScene:changeMoney(change, notControl)
    self.money = self.money + change
    local text = ""..self.money
    self.moneyLabel:setString(text)
    if self.money ~= self.initMoney then--重玩时有关卡金币变化才扣体力
        self.isMoneyChanged = true
    end
    ---[[没钱要禁用选塔
    if self.towerLayer ~= nil then 
        self.towerLayer:changeMoney(self.money)
    end
    if CLICK_GROUND then
        if self.towerCreateLayer then
            self.towerCreateLayer:changeMoney(self.money)
        end
    end
    --]]
    
    --更新塔的可升级状态
    for i = 1, #self.fightLayer.forts do
        self.fightLayer.forts[i]:updateForChangeMoney(self.money)
    end

    --任务处理
    if not notControl and change > 0 and self.task then
        self.task:addMoney(change)
    end
end

--获取一波怪要哪些提示
function PlayScene:getTipsForWave()
    --有没有BOSS，是不是大波怪，最一后波，都按大波判断不是子波。
    local hasBoss = false
    local waveEnemyNumber = 0
    for i = 1, #self.waves[self.waveNow] do
        if not hasBoss then
            for k,v in pairs(self.waves[self.waveNow][i].enemy) do
                if v > 60 then
                    hasBoss = true
                    break
                end
            end
        end
        waveEnemyNumber = waveEnemyNumber + #self.waves[self.waveNow][i].enemy
    end
    local hasBigWave = false
    if waveEnemyNumber > 10 then
        hasBigWave = true
    end
    local isLastWave = false
    if self.waveNow == self.wave then
        isLastWave = true
    end
    return hasBoss,hasBigWave,isLastWave
end
function PlayScene:restartWave()
    self.loopNum = self.loopNum + 1 --每循环一次波束加1，用于设置每次怪物战斗力提升用
    self.waveNow = 0
    self.waveInfo = {}
end
--主体出怪信息管理
function PlayScene:setWave(wave)
    self.waveNow = wave
    local text = self.waveNow..""
    self.waveLabel:setString(text)

    local tipDelay = 0
    --有可能之前的怪还没出完，加上这一波的出怪信息
    for i = 1, #self.waves[self.waveNow] do
        --获取提示选项
        local hasBoss,hasBigWave,isLastWave = false,false,false
        if i == 1 then --每大波只需要第一子波判断提示
            hasBoss,hasBigWave,isLastWave = self:getTipsForWave()
            --如果需要提示，之后加整体延时
            if hasBoss or hasBigWave or isLastWave then
                tipDelay = tipDelay + 2
            end
        end
        delay = self.waves[self.waveNow][i].delay or 0
        delay = delay + 2 + tipDelay --这个delay给闪箭头用
        local enemy,enemyHp
        if self.mode == "attackCityMode" then
            if self.waves[self.waveNow][i].enemyAttCity ~= nil then
                enemy = self.waves[self.waveNow][i].enemyAttCity
                enemyHp = self.waves[self.waveNow][i].enemyAttCityHp
            else
                enemy = self.waves[self.waveNow][i].enemy
                enemyHp = self.waves[self.waveNow][i].enemyHp
            end
        else
            enemy = self.waves[self.waveNow][i].enemy
            enemyHp = self.waves[self.waveNow][i].enemyHp
        end
        self.waveInfo[#self.waveInfo+1] = {
            waveIdx = self.waveNow, --波信息，在支线玩法关要用。
            subWaveIdx = i,
            delay = delay,
            useTime = -1.5-delay, --一小波内出第一个怪计时，闪箭头后一会开始按interval出怪。
            interval = self.waves[self.waveNow][i].interval, --出怪间隔
            wayIdx = self.waves[self.waveNow][i].wayIdx,
            enemy = enemy,--self.waves[self.waveNow][i].enemy
            enemyHp = enemyHp,--self.waves[self.waveNow][i].enemyHp --血量可变。
            count = 0, --已出怪数。
            hasBoss = hasBoss,
            hasBigWave = hasBigWave,           
            isLastWave = isLastWave,
            blinked = false,
        }
		--支线玩法波信息不一样
        if self.giftLevel then
            --从GiftManger中取出怪列表
            if self.giftManager.waves[self.waveNow] then
                self.waveInfo[#self.waveInfo].enemy = 
                    self.giftManager.waves[self.waveNow][i]
            end
            --礼盒有速度
            self.waveInfo[#self.waveInfo].speed = self.waves[self.waveNow][i].speed or 0.5
        end
        --大波计时，倒计时提前出怪用。现在不用。
        self.waveInfo.nextWaveTime = self.waves[self.waveNow].nextWaveTime
        self.waveInfo.tickTockTime = self.waves[self.waveNow].tickTockTime
        self.waveInfo.useTime = 0
        if self.waveNow < #self.waves and self.waveInfo.tickTockTime ~= nil then
            self.waveInfo.needTick = true
        else
            self.waveInfo.needTick = false
        end
    end

    --怪来以前，灯闪一下。
    self:wayStartBlinkNew()
end

function PlayScene:wayStartBlinkNew()
    self.waitStartBlink = true
    --出怪口
    for i = 1, #self.waveInfo do
        local wayIdx = self.waveInfo[i].wayIdx
        if wayIdx > #MapInfo.ways then break end
        local delay = self.waveInfo[i].delay
        --除了第一波外要等几秒。
        local pt = MapInfo:getCenterOfTile(MapInfo.ways[wayIdx].startPt)
        local orient = MapInfo.ways[wayIdx].wayOrient[1]
        local hasBoss = self.waveInfo[i].hasBoss
        local hasBigWave = self.waveInfo[i].hasBigWave
        local isLastWave = self.waveInfo[i].isLastWave      
        self:showEnemyWarningTip(isLastWave,hasBoss,hasBigWave,delay)
        self:wayBlickAction(orient,pt,delay)
    end
end
function PlayScene:showLastWaveEnemyWarningTip()
    self.lastWaveText = {}
    -- local lastWaveLine = display.newSprite("#lastWaveLine.png",display.cx,display.cy-70)
    -- self.actNode2:addChild(lastWaveLine)
    -- lastWaveLine:setScale(2)
    -- lastWaveLine:setOpacity(0)
    -- lastWaveLine:runAction(transition.sequence({
    --         cc.FadeIn:create(0.5),
    --         cc.DelayTime:create(2.15),
    --         cc.FadeOut:create(0.3)
    --     }))
    local textSort = 0
    if VERSION_REDUCE then
        for i = 1,3 do
            self.lastWaveText[i] = display.newSprite("#lastWaveEnglish"..i..".png")
            self.lastWaveText[i]:setPosition(display.cx-20+ (i-1.5)*250,display.height+70)
            self.actNode2:addChild(self.lastWaveText[i])
            if i == 3 then
                self.lastWaveText[i]:setPosition(display.cx-20+ (i-1.5)*170,display.cy)
                self.lastWaveText[i]:setScale(0)
                self.lastWaveText[i]:runAction(transition.sequence({
                    cc.DelayTime:create(2),
                    cc.ScaleTo:create(0.1,2),
                    cc.ScaleTo:create(0.05,1),
                    cc.DelayTime:create(0.5),
                    cc.FadeOut:create(0.3)
                }))
            else
                if i == 2 then
                    textSort = 3
                elseif i == 3 then
                    textSort = 2
                else
                    textSort = i
                end
                self.lastWaveText[i]:runAction(transition.sequence({
                    cc.DelayTime:create(0.3*textSort),
                    cc.EaseBounceOut:create(cc.MoveTo:create(0.8,cc.p(display.cx-20+ (i-1.5)*250,display.cy))),
                    cc.DelayTime:create(1.85-0.3*textSort),
                    cc.FadeOut:create(0.3)
                }))
            end
        end
    else
        for i = 1,5 do
            self.lastWaveText[i] = display.newSprite("#lastWave"..i..".png")
            self.lastWaveText[i]:setPosition(display.cx-20+ (i-2.5)*95,display.height+70)
            self.actNode2:addChild(self.lastWaveText[i])
            if i == 5 then
                self.lastWaveText[i]:setPosition(display.cx-20+ (i-2.5)*90,display.cy)
                self.lastWaveText[i]:setScale(0)
                self.lastWaveText[i]:runAction(transition.sequence({
                    cc.DelayTime:create(2),
                    cc.ScaleTo:create(0.1,2),
                    cc.ScaleTo:create(0.05,1),
                    cc.DelayTime:create(0.5),
                    cc.FadeOut:create(0.3)
                }))
            else
                if i == 2 then
                    textSort = 3
                elseif i == 3 then
                    textSort = 2
                else
                    textSort = i
                end
                self.lastWaveText[i]:runAction(transition.sequence({
                    cc.DelayTime:create(0.3*textSort),
                    cc.EaseBounceOut:create(cc.MoveTo:create(0.8,cc.p(display.cx-20+ (i-2.5)*95,display.cy))),
                    cc.DelayTime:create(1.85-0.3*textSort),
                    cc.FadeOut:create(0.3)
                }))
            end
        end
    end
    self.actNode2:runAction(transition.sequence({
        cc.DelayTime:create(3),
        cc.CallFunc:create(function()
            self.actNode2:removeFromParent()
            self.actNode2 = nil
        end)
    }))
    --音效
    SoundManager.playSound(GAME_SOUND.FinalWave)
end
function PlayScene:showEnemyWarningTip(isLastWave,hasBoss,hasBigWave,delay)
    --BOSS和大波怪提示
    if not isLastWave and not hasBoss and not hasBigWave then return end
    local boss = nil
    if isLastWave then
        if self.mode == "attackCityMode" then
            return 
        else
            return self:showLastWaveEnemyWarningTip()
        end
    elseif hasBoss then
        boss = display.newSprite("#bossAppearTip.png",display.width +360,display.cy)
    elseif hasBigWave then
        boss = display.newSprite("#enemyAppearTip.png",display.width +360,display.cy)
    end
    self.actNode2:addChild(boss)
    boss:runAction(transition.sequence({
        cc.DelayTime:create(delay-2),
        cc.CallFunc:create(function()
            for k, v in pairs(self.actSprites) do
                if boss == v then
	                table.remove(self.actSprites, k)
					break
                end
            end
		end),
        cc.EaseBackOut:create(cc.MoveBy:create((display.cx+360)/800,cc.p(-display.cx-360,0))),
        cc.DelayTime:create(1),
        cc.EaseBackIn:create(cc.MoveBy:create((display.cx+360)/800,cc.p(-display.cx-360,0)))
    }))
    self.actSprites[#self.actSprites+1] = boss
    --音效
    boss:performWithDelay(function ()
        SoundManager.playSound(GAME_SOUND.waring)
    end, 2.0)
end

function PlayScene:wayBlickAction(orient,pt,delay)
    local startPic = {}
    local delta = 20
    for i =1,3 do
        startPic[i] = display.newSprite("#enemyArrow.png")
        if orient == "left" then
            startPic[i]:setRotation(180)
            startPic[i]:setPosition(cc.p(pt.x-10-(i-1)*delta,pt.y))
        elseif orient == "right" then
            startPic[i]:setPosition(cc.p(pt.x+10+(i-1)*delta,pt.y))
        elseif orient == "up" then
            startPic[i]:setRotation(-90)
            startPic[i]:setPosition(cc.p(pt.x-5,pt.y+10+(i-1)*delta))
        else --orient == "down"
            startPic[i]:setRotation(90)
            startPic[i]:setPosition(cc.p(pt.x-5,pt.y-10-(i-1)*delta))
        end
        startPic[i]:setOpacity(0)
        self.actNode:addChild(startPic[i])

        startPic[i]:runAction(transition.sequence({
            cc.DelayTime:create(delay+(i-1)*0.1),
            cc.CallFunc:create(function()
                local tmp = {}
                for k, v in pairs(self.actSprites) do
                    if startPic[1] == v
                            or startPic[2] == v
                            or startPic[3] == v then
                        tmp[#tmp+1] = k
                    end
                end
                for i = #tmp,1,-1 do
                    self.actSprites[tmp[i]] = nil
                    table.remove(self.actSprites, tmp[i])
                end
            end),
            cc.FadeIn:create(0.1),
            --cc.DelayTime:create(0.6-i*0.1),
            cc.DelayTime:create(0.5),
            cc.FadeOut:create(0.1),
            cc.DelayTime:create(0.3),
            cc.FadeIn:create(0.1),
            --cc.DelayTime:create(0.6-i*0.1),
            cc.DelayTime:create(0.5),
            cc.FadeOut:create(0.1),
            cc.CallFunc:create(function()
                startPic[i]:removeFromParent()
            end)
        }))
        self.actSprites[#self.actSprites+1] = startPic[i]
    end
end

function PlayScene:wayStartBlink()
    self.waitStartBlink = true
    --出怪口
    local startArrow = {}
    for i = 1, #self.waves[self.waveNow] do
        local wayIdx = self.waves[self.waveNow][i].wayIdx
        if wayIdx > #MapInfo.ways then break end
        local delay = self.waves[self.waveNow][i].delay or 0
        --除了第一波外要等几秒。
        if self.waveNow ~= 1 then
            delay = delay + 3
        end
        local pt = MapInfo:getCenterOfTile(MapInfo.ways[wayIdx].startPt)
        startArrow[i] = display.newSprite("#startArrow.png")
        local orient = MapInfo.ways[wayIdx].wayOrient[1]
        if orient == "left" then
            startArrow[i]:setRotation(90)
            startArrow[i]:setPosition(cc.p(pt.x-64,pt.y))
        elseif orient == "right" then
            startArrow[i]:setRotation(-90)
            startArrow[i]:setPosition(cc.p(pt.x+64,pt.y))
        elseif orient == "up" then
            startArrow[i]:setRotation(180)
            startArrow[i]:setPosition(cc.p(pt.x,pt.y-64))
        else --orient == "down"
            startArrow[i]:setPosition(cc.p(pt.x,pt.y-64))
        end
        startArrow[i]:setVisible(false)
        self:addChild(startArrow[i])

        local action = transition.sequence({
            cc.DelayTime:create(0.5+delay),
            cc.CallFunc:create(function() startArrow[i]:setVisible(true) end),
            cc.DelayTime:create(0.5),
            cc.CallFunc:create(function() startArrow[i]:setVisible(false) end),
            cc.DelayTime:create(0.5),
            cc.CallFunc:create(function() startArrow[i]:setVisible(true) end),
            cc.DelayTime:create(0.5),
            cc.CallFunc:create(function() 
                startArrow[i]:removeFromParent()
                self.waitStartBlink = false
            end)
        })
        startArrow[i]:runAction(action)

        --[[
        local act0 = cc.DelayTime:create(delay)
        local act1 = cc.DelayTime:create(0.7)
        local act2 = cc.CallFunc:create(function() startArrow[i]:setVisible(false) end)
        local act3 = cc.DelayTime:create(0.7)
        local act4 = cc.CallFunc:create(function() startArrow[i]:setVisible(true) end)
        local act5 = cc.DelayTime:create(0.7)
        local act6 = cc.CallFunc:create(function() 
                startArrow[i]:removeFromParent()
                self.waitStartBlink = false
            end)
        local arr = CCArray:create()
        arr:addObject(act0)
        arr:addObject(act1)
        arr:addObject(act2)
        arr:addObject(act3)
        arr:addObject(act4)
        arr:addObject(act5)
        arr:addObject(act6)
        local seq = cc.Sequence:create(arr)
        startArrow[i]:runAction(seq)
        --]]
    end
end

--预设塔
function PlayScene:createPreTowers()
    for i = 1, #MapInfo.preTowers do
        local preTower = MapInfo.preTowers[i]
        self:createFort(preTower.towerIdx, preTower.tilePt, preTower.level)
        if self.task ~= nil then
            self.task:getPreFort(preTower.towerIdx)
        end
    end
end

--竹笋怪
function PlayScene:createE45Enemy(e45)
    local en = Enemys[45].new({
        enemyIdx = 45,
        enHp = e45.hp,
        wayIdx = e45.wayIdx,
        tilePt = e45.tilePt,
        growTime = e45.growTime,
        pos = e45.pos
    })
    self.fightLayer:addEnemy(en)
    e45.enemy = en
    en:init()
end

function PlayScene:createSubWayEnemy(wayIdx, enIdx, enHp, mixedWaveIdx)
    --print(wayIdx, enIdx, enHp, mixedWaveIdx)
    if wayIdx > #MapInfo.ways then return end
    local start = MapInfo:getCenterOfTile(MapInfo.ways[wayIdx].startPt)
    local orient = MapInfo.ways[wayIdx].wayOrient[1]
    local randmDist = 0
    if RANDOM_ENEMY_DIST then
        randmDist = math.random(-MapInfo.tileSize*0.25,MapInfo.tileSize*0.25)
    end
    if orient == "left" or orient == "right" then
        start.y = start.y + randmDist
    else
        start.x = start.x + randmDist
    end

    if self.giftLevel then
        self.giftManager:addGift(start, 
            enIdx,
            enHp,
            wayIdx, 
            self.waveInfo[mixedWaveIdx].speed,
            self.waveInfo[mixedWaveIdx].waveIdx,
            self.waveInfo[mixedWaveIdx].subWaveIdx,
            self.waveInfo[mixedWaveIdx].count)
        return true
    end

    local en = Enemys[enIdx].new({
        enemyIdx = enIdx,
        enHp = enHp,
        wayIdx = wayIdx,
        pos = start,
    })
    self.fightLayer:addEnemy(en)
    --音效
    SoundManager.playSound(GAME_SOUND.EnemyAppear)

    --火山出怪点
    if self.enemyHome[wayIdx].buffer then
        en:addBuffer({
            bufferType = EnemyBuffer.BUFFER_FIRE,
            time = 999,
        })
    end

    return true
end

function PlayScene:createFort(idx, tilePt, level, leftRight)
    --[[if NEW_GUIDE and GameData.guide.step < 48 then
        if GameData.guide.step > 21 and GameData.guide.step < 40 then

        elseif GameData.guide.step == 40 then
            if self.level == 102 then
                g_guidelayer:GetMessage(41)
            end
        end
    end]]
    local fort = Forts[idx].new({
        towerIdx = idx,
        tilePt = tilePt,
        level = level,
        leftRight = leftRight,
    })
    self.fightLayer:addFort(fort)
    fort:init()
    local pt = MapInfo:getCenterOfTile(tilePt)
    local sprite = display.newSprite("#createTower1.png")
    sprite:setPosition(pt)
    self.fightLayer:addChild(sprite,BaseZOrder.fort+1)
    local frames = display.newFrames("createTower%d.png", 1, 5)
    local animation = display.newAnimation(frames, 0.1)
    sprite:playAnimationOnce(animation,true)
end

function PlayScene:createNewFort(p, idx, leftRight)
    local towerIdx
    if CLICK_GROUND then
        towerIdx = idx
    elseif self.towerLayer then
        towerIdx = self.towerLayer.tower[idx].num
    end
    local m
    if self.mode == "randomTowerMode" then
        m = 120
    else
        m = ExcelTowersData[towerIdx].level[1].money
    end
    if not self.giftLevel and self.money < m then return end

    --print(towerIdx)
    self:createFort(towerIdx, p, 1, leftRight)
    --音效
    SoundManager.playSound(GAME_SOUND.TowerBuild)
    --use money
    if not self.giftLevel then
        self:changeMoney(-m)
    end

    if self.towerLayer then
        self.towerLayer:createTower(idx)
    end

    local pt = MapInfo:getCenterOfTile(p)
    self.fightLayer:moneyShow(-m, pt)
    --任务记录
    if self.task then
        self.task:createFort(towerIdx)
    end
end

function PlayScene:removeFort(fort)
    self:changeMoney(fort.removeMoney)
    local px,py = fort:getPosition()
    self.fightLayer:moneyShow(fort.removeMoney, cc.p(px,py-25))
    self.fightLayer:removeFort(fort)
end

function PlayScene:showResult(win)
    gameState = "GAMEOVER"
    --速度还原
    --self:popResult(win)
    cc.Director:getInstance():getScheduler():setTimeScale(1)

        --厦门
    -- if device.platform == "android" or device.platform == "ios" then
    --     if self.task then
    --         self.task:saveDataEyeTask()
    --     end
    -- end
        --厦门

    if win and self.task then --任务记录
        self.task:checkTaskAfterWin()
        self.task:saveTaskRecord()
    end

    self:performWithDelay(function()
        self.resultLayer = ResultLayer.new(self.level, win)
        self:addChild(self.resultLayer, PlaySceneOrder.resultLayer)
    end,0.5)
end

function PlayScene:popResult(win)
    local text = "#taskFail.png"
    if win then
        text = "#taskComplete.png"
    end
    local popSprite = display.newSprite(text,display.cx,display.cy)
    self:addChild(popSprite,300)
    popSprite:setScale(0)
    popSprite:runAction(transition.sequence({
            cc.ScaleTo:create(0.3,3),
            cc.ScaleTo:create(0.1,2.5),
            cc.DelayTime:create(0.5),
            cc.CallFunc:create(function()
                popSprite:removeFromParent()
            end)
        }))
end

function PlayScene:getCountNum()
    local countNum = display.newSprite("#MotionSenseCount3.png",display.cx,display.cy)--位置暂，等图
    countNum:setScale(0)
    countNum:runAction(transition.sequence({
        cc.ScaleTo:create(0.2,1.2),
        cc.ScaleTo:create(0.05,1),
        cc.CallFunc:create(function()
            SoundManager.playSound(GAME_SOUND.Clock)
        end)
    }))
    self:addChild(countNum,200)
    self:performWithDelay(function()
        countNum:setSpriteFrame(display.newSpriteFrame("MotionSenseCount2.png"))
        SoundManager.playSound(GAME_SOUND.Clock)
        self:performWithDelay(function()
            countNum:setSpriteFrame(display.newSpriteFrame("MotionSenseCount1.png"))    
            SoundManager.playSound(GAME_SOUND.Clock)
            self:performWithDelay(function()
                self:RemoveActSprites(countNum)
            end, 1)
        end, 1)
    end, 1)
    self.actSprites[#self.actSprites+1] = countNum
end
function PlayScene:showIceLabel()
    self:changeSpeedNormal()
    local label = display.newSprite("pic/ThemeTwoIce.png",display.cx,display.cy)
    --[[local label = cc.ui.UILabel.new({
        text = "冰块即将来临！",
        size = 100,
        x = display.cx,
        y = display.cy,
        color = display.COLOR_RED,
    }):align(display.CENTER)]]
    self:addChild(label,199)
    --label:setOpacity(0)
    --self:getCountNum(label)
    label:setScale(0)
    label:runAction(transition.sequence({
        cc.ScaleTo:create(0.3,1.2),
        cc.ScaleTo:create(0.1,1),
        --cc.FadeIn:create(0.5),
        cc.DelayTime:create(2),
        cc.FadeOut:create(1),
        cc.CallFunc:create(function()
            self:changeSpeedUser()
            self:showIce()
            self:RemoveActSprites(label)
        end)
    }))
    self.actSprites[#self.actSprites+1] = label
    --音效
    SoundManager.playSound(GAME_SOUND.weatherwarning)
end

function PlayScene:showIce()
    if self.iceShowed then return end
    self.iceShowed = true

    self.iceLayer = IceLayer.new()
    self:addChild(self.iceLayer, PlaySceneOrder.ice)
end
function PlayScene:showStarfishLabel()
    self:changeSpeedNormal()
    local label = display.newSprite("pic/ThemeFourStarfish.png",display.cx,display.cy)
    --[[local label = cc.ui.UILabel.new({
        text = "海星即将来临！",
        size = 100,
        x = display.cx,
        y = display.cy,
        color = display.COLOR_RED,
    }):align(display.CENTER)]]
    self:addChild(label,199)
    --label:setOpacity(0)
    --self:getCountNum(label)
    label:setScale(0)
    label:runAction(transition.sequence({
        cc.ScaleTo:create(0.3,1.2),
        cc.ScaleTo:create(0.1,1),
        --cc.FadeIn:create(0.5),
        cc.DelayTime:create(1),
        cc.FadeOut:create(0.5),
        cc.CallFunc:create(function()
            self:changeSpeedUser()
            self:showStarfish()
            self:RemoveActSprites(label)
        end)
    }))
    self.actSprites[#self.actSprites+1] = label
    --音效
    SoundManager.playSound(GAME_SOUND.weatherwarning)
end
function PlayScene:showStarfish()
    self.starfishLayer = StarfishLayer.new(2)
    self:addChild(self.starfishLayer, PlaySceneOrder.starfish)
end    
function PlayScene:showStormLabel()
    self:changeSpeedNormal()
    local label = display.newSprite("pic/ThemeOneStorm.png",display.cx,display.cy)
    --[[local label = cc.ui.UILabel.new({
        text = "沙尘暴即将来临！",
        size = 100,
        x = display.cx,
        y = display.cy,
        color = display.COLOR_RED,
    }):align(display.CENTER)]]
    self:addChild(label,199)
    --label:setOpacity(0)
    label:setScale(0)
    label:runAction(transition.sequence({
        cc.ScaleTo:create(0.3,1.2),
        cc.ScaleTo:create(0.1,1),
        --cc.FadeIn:create(0.5),
        cc.DelayTime:create(1),
        cc.FadeOut:create(0.5),
        cc.CallFunc:create(function()
            --self:showStorm() 先不用。
            self:getCountNum()
            self:performWithDelay(function()
                self:changeSpeedUser()
                self:showCloud("pic/stormFog.png")
                self:RemoveActSprites(label)
            end, 3)            
        end)
    }))
    self.actSprites[#self.actSprites+1] = label
    --音效
    SoundManager.playSound(GAME_SOUND.weatherwarning)
end
function PlayScene:showStorm()
    self.stormLayer = StormLayer.new()
    self:addChild(self.stormLayer, PlaySceneOrder.storm)
end    
function PlayScene:showCloudLabel()
    if gameState == "GAMEOVER" then return end
    self:changeSpeedNormal()
    local label = display.newSprite("pic/ThemeThreeFog.png",display.cx,display.cy)
    --[[local label = cc.ui.UILabel.new({
        text = "大雾即将来临！",
        size = 100,
        x = display.cx,
        y = display.cy,
        color = display.COLOR_RED,
    }):align(display.CENTER)]]
    self:addChild(label,199)
    --label:setOpacity(0)
    --self:getCountNum(label)
    label:setScale(0)
    label:runAction(transition.sequence({
        cc.ScaleTo:create(0.3,1.2),
        cc.ScaleTo:create(0.1,1),
        --cc.FadeIn:create(0.5),
        cc.DelayTime:create(1),
        cc.FadeOut:create(0.5),
        cc.CallFunc:create(function()
            self:changeSpeedUser()
            self:showCloud("pic/fog.png")
            self:RemoveActSprites(label)
        end)
    }))
    self.ui:setTouchCaptureEnabled(false)
    self.actSprites[#self.actSprites+1] = label
    --音效
    SoundManager.playSound(GAME_SOUND.weatherwarning)
end

function PlayScene:showCloud(pic)
    if self.cloudShowed then return end
    self.cloudShowed = true

    local FastCloud = false
    if not FastCloud then
        --[[
        local cloud1 = display.newSprite("#wu-1.png",display.cx,display.cy)
        cloud1:setOpacity(0)
        self:addChild(cloud1,1000)
        cloud1:runAction(transition.sequence({
            cc.FadeIn:create(0.3),
            cc.FadeOut:create(0.3),
            cc.CallFunc:create(function()
                cloud1:removeFromParent()
            end)
        }))
        local cloud2 = display.newSprite("#wu-2.png",display.cx,display.cy)
        cloud2:setOpacity(0)
        self:addChild(cloud2,1000)
        cloud2:runAction(transition.sequence({
            cc.DelayTime:create(0.3),
            cc.FadeIn:create(0.3),
            cc.FadeOut:create(0.3),
            cc.CallFunc:create(function()
                cloud2:removeFromParent()
            end)
        }))
        --]]
        local cloud3 = display.newSprite(pic,display.cx,display.cy)
        cloud3:setScale(2)
        cloud3:setOpacity(0)
        self:addChild(cloud3,1000)
        cloud3:runAction(transition.sequence({
            --cc.DelayTime:create(0.6),
            cc.FadeIn:create(1),
            cc.CallFunc:create(function()
                cloud3:removeFromParent()
                self.cloudLayer = CloudLayer.new(pic)
                self:addChild(self.cloudLayer, PlaySceneOrder.cloud)
            end)
        }))
    else
        local cloud3 = display.newSprite(pic,display.cx,display.cy)
        cloud3:setScale(2)
        cloud3:removeFromParent()
        self.cloudLayer = CloudLayer.new(pic)
        self:addChild(self.cloudLayer, PlaySceneOrder.cloud)
        self.cloudLayer:cloudGone()
    end
end

function PlayScene:removeCloud()
    --print("removeCloud")
    ---[[
    self.cloudLayer:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
    self.cloudLayer:unscheduleUpdate()
    self.cloudLayer.couldTouchLayer:removeFromParent()
    if USE_PIC_PEN then
        self.cloudLayer.finger:release()
    else
        self.cloudLayer.pen:release()
    end
    self.cloudLayer.render:removeFromParent()
    --]]
    --一移除就死，改成延时移除。
    local cloudLayer = self.cloudLayer
    self:performWithDelay(function()
        cloudLayer:removeFromParent()
    end, 1)

    self.cloudShowed = false
    self.cloudLayer = nil
    self.ui:setTouchCaptureEnabled(true)
end

function PlayScene:cloudHasGone()
    local label = cc.ui.UILabel.new({
        text = "大雾散去",
        size = 100,
        x = display.cx,
        y = display.cy,
        color = display.COLOR_RED,
        align = ui.TEXT_ALIGN_CENTER,
    })
    self:addChild(label,199)
    label:setOpacity(0)
    label:runAction(transition.sequence({
        cc.FadeIn:create(0.5),
        cc.DelayTime:create(1),
        cc.FadeOut:create(0.5),
        cc.CallFunc:create(function()
            self:RemoveActSprites(label)
        end)
    }))
    self.actSprites[#self.actSprites+1] = label
end

function PlayScene:getTip(params)
    local tipName
    local time
    if params.type == "cloud" then
        tipName = "pic/cloudTip.png"
        time = 0.5
    elseif params.type == "ice" then
        tipName = "#iceTip.png"
        time = 1
    elseif params.type == "storm" then
        tipName = "pic/stormTip.png"
        time = 1
    elseif params.type == "skill1" then
        tipName = "#skillTipAcceler.png"
        time = 0
    elseif params.type == "skill4" then
        tipName = "#skillTipClick.png"
        time = 0
    elseif params.type == "skill8" then
        tipName = "#skillTipSwipe.png"
        time = 0 
    elseif params.type == "skill12" then
        tipName = "#skillTipFly.png"
        time = 0       
    end
    local tip = display.newSprite(tipName,display.cx,110)
    if time > 0 then
        tip:setOpacity(0)
        tip:runAction(cc.FadeIn:create(time))
    end
    return tip
end

function PlayScene:getTipFinger(params)
    GameData.tips = GameData.tips or {}
    if params.type == "cloud" then
        if GameData.tips.cloud then
            return nil
        else
            GameData.tips.cloud = true
        end
    elseif params.type == "ice" then
        if GameData.tips.ice then
            return nil
        else
            GameData.tips.ice = true
        end
    elseif params.type == "storm" then
        if GameData.tips.storm then
            return nil
        else
            GameData.tips.storm = true
        end
    elseif params.type == "skill1" then
        if GameData.tips.skill1 then
            return nil
        else
            GameData.tips.skill1 = true
        end
    elseif params.type == "skill4" then
        if GameData.tips.skill4 then
            return nil
        else
            GameData.tips.skill4 = true
        end
    elseif params.type == "skill8" then
        if GameData.tips.skill8 then
            return nil
        else
            GameData.tips.skill8 = true
        end
    elseif params.type == "skill12" then
        if GameData.tips.skill12 then
            return nil
        else
            GameData.tips.skill12 = true
        end
    end
    GameState.save(GameData)

    local tipFinger
    if params.type == "cloud" or params.type == "skill8" then
        tipFinger = display.newSprite("#tipFinger1.png")
        tipFinger:runAction(cc.RepeatForever:create(
            transition.sequence({
                cc.CallFunc:create(function()
                    tipFinger:setPosition(display.cx+100,display.cy+100)
                    tipFinger:setOpacity(255)
                end),
                cc.MoveBy:create(0.5, cc.p(-100,-100)),
                cc.MoveBy:create(0.3, cc.p(100,0)),
                cc.MoveBy:create(0.5, cc.p(-100,-100)),
                cc.FadeOut:create(0.5),
                cc.DelayTime:create(1),
                cc.CallFunc:create(function ()
                    tipFinger.isCompleteOnce = true
                end)
            }))
        )
    elseif params.type == "skill12" then
        tipFinger = display.newSprite("#tipFingerAcceler1.png",display.cx,display.cy)
        local frames = display.newFrames("tipFingerAcceler%d.png", 1, 5)
        local animation = display.newAnimation(frames, 0.1)
        tipFinger:playAnimationForever(animation)
    elseif params.type == "skill1" then
        tipFinger = display.newSprite("#tipFingerAcceler1.png",display.cx,display.cy)
        local frames = display.newFrames("tipFingerAcceler%d.png", 1, 5)
        local animation = display.newAnimation(frames, 0.1)
        local framesTwo = display.newFrames("tipFingerAcceler%d.png", 1, 5, true)
        local animationTwo = display.newAnimation(framesTwo, 0.1)
        tipFinger:runAction(cc.RepeatForever:create(transition.sequence({
                cc.Animate:create(animation),
                cc.DelayTime:create(0.5),
                cc.Animate:create(animationTwo),
                cc.DelayTime:create(0.5)
            })))
    elseif params.type == "skill4" then
        tipFinger = display.newSprite("#tipFinger1.png",display.cx,display.cy)
        local frames = display.newFrames("tipFinger%d.png", 1, 2)
        local animation = display.newAnimation(frames, 0.1)
        tipFinger:playAnimationForever(animation, 0.2)
    elseif params.type == "ice" then
        tipFinger = display.newSprite("#iceTipPic.png")
        tipFinger:runAction(cc.RepeatForever:create(
            transition.sequence({
                cc.CallFunc:create(function()
                    tipFinger:setPosition(display.cx-100,display.cy+100)
                    tipFinger:setOpacity(255)
                end),
                cc.MoveBy:create(0.2, cc.p(200,-200)),
                cc.MoveBy:create(0.2, cc.p(-200,200)),
            }))
        )
    elseif params.type == "storm" then
        tipFinger = display.newSprite("#tipFinger1.png")
        tipFinger:runAction(cc.RepeatForever:create(
            transition.sequence({
                cc.DelayTime:create(0.5),
                cc.CallFunc:create(function()
                    tipFinger:setPosition(display.cx+100,display.cy)
                    tipFinger:setOpacity(255)
                end),
                cc.MoveBy:create(0.2, cc.p(-200,0)),
                cc.FadeOut:create(0.2),
            }))
        )
    end
    return tipFinger
end

function PlayScene:update(dt)
    --[[控制帧，没有用吧。
    self.callInterval = self.callInterval + dt
    if self.callInterval < self.updateInterval then return end
    self.callInterval = self.callInterval - dt
    --]]
    if gameState ~= "NORMAL" then return end

    if self.pause then return end

    --BOSS模式倒计时
    if self.mode == "bossMode" then
        local timeNow = self.timeCount - dt
        if math.floor(timeNow) < math.floor(self.timeCount) then
            if math.floor(timeNow) < 100 and math.floor(timeNow) >= 10 then
                self.timeCountLabel:setString("0"..math.floor(timeNow))
            elseif math.floor(timeNow) < 10 then
                self.timeCountLabel:setString("00"..math.floor(timeNow))
            else
                self.timeCountLabel:setString(math.floor(timeNow))
            end         
        end
        self.timeCount = timeNow
        if self.timeCount >= 10 and self.timeCount < 15 then
            if not self.isChangeSilver then
                self.timeMedal:setSpriteFrame(display.newSpriteFrame("timeSilverMedal.png"))
                self.isChangeSilver = true
            end
        elseif self.timeCount > 0 and self.timeCount < 10 then
            if not self.isChangeBronze then
                self.timeMedal:setSpriteFrame(display.newSpriteFrame("timeBronzeMedal.png"))    
                self.isChangeBronze = true
            end
        elseif self.timeCount <= 0 then
            self.timeCountLabel:setString("000")
            self:showResult(false)
        end
    end

    self.gamePassTime = self.gamePassTime + dt

    --出雾时间
    if self.cloudCoutDown ~= nil then
        self.cloudCoutDown = self.cloudCoutDown - dt
        if self.cloudCoutDown <= 0 then
            self.cloudCoutDown = nil
            self:showCloudLabel()
        end
    end
    --出冰时间
    if self.iceCoutDown ~= nil then
        self.iceCoutDown = self.iceCoutDown - dt
        if self.iceCoutDown <= 0 then
            self.iceCoutDown = nil
            self:showIceLabel()
        end
    end
    --出沙尘暴时间
    if self.stormCoutDown ~= nil then
        self.stormCoutDown = self.stormCoutDown - dt
        if self.stormCoutDown <= 0 then
            self.stormCoutDown = nil
            self:showStormLabel()
        end  
    end
    --出海星时间
    if self.starfishCoutDown ~= nil then
        self.starfishCoutDown = self.starfishCoutDown - dt
        if self.starfishCoutDown <= 0 then
            self.starfishCoutDown = nil
            self:showStarfishLabel()
        end  
    end
    --出竹笋怪时间
    if self.E45CountDown ~= nil then
        for i = 1, #self.E45CountDown do
            self.E45CountDown[i].time = self.E45CountDown[i].time - dt
            if self.E45CountDown[i].time <= 0 then
                self:createE45Enemy(self.E45CountDown[i].e45)
                table.remove(self.E45CountDown, i)
                break --一次只能remove一个。
            end
        end
    end
    if NEW_GUIDE and self.newbieguidelayer ~= nil then
        self.newbieguidelayer:update(dt)
    end
    --任务更新
    if self.task and self.task.flag.checkTime then
        if self.gamePassTime > self.task.lastCheckTime + 1 then          
            self.task:timePassed()
        end
    end

    --新的出怪管理
    local needClear = {}
    for i = 1, #self.waveInfo do
        if self.waveInfo[i].count >= #self.waveInfo[i].enemy then
            --print("waveInfo error...",self.waveInfo[i].count, #self.waveInfo[i].enemy)
            break
        end
        done = false
        if self.level == 100 then--教学关
            self.waveInfo[i].useTime = self.waveInfo[i].useTime + dt
        else
            if not self.hero.skilling then --放技能时候不出怪
                self.waveInfo[i].useTime = self.waveInfo[i].useTime + dt
            end
        end
        local defaultInterval = 1
        if self.giftLevel then
            defaultInterval = 2
        end
        local interval = self.waveInfo[i].interval or defaultInterval
        --显示出怪漩涡
        local idx = self.waveInfo[i].wayIdx
        if self.waveInfo[i].count == 0 
                and not self.enemyHomePos[idx]:isVisible() then
            if self.waveInfo[i].useTime > interval - 0.5 then
                self.enemyHomePos[idx]:setVisible(true)
                self.enemyHomePos[idx]:runAction(
                    cc.ScaleTo:create(0.2,1)
                )
            end
        end
        if self.waveInfo[i].useTime > interval then
            self.waveInfo[i].count = self.waveInfo[i].count + 1
            local wayIdx = self.waveInfo[i].wayIdx
            local enIdx = self.waveInfo[i].enemy[self.waveInfo[i].count]
            local enHp = nil
            if self.waveInfo[i].enemyHp ~= nil
                    and self.waveInfo[i].enemyHp[self.waveInfo[i].count] ~= nil then
                enHp = self.waveInfo[i].enemyHp[self.waveInfo[i].count]
            end
            --print(self.gamePassTime, wayIdx, enIdx)
            self:createSubWayEnemy(wayIdx, enIdx, enHp, i)
            self.waveInfo[i].useTime = 0
            --一小波怪出完得清掉这波信息，先记录，之后清。
            if self.waveInfo[i].count == #self.waveInfo[i].enemy then
                needClear[#needClear+1] = i
                --隐藏出怪点漩涡
                local idx = self.waveInfo[i].wayIdx
                self.enemyHomePos[idx]:runAction(transition.sequence({
                    cc.DelayTime:create(0.5),
                    cc.ScaleTo:create(0.2,0),
                    cc.CallFunc:create(function()
                        self.enemyHomePos[idx]:setVisible(false)
                    end),
                }))
            end
        end
    end
    --清掉出完怪的波信息
    for i = #needClear,1,-1 do
        table.remove(self.waveInfo, needClear[i])
    end
    --出倒计时圈
    if self.waveInfo.needTick then
        self.waveInfo.useTime = self.waveInfo.useTime + dt
        if self.waveInfo.useTime > self.waveInfo.nextWaveTime - self.waveInfo.tickTockTime then
            self:addTickTockRound(self.waveInfo.tickTockTime,handler(self,self.callNextWave))
            self.waveInfo.needTick = false
        end
    end

    --英雄也添加在fightLayer层上但不写在里面刷新了。
    if self.hero then
        self.hero:update(dt)
    end
    --核心、塔、怪、子弹更新。
    self.fightLayer:update(dt)
    if #self.waveInfo == 0 then
        if not self:isWaveClear() then
            return
        elseif self.waveNow < self.wave then
            --新手引导
            if (NEW_GUIDE and self.newbieguidelayer ~= nil) or (self.newbieguidelayer ~= nil and self.newbieguidelayer.isTeach) then
                self.newbieguidelayer:selectTheFunction()
            end
            if not self.pause then --新手引导会暂停
                --普通出怪模式，或者是波计时但这一波没有时间。
                if not WAVE_PROGRESS or self.waveInfo.tickTockTime == nil then
                    self:callNextWave()
                end
            end
        elseif self.mode == "bossMode" then
            if self.timeCount <= 0 then
                self:showResult(false)
            else
                self:showResult(true)
                if VERSION_REDUCE then
                    self:showResult(true)
                else
                    if self:isPopGiftBox() then --判断是解锁道具的提示的话先弹出礼盒
                        self:popGiftBox()
                    else
                        if self:isPopNewElementTips() then
                            self:unLockNewElement()
                        else
                            self:showResult(true)
                        end
                    end
                end      
            end 
        elseif self.heartNum > 0 then
            --攻城模式
            --[[if self.mode == "attackCityMode" then
                self:restartWave()
                return
            end]]
            --新手引导
            if (NEW_GUIDE and self.newbieguidelayer ~= nil and (self.level == 100 or self.level == 101)) or (self.newbieguidelayer ~= nil and self.newbieguidelayer.isTeach) then
                gameState = "GAMEOVER"
                self.newbieguidelayer:levelResultLayer(self.level)
            else
                if VERSION_REDUCE then
                    self:showResult(true)
                else
                    if self:isPopGiftBox() then 
                        self:popGiftBox()
                    else
                        if self:isPopNewElementTips() then
                            self:unLockNewElement()
                        else
                            self:showResult(true)
                        end
                    end
                end
            end
        else--应该走不到这
            if gameState ~= "GAMEOVER" then
                self:showResult(false)
            end
        end
    end
end

--一波怪是否清完可以出下一波。
function PlayScene:isWaveClear()
    return #self.fightLayer.enemies - g_playScene.E44num == 0 
        and #g_fightLayer.gifts == 0
end

function PlayScene:addTickTockRound(time, callbalck)
    self.waveProgress = WaveProgress.new(time, callbalck)
    self.waveProgress:setPosition(cc.p(display.width-100,display.height - 150))
    self:addChild(self.waveProgress)
end

function PlayScene:callNextWave()
    self.waveNow = self.waveNow + 1

    --出雾时间控制
    if self.levelData.cloud ~= nil then
        if self.waveNow == self.levelData.cloud then
            --出雾可控制延时
            self.cloudCoutDown = self.levelData.cloudDelay or 0
        end
    end
    --出冰时间控制
    if self.levelData.ice ~= nil then
        if self.waveNow == self.levelData.ice then
            --出冰可控制延时
            self.iceCoutDown = self.levelData.iceDelay or 0
        end
    end
    --出沙尘暴时间控制
    if self.levelData.storm ~= nil then
        if self.waveNow == self.levelData.storm then
            --出沙尘暴可控制延时
            self.stormCoutDown = self.levelData.stormDelay or 0
        end
    end
    --出海星时间控制
    if self.levelData.starfish ~= nil then
        if self.waveNow == self.levelData.starfish then
            --出海星可控制延时
            self.starfishCoutDown = self.levelData.starfishDelay or 0
        end
    end
    --竹笋怪控制，在这一波里的全加上。
    self.E45CountDown = self.E45CountDown or {}
    for i = 1, #MapInfo.E45 do
        if MapInfo.E45[i].wave == self.waveNow then
            self.E45CountDown[#self.E45CountDown+1] = {
                e45 = MapInfo.E45[i],
                time = MapInfo.E45[i].delay
            }
        end
    end
    --新敌人提示（动态效果跟炮塔相同）
    if self.levelOtherData ~= nil and self.levelOtherData[self.waveNow] ~= nil and (TEST_DEMO or self.level == GameData.openlevel) then
        self.pause = true 
        local getFortLayer = display.newLayer()
        self:addChild(getFortLayer,201)
        display.newColorLayer(cc.c4b(0,0,0,128)):addTo(getFortLayer,-2)
        --button
        self.getNewEnemyButton = cc.ui.UIPushButton.new({
            normal = "#getNewFortButton.png",
            pressed = "#getNewFortButton.png",
            disabled = "#getNewFortButton.png",
            })
            :onButtonPressed(function()
                self.getNewEnemyButton:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.getNewEnemyButton:setScale(1)
            end)
            :onButtonClicked(function()
                self.pause = false
                if self.waveNow == 1 then--第一波时有321Go
                    self.propSelectLayer = PropSelectLayer.new()
                    self:addChild(self.propSelectLayer, PlaySceneOrder.prop)
                end
                getFortLayer:removeFromParent()
                self:setWave(self.waveNow)        
            end):align(display.CENTER,display.cx,display.cy)
            :addTo(getFortLayer)
        self.getNewEnemyButton:setOpacity(0)
        --背景光
        local getNewFortLight = display.newSprite("#getNewFortLight.png",display.cx,display.cy)
        getFortLayer:addChild(getNewFortLight,-1)
        getNewFortLight:setVisible(false)
        self:performWithDelay(function()
            getNewFortLight:setVisible(true)
            getNewFortLight:runAction(cc.RepeatForever:create(cc.RotateBy:create(10, -180)))
        end, 0.9)
        --背景
        local getNewFortBg = display.newSprite("#newEnemyTip.png",display.cx,display.cy)
        getFortLayer:addChild(getNewFortBg)
        getNewFortBg:setScale(0)
        getNewFortBg:runAction(transition.sequence({
            cc.ScaleTo:create(0.3,1.1),
            cc.ScaleTo:create(0.1,1),
            cc.DelayTime:create(0.1),
            cc.RotateBy:create(0.05,25),
            cc.RotateBy:create(0.05,-25),
            cc.RotateBy:create(0.05,25),
            cc.RotateBy:create(0.05,-25),
        }))
        --标题
        -- local getNewFortTitle = display.newSprite("#getNewFortTitle.png",display.cx,display.cy+170)
        -- getFortLayer:addChild(getNewFortTitle)
        -- getNewFortTitle:setScale(0)
        -- getNewFortTitle:runAction(transition.sequence({    
        --     cc.ScaleTo:create(0.3,1.1),
        --     cc.ScaleTo:create(0.1,1),
        -- }))
        --怪物图片
        local getNewFortPic = display.newSprite("#"..EnemyData[self.levelOtherData[self.waveNow].enemyId].pic,110,200)
        getNewFortBg:addChild(getNewFortPic,5)
        --类型
        local enemyType = EnemyData[self.levelOtherData[self.waveNow].enemyId].enemyType
        if enemyType then
            local typePic = display.newSprite("#label"..enemyType..".png",75,237)
            getNewFortBg:addChild(typePic,6)
        end
        --描述
        local towerIntro
        if VERSION_REDUCE then
            towerIntro = cc.ui.UILabel.new({
                UILabelType = 2,
                text = kkFunc.getVersionText("新怪",self.levelOtherData[self.waveNow].enemyId),
                size = 16,
                font = "fontEasy.ttf",
                color = cc.c3b(177,105,57),
                x = 25,
                y = 105,--110
                dimensions = cc.size(180, 150),
                }):align(display.LEFT_TOP)
        else
            towerIntro = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",
                text = kkFunc.getVersionText("新怪",self.levelOtherData[self.waveNow].enemyId),
                size = 20,
                color = cc.c3b(177,105,57),
                x = 25,
                y = 105,--110
                }):align(display.LEFT_TOP)
        end
        getNewFortBg:addChild(towerIntro)
        --buttonAction
        transition.execute(self.getNewEnemyButton, transition.sequence({    
                cc.Spawn:create(
                    cc.FadeIn:create(0.1),
                    cc.MoveBy:create(0.1,cc.p(0,-190))
                ),
                cc.CallFunc:create(function()
                    kkFunc.bubbleButton(self.getNewEnemyButton,true)
                end)
            }) , {delay = 1.1})
    else
        self:setWave(self.waveNow)
    end
end

function PlayScene:getTileFort(tilePt)
    for i = 1, #self.fightLayer.forts do
        --拦路兔占两格
        if self.fightLayer.forts[i].blockTime ~= nil then
            if self.fightLayer.forts[i].leftRight then
                if self.fightLayer.forts[i].tilePt.y == tilePt.y then
                    if self.fightLayer.forts[i].tilePt.x-1 == tilePt.x
                        --or self.fightLayer.forts[i].tilePt.x == tilePt.x
                        or self.fightLayer.forts[i].tilePt.x+1 == tilePt.x then
                            return self.fightLayer.forts[i]
                    end
                end  
            else --上下
                if self.fightLayer.forts[i].tilePt.x == tilePt.x then
                    if self.fightLayer.forts[i].tilePt.y-1 == tilePt.y
                        --or self.fightLayer.forts[i].tilePt.y == tilePt.y
                        or self.fightLayer.forts[i].tilePt.y+1 == tilePt.y then
                            return self.fightLayer.forts[i]
                    end
                end                
            end
        elseif self.fightLayer.forts[i].tilePt.x == tilePt.x 
            and self.fightLayer.forts[i].tilePt.y == tilePt.y then
                return self.fightLayer.forts[i]
        end
    end
    return nil
end

function PlayScene:isCanTouch()
    return self.playSceneCanTouch
end

function PlayScene:setCanTouch(b)
    self.playSceneCanTouch = b
    self.ui:setTouchCaptureEnabled(b)
    if self.towerCreateLayer.createTilePt ~= nil then
        self.towerCreateLayer.createTilePt = nil
        self.towerCreateLayer.blank:stopAllActions()
        self.towerCreateLayer.blank:setVisible(false)
        self.towerCreateLayer.showLayer:setVisible(false)
    end
end

--[[
touch事件处理函数
@param event
@param x
@param y
]]
function PlayScene:onTouch(event, x, y)
    if not self.playSceneCanTouch then return end --是否可触摸自己判断，不设置touchEnable。
    if LOADING_CLOUD and self.coverWhiteCloud then return end
    if gameState == "DIALOG" and self.dialogCanClick then
        self.dialog:click()
    end
    if self.needSelectTower then
        if gameState == "SELECT" then
            if self.selectLayer then 
                return self.selectLayer:onTouch(event, x, y)
            end
        end
    end
    --塔的升级移除界面
    if self.fightLayer ~= nil and self.fightLayer.selectedFort ~= nil then
        if self.fightLayer.selectedFort:onTouch(x,y) then
            self.fightLayer.selectedFort = nil
        end
        return
    end

    --非正常游戏时不能点
    if gameState ~= "NORMAL" then return end

    --暂停时不能点
    if not self.pause then
        --雾中不能点。
        if event == "began" and self.cloudShowed and self.cloudLayer then
            if self.cloudLayer:inCloud(x,y) then
                return
            end
        end

        --冰块中不能点。
        if event == "began" and self.iceShowed and self.iceLayer then
            return
        end

        --出怪倒计时
        if self.waveProgress then 
            if self.waveProgress:onTouch(x,y) then
                return
            end
        end
    end

    --英雄技能触摸
    if self.skillLayer then
        if event == "began" then
            local ret, swallow = self.skillLayer:onTouch("began", x,y)
            if ret then
                return true
            elseif swallow then
                return false
            end
        elseif event == "moved" and self.skillLayer.selectedSkill then
            return self.skillLayer:onTouch("moved", x,y)
        elseif event == "ended" and self.skillLayer.selectedSkill then
            return self.skillLayer:onTouch("ended", x,y)
        end
    end
    --造塔列表出现时优先点。
    if CLICK_GROUND then
        if self.towerCreateLayer.createTilePt ~= nil then
            return self.towerCreateLayer:onTouch(x, y)
        end
    end

    --英雄触摸，暂停时可用。
    if NEW_GUIDE and self.newbieguidelayer ~= nil and not self.newbieguidelayer.heroCanTouch and self.level ==101 then
    else
        if self.hero then
            if event == "began" and self.hero:onTouch("began", x,y) then 
                return true
            elseif event == "moved" and self.hero.selected then
                return self.hero:onTouch("moved", x,y)
            elseif event == "ended" and self.hero.selected then
                return self.hero:onTouch("ended", x,y)
            end
        end
    end
    if event == "began" then
        return self:onTouchBegan(x,y)
    elseif event == "moved" then
        return self:onTouchMoved(x,y)
    elseif event == "ended" then
        return self:onTouchEnded(x,y)
    end
end

function PlayScene:onTouchBegan(x, y)
    --选塔层触摸
    if self.towerLayer then
        if cc.rectContainsPoint(self.towerLayer.rect, cc.p(x,y))
                and self.towerLayer:onTouch("began", x, y) then 
            return true
        end
    end

    local tilePt = MapInfo:getTilePositionInCCP(cc.p(x,y))
    --print("tilePt:",tilePt.x,tilePt.y)
    if not MapInfo:isTilePtInMap(tilePt) then
        self:showFobid(cc.p(x,y))
        return false
    end

    --捡道具
    if self.fightLayer:clickThingItem(x,y) then
        return
    end
    --先检查有没有塔。
    local fort = self:getTileFort(tilePt)

    --选中塔后的点击单独处理。只考虑能不能造塔
    if self.towerLayer and self.towerLayer.selectedTower ~= nil then
        if fort == nil then
            --如果要在路上造塔要看这种塔能不能造在路上。
            local towerIdx = self.towerLayer.tower[self.towerLayer.selectedTower].num
            local canBuild, leftRight = self:canCreateFortOnTile(towerIdx, tilePt)
            if canBuild then
                --造个塔
                --print("tilePt:",tilePt.x,tilePt.y)
                self:createNewFort(tilePt, self.towerLayer.selectedTower, leftRight)
                if not self.giftLevel then
                    self.towerLayer:selectTower(self.towerLayer.selectedTower)
                end
            else
                self.towerLayer:selectTower(self.towerLayer.selectedTower)
                self:showFobid(MapInfo:getCenterOfTile(tilePt))
            end
        else
            self.towerLayer:selectTower(self.towerLayer.selectedTower)
            self:showFobid(MapInfo:getCenterOfTile(tilePt))
        end
        return
    end
    if fort ~= nil then
        --地上已经有塔
        if fort.unlockTime ~= nil and self.gamePassTime - fort.unlockTime < 1 then
            --print("unlockTime,gametime:",fort.unlockTime,self.gamePassTime)
            return
        else
            return fort:select(tilePt)
        end
    else
        --没有点到塔才检查怪和道具。
        if self.mode == "attackCityMode" then
            if self.fightLayer:selectCity(x,y) then
                return
            end
        end
        if CLICK_GROUND then
            --点地面造塔
            if self:checkTileNormalCreateTower(tilePt)
                    and self.towerCreateLayer:checkGroundShowList(tilePt) then
                --新手引导
                if (NEW_GUIDE and g_playScene.level == 100) or (self.newbieguidelayer ~= nil and self.newbieguidelayer.isTeach) then
                    self.newbieguidelayer:createTower(1)
                elseif (self.newbieguidelayer ~= nil and self.newbieguidelayer.rect ~= nil and g_playScene.level == 107) then
                    self.newbieguidelayer:goLevel7(3)
                elseif (self.newbieguidelayer ~= nil and self.newbieguidelayer.rect ~= nil and g_playScene.level == 109) then
                    self.newbieguidelayer:goLevel14(3)
                end     
                return
            end
        end
        --点击兔子卡片
        if self.fightLayer:selectRabbitCard(x,y) then
            return
        end
        --击破礼盒
        if self.fightLayer:selectGift(x,y) then
            return
        end
        --选中可打击出怪点
        if self.fightLayer:selectThing(tilePt, 2) then
            return
        end
        --选中浮冰
        if self.fightLayer:selectThing(tilePt, 1) then
            return
        end
        --选中怪
        if self.fightLayer:selectEnemy(x,y) then
            return
        end
        --选中可打道具
        if self.fightLayer:selectThing(tilePt, 0) then
            --[[if NEW_GUIDE and GameData.guide.step < 48 then
                if g_guidelayer and g_guidelayer.next:isVisible() then
                    g_guidelayer.next:setVisible(false)
                    g_guidelayer.clickMes:setVisible(false)
                    self.pause = true 
                    self:suspend()
                else
                    g_guidelayer.next:setVisible(true)
                    g_guidelayer.clickMes:setVisible(true)
                end    
            end]]       
            return
        end
    end
    --啥都没有
    self:showFobid(MapInfo:getCenterOfTile(tilePt))
end

--点地面造塔，只简单判断这个点不是路不是水。
function PlayScene:checkTileNormalCreateTower(tilePt)
    local road = MapInfo:checkTileRoadValid(tilePt)
    local water = MapInfo:checkWater(tilePt)
    local waterWay = MapInfo:checkWaterWay(tilePt)
    if road or water or waterWay then return false end

    return true
end

function PlayScene:canCreateFortOnTile(towerIdx,tilePt)
    --[[
    if NEW_GUIDE then
        if GameData.guide.step == 5 and tilePt.x == 5 and tilePt.y == 6 then
            return true
        elseif GameData.guide.step == 40 and tilePt.x == 7 and tilePt.y == 6 then
            return true
        else
            return false
        end
    end
    --]]
    --非空地且不是路不能造塔
    local e45 = MapInfo:checkE45(tilePt)
    local road = MapInfo:checkTileRoadValid(tilePt)
    local water = MapInfo:checkWater(tilePt)
    local waterWay = MapInfo:checkWaterWay(tilePt)

    if MapInfo:checkTileBlank(tilePt) == false and 
        not road and not waterWay then 
        return false
    end

    --铁锹兔
    local E45Create = TowersData[towerIdx].onE45 and e45

    --是不是造水路上。
    local waterWayCreate = waterWay and TowersData[towerIdx].onWaterWay

    --是不是造水上。
    local waterCreate = water and TowersData[towerIdx].onWater

    --如果要在路上造塔要看这种塔能不能造在路上。
    local roadCreate = road and TowersData[towerIdx].onRoad and not e45

    --拦路兔特殊判断
    if roadCreate and TowersData[towerIdx].blockTime ~= nil then
        if tilePt.x > 0 and tilePt.x < MapInfo.map:getMapSize().width-1 then
            if MapInfo:checkTileBlank(cc.p(tilePt.x-1,tilePt.y))
                and MapInfo:checkTileBlank(cc.p(tilePt.x+1,tilePt.y)) then
                    if self:getTileFort(cc.p(tilePt.x-1,tilePt.y)) == nil
                        and self:getTileFort(cc.p(tilePt.x+1,tilePt.y)) == nil then
                        return true, true
                    end
            end
        end
        if tilePt.y > 0 and tilePt.y < MapInfo.map:getMapSize().height-1 then
            if MapInfo:checkTileBlank(cc.p(tilePt.x,tilePt.y-1))
                and MapInfo:checkTileBlank(cc.p(tilePt.x,tilePt.y+1)) then
                    if self:getTileFort(cc.p(tilePt.x,tilePt.y-1)) == nil
                        and self:getTileFort(cc.p(tilePt.x,tilePt.y+1)) == nil then
                        return true, false
                    end
            end
        end
        return false
    end
    local nomalCreate = not road and not TowersData[towerIdx].onRoad
        and not water and not TowersData[towerIdx].onWater
        and not waterWay and not TowersData[towerIdx].onWaterWay
        and not TowersData[towerIdx].onE45
    if nomalCreate or roadCreate or waterCreate 
            or waterWayCreate or E45Create then
        return true
    else
        return false
    end
end

function PlayScene:showFobid(pt)
    if self.fobid ~= nil then
        self.fobid:removeFromParent()
    end
    self.fobid = display.newSprite("#forbid.png", pt.x, pt.y)
    self:addChild(self.fobid,1)
    self.fobid:runAction(transition.sequence({
        cc.DelayTime:create(0.5),
        cc.FadeOut:create(0.5),
        cc.CallFunc:create(function()
            self.fobid:removeFromParent()
            self.fobid = nil
        end)
    }))    
    --音效
    SoundManager.playSound(GAME_SOUND.Forbidden)
end

--关卡内测试按钮 体感技能，刷新英雄技能。
function PlayScene:addGameTestLayer()
    self.gameTestLayer = display.newNode():addTo(self, PlaySceneOrder.ui)
    --刷新技能
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "刷新技能",
            size = 20,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if self.skillLayer ~= nil then
                self.skillLayer:endProgress()
            end
        end)
        :pos(50, display.cy + 200)
        :addTo(self.gameTestLayer)
    --放沙尘暴
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "沙尘暴",
            size = 20,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            self:showStormLabel()
        end)
        :pos(50, display.cy + 150)
        :addTo(self.gameTestLayer)
end

function PlayScene:onTouchMoved(x, y)
    if self.towerLayer and self.towerLayer.selectedTower ~= nil then
        return self.towerLayer:onTouch("moved", x, y)
    end
end

function PlayScene:onTouchEnded(x, y)
    if self.towerLayer and self.towerLayer.movedTower ~= nil then
        local tilePt = MapInfo:getTilePositionInCCP(cc.p(x,y))
        local road = MapInfo:checkTileRoadValid(tilePt)
        local fort = self:getTileFort(tilePt)
        if fort ~= nil then
            self:showFobid(MapInfo:getCenterOfTile(tilePt))
        else
            --拖动放下直接参照移动时的判断能否造塔。
            if self.towerLayer.movedTower.canBuild then
                self:createNewFort(tilePt, self.towerLayer.preSelect, self.towerLayer.movedTower.leftRight)
            else
                self:showFobid(MapInfo:getCenterOfTile(tilePt))                        
            end
            if not self.giftLevel then
                self.towerLayer:selectTower(self.towerLayer.selectedTower)
            end
        end
    end
    if self.towerLayer then
        self.towerLayer:onTouch("ended", x, y)
    end
end

function PlayScene:onEnter()

        --厦门返回键
    if device.platform == "android" then
        self:performWithDelay(function()
            local layer = display.newLayer()
            layer:addNodeEventListener(cc.KEYPAD_EVENT, function(event)
                if event.key == "back" then
                    if gameState ~= "GAMEOVER" then
                        if self.task.taskLayer:isVisible() then
                            self.task:hide()
                        elseif gameState == "SETTING" then
                            self:SettingContinue()
                        elseif self.playSceneCanTouch then
                            self:setting()
                        end
                    elseif self.resultLayer.touchControl then--结算的延迟动作播完再响应返回
                        app:level()
                    end
                end
            end)
            self:addChild(layer)
            layer:setTouchSwallowEnabled(false)
            layer:setKeypadEnabled(true)
        end, 0.5)
    end  
        --厦门返回键

    -- 注册touch事件处理函数
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
        return self:onTouch(event.name, event.x, event.y)
    end)
    self.playSceneCanTouch = true
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)
    -- 注册帧事件处理函数
    --self.updateInterval = 1/60
    --self.callInterval = 0
    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
        self:update(dt) 
    end)
    self:scheduleUpdate()
end

function PlayScene:onExit()
    self:unscheduleUpdate()
    --self.touchLayer:removeAllEventListeners()
    if not self.isRestart then
        g_fightLayer = nil
        g_playScene = nil
        SoundManager.stopMusic(true)
        MapInfo:removeAll()
        --释放资源
        for k,v in pairs(self.res) do
            ResData.removeRes(v)
        end
        --display.removeUnusedSpriteFrames() 
        --CCTextureCache:sharedTextureCache():removeUnusedTextures()
    end
    --速度还原
    --cc.Director:sharedDirector:purgeDatacache()
    cc.Director:getInstance():getScheduler():setTimeScale(1) 
end

function PlayScene:RemoveActSprites(actSprite)
    for k, v in pairs(self.actSprites) do
        if actSprite == v then
            table.remove(self.actSprites, k)
            break
        end
    end
    actSprite:removeFromParent()
end

function PlayScene:onEnterForeground()
    print("PlayScene:onEnterForeground()")
    if NEW_GUIDE and self.newbieguidelayer then return end --新手引导时从后台返回不弹设置框。
    if self:isCanTouch() and gameState ~= "SETTING" and not self.pause then
        self:setting()
    end
end

function PlayScene:Restart()
    if (GameData.energy.value > 0 or (GameData.energy.value == -1)) or (kkFunc.checkTimer() and self:CalculateEnergy()) then
        self.isRestart = true
        SoundManager.stopMusic(true)
        MapInfo:removeAll()
        if self.isMoneyChanged then
            kkFunc.EnergyReduce()
        end
        app:realPlay({
                        level = self.level,
                        items = self.items,
                        loadType = "play"
                    })
    else
        self:EnergyLess()
    end
end

function PlayScene:Reborn()
    self.pause = false
    gameState = "NORMAL"
    local heartNum = MAX_HEART
    if VERSION_REDUCE then
        if self.items[2] == true then --守护点加血道具
            heartNum = heartNum + 2
        end
    end
    if GameData.selectHero == 4 then --第四个英雄另一个被动技能，守护点多3血。
        heartNum = heartNum + 3
    end
    self:setHeart(heartNum, true)
    local frame = display.newSpriteFrame("protectPoint.png")
    self.treaPic:setSpriteFrame(frame)
end

function PlayScene:EnergyLess()--体力不足弹出框
    local popLayer = display.newLayer()
    self:addChild(popLayer, 204)
    popLayer:setTouchSwallowEnabled(true)
    local grayBg = display.newColorLayer(cc.c4b(0,0,0,180)):addTo(popLayer)
    local popBg = display.newSprite("#poplayer.png",display.cx,display.cy):addTo(popLayer)
    local title = display.newSprite("#energyNotEnough.png",popBg:getContentSize().width/2,240):addTo(popBg)
    title:setScale(0.85)
    local text = cc.ui.UILabel.new({
    text = "体力不足",
    size = 28,
    color = cc.c3b(255,255,255),
    x = popBg:getContentSize().width/2,
    y = 150,
    }):align(display.CENTER):addTo(popBg)           
    self.sure = cc.ui.UIPushButton.new({
    normal = "#poplayerSure.png",
    disabled = "#poplayerSure.png",
    pressed = "#poplayerSure.png",
    })
    :onButtonPressed(function()
        self.sure:setScale(1.1)
        --音效
        SoundManager.playSound(GAME_SOUND.Button2)
    end)
    :onButtonRelease(function()
        self.sure:setScale(1)
    end)
    :onButtonClicked(function()           
        app:level({success = true})
    end)
    :pos(popBg:getContentSize().width/2, 55)
    :addTo(popBg)
    --音效
    SoundManager.playSound(GAME_SOUND.Menu)
end

function PlayScene:CalculateEnergy()--从LevelInfoLayer:showEnergyTime复制
    self.timeSec = 300
    local Sub = math.floor((kkFunc.getSystime() - GameData.energy.startTime)%300)
    self.timeSec = ((Sub>0) and (300 - Sub)) or 300
    local timeStr = kkFunc.getTimeLabelFromSecond(self.timeSec)
    self.num = math.floor((kkFunc.getSystime() - GameData.energy.startTime)/300)
    if (self.num<=5) and (self.num>0) then
        GameData.energy.value = GameData.energy.value + self.num
    elseif self.num >5 then
        GameData.energy.value = GameData.energy.value + 5
    end
    if self.num > 0 then
        GameData.energy.startTime = kkFunc.getSystime()
        GameState.save(GameData)
    end

    if GameData.energy.value > 5 then 
        GameData.energy.value = 5
        GameState.save(GameData)
    end

    if self.num > 0 then--有体力可回复
        return true
    end
    return false
end

--移动镜动的动作，对scene做不了了，但直接改PlayScene要改太多，
--所以把PlayScene改成node，加一个scene壳。
local PlaySceneShell = class("PlaySceneShell", function(params)
    local scene = display.newScene("PlaySceneShell")
    scene.layer = PlayScene.new(params)
    scene:addChild(scene.layer)
    return scene
end)

function PlaySceneShell:onEnterForeground()
    self.layer:onEnterForeground()
end

return PlaySceneShell
