--
-- Author: KK
-- Date: 2014-09-09 09:49:36
--
--兔子家

local http = require("framework.network")
local server = "http://211.151.176.56:8080/tower/gettime.php"

local LevelInfoLayer = import(".LevelInfoLayer")
local RabbitNest = import("..views.RabbitNest")
local RabbitList = import("..views.RabbitList")
local RabbitPreview = import("..views.RabbitPreview")
local GuideLayer = import("..views.GuideLayer")
local RabbitHouse = class("RabbitHouse", function()
    return display.newScene("RabbitHouse")
end)

function RabbitHouse:ctor()
    --[[if NEW_GUIDE and GameData.guide.step < 48 then
        if GameData.guide.step >= 37 then
        else
            GameData.rabbitHouse["n1"] = {state = "free"}
            GameData.myRabbit["r1"].level = 1
            GameData.myRabbit["r1"].upgrading = false
            self.guidelayer = GuideLayer.new(23)
            self:addChild(self.guidelayer,5)
        end
    end]]
    display.newColorLayer(cc.c4b(140,100,100,255))
        :addTo(self,-1)

    --资源
    ResData.loadRes("ROLE")
    ResData.loadRes("UI")
    --触摸层
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,5)

    --体力、萝卜、钻石
    self.infoLayer = LevelInfoLayer.new(2)
    self:addChild(self.infoLayer)

	--返回按钮
    self.menu = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "退出",
        }))
        :onButtonClicked(function()
            app:level()         
        end)
        :pos(50, display.height-50)
        :addTo(self)

    --选择养成时返回
    self.menu2 = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "返回",
        }))
        :onButtonClicked(function()
            self.nests[self.selectedNestIdx]:returnFromSelect()
            self:returnFromSelect()         
        end)
        :pos(50, display.height-50)
        :addTo(self,10)
        self.menu2:setVisible(false)

    --向左向右拉
    self.menuLeft = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "向左",
            size = 20,
            align = ui.TEXT_ALIGN_CENTER,
        }))
        :onButtonClicked(function()
            self:goLeft()         
        end)
        :pos(100, display.cy)
        :addTo(self)
        self.menuLeft:setVisible(false)
    self.menuRight = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "向右",
            size = 20,
            align = ui.TEXT_ALIGN_CENTER,
        }))
        :onButtonClicked(function()
            self:goRight()        
        end)
        :pos(display.width-100, display.cy)
        :addTo(self)    

    --标题
    self.title = cc.ui.UILabel.new({
    	text = "兔子家",
    	size = 80,
    	x = display.cx,
    	y = display.height-80,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self:addChild(self.title)

    self.nests = {}

    --显示窝
    self:showNests()

    --状态
    self.state = "main"
    self.selectedNestIdx = nil
    --显示从第几个到之后三个。只能是1到3
    self.firstIdx = 1

    --预览
    self.preview = nil

    --图鉴
    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "图鉴",
            align = ui.TEXT_ALIGN_CENTER,
            size = 60,
        }))
        :onButtonClicked(function()
            app:handbook()        
        end)
        :pos(display.width - 100, 80)
        :addTo(self)

    --计时器检查
    --[[
    testTime = testTime or 1
    testTime = testTime + 1
    if testTime == 3 then
        testTime = 1
        print("测试时间不对的情况。")
        GameData.timer.lastStartSystemTime = GameData.timer.lastStartSystemTime + 100
    end
    --]]

    local timeOK = kkFunc.checkTimer()

    if not timeOK then
        self:timerWrong()
    end
end

function RabbitHouse:timerWrong()
    for i = 1, #self.nests do
        self.nests[i]:setInvalid()
    end
    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt)
        self:update(dt)
    end)
    self:scheduleUpdate()
end

--如果联网刷新计时器。
function RabbitHouse:update(dt)
    local netOK = network.isLocalWiFiAvailable() or network.isInternetConnectionAvailable()
    if netOK then
        print("net ok...")
        local body,code = http.request(server)
        if code == 200 then
            kkFunc.fixTimer(body)
            for i = 1, #self.nests do
                self.nests[i]:setValid()
            end
            self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
            self:unscheduleUpdate()
        end
    end
end

function RabbitHouse:goLeft()
    if self.firstIdx <= 1 then return end

    for i = 1, 5 do
        local action
        if i == self.firstIdx - 1 then
            self.nests[i]:setVisible(true)
            self.nests[i]:setOpacity(0)
            action = transition.sequence({
                cc.Spawn:create(cc.FadeIn:create(0.2),
                    cc.MoveBy:create(0.2, cc.p(250,0)))
            })
        elseif i == self.firstIdx + 2 then
            action = transition.sequence({
                cc.Spawn:create(cc.FadeOut:create(0.2),
                    cc.MoveBy:create(0.2, cc.p(250,0))),
                cc.CallFunc:create(function()
                    self.nests[i]:setVisible(false)
                end)
            })
        else--if i == self.firstIdx or i == self.firstIdx + 1
            action = cc.MoveBy:create(0.2, cc.p(250,0))
        end
        self.nests[i]:runAction(action)
    end
    self.firstIdx = self.firstIdx - 1
    if self.firstIdx == 1 then 
        self.menuLeft:setVisible(false)
    end
    self:performWithDelay(function()
        self.menuRight:setVisible(true)
    end, 0.2)
end

function RabbitHouse:goRight()
    if self.firstIdx >= 3 then return end
    for i = 1, 5 do
        local action
        if i == self.firstIdx + 3 then
            self.nests[i]:setVisible(true)
            self.nests[i]:setOpacity(0)
            action = transition.sequence({
                cc.Spawn:create(cc.FadeIn:create(0.2),
                    cc.MoveBy:create(0.2, cc.p(-250,0)))
            })
        elseif i == self.firstIdx then
            action = transition.sequence({
                cc.Spawn:create(cc.FadeOut:create(0.2),
                    cc.MoveBy:create(0.2, cc.p(-250,0))),
                cc.CallFunc:create(function()
                    self.nests[i]:setVisible(false)
                end)
            })
        else--if i == self.firstIdx or i == self.firstIdx + 1
            action = cc.MoveBy:create(0.2, cc.p(-250,0))
        end
        self.nests[i]:runAction(action)
    end
    self.firstIdx = self.firstIdx + 1
    if self.firstIdx == 3 then 
        self.menuRight:setVisible(false)
    end
    self:performWithDelay(function()
        self.menuLeft:setVisible(true)
    end, 0.2)
end

function RabbitHouse:showNests()
    local nestNumber = GameData.rabbitHouse.nestNumber
    for i = 1, 5 do
        self:addNest(i)
    end
    self.nests[4]:setVisible(false)
    self.nests[5]:setVisible(false)
end

--加窝
function RabbitHouse:addNest(idx)
    local params = GameData.rabbitHouse["n"..idx]

    self.nests[idx] = RabbitNest.new({
        parent = self,
        idx = idx,
    })
    self:addChild(self.nests[idx],10)

    self.nests[idx]:setPosition(cc.p(display.cx+(idx-2)*250,200))
end

--给空窝选兔子
function RabbitHouse:selectRabbitForNest(idx)
    if self.state ~= "main" then return end
    self.menu:setVisible(false)
    self.menu2:setVisible(true)

    self.menuLeft:setVisible(false)
    self.menuRight:setVisible(false)
    for i = 1, #self.nests do
        if i ~= idx then
            self.nests[i]:setVisible(false)
        end
    end
    self.nests[idx].menu:setVisible(false)
    local x,y = self.nests[idx]:getPosition()
    self.selectMoveDx = display.cx-x
    self.nests[idx]:runAction(transition.sequence({
        cc.MoveBy:create(math.abs(self.selectMoveDx)/1250, cc.p(self.selectMoveDx,0)),
        cc.CallFunc:create(function()
            self:showRabbitList()
        end)
    }))
    self.selectedNestIdx = idx
    
    --print("selectNest", idx,x,y)
end

--显示兔子列表
function RabbitHouse:showRabbitList()
    self.state = "select"
    self.rabbitList = RabbitList.new(function(idx)
        self:showRabbitOnSelectedNest(idx)
    end)
    self:addChild(self.rabbitList)
    self.rabbitList:ignoreAnchorPointForPosition(true)
    self.rabbitList:setAnchorPoint(cc.p(0.5,0.5))
    self.rabbitList:setPosition(cc.p(display.cx-280,display.cy))

    --预览
    self.preview = RabbitPreview.new()
    self.preview:setPosition(cc.p(display.cx + 280 - 150, display.cy-220))
    self:addChild(self.preview)
end

--从选择状态返回
function RabbitHouse:returnFromSelect()
    self.state = "lock"
    local nest = self.nests[self.selectedNestIdx]
    --self.rabbitList:setVisible(false)
    self.rabbitList:removeFromParent()
    self.rabbitList = nil
    self.preview:removeFromParent()
    self.preview = nil

    self.menu2:setVisible(false)
    self.menu:setVisible(true)
    for i = 1, #self.nests do
        if i ~= self.selectedNestIdx then
            if i >= self.firstIdx and i <= self.firstIdx+2 then
                self.nests[i]:performWithDelay(function()
                    self.nests[i]:setVisible(true)
                end,0.2)
            end
        end
    end
    local x,y = nest:getPosition()
    nest:runAction(transition.sequence({
        cc.MoveBy:create(math.abs(self.selectMoveDx)/1250, cc.p(-self.selectMoveDx,0)),
        cc.CallFunc:create(function()
            self.state = "main"
            self.selectedNestIdx = nil
            if self.firstIdx > 1 then
                self.menuLeft:setVisible(true)
            end
            if self.firstIdx < 3 then
                self.menuRight:setVisible(true)
            end
        end)
    }))

end

--选中兔子时展示在窝里
function RabbitHouse:showRabbitOnSelectedNest(idx)
    local nest = self.nests[self.selectedNestIdx]
    nest:selectRabbit(idx)
    self.preview:setRabbit(idx)
end

function RabbitHouse:startUpgrade()
    self:returnFromSelect()
end

function RabbitHouse:onTouch(event, x, y)
    if self.rabbitList ~= nil and self.rabbitList:isVisible() then

        return self.rabbitList:onTouch(event,x,y)
    end
end

function RabbitHouse:onEnter()
    -- 注册touch事件处理函数
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)
end

function RabbitHouse:onExit()

end

return RabbitHouse