--
-- Author: KK
-- Date: 2014-09-01 17:00:40
--
--火球

local MapInfo = import("..views.MapInfo")

local Fireball = class("Fireball", function()
	return display.newNode()
end)

function Fireball:ctor(params)
    self.fire = display.newSprite("#s05_move_1.png")
    self.fire:setVisible(false)
	self.fire:setAnchorPoint(cc.p(0.5,0.1))
    self:addChild(self.fire)
	self.from = params.from
	self.to = params.to
	self.time = params.time
	self.delay = params.delay
	self.onlyShow = params.onlyShow

	self.passTime = 0
	self.pos = self.from
	self.speedX = (self.to.x-self.from.x)/self.time
	self.speedY = (self.to.y-self.from.y)/self.time
	self.moved = false
	self.exploded = false

	--计算火球角度
	local at = math.atan2(self.from.y-self.to.y,self.from.x-self.to.x)
	local angle = 180*at/math.pi
	--print(self.from.y-self.to.y, self.from.x-self.to.x, at, angle)
	self.fire:setRotation(90-angle)

	self:setPosition(self.from)
	--[[
	self:runAction(transition.sequence({
		cc.DelayTime:create(self.delay),
		cc.MoveTo:create(self.time, self.to),
		cc.CallFunc:create(function()
			self:explode()
		end),
	}))]]
end

function Fireball:update(dt)
	if self.exploded then return end
	self.passTime = self.passTime + dt
	if self.passTime < self.delay then
		return
	elseif not self.moved then
		self.moved = true
		self.fire:setVisible(true)
		local fireMoveAct = display.getAnimationCache("h02_s05_move")
		self.fire:playAnimationOnce(fireMoveAct)
	end

	if self.passTime > self.delay + self.time then
		self.exploded = true
		self:explode()
		return
	end

	self.pos.x = self.pos.x + self.speedX * dt
	self.pos.y = self.pos.y + self.speedY * dt
	self:setPosition(self.pos)
end

function Fireball:explode()
	--self:stopAllActions()
	local explodePic = display.newSprite("#s05_explode_1.png",0,0)
    --explodePic:setScale(1.2)
	self:addChild(explodePic)
	self.explodeAct = display.getAnimationCache("h02_s05_explode")
	explodePic:playAnimationOnce(self.explodeAct, false, function()
		self:afterExplode()
	end)

	if not self.onlyShow then
		local enemies = g_fightLayer:getEnimiesAroundPos(self.to, math.pow(MapInfo.tileSize*2,2))
		for i = 1, #enemies do
			enemies[i]:updateHp(-100)
		end
	end
end

function Fireball:afterExplode()
	g_fightLayer:removeFireball(self)
	self:removeFromParent()
end

return Fireball