--
-- Author: KK
-- Date: 2014-10-08 15:36:36
--
--处理随机礼盒

local Gift = import(".Gift")

local GiftManager = class("GiftManager")

function GiftManager:ctor(level)
	self.level = level
end

function GiftManager:init()
	self.waves = {}
	for i = 1, #LevelsData[self.level].waves do
		if LevelsData[self.level].waves[i].giftRandom ~= nil then
			self:getRandomSubWaves(i, LevelsData[self.level].waves[i])
		end
	end
end

function GiftManager:getRandomSubWaves(waveNum, wave)
	self.waves[waveNum] = {}
	local giftRandom = wave.giftRandom
	local randomCount = #giftRandom
	local subWaveCount = #wave
	if randomCount < subWaveCount then
		print("randomWave cant smaller than subWaves")
	end
	local tmp = {}
	--可选列表
	for i = 1, randomCount do
		tmp[i] = i
	end
	--随机选出子波数组列表
	for i = 1, subWaveCount do
		local idx = math.random(i,#tmp)
		local matchIdx = tmp[idx]
		tmp[idx] = tmp[i]
		tmp[i] = matchIdx
		self.waves[waveNum][i] = self:getSingleRandomWave(giftRandom[matchIdx])
		--print("wave:",waveNum," subWave:",i)
		--dump(self.waves[waveNum][i])
	end
end

--选取一个列表打乱
function GiftManager:getSingleRandomWave(towerAndEnemy)
	local enemy = {}
	for i = 1, #towerAndEnemy.tower do
		enemy[#enemy+1] = "T"..towerAndEnemy.tower[i]
	end
	for i = 1, #towerAndEnemy.enemy do
		enemy[#enemy+1] = "E"..towerAndEnemy.enemy[i]
	end
	for i = 1, #enemy-1 do
		local idx = math.random(i,#enemy)
		local tmp = enemy[idx]
		enemy[idx] = enemy[i]
		enemy[i] = tmp
	end
	return enemy
end

--后三个参数用不到，因为一开始就排好了出怪内容。
function GiftManager:addGift(start, enIdx, enHp, wayIdx, speed, waveIdx, subWaveIdx, count)
	--print(waveIdx, subWaveIdx, count)
    local gift = Gift.new({
        giftIdx = enIdx,
        enHp = enHp,
        wayIdx = wayIdx,
        speed = speed,
    })
    gift:setPosition(start)
    g_fightLayer:addGift(gift)
end

return GiftManager