--
-- Author: KK
-- Date: 2014-04-23 09:55:57
--

--因为要放在batchNode上，不同大图上的要分开。
HPBAR_TYPE_FORT = 1
HPBAR_TYPE_FORT_ANGER = 2
HPBAR_TYPE_ENEMY = 3
HPBAR_TYPE_THING = 4
HPBAR_TYPE_HERO = 5
HPBAR_TYPE_HERO_HEAD = 6
HPBAR_TYPE_OTHER = 7
HPBAR_TYPE_City = 8

local HpBar = class("HpBar", function(barType, size, maxHp, pos)
	if barType == HPBAR_TYPE_FORT 
			or barType == HPBAR_TYPE_FORT_ANGER then
		return display.newSprite("#hpBar_bg.png")
	elseif barType == HPBAR_TYPE_ENEMY then
		return display.newSprite("#hp_bar_red.png")
	elseif barType == HPBAR_TYPE_HERO_HEAD then
		return display.newSprite("#hpBar_bg.png")
	elseif barType == HPBAR_TYPE_HERO then
		return display.newSprite("#heroHpBg.png")
	elseif barType == HPBAR_TYPE_City then
		return display.newSprite("#ui_hpBar_Bottom.png")	
	else
		return display.newSprite("#hpBar_bg.png")
	end
end)

function HpBar:ctor(barType, size, maxHp, pos)
	--如果用updateHpCent直接给百分比，就不用最大血量。
	self.maxHp = maxHp or 100
	local x, y = 0, 0
	if pos ~= nil then
		x = pos.x
		y = pos.y
	end
	self.type = barType
	if self.type == HPBAR_TYPE_FORT 
			or self.type == HPBAR_TYPE_FORT_ANGER then
		self.hp2 = display.newSprite("#hpBar_front.png")
	elseif self.type == HPBAR_TYPE_ENEMY then
		self.hp2 = display.newSprite("#hp_bar_green.png")
		self.hp2:setPosition(1,1)
	elseif self.type == HPBAR_TYPE_HERO_HEAD then
		self.hp2 = display.newSprite("#heroHeadHp.png")
		self.hp2:setPosition(1,1)
	elseif self.type == HPBAR_TYPE_HERO then
		self.hp2 = display.newSprite("#heroHp.png")
		self.hp2:setPosition(1,0)
	elseif self.type == HPBAR_TYPE_City then
		self.hp2 = display.newSprite("#ui_hpBar_Up.png")
		self.hp2:setPosition(0,6)
	else
		self.hp2 = display.newSprite("#hpBar_front.png")
		self.hp2:setPosition(1,1)
	end
	self.hp2:setAnchorPoint(cc.p(0,0))
	self:addChild(self.hp2)

	self.rect = self.hp2:getTextureRect()
	self.MinX = self.rect.x
	self.MinY = self.rect.y
	self.rotated = self.hp2:isTextureRectRotated()

	self.standWidth = self.hp2:getContentSize().width
	self.standHeight = self.hp2:getContentSize().height
	--local scale = size.width/self.standWidth
	--self:setScaleX(scale)
	--self:setAnchorPoint(cc.p(0,0.5))
	if self.type == HPBAR_TYPE_FORT then
		self:setPosition(cc.p(x, y+size.height*0.5))
	elseif self.type == HPBAR_TYPE_FORT_ANGER then
		local scale = size.height/self.standWidth*0.8
		self:setScaleX(scale)
		self:setRotation(270)
		self:setPosition(x+size.width*0.5,y-size.height*0.4)
	elseif self.type == HPBAR_TYPE_HERO_HEAD then
		self:setPosition(cc.p(x, y+size.height))
	elseif self.type == HPBAR_TYPE_City then
		self:setPosition(cc.p(x, y))
		self.standWidth = self.standWidth - 30		
	else
		self:setPosition(cc.p(x+size.width*0.5, y+size.height))
	end
end

function HpBar:setMaxHP(hp)
	self.maxHp = hp
	if self:isVisible() then
		self:updateHp(hp)
	end
end

function HpBar:updateHp(hp)
	local hpCent = hp / self.maxHp
	self:updateHpCent(hpCent)
end

function HpBar:updateHpCent(cent)
	if not self:isVisible() then
		self:setVisible(true)
	end
	--怒气条不隐藏
	if self.type ~= HPBAR_TYPE_FORT_ANGER
			and self.type ~= HPBAR_TYPE_HERO then			
		if self.type ~= HPBAR_TYPE_HERO_HEAD or cent > 0.5 then --英雄少于一半血一直显示
			self:stopAllActions()
			if self.type ~= HPBAR_TYPE_City then 
			    self:performWithDelay(function() self:setVisible(false) end, 3)
			end
		end
	end

	if self.type == HPBAR_TYPE_City then
		self.hp2:setPosition(15,18)
	end

	self.rect.width = self.standWidth*cent
	self.hp2:setTextureRect(self.rect,self.rotated,cc.size(self.rect.width, self.rect.height))
	--[[
	if not self.rotated then
		self.rect.width = self.standWidth*cent
		--self.rect:setRect(self.MinX, self.MinY, self.standWidth*cent, self.standHeight)
		self.hp2:setTextureRect(self.rect,false,cc.size(self.rect.width, self.rect.height))
	else
		self.rect.width = self.standWidth*cent
		--self.rect:setRect(self.MinX, self.MinY, self.standWidth*cent, self.standHeight)
		self.hp2:setTextureRect(self.rect,true,cc.size(self.rect.width, self.rect.height))
	end
	--]]
end

return HpBar