--
-- Author: Wangzhihao
-- Date: 2015-09-01 17:46:25
--
local PurchaseItemLayer = class("PurchaseItemLayer", function()
	if VERSION_REDUCE then
		return display.newSprite("#pre_taskBg.png")
	else
		return display.newSprite("#purchaseItemBag.png")
	end
end)

function PurchaseItemLayer:ctor()
    local itemBgX,itemBgY
    if VERSION_REDUCE then
    	itemBgX = display.cx - 200
    	itemBgY = display.cy - 30
    else
    	itemBgX = display.cx
    	itemBgY = display.cy
        --cancle
        self.cancle = cc.ui.UIPushButton.new({
            normal = "#buttonCancel.png",
            pressed = "#buttonCancel.png",
            disabled = "#buttonCancel.png",
        })
        :onButtonPressed(function()
            self.cancle:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button1)
        end)
        :onButtonRelease(function()
            self.cancle:setScale(1)
        end)
        :onButtonClicked(function()
            if g_playScene.skillLayer.paused then
                g_playScene:suspend(true)
            end
            g_playScene.skillLayer.itemLayer:setVisible(false)  
        end)
        :pos(self:getContentSize().width-20, self:getContentSize().height-55)  
        self:addChild(self.cancle)
        --coinNum
        self.coinNum = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = ""..GameData.carrot,
            size = 20,
            color = cc.c3b(255,255,255),
            x = self:getContentSize().width/2 -90,
            y = self:getContentSize().height - 96,
            }):align(display.LEFT_TOP)
        self:addChild(self.coinNum)
        --diamondNum
        self.diamondNum = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = ""..GameData.diamond,
            size = 20,
            color = cc.c3b(255,255,255),
            x = self:getContentSize().width/2 +80,
            y = self:getContentSize().height - 96,
            }):align(display.LEFT_TOP)
        self:addChild(self.diamondNum)
    end
    self:setPosition(itemBgX,itemBgY)
    if VERSION_REDUCE then
        self:setVisible(false)
    end
    if VERSION_REDUCE then
        local itemBarBg = display.newScale9Sprite("#pre_itemBarBg.png",215,243,cc.size(378,402))
        self:addChild(itemBarBg)
        local itemLabel = display.newSprite("#pre_itemLabel.png",self:getContentSize().width/2,500)
        self:addChild(itemLabel)
        --滑动箭头指示
        self.itemUp = display.newSprite("#pre_itemUp.png",self:getContentSize().width/2,455)
        self:addChild(self.itemUp)
        self.itemUp:setVisible(false)
        self.itemDown = display.newSprite("#pre_itemDown.png",self:getContentSize().width/2,30)
        self:addChild(self.itemDown)
        self.itemDown:setVisible(false)
        --
    end   
    
    self.contentlayer = display.newLayer()
    self.contentlayer:setContentSize(cc.size(self:getContentSize().width*9/10, 400))
    self.singleItemBg = {}
    self.itemIcon = {}
    self.titleNum = {}
    self.button = {}
    self.itemNumBg = {}
    local buttonText = ""
    for i = 1, 4 do
        self.singleItemBg[i] = display.newSprite("#pre_itemSingleBg.png")
        self.singleItemBg[i]:setAnchorPoint(0,0)
        self.singleItemBg[i]:setPosition(15,390-99*i)
        self.contentlayer:addChild(self.singleItemBg[i],2) 
        if not VERSION_REDUCE and not GameData.item["i"..i].isUnLock then
            local grayLayer = display.newSprite("#unlockLayer.png",15,390-99*i)
            grayLayer:setAnchorPoint(0,0)
            self.contentlayer:addChild(grayLayer,5) 
        end
        self.itemIcon[i] = display.newSprite("#"..ItemData[i].pic,53,53)
        if not VERSION_MONSTER then
            if i == 1 then
                self.itemIcon[i]:setPosition(53,57)
            end
        end
        self.singleItemBg[i]:addChild(self.itemIcon[i])
        if VERSION_REDUCE then
            if GameData.item["i"..i].number == 0 then
                buttonText = "#pre_itemPurchase.png"
            else
                buttonText = "#pre_itemUse.png"
            end
        else
            buttonText = "#pre_itemPurchase.png"
        end
        local price
        if VERSION_REDUCE then
            price = ItemData[i].moneyOverSeas
        else
            price = ItemData[i].money
        end
        if GameData.selectHero == 2 then --第二英雄被动技能，道具便宜一半
            price = price * 0.5
        end
        self.button[i] = cc.ui.UIPushButton.new({
                normal = buttonText,
                pressed = buttonText,
                disabled = buttonText,
            })
            :onButtonPressed(function()
                self.button[i]:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button1)
            end)
            :onButtonRelease(function()
                self.button[i]:setScale(1)
            end)
            :onButtonClicked(function()
                if VERSION_REDUCE then
                    if GameData.item["i"..i].number == 0 then                  
                        if GameData.carrot >= price then               
                            GameData.carrot = GameData.carrot - price
                            g_infoLayer.carrotLabel:setString(""..GameData.carrot)
                            self.button[i]:setButtonImage("normal", "#pre_itemUse.png")
                            self.button[i]:setButtonImage("disabled", "#pre_itemUse.png")
                            self.button[i]:setButtonImage("pressed", "#pre_itemUse.png")
                            GameData.item["i"..i].number = GameData.item["i"..i].number + 1
                            self.titleNum[i]:setString(""..GameData.item["i"..i].number)
                            self.itemNumBg[i]:setVisible(true)    
                            AchievementData.checkItem()
                            AchievementData.checkUseMoney(price)
                            --DataEye
                            local itemId
                            if i == 1 then
                                itemId = "圣水"
                            elseif i == 2 then
                                itemId = "守护石"
                            elseif i == 3 then
                                itemId = "复活石"
                            elseif i == 4 then
                                itemId = "时间沙漏"
                            end
                                 --厦门
                            -- if device.platform == "android" or device.platform == "ios" then
                            --     DCItem.buy(itemId, "消耗品", 1, price, "金币")
                            --     --虚拟比统计
                            --     DCCoin.lost("购买道具", "金币", price, GameData.carrot)
                            -- end
                                 --厦门
                        else
                            if VERSION_REDUCE then
                                g_infoLayer:popLayer("金币")
                            else
                                --厦门修改
                                 g_infoLayer:popLayer("金币")
                                -- if kkFunc.simplifyPurchaseSwitch() then
                                --     kkFunc.simplifyPurchaseSdkCallBackCoin(7)
                                -- else
                                --     g_infoLayer:popLayer("金币")
                                -- end
                                --厦门修改

                            end
                        end
                    else
                        GameData.item["i"..i].number = GameData.item["i"..i].number - 1
                        if GameData.item["i"..i].number == 0 then
                            self.button[i]:setButtonImage("normal", "#pre_itemPurchase.png")
                                self.button[i]:setButtonImage("disabled", "#pre_itemPurchase.png")
                                self.button[i]:setButtonImage("pressed", "#pre_itemPurchase.png")
                            self.itemNumBg[i]:setVisible(false)
                        else
                            self.titleNum[i]:setString(""..GameData.item["i"..i].number)
                        end
                        AchievementData.checkUseItem()
                        self:useItem(i)   
                        --DataEye
                             --厦门
                        -- local itemId = kkFunc.getVersionPrepareText("道具",i)
                        -- if device.platform == "android" or device.platform == "ios" then
                        --     DCItem.consume(itemId, "消耗品", 1, "更快通关")
                        -- end    
                             --厦门             
                    end
                else            
                    if i == 3 or i == 4 then
                        if GameData.diamond >= price then
                            if GameData.item["i"..i].number >= 100 then 
                                local titleNum = cc.ui.UILabel.new({
                                    UILabelType = 2,
                                    font = "fontCommon.TTF",
                                    text = "道具数量已达上限",
                                    color = cc.c3b(255,0,0),
                                    size = 32,
                                    x = display.cx,
                                    y = display.cy,
                                    }):align(display.CENTER)
                                g_playScene:addChild(titleNum,50000)
                                titleNum:runAction(transition.sequence({
                                        cc.DelayTime:create(1),
                                        cc.FadeOut:create(0.5)
                                    }))
                            else
                                if GameData.item["i"..i].number == 0 then
                                    g_playScene.skillLayer.itemNumBgBar[i]:setVisible(true)
                                end
                                GameData.diamond = GameData.diamond - price
                                self.diamondNum:setString(""..GameData.diamond)
                                GameData.item["i"..i].number = GameData.item["i"..i].number + 1
                                self.titleNum[i]:setString(""..GameData.item["i"..i].number)
                                g_playScene.skillLayer.itemNum[i]:setString(""..GameData.item["i"..i].number)
                                self.itemNumBg[i]:setVisible(true)
                                AchievementData.checkItem()
                                AchievementData.checkDiamond(price)
								--DataEye
                                     --厦门
                                -- if device.platform == "android" or device.platform == "ios" then
                                --     local itemId
                                --     if i == 3 then
                                --         itemId = "复活石"
                                --     elseif i == 4 then
                                --         itemId = "狂暴"
                                --     end
                                --     DCItem.buy(itemId, "消耗品", 1, price, "钻石")
                                --     --虚拟比统计
                                --     DCCoin.lost("购买道具", "钻石", price, GameData.diamond)
                                -- end
                                     --厦门
                            end
                        else
                            if VERSION_REDUCE then
                                kkFunc.popLayer("钻石")
                            else
                                --厦门修改
                                kkFunc.popLayer("钻石")
                                -- if kkFunc.simplifyPurchaseSwitch() then
                                --     kkFunc.simplifyPurchaseSdkCallBack(5)
                                -- else
                                --     kkFunc.popLayer("钻石")
                                -- end
                                --厦门修改
                            end
                        end
                    else
                        if GameData.carrot >= price then 
                            if GameData.item["i"..i].number >= 100 then 
                                local titleNum = cc.ui.UILabel.new({
                                    UILabelType = 2,
                                    font = "fontCommon.TTF",
                                    text = "道具数量已达上限",
                                    color = cc.c3b(255,0,0),
                                    size = 32,
                                    x = display.cx,
                                    y = display.cy,
                                    }):align(display.CENTER)
                                g_playScene:addChild(titleNum,50000)
                                titleNum:runAction(transition.sequence({
                                        cc.DelayTime:create(1),
                                        cc.FadeOut:create(0.5)
                                    }))
                            else  
                                if GameData.item["i"..i].number == 0 then
                                    g_playScene.skillLayer.itemNumBgBar[i]:setVisible(true)
                                end            
                                GameData.carrot = GameData.carrot - price
                                self.coinNum:setString(""..GameData.carrot)
                                GameData.item["i"..i].number = GameData.item["i"..i].number + 1
                                self.titleNum[i]:setString(""..GameData.item["i"..i].number)
                                g_playScene.skillLayer.itemNum[i]:setString(""..GameData.item["i"..i].number)
                                self.itemNumBg[i]:setVisible(true)    
                                AchievementData.checkItem()
                                AchievementData.checkUseMoney(price)
                                --DataEye
                                     --厦门
         --                        if device.platform == "android" or device.platform == "ios" then
									-- local itemId
         --                            if i == 1 then
         --                                itemId = "圣水"
         --                            elseif i == 2 then
         --                                itemId = "牛奶"
         --                            end
									-- DCItem.buy(itemId, "消耗品", 1, price, "金币")
									-- --虚拟比统计
									-- DCCoin.lost("购买道具", "金币", price, GameData.carrot)
         --                        end
                                     --厦门
                            end
                        else
                            if VERSION_REDUCE then
                               kkFunc.popLayer("金币")
                            else
                                --厦门修改
                                kkFunc.popLayer("金币")
                                -- if kkFunc.simplifyPurchaseSwitch() then
                                --     kkFunc.simplifyPurchaseSdkCallBackCoin(7)
                                -- else
                                --     kkFunc.popLayer("金币")
                                -- end
                                --厦门修改
                            end
                        end
                    end
                end
                GameState.save(GameData)             
            end)
            :pos(self:getContentSize().width - 125,52.5)
            :addTo(self.singleItemBg[i]) 
        if not VERSION_REDUCE then
            if not GameData.item["i"..i].isUnLock then
                self.button[i]:setButtonEnabled(false)
            end
        end   
        local moneyPic
        if VERSION_REDUCE then
            moneyPic = "#"..ItemData[i].moneyOverSeasPic
        else
            moneyPic = "#"..ItemData[i].moneyPic
        end
        local moneyIcon = display.newSprite(moneyPic,self:getContentSize().width/4-1,71)
        if VERSION_REDUCE then
            moneyIcon:setScale(0.4)
        else
            if i == 1 or i == 2 then
                moneyIcon:setScale(0.4)
            end
        end
        self.singleItemBg[i]:addChild(moneyIcon)
        local mX,mY
        local numX
        local fontType
        local fontColor
        local mesX,mesY
        if VERSION_REDUCE then 
            mX = 12
            mY = 72
            numX = 55
            fontType = "fontEasy.ttf"
            fontColor = cc.c3b(108,83,42)
            mesX = self:getContentSize().width/4-20
            mesY = 60
        else
            mX = 12
            mY = 72
            numX = 55
            fontType = "fontCommon.TTF"
            fontColor = cc.c3b(108,83,42)
            mesX = self:getContentSize().width/4-10
            mesY = 55
        end 

        local needMoney = cc.ui.UILabel.new({
            font = fontType,
            text = price,
            size = 18,
            textAlign = ui.TEXT_ALIGN_LEFT,
            color = cc.c3b(255,255,255),
            x = self:getContentSize().width/4 +mX,
            y = mY,
            })
        self.singleItemBg[i]:addChild(needMoney)       
        --图标上背景和数量
        self.itemNumBg[i] = display.newSprite("#pre_itemNumBg.png",5,numX)
        self.itemIcon[i]:addChild(self.itemNumBg[i])
        self.titleNum[i] = cc.ui.UILabel.new({
            text = GameData.item["i"..i].number,
            size = 20,
            color = cc.c3b(255,255,255),
            x = self.itemNumBg[i]:getContentSize().width/2,
            y = self.itemNumBg[i]:getContentSize().height/2,
            }):align(display.CENTER)
        self.itemNumBg[i]:addChild(self.titleNum[i])
        if GameData.item["i"..i].number == 0 then
            self.itemNumBg[i]:setVisible(false)
        end
        local itemMes
        if VERSION_REDUCE then
            itemMes = cc.ui.UILabel.new({
                UILabelType = 2,
                font = fontType,
                text = kkFunc.getVersionPrepareText("道具信息",i),
                size = 14,--旧18
                dimensions = cc.size(170, 60),
                color = fontColor,
                x = mesX,
                y = mesY--旧58
            }):align(display.LEFT_TOP)
        else
            itemMes = cc.ui.UILabel.new({
                UILabelType = 2,
                font = fontType,
                text = kkFunc.getVersionPrepareText("道具信息",i),
                size = 15,--旧18
                color = fontColor,
                x = mesX,
                y = mesY--旧58
            }):align(display.LEFT_TOP)
        end         
        self.singleItemBg[i]:addChild(itemMes)   
    end

    self:getScrollView()
end
function PurchaseItemLayer:getScrollView()
	--
    self.scrollView = cc.ui.UIScrollView.new({})   
    self.scrollView:setColor(cc.c3b(230,143,233))
    self.scrollView:setTouchSwallowEnabled(true)
    local screenSize = cc.Director:getInstance():getWinSize()
    local function scrollView1DidScroll(event)
       --local cp = self.scrollView:getContentOffset()
        if event.name == "moved" then
            --self.preChoose = nil
        end
    end
    local function scrollView1DidZoom()
        --print("scrollView1DidZoom")
    end
    local csize = self.contentlayer:getContentSize()
    if nil ~= self.scrollView then
        local scrollSize = self.contentlayer:getBoundingBox()
        scrollSize.width = self:getContentSize().width
        scrollSize.height = 391
        self.scrollView:setViewRect(scrollSize)
        local sx,sy
        if VERSION_REDUCE then
            sx = 14
            sy = 47
        else
            sx = 18
            sy = 42
        end
        self.scrollView:setPosition(cc.p(sx,sy))
        self.scrollView:setScale(1.0)
        self.scrollView:addScrollNode(self.contentlayer)
        self.scrollView:setDirection(1)
        self.scrollView:setBounceable(true)
        self.scrollView:onScroll(scrollView1DidScroll)
    end
    self:addChild(self.scrollView,1)
end
function PurchaseItemLayer:useItem(idx)

end
return PurchaseItemLayer