--
-- Author: KK
-- Date: 2014-10-20 14:10:01
--管理员控制页，内部使用

local IceLayer = import("..views.IceLayer")
local AdminLayer = class("AdminLayer", function()
    return display.newLayer("AdminLayer")
end)

function AdminLayer:ctor()
	self:setTouchEnabled(true)
	self:setTouchSwallowEnabled(true)

	local bg = display.newColorLayer(cc.c4b(100,140,210,255))
	self:addChild(bg)

    cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "返回",
            size = 80,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            self:removeFromParent()             
        end)
        :pos(display.cx,display.cy-200)
        :addTo(self)

    local items = {}
    items[1] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "清空数据",
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            GameData = {}
            GameState.save(GameData)             
        end)
        :pos(display.cx,display.cy - 100)
        :addTo(self)

    local text = "开启倒计时"
    if COUNT_DOWN then
    	text = "关闭倒计时"
    end
    items[2] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if COUNT_DOWN then
                COUNT_DOWN = false
                items[2]:setButtonLabelString("normal","开启倒计时")
            else
                COUNT_DOWN = true
                items[2]:setButtonLabelString("normal","关闭倒计时")
            end             
        end)
        :pos(display.cx,display.cy - 50)
        :addTo(self)
    text = "开启移镜头"
    if MOVE_CAMERA then
    	text = "关闭移镜头"
    end
    items[3] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if MOVE_CAMERA then
                MOVE_CAMERA = false
                items[3]:setButtonLabelString("normal","开启移镜头")
            else
                MOVE_CAMERA = true
                items[3]:setButtonLabelString("normal","关闭移镜头")
            end           
        end)
        :pos(display.cx,display.cy)
        :addTo(self)

    text = "开启音效"
    if GameData.sound then
        text = "关闭音效"
    end
    items[4] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if GameData.sound then
                SoundManager.setSound(false)
                items[4]:setButtonLabelString("normal","开启音效")
            else
                SoundManager.setSound(true)
                items[4]:setButtonLabelString("normal","关闭音效")
            end        
        end)
        :pos(display.cx,display.cy + 50)
        :addTo(self)

    text = "开启音乐"
    if GameData.music then
        text = "关闭音乐"
    end
    items[5] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if GameData.music then
                SoundManager.setMusic(false)
                items[5]:setButtonLabelString("normal","开启音乐")
            else
                SoundManager.setMusic(true)
                items[5]:setButtonLabelString("normal","关闭音乐")
            end      
        end)
        :pos(display.cx,display.cy + 100)
        :addTo(self)

    text = "开启新手引导"
    if NEW_GUIDE then
        text = "关闭新手引导"
    end
    items[6] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if NEW_GUIDE then
                NEW_GUIDE = false
                items[6]:setButtonLabelString("normal","开启新手引导")
            else
                NEW_GUIDE = true
                items[6]:setButtonLabelString("normal","关闭新手引导")
            end    
        end)
        :pos(display.cx,display.cy + 150)
        :addTo(self)
    --[[self.menu = ui.newMenu(items)
    self:addChild(self.menu)
    self.menu:alignItemsVertically()
    self.menu:setPosition(cc.p(display.cx,display.cy+100))]]


    ResData.loadRes("SHAKE_ICE")
    items[7] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "测试冰1",
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            self:addChild(IceLayer.new(1))
        end)
        :pos(display.cx-200, display.cy + 150)
        :addTo(self)
    items[8] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "测试冰2",
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            self:addChild(IceLayer.new(2))
        end)
        :pos(display.cx-200, display.cy + 100)
        :addTo(self)
    items[9] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "测试冰3",
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            self:addChild(IceLayer.new(3))
        end)
        :pos(display.cx-200, display.cy + 50)
        :addTo(self)
    items[10] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "测试冰4",
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            self:addChild(IceLayer.new(4))
        end)
        :pos(display.cx-200, display.cy)
        :addTo(self)
    text = "开启所有关卡"
    if OPEN_LEVEL then
        text = "关闭所有关卡"
    end
    items[11] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if OPEN_LEVEL then
                for k,v in pairs(LevelsData) do
                    if k > 100 and k < 500 then
                        GameData.openlevel = k
                        if GameData.levelTask[""..k].star == 0 then
                            break 
                        end  
                    end
                end
                OPEN_LEVEL = false
                items[11]:setButtonLabelString("normal","开启所有关卡")
            else
                GameData.openlevel = 410
                OPEN_LEVEL = true
                items[11]:setButtonLabelString("normal","关闭所有关卡")
            end
            GameState.save(GameData)    
        end)
        :pos(display.cx+250,display.cy + 150)
        :addTo(self)
    text = "开启关卡内测试"
    if GAME_TEST then
        text = "关闭关卡内测试"
    end
    items[12] = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 40,
            align = ui.TEXT_ALIGN_CENTER,
            color = display.COLOR_BLACK,
        }))
        :onButtonClicked(function()
            if GAME_TEST then
                GAME_TEST = false
                items[12]:setButtonLabelString("normal","开启关卡内测试")
            else
                GAME_TEST = true
                items[12]:setButtonLabelString("normal","关闭关卡内测试")
            end
        end)
        :pos(display.cx+250, display.cy + 100)
        :addTo(self)
end

return AdminLayer