--
-- Author: Wangzhihao
-- Date: 2014-09-28 12:39:30
--
local DailyLogin_Message = {
	[1] = {
        pic = "#dailyLoginCoin.png",
        num = 100,
    },
	[2] = {
        pic = "#dailyLoginDiamond.png",
        num = 20,
    },
	[3] = {
        pic = "#dailyLoginCoin.png",
        num = 150,
    },
	[4] = {
        pic = "#dailyLoginDiamond.png",
        num = 30,
    },
	[5] = {
        pic = "#dailyLoginCoin.png",
        num = 200,
    },
	[6] = {
        pic = "#dailyLoginCoin.png",
        num = 300,
    },
	[7] = {
        pic = "#dailyLoginDiamond.png",
        num = 150,
    },
}
local DailyLogin_Secret = {
	[1] = "钻石×50",
	[2] = "萝卜×500",
	[3] = "急救包×20",
}
local GiftBagLayer = import("..views.GiftBagLayer")
local DailyLoginLayer = class("DailyLoginLayer",function() 
	return  display.newLayer("DailyLoginLayer") 
end)

function DailyLoginLayer:ctor()
    ResData.loadRes("UI_DAILYLOGIN")
    self:setNodeEventEnabled(true)
    local y = tonumber(os.date("%Y", os.time())) 
    local m = tonumber(os.date("%m", os.time()))
    local d = tonumber(os.date("%d", os.time()))
    self.y = y
    self.m = m
    self.d = d
    if GameData.login.year == 0 then
        GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        GameState.save(GameData)
    else

        if  self.d-GameData.login.day == 1  then 
                   
        elseif (self.d == 1 and GameData.login.day == 31 and  (GameData.login.month == 1 or 3 or 5 or 7 or 8 or 10 or 12))  then
        elseif  (self.d == 1 and GameData.login.day == 30 and  (GameData.login.month == 4 or 6 or 9 or 11))  then
        elseif (self.d == 1 and GameData.login.day == 29 and  GameData.login.month == 2 and ((GameData.login.year % 4 == 0 and GameData.login.year % 100 ~= 0 ) or GameData.login.year%400 == 0)) then
        elseif (self.d == 1 and GameData.login.day == 28 and  GameData.login.month == 2 and GameData.login.year % 4 ~= 0 ) then
        else 
            GameData.login.loginDay = 1
            GameState.save(GameData)
        end
        
    end
      
	self:show()
    
end

function DailyLoginLayer:onTouch(event, x, y)
	return true
end
function DailyLoginLayer:show()
    display.newColorLayer(cc.c4b(0,0,0,128)):addTo(self,-1)
    self.bg = display.newSprite("#dailyLoginBg.png", display.cx, display.cy - 20)
    self:addChild(self.bg)
    local height = self.bg:getContentSize().height
    local width = self.bg:getContentSize().width

    self.gifts = {}
    for i = 1, 7 do
        if i < GameData.login.loginDay then
            self.gifts[i] = display.newGraySprite("#dailyLoginBarYellow.png")
    	elseif i == GameData.login.loginDay then
            self.gifts[i] = display.newSprite("#dailyLoginBarYellow.png")
        else 
            self.gifts[i] = display.newSprite("#dailyLoginBarBlue.png")
    	end
    end
    local dis = (width - 600)/5
    local disH = (height - 300)/5
    for i = 1, 4 do
    	self.gifts[i]:setPosition(self.bg:getContentSize().width/2+(i-2.5)*185,350)
    	--self.gifts[i]:setContentSize(cc.size(150,150))
    	self.bg:addChild(self.gifts[i])
    end
    for i = 5, 7 do
    	self.gifts[i]:setPosition(self.bg:getContentSize().width/2+(i-6)*185,190)
    	--self.gifts[i]:setContentSize(cc.size(150,150))
    	self.bg:addChild(self.gifts[i])
    end
    
    for i = 1, 7 do
        local dayNum
        if i < GameData.login.loginDay then
            dayNum = display.newGraySprite("#dayNum"..i..".png")
            dayNum:setPosition(96,104)
        else
        	dayNum = display.newSprite("#dayNum"..i..".png",96,104)        
        end
        self.gifts[i]:addChild(dayNum,2)
        --sprite
        local giftsprite
        local giftNum
        if i < GameData.login.loginDay then
            giftsprite = display.newGraySprite(DailyLogin_Message[i].pic)
            giftsprite:setPosition(75,84)
        else
            giftsprite = display.newSprite(DailyLogin_Message[i].pic,75,84)        
        end
        --giftNum
        giftNum = cc.ui.UILabel.new({
            text = DailyLogin_Message[i].num,
            size = 30,
            x = 75,
            y = 27,
            color = cc.c3b(87,87,255),
            }):align(display.CENTER)
        self.gifts[i]:addChild(giftsprite)
        self.gifts[i]:addChild(giftNum)
        
        --已领取 
        if i < GameData.login.loginDay then
            local hasGifted = display.newSprite("#hasGifted.png",75,84)
            self.gifts[i]:addChild(hasGifted,3)
        elseif i == GameData.login.loginDay then
            local sprite = display.newSprite("#dailyLoginBlink1.png")
            sprite:setPosition(cc.p(self.gifts[i]:getContentSize().width/2,self.gifts[i]:getContentSize().height/2))
            self.gifts[i]:addChild(sprite)
            local frames = display.newFrames("dailyLoginBlink%d.png", 1, 8)
            local animation = display.newAnimation(frames, 0.1)
            sprite:playAnimationForever(animation)
            --[[local clickGifted = display.newSprite("#clickGifted.png",75,84)
            self.gifts[i]:addChild(clickGifted,3)]]
        end
    end

    --buymenu
    self.dailyLoginGiftButton = cc.ui.UIPushButton.new({
            normal = "#dailyLoginGiftButton.png",
            disabled = "#dailyLoginGiftButton.png",
            pressed = "#dailyLoginGiftButton.png",
        })
        :onButtonPressed(function()
            self.dailyLoginGiftButton:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.dailyLoginGiftButton:setScale(1)
        end)
        :onButtonClicked(function()
            self:getGift()           
        end)
        :pos(width/2,height/10)
        :addTo(self.bg)
    
    self:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self:setTouchEnabled(true)
    self:setTouchSwallowEnabled(true)

    --音效
    SoundManager.playSound(GAME_SOUND.Menu)
end
function DailyLoginLayer:getGift()
    local money
	if GameData.login.loginDay == 1 then
        GameData.login.loginDay = GameData.login.loginDay + 1
		GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        money = 100
        GameData.carrot = GameData.carrot + money
		g_infoLayer:refresh()		
	elseif GameData.login.loginDay == 2 then
        GameData.login.loginDay = GameData.login.loginDay + 1
		GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        money = 20
		GameData.diamond = GameData.diamond + money
		g_infoLayer:refresh()
	elseif GameData.login.loginDay == 3 then
        GameData.login.loginDay = GameData.login.loginDay + 1
		GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        money = 150
		GameData.carrot = GameData.carrot + money
		g_infoLayer:refresh()
	elseif GameData.login.loginDay == 4 then
        GameData.login.loginDay = GameData.login.loginDay + 1
		GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        money = 30
        GameData.diamond = GameData.diamond + money
        g_infoLayer:refresh()
	elseif GameData.login.loginDay == 5 then
        GameData.login.loginDay = GameData.login.loginDay + 1
		GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        money = 200
		GameData.carrot = GameData.carrot + money
		g_infoLayer:refresh()
	elseif GameData.login.loginDay == 6 then
        GameData.login.loginDay = GameData.login.loginDay + 1
		GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        money = 300
		GameData.carrot = GameData.carrot + money
		g_infoLayer:refresh()
	elseif GameData.login.loginDay == 7 then
		GameData.login.loginDay = 1
        GameData.login.year = self.y
        GameData.login.month = self.m
        GameData.login.day = self.d
        money = 150
        GameData.diamond = GameData.diamond + money
		g_infoLayer:refresh()
	end
    if NEW_GUIDE and (not GameData.guide.level3) and GameData.openlevel == 103 then
        if not MI_SERVICE then
            self.giftBag = GiftBagLayer.new(2)
            display.getRunningScene():addChild(self.giftBag,21)
        end
        GameData.guide.level3 = true
        GameState.save(GameData)
    end
    --DataEye
         --厦门
    -- if device.platform == "android" or device.platform == "ios" then
    --     if GameData.login.loginDay == 2 or GameData.login.loginDay == 4 or GameData.login.loginDay == 7 then
    --         DCCoin.gain("每日登陆获得钻石", "钻石", money, GameData.diamond)
    --     else
    --         DCCoin.gain("每日登陆获得金币", "金币", money, GameData.carrot)
    --     end           
    -- end
         --厦门
    self:performWithDelay(function()
        self:removeFromParent()
    end, 0.1)	
end
function DailyLoginLayer:onExit()
    ResData.removeRes("UI_DAILYLOGIN")       
end
return DailyLoginLayer