--
-- Author: KK
-- Date: 2014-11-28 13:40:40
--主题场景上的对话框
local DialogLayer = class("DialogLayer",function() 
	return  display.newLayer("DialogLayer") 
end)

function DialogLayer:ctor(dialog)
    local themeNum = LevelsData[g_playScene.level].theme 
    self.themeNum = themeNum
    ResData.loadRes("DIALOG")
    ResData.loadRes("DIALOG"..themeNum)
    local sceneName = "map/Theme"..themeNum.."/theme"..themeNum.."DialogScene.png"
    self.dialogBg = display.newSprite(sceneName, 0, display.cy)
    self.dialogBg:setAnchorPoint(cc.p(0,0.5))
    self:addChild(self.dialogBg)
    if themeNum == 1 then
        self:showThemeOneAnimation()
    elseif themeNum == 2 then
        self:showThemeTwoAnimation()      
    elseif themeNum == 3 then
    elseif themeNum == 4 then
    end
    self.window = display.newScale9Sprite("#dialogBg.png", display.cx, 70,cc.size(700,150))
    self:addChild(self.window)

    self.rabbit = display.newSprite("#dialogRabbit.png", 0, 110)
    self.window:addChild(self.rabbit)
   	self.rabbit:setVisible(false)
    self.enemy = display.newSprite("#dialogEnemy.png", self.window:getContentSize().width, 140)
    self.enemy:setScale(0.8)
    self.window:addChild(self.enemy)
   	self.enemy:setVisible(false)

    self.dialog = dialog
    self.idx = 0
    self:showMessage()
end
function DialogLayer:showThemeOneAnimation()
    local spriteEye = display.newSprite("#blinkEye1.png",378,365)
    self.dialogBg:addChild(spriteEye,20)
    local framesEye = display.newFrames("blinkEye%d.png", 1, 6)
    local animationEye = display.newAnimation(framesEye, 0.1)
    spriteEye:playAnimationForever(animationEye,2.7)

    local spriteSmoke = display.newSprite("#carSmoke1.png",660,580)
    self.dialogBg:addChild(spriteSmoke,20)
    local framesSmoke = display.newFrames("carSmoke%d.png", 1, 16)
    local animationSmoke = display.newAnimation(framesSmoke, 0.1)
    spriteSmoke:playAnimationForever(animationSmoke)

    local spriteLight = display.newSprite("#flashLight1.png",348,460)
    self.dialogBg:addChild(spriteLight,20)
    local framesLight = display.newFrames("flashLight%d.png", 1, 6)
    local animationLight = display.newAnimation(framesLight, 0.05)
    spriteLight:playAnimationForever(animationLight,2.7)

    local spriteLightA = display.newSprite("#colorLightA_1.png",366,571.5)
    self.dialogBg:addChild(spriteLightA,20)
    local framesLightA = display.newFrames("colorLightA_%d.png", 1, 6)
    local animationLightA = display.newAnimation(framesLightA, 1)
    spriteLightA:playAnimationForever(animationLightA)
    local hill = display.newSprite("#zhengdang.png",660,605)
    self.dialogBg:addChild(hill,19)
    local spriteCamel = display.newSprite("#camel1.png",655,600)
    self.dialogBg:addChild(spriteCamel,18)
    local framesCamel = display.newFrames("camel%d.png", 1, 7)
    local animationCamel = display.newAnimation(framesCamel, 0.2)
    spriteCamel:playAnimationForever(animationCamel)
    self.time = (display.width-620)/5
    spriteCamel:runAction(cc.RepeatForever:create(transition.sequence({
            cc.MoveBy:create(self.time,cc.p(display.width-620,0)),
            cc.DelayTime:create(1),
            cc.CallFunc:create(function()
                spriteCamel:setPosition(cc.p(655,600))
            end),
        })))    
end
function DialogLayer:showThemeTwoAnimation()
    local spriteflyPenguin = display.newSprite("#flyPenguin1.png",209,383)
    self.dialogBg:addChild(spriteflyPenguin,20)
    local framesflyPenguin = display.newFrames("flyPenguin%d.png", 1, 18)
    local animationflyPenguin = display.newAnimation(framesflyPenguin, 0.1)
    spriteflyPenguin:playAnimationForever(animationflyPenguin)

    local spritehangingIce = display.newSprite("#hangingIce1.png",436,209)
    self.dialogBg:addChild(spritehangingIce,20)
    local frameshangingIce = display.newFrames("hangingIce%d.png", 1, 11)
    local animationhangingIce = display.newAnimation(frameshangingIce, 0.1)
    spritehangingIce:playAnimationForever(animationhangingIce)

    local spritestrikeIce = display.newSprite("#strikeIce1.png",504,273)
    self.dialogBg:addChild(spritestrikeIce,20)
    local framesstrikeIce = display.newFrames("strikeIce%d.png", 1, 7)
    local animationstrikeIce = display.newAnimation(framesstrikeIce, 0.1)
    spritestrikeIce:playAnimationForever(animationstrikeIce)

    local spritedrillingIce = display.newSprite("#drillingIce1.png",476,455)
    self.dialogBg:addChild(spritedrillingIce,20)
    local framesdrillingIce = display.newFrames("drillingIce%d.png", 1, 4)
    local animationdrillingIce = display.newAnimation(framesdrillingIce, 0.1)
    spritedrillingIce:playAnimationForever(animationdrillingIce)

    local spriteiceFan = display.newSprite("#iceFan1.png",687,635)
    self.dialogBg:addChild(spriteiceFan,20)
    local framesiceFan = display.newFrames("iceFan%d.png", 1, 6)
    local animationiceFan = display.newAnimation(framesiceFan, 0.1)
    spriteiceFan:playAnimationForever(animationiceFan)
    local blinkLight = {}
    for i =1,3 do
        blinkLight[i] = display.newSprite("#shanguang.png",390,495)
        blinkLight[i]:setScale(0)
        self.dialogBg:addChild(blinkLight[i],20)
        blinkLight[i]:runAction(cc.RepeatForever:create(
            cc.Sequence:create(
                cc.DelayTime:create(math.random(100,200)/100),
                cc.Spawn:create(
                    cc.ScaleTo:create(0.4,1.2),
                    cc.RotateBy:create(0.4,180)
                    ),
                cc.Spawn:create(
                    cc.ScaleTo:create(0.4,0),
                    cc.RotateBy:create(0.4,180)
                    )
                
            )
        ))
        
    end
    blinkLight[1]:setPosition(425,345)
    blinkLight[2]:setPosition(405,570)
    blinkLight[3]:setPosition(290,425)
end    
function DialogLayer:showMessage(idx)
	if self.words ~= nil then
		self.words:removeFromParent()
		self.words = nil
		self.title:removeFromParent()
		self.title = nil
	end
	self.idx = self.idx + 1
	local title
	if self.dialog[self.idx].role == "enemy" then
		title = "蔬菜军团："
   		self.enemy:setVisible(true)
   		self.rabbit:setVisible(false)
	else
		title = "萌萌兔："
   		self.rabbit:setVisible(true)
   		self.enemy:setVisible(false)
	end
    self.title = cc.ui.UILabel.new({
        text = title,
        size = 30,
        color = cc.c3b(255,255,0),
        x = 70,
        y = 110,
        })
    :addTo(self.window)	

	local words = self.dialog[self.idx].words
    self.words = cc.ui.UILabel.new({
        text = words,
        size = 30,
        color = cc.c3b(255,255,255),
        x = display.cx,
        y = 50,
        }):align(display.CENTER)
    :addTo(self)
end

function DialogLayer:click()
	if self.idx >= #self.dialog then
		g_playScene:clearDialog()
	else
		self:showMessage()
	end
end

return DialogLayer