--
-- Author: KK
-- Date: 2014-04-11 12:04:25
--
--核心战斗layer。塔、怪、子弹都放在这一层上。还有龙卷风、火球什么的。

BaseZOrder = {
	fort = 100,
	enemy = 200,
	fight = 210,
	selectDot = 220,
	hero = 250,
	gift = 300,
	card = 400,
	bullet = 2000,
	heroSkill = 3000,
	tornado = 3000,
	ufo = 3000,
	fireball = 3000,
	towerSelectNode = 4000
}

local Fireball = import("..sprites.Fireball")
local Tornado = import("..sprites.Tornado")
local MapInfo = import("..views.MapInfo")

local FightLayer = class("FightLayer", function()
    return display.newLayer()
end)

function FightLayer:ctor()
	self.rabbitCards = {}
	self.gifts = {}
	self.enemies = {}
	self.forts = {}
	self.bullets = {}
	self.thingItem = {}--新加打掉障碍爆道具
	self.selectedFort = nil
	self.selectedTarget = nil
	self.selectedWay = nil
	self.selectedCity = nil
	--[[
	self.selectDot = display.newSprite("#selectDot.png", x, y)
	self.selectDot:setVisible(false)
	self:addChild(self.selectDot, BaseZOrder.selectDot)]]
	self.selectedEnemy = nil
	self.skills = {} --技能update
	self.tornado = {} --风扇兔的大招龙卷风
	self.fireballs = {} --脸谱兔大招火球
	self.bombs = {} --埋地雷
	self.actSprites = {} --做Action需要暂停或结束。
	--三个batchNode
	--self.towerBatchNode = display.newBatchNode("tower.png")
	--self:addChild(self.towerBatchNode,BaseZOrder.fort)
	--self.enemyBatchNode = display.newBatchNode("enemyCommon.png")
	--self:addChild(self.enemyBatchNode,BaseZOrder.enemy)
	--self.bulletBatchNode = display.newBatchNode("bullet.png")
	--self:addChild(self.bulletBatchNode,BaseZOrder.bullet)
	self.fightBatchNode = display.newBatchNode("fight.png")
	self:addChild(self.fightBatchNode,BaseZOrder.fight)
end

function FightLayer:clear()
	for i = 1,#self.tornado do --龙卷风
		self.tornado[i]:removeTornado()
	end
	self.tornado = {}
	for i = 1,#self.fireballs do --火球
		self.fireballs[i]:removeFromParent()
	end
	self.fireballs = {}
	for i = 1,#self.bombs do
		self.bombs[i]:removeFromParent()
	end
	self.bombs = {}
	for i = 1,#self.skills do
		self.skills[i]:endSkill()
	end
	self.skills = {}
	for i = 1,#self.actSprites do
		self.actSprites[i]:removeFromParent()
	end
	self.actSprites = {}

	self.rabbitCards = {}
	self.gifts = {}
	self.enemies = {}
	self.forts = {}
	self.bullets = {}
	self.selectedFort = nil
	self.selectedTarget = nil
	self.selectedWay = nil
	if self.selectDot ~= nil then
		self.selectDot:removeFromParent()
		self.selectDot = nil
	end
	self.selectedEnemy = nil
	--在selectDot移除之后再清除所有精灵
	self:removeAllChildren()
	
	--self.towerBatchNode = display.newBatchNode("tower.png")
	--self:addChild(self.towerBatchNode,BaseZOrder.fort)
	--self.enemyBatchNode = display.newBatchNode("enemyCommon.png")
	--self:addChild(self.enemyBatchNode,BaseZOrder.enemy)
	--self.bulletBatchNode = display.newBatchNode("bullet.png")
	--self:addChild(self.bulletBatchNode,BaseZOrder.bullet)
	self.fightBatchNode = display.newBatchNode("fight.png")
	self:addChild(self.fightBatchNode,BaseZOrder.fight)
end

function FightLayer:suspend()
	for i = 1,#self.actSprites do
		cc.Director:getInstance():getActionManager():pauseTarget(self.actSprites[i])
	end
end

function FightLayer:resume()
	for i = 1,#self.actSprites do
		cc.Director:getInstance():getActionManager():resumeTarget(self.actSprites[i])
	end
end

function FightLayer:update(dt)
	--地图上的更新，现在就只是浮冰重新出现。
	MapInfo:update(dt)
 	--地雷更新
 	self:updateBombs()
 	--[[
 	--龙卷风更新
	for i = 1,#self.tornado do
		if self.tornado[i] ~= nil then
 			self.tornado[i]:update(dt)
 		end
 	end
 	--]]

 	--火球更新
	for i = 1,#self.fireballs do
		if self.fireballs[i] ~= nil then
 			self.fireballs[i]:update(dt)
 		end
 	end

 	for k, v in pairs(self.gifts) do
 		v:update(dt)
 	end
	for k, v in pairs(self.forts) do
		v:update(dt)
	end
	for k, v in pairs(self.enemies) do
		v:update(dt)
	end
	for k, v in pairs(self.bullets) do
		if v.needUpdate then
			v:update(dt)
		end
	end

	--技能更新
	for i = 1, #self.skills do
		self.skills[i]:update(dt)
	end
end

function FightLayer:dropItem(itemIdx,titlePt)
	local pt = MapInfo:getCenterOfTile(titlePt)
	local item = display.newSprite("#"..ItemData[itemIdx].pic,pt.x,pt.y+30)
	g_playScene:addChild(item,5)
	item:runAction(cc.RepeatForever:create(transition.sequence({
			cc.EaseBackIn:create(cc.MoveBy:create(0.2, cc.p(0,-10))),
			cc.MoveBy:create(0.2, cc.p(0,10))
		})))
	self.thingItem[#self.thingItem+1] = item
	self.thingItem[#self.thingItem].itemIdx = itemIdx
end
function FightLayer:clickThingItem(x,y)
	if not VERSION_REDUCE then
		for i=1,#self.thingItem do
			local rect = self.thingItem[i]:getCascadeBoundingBox()
			if cc.rectContainsPoint(rect, cc.p(x,y)) then
				self.thingItem[i]:setVisible(false)
				kkFunc.ObtainEffect(g_playScene,g_playScene:convertToWorldSpace(cc.p(self.thingItem[i]:getPosition())),
		            g_playScene:convertToWorldSpace(cc.p(g_playScene.skillLayer.items[self.thingItem[i].itemIdx].sprite:getPosition()))
		            ,0.7,"#"..ItemData[self.thingItem[i].itemIdx].pic,function ()
		            	--对应道具数量增加
		            	if not g_playScene.skillLayer.itemNumBgBar[self.thingItem[i].itemIdx]:isVisible() then
		            		g_playScene.skillLayer.itemNumBgBar[self.thingItem[i].itemIdx]:setVisible(true)
		            	end
		            	GameData.item["i"..self.thingItem[i].itemIdx].number = GameData.item["i"..self.thingItem[i].itemIdx].number + 1
		            	g_playScene.skillLayer.itemNum[self.thingItem[i].itemIdx]:setString(""..GameData.item["i"..self.thingItem[i].itemIdx].number)
		            	if g_playScene.skillLayer.purchaseItemLayer ~= nil then
							g_playScene.skillLayer.purchaseItemLayer.titleNum[self.thingItem[i].itemIdx]:setString(""..GameData.item["i"..i].number)
						end
		            	GameState.save(GameData)
		            	--移除道具精灵
		                self.thingItem[i]:removeFromParent()
		                self.thingItem[i] = nil
		                table.remove(self.thingItem,i)
		            end
		            )
				return true
			end
		end
	end
end
function FightLayer:addGift(gift)
    self:addChild(gift, BaseZOrder.gift)
    --用batchNode
    --self.enemyBatchNode:addChild(en)    
	self.gifts[#self.gifts+1] = gift
end

function FightLayer:removeGift(gift)
	for k, v in pairs(self.gifts) do
		if gift == v then
			v:removeFromParent()
			v = nil
			table.remove(self.gifts, k)
			break
		end
	end
end

function FightLayer:addRabbitCard(card)
    self:addChild(card, BaseZOrder.card)
    --用batchNode
    --self.enemyBatchNode:addChild(en)    
	self.rabbitCards[#self.rabbitCards+1] = card
	card:runAction(transition.sequence({
		cc.DelayTime:create(3),
		cc.Blink:create(2, 3),
		cc.CallFunc:create(function()
			card.clicked = true
			self:removeRabbitCard(card)
		end)
	}))
end

function FightLayer:removeRabbitCard(card)
	for k, v in pairs(self.rabbitCards) do
		if card == v then
			v:removeFromParent()
			v = nil
			table.remove(self.rabbitCards, k)
			break
		end
	end
end

function FightLayer:addFightContent(content)
	self.fightBatchNode:addChild(content)
end

function FightLayer:addSkill(skill)
	self.skills[#self.skills+1] = skill
end
function FightLayer:removeSkill(skill)
	for k, v in pairs(self.skills) do
		if skill == v then
			table.remove(self.skills, k)
			break
		end
	end
end

function FightLayer:addEnemy(en)
	--怪也是在空sprite上加enemyPic所以不能再用batchNode了。
    self:addChild(en, BaseZOrder.enemy)
    --[[
	if not USE_BATCHNODE or en.idx > 40 then
    	self:addChild(en, BaseZOrder.enemy)
	else
    	--用batchNode
    	self.enemyBatchNode:addChild(en)    
	end
	--]]
	self.enemies[#self.enemies+1] = en
end
function FightLayer:removeCity(city)
	city.needUpdate = false
	if self.selectDot ~= nil then
		if self.selectDot:getParent() == city then
			self.selectedCity = nil
			self.selectDot:removeFromParent()
			self.selectDot = nil
		end
	end
	for i = 1, #self.bullets do
		local bullet = self.bullets[i]
		if bullet.cityTarget == city then
			bullet.cityTarget = nil
		end
	end
	for i = 1, #self.forts do
		local fort = self.forts[i]
		if fort.cityTarget == city then
			fort.cityTarget = nil
		end
	end
	g_playScene.cityHome:removeFromParent()
	g_playScene.cityHome = nil
end
function FightLayer:removeEnemy(en)
	en.needUpdate = false
	if self.selectDot ~= nil then
		--local p1 = self.selectDot:getParent():getPosition()
		--local p2 = en:getPosition()
		--print("removeEnemy",p1,p2)
		if self.selectDot:getParent() == en then
			self.selectedEnemy = nil
			self.selectDot:removeFromParent()
			self.selectDot = nil
		end
	end

	for i = 1, #self.bullets do
		local bullet = self.bullets[i]
		if bullet.target == en then
			bullet.target = nil
		end
	end
	for i = 1, #self.forts do
		local fort = self.forts[i]
		if fort.targets ~= nil then
			for i = #fort.targets, 1, -1 do
				if fort.targets[i] == en then
					table.remove(fort.targets,i)
				end
			end
		elseif fort.target == en then
			fort.target = nil
		end
	end
	--新加了个龙卷风
	for i = 1, #self.tornado do
		for j = 1, #self.tornado[i].enemies do
			if self.tornado[i].enemies[j] == en then
				en.tornado = nil
				self.tornado[i].enemies[j] = 0 --设为nil数组就乱了。
				--print("remove and left",#self.tornado[i].enemies)
			end
		end
	end
	--盖伦技能记录的怪要清除
	for i = 1, #self.skills do
		if self.skills[i].idx == 1 then
			for j = 1,#self.skills[i].enemies do
				if self.skills[i].enemies[j] == en then
					self.skills[i].enemies[j] = 0 --设为nil数组就乱了。
				end
			end
		end
	end
	if g_playScene and g_playScene.hero then
		if g_playScene.hero.attackEnemy == en then
			g_playScene.hero:lostEnemy()
		end
	end
	for k, v in pairs(self.enemies) do
		if en == v then
			v:removeFromParent()
			v = nil
			table.remove(self.enemies, k)
			break
		end
	end
end

--南极洲、大洋洲放置点道具被打掉，在放置点上造塔，删除塔，放置点要变。
function FightLayer:changeWaterSeat(tilePt, changeType)
	local waterSeat
	for i = 1, #MapInfo.waterTowerSeats do
		local waterTowerSeat = MapInfo.waterTowerSeats[i]
		if waterTowerSeat.tilePt.x == tilePt.x and
				waterTowerSeat.tilePt.y == tilePt.y then
			waterSeat = waterTowerSeat
			break
		end
	end
	if not waterSeat then return end

	local name
	if changeType == 1 then --打完道具出空座
		name = "#waterSeat.png"
	elseif changeType == 2 then --放了塔改成有座
		waterSeat.sprite:removeFromParent()
		name = "#waterSeat2.png"
	elseif changeType == 3 then --删了塔改成空座
		waterSeat.sprite:removeFromParent()
		name = "#waterSeat2.png"
	end
	local pt = MapInfo:getCenterOfTile(waterSeat.tilePt)
	local seat = display.newSprite(name,pt.x,pt.y)
	g_fightLayer:addChild(seat)
	waterSeat.sprite = seat
end

function FightLayer:addFort(fort)
	--[[
	if not USE_BATCHNODE then
    	self:addChild(fort, BaseZOrder.fort + fort.tilePt.y)
    else
    	self.towerBatchNode:addChild(fort, BaseZOrder.fort + fort.tilePt.y)    	
    end
    --]]
    self:addChild(fort, BaseZOrder.fort)
	self.forts[#self.forts+1] = fort
	self:changeWaterSeat(fort.tilePt, 2)
end
function FightLayer:removeFort(fort)
	local pt = MapInfo:getCenterOfTile(fort.tilePt)
	local sprite = display.newSprite("#createTower1.png")
    sprite:setPosition(pt)
    g_fightLayer:addChild(sprite,BaseZOrder.fort+1)
    local frames = display.newFrames("createTower%d.png", 1, 5)
    local animation = display.newAnimation(frames, 0.1)
    sprite:playAnimationOnce(animation,true)
	self:changeWaterSeat(fort.tilePt, 3)
	fort.needUpdate = false
	for i = 1, #self.bullets do
		local bullet = self.bullets[i]
		if bullet.fortTarget == fort then
			bullet.fortTarget = nil
		end
	end
	--准备升级的塔被移除
	if self.selectedFort == fort then
		self.selectedFort = nil
	end
	for k, v in pairs(self.forts) do
		if fort == v then
			v:callBeforRemove()
			v:removeFromParent()
			v = nil
			table.remove(self.forts, k)
			break
		end
	end
end
function FightLayer:addBullet(bullet)
	--[[
	if not USE_BATCHNODE then
    	self:addChild(bullet, BaseZOrder.bullet)
    else
    	self.bulletBatchNode:addChild(bullet, BaseZOrder.bullet)
    end
    --]]
	self:addChild(bullet, BaseZOrder.bullet)
	self.bullets[#self.bullets+1] = bullet
end
function FightLayer:removeBullet(bullet)
	for k, v in pairs(self.bullets) do
		if bullet == v then
			v:removeFromParent()
			v = nil
			table.remove(self.bullets, k)
			break
		end
	end
end

function FightLayer:getEnimiesAroundPos(pos, rangeSq, isAnchorPos)
	local enemies = {}
	for k,v in pairs(self.enemies) do
		--默认取怪的视觉中心
		local enPt
		if isAnchorPos then
			enPt = v:getPositionInCCP()
		else
			enPt = v:getPositionCenter()
		end
		local dist2 = cc.pDistanceSQ(pos, enPt)
		if dist2 <= rangeSq then
			enemies[#enemies+1] = v
		end
	end
	return enemies
end

function FightLayer:getEnimiesAroundPosToBomb(pos, rangeSq)
	local enemies = {}
	for k,v in pairs(self.enemies) do
		--取怪的视觉中心
		local enPt = v:getPositionCenterToBomb()
		local dist2 = cc.pDistanceSQ(pos, enPt)
		if dist2 <= rangeSq then
			enemies[#enemies+1] = v
		end
	end
	return enemies
end
function FightLayer:getFortsAroundPos(pos, rangeSq)
	local forts = {}
	for i = 1, #self.forts do
		local fortPos = cc.p(self.forts[i]:getPosition())
		local disSq = cc.pDistanceSQ(pos, fortPos)
		if disSq <= rangeSq then
			forts[#forts+1] = self.forts[i]
		end
	end
	return forts
end

function FightLayer:isThingInPosRange(thing, pos, rangeSq)
	for i = 1, thing.width do
		for j = 1, thing.height do
			local thingPt =	MapInfo:getCenterOfTile(cc.p(thing.tilePt.x-1+i,
				thing.tilePt.y+1-j))
			local disSq = cc.pDistanceSQ(pos, thingPt)
			if disSq < rangeSq then
				return true
			end
		end
	end
	return false
end

function FightLayer:getThingsAroundPos(pos, rangeSq)
	local things = {}
	for i = 1, #MapInfo.things do
		if MapInfo.things[i].part == false then
			local thing = MapInfo.things[i]
			if self:isThingInPosRange(MapInfo.things[i], pos, rangeSq) then
				things[#things+1] = MapInfo.things[i]
			end
		end
	end
	return things
end

function FightLayer:setSelectDot(target, pt)
	if self.selectDot == nil then
		self.selectDot = display.newSprite("#selectDot.png", pt.x, pt.y+20)
		self.selectDot:setVisible(true)
		self.selectDot:runAction(cc.RepeatForever:create(transition.sequence({
			cc.MoveBy:create(0.5,cc.p(0,5)),
			cc.MoveBy:create(0.5,cc.p(0,-5)),
		})))
		target:addChild(self.selectDot, BaseZOrder.selectDot)
		return
	end

	if not self.selectDot:isVisible() then
		self.selectDot:setVisible(true)
	end
	self.selectDot:setPosition(pt.x,pt.y+20)
	self.selectDot:retain()
	self.selectDot:removeFromParent(false)
	target:addChild(self.selectDot, BaseZOrder.selectDot)
	self.selectDot:release()
end
function FightLayer:selectTheCity(city)
    if self.selectedCity == city then
    	self.selectedCity = nil 
    	self.selectDot:setVisible(false)
    	return true
    end  
    if NEW_GUIDE and g_playScene.newbieguidelayer ~= nil and g_playScene.newbieguidelayer.rect ~= nil and GameData.guide.level3 then
		g_playScene.newbieguidelayer:goLevel7(5)
	end
    self.selectedWay = nil
	self.selectedTarget = nil 
	self.selectedEnemy = nil
	self.selectedCity = city
    
	self:setSelectDot(city, cc.p(city:getContentSize().width/2, city:getContentSize().height+10))
	--音效
	SoundManager.playSound(GAME_SOUND.ShootSelect)
	return true
end
function FightLayer:selectCity(x,y)
	--attckCityMode
	if g_playScene.mode == "attackCityMode" then
		if g_playScene.cityHome ~= nil then
			local rect = g_playScene.cityHome:getCascadeBoundingBox()
			if cc.rectContainsPoint(rect, cc.p(x,y)) then
				return self:selectTheCity(g_playScene.cityHome)
			end 
		end
	end
	return false
end

function FightLayer:selectTheEnemy(en)
	--print(rect.origin.x,rect.origin.y,rect:getMaxX(),rect:getMaxY(),x,y)
    if self.selectedEnemy == en then
    	self.selectedEnemy = nil 
    	self.selectDot:setVisible(false)
    	return true
    end   
    self.selectedWay = nil
	self.selectedTarget = nil
	self.selectedCity = nil
	self.selectedEnemy = en
	--print(size.width,size.height)
    
	self:setSelectDot(en, cc.p(0, en.enemySize.height-10))
	--音效
	SoundManager.playSound(GAME_SOUND.ShootSelect)
	return true
end

function FightLayer:selectEnemy(x,y)
	local ens = {}
	--优先选有气泡的。
	for k, v in pairs(self.enemies) do
		local rect = v:getRect() --v:getCascadeBoundingBox()
		if v.canHit and cc.rectContainsPoint(rect, cc.p(x,y)) then
			--可以戳的气泡
			if v.buffers.bubble then
				v:pokeBubble()
				return true
			end
			--优先竹笋怪
			if v.idx == 45 then
				return self:selectTheEnemy(v)
			end
			ens[#ens+1] = v
		end
	end
	if #ens > 0 then
		return self:selectTheEnemy(ens[1])
	end
	return false
end

--点击兔子卡片
function FightLayer:selectRabbitCard(x,y)
	for k, v in pairs(self.rabbitCards) do
		local rect = v:getCascadeBoundingBox() --v:getRect()--
		if cc.rectContainsPoint(rect, cc.p(x,y)) then
			if not v.clicked then
				self:addCardToTowerLayer(v)
				return true
			end
		end
	end
	return false
end

function FightLayer:addCardToTowerLayer(card)
	local towerLayer = self:getParent().towerLayer
	if towerLayer.giftTowerNum >= 4 then return end
	towerLayer.giftTowerNum = towerLayer.giftTowerNum + 1
	card:stopAllActions()
	card:setVisible(true)
	card.clicked = true

	local destPos = towerLayer:getCardPosByIdx(towerLayer.giftTowerNum)
	card:runAction(transition.sequence({
		cc.EaseSineInOut:create(cc.MoveTo:create(0.5, destPos)),
		cc.CallFunc:create(function()
			towerLayer:addTower(card.towerIdx)
			self:removeRabbitCard(card)
		end)
	}))
end

--点击礼盒
function FightLayer:selectGift(x,y)
	for k, v in pairs(self.gifts) do
		local rect = v:getCascadeBoundingBox() --v:getRect()--
		if cc.rectContainsPoint(rect, cc.p(x,y)) then
			v:open()
			return true
		end
	end
	return false
end

--[[
选道具，
普通道具thingType = 0,
浮冰thingType = 1,
可打击出怪点thingType = 2,
--]]
function FightLayer:selectThing(tilePt, thingType)
	--print(tilePt.x,tilePt.y)
    local thing
    if thingType == 2 then --选可打击出怪点
		thing = MapInfo:checkStrangePoint(tilePt)
    elseif thingType == 1 then --选浮冰
    	thing = MapInfo:checkFloatWay(tilePt)
    	if thing ~= nil then
    		if thing.fill then
    			return self:selectTheEnemy(thing.fillEnemy)
    		elseif not thing.sprite:isVisible() then
    			return false
    		end
    	end
    else
    	thing = MapInfo:checkTileThing(tilePt)
    end
    if thing == nil then return false end
    if self.selectedTarget == thing then
    	self.selectedTarget = nil 
    	self.selectDot:setVisible(false)
    	--[[if NEW_GUIDE and g_playScene.newbieguidelayer ~= nil and g_playScene.newbieguidelayer.rect ~= nil and GameData.guide.level1 == true then
			g_playScene.newbieguidelayer:goLevel2(9)
		end]]
    	return true
    end
	self.selectedTarget = thing
	self.selectedEnemy = nil
	self.selectedCity = nil
	--local pt = MapInfo:getCenterOfTile(self.selectedTarget.tilePt)
	local pt = MapInfo:getTopOfThing(self.selectedTarget)
	self:setSelectDot(self, pt)
	if NEW_GUIDE and g_playScene.newbieguidelayer ~= nil and g_playScene.newbieguidelayer.rect ~= nil and GameData.guide.level1 == true then
		g_playScene.newbieguidelayer:goLevel2(8)
	end
	--音效
	SoundManager.playSound(GAME_SOUND.ShootSelect)
	return true
end
function FightLayer:playAnimationAfterThingDead(thing)
	local tp = MapInfo:getCenterOfThing(thing)
	local dead = display.newSprite(EnemyData.common.deadPic,tp.x,tp.y)
	self:addChild(dead,300)
	local deadAni = display.getAnimationCache(EnemyData.common.deadAni)
	dead:playAnimationOnce(deadAni, true)
end
function FightLayer:hitThing(thing, attack,towerIdx)
	if thing == nil then return end
	--浮冰特殊
	if thing.thingType == 1 then
		--浮冰只要看不到就不能打了。目前防止被警灯兔扇到。
		if not thing.sprite:isVisible() then return end
		if thing.hp - attack > thing.maxHp*1/3 and thing.hp - attack <= thing.maxHp*2/3 then
			thing.sprite:setSpriteFrame(display.newSpriteFrame("floatIce2.png"))
			--音效
			if not thing.firstBreak then
				SoundManager.playSound(GAME_SOUND.Iceroad[1])
				thing.firstBreak = true
			end
		elseif thing.hp - attack > 0 and thing.hp - attack <= thing.maxHp*1/3 then
			thing.sprite:setSpriteFrame(display.newSpriteFrame("floatIce3.png"))
			--音效
			if not thing.secondBreak then
				SoundManager.playSound(GAME_SOUND.Iceroad[1])
				thing.secondBreak = true
			end
		end
	end
	thing.hp = thing.hp - attack
	thing.hpBar:updateHp(thing.hp)
	--print(thing.hp)
	if thing.hp <= 0 then
		--[[if NEW_GUIDE and g_playScene.newbieguidelayer ~= nil and g_playScene.newbieguidelayer.rect ~= nil and GameData.guide.level1 == true then
			g_playScene.newbieguidelayer:goLevel2(2)
		end]]
		--影响的东西先处理
		for i = 1, #self.bullets do
			local bullet = self.bullets[i]
			if thing == self.selectedTarget and bullet.thingTarget ~= nil then
				bullet.thingTarget = nil
			end
		end
		for i = 1, #self.forts do
			local fort = self.forts[i]
			--范围攻击的塔要注意。
			if thing == self.selectedTarget and fort.thingTarget ~= nil then
				fort.thingTarget = nil
			end
		end
		if thing == self.selectedTarget then
			self.selectedTarget = nil
			self.selectDot:setVisible(false)
		end
        --音效
        SoundManager.playSound(GAME_SOUND.Object)
		--print("hitThing:",self.selectedTarget.tilePt.x,self.selectedTarget.tilePt.y)
		if thing.thingType == 0 then --只有普通的道具才要这么删。
			for i = 1,thing.width do
				for j = 1,thing.height do
					local p = cc.p(thing.tilePt.x+i-1, thing.tilePt.y-j+1)
					MapInfo:removeThing(p)
					--南极洲打完道具可放置塔的地方
					self:changeWaterSeat(p, 1)
					--打掉道具可能出塔
					for i = 1, #MapInfo.openTowers do
						local openTower = MapInfo.openTowers[i]
						if openTower.tilePt.x == p.x and
							    openTower.tilePt.y == p.y then
       						g_playScene:createFort(openTower.towerIdx, openTower.tilePt, openTower.level)
       						--新塔一出来就判断是否更新为可升级状态
						    for i = 1, #g_playScene.fightLayer.forts do
						        g_playScene.fightLayer.forts[i]:updateForChangeMoney(g_playScene.money)
						    end
							if g_playScene.task ~= nil then
								g_playScene.task:getPreFort(openTower.towerIdx)
							end	
						end
					end
					-- 炸弹炸一圈道具
					for i = 1, #MapInfo.thingBomb do
						local bomb = MapInfo.thingBomb[i]
						if bomb.x == p.x and bomb.y == p.y then
       						self:bombThing(p.x,p.y)
						end
					end
				end
			end
			--道具死后动画
			self:playAnimationAfterThingDead(thing)
			--任务处理
			if g_playScene ~= nil then
				if g_playScene.task then
					g_playScene.task:removeThing(thing.thingIdx,towerIdx)
				end
			end
		else
			MapInfo:removeThing(thing.tilePt)
		end
		--选塔时的blankArea闪烁更新。。不用了。现在不闪烁，只出现一次。
		--self:getParent().towerLayer:addBlankWhenThingRemove(thing.tilePt)
	end
end

--技能地雷
function FightLayer:createBomb(pos)
	local p = MapInfo:getTilePositionInCCP(pos)
	local bomb = display.newSprite("#h04_bomb_1.png")
    local frames = display.newFrames("h04_bomb_%d.png", 1, 2)
    local animation = display.newAnimation(frames, 0.5)
    bomb:playAnimationForever(animation)
    bomb:runAction(cc.RepeatForever:create(transition.sequence({
    		cc.ScaleTo:create(0.2, 1.2),
			cc.ScaleTo:create(0.2, 1),
			cc.ScaleTo:create(0.2, 1.2),
			cc.ScaleTo:create(0.2, 1),
    	})))
	bomb:setPosition(MapInfo:getCenterOfTile(p).x,MapInfo:getCenterOfTile(p).y+15)
	self:addChild(bomb,BaseZOrder.enemy-1)
	self.bombs[#self.bombs+1] = bomb
	self.bombs[#self.bombs].control = true
end

function FightLayer:updateBombs()
 	for i =1,#self.bombs do
 		if self.bombs[i] ~= nil then
	 		if self.bombs[i].control == true then
		 		local enemies = self:getEnimiesAroundPosToBomb(cc.p(self.bombs[i]:getPosition()), math.pow(0.5*MapInfo.tileSize,2))
		 		if #enemies ~= 0 then
		 			self.bombs[i].control = false
		 			self.bombs[i]:stopAllActions()
				    local frames = display.newFrames("h04_bombExplode_%d.png", 1, 7)
				    local animation = display.newAnimation(frames, 0.1)
				    self.bombs[i]:playAnimationOnce(animation, true)
				    --音效
    				SoundManager.playSound(GAME_SOUND.Hero[4].skill2)
    				
				    for j=1,#enemies do
						for k=1,#self.enemies do
							local en = self.enemies[k]
							if enemies[j] == en then
								en:updateHp(-math.floor(ExcelHeroSkillData[13][GameData.heros["h4"].skill["s2"]].value))
							end
						end
					end
				    table.remove(self.bombs,i)
				    --self.bombs[i] = nil 
		 			--[[self.bombs[i]:runAction(transition.sequence({
						cc.ScaleTo:create(0.2, 1.2),
						cc.ScaleTo:create(0.2, 1),
						cc.ScaleTo:create(0.2, 1.2),
						cc.ScaleTo:create(0.2, 1),
						cc.CallFunc:create(function()
							--if self.bombs[i] ~= nil then
			 				self.bombs[i]:stopAllActions()
						    local frames = display.newFrames("h04_bombExplode_%d.png", 1, 7)
						    local animation = display.newAnimation(frames, 0.1)
						    self.bombs[i]:playAnimationOnce(animation, true)
						    for j=1,#enemies do
								for i=1,#self.enemies do
									local en = self.enemies[i]
									if enemies[j] == self.enemies[i] then
										en:updateHp(-20)
									end
								end
							end
						    table.remove(self.bombs,i)
						end)
					}))]]
				end
	 		end
	 	end 
 	end
end

-- 炸弹炸一圈道具
function FightLayer:bombThing(x,y)
	local tps = {cc.p(x-1,y-1),cc.p(x,y-1),cc.p(x+1,y-1),cc.p(x-1,y),cc.p(x+1,y),
					cc.p(x-1,y+1),cc.p(x,y+1),cc.p(x+1,y+1)}

	local bomb = display.newSprite("#thingBomb.png")
	bomb:setPosition(MapInfo:getCenterOfTile(cc.p(x,y)))
	self:addChild(bomb, BaseZOrder.fort)

	bomb:runAction(transition.sequence({
		cc.ScaleTo:create(0.2, 1.2),
		cc.CallFunc:create(function()
			for k, v in pairs(tps) do
				local thing = MapInfo:checkTileThing(v)
				if thing ~= nil then
					self:hitThing(thing, thing.hp)
				end
			end
		end),
		cc.ScaleTo:create(0.2, 1),
		cc.ScaleTo:create(0.2, 1.2),
		cc.ScaleTo:create(0.2, 1),
		cc.CallFunc:create(function()
		    local frames = display.newFrames("thingBomb%03d.png", 1, 8)
		    local animation = display.newAnimation(frames, 0.1)
		    bomb:playAnimationOnce(animation, false, function()
				for k, v in pairs(self.actSprites) do
					if bomb == v then
						v:removeFromParent()
						v = nil
						table.remove(self.actSprites, k)
						break
					end
				end
		   	end)			
		end)
	}))
	self.actSprites[#self.actSprites+1] = bomb
end

function FightLayer:skillE64(E64Pos,randomFortsTable,TowerIdxTable,TowerLevelTable,TilePtTable)
	self.randomFortsNatureTowerIdx = TowerIdxTable
	self.randomFortsNatureTowerLevel = TowerLevelTable
	self.randomFortsNatureTilePt = TilePtTable
	self.randomForts = randomFortsTable
	self:performWithDelay(function()
		--随机出几个建造塔的位置坐标
		self:randomTowerTitlePt(E64Pos)
		--在随机出的地方造塔
		for i = 1, #self.randomForts do
			self:E64CreateNewTower(i)
		end
	end, 2.9)
end
	
function FightLayer:randomTowerTitlePt(E64Pos)
	self.randomTitlePt = {}
	local pt = E64Pos
	--[[if boss ~= nil then
		print("fff",boss)
		print("ddddd",boss:getPositionX())
		pt = cc.p(boss:getPosition())
	else
		pt = MapInfo.endPos
	end]]
	for x=0,12 do
		for y=0,6 do
			local fort = g_playScene:getTileFort(cc.p(x,y))
			if fort == nil and g_playScene:checkTileNormalCreateTower(cc.p(x,y)) and MapInfo:checkTileBlank(cc.p(x,y)) then
            	local towerPt = MapInfo:getCenterOfTile(cc.p(x,y))
            	local disSq = cc.pDistanceSQ(towerPt, pt)
            	--以怪物为中心，随机的炮塔位置在3瓦格以外
            	if disSq > math.pow(MapInfo.tileSize*3,2) then
	            	self.randomTitlePt[#self.randomTitlePt+1] = cc.p(x,y)
		            if #self.randomTitlePt == #self.randomForts then
	            		return  
	            	end 
            	end     
            end	
		end
	end

	if #self.randomTitlePt < #self.randomForts then
		for x=0,12 do
			for y=0,6 do			
				local fort = g_playScene:getTileFort(cc.p(x,y))
				if fort == nil and g_playScene:checkTileNormalCreateTower(cc.p(x,y)) and MapInfo:checkTileBlank(cc.p(x,y)) then
	            	local towerPt = MapInfo:getCenterOfTile(cc.p(x,y))
	            	local disSq = cc.pDistanceSQ(towerPt, pt)
	            	--如果三瓦格以外没有空余建塔位置，优先考虑三瓦各以内空余的炮塔位置
	            	if disSq <= math.pow(MapInfo.tileSize*3,2) then
		            	self.randomTitlePt[#self.randomTitlePt+1] = cc.p(x,y)
			            if #self.randomTitlePt == #self.randomForts then
		            		return  
		            	end 
	            	end     
	            end	
			end
		end
		--最后如果还没有空余的建塔位置，三个炮塔位置随机互换。
		local num = #self.randomForts - #self.randomTitlePt
		for i=1, num do
			self.randomTitlePt[#self.randomTitlePt+1] = self.randomFortsNatureTilePt[num-i+1]
		end
	end
end
function FightLayer:E64CreateNewTower(TOWERIDX)
	if g_playScene.towerCreateLayer.blank:isVisible() then
		g_playScene.towerCreateLayer.blank:setVisible(false)
		g_playScene.towerCreateLayer.showLayer:setVisible(false)
	end
	local sprite = display.newSprite("#swrilWater1.png")
	local pt = MapInfo:getCenterOfTile(self.randomTitlePt[TOWERIDX])
	sprite:setPosition(pt.x,pt.y+15)
	self:addChild(sprite,BaseZOrder.fort+1)
	local frames = display.newFrames("swrilWater%d.png", 1, 6)
	local animation = display.newAnimation(frames, 0.1)
	g_playScene:createFort(self.randomFortsNatureTowerIdx[TOWERIDX], self.randomTitlePt[TOWERIDX], self.randomFortsNatureTowerLevel[TOWERIDX], true)
	sprite:playAnimationOnce(animation, true, function()		
		--更新塔的可升级状态
	    for i = 1, #self.forts do
	        self.forts[i]:updateForChangeMoney(g_playScene.money)
	    end
	end)
end
function FightLayer:moneyShow(money, pt)
	local text = money..""
	if money > 0 then
		text = "+"..money
	end
	local moneyBg = display.newSprite("#getMoneyBg.png",pt.x,pt.y+60)
    self:addChild(moneyBg,BaseZOrder.fight)
    --白色字体
	-- local moneyLabel = cc.ui.UILabel.new({
 --        text = text,
 --        size = 16,
 --        x = 40,
 --        y = 16,
 --    })
	--黑色字体
	local moneyLabel = cc.ui.UILabel.new({
            UILabelType = 1,
            text = text,
            font = "fontFortMoney.fnt",
        })
	moneyLabel:setPosition(45, 16)
	moneyLabel:setScale(0.7)
    moneyLabel:setAnchorPoint(cc.p(0.5,0.75))
    moneyBg:addChild(moneyLabel)
    moneyBg:runAction(transition.sequence({
    	cc.MoveBy:create(0.4, cc.p(0,15)),
    	cc.DelayTime:create(0.2),
    	cc.FadeOut:create(0.1),
        cc.CallFunc:create(function()
            moneyBg:removeFromParent()
        end) 
    }))
end

--现在是第一英雄的第一技能。风扇兔的大招龙卷风~~
function FightLayer:createTornado(params)
    if #self.tornado == 0 then
    	self.tornadoLayer = cc.Layer:create()
    	self:addChild(self.tornadoLayer)
        cc.Device:setAccelerometerEnabled(true)
	    cc.Device:setAccelerometerInterval(0.03)
        local function didAccelerate(event,x,y,z,timestamp)
            self.vx = x*300
            self.vy = y*300
        end
        local listener = cc.EventListenerAcceleration:create(didAccelerate)
        cc.Director:getInstance():getEventDispatcher():addEventListenerWithSceneGraphPriority(listener, self.tornadoLayer)

	    self.tornadoLayer:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt) 
		 	--龙卷风更新
			for i = 1,#self.tornado do
				if self.tornado[i] ~= nil then
		 			self.tornado[i]:update(dt)
		 		end
		 	end
       	end)
    	self.tornadoLayer:scheduleUpdate()
        --[[
	    self:addNodeEventListener(ACCELERATE_EVENT,function(event)
	    	self:accelerate(event)
	    end)
	    --]]
	end
	self.tornado[#self.tornado+1] = Tornado.new(params)
	self:addChild(self.tornado[#self.tornado], BaseZOrder.tornado)
    --self:setAccelerometerEnabled(true)
    self.vx = 0
    self.vy = 0
    --[[if NEW_GUIDE and GameData.guide.step < 48 then
	    self:performWithDelay(function()
	        g_guidelayer:GetMessage(13)
	    end, 8)
	end]]
end

function FightLayer:accelerate(event)
    self.vx = event.x*600
    self.vy = event.y*600
    --if self.vx < 300 then self.vx = self.vx * 2 end
    --if self.vy < 300 then self.vy = self.vy * 2 end
end

function FightLayer:removeTornado(tnd)
	for i = 1, #self.tornado do
		if self.tornado[i] == tnd then
			table.remove(self.tornado,i)
			tnd:clear()
			break
		end
	end
	if #self.tornado == 0 then
		self.tornadoLayer:unscheduleUpdate()
		self:performWithDelay(function()
			self.tornadoLayer:removeFromParent()
			self.tornadoLayer = nil
		end, 0.5)
        cc.Device:setAccelerometerEnabled(false)
	    --self:setAccelerometerEnabled(false)
		--self:removeNodeEventListenersByEvent(ACCELERATE_EVENT)
	end
end

--脸谱兔的大招火球~
function FightLayer:createFireball(params)
	local num = params.num or 5
	local interval = params.interval or 0.3
	local range = params.range or 70
	for i = 1, num do
		local pos
		if params.pos == nil then
			pos = MapInfo:getRandomWayPos()
		else
			pos = cc.p(params.pos.x + math.random(-range,range),
				params.pos.y + math.random(-range,range))
		end
		local x = pos.x + 50
		local y = pos.y + 180
		local t = 0.2

		local fb = Fireball.new({
			from = cc.p(x,y),
			to = pos,
			time = t,
			delay = (i-1)*interval,
			onlyShow = params.onlyShow,
		})
		self:addChild(fb,BaseZOrder.fireball)
		self.fireballs[#self.fireballs+1] = fb
	end
end

function FightLayer:removeFireball(fb)
	for i = 1, #self.fireballs do
		if self.fireballs[i] == fb then
			table.remove(self.fireballs,i)
			break
		end
	end
end

return FightLayer