--
-- Author: KK
-- Date: 2014-11-05 10:11:15
--
--英雄技能层
local MapInfo = import("..views.MapInfo")
local Skills = import("..obj.Skills")

local LAYER_HEIGHT = 60
local LAYER_WIDTH = 60
local PurchaseItemLayer = import("..sprites.PurchaseItemLayer")
local HeroSkillLayer = class("HeroSkillLayer", function()
	return display.newLayer()
end)

function HeroSkillLayer:ctor(heroIdx,items)
	if VERSION_REDUCE then
		self.items = items
	end
	local bg = display.newSprite("#skillBg.png")
	bg:setAnchorPoint(cc.p(0.5,0))
	self:addChild(bg)
	self.heroIdx = heroIdx
	self.heroData = HeroData[self.heroIdx]
	self.heroLevel = GameData.heros["h"..self.heroIdx].level
	self.heroIcon = display.newSprite("#"..self.heroData.icon)
	self:addChild(self.heroIcon)
	local bX
	local iconPos
	if VERSION_MONSTER then
		bX = -10
		iconPos = cc.p(display.cx+315, 63)
	else
		bX = 0
		iconPos = cc.p(display.cx+330, 45)
	end
	bg:setPosition(display.cx, bX)
	self.heroIcon:setPosition(iconPos)
	self.skills = {}
	self.skillSprite = {}
	for i = 1, #HeroData[self.heroIdx].skill do
		--技能级别为0时未开启
		local skillLevel = GameData.heros["h"..self.heroIdx].skill["s"..i]
		local skillIdx = HeroData[self.heroIdx].skill[i]
		local sk = SkillData[skillIdx]
		if sk.passive ~= true then
			--[[local skillBg = display.newSprite("#skillIconBg.png")
			skillBg:setPosition(display.cx + 380 - 100*i, 44)
			self:addChild(skillBg)]]
			self.skillSprite[i] = display.newSprite("#"..sk.pic2)
			local spritePos
			if VERSION_MONSTER then
				spritePos = cc.p(display.cx + 290 - 85*i, 38)
			else
				spritePos = cc.p(display.cx + 330 - 100*i, 38)
			end
			self.skillSprite[i]:setPosition(spritePos)
			self:addChild(self.skillSprite[i],1)--z为1，技能动态框z为0
			if skillLevel == 0 then
				local size = self.skillSprite[i]:getContentSize()
				local lock = display.newSprite("#skillIconLock.png",size.width*0.5, size.height*0.5)
				self.skillSprite[i]:addChild(lock)
				self.skillSprite[i]:setColor(cc.c3b(128,128,128))
			else
				--新手引导
				if NEW_GUIDE and GameData.guide.level1 == false and g_playScene.level == 101 then
					local size = self.skillSprite[i]:getContentSize()
					local lock = display.newSprite("#skillIconLock.png",size.width*0.5, size.height*0.5)
					self.skillSprite[i]:addChild(lock)
				else				
					local cdTime = ExcelHeroSkillData[skillIdx][skillLevel].cd
					if VERSION_REDUCE then
						if self.items[4] == true then
							cdTime = cdTime*0.7
						end
					end
					self.skills[i] = {
						skillIdx = skillIdx,
						sprite = self.skillSprite[i],
						level = skillLevel,
						skillType = sk.skillType,
						cd = cdTime,
						enable = true, 
						skillBox = self:createSkillBox(i,self.skillSprite[i])--加入技能动态框
					}
					--self.skills[i].cd = 1--技能cd都变为1秒
					if NEW_GUIDE and GameData.guide.level2 == false and g_playScene.level == 102 then
						local size = self.skillSprite[i]:getContentSize()
						local lock = display.newSprite("#skillIconLock.png",size.width*0.5, size.height*0.5)
						self.skillSprite[i]:addChild(lock)
					end
				end
			end
			--新手引导
			if NEW_GUIDE and GameData.guide.level1 == false and g_playScene.level == 101 then
				if self.heroIcon:isVisible() then
					self.heroIcon:setVisible(false)
				end
				self.skillSprite[i]:setVisible(false)
			end
		end
	end
	--任务
	if g_playScene.task then
		local userData = GameData.levelTask[""..g_playScene.level]
		self.taskIcons = {}
		for i = 1, #g_playScene.task.tasks do
			local complete = userData[""..i]
			local taskType = g_playScene.task.tasks[i].type
			if VERSION_MONSTER then
				local task = g_playScene.task.tasks[i]
				if task.type == 1 or task.type == 2 or task.type == 6 or task.type == 10 or task.type == 11 then--炮塔
					self.taskIcons[i] = display.newSprite("#taskTowerIcon"..task.towerIdx..".png")
				elseif task.type == 8 then--所有炮塔
					self.taskIcons[i] = display.newSprite("#taskTowerIcon1.png")
				elseif task.type == 7 or task.type == 14 then--英雄
					self.taskIcons[i] = display.newSprite("#taskHeroIcon"..GameData.selectHero..".png")
				elseif task.type == 3 or task.type == 5 or task.type == 9 or task.type ==  12 or task.type ==  13 then--道具
					self.taskIcons[i] = display.newSprite("#taskThingIcon.png")
				elseif task.type == 4 then--金钱
					self.taskIcons[i] = display.newSprite("#taskMoneyIcon.png")
				elseif task.type == 15 then
					self.taskIcons[i] = display.newSprite("#littleTaskIcon5.png")
				end
				if task.type == 15 then
					self.taskIcons[i]:setScale(0.81)
				else
					self.taskIcons[i]:setScale(0.75)
				end
				self.taskIcons[i]:setPosition(display.cx - 450 + i * 75, 42)
			else
				local taskX,taskY
				if VERSION_REDUCE then
					taskX = display.cx - 430 + i * 65
					taskY = 32
				else
					taskX = 32
					taskY = display.cy -120 + i*65
				end
				self.taskIcons[i] = display.newSprite("#"..TaskTypeData[taskType].pic)
				self.taskIcons[i]:setPosition(taskX,taskY)
			end
				
			if not complete then
				self.taskIcons[i]:setColor(cc.c3b(128, 128, 128))
			end
			self.taskIcons[i].idx = i
			self.taskIcons[i].taskType = taskType
			self:addChild(self.taskIcons[i])
		end
	end
	if not VERSION_REDUCE then
		--道具
		self.items = {}
		self.itemSprite = {}
		self.itemNum = {}
		self.itemNumBgBar = {}
		for i = 1, #ItemData do
			self.itemSprite[i] = display.newSprite("#"..ItemData[i].pic2,display.cx - 430 + i * 80,38)
			self:addChild(self.itemSprite[i],1)
			--未解锁道具蒙灰
			if not GameData.item["i"..i].isUnLock then
				self.itemSprite[i]:setColor(cc.c3b(128, 128, 128))
				local size = self.itemSprite[i]:getContentSize()
				local lock = display.newSprite("#skillIconLock.png",size.width*0.5, size.height*0.5)
				self.itemSprite[i]:addChild(lock)
			else
				self.itemNumBgBar[i] = display.newSprite("#pre_itemNumBg.png",self.itemSprite[i]:getContentSize().width-15,self.itemSprite[i]:getContentSize().height-15)
				self.itemSprite[i]:addChild(self.itemNumBgBar[i],15)
				self.itemNum[i] = cc.ui.UILabel.new({
		            UILabelType = 1,
		            font = "fontTitleNumber.fnt",
		            text = ""..GameData.item["i"..i].number,
		            x = self.itemNumBgBar[i]:getContentSize().width/2,
		            y = self.itemNumBgBar[i]:getContentSize().height/2-2,
		            }):align(display.CENTER)
				self.itemNum[i]:setScale(0.7)
		        self.itemNumBgBar[i]:addChild(self.itemNum[i])
		        if GameData.item["i"..i].number == 0 then
		        	self.itemNumBgBar[i]:setVisible(false)
			    end
			end
			local cdTime = ItemData[i].cd
			self.items[i] = {
				sprite = self.itemSprite[i],
				cd = cdTime,
				enable = true, 
				isUnLock = GameData.item["i"..i].isUnLock,
				skillBox = nil--加入技能动态框
			}
		end
	end
end

function HeroSkillLayer:createSkillBox(idx,obj)
	local Box
	Box = display.newSprite("#skillBox.png")
	Box:setPosition(obj:getPosition())
	self:addChild(Box)
	Box:runAction(cc.RepeatForever:create(
		transition.sequence({
        		transition.fadeOut(Box, {time = 0.5}),
        		transition.fadeIn(Box, {time = 0.5})
    		})
		))
	return Box
end

function HeroSkillLayer:setTask(idx, complete, fail)
	for i = 1, #self.taskIcons do
		if self.taskIcons[i].idx == idx then
			if complete then
				self.taskIcons[i]:setColor(cc.c3b(255,255,255))
				local sprite = display.newSprite("#taskfinish1.png")
				sprite:setPosition(self.taskIcons[i]:getContentSize().width/2,self.taskIcons[i]:getContentSize().height/2)
				self.taskIcons[i]:addChild(sprite,5)
				sprite:setScale(1.5)
				local frames = display.newFrames("taskfinish%d.png", 1, 5)
			    local animation = display.newAnimation(frames, 0.1)
			    sprite:playAnimationOnce(animation,true) 	
			elseif fail then
				local cryIcon = display.newSprite("#taskFailCry.png",self.taskIcons[i]:getContentSize().width/2,self.taskIcons[i]:getContentSize().height/2)
				self.taskIcons[i]:addChild(cryIcon,5)
			end
			break
		end
	end

end
function HeroSkillLayer:taskTouchArea(x,y)
	if VERSION_REDUCE then
		if x > display.cx - 410 and x < display.cx - 200 and y < LAYER_HEIGHT then
			return true
		end
	else
		if y > display.cy-80 and y < display.cy + 180 and x < LAYER_WIDTH then
			return true
		end
	end
	return false
end
function HeroSkillLayer:showItem()
	if self.itemLayer == nil then
		self.itemLayer = display.newLayer()
		g_playScene:addChild(self.itemLayer,6000)
		local grayBg = display.newColorLayer(cc.c4b(0,0,0,128))
		self.itemLayer:addChild(grayBg)
		self.itemLayer:setTouchEnabled(true)
		self.itemLayer:setTouchSwallowEnabled(true)
		self.purchaseItemLayer = PurchaseItemLayer.new()
		self.itemLayer:addChild(self.purchaseItemLayer)
	else
		self.itemLayer:setVisible(true)
	end
	self.paused = false
	if not g_playScene.pause then 
		self.paused = true
		g_playScene:suspend(true)
	end
end
function HeroSkillLayer:useItem(i)
	--label的一些显示变化
	if self.items[i].enable then
		--道具作用
		local isreturn = self:executeItem(i)
		if isreturn then return end
		--DataEye
			 --厦门
        -- if device.platform == "android" or device.platform == "ios" then
        -- 	local itemId = kkFunc.getVersionPrepareText("道具",i)
        --     DCItem.consume(itemId, "消耗品", 1, "更快通关")
        -- end
        	 --厦门
		GameData.item["i"..i].number = GameData.item["i"..i].number -1
		self.itemNum[i]:setString(""..GameData.item["i"..i].number)
		if self.purchaseItemLayer ~= nil then
			self.purchaseItemLayer.titleNum[i]:setString(""..GameData.item["i"..i].number)
		end
		if GameData.item["i"..i].number == 0 then
			self.itemNumBgBar[i]:setVisible(false)
			if self.purchaseItemLayer ~= nil then
				self.purchaseItemLayer.itemNumBg[i]:setVisible(false)
			end
		end
		--CD进度条
		self:progressSkillandItem(i,self.items[i])
		--检查使用道具
		AchievementData.checkUseItem()
		GameState.save(GameData)
	end
end
function HeroSkillLayer:executeItem(i)
	if i == 1 then --增加200点圣水
		g_playScene:changeMoney(200, true)
	elseif i == 2 then --守护生命立即回复3点
		if GameData.selectHero ~= 4 then
			if g_playScene.heartNum == 10 then
				local titleNum = cc.ui.UILabel.new({
		            UILabelType = 2,
		            font = "fontCommon.TTF",
		            text = "血量已满",
		            color = cc.c3b(255,0,0),
		            size = 32,
		            x = display.cx,
		            y = display.cy,
		            }):align(display.CENTER)
		        self:addChild(titleNum,100)
		        titleNum:runAction(transition.sequence({
		        		cc.DelayTime:create(1),
		        		cc.FadeOut:create(0.5)
		        	}))
		        return true
			elseif (g_playScene.heartNum + 3) >= 10 then
				g_playScene:setHeart(10,true)
			else
				g_playScene:setHeart(g_playScene.heartNum + 3,true)
			end
		else
			if g_playScene.heartNum == 13 then
				local titleNum = cc.ui.UILabel.new({
		            UILabelType = 2,
		            font = "fontCommon.TTF",
		            text = "血量已满",
		            color = cc.c3b(255,0,0),
		            size = 32,
		            x = display.cx,
		            y = display.cy,
		            }):align(display.CENTER)
		        self:addChild(titleNum,100)
		        titleNum:runAction(transition.sequence({
		        		cc.DelayTime:create(1),
		        		cc.FadeOut:create(0.5)
		        	}))
		        return true
			elseif (g_playScene.heartNum + 3) >= 13 then
				g_playScene:setHeart(13,true)
			else
				g_playScene:setHeart(g_playScene.heartNum + 3,true)
			end
		end
	elseif i == 3 then --立即复活英雄
		return self:endHeroProgress()
	elseif i == 4 then --英雄攻击,攻击速度增加5%，持续15秒，外形放大
		if g_playScene.hero.state == "dead" then
	        return true
		else
			g_playScene.hero:heroAnger()
		end
	end
	return false
end
function HeroSkillLayer:onTouch(event, x, y)
	--print(event,x,y)
	if event == "began" then
		--点道具
		if not VERSION_REDUCE then
			for i = 1, #self.items do
				--做逻辑处理1钱不足2钱够弹出购买界面道具达到上限
				local rect = self.items[i].sprite:getCascadeBoundingBox()
				if cc.rectContainsPoint(rect, cc.p(x,y)) then	
					if self.items[i].isUnLock then --解锁
						if GameData.item["i"..i].number == 0 then --道具数量为0可购买
							self:showItem()
						else--非0点击后使用道具
							self:useItem(i)
						end
					else
						local titleNum = cc.ui.UILabel.new({
				            UILabelType = 2,
				            font = "fontCommon.TTF",
				            text = "道具未解锁",
				            color = cc.c3b(255,0,0),
				            size = 32,
				            x = display.cx,
				            y = display.cy,
				            }):align(display.CENTER)
				        self:addChild(titleNum,100)
				        titleNum:runAction(transition.sequence({
				        		cc.DelayTime:create(1),
				        		cc.FadeOut:create(0.5)
				        	}))
					end
					return false, true
				end
			end
		end
		--点任务
		if self:taskTouchArea(x,y) then
			if g_playScene.task then
            	g_playScene.task:show()
            	return false, true
            end
	    end
		if g_playScene.pause then 
		    if NEW_GUIDE and g_playScene.newbieguidelayer ~= nil and GameData.guide.level1 == true then
	    	else
				return false
			end
		end
		if NEW_GUIDE and g_playScene.newbieguidelayer ~= nil and g_playScene.newbieguidelayer.heroSkillControl == false and g_playScene.level == 102 and GameData.guide.level2 == false then 
			return
		end
	    if g_playScene.hero.state == "dead" or g_playScene.hero.state == "skilling" then return false end
		for i = 1, #self.skills do
			local rect = self.skills[i].sprite:getCascadeBoundingBox()
			if cc.rectContainsPoint(rect, cc.p(x,y)) then
				if not self.skills[i].enable then 
					return false, true
				end
				--技能动态框移除
				self.skills[i].skillBox:removeFromParent()
				if self.skills[i].skillType == 1 then
					--按下就释放
					self:executeSkill(i)
					return false, true
				else
					--要拖动，等后续事件
					self.selectedSkill = i
					if self.skills[self.selectedSkill].skillIdx == 5 then
						self.skillMovePic = display.newSprite("#heroSkillCircle.png")
					else
						self.skillMovePic = display.newSprite("#"..SkillData[self.skills[i].skillIdx].pic2)
					end
					self.skillMovePic:setPosition(cc.p(x,y))
					self:addChild(self.skillMovePic,2)
					self.skillMoveReady = false --是否能正常释放
					self.skillMovePic:setColor(cc.c3b(128,128,128))
					--拖动技能提示
					if self.tip ~= nil then
						self.tip:removeFromParent()
					end
					--拖动技能提示
					self.tip = display.newSprite("#skillTipDrag.png",display.cx,110)
					self:addChild(self.tip,1)
					return true
				end
			end
		end
		--其他点在技能栏上的都吞掉。
		if x > display.cx - 450 and x < display.cx + 450 and y < LAYER_HEIGHT then return false, true end
		return false, false --前面的处理都要吞噬。这是没点在技能栏上。
	elseif event == "moved" then
		self:checkMoveSkillPosition(x,y)
	elseif event == "ended" then
		--skill9
		if self.moveLine ~= nil then
			self.moveLine:removeFromParent()
			self.moveLine = nil
		end
		self.skillMovePic:removeFromParent()
		self.skillMovePic = nil
		if y > 70 and self.skillMoveReady then
			if self.skills[self.selectedSkill].skillIdx == 9 then				
				self:executeSkill(self.selectedSkill, self.midPos)
			elseif self.skills[self.selectedSkill].skillIdx == 13 then
				if self:throwBomb(cc.p(x,y)) then
					self:executeSkill(self.selectedSkill, cc.p(x,y))
				else
					self.skills[self.selectedSkill].skillBox = self:createSkillBox(self.selectedSkill,self.skillSprite[self.selectedSkill])--重新加入技能动态框
				end
			else
				self:executeSkill(self.selectedSkill, cc.p(x,y))
			end
		else 
			self.skills[self.selectedSkill].skillBox = self:createSkillBox(self.selectedSkill,self.skillSprite[self.selectedSkill])--重新加入技能动态框
		end
		self.selectedSkill = nil
		--移除提示
		self.tip:runAction(transition.sequence({
			 cc.FadeOut:create(0.5),
			 cc.CallFunc:create(function()
			 	self.tip:removeFromParent()
			 	self.tip = nil
			 end)
		}))
	end
end

--拖动技能位置判断
function HeroSkillLayer:checkMoveSkillPosition(x,y)
	self.skillMovePic:setPosition(cc.p(x,y))
	if MapInfo:isPosInMapRange(cc.p(x,y)) then
		if not self.skillMoveReady then
			self.skillMoveReady = true
			self.skillMovePic:setColor(cc.c3b(255,255,255))
		end
	else
		if self.skillMoveReady then
			self.skillMoveReady = false
			self.skillMovePic:setColor(cc.c3b(128,128,128))
		end
	end
	if not self.skillMoveReady then 
		if self.moveLine ~= nil then
			self.moveLine:removeFromParent()
			self.moveLine = nil
		end
		return 
	end
	if self.skills[self.selectedSkill].skillIdx == 9 then
		if y > 70 and self.skillMoveReady then
			self.skillMovePic:setVisible(false)
		else
			self.skillMovePic:setVisible(true)
		end
		self:redrawLine(cc.p(g_playScene.hero:getPosition()),cc.p(x,y))
	end
end

--提莫放炸弹位置判断
function HeroSkillLayer:throwBomb(p)
	local tilePt = MapInfo:getTilePositionInCCP(p)
	local road = MapInfo:checkTileRoadValid(tilePt)
    local waterWay = MapInfo:checkWaterWay(tilePt)
    return road or waterWay
end

function HeroSkillLayer:redrawLine(p1,p2)
    MapInfo:adjustPosInMapRange(p2)
	if self.moveLine ~= nil then
		self.moveLine:removeFromParent()
		self.moveLine = nil
	end
	self.midPos = p2
	local dist = cc.pGetDistance(p1, p2)
	if dist >300 then
	    local sub = cc.pSub(p1,p2)
	    local pcent = 300/dist
	    local dx = sub.x*pcent
	    local dy = sub.y*pcent
	    self.midPos = cc.p(p1.x-dx,p1.y-dy)
	end
	--[[self.moveLine = display.newLine({
			[1] = {p1.x, p1.y},
			[2] = {self.midPos.x, self.midPos.y},
	},
	{
		borderColor = cc.c4f(0.5, 0.5, 0.0, 1.0),
	    borderWidth = 3,
	})]]
	self.moveLine = display.newSprite("#heroSkillLine.png")
	if self.maxLine == nil then
		self.maxLine = self.moveLine:getContentSize().height
	end
	self.moveLine:setPosition(p1)
	self.moveLine:setAnchorPoint(cc.p(0.5,0))
	local dest = cc.p(p1.x - self.midPos.x,
			 	p1.y - self.midPos.y)
	local z = math.sqrt(dest.x*dest.x +dest.y*dest.y)
	local rt = kkFunc.getLineRotation(p1, self.midPos)
	self.moveLine:setRotation(rt)
	self.moveLine:setScaleY(z/self.maxLine)
	self:getParent():addChild(self.moveLine, BaseZOrder.hero)
end

function HeroSkillLayer:executeSkill(idx, pos)
	if g_playScene.hero.angerTime ~= nil then
 		g_playScene.hero:cancleHeroAnger()
	end
	AchievementData.checkUseSkill()
	if NEW_GUIDE and g_playScene.newbieguidelayer ~= nil and g_playScene.newbieguidelayer.heroSkillControl == true and GameData.guide.level1 == true then
		g_playScene.newbieguidelayer:goLevel2(5)
	end
	self:progressSkillandItem(idx,self.skills[idx])
	local skill = Skills[self.skills[idx].skillIdx].new({
		idx = self.skills[idx].skillIdx,
		pos = pos,
	})
	g_fightLayer:addChild(skill, BaseZOrder.hero)
end

function HeroSkillLayer:progressSkillandItem(idx,obj)
	local progressPic,skillboxSprite
	if self.skills[idx] == obj then
		progressPic = "#"..SkillData[self.skills[idx].skillIdx].pic2
		skillboxSprite = self.skillSprite[idx]
	else
		progressPic = "#"..ItemData[idx].pic2
		skillboxSprite = self.itemSprite[idx]
	end
	local proTo = cc.ProgressTo:create(obj.cd, 100)
    obj.progress = cc.ProgressTimer:create(display.newSprite(progressPic))
    obj.progress:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)--cc.PROGRESS_TIMER_TYPE_BAR
    --self.skills[idx].progress:setMidpoint(cc.p(0.5,0))
    --self.skills[idx].progress:setBarChangeRate(cc.p(0,1))
    local size = obj.sprite:getContentSize()
    obj.progress:setPosition(cc.p(size.width*0.5,size.height*0.5))
    local seq = transition.sequence({
		proTo,
    	cc.CallFunc:create(function()
			local sprite = display.newSprite("#cdEffect.png",obj.sprite:getContentSize().width/2,obj.sprite:getContentSize().height/2+5)
			sprite:setOpacity(0)
			obj.sprite:addChild(sprite,5)
			sprite:runAction(transition.sequence({
					cc.FadeIn:create(0.4),
					cc.FadeOut:create(0.4),
					cc.FadeIn:create(0.4),
					cc.FadeOut:create(0.4),
				}))
			obj.sprite:setColor(cc.c3b(255,255,255))
			obj.enable = true
			obj.progress:removeFromParent()
			obj.progress = nil
			if self.skills[idx] == obj then
				obj.skillBox = self:createSkillBox(idx,skillboxSprite)--重新加入技能动态框
			end
		end)
    })
    obj.progress:runAction(seq)
    obj.enable = false
	obj.sprite:setColor(cc.c3b(58,58,58))
	obj.sprite:addChild(obj.progress,11)
end

function HeroSkillLayer:suspendProgress()
	for i = 1, #self.skills do
		if self.skills[i].progress ~= nil then
			self.skills[i].progress:stopAllActions()
		end
	end
	if not VERSION_REDUCE then
		if self.items ~= nil then
			for i = 1, #self.items do
				if self.items[i].progress ~= nil then
					self.items[i].progress:stopAllActions()
				end
			end
		end
	end
	if self.heroIcon.progress ~= nil then
		self.heroIcon.progress:stopAllActions()
		transition.pauseTarget(self)--暂停复活效果
	end
end

function HeroSkillLayer:resumeProgress()
	for i = 1, #self.skills do
		if self.skills[i].progress ~= nil then
			local pcent = self.skills[i].progress:getPercentage()
			local t = self.skills[i].cd*(100-pcent)/100
			local proTo = cc.ProgressTo:create(t, 100)
			local seq = transition.sequence({
				proTo,
    			cc.CallFunc:create(function() 
    				local sprite = display.newSprite("#cdEffect.png",self.skills[i].sprite:getContentSize().width/2,self.skills[i].sprite:getContentSize().height/2+5)
    				sprite:setOpacity(0)
    				self.skills[i].sprite:addChild(sprite,5)
    				sprite:runAction(transition.sequence({
    						cc.FadeIn:create(0.4),
    						cc.FadeOut:create(0.4),
    						cc.FadeIn:create(0.4),
    						cc.FadeOut:create(0.4),
    					}))
					self.skills[i].sprite:setColor(cc.c3b(255,255,255))
					self.skills[i].enable = true
					self.skills[i].progress:removeFromParent()
					self.skills[i].progress = nil
					self.skills[i].skillBox = self:createSkillBox(i,self.skillSprite[i])--重新加入技能动态框
				end)
    		})
    		self.skills[i].progress:runAction(seq)
		end
	end
	if not VERSION_REDUCE then
		if self.items ~= nil then
			for i = 1, #self.items do
				if self.items[i].progress ~= nil then
					local pcent = self.items[i].progress:getPercentage()
					local t = self.items[i].cd*(100-pcent)/100
					local proTo = cc.ProgressTo:create(t, 100)
					local seq = transition.sequence({
						proTo,
		    			cc.CallFunc:create(function() 
		    				local sprite = display.newSprite("#cdEffect.png",self.items[i].sprite:getContentSize().width/2,self.items[i].sprite:getContentSize().height/2+5)
		    				sprite:setOpacity(0)
		    				self.items[i].sprite:addChild(sprite,5)
		    				sprite:runAction(transition.sequence({
		    						cc.FadeIn:create(0.4),
		    						cc.FadeOut:create(0.4),
		    						cc.FadeIn:create(0.4),
		    						cc.FadeOut:create(0.4),
		    					}))
							self.items[i].sprite:setColor(cc.c3b(255,255,255))
							self.items[i].enable = true
							self.items[i].progress:removeFromParent()
							self.items[i].progress = nil
						end)
		    		})
		    		self.items[i].progress:runAction(seq)
				end
			end
		end
	end
	if self.heroIcon.progress ~= nil then
		local pcent = self.heroIcon.progress:getPercentage()
		local t = self.heroData.rebornCD*(100-pcent)/100
		local proTo = cc.ProgressTo:create(t, 100)
		local seq = transition.sequence({
			proTo,
			cc.CallFunc:create(function() 
				self.heroIcon:setColor(cc.c3b(255,255,255))
				g_playScene.hero:reborn()
				self.heroIcon.progress:removeFromParent()
				self.heroIcon.progress = nil
			end)
		})
		self.heroIcon.progress:runAction(seq)
		transition.resumeTarget(self)--恢复复活效果
	end
end

--测试用，直接结束CD
function HeroSkillLayer:endProgress()
	for i = 1, #self.skills do
		if self.skills[i].progress ~= nil then
			self.skills[i].progress:stopAllActions()
			self.skills[i].sprite:setColor(cc.c3b(255,255,255))
			self.skills[i].enable = true
			self.skills[i].progress:removeFromParent()
			self.skills[i].progress = nil
		end
	end
end

function HeroSkillLayer:heroDeadProgress()
	local progressTime = self.heroData.rebornCD
	if VERSION_REDUCE then
		if self.items[3] == true then
			progressTime = progressTime/2
		end
	end
	local proTo = cc.ProgressTo:create(progressTime, 100)
    self.heroIcon.progress = cc.ProgressTimer:create(display.newSprite("#"..self.heroData.icon))
    self.heroIcon.progress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    self.heroIcon.progress:setMidpoint(cc.p(0.5,0))
    self.heroIcon.progress:setBarChangeRate(cc.p(0,1))
    local size = self.heroIcon:getContentSize()
    self.heroIcon.progress:setPosition(cc.p(size.width*0.5,size.height*0.5))
    local seq = transition.sequence({
		proTo,
    	cc.CallFunc:create(function() 
			self.heroIcon:setColor(cc.c3b(255,255,255))
			g_playScene.hero:reborn()
			if not VERSION_REDUCE then
				--英雄复活狂暴道具恢复
				self.items[4].sprite:setColor(cc.c3b(128,128,128))
			end
			self.heroIcon.progress:removeFromParent()
			self.heroIcon.progress = nil
		end)
    })
    self.heroIcon.progress:runAction(seq)
	self.heroIcon:setColor(cc.c3b(58,58,58))
	self.heroIcon:addChild(self.heroIcon.progress,11)
	self:PlayRebornEffect(progressTime)
end
--测试用，直接结束CD,英雄直接复活道具3
function HeroSkillLayer:endHeroProgress()
	if g_playScene.hero.state ~= "dead" then 
		local titleNum = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = "英雄未阵亡",
            color = cc.c3b(255,0,0),
            size = 32,
            x = display.cx,
            y = display.cy,
            }):align(display.CENTER)
        self:addChild(titleNum,100)
        titleNum:runAction(transition.sequence({
        		cc.DelayTime:create(1),
        		cc.FadeOut:create(0.5)
        	}))
        return true
	end
	g_playScene.hero:rebornEffect()
	self:performWithDelay(function()
		if self.heroIcon.progress ~= nil then
			self.heroIcon.progress:stopAllActions()
			self.heroIcon:setColor(cc.c3b(255,255,255))
			self.heroIcon.progress:removeFromParent()
			self.heroIcon.progress = nil
		end
		g_playScene.hero:reborn()
	end, 0.2)
end
function HeroSkillLayer:PlayRebornEffect(time)
	if time < 0.2 then
		g_playScene.hero:rebornEffect()
	else
		local seq = transition.sequence({
				cc.DelayTime:create(time-0.2),
				cc.CallFunc:create(function ()
					g_playScene.hero:rebornEffect()
				end)
			})
		self:runAction(seq)
	end	
end

return HeroSkillLayer