--
-- Author: KK
-- Date: 2014-07-29 11:28:08
--

local IceLayer = class("IceLayer", function()
    return display.newLayer()
end)

local ICE_TOUCH = false
local ICE_MODE = 4
function IceLayer:ctor(mode)
    g_playScene:changeSpeedNormal()
    if ICE_TOUCH then
        -- 注册touch事件处理函数
        self:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
                return self:onTouch(event)
            end)
        self:setTouchEnabled(true)
    else
        cc.Device:setAccelerometerEnabled(true)
        cc.Device:setAccelerometerInterval(0.1)
        local function didAccelerate(event,x,y,z,timestamp)
            local gx = x*9.81
            local gy = y*9.81
            if math.abs(gx) > 10 or math.abs(gy) > 10 then
                self:onTouch({name="began"})
                if self.count < 5 then
                    self:runAction(transition.sequence({
                        cc.CallFunc:create(function()
                            cc.Device:setAccelerometerEnabled(false)
                        end),
                        cc.DelayTime:create(0.5),
                        cc.CallFunc:create(function()
                            cc.Device:setAccelerometerEnabled(true)
                            cc.Device:setAccelerometerInterval(0.1)
                        end),
                    }))
                end
            end
        end
        local listener = cc.EventListenerAcceleration:create(didAccelerate)
        cc.Director:getInstance():getEventDispatcher():addEventListenerWithSceneGraphPriority(listener, self)
    end
    self.icePen = {}
    self.canTouch = false
    self:show()
    ICE_MODE = mode or 4

    self.breaked = false
    self:performWithDelay(function()
        self:breakIce()
    end, 10)
end

function IceLayer:onTouch(event)
    if event.name == "began" then
        if not self.canTouch then return end
        self.count = self.count or 0
        self.count = self.count + 1
        --音效
        SoundManager.playSound(GAME_SOUND.IceBreak[self.count])

        self:runAction(transition.sequence({
            --[[
            cc.MoveBy:create(0.05, cc.p(5,0)),
            cc.MoveBy:create(0.1, cc.p(-10,0)),
            cc.MoveBy:create(0.1, cc.p(10,0)),
            cc.MoveBy:create(0.05, cc.p(-5,0)),
            --]]
            ---[[
            cc.MoveBy:create(0.03, cc.p(0,4)),
            cc.MoveBy:create(0.06, cc.p(0,-8)),
            cc.MoveBy:create(0.06, cc.p(0,8)),
            cc.MoveBy:create(0.03, cc.p(0,-4)),
            --]]
        }))
        if ICE_MODE < 4 then
            --笔刷
            self.icePen[#self.icePen+1] = display.newSprite("#icePen.png", event.x, event.y)
            self:addChild(self.icePen[#self.icePen])
            self.icePen[#self.icePen]:setRotation(math.random(0,360))

            if self.count >= 3 then
                self.canTouch = false
                self:breakIce()
            end
            if ICE_MODE == 1 then
                self.iceLine:setOpacity(self.count*50+5)
            end
        elseif ICE_MODE == 4 then
            if self.count >= 3 then
                self.canTouch = false
                self:breakIce()
                return
            end
            local frame = display.newSpriteFrame("icePic"..self.count..".png")
            self.icePic:setSpriteFrame(frame)
        end
    end
end

--1、8、9、3、10、2、7、4、6、5
local IcePos = {
    [1] = {display.cx-568, display.cy-73},
    [2] = {display.cx-70, display.cy+143},
    [3] = {display.cx-62, display.cy-359},
    [4] = {display.cx-423, display.cy-35},
    [5] = {display.cx+251, display.cy-281},
    [6] = {display.cx-568, display.cy-360},
    [7] = {display.cx+61, display.cy-128},
    [8] = {display.cx-219, display.cy-232},
    [9] = {display.cx-70, display.cy-45},
    [10] = {display.cx-27, display.cy-231},
}
local IceTime = {
    [1] = 1, --1,
    [2] = 5,--2,
    [3] = 5,--2,
    [4] = 9,--3,
    [5] = 5,--2,
    [6] = 1, --1,
    [7] = 9,--3,
    [8] = 12,--4,
    [9] = 14,--5,
    [10] = 16,--6,
}
local IceTime2 = {
    [1] = 2, --1,
    [2] = 2,--2,
    [3] = 2,--2,
    [4] = 1.5,--3,
    [5] = 2,--2,
    [6] = 2, --1,
    [7] = 1.5,--3,
    [8] = 1,--4,
    [9] = 1,--5,
    [10] = 1,--6,
}
function IceLayer:show()
    if ICE_MODE < 4 then
        self.ice = {}
        for i = 1, 10 do
            local time = 0
            if i > 6 then time = 2 end
            self.ice[i] = display.newSprite("#shakeIce"..i..".png", unpack(IcePos[i]))
            self.ice[i]:setAnchorPoint(0,0)
            self:addChild(self.ice[i])
            self.ice[i]:setOpacity(0)
            if i < 10 then
                self.ice[i]:runAction(transition.sequence({
                    --cc.DelayTime:create(IceTime[i]*0.2),
                    cc.FadeIn:create(2),
                }))
            else
                self.ice[i]:runAction(transition.sequence({
                    --cc.DelayTime:create(IceTime[i]*0.2),
                    --cc.DelayTime:create((i-1)*0.2),
                    cc.FadeIn:create(2),
                    cc.CallFunc:create(function()
                        self.canTouch = true
                    end)
                }))
            end
        end
        self.iceLine = display.newSprite("#shakeIceLine.png",display.cx,display.cy)
        self:addChild(self.iceLine)
        self.iceLine:setOpacity(0)
    elseif ICE_MODE == 4 then
        self.icePic = display.newSprite("#icePic0.png",display.cx,display.cy):addTo(self)
        self.icePic:setScale(2)
        self.icePic:setOpacity(0)
        self.icePic:runAction(transition.sequence({
            --cc.DelayTime:create(IceTime[i]*0.2),
            --cc.DelayTime:create((i-1)*0.2),
            cc.FadeIn:create(2),
            cc.CallFunc:create(function()
                self.canTouch = true
            end)
        }))
    end

    --提示语
    self.tip = g_playScene:getTip({type = "ice"})
    self:addChild(self.tip,5)

    --提示手 首次显示
    self.tipFinger = g_playScene:getTipFinger({type = "ice"})
    if self.tipFinger then
        self:addChild(self.tipFinger,5)
    end
    --音效
    SoundManager.playSound(GAME_SOUND.Frozen)
end

function IceLayer:breakIce()
    if self.breaked then return end
    self.breaked = true
    self:stopAllActions()
    --移除提示
    self.tip:runAction(cc.FadeOut:create(1)) 
    --移除手
    if self.tipFinger then
        self.tipFinger:removeFromParent()
    end
    
    if g_playScene ~= nil then
        g_playScene.iceShowed = false
        g_playScene.iceLayer = nil
    end

    if ICE_MODE == 1 then
        self.iceLine:runAction(cc.FadeOut:create(1))
        for i = 1, 10 do
            local x, y = unpack(IcePos[i])
            self.ice[i]:runAction(transition.sequence({
                cc.DelayTime:create((i-1)*0.1),
                --[[
                cc.RotateBy:create(0.1,10),
                cc.RotateBy:create(0.1,-20),
                cc.RotateBy:create(0.1,20),
                cc.RotateBy:create(0.1,-20),
                --]]
                cc.Spawn:create(
                    cc.MoveBy:create(1, cc.p(0, -900)),
                    cc.FadeOut:create(1)
                ),
                --cc.FadeOut:create(1)
            }))
        end
        for i = 1, #self.icePen do
            self.icePen[i]:runAction(transition.sequence({
                cc.FadeOut:create(1)
            }))        
        end
    elseif ICE_MODE == 2 then
        for i = 1, 10 do
            self.ice[i]:runAction(transition.sequence({
                cc.DelayTime:create(0.5+(i-1)*0.1),
                cc.Spawn:create(
                    cc.MoveBy:create(1, cc.p(0, -900)),
                    cc.FadeOut:create(1)
                    --cc.ScaleTo:create(1, 0.5),
                    --cc.FadeOut:create(1)
                ),
            }))
        end
        for i = 1, #self.icePen do
            self.icePen[i]:runAction(transition.sequence({
                cc.FadeOut:create(1.5)
            }))        
        end
    elseif ICE_MODE == 3 then
        for i = 1, 10 do
            self.ice[i]:removeFromParent()
        end
        for i = 1, #self.icePen do
            self.icePen[i]:removeFromParent()
        end

        local sprite = display.newSprite("#iceBreak1.png",display.cx,display.cy):addTo(self)
        sprite:setScale(2)
        local frames = display.newFrames("iceBreak%d.png", 1, 4)
        local animation = display.newAnimation(frames, 0.1)
        sprite:playAnimationOnce(animation, true)
    elseif ICE_MODE == 4 then
        self.icePic:removeFromParent()
        local sprite = display.newSprite("#iceBreak1.png",display.cx,display.cy):addTo(self)
        sprite:setScale(2)
        local frames = display.newFrames("iceBreak%d.png", 1, 8)
        local animation = display.newAnimation(frames, 0.08)
        sprite:playAnimationOnce(animation, true)
    end

    g_playScene:changeSpeedUser()
    if ICE_TOUCH then
        self:setTouchEnabled(false)
    else
        cc.Device:setAccelerometerEnabled(false)
    end
    self:performWithDelay(function()
        self:removeFromParent()
    end, 2)
end

return IceLayer