

--[[
地图读取说明
内容层：content
	图块属性：way = 1是路, blank = 1是可以放炮塔,
			  blank = 0禁用可以用特殊块，不显示。
道具层：things 如果没有道具，就把这一层删掉。
	图块属性：只有thingIdx一个属性。
			  数值定义在lua中：
			  		hp血量，money回收金币，
			  		width,height表示道具长宽，不写就是1。
对象层：objs
	单条路的只需加start
	多条路的需要way1_0,way1_1...way2_0,way2_1...（终点应该是同一块）
	(还是直接加图块上了)道具也放到对象层上了名字是thing，属性为idx。放在道具左右角那格上。
			  数值定义在lua中：
			  		hp血量，money回收金币，
			  		width,height表示道具长宽，不写就是1。
	浮冰加floatWay。属性hp是血量，不填是100
	水面加water。
	水路加waterWay。
	竹笋怪加E45。属性wayIdx表示在哪一条路上，默认1。
				 wave表示第几波出，默认1。
				 delay表示延时几秒，默认0。growTime表示几秒钟长出，默认20。
				 hp表示血量，不填为标准血量。
	可打击出怪点加hitableStrangePoint。属性width/height表示占几格，wayIdx是哪条路。
	------
	水面上的放置点都加waterTowerSeat，打完道具出放置点的也加。
	预设塔加preTower，属性towerIdx和level表示塔的编号和等级。
	道具打完出塔，在道具位置加openTower，属性towerIdx和level表示塔的编号和等级。
	加thingBomb。打掉道具出炸弹，炸周围一圈道具。
	如果有hero，所在格中心就是英雄初始位置，没有就取屏幕中心。
	如果有heart，守护点血量就在指定位置，没有就在守护点上方。
--]]

s_mapTileSize = 0
local HpBar = import("..sprites.HpBar")

local MapInfo = {
	tileSize,
	left,right,top,bottom,
	mapBg,
	mapBg2,
	map,
	mapPos,
	endPos, --守护点ccp
	endTilePt, --守护点tilePt
	ways = {}, --tile座标点
	allWayTile = {}, --用来记录所有路的点，方便随机取
	things = {
		normalThingCount = 0, --道具总数，清除所有道具任务里用到。
	},
	hitableStrangePoint, --things中的一个，单独放出
	wayPoints = {
		startPos, 
	}, --像素点
	tileType = {}, 	--记录所有地图块的类型。方便索引判断。
				  	--目前有way,thing,floatWay,water,thingAndWater
	updateThings = {}, --浮冰需要重现。--暂时无用，改成progress。
	actSprites = {}, --加入的需要暂停的动作。
	E45 = {}, --竹笋怪
	preTowers = {}, --地图里预设塔。
	openTowers = {}, --打掉道具出的塔。
	waterTowerSeats = {}, --水面上道具打完出放置点
	thingBomb = {}, --打掉道具出炸弹，炸周围一圈道具。
	heroPos, --英雄初始位置，没有就在屏幕中间。
	heartPos, --守护点血量指定位置，没有就在守护点上方。
}

--[[
--things结构
things = {
	hpBar = hpBar,
	tilePt = tilePt,
	pos = pos,
	rect = rect,
	thingIdx = params.thingIdx,
	maxHp = hp,
	hp = hp,
	money = money,
	width = width,
	height = height,
	part = false,
	thingType = params.thingType, --0是普通道具，1是浮冰，2是可打击出怪口。
	fill = params.fill, --浮冰有没被填
	wayIdx = params.wayIdx, --火山出怪点
	sprite = params.sprite,
}

--tilePt结构
tileType = {
	name = "thing", --"way","floatWay","water","thing"
	value = self.things[#self.things], --或空
	wayDist = {--只有way和floatWay有。
		[1] = 9999, --是不在这条路上
		[2] = 2,--第几格
	}
}

--]]

function MapInfo:init()
	self.tileSize = self.map:getTileSize().width
	s_mapTileSize = self.tileSize
	self:getMapPosRange()--上下左右边界，英雄移动用到。
	self.ways = {}
	self.things = {}
	self.things.normalThingCount = 0
	self.tileType = {}
	self.updateThings = {}
	self.actSprites = {} --self.map清空后这也清了。
	self.E45 = {}
	self.preTowers = {}
	self.openTowers = {} --打掉道具出的塔。
	self.waterTowerSeats = {}
	self.thingBomb = {}
	self.heroPos = nil
	self.heartPos = nil	

	self:getMapWay() --路径，会设tileType
	self:getThingsOnMap() --道具，会设tileType
	--self:getThingsOnMapByObject() --道具，会设tileType，用对象层
	self:getSomeObjects() --遍历按名字读取object，
						  --水面、水路、浮冰、出怪点(这四个有tileType)、竹笋怪。

	self:getAllWayTileDistance() --tileType是路way/floatWay的加上distance信息

	self:clearNoTouchTiles() --图块属性为blank的不可见。似乎可以不用。
	
	self.scene = self.map:getParent()
	if self.scene.__cname == "PlayScene" then
		--第几主题
		self.mapThemeNum = LevelsData[self.scene.level].theme
		--现在出怪点和守护点的路都不需要隐藏了
		--self:hideStartAndEndOfWays() --隐藏路的开始和结束点。预览地图不隐藏。
    	--支线玩法终点前有红线自动破礼盒。
		if self.scene.giftLevel then
			self:getGiftLevelLines()
		end
	end
	--dump(self.tileType)
end

function MapInfo:removeAll()
	self.ways = {}
end

function MapInfo:getMapForNumbers()
	local c1 = 0
	local c2 = MapInfo.map:getMapSize().width-1
	local r1 = 0
	local r2 = MapInfo.map:getMapSize().height-1
	if r2>8 then
		r1 = 2
		r2 = MapInfo.map:getMapSize().height-3
		c1 = 2
		c2 = MapInfo.map:getMapSize().width-3
	end
	return c1,c2,r1,r2
end

function MapInfo:isPosInMapRange(pt)
	return pt.x >= self.left and pt.x <= self.right and pt.y >= self.bottom and pt.y <= self.top
end

function MapInfo:adjustPosInMapRange(pt)
	if pt.x < self.left then pt.x = self.left end
	if pt.x > self.right then pt.x = self.right end
	if pt.y < self.bottom then pt.y = self.bottom end
	if pt.y > self.top then pt.y = self.top end
end

--测试英雄锁定视角地图移动时用
--[[function MapInfo:adjustMapPosInSceneRange(pt)
	local width = self.mapBg:getContentSize().width
	local height = self.mapBg:getContentSize().height
	local left = width-display.cx
	local right = display.cx - width
	local bottom = height - display.cy
	local top = display.cy - height
	local isChange = false
	if pt.x > left then pt.x = left isChange = true end
	if pt.x < right then pt.x = right isChange = true end
	if pt.y > bottom then pt.y = bottom isChange = true end
	if pt.y < top then pt.y = top isChange = true end

	return isChange	
end]]

function MapInfo:getMapPosRange()
	self.left = - self.mapPos.x
	self.right = 13*self.map:getTileSize().width - self.mapPos.x
	self.bottom = - self.mapPos.y
	self.top = self.map:getMapSize().height * self.map:getTileSize().height - self.mapPos.y
end

function MapInfo:isTilePtInMap(p)
	if p.x < 0 or p.x >= self.map:getMapSize().width
		or p.y < 0 or p.y >= self.map:getMapSize().height then
		return false
	end
	if self.map:getMapSize().height > 7 then
		if p.x < 2 or p.x > 16 then return false end
		if p.y < 2 or p.y > 9 then return false end
	elseif self.map:getMapSize().width > 11 then
		if p.x < 1 or p.x > 11 then return false end
	end
	return true
end

function MapInfo:getTileIdx(p)
	return self.map:getMapSize().width*p.y+p.x
end

--屏幕座标转成地图座标，fromTileMap = true代表地图编辑器里的值。
function MapInfo:getTilePosition(pos, fromTileMap)
	if not fromTileMap then
		local x = (pos.x+self.mapPos.x) / self.map:getTileSize().width
		local y = ((self.map:getMapSize().height * 
			self.map:getTileSize().height) - (pos.y+self.mapPos.y)) / self.map:getTileSize().height
		return math.floor(x), math.floor(y)
	else
		local x = pos.x / self.map:getTileSize().width
		local y = ((self.map:getMapSize().height * 
			self.map:getTileSize().height) - pos.y) / self.map:getTileSize().height
		return math.floor(x), math.floor(y)
	end
end

--屏幕座标转成地图座标cpp，fromTileMap = true代表地图编辑器里的值。
function MapInfo:getTilePositionInCCP(pos, fromTileMap)
	return cc.p(self:getTilePosition(pos, fromTileMap))
end

--获取地图坐标中心对应的屏幕坐标。
function MapInfo:getCenterOfTile(p)
	local pos = cc.p((p.x + 0.5) * self.map:getTileSize().width ,
	  (self.map:getMapSize().height - p.y - 0.5) * self.map:getTileSize().height);
	return cc.p(pos.x - self.mapPos.x, pos.y - self.mapPos.y)
end

--获取单个tile顶部中心位置屏幕坐标。
function MapInfo:getTopOfTile(p)
	local pos = cc.p((p.x+0.5) * self.map:getTileSize().width ,
	  (self.map:getMapSize().height - p.y) * self.map:getTileSize().height);
	return cc.p(pos.x - self.mapPos.x, pos.y - self.mapPos.y)
end

--获取道具的中心位置屏幕坐标。
function MapInfo:getCenterOfThing(thing)
	local px = thing.tilePt.x + thing.width*0.5
	local py = thing.tilePt.y - thing.height*0.5
	local ppx = px * self.map:getTileSize().width
	local ppy = (self.map:getMapSize().height - py-1) * self.map:getTileSize().height
	return cc.p(ppx - self.mapPos.x, ppy - self.mapPos.y)
end

--获取道具的顶部中心位置屏幕坐标。
function MapInfo:getTopOfThing(thing)
	local p = cc.p(thing.tilePt.x + thing.width*0.5, 
				  thing.tilePt.y + 1 - thing.height)
	local pos = cc.p(p.x * self.map:getTileSize().width ,
	  (self.map:getMapSize().height - p.y) * self.map:getTileSize().height);
	return cc.p(pos.x - self.mapPos.x, pos.y - self.mapPos.y)
end

--取路径上随机一点的座标点
function MapInfo:getRandomWayPos()
	local tilePt = self.allWayTile[math.random(1, #self.allWayTile)]

	local pos = MapInfo:getCenterOfTile(tilePt)
	return pos
end

--取得离某点最近的路的中心点，这是改进的，不只算拐点。
function MapInfo:getNearestWayTilePos(pos)
	local dist2 = 1000000
	local nearPos
	local function checkNearTilePt(x,y)
		local pt = self:getCenterOfTile(cc.p(x,y))
		local d2 = cc.pDistanceSQ(pos, pt)
		if d2 < dist2 then
			dist2 = d2
			nearPos = pt
		end
	end
	for i = 1, #self.ways do
		local first = self.ways[i].startPt
		for j = 1,#self.ways[i].way do
			local second = self.ways[i].way[j]
			if first.x == second.x then
				if first.y > second.y then
					for k = first.y, second.y+1, -1 do
						checkNearTilePt(first.x,k)
					end
				else
					for k = first.y, second.y-1 do
						checkNearTilePt(first.x,k)
					end
				end
			elseif first.y == second.y then
				if first.x > second.x then
					for k = first.x, second.x+1, -1 do
						checkNearTilePt(k, first.y)
					end
				else
					for k = first.x, second.x-1 do
						checkNearTilePt(k, first.y)
					end
				end
			end
			first = self.ways[i].way[j]
		end
	end
	return nearPos
end

--取得离某点最近的路的中心点，实际只是拐点。不用了。
function MapInfo:getNearestWayPos(pos)
	local dist2 = 1000000
	local ri,rj = 0,0
	for i = 1, #self.wayPoints do
		for j = 1,#self.wayPoints[i] do
			local d2 = cc.pDistanceSQ(pos, self.wayPoints[i][j])
			if d2 < dist2 then
				dist2 = d2
				ri,rj = i,j
			elseif d2 == dist2 then --距离一样的看哪一个离终点最近
				--print(self.endTilePt.x,self.endTilePt.y)
				--print(self:getTileIdx(self.endTilePt))
				--dump(self.tileType[self:getTileIdx(self.endTilePt)])
				local dists = self.tileType[self:getTileIdx(self.endTilePt)].wayDist
				--最终点最近的距离
				local wayDist1 = self.tileType[self:getTileIdx(self.ways[ri].way[rj])].wayDist
				local wayDist2 = self.tileType[self:getTileIdx(self.ways[i].way[j])].wayDist
				local wd1,wd2 = 99,99
				for k = 1, #dists do
					if wayDist1[k] ~= nil then
						if dists[k] - wayDist1[k] < wd1 then
							wd1 = dists[k] - wayDist1[k]
						end
					end
					if wayDist2[k] ~= nil then
						if dists[k] - wayDist2[k] < wd2 then
							wd2 = dists[k] - wayDist2[k]
						end
					end
				end
				if wd2 < wd1 then
					dist2 = d2
					ri,rj = i,j
				end
			end
		end
	end
	return self.wayPoints[ri][rj]
end

--怪被龙卷风吹完放下，要重算现在往哪个waypoint走。
function MapInfo:getWayPointByPos(wayIdx,pos)
	local way = self.wayPoints[wayIdx]
	for j = 1, #way do
		if j == 1 then 
			pt1 = self:getCenterOfTile(self.ways[wayIdx].startPt)
		else
			pt1 = way[j-1] 
		end
		local pt2 = way[j] 
		--print(pt1.x,pt1.y,pt2.x,pt2.y,pos.x,pos.y)
		if pt1.x == pt2.x then
			if pt1.x == pos.x then
				if pt1.y > pt2.y then
					if pt1.y>=pos.y and pt2.y<=pos.y then
						return j
					end
				else
					if pt1.y<=pos.y and pt2.y>=pos.y then
						return j
					end
				end
			end
		elseif pt1.y == pt2.y then
			if pt1.y == pos.y then
				if pt1.x > pt2.x then
					if pt1.x>=pos.x and pt2.x<=pos.x then
						return j
					end
				else
					if pt1.x<=pos.x and pt2.x>=pos.x then
						return j
					end
				end
			end
		end
	end
	return 0
end

--[[被下面的函数替代了。
--取得从路的起点到该tile点的距离，返回多条路的
function MapInfo:getWayDistanceTo(tilePt)
	--print("To:", tilePt.x,tilePt.y)
	local wayDist = {}
	for i = 1, #self.ways do
		wayDist[i] = 0 
		local arrive = false
		for j = 1, #self.ways[i].way do
			local pt1
			if j == 1 then pt1 = self.ways[i].startPt else pt1 = self.ways[i].way[j-1] end
			local pt2 = self.ways[i].way[j]
			--print("pt1:", pt1.x,pt1.y)
			--print("pt2:", pt2.x,pt2.y)
			--print("tilePt:", tilePt.x,tilePt.y)

			if pt1.x == pt2.x then
				if pt1.x == tilePt.x then
					if pt1.y > pt2.y then
						if pt1.y>tilePt.y and pt2.y<tilePt.y then
							wayDist[i] = wayDist[i] + pt1.y-tilePt.y
							arrive = true
						end
					else
						if pt1.y<tilePt.y and pt2.y>tilePt.y then
							wayDist[i] = wayDist[i] +tilePt.y-pt1.y
							arrive = true
						end
					end
				end
				if not arrive then
					wayDist[i] = wayDist[i] + math.abs(pt1.y-pt2.y)
				end
			elseif pt1.y == pt2.y then
				if pt1.y == tilePt.y then
					if pt1.x > pt2.x then
						if pt1.x>tilePt.x and pt2.x<tilePt.x then
							wayDist[i] = wayDist[i] + pt1.x-tilePt.x
							arrive = true
						end
					else
						if pt1.x<tilePt.x and pt2.x>tilePt.x then
							wayDist[i] = wayDist[i] + tilePt.x-pt1.x
							arrive = true
						end
					end
				end
				if not arrive then
					wayDist[i] = wayDist[i] + math.abs(pt1.x-pt2.x)
				end
			end
			--print(i,j..":",wayDist[i])
			if arrive then
				break
			end
		end
		if not arrive then --没在这条路上（在另一条支路上）
			wayDist[i] = 9999
		end
		--print("wayDist"..i..":"..wayDist[i])
		wayDist[i] = wayDist[i] * self.tileSize
	end
	return wayDist
end
--]]

--从起点到所有way块的tile距离，记录到tileType里
function MapInfo:getAllWayTileDistance()
	for i = 1, #self.ways do
		local nextTilePt = cc.p(self.ways[i].startPt.x,self.ways[i].startPt.y)
		local distCount = -1
		local function checkNextTilePt(dx,dy)
			nextTilePt = cc.p(nextTilePt.x+dx,nextTilePt.y+dy)
			local tileIdx = self:getTileIdx(nextTilePt)
			distCount = distCount + 1
			if self.tileType[tileIdx] ~= nil then
				--print(i,distCount,nextTilePt.x,nextTilePt.y, self.tileType[self:getTileIdx(nextTilePt)].name)
				if self.tileType[tileIdx].wayDist == nil then
					self.tileType[tileIdx].wayDist = {}
				end
				self.tileType[tileIdx].wayDist[i] = distCount
			end
		end
		checkNextTilePt(0,0) --出怪点也记录。

		for j = 1, #self.ways[i].way do
			local dx,dy = 0,0
			if self.ways[i].wayOrient[j] == "right" then
				dx = 1
				while nextTilePt.x < self.ways[i].way[j].x do
					checkNextTilePt(dx,dy)
				end
			elseif self.ways[i].wayOrient[j] == "left" then
				dx = -1
				while nextTilePt.x > self.ways[i].way[j].x do
					checkNextTilePt(dx,dy)
				end
			elseif self.ways[i].wayOrient[j] == "up" then
				dy = -1
				while nextTilePt.y > self.ways[i].way[j].y do
					checkNextTilePt(dx,dy)
				end
			elseif self.ways[i].wayOrient[j] == "down" then
				dy = 1
				while nextTilePt.y < self.ways[i].way[j].y do
					checkNextTilePt(dx,dy)
				end
			end
			nextTilePt = cc.p(self.ways[i].way[j].x,self.ways[i].way[j].y)
		end
	end
end

--算出支线玩法关每条路离终点1格的地方，要标红线。
function MapInfo:getGiftLevelLines()
	self.giftLines = {}
	local lastDest = 2
	for i = 1, #self.ways do
		local findLine = false
		self.giftLines[i] = {}
		local endPt = self.ways[i].way[#self.ways[i].way]
		local nextTilePt = cc.p(endPt.x,endPt.y)
		local stepCount = 0
		local function checkNextTilePt(dx,dy)
			nextTilePt = cc.p(nextTilePt.x+dx,nextTilePt.y+dy)
			--print("dx,dy:",dx,dy)
			--print("nextTilePt:",nextTilePt.x,nextTilePt.y)
			stepCount = stepCount + 1
			if stepCount == lastDest then
				self.giftLines[i].p1 = cc.p(nextTilePt.x,nextTilePt.y)
			elseif stepCount == lastDest + 1 then
				self.giftLines[i].p2 = cc.p(nextTilePt.x,nextTilePt.y)
				findLine = true
				self.giftLines[i].pt = cc.pMidpoint(self:getCenterOfTile(self.giftLines[i].p1), 
					self:getCenterOfTile(self.giftLines[i].p2))
				if dx ~= 0 then
					self.giftLines[i].orient = "leftRight"
				elseif dy ~= 0 then
					self.giftLines[i].orient = "upDown"
				end

				local line = display.newRect(cc.rect(0, 0, 10, MapInfo.tileSize), 
		            {fillColor = cc.c4f(1,0,0,1)})
		        line:setAnchorPoint(cc.p(0.5,0.5))
		        line:ignoreAnchorPointForPosition(false)
		        if self.giftLines[i].orient == "leftRight" then
		        	line:setPosition(cc.p(self.giftLines[i].pt.x-5,self.giftLines[i].pt.y-MapInfo.tileSize*0.5))
		        elseif self.giftLines[i].orient == "upDown" then
		        	line:setPosition(cc.p(self.giftLines[i].pt.x-MapInfo.tileSize*0.5,self.giftLines[i].pt.y+5))
		            line:setRotation(90)
		        end
		        self.scene:addChild(line,-1)
		        self.giftLines[i].tileDist = self.tileType[self:getTileIdx(self.giftLines[i].p2)].wayDist[i]
		        self.giftLines[i].dist = (self.giftLines[i].tileDist+0.5)*self.tileSize

		        --[[print("line "..i.." dist:",self.giftLines[i].dist)
				print("p1:",self.giftLines[i].p1.x,self.giftLines[i].p1.y)
				print("p2:",self.giftLines[i].p2.x,self.giftLines[i].p2.y)
				print("pt:",self.giftLines[i].pt.x,self.giftLines[i].pt.y)
				print("orient:",self.giftLines[i].orient)]]
			end
		end
		for j = #self.ways[i].way,0,-1 do
			local beforeTilePt
			if j > 1 then
				beforeTilePt = self.ways[i].way[j-1]
			else
				beforeTilePt = self.ways[i].startPt
			end
			--print("beforeTilePt:",beforeTilePt.x,beforeTilePt.y)
			local dx,dy = 0,0
			if self.ways[i].wayOrient[j] == "right" then
				dx = -1
				while nextTilePt.x > beforeTilePt.x do
					checkNextTilePt(dx,dy)
				end
			elseif self.ways[i].wayOrient[j] == "left" then
				dx = 1
				while nextTilePt.x < beforeTilePt.x do
					checkNextTilePt(dx,dy)
				end
			elseif self.ways[i].wayOrient[j] == "up" then
				dy = 1
				while nextTilePt.y < beforeTilePt.y do
					checkNextTilePt(dx,dy)
				end
			elseif self.ways[i].wayOrient[j] == "down" then
				dy = -1
				while nextTilePt.y > beforeTilePt.y do
					checkNextTilePt(dx,dy)
				end
			end
			if findLine then break end
		end
	end
end

--判断是不是有竹笋怪。没长出来的。
function MapInfo:checkE45(tilePt)
	for i = 1, #self.E45 do
		if self.E45[i].created 
				and self.E45[i].tilePt.x == tilePt.x
				and self.E45[i].tilePt.y == tilePt.y
				and self.E45[i].enemy:isVisible() then
			return true
		end
	end
	return false
end

function MapInfo:checkTileRoadValid(p)
	if not self:isTilePtInMap(p) then return false end
	if self:checkTileRoad(p) == false then
		return false
	end
	for i = 1, #self.ways do
		if self.ways[i].startPt.x == p.x
				and self.ways[i].startPt.y == p.y then
			return false
		elseif self.ways[i].way[#self.ways[i].way].x == p.x
				and self.ways[i].way[#self.ways[i].way].y == p.y then
			return false
		end
	end
	return true
end

function MapInfo:checkTileRoad(p, checkMap)
	--直接用类型记录。不再检查地图。
	if not checkMap then
		local tileType = self.tileType[self:getTileIdx(p)]
		if tileType ~= nil and tileType.name == "way" then
			return true
		else
			return false
		end
	else
		local layer = self.map:getLayer("content")
		local gid = layer:getTileGIDAt(p)
		if gid == 0 then return false end
		local prop = self.map:getPropertiesForGID(gid);
		if type(prop) ~= "table" then return false end
		local way = prop.way
		if way == nil then return false end
	    local x = tonumber(way)
	    if x == 1 then
			return true
		else
			return false
		end
	end
end

function MapInfo:checkTileBlank(p)
	if not self:isTilePtInMap(p) then return false end

	if self:checkTileThing(p) ~= nil then return false end
	if self:checkStrangePoint(p) ~= nil then return false end
	
	local layer = self.map:getLayer("content")
	local gid = layer:getTileGIDAt(p)
	if gid == 0 then return true end
	local prop = self.map:getPropertiesForGID(gid);
	if type(prop) ~= "table" then return false end
	local str = prop.blank
	if str == nil then return false end
    local x = tonumber(str)
    if x == 1 then
		return true
	else
		return false
	end
end

function MapInfo:checkTileThing(p)
	--直接用类型记录。不再遍历things。
	local tileType = self.tileType[self:getTileIdx(p)]
	if tileType ~= nil then
		if tileType.name == "thing" 
			or tileType.name == "thingAndWater" then
			local thing = tileType.value
			--直接返回实际的道具值(左下角那个)
		    if thing.part then
		    	local realThingTilePt = cc.p(thing.tilePt.x+1-thing.x, thing.tilePt.y+thing.y-1)
		    	return MapInfo:checkTileThing(realThingTilePt)
		    else
				return thing
		    end
		else
			return nil
		end
	else
		return nil
	end
	--[[
	--print ("checkTileThing:",p.x,p.y)
	for i = 1, #self.things do
		--print(self.things[i].tilePt.x,self.things[i].tilePt.y)
		if self.things[i].tilePt.x == p.x and 
			self.things[i].tilePt.y == p.y then 
			--print ("thing hp:", self.things[1].hp)
			return self.things[i]
		end
	end
	return nil
	--]]
end

function MapInfo:checkFloatWayBroken(p)
	local floatWay = self:checkFloatWay(p)
	if floatWay == nil then return false end
	if floatWay.sprite:isVisible() or floatWay.fill then
		return false
	else
		return true --被打掉隐藏了。
	end
end

function MapInfo:checkFloatWayGood(p)
	local floatWay = self:checkFloatWay(p)
	if floatWay == nil then return nil end
	if floatWay.sprite:isVisible() then
		return floatWay
	else
		return nil --被打掉隐藏了。
	end
end

function MapInfo:checkStrangePoint(p)
	--直接用类型记录。不再遍历things。
	local tileType = self.tileType[self:getTileIdx(p)]
	if tileType ~= nil and tileType.name == "strangePoint" then
		return tileType.value
	else
		return nil
	end
end

function MapInfo:checkFloatWay(p)
	--直接用类型记录。不再遍历things。
	local tileType = self.tileType[self:getTileIdx(p)]
	if tileType ~= nil and tileType.name == "floatWay" then
		return tileType.value
	else
		return nil
	end
	--[[
	--print ("checkFloatWay:",p.x,p.y)
	local thing = self:checkTileThing(p)
	if thing ~= nil and thing.thingType == 1 then 
		return thing 
	else
		return nil
	end
	--]]
end

function MapInfo:checkWaterWay(p)
	--直接用类型记录。不再遍历things。
	local tileType = self.tileType[self:getTileIdx(p)]
	if tileType ~= nil and tileType.name == "waterWay" then
		return true
	else
		return false
	end
end

function MapInfo:checkWater(p, b)
	--默认如果有道具即使是水面也不当作是水面。
	local checkThing = b or true
	--直接用类型记录。不再遍历things。
	local tileType = self.tileType[self:getTileIdx(p)]
	if tileType ~= nil then 
		if tileType.name == "water" then
			return true
		elseif not checkThing and tileType.name == "thingAndWater" then
			--忽略道具还认为是水面
			return true
		else
			return false
		end
	else
		return false
	end
end

function MapInfo:getWayFromAroundTile(p)
	local wayPt = cc.p(0,0)
 	local layer = self.map:getLayer("content")
	local lastOrient = nil
	if #self.ways[1].wayOrient > 0 then
		lastOrient = self.ways[1].wayOrient[#self.ways[1].wayOrient]
	end
	if lastOrient ~= "down" and p.y - 1 >= 0 then
		wayPt = cc.p(p.x,p.y-1)
		--print(wayPt.x, wayPt.y)
		--local gid = layer:getTileGIDAt(wayPt)
		if self:checkTileRoad(wayPt,true) == true then
			return true, wayPt
		end
	end
	if lastOrient ~= "right" and p.x - 1 >= 0 then
		wayPt = cc.p(p.x-1,p.y)
		--local gid = layer:getTileGIDAt(wayPt)
		if self:checkTileRoad(wayPt,true) == true then
			return true, wayPt
		end
	end
	if lastOrient ~= "up" and p.y + 1 < self.map:getMapSize().height then
		wayPt = cc.p(p.x,p.y+1)
		--local gid = layer:getTileGIDAt(wayPt)
		if self:checkTileRoad(wayPt,true) == true then
			return true, wayPt
		end
	end
	if lastOrient ~= "left" and p.x + 1 < self.map:getMapSize().width then
		wayPt = cc.p(p.x+1,p.y)
		--local gid = layer:getTileGIDAt(wayPt)
		if self:checkTileRoad(wayPt,true) == true then
			return true, wayPt
		end
	end
	return false, wayPt
end

function MapInfo:getWayOrient(p1, p2)
	if p1.x>p2.x then
		return "left"
	end
	if p1.x<p2.x then
		return "right"
	end
	if p1.y>p2.y then
		return "up"
	end
	if p1.y<p2.y then
		return "down"
	end
	return "";
end

function MapInfo:getMapObjTilePoint(groupName, objName)
	local group = self.map:getObjectGroup(groupName)
	if group == nil then return nil end
	local obj = group:getObject(objName)
	if obj == nil or obj.x == nil or obj.y == nil then return nil end
	local x = obj.x;
	local y = obj.y;
    return self:getTilePositionInCCP(cc.p(x,y), true)
end

function MapInfo:getMapWayByStart()
	self.ways[1] ={
		startPt,
		wayOrient = {},
		way = {},
	}
	local way1 = self.ways[1]
	way1.startPt = self:getMapObjTilePoint("objs", "start")
	if way1.startPt == nil then 
		print ("Can't find start point!")
	end
	--print("startPt:",way1.startPt.x,way1.startPt.y)

	local lastOrient = "";
	local p = clone(way1.startPt)

	while 1 do
		local b, wayPt = self:getWayFromAroundTile(p)
		--print("wp:",wayPt.x,wayPt.y)
		if b then
			local orient = self:getWayOrient(p, wayPt)
			if lastOrient ~= orient then
				way1.way[#way1.way+1] = wayPt
				way1.wayOrient[#way1.wayOrient+1] = orient
				lastOrient = orient;
			else
				way1.way[#way1.way] = nil
				way1.way[#way1.way+1] = wayPt
			end
			p = wayPt
		else
			break
		end
	end
	self.endTilePt = way1.way[#way1.way]
	self.endPos = self:getCenterOfTile(way1.way[#way1.way])
	--[[
	for i = 1, #way1 do
		print("Way:", way1[i].x, way1[i].y)
		print("wayOrient:", self.wayOrient[i])
	end
	--]]
end

function MapInfo:getMapSingleWay(wayNum)

	local waySubNum = 0
	local point = self:getMapObjTilePoint("objs", "way"..wayNum.."_"..waySubNum)
	if point == nil then return false end
	self.ways[wayNum] ={
		startPt,
		wayOrient = {},
		way = {},
	}
	while point ~= nil do 
		if waySubNum == 0 then
			self.ways[wayNum].startPt = point;
		else
			self.ways[wayNum].way[waySubNum] = point;
			if waySubNum == 1 then
				self.ways[wayNum].wayOrient[waySubNum] =
					self:getWayOrient(self.ways[wayNum].startPt, self.ways[wayNum].way[waySubNum])
			else
				self.ways[wayNum].wayOrient[waySubNum] =
					self:getWayOrient(self.ways[wayNum].way[waySubNum-1], self.ways[wayNum].way[waySubNum])
			end
		end
		waySubNum = waySubNum + 1
		point = self:getMapObjTilePoint("objs", "way"..wayNum.."_"..waySubNum)
	end
	if #self.ways[wayNum].way == 0 then return false end
	return true
end

function MapInfo:getMapMultipleWay()
	local wayNum = 1
	while self:getMapSingleWay(wayNum) do
		wayNum = wayNum + 1
	end
	self.endTilePt = self.ways[#self.ways].way[#self.ways[#self.ways].way]
	self.endPos = self:getCenterOfTile(self.ways[#self.ways].way[#self.ways[#self.ways].way])
end

function MapInfo:getMapWay()
	--[[外部定义
	self.mapPos = cc.p(self.map:getContentSize().width*0.5 - display.cx,
						  self.map:getContentSize().height*0.5 - display.cy)
	--]]
	local group = self.map:getObjectGroup("objs")
	local dict = group:getObject("start")
	if dict ~= nil and dict.x ~= nil and dict.y ~= nil then 
		MapInfo:getMapWayByStart()
	else
		MapInfo:getMapMultipleWay()
	end

	--记录所有tileType是路的。
	for i = 1, #self.ways do
		self.wayPoints[i] = {}
		local p1 = self.ways[i].startPt
		self.wayPoints[i].startPos = self:getCenterOfTile(p1)
		self.tileType[self:getTileIdx(self.ways[i].startPt)] = {name = "way"}
		for j = 1, #self.ways[i].way do
			local p2 = self.ways[i].way[j]
			if self.ways[i].wayOrient[j] == "up" then
				for k = p1.y-1, p2.y, -1 do
					self.tileType[self:getTileIdx(cc.p(p1.x,k))] = {name = "way"}
					self.allWayTile[#self.allWayTile+1] = cc.p(p1.x,k)
				end
			elseif  self.ways[i].wayOrient[j] == "down" then
				for k = p1.y+1, p2.y do
					self.tileType[self:getTileIdx(cc.p(p1.x,k))] = {name = "way"}
					self.allWayTile[#self.allWayTile+1] = cc.p(p1.x,k)
				end
			elseif  self.ways[i].wayOrient[j] == "left" then
				for k = p1.x-1, p2.x, -1 do
					self.tileType[self:getTileIdx(cc.p(k,p1.y))] = {name = "way"}
					self.allWayTile[#self.allWayTile+1] = cc.p(k,p1.y)
				end
			elseif  self.ways[i].wayOrient[j] == "right" then
				for k = p1.x+1, p2.x do
					self.tileType[self:getTileIdx(cc.p(k,p1.y))] = {name = "way"}
					self.allWayTile[#self.allWayTile+1] = cc.p(k,p1.y)
				end
			end
			p1 = cc.p(p2.x,p2.y)
			self.wayPoints[i][j] = self:getCenterOfTile(self.ways[i].way[j])
		end
	end
	--清理路的记录中终点的路块
	local tmp = {}
	local endTilePt = self.ways[1].way[#self.ways[1].way]
	for i = 1, #self.allWayTile do
		if self.allWayTile[i].x == endTilePt.x and 
				self.allWayTile[i].y == endTilePt.y then
			tmp[#tmp+1] = i
		end
	end
	for i = #tmp,1,-1 do
		table.remove(self.allWayTile,tmp[i])
	end
end

function MapInfo:getThingsOnMap()
	local layer = self.map:getLayer("things")
	if layer == nil then return end
	local mapW = self.map:getMapSize().width
	local mapH = self.map:getMapSize().height
	for i = 0,mapW-1 do
		for j = 0,mapH-1 do
			local gid = layer:getTileGIDAt(cc.p(i,j))
			local prop = self.map:getPropertiesForGID(gid)
			if type(prop) == "table" then
				--道具只需要标thingIdx
				local thingIdxStr = prop.thingIdx		
				if thingIdxStr ~= nil then
					local thingIdx = tonumber(thingIdxStr)
					local value = ThingValue[ThingData[thingIdx].valueIdx]
					local width = value.width or 1
					local height = value.height or 1
    				self:addThing({
    					thingIdx = thingIdx, --任务有打道具类型的。
						tilePt = cc.p(i,j),
    					hp = value.hp,
    					money = value.money,
    					width = width,
    					height = height,
    					thingType = 0,
    				})
    				self.things.normalThingCount = self.things.normalThingCount + 1
    				--添加大块中的其他块，不用在地图上再标属性
    				for w = 1, width do
    					for h = 1, height do
    						if w ~= 1 or h ~= 1 then --不是自身块
    							local tilePt = cc.p(i+w-1,j-h+1)
								self.things[#self.things+1] = {
									tilePt = tilePt,
									x = w,
									y = h,
									part = true,
								}
								self.tileType[self:getTileIdx(tilePt)] = {
									name = "thing",
									value = self.things[#self.things]
								}
    						end
    					end
    				end
    			end
			elseif gid > 0 then --没加属性的道具。默认也加。
				--[[还是不加了。。。会影响自动添加的子块。
				self:addThing({
					tilePt = cc.p(i,j),
					hp = 100,
					money = 50,
					width = 1,
					height = 1,
					thingIdx = 1,
				})
				--]]
			end
		end
	end
end

function MapInfo:getThingsOnMapByObject()
	local group = self.map:getObjectGroup("objs")
	local array = group:getObjects()
	for k,v in pairs(array) do
	    local name = v.name
	    if name == "thing" then
		    local x = tonumber(v.x)
		    local y = tonumber(v.y)
		    local thingIdx = tonumber(v.idx)
		    local tilePt = self:getTilePositionInCCP(cc.p(x,y), true)

			local value = ThingValue[ThingData[thingIdx].valueIdx]
			local width = value.width or 1
			local height = value.height or 1
			self:addThing({
				thingIdx = thingIdx, --任务有打道具类型的。
				tilePt = tilePt,
				hp = value.hp,
				money = value.money,
				width = width,
				height = height,
				thingType = 0,
			})
			self.things.normalThingCount = self.things.normalThingCount + 1
			--添加大块中的其他块，不用在地图上再标属性
			for w = 1, width do
				for h = 1, height do
					if w ~= 1 or h ~= 1 then --不是自身块
						local tilePt = cc.p(tilePt.x+w-1,tilePt.y-h+1)
						self.things[#self.things+1] = {
							tilePt = tilePt,
							x = w,
							y = h,
							part = true,
						}
						self.tileType[self:getTileIdx(tilePt)] = {
							name = "thing",
							value = self.things[#self.things]
						}
					end
				end
			end
	    end
	end
end

function MapInfo:getThingRect(thing)
	if thing.part then return nil end --应该不会传子块进来。
	return cc.rect(thing.pos.x - MapInfo.tileSize*0.4,
				thing.pos.y - MapInfo.tileSize*0.5,
				(thing.width - 0.2)*MapInfo.tileSize,
				(thing.height - 0.2)*MapInfo.tileSize)
end

function MapInfo:addThing(params)
	local tilePt = params.tilePt
	local pos = self:getCenterOfTile(tilePt)
	local hp = params.hp
	local money = params.money
	local width = params.width
	local height = params.height
	local rect = cc.rect(pos.x - self.tileSize*0.5, pos.y - self.tileSize*0.5,
		self.tileSize*width, self.tileSize*height)
	--print(i,j,hp,money,width,height)
	local layer = self.map:getLayer("things")
	local size = cc.size(self.map:getTileSize().width*width,
						self.map:getTileSize().height*height)
	local hpBar = HpBar.new(HPBAR_TYPE_THING, size,hp,
		layer:getPositionAt(tilePt))
	hpBar:setVisible(false)
	self.map:addChild(hpBar,10)
	self.things[#self.things+1] = {
		hpBar = hpBar,
		tilePt = tilePt,
		pos = pos,
		rect = rect,
		thingIdx = params.thingIdx,
		maxHp = hp,
		hp = hp,
		money = money,
		width = width,
		height = height,
		part = false,
		thingType = params.thingType,
		fill = params.fill, --浮冰有没被填
		wayIdx = params.wayIdx, --火山出怪点
		sprite = params.sprite
	}
	if params.thingType == 2 then
		self.tileType[self:getTileIdx(tilePt)] = {
			name = "strangePoint",
			value = self.things[#self.things]
		}
		--只需标记tileType。partThing最好也改。
		for i= 1, width do
			for j = 1, height do
				if i ~= 1 or j ~= 1 then
					local partTilePt = cc.p(tilePt.x-1+i,tilePt.y+1-j)
					--print("partTilePt:",partTilePt.x,partTilePt.y)
					self.tileType[self:getTileIdx(partTilePt)] = {
						name = "strangePoint",
						value = self.things[#self.things]
					}
				end
			end
		end
		self.hitableStrangePoint = self.things[#self.things]
	elseif params.thingType == 1 then
		self.tileType[self:getTileIdx(tilePt)] = {
			name = "floatWay",
			value = self.things[#self.things]
		}
	else
		self.tileType[self:getTileIdx(tilePt)] = {
			name = "thing",
			value = self.things[#self.things]
		}
	end
end

--遍历按名字读取object，水面、水路、浮冰、出怪点、竹笋怪。
function MapInfo:getSomeObjects()
	local group = self.map:getObjectGroup("objs")
	local array = group:getObjects()
	for k,v in pairs(array) do
	    local name = v.name
	    if name == "water" then
	    	self:dealWithWaterObject(v)
	    elseif name == "waterWay" then
	    	self:dealWithWaterWayObject(v)
	    elseif name == "floatWay" then
	    	self:dealWithfloatWayObject(v)
	    elseif name == "hitableStrangePoint" then
	    	self:dealWithHitableStrangePointObject(v)
	    elseif name == "E45" then
	    	self:dealWithE45Object(v)
	    elseif name == "preTower" then
	    	self:dealWithPreTowerObject(v)
	    elseif name == "openTower" then
	    	self:dealWithOpenTowerObject(v)
	    elseif name == "waterTowerSeat" then
	    	self:dealWithWaterTowerSeatObject(v)
	    elseif name == "thingBomb" then
	    	self:dealWithThingBombObject(v)
	    elseif name == "hero" then
		    local x = tonumber(v.x)
		    local y = tonumber(v.y)
		    local tilePt = self:getTilePositionInCCP(cc.p(x,y), true)
		    self.heroPos = self:getCenterOfTile(tilePt)
		elseif name == "heart" then
		    local x = tonumber(v.x)
		    local y = tonumber(v.y)
		    self.heartPos = cc.p(x-self.mapPos.x, y-self.mapPos.y)
	    end
	end
end

--取出是水面的位置。
function MapInfo:dealWithWaterObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local pt = self:getTilePositionInCCP(cc.p(x,y), true)
    --print(pt.x,pt.y)
    --道具在水面上
    if self.tileType[self:getTileIdx(pt)] ~= nil 
    	and self.tileType[self:getTileIdx(pt)].name == "thing" then
    	self.tileType[self:getTileIdx(pt)].name = "thingAndWater"
    else
    	self.tileType[self:getTileIdx(pt)] = {name = "water"}
    end
end

--水路
function MapInfo:dealWithWaterWayObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local pt = self:getTilePositionInCCP(cc.p(x,y), true)
   
    self.tileType[self:getTileIdx(pt)] = {name = "waterWay"}
end

--浮冰
function MapInfo:dealWithfloatWayObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local pt = self:getTilePositionInCCP(cc.p(x,y), true)
    local hp = 100
    if dict.hp ~= nil then
    	hp = tonumber(dict.hp)
    end
	local floatSprite = display.newSprite("#floatIce1.png")
	local layer = self.map:getLayer("content")
	local pos = layer:getPositionAt(pt)
	floatSprite:setPosition(cc.p(pos.x+self.tileSize*0.5,pos.y+self.tileSize*0.5))
	self.map:addChild(floatSprite)
	--原来的路隐藏
	local t = layer:getTileAt(pt)
	t:setVisible(false)
	self:addThing({
		tilePt = pt,
		hp = hp,
		money = 0,
		width = 1,
		height = 1,
		thingType = 1, --浮冰是1
		fill = false,
		sprite = floatSprite,
	})
end

--读取可打击出怪点。
function MapInfo:dealWithHitableStrangePointObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local tilePt = self:getTilePositionInCCP(cc.p(x,y), true)
    local width = tonumber(dict.width)
    local height = tonumber(dict.height)
    local wayIdx = tonumber(dict.wayIdx)
    --print(pt.x,pt.y)
	local strangePointSprite = display.newSprite("#strangePoint.png")
	local layer = self.map:getLayer("content")
	local pos = layer:getPositionAt(tilePt)
	strangePointSprite:setPosition(cc.p(pos.x+self.tileSize*width*0.5,pos.y+self.tileSize*height*0.5))
	self.map:addChild(strangePointSprite,5)
	self:addThing({
		tilePt = tilePt,
		hp = 100,
		money = 0,
		width = width,
		height = height,
		wayIdx = wayIdx,
		thingType = 2, --可打击出怪点是2
		sprite = strangePointSprite,
	})
end

--竹笋怪读取
function MapInfo:dealWithE45Object(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local wayIdx
    if dict.wayIdx == nil then
    	wayIdx = 1
    else
    	wayIdx = tonumber(dict.wayIdx)
    end
    local wave
    if dict.wave == nil then
    	wave = 1
    else
    	wave = tonumber(dict.wave)
    end
    local delay
    if dict.delay == nil then
    	delay = 1
    else
    	delay = tonumber(dict.delay)
    end
    local hp = nil
    if dict.hp ~= nil then
    	hp = tonumber(dict.hp)
    end
    local growTime = nil
    if dict.growTime ~= nil then
    	growTime = tonumber(dict.growTime)
    end

    local tilePt = self:getTilePositionInCCP(cc.p(x,y), true)
    self.E45[#self.E45+1] = {
    	created = false,
    	tilePt = tilePt,
    	pos = self:getCenterOfTile(tilePt),
    	wayIdx = wayIdx,
    	hp = hp,
    	wave = wave,
    	delay = delay,
    	growTime = growTime,
    }
end

--预设塔
function MapInfo:dealWithPreTowerObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local towerIdx = tonumber(dict.towerIdx)
    local level
    if dict.level == nil then
    	level = 1
    else
     	level = tonumber(dict.level)
    end
    local tilePt = self:getTilePositionInCCP(cc.p(x,y), true)
    self.preTowers[#self.preTowers+1] = {
    	towerIdx = towerIdx,
    	level = level,
    	tilePt = tilePt,
	}
end

--打掉水上道具出的可放置塔的位置。
function MapInfo:dealWithWaterTowerSeatObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local tilePt = self:getTilePositionInCCP(cc.p(x,y), true)

	local layer = self.map:getLayer("things")
	local gid = layer:getTileGIDAt(cc.p(tilePt.x,tilePt.y))
	local prop = self.map:getPropertiesForGID(gid)
	local hasThing = type(prop) == "table" and prop.thingIdx ~= nil
	local seat = layer:getTileAt(tilePt)
	if not hasThing and seat ~= nil then
		--地图上已放了底座直接用。记录是为了到时移除。
	    self.waterTowerSeats[#self.waterTowerSeats+1] = {
	    	tilePt = tilePt,
	    	sprite = seat,
		}
	else
		--等打完道具时加上。
	    self.waterTowerSeats[#self.waterTowerSeats+1] = {
	    	tilePt = tilePt,
	    	sprite = nil,
		}
	end
end
function MapInfo:dealWithOpenTowerObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local towerIdx = tonumber(dict.towerIdx)
    local level
    if dict.level == nil then
    	level = 1
    else
     	level = tonumber(dict.level)
    end
    local tilePt = self:getTilePositionInCCP(cc.p(x,y), true)
    self.openTowers[#self.openTowers+1] = {
    	towerIdx = towerIdx,
    	level = level,
    	tilePt = tilePt,
	}
end

--打掉道具出炸弹，炸周围一圈道具。
function MapInfo:dealWithThingBombObject(dict)
    local x = tonumber(dict.x)
    local y = tonumber(dict.y)
    local tx,ty = self:getTilePosition(cc.p(x,y), true)
    --为什么不直接记在things上，因为things有可能是多块的。
    self.thingBomb[#self.thingBomb+1] = {
    	x = tx,
    	y = ty,
	}
end

function MapInfo:hideStartAndEndOfWays()
	local layer = self.map:getLayer("content")
	for i = 1, #self.ways do
		local t1 = layer:getTileAt(self.ways[i].startPt)
		t1:setVisible(false)
		local t2 = layer:getTileAt(self.ways[i].way[#self.ways[i].way])
		t2:setVisible(false)
	end
end

function MapInfo:clearNoTouchTiles()
	local layer = self.map:getLayer("content")
	if layer == nil then return end
	local mapW = self.map:getMapSize().width
	local mapH = self.map:getMapSize().height
	for i = 0,mapW-1 do
		for j = 0,mapH-1 do
			local gid = layer:getTileGIDAt(cc.p(i,j))
			local prop = self.map:getPropertiesForGID(gid)
			if type(prop) == "table" then 
				local str = prop.blank
				if str ~= nil then
    				local x = tonumber(str)
    				if x == 0 then
    					local t = layer:getTileAt(cc.p(i,j))
    					t:setVisible(false)
    				end
    			end
    		end
    	end
    end
end

function MapInfo:removeThing(tilePt)
	local idx --主要是为了最后用这个idx从表中删除。
	for i = 1, #self.things do
		--print(self.things[i].tilePt.x,self.things[i].tilePt.y)
		if self.things[i].tilePt.x == tilePt.x 
				and self.things[i].tilePt.y == tilePt.y then
			idx = i
			--随机出来的爆道具障碍的IDX随着移除道具的IDX发生变化
			if not VERSION_REDUCE then
				if g_playScene.randomFinalThing1 ~= nil then
					if g_playScene.randomFinalThing1 > i then
						g_playScene.randomFinalThing1 = g_playScene.randomFinalThing1 - 1 --idx往后减1
					elseif g_playScene.randomFinalThing1 == i then
						g_playScene.randomFinalThing1 = nil
						--此障碍5%几率爆装备
						local percent
						if LevelsData.getRealLevel(g_playScene.level) < 7 then
							percent = math.random(1,5)
						else
							percent = math.random(1,20)
						end	
						if percent == 1 then
							local maxItemIdx = 4
							for j = 1,4 do
								if GameData.item["i"..j].isUnLock == false then --未解锁
									maxItemIdx = maxItemIdx - 1
								end
							end
							local randomItemIdx = math.random(1,maxItemIdx)--随机一个道具
							g_fightLayer:dropItem(randomItemIdx,tilePt)--掉道具
						end
					end
				end
				if g_playScene.randomFinalThing2 ~= nil then
					if g_playScene.randomFinalThing2 > i then
						g_playScene.randomFinalThing2 = g_playScene.randomFinalThing2 - 1 --idx往后减1
					elseif g_playScene.randomFinalThing2 == i then
						g_playScene.randomFinalThing2 = nil
						--此障碍5%几率爆装备
						local percent
						if LevelsData.getRealLevel(g_playScene.level) < 7 then
							percent = math.random(1,5)
						else
							percent = math.random(1,20)
						end
						if percent == 1 then
							local maxItemIdx = 4
							for j = 1,4 do
								if GameData.item["i"..j].isUnLock == false then --未解锁
									maxItemIdx = maxItemIdx - 1
								end
							end
							local randomItemIdx = math.random(1,maxItemIdx)--随机一个道具
							g_fightLayer:dropItem(randomItemIdx,tilePt)--掉道具
						end
					end
				end
			end
			break
		end
	end

	local thing = self.things[idx]

	--浮冰不是真的删掉。
	if thing.thingType == 1 then
		--播放浮冰破碎动画。
		--[[
		local ice = display.newSprite("#floatIceBreak_1.png",thing.sprite:getPosition())
		self.map:addChild(ice)
	    local frames = display.newFrames("floatIceBreak_%d.png", 1, 11)
	    local animation = display.newAnimation(frames, 0.08)
	    ice:playAnimationOnce(animation, true)
		thing.sprite:setVisible(false)
		thing.hpBar:setVisible(false)
		self.updateThings[#self.updateThings+1] = {
			value = thing,
			time = 5, --5秒后还原
		}
	    --]]
	    --浮冰进度圈。
	    self:createFloatCircleProcess(thing)
	    --音效
		SoundManager.playSound(GAME_SOUND.Iceroad[2])
		thing.firstBreak = false
		thing.secondBreak = false
		return
	elseif thing.thingType == 2 then --可打出怪点
		--原出怪点显示
		display.getRunningScene().enemyHome[thing.wayIdx]:setVisible(true)
		display.getRunningScene().enemyHome[thing.wayIdx].buffer = nil
		thing.hpBar:removeFromParent()
		thing.sprite:removeFromParent()
		for i = 1, thing.width do
			for j = 1, thing.height do
				local tileIdx = self:getTileIdx(cc.p(tilePt.x-1+i,tilePt.y+1-j))
				self.tileType[tileIdx] = nil
			end
		end
		table.remove(self.things, idx)
		return
	end
	
	local layer = self.map:getLayer("things")
	if layer == nil then return end
	layer:removeTileAt(tilePt)
	
	if thing.part == false then
		thing.hpBar:removeFromParent()
		g_playScene:changeMoney(thing.money)
		local pos = self:getCenterOfThing(thing)
		g_fightLayer:moneyShow(thing.money, cc.p(pos.x,pos.y-25))
	end

	local tileIdx = self:getTileIdx(thing.tilePt)
	if self.tileType[tileIdx].name == "thingAndWater" then
		self.tileType[tileIdx] = { name = "water" }
	else
		self.tileType[tileIdx] = nil
	end
	table.remove(self.things, idx)
	--print("thing num:", #self.things)
end

function MapInfo:createFloatCircleProcess(thing)
	thing.hpBar:setVisible(false)
	thing.sprite:setVisible(false)

	local proTo = cc.ProgressTo:create(5, 100)
    thing.progress = cc.ProgressTimer:create(display.newSprite("#floatCircle.png"))
    thing.progress:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
    thing.progress:setPosition(cc.p(thing.sprite:getPosition()))
    thing.func = function()
		thing.hp = thing.maxHp
		thing.hpBar:updateHp(thing.maxHp)
		thing.hpBar:setVisible(false)
		thing.sprite:setVisible(true)
	    local frames = display.newFrames("floatGrow%d.png", 1, 4)
	    local animation = display.newAnimation(frames, 0.1)
	    thing.sprite:playAnimationOnce(animation, false, function()
	    	thing.sprite:setSpriteFrame(display.newSpriteFrame("floatIce1.png"))
	    end)
	    for k,v in pairs(self.actSprites) do
	    	if v == thing then
	    		table.remove(self.actSprites,k)
	    		break
	    	end
	    end
		thing.progress:removeFromParent()
		thing.progress = nil
		thing.func = nil
	end
    local seq = transition.sequence({
		proTo,
    	cc.CallFunc:create(function()
			thing.func()
		end)
    })
    thing.progress:runAction(seq)
	self.map:addChild(thing.progress)
	self.actSprites[#self.actSprites+1] = thing
end

--现在只有浮冰进度条
function MapInfo:suspend()
	for k,v in pairs(self.actSprites) do	
		v.progress:stopAllActions()
	end
end

function MapInfo:resume()
	for k,v in pairs(self.actSprites) do
		local pcent = v.progress:getPercentage()
		local t = 5*(100-pcent)/100
		local proTo = cc.ProgressTo:create(t, 100)
		local seq = transition.sequence({
			proTo,
			cc.CallFunc:create(function()
				v.func()
			end)
		})
		v.progress:runAction(seq)
	end
end

--暂时无用
function MapInfo:update(dt)
	if #self.updateThings == 0 then return end
	local tmp = {}
	for i = 1, #self.updateThings do
		local thing = self.updateThings[i]
		if not thing.value.fill then --没被黄瓜怪填才重现。
			thing.time = thing.time - dt
			if thing.time <= 0 then
				thing.value.sprite:setSpriteFrame("floatIce1.png")
				thing.value.sprite:setVisible(true)
				thing.value.sprite:setOpacity(0)
				thing.value.sprite:runAction(cc.FadeIn:create(0.5))
				thing.value.hp = thing.value.maxHp
				thing.value.hpBar:updateHp(thing.value.maxHp)
				thing.value.hpBar:setVisible(false)
				tmp[#tmp+1] = i
			end
		end
	end
	for i = #tmp, 1, -1 do
		table.remove(self.updateThings, tmp[i])
	end
end

--黄瓜怪填坑
function MapInfo:fillFloatWay(en, tilePt, orient)
	--浮冰设计只会是水平的。
	local s = 1
	if orient == "left" then s = -1 end
	for i = 0, 0 do 
		local float = self:checkFloatWay(cc.p(tilePt.x+i*s,tilePt.y))
		if float ~= nil then
			float.fill = true
			float.fillEnemy = en
			en.fillFloatWays[#en.fillFloatWays+1] = float --记录下等怪死时处理。
		end
	end
end

return MapInfo
