--
-- Author: Wangzhihao
-- Date: 2015-01-20 15:52:51
--
local Skills = import("..obj.Skills")
local MapInfo = import("..views.MapInfo")
local NewbieGuideLayer = class("NewbieGuideLayer",function() 
	return  display.newLayer("NewbieGuideLayer") 
end)
function NewbieGuideLayer:ctor(isTeach)
    self:setNodeEventEnabled(true)
	ResData.loadRes("UI_NEWBIEGUIDE")
	self:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self:setTouchEnabled(true)
	self:setTouchSwallowEnabled(false)
    self.isTeach = isTeach 
end

function NewbieGuideLayer:onEnter()
    if self.isTeach then
        self:showDialog()
        return
    end
    --print(GameData.guide.herohouse,display.getRunningScene().__cname)
    local scene = display.getRunningScene()
    if scene.__cname == "LevelScene" then
        if not GameData.guide.teachLevel then
            self:goTeachLevel()
        elseif not GameData.guide.level1 then
            self:goLevel1(1)
        elseif not GameData.guide.herohouse then
            self:goHeroHouse(1)
        elseif not GameData.guide.level2 then
            self:goLevel2(6)
        end
    elseif scene.__cname == "HeroHouse" then
        if not GameData.guide.herohouse then
            self:goHeroHouse(3)
        end
    elseif scene.__cname == "PlaySceneShell" then
        if g_playScene.level == 100 then
            self:showDialog()
        elseif g_playScene.level == 102 and not GameData.guide.level2 then
            self:goLevel2(1)
        elseif g_playScene.level == 201 and not GameData.guide.level11 then
            self:goLevel11(1)
        elseif g_playScene.level == 202 and not GameData.guide.level12 then
            self:goLevel12(1)
        elseif g_playScene.level == 107 and not GameData.guide.level7 and g_playScene.mode ~= nil then
            self:goLevel7(1)
        elseif g_playScene.level == 109 and not GameData.guide.level9 and g_playScene.mode ~= nil then
            self:goLevel14(1)
        end
    end
end
function NewbieGuideLayer:selectTheFunction()
    --print(g_playScene.waveNow)
    if g_playScene.waveNow == 1 and g_playScene.level == 100 then
        self:createTower(3)
    elseif g_playScene.waveNow == 2 and g_playScene.level == 100 then
        self:createTower(4)
    elseif g_playScene.waveNow == 2 and g_playScene.level == 101 then
        self:showDialogLevel1(1)
    elseif g_playScene.waveNow == 3 and g_playScene.level == 101 then
        self:showDialogLevel1(2)
    else
    end
end
function NewbieGuideLayer:onTouch(event, x, y)
	if event == "began" then
        if self.step == 1 then
            self:clickGround()
        elseif self.step == 3 then
            app:level()
        elseif self.step == 4 then
            self:createSkill2()
        elseif self.step == 6 then
            self:moveHeroTip()
        elseif self.step == 8 then
            GameData.guide.level1 = true
            GameState.save(GameData)
            self:levelShowResult()
        elseif self.step == 9 then
            self:goHeroHouse(2)
        elseif self.step == 11 then
            self:goLevel2(2)
        elseif self.step == 15 then
            self:goHeroHouse(6)
        elseif self.step == 21 then
            self:goLevel11(2)
        elseif self.step == 23 then
            self:goLevel12(2)
        elseif self.step == 25 then
            self:goLevel7(2)
        elseif self.step == 27 then
            self:goLevel14(2)
        end
        if self.rect ~= nil and g_playScene ~= nil and (g_playScene.level == 100 or g_playScene.level == 102) then
            if self.rectVisible == true then
                if cc.rectContainsPoint(self.rect, cc.p(x,y)) then
                    self:setTouchSwallowEnabled(false)
                else     
                    self:setTouchSwallowEnabled(true)    
                end
            else
                self:setTouchSwallowEnabled(true)
            end
        elseif self.rect ~= nil and (GameData.guide.teachLevel == true or GameData.guide.level1 == true) then
            if not self.heroCanTouch then
                if cc.rectContainsPoint(self.rect, cc.p(x,y)) then
                    self:setTouchSwallowEnabled(false)
                else      
                    self:setTouchSwallowEnabled(true)    
                end
            end
        end
        if self.rectHero ~= nil and g_playScene ~= nil and g_playScene.level == 101 then  
            if cc.rectContainsPoint(self.rectHero, cc.p(x,y)) then
                self:setTouchSwallowEnabled(false)
            else
                self:setTouchSwallowEnabled(true)
            end
        end      
        return true
    elseif event == "moved" then
    elseif event == "ended" then
        if self.rect ~= nil and g_playScene ~= nil and g_playScene.level == 101 then
            if g_playScene.hero.moveLine ~= nil then--cc.rectContainsPoint(self.rect, cc.p(x,y)) and
                self:moveHero()
            end
        end
    end
end
function NewbieGuideLayer:goTeachLevel()
    self:setTouchSwallowEnabled(true)
    self.grayColorLayer = display.newColorLayer(cc.c4b(0,0,0,150))
        :addTo(self)
	self.goTeachLevelBg = display.newSprite("#goteachBg.png",display.cx,display.cy)
	self.grayColorLayer:addChild(self.goTeachLevelBg)
    local teachleveltext
    if VERSION_REDUCE then
        teachleveltext = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionText("教学",1),
            size = 30,
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = 40,
            y = 180,
            }):align(display.LEFT_TOP)
    else
        teachleveltext = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionText("教学",1),
            size = 30,
            color = cc.c3b(255,255,255),
            x = 200,
            y = 170,
            }):align(display.CENTER)
    end
	-- local teachleveltext = cc.ui.UILabel.new({
 --        text = kkFunc.getVersionText("教学",1),
 --        size = 30,
 --        color = cc.c3b(255,255,255),
 --        x = 200,
 --        y = 170,
 --        }):align(display.CENTER)
    self.goTeachLevelBg:addChild(teachleveltext)
    self.sure = cc.ui.UIPushButton.new({
        normal = "#teachSure.png",
        disabled = "#teachSure.png",
        pressed = "#teachSure.png",
        })
        :onButtonPressed(function()
            self.sure:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.sure:setScale(1)
        end)
        :onButtonClicked(function()
            app:play({level = 100})
        end)
        :pos(266, 70)
        :addTo(self.goTeachLevelBg)
    self.cancle = cc.ui.UIPushButton.new({
        normal = "#teachCancle.png",
        disabled = "#teachCancle.png",
        pressed = "#teachCancle.png",
        })
        :onButtonPressed(function()
            self.cancle:setScale(1.1)
            --音效
            SoundManager.playSound(GAME_SOUND.Button2)
        end)
        :onButtonRelease(function()
            self.cancle:setScale(1)
        end)
        :onButtonClicked(function()
            GameData.guide.teachLevel = true
            GameState.save(GameData)
            self:goLevel1(1)
            self.grayColorLayer:removeFromParent()
        end)
        :pos(133, 70)
        :addTo(self.goTeachLevelBg)
end

function NewbieGuideLayer:showHeroDialog(heroIdx, msg, continue, orient, x)
    self.textBg = display.newSprite("#teachlevelBg.png"):addTo(self)
    local size = self.textBg:getContentSize()
    local px = x or display.cx-20
    self.textBg:setPosition(px,-5)
    self.textBg:setAnchorPoint(0.5,0)
    local hero = display.newSprite("#newbieHero"..heroIdx..".png",-110,0)
    hero:setAnchorPoint(0.5,0)
    self.textBg:addChild(hero)
    if orient == "right" then
        self.textBg:setFlippedX(true)
        hero:setFlippedX(true)
        hero:setPosition(500,0)
    elseif orient == "up" then
        self.textBg:setFlippedY(true)
        self.textBg:setPositionY(225)
        hero:setPosition(cc.p(-90,-225))
    end
    local text = kkFunc.getVersionText("教学",4)
    if heroIdx == 3 then
        text = kkFunc.getVersionText("教学",3)
    end
    local heroname
    if VERSION_REDUCE then
        heroname = cc.ui.UILabel.new({
            UILabelType = 2,
            text = text,
            size = 20,
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = 60,
            y = 140,
            })
    else
        heroname = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = text,
            size = 24,
            color = cc.c3b(255,255,255),
            x = 70,
            y = 140,
            })
    end
    -- local heroname = cc.ui.UILabel.new({
    --     text = text,
    --     size = 24,
    --     color = cc.c3b(255,255,255),
    --     x = 70,
    --     y = 140,
    --     })
    self.textBg:addChild(heroname)
    if VERSION_REDUCE then
        self.textMess = cc.ui.UILabel.new({
            UILabelType = 2,
            text = msg,
            size = 20,
            font = "fontEasy.ttf",
            dimensions = cc.size(300, 150),
            color = cc.c3b(255,255,255),
            x = 70,
            y = 125,
            }):align(display.LEFT_TOP)
    else
        self.textMess = cc.ui.UILabel.new({
            text = msg,
            size = 24,
            color = cc.c3b(255,255,255),
            x = 70,
            y = 125,
            }):align(display.LEFT_TOP)
    end
    -- self.textMess = cc.ui.UILabel.new({
    --     text = msg,
    --     size = 24,
    --     color = cc.c3b(255,255,255),
    --     x = 70,
    --     y = 125,
    --     }):align(display.LEFT_TOP)
    self.textBg:addChild(self.textMess)

    if continue then
        if VERSION_REDUCE then
            self.continue = cc.ui.UILabel.new({
                UILabelType = 2,
                text = kkFunc.getVersionText("教学",5),
                size = 20,
                font = "fontEasy.ttf",
                color = cc.c3b(255,230,60),
                x = 220,
                y = 37,
                })
        else
            self.continue = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",
                text = kkFunc.getVersionText("教学",5),
                size = 24,
                color = cc.c3b(255,230,60),
                x = 200,
                y = 35,
                })
        end
        -- self.continue = cc.ui.UILabel.new({
        --     text = kkFunc.getVersionText("教学",5),
        --     size = 24,
        --     color = cc.c3b(255,230,60),
        --     x = 200,
        --     y = 37,
        --     })
        self.textBg:addChild(self.continue)
    end
end
function NewbieGuideLayer:showClickHand(pt,hasCircle)
    self.hand = display.newSprite("#tipFinger1.png")
    local frames = display.newFrames("tipFinger%d.png", 1, 2)
    local animation = display.newAnimation(frames, 0.1)
    self.hand:runAction(cc.RepeatForever:create(transition.sequence({
        cc.Animate:create(animation),
        cc.Animate:create(animation),
        cc.DelayTime:create(0.6),
    })))
    self.hand:setPosition(pt.x+25,pt.y-25)
    self.hand:setScale(0.5)
    self:addChild(self.hand,2)
    --if hasCircle then
        self.clickground = display.newSprite("#clickground.png",pt.x,pt.y)
        if not hasCircle then
            self.clickground:setVisible(false)
        end
        self:addChild(self.clickground)
        self.clickground:setScale(0)
        self.clickground:runAction(cc.RepeatForever:create(transition.sequence({
            cc.Spawn:create(
                cc.ScaleTo:create(1,1),
                cc.FadeTo:create(1,0)
            ),
            cc.CallFunc:create(function()
                self.clickground:setOpacity(255)
                self.clickground:setScale(0)
            end)
        })))
   -- end
end

function NewbieGuideLayer:goLevel11(goLevelStep)
    if goLevelStep == 1 then
        self.step = 21
        g_playScene.pause = false
        g_playScene:suspend()
        self:showHeroDialog(3, "  注意！在南极洲关卡中，炮\n塔只能建在虚线框内的浮冰\n上。", true, "left")
    elseif goLevelStep == 2 then
        g_playScene.pause = true
        g_playScene:suspend()
        self.textBg:setVisible(false)
        self.step = 22
    end
end
function NewbieGuideLayer:goLevel12(goLevelStep)
    if goLevelStep == 1 then
        self.step = 23
        g_playScene.pause = false
        g_playScene:suspend()
        self:showHeroDialog(3, "  部分地图中会出现不稳定\n的冰块，打碎它们，怪物就\n会从冰缝之间掉下去直接\n被秒杀。但是要注意，每\n隔一段时间，冰块就会恢复。", true, "left")
        local pt = {
                [1] = MapInfo:getCenterOfTile(cc.p(4,3)),
                [2] = MapInfo:getCenterOfTile(cc.p(8,5)),
            }
        self.floatIce = {}
        for i=1 ,2 do
            self.floatIce[i] = display.newSprite("#clickground.png",pt[i].x,pt[i].y)
            self:addChild(self.floatIce[i])
            self.floatIce[i]:setScale(0)
            self.floatIce[i]:runAction(cc.RepeatForever:create(transition.sequence({
                cc.Spawn:create(
                    cc.ScaleTo:create(1,1),
                    cc.FadeTo:create(1,0)
                ),
                cc.CallFunc:create(function()
                    self.floatIce[i]:setOpacity(255)
                    self.floatIce[i]:setScale(0)
                end)
            })))
        end
    elseif goLevelStep == 2 then
        g_playScene.pause = true
        g_playScene:suspend()
        self.textBg:setVisible(false)
        self.floatIce[1]:removeFromParent()
        self.floatIce[2]:removeFromParent()
        self.step = 24
    end
end
function NewbieGuideLayer:goLevel14(goLevelStep)
    if goLevelStep == 1 then
        self.step = 27
        g_playScene.pause = false
        g_playScene:suspend()
        self:showHeroDialog(3, kkFunc.getVersionText("教学",24), true, "left")
    elseif goLevelStep == 2 then
        self.step = 28
        self.textMess:setString(kkFunc.getVersionText("教学",25))
        self.continue:setVisible(false)
        local pt = MapInfo:getCenterOfTile(cc.p(6,2))--7,2
        self.graylayer = self:getMaskLayer(pt)
        self:addChild(self.graylayer,-1)
        self.rect = cc.rect(pt.x-25,pt.y-20, 100, 100)
        self.rectVisible = true
        self:showClickHand(pt,true)
    elseif goLevelStep == 3 then
        self.isCanTouchGround = true
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.rect.y = self.rect.y + 60
        self.graylayer = self:getMaskLayer(cc.p(self.rect.x+25,self.rect.y+25))
        self:addChild(self.graylayer,-1)
        self.hand:setPosition(self.rect.x+50,self.rect.y)
    elseif goLevelStep == 4 then
        self.clickground:removeFromParent()
        self.graylayer:removeFromParent()
        self.hand:removeFromParent()
        self.textBg:removeFromParent()
        self.rect = nil
        self.isCanTouchGround = false
        g_playScene.pause = true
        g_playScene:suspend()
        GameData.guide.level9 = true
        GameState.save(GameData)
    end
end
function NewbieGuideLayer:goLevel7(goLevelStep)
    if goLevelStep == 1 then
        self.step = 25
        g_playScene.pause = false
        g_playScene:suspend()
        self:showHeroDialog(3, kkFunc.getVersionText("教学",22), true, "left")
    elseif goLevelStep == 2 then
        self.step = 26
        self.textMess:setString(kkFunc.getVersionText("教学",6))
        self.continue:setVisible(false)
        local pt = MapInfo:getCenterOfTile(cc.p(4,0))--7,2
        self.graylayer = self:getMaskLayer(pt)
        self:addChild(self.graylayer,-1)
        self.rect = cc.rect(pt.x-25,pt.y-20, 40, 40)
        self.rectVisible = true
        self:showClickHand(pt,true)
    elseif goLevelStep == 3 then
        self.clickground:setVisible(false)
        self.rect.y = self.rect.y-90
        self.rect.x = self.rect.x - 20
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.graylayer = self:getMaskLayer(cc.p(self.rect.x,self.rect.y+20))
        self:addChild(self.graylayer,-1)
        self.rect.width = self.rect.width
        self.rect.height = self.rect.height + 10
        self.hand:setPosition(self.rect.x+45,self.rect.y)
    elseif goLevelStep == 4 then
        local pt = g_playScene.cityHome:getPositionCenter()
        self.rect = cc.rect(pt.x-50,pt.y-50, 100, 100)
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.graylayer = self:getMaskLayer(cc.p(pt.x,pt.y))
        self:addChild(self.graylayer,-1)
        self.textMess:setString(kkFunc.getVersionText("教学",23))
        self.hand:setPosition(self.rect.x+80,self.rect.y+20)
    elseif goLevelStep == 5 then
        self.graylayer:removeFromParent()
        self.hand:removeFromParent()
        self.textBg:removeFromParent()
        g_playScene.pause = true
        g_playScene:suspend()
        self.rect = nil
        GameData.guide.level7 = true
        GameState.save(GameData)
        --self.rectVisible = false
        --g_playScene:callNextWave()
    end
end
function NewbieGuideLayer:goLevel1(goLevelStep)
    if goLevelStep == 1 then
        local px = self:getParent().levelButton[101]:getPositionX()
        local py = self:getParent().levelButton[101]:getPositionY() --+ 20 - (720 - display.height)*0.5
        self.rect = cc.rect(px-30,py-30,60,60)
        self.graylayer = self:getMaskLayer(cc.p(px,py))
        self:addChild(self.graylayer,-1)
        self:showClickHand(cc.p(px,py),false)
        self:showHeroDialog(1, kkFunc.getVersionText("教学",10), false, "right")
    elseif goLevelStep == 2 then
        self.textBg:setVisible(false)
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.rect = cc.rect(display.cx+160,display.cy-290,140,60) 
        self.graylayer = self:getMaskLayer(cc.p(display.cx+230,display.cy-260))
        self:addChild(self.graylayer,-1)
        self.hand:setPosition(display.cx+270,display.cy-300)
        self.clickground:setPosition(display.cx+270-25,display.cy-300+25)
        self.clickground:setVisible(true)
    end
end

function NewbieGuideLayer:goLevel2(LevelTwoStep)
    if LevelTwoStep == 1 then
        self:setTouchSwallowEnabled(true)
        self.heroSkillControl = false
        g_playScene.pause = false
        g_playScene:suspend()

        self:showHeroDialog(3, kkFunc.getVersionText("教学",19), false, "left")
    
        local pt = MapInfo:getCenterOfTile(cc.p(3,2))--7,2
        self.graylayer = self:getMaskLayer(pt)
        self:addChild(self.graylayer,-1)
        self.rect = cc.rect(pt.x-20,pt.y-20, 40, 40)
        self.rectVisible = true
        self:showClickHand(pt,true)
    elseif LevelTwoStep == 8 then
        self.step = 11
        g_playScene.pause = true
        g_playScene:suspend()
        self.hand:setVisible(false)
        self.clickground:setVisible(false)
        self.textBg:removeFromParent()
        self:showHeroDialog(3, kkFunc.getVersionText("教学",20), true, "left")
    elseif LevelTwoStep == 9 then
        g_playScene.pause = false
        g_playScene:suspend()
        self.hand:setVisible(true)
        self.clickground:setVisible(true)
    elseif LevelTwoStep == 2 then
        self.step = 12
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
            self.graylayer = nil
        end
        self.clickground:setVisible(false)
        self.hand:setVisible(false)
        self.textBg:setVisible(false) 
        self.rect = nil
        self:setTouchSwallowEnabled(false)
    elseif LevelTwoStep == 3 then
        g_playScene.pause = false
        g_playScene:suspend()
        self.textMess:setString(kkFunc.getVersionText("教学",21))
        self.textBg:setVisible(true)
        self.heroSkillControl = true
        g_playScene.skillLayer.skillSprite[1]:removeAllChildren()
        local px = g_playScene.skillLayer.skills[1].sprite:getPositionX()
        local py = 44
        self.rect = cc.rect(px-30,py-30, 60, 60)
        self.graylayer = self:getMaskLayer(cc.p(px,py))
        self:addChild(self.graylayer,-1)
        self.hand:setPosition(px+25,py-25)
        self.clickground:setPosition(px,py)
        self.hand:setVisible(true)
        self.clickground:setVisible(true)
    elseif LevelTwoStep == 5 then
        self.graylayer:removeFromParent()
        self:performWithDelay(function()
            g_playScene.newbieguidelayer:removeFromParent()
            g_playScene.newbieguidelayer = nil
        end, 5)
        self.textBg:setVisible(false)
        g_playScene.pause = true
        g_playScene:suspend()
        self.rectVisible = false     
        self.hand:setVisible(false)
        self.clickground:setVisible(false)    
        GameData.guide.level2 = true
        GameState.save(GameData)
    elseif LevelTwoStep == 6 then
        local px = self:getParent().levelButton[102]:getPositionX()
        local py = self:getParent().levelButton[102]:getPositionY() --+ 40 - (720 - display.height)*0.5
        self.rect = cc.rect(px-30,py-30,60,60)
        self.graylayer = self:getMaskLayer(cc.p(px,py))
        self:addChild(self.graylayer,-1)
        self:showClickHand(cc.p(px,py),false)
        self:showHeroDialog(1, kkFunc.getVersionText("教学",18), false, "up")
    elseif LevelTwoStep == 7 then
        self.textBg:setVisible(false)
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.rect = cc.rect(display.cx+160,display.cy-290,140,60) 
        self.graylayer = self:getMaskLayer(cc.p(display.cx+230,display.cy-260))
        self:addChild(self.graylayer,-1)
        self.hand:setPosition(display.cx+270,display.cy-300)
        self.clickground:setPosition(display.cx+270-25,display.cy-300+25)
        self.clickground:setVisible(true)
    end
end
function NewbieGuideLayer:goHeroHouse(goHeroHouseStep)
    if goHeroHouseStep == 1 then
        self.step = 9
        self:setTouchSwallowEnabled(true)
        self.graylayer = self:getMaskLayer(cc.p(10000,10000))
        self:addChild(self.graylayer)
        self:showHeroDialog(1, kkFunc.getVersionText("教学",15), true, "up")
    elseif goHeroHouseStep == 2 then
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self:performWithDelay(function()
            self.rect = cc.rect(display.cx+50,25, 100, 100)
        end, 0.2)
        self.step = 10
        self.graylayer = self:getMaskLayer(cc.p(display.cx+100,75))
        self:addChild(self.graylayer,-1)
        self.textBg:setVisible(false)
        self:showClickHand(cc.p(display.cx+100,75),true)
    elseif goHeroHouseStep == 3 then
        self:showHeroDialog(1, kkFunc.getVersionText("教学",16), false, "right",display.cx+20)
        local px = display.cx -420 +115
        local py = display.cy - 265   
        self:performWithDelay(function()
            self.rect = cc.rect(px-60,py-40, 120, 70)
        end, 0.2)
        self.graylayer = self:getMaskLayer(cc.p(px,py))
        self:addChild(self.graylayer,-1)
        self:showClickHand(cc.p(px,py),true)
    elseif goHeroHouseStep == 5 then
        self.step = 15
        self.graylayer:removeFromParent()
        self.graylayer = nil
        self:setTouchSwallowEnabled(true)
        self.hand:setVisible(false)
        self.clickground:setVisible(false)
        self.rect = nil
        self.textBg:removeFromParent()
        self:showHeroDialog(1, kkFunc.getVersionText("教学",17), true, "left")
    elseif goHeroHouseStep == 6 then
        self.step = 16
        self.textBg:setVisible(false)
        local px = display.cx-380
        local py = display.height-50
        self.rect = cc.rect(px-25,py-25,50,50)
        self.graylayer = self:getMaskLayer(cc.p(px,py))
        self:addChild(self.graylayer,-1)
        self:showClickHand(cc.p(px,py),true)
        GameData.guide.herohouse = true
    end
end
function NewbieGuideLayer:showDialogLevel1(step)
    --第一关步骤self.step从4开始
    if step == 1 then 
        self.heroSkillLabelCount = 10   
        self.heroCanTouch = false
        self:showHeroDialog(1, kkFunc.getVersionText("教学",11), true, "left")
        self.textBg:setVisible(false)
    elseif step == 2 then
        self.heroMoveLabelCount = 10
    end
end
function NewbieGuideLayer:update(dt)
    if self.heroSkillLabelCount ~= nil then
        self.heroSkillLabelCount = self.heroSkillLabelCount - dt
        if self.heroSkillLabelCount < 0 then
            self.step = 4
            g_playScene.pause = false
            g_playScene:suspend()
            self.textBg:setVisible(true)
            self.heroSkillLabelCount = nil
        end
    end
    if self.heroMoveLabelCount ~= nil then
        self.heroMoveLabelCount = self.heroMoveLabelCount - dt
        if self.heroMoveLabelCount < 0 then
            self:setTouchSwallowEnabled(true)
            self.step = 6
            g_playScene.ui:setTouchCaptureEnabled(false)
            g_playScene.pause = false
            g_playScene:suspend()
            self.textBg:setVisible(true)
            self.textMess:setString(kkFunc.getVersionText("教学",12))
            self.heroMoveLabelCount = nil
        end
    end
end
function NewbieGuideLayer:moveHeroTip()
    self.step = 7
    g_playScene.hero.waitInfo.focus = false
    self.heroCanTouch = true

    self.textBg:removeFromParent()
    self:showHeroDialog(1, kkFunc.getVersionText("教学",13), false, "right",display.cx+20)

    local pt = MapInfo:getCenterOfTile(cc.p(3,5))--7,2
    local ptHero = MapInfo:getCenterOfTile(cc.p(5,3))
    --self.graylayer = self:getMaskLayer(pt,cc.p(ptHero.x,ptHero.y+40))
    --self:addChild(self.graylayer,-1)
    self.rect = cc.rect(pt.x-50,pt.y-50, 100, 100)
    self.rectHero = cc.rect(ptHero.x-20,ptHero.y-20,40,60)
    self.hand = display.newSprite("#tipFinger1.png",ptHero.x+20,ptHero.y)
    local frames = display.newFrames("tipFinger%d.png", 1, 2)
    local animation = display.newAnimation(frames, 0.1)
    self.hand:setScale(0.5)
    self:addChild(self.hand,2)
    self.hand:runAction(cc.RepeatForever:create(transition.sequence({
        cc.Animate:create(animation),
        cc.MoveTo:create(1.5,cc.p(pt.x+25,pt.y-30)),
        cc.Animate:create(animation),
        cc.DelayTime:create(1),
        cc.CallFunc:create(function()
            self.hand:setPosition(ptHero.x+20,ptHero.y)
        end),
        cc.DelayTime:create(1)
    })))
end
function NewbieGuideLayer:moveHero()
    --[[if self.graylayer ~= nil then
        self.graylayer:removeFromParent()
        self.graylayer = nil
    end
    ]]
    self.rect = nil
    g_playScene.pause = true
    g_playScene:suspend()
    g_playScene.hero.waitInfo.focus = true
    self.hand:stopAllActions()
    self.hand:setVisible(false)
    self.rectHero = nil
    self.textBg:setVisible(false)
    g_playScene.ui:setTouchCaptureEnabled(true)
end
function NewbieGuideLayer:showDialog()
    self.step = 1
    g_playScene.pause = false
    g_playScene:suspend()
    self:showHeroDialog(3, kkFunc.getVersionText("教学",2), true, "left")
end
function NewbieGuideLayer:clickGround()
    self.step = 2
    self.textMess:setString(kkFunc.getVersionText("教学",6))
    self.continue:setVisible(false)
    local pt = MapInfo:getCenterOfTile(cc.p(6,4))--7,2
    self.graylayer = self:getMaskLayer(pt)
    self:addChild(self.graylayer,-1)
    self.rect = cc.rect(pt.x-20,pt.y-20, 40, 40)
    self.rectVisible = true
    self:showClickHand(pt,true)
end
function NewbieGuideLayer:createTower(step)
    if step == 1 then
        self.clickground:setVisible(false)
        self.rect.y = self.rect.y+70
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.graylayer = self:getMaskLayer(cc.p(self.rect.x+20,self.rect.y+35))
        self:addChild(self.graylayer,-1)
        self.rect.height = self.rect.height + 10
        self.hand:setPosition(self.rect.x+45,self.rect.y)
    elseif step == 2 then
        self.graylayer:removeFromParent()
        self.graylayer = nil
        g_playScene.pause = true
        g_playScene:suspend()
        self.textBg:setVisible(false)
        self.hand:setVisible(false)
        self.rectVisible = false
        g_playScene:callNextWave()
    elseif step == 3 then
        self.textMess:setString(kkFunc.getVersionText("教学",7))
        g_playScene.pause = false
        g_playScene:suspend()
        local pt = MapInfo:getCenterOfTile(cc.p(5,2))
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.graylayer = self:getMaskLayer(pt)
        self:addChild(self.graylayer,-1)
        self.rect.x = pt.x-20
        self.rect.y = pt.y-20
        self.hand:setPosition(pt.x+25,pt.y-30)
        self.clickground:setPosition(pt)
        self.clickground:setVisible(true)
        self.textBg:setVisible(true)
        self.rectVisible = true
        self.hand:setVisible(true)
    elseif step == 4 then
        g_playScene.pause = false
        g_playScene:suspend()
        local pt = MapInfo:getCenterOfTile(cc.p(6,4))
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.graylayer = self:getMaskLayer(pt)
        self:addChild(self.graylayer,-1)
        self.rect.x = pt.x-20
        self.rect.y = pt.y-20
        self.hand:setPosition(pt.x+25,pt.y-30)
        self.rectVisible = true
        self.hand:setVisible(true)
        self.textBg:setVisible(true)
        self.textMess:setString(kkFunc.getVersionText("教学",8))
    elseif step == 5 then
        self.rect.y = self.rect.y+70
        if self.graylayer ~= nil then
            self.graylayer:removeFromParent()
        end
        self.graylayer = self:getMaskLayer(cc.p(self.rect.x+20,self.rect.y+35))
        self:addChild(self.graylayer,-1)
        self.rect.height = self.rect.height + 10
        self.hand:setPosition(self.hand:getPositionX(),self.hand:getPositionY()+70)
    elseif step == 6 then
        self.graylayer:removeFromParent()
        g_playScene.pause = true
        g_playScene:suspend()
        self.hand:setVisible(false)
        self.textBg:setVisible(false)
        self.rectVisible = false
        g_playScene:callNextWave()
    end
end
function NewbieGuideLayer:levelResultLayer(levelNum)
    if levelNum == 100 then
        self.step = 3
        self.continue:setVisible(true)
        self.textBg:setVisible(true)
        self.textMess:setString(kkFunc.getVersionText("教学",9))
        GameData.guide.teachLevel = true
        GameState.save(GameData)
    elseif levelNum == 101 then
        self.step = 8
        self:showHeroDialog(1, kkFunc.getVersionText("教学",14), true, "left")
    end
end
function NewbieGuideLayer:levelShowResult()
    self.step = 19
    g_playScene:showResult(true)
    self:performWithDelay(function()
        self:removeFromParent()
    end, 0.5)
end
function NewbieGuideLayer:createSkill2() 
    self.textBg:setVisible(false)
    self.step = 5
    for i=1,2 do
        g_playScene.skillLayer.skillSprite[i]:setVisible(true)
    end
    local pt = MapInfo:getCenterOfTile(cc.p(5,3))
    if g_playScene.hero.waitInfo.focusBuff ~= nil then
        g_playScene.hero.waitInfo.focusBuff:removeFromParent()
        g_playScene.hero.waitInfo.focusBuff = nil
    end
    g_playScene.hero:setPosition(cc.p(pt.x-3,pt.y))
    g_playScene.hero.waitInfo.pos = pt
    g_playScene.skillLayer.heroIcon:setVisible(true)
    g_playScene.hero.hpBar:setVisible(true)
    g_playScene.hero:setVisible(true)
    self.cover = cc.LayerColor:create(cc.c4b(0,0,0,200))
    self:performWithDelay(function()
        self.cover:removeFromParent()
        g_playScene.pause = true
        g_playScene:suspend()
        g_playScene:setCanTouch(true)
    end, 3)
    g_playScene:setCanTouch(false)  
    g_fightLayer:addChild(self.cover, BaseZOrder.hero-1)
    local skill = Skills[2].new({idx = 2}) 
    g_fightLayer:addChild(skill, BaseZOrder.hero)
end
function NewbieGuideLayer:onExit()
	--ResData.removeRes("UI_NEWBIEGUIDE")		
end

--蒙灰板上有一圆形光亮
function NewbieGuideLayer:getMaskLayer(p,p2)
    local layer = cc.LayerColor:create(cc.c4b(0,0,0,150))
    layer:retain()
    local finger = display.newSprite("pic/pen.png",p.x, p.y)
    finger:retain()
    finger:setBlendFunc(gl.ZERO, gl.ONE_MINUS_SRC_ALPHA)
    finger:setScale(2)
    local finger2 = nil
    if p2 ~= nil then
        finger2 = display.newSprite("pic/pen.png",p2.x, p2.y)
        finger2:retain()
        finger2:setBlendFunc(gl.ZERO, gl.ONE_MINUS_SRC_ALPHA)
        finger2:setScale(2)
    end
    local mask = cc.RenderTexture:create(
        display.width, display.height,
        cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
    mask:setPosition(display.cx,display.cy)
    mask:begin()
    layer:visit()
    finger:visit()
    if finger2 ~= nil then
        finger2:visit()
    end
    mask:endToLua()
    layer:performWithDelay(function() layer:release() end, 1)
    finger:performWithDelay(function() finger:release() end, 1)
    if finger2 ~= nil then
        finger2:performWithDelay(function() finger2:release() end, 1)
    end
    return mask
end

return NewbieGuideLayer