--
-- Author: Wangzhihao
-- Date: 2014-11-10 10:12:35
--
--现在 圣水1 牛奶2 复活石3 狂暴4
--[[local ItemMes = {
	[1] = "关卡初始圣水增加\n500",
	[2] = "守护点生命上限提高\n两点",
    [3] = "英雄复活时间减少一\n半",
    [4] = "英雄技能冷却时间减\n少30%",
    [5] = "获得1次使用钻石英\n雄的机会",
    [6] = "随机获得一种道具",
}]]
local ItemGiftBag = {
    [1] = {
        pic = "#pre_itemIcon2.png",
        message = "守护生命立即回复3\n点",
    },
    [2] = {
        pic = "#pre_itemIcon3.png",
        message = "立即复活英雄",
    },
    [3] = {
        pic = "#pre_itemIcon4.png",
        message = "英雄攻击增加5%，\n持续15秒",
    },
}
local Task = import("..common.Task")
local PurchaseItemLayer = import("..sprites.PurchaseItemLayer")
local PrepareLayer = class("PrepareLayer",function() 
	return  display.newLayer("PrepareLayer") 
end)
PrepareLayer.lastTheme = 0

function PrepareLayer:ctor(level)
    self:setNodeEventEnabled(true)
	self.level = level
	self.startControl = 1
    self.items = {}
    --触摸层
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,5)

	self.colorBg = cc.LayerColor:create(cc.c4b(0,0,0,0),display.width,display.height)
	self:addChild(self.colorBg,-1)
	self.returnButton = cc.ui.UIPushButton.new({
        normal = "#returnNew.png",
        pressed = "#returnNew.png",
        disabled = "#returnNew.png",
	})
    :onButtonPressed(function()
        self.returnButton:setScale(1.1)
        --音效
        SoundManager.playSound(GAME_SOUND.Button2)
    end)
    :onButtonRelease(function()
        self.returnButton:setScale(1)
    end)
    :onButtonClicked(function(event)
        self:Remove()
    end)
    :pos(display.cx-380, display.height-50)
    :addTo(self)

    if VERSION_REDUCE then
        self.startButton = cc.ui.UIPushButton.new({
                normal = "#pre_startButton.png",
                pressed = "#pre_startButton.png",
                disabled = "#pre_startButton.png",
            })
            :onButtonPressed(function()
                self.startButton:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button1)
            end)
            :onButtonRelease(function()
                self.startButton:setScale(1)
            end)
            :onButtonClicked(function()
                if GameData.energy.value ~= 0 then
                    if self.startControl == 1 then
                    	self.startControl = self.startControl + 1
                        self:rotateLayer(false)
                    elseif self.startControl == 2 then
                        local function EnterGame()
                            app:play({
                                level = self.level,
                                items = self.items,
                            })
                        end
                        kkFunc.EnergyReduce()
                        g_infoLayer.energyLabel:setString(g_infoLayer:GetEnergyLabel())
                        if GameData.energy.value == -1 then
                            EnterGame()
                        else
                            self.startButton:setTouchEnabled(false)
                            self:runAction(transition.sequence({
                                cc.CallFunc:create(function ()
                                    kkFunc.ObtainEffect(self,g_infoLayer.TopPic.Energy,
                                        self:convertToWorldSpace(cc.p(self.startButton:getPosition()))
                                        ,0.7,"#bloodNew.png",function ()
                                            EnterGame()
                                        end
                                        )
                                end),
                            }))
                        end
                    end 
                end            
            end)
            :pos(display.cx + 830, display.cy - 260)
            :addTo(self) 
    end
    self.percent = self:countPopGiftBagPercent()
    --LevelTask
    self:showTaskList() --任务列表
    if VERSION_REDUCE then--道具列表
        self.itemBg = PurchaseItemLayer.new()
        self:addChild(self.itemBg)
    else
        if self:isPopItemGiftBag() then
            self:showItemGiftBag()
        end
    end   
    self:showMapPreview() --预览页面
end
function PrepareLayer:countPopGiftBagPercent()
    local popPercent = 3
         --厦门
    -- if device.platform == "android" then
    --     popPercent = DCConfigParams.getParamNumber("GiftBagPopPercent", 3)
    -- end
         --厦门
    if popPercent < 0 or popPercent > 100 then
        popPercent = 3
    end
    local randomNum = math.random(0,100)
    if randomNum <= popPercent then
        return true
    else
        return false
    end
end
function PrepareLayer:isPopItemGiftBag() 
    local dataEyeParamsSwitch = "true"--在模拟器上正常打开
    local firstPopLevel = 3
    local mustPopLevel = 10
        --厦门
    -- if device.platform == "android" then
    --     if MI_SERVICE then
    --         dataEyeParamsSwitch = DCConfigParams.getParamString("ItemGiftBagSwitch_MI", "false")
    --     else
    --         dataEyeParamsSwitch = DCConfigParams.getParamString("ItemGiftBagSwitch", "false")
    --     end
    --     firstPopLevel = DCConfigParams.getParamNumber("GiftBagFirstPopLevel", 3)
    --     mustPopLevel = DCConfigParams.getParamNumber("GiftBagMustPopLevel", 10)
    -- end 
        --厦门
    if dataEyeParamsSwitch == "true" then
        if (LevelsData.getRealLevel(self.level) >= firstPopLevel and LevelsData.getRealLevel(self.level) < mustPopLevel and self.percent)
            or LevelsData.getRealLevel(self.level) >= mustPopLevel then
            return true
        else
            return false
        end
    end
    return false
end
function PrepareLayer:Remove()
    if self.startControl == 1 then
        self:back()
    elseif self.startControl == 2 then
        self.startControl = self.startControl - 1
        self:rotateLayer(true)
    end
end

function PrepareLayer:onEnter()
    -- 注册touch事件处理函数
    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)
    self.touchLayer:setTouchSwallowEnabled(false)

    self.colorBg:runAction(cc.FadeTo:create(0.2,100))
    if VERSION_REDUCE then
        self.taskBg:runAction(cc.EaseOut:create(cc.MoveBy:create(0.2,cc.p(600,0)),1))
        self.mapBg:runAction(cc.EaseOut:create(cc.MoveBy:create(0.2,cc.p(-600,0)),1))
    else
        local percent = math.random(1,5) 
        if self:isPopItemGiftBag() then
            self.itemBg:runAction(cc.EaseOut:create(cc.MoveBy:create(0.2,cc.p(-600,0)),1))
        else
            self.taskBg:runAction(cc.EaseOut:create(cc.MoveBy:create(0.2,cc.p(-600,0)),1))
        end
        self.mapBg:runAction(cc.EaseOut:create(cc.MoveBy:create(0.2,cc.p(600,0)),1))
    end
    -- self.mapBg:runAction(cc.EaseOut:create(cc.MoveBy:create(0.2,cc.p(-600,0)),1))
    if VERSION_REDUCE then
        self.startButton:runAction(cc.EaseOut:create(cc.MoveBy:create(0.2,cc.p(-600,0)),1))
    end
end

function PrepareLayer:back()
    self:setTouchCaptureEnabled(false)
    self:getParent():levelBack()
    self.colorBg:runAction(cc.FadeTo:create(0.2,0))
    if VERSION_REDUCE then
        self.taskBg:runAction(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(-600,0)),1))
        self.mapBg:runAction(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(600,0)),1))
    else
        if self:isPopItemGiftBag() then
            self.itemBg:runAction(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(600,0)),1))
        else
            self.taskBg:runAction(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(600,0)),1))
        end
        self.mapBg:runAction(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(-600,0)),1))
    end
    if VERSION_REDUCE then
        self.startButton:runAction(cc.EaseIn:create(cc.MoveBy:create(0.2,cc.p(600,0)),1))
    end
end

function PrepareLayer:rotateLayer(isBack)
    if isBack == true then
        local seqOne = cc.Sequence:create({
            cc.OrbitCamera:create(0.15,1,0,0,90,0,0),
            cc.CallFunc:create(function()
                if VERSION_REDUCE then
                    self.itemBg:setVisible(false)
                else
                    self.taskBg:setVisible(false)
                end 
            end),
            cc.OrbitCamera:create(0.15,1,0,90,-90,0,0),
        })
        local seqTwo = cc.Sequence:create({
            cc.OrbitCamera:create(0.15,1,0,0,90,0,0),
            cc.CallFunc:create(function()
                if VERSION_REDUCE then
                    self.taskBg:setVisible(true)
                else
                    self.itemBg:setVisible(true)
                end        
            end),
            cc.OrbitCamera:create(0.15,1,0,90,-90,0,0),
        }) 
        if VERSION_REDUCE then
            self.taskBg:runAction(seqOne) 
            self.itemBg:runAction(seqTwo)
        else
            self.itemBg:runAction(seqOne) 
            self.taskBg:runAction(seqTwo)
        end
    else
        local seqOne = cc.Sequence:create({
            cc.OrbitCamera:create(0.15,1,0,0,90,0,0),
            cc.CallFunc:create(function()
                if VERSION_REDUCE then
                    self.taskBg:setVisible(false)
                else
                    self.itemBg:setVisible(false)
                end     
            end),
            cc.OrbitCamera:create(0.15,1,0,90,-90,0,0),
        })
        local seqTwo = cc.Sequence:create({
            cc.OrbitCamera:create(0.15,1,0,0,90,0,0),
            cc.CallFunc:create(function()
                if VERSION_REDUCE then
                    self.itemBg:setVisible(true)
                else
                    self.taskBg:setVisible(true)
                end
            end),
            cc.OrbitCamera:create(0.15,1,0,90,-90,0,0),
        })
        if VERSION_REDUCE then
            self.taskBg:runAction(seqOne)
            self.itemBg:runAction(seqTwo)
        else
            self.itemBg:runAction(seqOne) 
            self.taskBg:runAction(seqTwo)
        end
    end
end

function PrepareLayer:showTaskList()
	local subX,numSub
	if VERSION_REDUCE then	
		subX = 800
        numSub = 30
	else
        if self:isPopItemGiftBag() then
    		-- subX = 220 -- -230
            subX = -220
            numSub = 22
        else
            -- subX = 820 -- -830
            subX = -830
            numSub = 22
        end
	end	
    self.taskBg = display.newSprite("#pre_taskBg.png",display.cx - subX,display.cy - numSub)
    local size = self.taskBg:getContentSize()
	self:addChild(self.taskBg)
    if not VERSION_REDUCE and self:isPopItemGiftBag() then
        self.taskBg:setVisible(false)
    end
    --
    local taskX
    if VERSION_MONSTER then
        taskX = self.taskBg:getContentSize().width/2 + 5
    else
        taskX = self.taskBg:getContentSize().width/2
        local taskBarBg = display.newSprite("#pre_itemBarBg.png",215,275)
        self.taskBg:addChild(taskBarBg)
    end
    local taskLabel = display.newSprite("#pre_taskLabel.png",taskX,500)
    self.taskBg:addChild(taskLabel)
	self.taskData = TaskData[self.level]
    self.singletaskBg = {}
    if TaskData[self.level] == nil then return end
    for i = 1 , #self.taskData do
        self.singletaskBg[i] = display.newSprite("#pre_taskSingleBg.png")
        --self.singletaskBg[i] = cc.LayerColor:create(cc.c4b(0,0,0,0),self.taskBg:getContentSize().width*9/10,self.taskBg:getContentSize().height/5)
        self.singletaskBg[i]:setPosition(self.taskBg:getContentSize().width/2,self.taskBg:getContentSize().height/2+(2-i)*120-4)
        self.taskBg:addChild(self.singletaskBg[i],5)
        --图标
        local task = self.taskData[i]
        local taskIcon
        if task.type == 1 or task.type == 2 or task.type == 6 or task.type == 10 or task.type == 11 then--炮塔
            taskIcon = display.newSprite("#taskTowerIcon"..task.towerIdx..".png",65,64)
        elseif task.type == 8 then--所有炮塔
            taskIcon = display.newSprite("#taskTowerIcon1.png",65,64)
        elseif task.type == 7 or task.type == 14 then--英雄
            taskIcon = display.newSprite("#taskHeroIcon"..GameData.selectHero..".png",65,64)
        elseif task.type == 3 or task.type == 5 or task.type == 9 or task.type ==  12 or task.type ==  13 then--道具
            taskIcon = display.newSprite("#taskThingIcon.png",65,64)
        elseif task.type == 4 then--金钱
            taskIcon = display.newSprite("#taskMoneyIcon.png",65,64)
        end
        self.singletaskBg[i]:addChild(taskIcon)
        local levelTask
        if VERSION_REDUCE then
            levelTask = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontEasy.ttf",
                text = Task:getTaskText(self.taskData[i]),
                color = cc.c3b(108,83,42),
                size = 17,
                dimensions = cc.size(145, 150),
                x = 110,
                y = 20,
            })
        else
            levelTask = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",
                text = Task:getTaskText(self.taskData[i]),
                color = cc.c3b(108,83,42),
                size = 20,
                dimensions = cc.size(135, 90),
                x = 110,
                y = 95,
            }):align(display.LEFT_TOP)
        end
        -- local levelTask = cc.ui.UILabel.new({
        --     text = Task:getTaskText(self.taskData[i]),
        --     color = cc.c3b(108,83,42),
        --     size = 20,
        --     x = 110,
        --     y = 65,
        -- })
        self.singletaskBg[i]:addChild(levelTask)
        if GameData.levelTask[""..self.level][""..i] == true then
            local finish = display.newSprite("#pre_taskFinish.png",305,65)
            self.singletaskBg[i]:addChild(finish)
        else
            local gift = display.newSprite("#pre_taskGifted.png",305,65)
            self.singletaskBg[i]:addChild(gift)
            local fontType
            if VERSION_REDUCE then
                fontType = "fontEasy.ttf"
            else
                fontType = "fontCommon.TTF"
            end
            local num = cc.ui.UILabel.new({
                    UILabelType = 2,
                    font = fontType,
                    text = "×"..ExcelTaskReward[LevelsData.getRealLevel(self.level)][i],
                    size = 20,
                    color = cc.c3b(255,255,255),
                    x = 25,
                    y = 13,
                    })
            gift:addChild(num)
        end         
    end
    local hindranceIconLight = display.newSprite("#pre_allClearLight.png",215,60)
    self.taskBg:addChild(hindranceIconLight)
    if VERSION_REDUCE then
        local hindranceIcon
        if GameData.levelTask[""..self.level]["4"] == true then
            hindranceIcon = display.newSprite("#pre_allClearTitle.png",self.taskBg:getContentSize().width/2,50)
        else
            hindranceIcon = display.newSprite("#pre_allClearTitle.png",self.taskBg:getContentSize().width/2,50)
            hindranceIcon:setColor(cc.c3b(128,128,128))
        end
        self.taskBg:addChild(hindranceIcon)
    else
        self.startButton = cc.ui.UIPushButton.new({
                normal = "#pre_startButton.png",
                pressed = "#pre_startButton.png",
                disabled = "#pre_startButton.png",
            })
            :onButtonPressed(function()
                self.startButton:setScale(1.1)
                --音效
                SoundManager.playSound(GAME_SOUND.Button1)
            end)
            :onButtonRelease(function()
                self.startButton:setScale(1)
            end)
            :onButtonClicked(function()
                if GameData.energy.value ~= 0 then
                    local function EnterGame()
                        app:play({
                            level = self.level,
                            items = self.items,
                        })
                    end
                    kkFunc.EnergyReduce()
                    g_infoLayer.energyLabel:setString(g_infoLayer:GetEnergyLabel())
                    if GameData.energy.value == -1 then
                        EnterGame()
                    else
                        self.startButton:setTouchEnabled(false)
                        self:runAction(transition.sequence({
                            cc.CallFunc:create(function ()
                                kkFunc.ObtainEffect(self,g_infoLayer.TopPic.Energy,
                                    self:convertToWorldSpace(cc.p(790 , 55))
                                    ,0.7,"#bloodNew.png",function ()
                                        EnterGame()
                                    end
                                    )
                            end),
                        }))
                    end 
                end            
            end)
            :pos(self.taskBg:getContentSize().width/2, 55)
            :addTo(self.taskBg) 
    end
end	
function PrepareLayer:showItemGiftBag()
        --厦门
    -- if device.platform == "android" or device.platform == "ios" then
    --     DCEvent.onEvent("道具礼包在关卡界面出现次数")
    -- end
        --厦门
    local subX,numSub
    if self:isPopItemGiftBag() then
        -- subX = 820 -- -820
        subX = -820
        numSub =  22

    else
        -- subX = 220 -- -220
        subX = -220
        numSub = 22
    end
    self.itemBg = display.newSprite("#pre_taskBg.png",display.cx - subX,display.cy -numSub)
    self:addChild(self.itemBg)
    
    local itemBarBg = display.newScale9Sprite("#pre_itemBarBg.png",215,275,cc.size(378,375))
    self.itemBg:addChild(itemBarBg)
    local itemLabel = display.newSprite("#pre_itemLabel.png",self.taskBg:getContentSize().width/2,500)--等换图为 道具礼包
    self.itemBg:addChild(itemLabel)
    self.cancleBtn = cc.ui.UIPushButton.new({
        normal = "#buttonCancel.png",
        pressed = "#buttonCancel.png",
        disabled = "#buttonCancel.png",
    })
    :onButtonPressed(function()
        self.cancleBtn:setScale(1.1)
        --音效
        SoundManager.playSound(GAME_SOUND.Button2)
    end)
    :onButtonRelease(function()
        self.cancleBtn:setScale(1)
    end)
    :onButtonClicked(function(event)
        self.startControl = self.startControl + 1
        self:rotateLayer(false)
    end)
    :pos(self.itemBg:getContentSize().width-20,self.itemBg:getContentSize().height-50)
    :addTo(self.itemBg)
    --18元购买
    self.purchaseGiftBagBtn = cc.ui.UIPushButton.new({
        normal = "#buyItemGiftBag.png",
        pressed = "#buyItemGiftBag.png",
        disabled = "#buyItemGiftBag.png",
    })
    :onButtonPressed(function()
        self.purchaseGiftBagBtn:setScale(1.1)
        --音效
        SoundManager.playSound(GAME_SOUND.Button2)
    end)
    :onButtonRelease(function()
        self.purchaseGiftBagBtn:setScale(1)
    end)
    :onButtonClicked(function(event)
        --厦门
        -- if device.platform == "android" or device.platform == "ios" then
        --     DCEvent.onEvent("玩家进入SDK次数")
        -- end
        --厦门
        local function paycallback(result)
            if result == "success" then
                for i = 2 , 4 do
                    GameData.item["i"..i].number = GameData.item["i"..i].number + 8
                end
                if not GameData.item["i3"].isUnLock or not GameData.item["i4"].isUnLock then
                    kkFunc.popPayPrepSuccessLayer()
                end
                --购买道具礼包解锁道具
                self:unLockItem()
                GameState.save(GameData)
                --DataEye
                    --厦门
                -- if device.platform == "android" or device.platform == "ios" then
                --     DCVirtualCurrency.paymentSuccess("","获得道具礼包",18,"CNY",CHANLE_NAME)
                --     DCEvent.onEvent("购买成功次数")
                -- end
                    --厦门
                --kkFunc.popPaySuccessLayer()
            end          
        end
        --购买道具礼包
        if TEST_DEMO then
            paycallback("success")
        else
            kkFunc.Pay(6,paycallback)
        end
        
    end)
    :pos(self.itemBg:getContentSize().width/2,52)
    :addTo(self.itemBg)
    
    --滑动箭头指示
    self.itemUp = display.newSprite("#pre_itemUp.png",self.itemBg:getContentSize().width/2,370)
    self.itemBg:addChild(self.itemUp)
    self.itemUp:setVisible(false)
    self.itemDown = display.newSprite("#pre_itemDown.png",self.itemBg:getContentSize().width/2,30)
    self.itemBg:addChild(self.itemDown)
    self.itemDown:setVisible(false)
    --
    self.contentLayer = display.newLayer()
    self.contentLayer:setContentSize(cc.size(self.itemBg:getContentSize().width*9/10, 362))
    self.singleItemBg = {}
    self.itemIcon = {}
    local itemNumBg = {}
    local buttonText = ""
    for i = 1, 3 do
        self.singleItemBg[i] = display.newSprite("#pre_taskSingleBg.png")
        self.singleItemBg[i]:setAnchorPoint(0,0)
        local pX
        local buttonX
        if VERSION_MONSTER then 
            pX = 26
            buttonX = 145
        else
            pX = 15
            buttonX = 125
        end
        local itemBgY
        if VERSION_MONSTER then 
            itemBgY = 360-120*i
        else
            itemBgY = 355-120*i
        end
        self.singleItemBg[i]:setPosition(pX,itemBgY)
        self.contentLayer:addChild(self.singleItemBg[i],2) 
        self.itemIcon[i] = display.newSprite(ItemGiftBag[i].pic,53,self.singleItemBg[i]:getContentSize().height/2)
        self.singleItemBg[i]:addChild(self.itemIcon[i])
        local price = ItemData[i].money 
        local mX,mY
        local numX
        local fontColor,fontType
        if VERSION_MONSTER then 
            mX = 44
            mY = 71
            numX = 60
            fontType = "fontCommon.TTF"
            fontColor = cc.c3b(255,201,65)
        else
            mX = 12
            mY = 72
            numX = 55
            fontColor = cc.c3b(108,83,42)
            fontType = "fontCommon.TTF"
        end        
        --图标上背景和数量
        local titleNum = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = "8个",
            color = cc.c3b(255,255,255),
            x = self.singleItemBg[i]:getContentSize().width-60,
            y = self.singleItemBg[i]:getContentSize().height/2,
            }):align(display.CENTER)
        self.singleItemBg[i]:addChild(titleNum)      
        local itemMes = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            size = 18,
            text = ItemGiftBag[i].message,
            color = fontColor,
            x = self.singleItemBg[i]:getContentSize().width/2-90,
            y = self.singleItemBg[i]:getContentSize().height/2+20--旧58
        }):align(display.LEFT_TOP)
        self.singleItemBg[i]:addChild(itemMes)  
    end           
    --
    self.scrollView = cc.ui.UIScrollView.new({})   
    self.scrollView:setColor(cc.c3b(230,143,233))
    self.scrollView:setTouchSwallowEnabled(true)
    local screenSize = cc.Director:getInstance():getWinSize()
    local function scrollView1DidScroll(event)
       --local cp = self.scrollView:getContentOffset()
        if event.name == "moved" then
            --self.preChoose = nil
        end
    end
    local function scrollView1DidZoom()
        --print("scrollView1DidZoom")
    end
    local csize = self.contentLayer:getContentSize()
    if nil ~= self.scrollView then
        local scrollSize = self.contentLayer:getBoundingBox()
        local width
        if VERSION_MONSTER then 
            width = self.itemBg:getContentSize().width-67
        else
            width = self.itemBg:getContentSize().width
        end
        scrollSize.width = width
        scrollSize.height = 360
        self.scrollView:setViewRect(scrollSize)
        self.scrollView:setPosition(cc.p(17,94))
        self.scrollView:setScale(1.0)
        --self.scrollView:setAnchorPoint(cc.p(0.5,0.5))
        --self.scrollView:ignoreAnchorPointForPosition(false)
        self.scrollView:addScrollNode(self.contentLayer)
        self.scrollView:setDirection(1)
        --self.scrollView:scrollTo(cc.p(0,csize.height - scrollSize.height))
        self.scrollView:setBounceable(true)
        self.scrollView:onScroll(scrollView1DidScroll)
    end
    self.itemBg:addChild(self.scrollView,1)
    --self.itemBg:addChild(self.contentLayer,1)
end
function PrepareLayer:unLockItem()
    if  LevelsData.getRealLevel(GameData.openlevel) < 6 then
        for i = 3, 4 do
            if not GameData.item["i"..i].isUnLock then
                GameData.item["i"..i].number = GameData.item["i"..i].number + 3
                GameData.item["i"..i].isUnLock = true
            end
        end
    elseif LevelsData.getRealLevel(GameData.openlevel) >= 6 and LevelsData.getRealLevel(GameData.openlevel) < 8 then
        if not GameData.item["i"..4].isUnLock then
            GameData.item["i"..4].number = GameData.item["i"..4].number + 3
            GameData.item["i"..4].isUnLock = true
        end
    end
end
function PrepareLayer:showItemList()
	local subX
	if VERSION_MONSTER then	
		subX = 215
	else
		subX = 200
	end	
    self.itemBg = display.newSprite("#pre_taskBg.png",display.cx - subX,display.cy - 30)
	self:addChild(self.itemBg)
    self.itemBg:setVisible(false)
    local itemX
    if VERSION_MONSTER then
        itemX = self.taskBg:getContentSize().width/2 + 5
    else
        itemX = self.taskBg:getContentSize().width/2
        local itemBarBg = display.newScale9Sprite("#pre_itemBarBg.png",215,243,cc.size(378,402))
        self.itemBg:addChild(itemBarBg)
    end
    local itemLabel = display.newSprite("#pre_itemLabel.png",itemX,500)
    self.itemBg:addChild(itemLabel)
	
	--滑动箭头指示
    if VERSION_MONSTER then
        self.itemRight = display.newSprite("#pre_itemRight.png",414,415)
        self.itemBg:addChild(self.itemRight)
    else
        self.itemUp = display.newSprite("#pre_itemUp.png",self.itemBg:getContentSize().width/2,455)
        self.itemBg:addChild(self.itemUp)
        self.itemUp:setVisible(false)
        self.itemDown = display.newSprite("#pre_itemDown.png",self.itemBg:getContentSize().width/2,30)
        self.itemBg:addChild(self.itemDown)
        self.itemDown:setVisible(false)
    end
    --
	self.contentLayer = display.newLayer()
    self.contentLayer:setContentSize(cc.size(self.itemBg:getContentSize().width*9/10, 400))
    self.singleItemBg = {}
    self.itemIcon = {}
    self.titleNum = {}
    self.button = {}
    local itemNumBg = {}
    local buttonText = ""
    for i = 1, 4 do
        self.singleItemBg[i] = display.newSprite("#pre_itemSingleBg.png")
        self.singleItemBg[i]:setAnchorPoint(0,0)
		local pX
		local buttonX
		if VERSION_MONSTER then	
			pX = 26
			buttonX = 145
		else
			pX = 15
			buttonX = 125
		end
		local itemBgY
		if VERSION_MONSTER then	
			itemBgY = 393-99*i
		else
			itemBgY = 390-99*i
		end
        self.singleItemBg[i]:setPosition(pX,itemBgY)
        self.contentLayer:addChild(self.singleItemBg[i],2) 
    	self.itemIcon[i] = display.newSprite("#"..ItemData[i].pic,53,53)
		if not VERSION_MONSTER then
			if i == 1 then
				self.itemIcon[i]:setPosition(53,57)
			end
		end
        self.singleItemBg[i]:addChild(self.itemIcon[i])
    	if GameData.item["i"..i].number == 0 then
    		buttonText = "#pre_itemPurchase.png"
    	else
    		buttonText = "#pre_itemUse.png"
    	end
        local price = ItemData[i].money
        if GameData.selectHero == 2 then --第二英雄被动技能，道具便宜一半
            price = price * 0.5
        end
    	self.button[i] = cc.ui.UIPushButton.new({
                normal = buttonText,
                pressed = buttonText,
                disabled = buttonText,
            })
	        :onButtonClicked(function()
	            if GameData.item["i"..i].number == 0 then                  
                    if i == 5 then
                        if GameData.diamond >= price then
                            GameData.diamond = GameData.diamond - price
                            g_infoLayer.diamondLabel:setString(""..GameData.diamond)
                            self.button[i]:setButtonImage("normal", "#pre_itemUse.png")
                            self.button[i]:setButtonImage("disabled", "#pre_itemUse.png")
                            self.button[i]:setButtonImage("pressed", "#pre_itemUse.png")
                            GameData.item["i"..i].number = GameData.item["i"..i].number + 1
                            self.titleNum[i]:setString(""..GameData.item["i"..i].number)
                            itemNumBg[i]:setVisible(true)
                            AchievementData.checkItem()
                            AchievementData.checkDiamond(price)
                        else
                            if VERSION_REDUCE then
                                g_infoLayer:popLayer("钻石")
                            else
                                --厦门修改
                                 g_infoLayer:popLayer("钻石")
                                -- if kkFunc.simplifyPurchaseSwitch() then
                                --     kkFunc.simplifyPurchaseSdkCallBack(5)
                                -- else
                                --     g_infoLayer:popLayer("钻石")
                                -- end
                                --厦门修改
                            end
                        end
                    else
    					if GameData.carrot >= price then               
    						GameData.carrot = GameData.carrot - price
                            g_infoLayer.carrotLabel:setString(""..GameData.carrot)
                            self.button[i]:setButtonImage("normal", "#pre_itemUse.png")
                            self.button[i]:setButtonImage("disabled", "#pre_itemUse.png")
                            self.button[i]:setButtonImage("pressed", "#pre_itemUse.png")
                            GameData.item["i"..i].number = GameData.item["i"..i].number + 1
                            self.titleNum[i]:setString(""..GameData.item["i"..i].number)
                            itemNumBg[i]:setVisible(true)    
                            AchievementData.checkItem()
                            AchievementData.checkUseMoney(price)
                            --DataEye
                            local itemId
                            if i == 1 then
                                itemId = "圣水"
                            elseif i == 2 then
                                itemId = "守护石"
                            elseif i == 3 then
                                itemId = "复活石"
                            elseif i == 4 then
                                itemId = "时间沙漏"
                            end
                                --厦门
                            -- if device.platform == "android" or device.platform == "ios" then
                            --     DCItem.buy(itemId, "消耗品", 1, price, "金币")
                            --     --虚拟比统计
                            --     DCCoin.lost("购买道具", "金币", price, GameData.carrot)
                            -- end
                                --厦门
                        else
                            if VERSION_REDUCE then
                               g_infoLayer:popLayer("金币")
                            else
                                --厦门修改
                                 g_infoLayer:popLayer("金币")
                                -- if kkFunc.simplifyPurchaseSwitch() then
                                --     kkFunc.simplifyPurchaseSdkCallBackCoin(7)
                                -- else
                                --     g_infoLayer:popLayer("金币")
                                -- end
                                --厦门修改
                            end
    					end
                    end
				else
					GameData.item["i"..i].number = GameData.item["i"..i].number - 1
                    if GameData.item["i"..i].number == 0 then
                        self.button[i]:setButtonImage("normal", "#pre_itemPurchase.png")
                            self.button[i]:setButtonImage("disabled", "#pre_itemPurchase.png")
                            self.button[i]:setButtonImage("pressed", "#pre_itemPurchase.png")
                        itemNumBg[i]:setVisible(false)
                    else
                        self.titleNum[i]:setString(""..GameData.item["i"..i].number)
                    end
                    AchievementData.checkUseItem()
                    self:useItem(i)   
                    --DataEye
                    local itemId = kkFunc.getVersionPrepareText("道具",i)
                    --[[if i == 1 then
                        itemId = "圣水"
                    elseif i == 2 then
                        itemId = "守护石"
                    elseif i == 3 then
                        itemId = "复活石"
                    elseif i == 4 then
                        itemId = "时间沙漏"
                    end]]
                        --厦门
                    -- if device.platform == "android" or device.platform == "ios" then
                    --     DCItem.consume(itemId, "消耗品", 1, "更快通关")
                    -- end   
                        --厦门              
				end
                GameState.save(GameData)             
	        end)
	        :pos(self.itemBg:getContentSize().width - buttonX,52.5)
	        :addTo(self.singleItemBg[i]) 
		local iconX 
		if VERSION_MONSTER then	
        	self.button[i]:setScale(0.9)
			iconX = self.itemBg:getContentSize().width/4+25
		else
			iconX = self.itemBg:getContentSize().width/4-1
		end  
        local moneyIcon = display.newSprite("#"..ItemData[i].moneyPic,iconX,71)
        if i ~= 5 then
            moneyIcon:setScale(0.4)
        end
        self.singleItemBg[i]:addChild(moneyIcon)
		local mX,mY
		local numX
		local fontType
		local fontColor
		local mesX,mesY
		if VERSION_MONSTER then	
			mX = 44
			mY = 71
			numX = 60
			fontType = "fontCommon.TTF"
			fontColor = cc.c3b(255,201,65)
			mesX = self.itemBg:getContentSize().width/4+15
			mesY = 55
		else
			mX = 12
			mY = 72
			numX = 55
			fontType = "fontCommon.TTF"
			fontColor = cc.c3b(108,83,42)
			mesX = self.itemBg:getContentSize().width/4-20
			mesY = 60
		end	
        if VERSION_REDUCE then
            mX = 12
            mY = 72
            numX = 55
            fontType = "fontEasy.ttf"
            fontColor = cc.c3b(108,83,42)
            mesX = self.itemBg:getContentSize().width/4-20
            mesY = 60
        end
        local needMoney = cc.ui.UILabel.new({
            font = fontType,
            text = price,
            size = 18,
            textAlign = ui.TEXT_ALIGN_LEFT,
            color = cc.c3b(255,255,255),
            x = self.itemBg:getContentSize().width/4 +mX,
            y = mY,
            })
        self.singleItemBg[i]:addChild(needMoney)       
        --图标上背景和数量
        itemNumBg[i] = display.newSprite("#pre_itemNumBg.png",5,numX)
        self.itemIcon[i]:addChild(itemNumBg[i])
        self.titleNum[i] = cc.ui.UILabel.new({
            text = GameData.item["i"..i].number,
            size = 20,
            color = cc.c3b(255,255,255),
            x = itemNumBg[i]:getContentSize().width/2,
            y = itemNumBg[i]:getContentSize().height/2,
            }):align(display.CENTER)
        itemNumBg[i]:addChild(self.titleNum[i])
        if GameData.item["i"..i].number == 0 then
            itemNumBg[i]:setVisible(false)
        end
        local itemMes
        if VERSION_REDUCE then
            itemMes = cc.ui.UILabel.new({
                UILabelType = 2,
                font = fontType,
                text = kkFunc.getVersionPrepareText("道具信息",i),
                size = 14,--旧18
                dimensions = cc.size(170, 60),
                color = fontColor,
                x = mesX,
                y = mesY--旧58
            }):align(display.LEFT_TOP)
        else
            itemMes = cc.ui.UILabel.new({
                UILabelType = 2,
                font = fontType,
                text = kkFunc.getVersionPrepareText("道具信息",i),
                size = 15,--旧18
                color = fontColor,
                x = mesX,
                y = mesY--旧58
            }):align(display.LEFT_TOP)
        end         
        self.singleItemBg[i]:addChild(itemMes)   
    end
    --
	self.scrollView = cc.ui.UIScrollView.new({})   
    self.scrollView:setColor(cc.c3b(230,143,233))
    self.scrollView:setTouchSwallowEnabled(true)
    local screenSize = cc.Director:getInstance():getWinSize()
    local function scrollView1DidScroll(event)
       --local cp = self.scrollView:getContentOffset()
        if event.name == "moved" then
            --self.preChoose = nil
        end
    end
    local function scrollView1DidZoom()
        --print("scrollView1DidZoom")
    end
    local csize = self.contentLayer:getContentSize()
    if nil ~= self.scrollView then
        local scrollSize = self.contentLayer:getBoundingBox()
		local width
		if VERSION_MONSTER then	
			width = self.itemBg:getContentSize().width-67
		else
			width = self.itemBg:getContentSize().width
		end
        scrollSize.width = width
        scrollSize.height = 391
        self.scrollView:setViewRect(scrollSize)
        self.scrollView:setPosition(cc.p(14,47))
        self.scrollView:setScale(1.0)
        --self.scrollView:setAnchorPoint(cc.p(0.5,0.5))
        --self.scrollView:ignoreAnchorPointForPosition(false)
        self.scrollView:addScrollNode(self.contentLayer)
        self.scrollView:setDirection(1)
        --self.scrollView:scrollTo(cc.p(0,csize.height - scrollSize.height))
        self.scrollView:setBounceable(true)
        self.scrollView:onScroll(scrollView1DidScroll)
    end
    self.itemBg:addChild(self.scrollView,1)
    --self.itemBg:addChild(self.contentLayer,1)
end	

function PrepareLayer:getLevelName(level)
    if level <= 10 then
        return "L1_"..level..".png"
    elseif level <= 20 then
        return "L2_"..(level-10)..".png"
    elseif level <= 30 then
        return "L3_"..(level-20)..".png"
    elseif level <= 40 then
        return "L4_"..(level-30)..".png"
    end
end

function PrepareLayer:showMapPreview()
    self.mapBg = display.newSprite("#pre_previewBg.png")
    local size = self.mapBg:getContentSize()
	local subX,lightY,numSub
	local starPic
	if VERSION_MONSTER then	
		subX = 835
	elseif not VERSION_REDUCE then
        -- subX = 830
        subX = -830
        lightY = 90
        numSub = 30
        self.star = {}
        starPic = {
        [1] = "#pre_starLeft.png",
        [2] = "#pre_starMid.png",
        [3] = "#pre_starRight.png",
    }
    else
		subX = 830
        lightY = 0
        numSub = 0
		self.star = {}
    	starPic = {
        [1] = "#pre_starLeft.png",
        [2] = "#pre_starMid.png",
        [3] = "#pre_starRight.png",
    }
	end	
    self.mapBg:setPosition(display.cx + subX, display.cy-numSub)
    --self.mapBg = cc.LayerColor:create(cc.c4b(211,211,211,255),400, 420)
    --self.mapBg:setAnchorPoint(cc.p(0,0.5))
    --self.mapBg:setPosition(display.cx + 20, display.cy - size.height*0.5)
    self:addChild(self.mapBg)
    --self.starbg = cc.LayerColor:create(cc.c4b(200,0,0,255),self.mapBg:getContentSize().width - 40,80)
    --self.starbg:setPosition(cc.p(20,self.mapBg:getContentSize().height - 100))
    --self.mapBg:addChild(self.starbg)
    if GameData.levelTask[""..self.level].star ~= 0 then
        if VERSION_MONSTER then
        	local pre_star = display.newSprite("#pre_star"..GameData.levelTask[""..self.level].star..".png")
            pre_star:setPosition(cc.p(self.mapBg:getContentSize().width/2-2,404))
            self.mapBg:addChild(pre_star)
        else
        	for i = 1, GameData.levelTask[""..self.level].star do
                self.star[i] = display.newSprite(starPic[i])
                --self.star[i]:setScale(0.7)
                if i == 1 then
                    self.star[i]:setPosition(self.mapBg:getContentSize().width/2+3+(i-2)*86,-math.abs(i-2)*14.5+421+lightY)
                elseif i == 3 then
                    self.star[i]:setPosition(self.mapBg:getContentSize().width/2-9+(i-2)*86,-math.abs(i-2)*12.5+419+lightY)
                else
                    self.star[i]:setPosition(self.mapBg:getContentSize().width/2-6+(i-2)*86,-math.abs(i-2)*12+419+lightY)
                end    
                self.mapBg:addChild(self.star[i])
            end
        end	        
    end
	local starY
    local fontType
	if VERSION_MONSTER then	
		starY = 349
        fontType = "fontCommon.TTF"
	elseif not VERSION_REDUCE then
		starY = 420
        fontType = "fontCommon.TTF"
    else
        starY = 332
        fontType = "fontEasy.ttf"
	end
    self.starMes = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = kkFunc.getVersionPrepareText("关卡数",LevelsData.getRealLevel(self.level)),
            size = 22,
            textAlign = ui.TEXT_ALIGN_LEFT,
            color = cc.c3b(255,255,255),
            x = self.mapBg:getContentSize().width/2-2,
            y = starY,
            })
    self.starMes:setAnchorPoint(cc.p(0.5,0.5))
    self.mapBg:addChild(self.starMes)

    --
    --[[self.energynode = display.newNode()
    self.mapBg:addChild(self.energynode)
    self.energyLabel = cc.ui.UILabel.new({
            text = "体力消耗：",
            size = 24,
            textAlign = ui.TEXT_ALIGN_LEFT,
            color = cc.c3b(0,0,0),
            x = 20,
            y = self.mapBg:getContentSize().height - 130,
            })
    self.energynode:addChild(self.energyLabel)
    self.heart = display.newSprite("#bloodNew.png",140,self.mapBg:getContentSize().height - 130)
    self.heart:setScale(0.5)
    self.energynode:addChild(self.heart)
    self.energyLabel = cc.ui.UILabel.new({
            text = "6",
            size = 24,
            textAlign = ui.TEXT_ALIGN_LEFT,
            color = cc.c3b(0,0,0),
            x = 170,
            y = self.mapBg:getContentSize().height - 130,
            })
    self.energynode:addChild(self.energyLabel)]]
    
    --地图预览
	local mapY
	if VERSION_MONSTER then
		mapY = 227
	elseif not VERSION_REDUCE then
        mapY = 297
    else
		mapY = 212
	end
    if not VERSION_REDUCE then
        self.tipLable = cc.ui.UILabel.new({
            UILabelType = 2,
            text = LevelsData[self.level].tips,
            size = 17,
            font  = "fontCommon.TTF",
            dimensions = cc.size(365, 150),
            color = cc.c3b(255,255,255),
            x = 40,
            y = 110,
            })
    end
    local levelName = self:getLevelName(LevelsData.getRealLevel(self.level))
    self.previewPic = "res/map/LevelTheme/levelPreview/"..levelName
    --cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RG_B565)
    self.mapPreview = display.newSprite(self.previewPic)
    --cc.Texture2D:setDefaultAlphaPixelFormat(cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
    self.mapPreview:setPosition(self.mapBg:getContentSize().width*0.5,mapY)
    self.mapBg:addChild(self.mapPreview)
    if not VERSION_REDUCE then
        self.mapBg:addChild(self.tipLable)
    end
    if not VERSION_REDUCE then
        if GameData.levelTask[""..self.level].star >= 3  then
            self.complatePic = display.newSprite("#allStars.png")
            self.complatePic:setPosition(self.mapBg:getContentSize().width*0.5+120,450)
            self.mapBg:addChild(self.complatePic)
        end
    end
	if VERSION_MONSTER then
		self.mapPreview:setScale(0.9)
	end  
    --[[
    local themeNum = LevelsData[self.level].theme
    local theme = "map/Theme"..themeNum.."/theme"..themeNum.."Map.png"
    self.map = display.newSprite(theme)
    --self.map:setTextureRect(cc.rect(self.map:getContentSize().width*4/9 - 100,40,self.map:getContentSize().width*5/9 + 100,self.map:getContentSize().height-40))
    self.map:setScale(0.3)
    self.map:setPosition(200,170)
    self.mapBg:addChild(self.map)
    self.mapRoad = cc.TMXTiledMap:create(LevelsData[self.level].map)
    self.mapRoad:setAnchorPoint(cc.p(0.5,0.5))
    self.mapRoad:setPosition(cc.p(display.cx + 50,display.cy + 20))
    self.map:addChild(self.mapRoad)
    --]]
    --Tower
    self.mode = self:getGameMode()
    local num = #LevelsData[self.level].selectedTowers
    if self.mode == "randomTowerMode" then
        num = 1
    end
    local halfnum = nil
    if num%2 == 0 then
        halfnum = num/2
    else
        halfnum = math.ceil(num/2)
    end
    for i = 1, num do
        local pic = "#T_select_"..LevelsData[self.level].selectedTowers[i]..".png"
        if self.mode == "randomTowerMode" then
            pic = "#lock.png"
        end
        local towerPic = display.newSprite(pic)
		local tY
		if VERSION_MONSTER then
			tY = 57
		else
			tY = 75
			towerPic:setScale(0.5)
		end
        if self.mode == "randomTowerMode" then
            towerPic:setScale(0.8)
        end
        towerPic:setPosition(self.mapBg:getContentSize().width/2 + (i-halfnum)*50+(num%2-1)*25, tY)
        self.mapBg:addChild(towerPic)
    end
end
 --游戏模式判定
function PrepareLayer:getGameMode()
    local mode,level
    level = self.level
    if level == 710 then
        mode = "oneWaveMode"
    elseif level == 109 or level == 204  or level == 303 or level == 403 then
        mode = "randomTowerMode"
    elseif level == 107  or level == 208 or level == 306 or level == 408 then
        mode = "attackCityMode"
    elseif level == 702 then 
        mode = "bossMode"
    else
        mode = nil
    end 
    return mode  
end

function PrepareLayer:useItem(itemIdx)   
    if itemIdx == 6 then
        local idx = math.random(1,5)
        self.items[idx] = true
    else
        self.items[itemIdx] = true
    end
end

function PrepareLayer:onTouch(event, x, y)
    if event == "began" then
        self.beginY = y
        return true
    elseif event == "moved" then
        if VERSION_MONSTER then
            local rect = self.itemRight:getCascadeBoundingBox()
            if cc.rectContainsPoint(rect, cc.p(x,y)) then
                local subY = self.beginY - y
                self.itemRight:setPositionY(self.itemRight:getPositionY()-subY)
                --self.contentLayer:setPositionY(-self.itemRight:getPositionY()/1.8)
                if self.itemRight:getPositionY() <= (415-190*1.8) then
                    self.itemRight:setPositionY(415-190*1.8)
                elseif self.itemRight:getPositionY() >= 410 then
                    self.itemRight:setPositionY(410)
                end
            end
            if self.contentLayer:getPositionY() >= 5 and self.contentLayer:getPositionY() < 190 then
                self.itemRight:setPositionY(415-self.contentLayer:getPositionY()*1.8)
            elseif self.contentLayer:getPositionY() < 5 then
                self.itemRight:setPositionY(410)
            elseif self.contentLayer:getPositionY() >= 190 then 
                self.itemRight:setPositionY(415-190*1.8)     
            end
            self.beginY = y
        else
            --[[if self.contentLayer:getPositionY() >= 5 and self.contentLayer:getPositionY() < 190 then
                self.itemUp:setVisible(true)
                self.itemDown:setVisible(true)
            elseif self.contentLayer:getPositionY() < 5 then
                self.itemUp:setVisible(false)
            elseif self.contentLayer:getPositionY() >= 190 then 
                self.itemDown:setVisible(false)      
            end]]
        end
    elseif event == "ended" then        
    end
end

function PrepareLayer:onExit()
    display.removeSpriteFrameByImageName(self.previewPic)
end

return PrepareLayer