--
-- Author: KK
-- Date: 2014-09-09 13:16:38
--
--兔子家里的兔子列表

local RabbitList = class("RabbitList", function()
    return display.newLayer()
end)

function RabbitList:ctor(selectCallback)
	--选中回调
	self.selectCallback = selectCallback
    self.bg = cc.LayerColor:create(cc.c4b(100, 100, 200, 255),300,440)
	self.bg:ignoreAnchorPointForPosition(false)
	self.bg:setAnchorPoint(cc.p(0.5,0.5))
	self:addChild(self.bg)
    self.rect = self.bg:getCascadeBoundingBox()

	--向上向下箭头
	self.upArrow = cc.ui.UILabel.new({
		text = "向上",
		size = 20,
		align = ui.TEXT_ALIGN_CENTER,
		x = 0,
		y = 210,
	})
	self:addChild(self.upArrow)
	self.upArrow:setVisible(false)
	self.downArrow = cc.ui.UILabel.new({
		text = "向下",
		size = 20,
		align = ui.TEXT_ALIGN_CENTER,
		x = 0,
		y = -210,
	})
	self:addChild(self.downArrow)



	self.towerList = self:getTowerList()
    
	
	self:getContent()

	self:getScrollView(self.contentLayer)

	--选中的兔子
	self.selectRabbitIdx = nil
end

function RabbitList:init()
    self.scrollView:setContentOffset(cc.p(0,400 - self.contentLayer:getContentSize().height))
    if self.selectRabbitIdx ~= nil then
        self.towers[self.selectRabbitIdx]:setScale(1)
    end
    self.selectRabbitIdx = nil
    self.preChoose = nil
end

function RabbitList:getTowerList()
    local tmp = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,23}

    local towerList = {}
    local towerUpgrading = {}
    local towerComplete = {}
    local towerNoOpen = {}
    for i = 1, #tmp do
        local idx = tmp[i]
        if GameData.myRabbit["r"..idx].open == false then
            towerNoOpen[#towerNoOpen+1] = idx
        elseif GameData.myRabbit["r"..idx].level == 3 then
            towerComplete[#towerComplete+1] = idx
        elseif GameData.myRabbit["r"..idx].upgrading == true then
            towerUpgrading[#towerUpgrading+1] = idx
        else
            towerList[#towerList+1] = idx
        end
    end

    for i = 1, #towerList do
        towerUpgrading[#towerUpgrading+1] = towerList[i]
    end

    for i = 1, #towerComplete do
        towerUpgrading[#towerUpgrading+1] = towerComplete[i]
    end

    for i = 1, #towerNoOpen do
        towerUpgrading[#towerUpgrading+1] = towerNoOpen[i]
    end

    return towerUpgrading
end

function RabbitList:getContent()
	--self.contentLayer = display.newColorLayer(cc.c4b(100, 100, 200, 255))
	self.contentLayer = display.newLayer()
	self.contentLayer:ignoreAnchorPointForPosition(false)
	self.contentLayer:setAnchorPoint(cc.p(0.5,0.5))
	self.contentLayer:setContentSize(cc.size(300, 700))

    local picSize = 100
    local startX,startY = 50, 650
    local rowSize = 3
    local rowNum = math.ceil(#self.towerList / rowSize)

	self.towers = {}
    for row = 1, rowNum do
    	for col = 1, rowSize do
    		local idx = (row-1)*rowSize+col
    		if idx > #self.towerList then break end
            local x = startX + picSize*(col-1)
            local y = startY - picSize*(row-1)
            if GameData.myRabbit["r"..self.towerList[idx]].open == false then
                self.towers[idx] = display.newFilteredSprite("#"..TowersData[self.towerList[idx]].pic, "GRAY", {0.2, 0.3, 0.5, 0.1})
                self.towers[idx]:setPosition(cc.p(x,y))
                self.towers[idx].state = "notOpen"
                local label = cc.ui.UILabel.new({
                    text = "未得到",
                    size = 20,
                    color = display.COLOR_WHITE,
                    x = 30,
                    y = 30,
                })
                self.towers[idx]:addChild(label)
            elseif GameData.myRabbit["r"..self.towerList[idx]].upgrading then
                self.towers[idx] = display.newFilteredSprite("#"..TowersData[self.towerList[idx]].pic, "GRAY", {0.2, 0.3, 0.5, 0.1})
                self.towers[idx]:setPosition(cc.p(x,y))
                self.towers[idx].state = "upgrading"
                local label = cc.ui.UILabel.new({
                    text = "升级中",
                    size = 20,
                    color = display.COLOR_WHITE,
                    x = 30,
                    y = 30,
                })
                self.towers[idx]:addChild(label)
            elseif GameData.myRabbit["r"..self.towerList[idx]].level == 3 then
                self.towers[idx] = display.newFilteredSprite("#"..TowersData[self.towerList[idx]].pic, "GRAY", {0.2, 0.3, 0.5, 0.1})
                self.towers[idx]:setPosition(cc.p(x,y))
                self.towers[idx].state = "maxLevel"
                local label = cc.ui.UILabel.new({
                    text = "顶级",
                    size = 20,
                    color = display.COLOR_WHITE,
                    x = 30,
                    y = 30,
                })
                self.towers[idx]:addChild(label)
            else
                self.towers[idx] = display.newSprite("#"..TowersData[self.towerList[idx]].pic,x,y)
                self.towers[idx].state = "normal"
            end
            self.towers[idx].towerIdx = self.towerList[idx]
            if DEBUG_INFO then
                local idLabel = cc.ui.UILabel.new({
                    text = "T"..self.towerList[idx],
                    size = 15,
                    color = display.COLOR_BLACK,
                    x = 0,
                    y = 0,
                })
                self.towers[idx]:addChild(idLabel)
                local idLabel2 = cc.ui.UILabel.new({
                    text = "L"..GameData.myRabbit["r"..self.towerList[idx]].level,
                    size = 15,
                    color = display.COLOR_BLACK,
                    x = 70,
                    y = 70,
                })
                self.towers[idx]:addChild(idLabel2)
            end
            self.contentLayer:addChild(self.towers[idx],2)
    	end
    end
end

function RabbitList:getScrollView(contentLayer)
    self.scrollView = cc.ui.UIScrollView.new({})
    self.scrollView:setTouchSwallowEnabled(false)
    self.scrollView:setColor(cc.c3b(230,143,233))

    local screenSize = cc.Director:getInstance():getWinSize()
    local function scrollView1DidScroll(event)
    	if event.name == "moved" then
            self.preChoose = nil
        end
    	local px, py = self.scrollView:getScrollNode():getPosition()
        --print("scrollView1DidScroll,",cp.x,cp.y)
        if py > -300 then
        	self.upArrow:setVisible(true)
	        if py >= 0 then
	        	self.downArrow:setVisible(false)
	        end
	    end
        if py < 0 then
        	self.downArrow:setVisible(true)
	        if py <= -300 then
	        	self.upArrow:setVisible(false)
	        end
        end
    end
    local function scrollView1DidZoom()
        --print("scrollView1DidZoom")
    end
    local csize = self.contentLayer:getContentSize()
    if nil ~= self.scrollView then
        local scrollSize = contentLayer:getBoundingBox()
        scrollSize.width = 300
        scrollSize.height = 400
        self.scrollView:setViewRect(scrollSize)
        self.scrollView:setPosition(cc.p(0,140))
        self.scrollView:setScale(1.0)
        self.scrollView:setAnchorPoint(cc.p(0.5,0.5))
        self.scrollView:ignoreAnchorPointForPosition(false)
        self.scrollView:addScrollNode(contentLayer)
        self.scrollView:scrollTo(cc.p(0,scrollSize.height - csize.height))
        --self.scrollView:updateInset()
        self.scrollView:setDirection(1)
        --self.scrollView:setDirection(kCCScrollViewDirectionVertical)
        self.scrollView:setBounceable(true)
        self.scrollView:onScroll(scrollView1DidScroll)
    end
    self:addChild(self.scrollView,2)
end

function RabbitList:onTouch(event, x, y)
	--print(event, x, y)
    if event == "began" then
        self.preChoose = nil
    	for i = 1, #self.towers do
            if self.towers[i].state == "normal" then
                local rect = self.towers[i]:getCascadeBoundingBox()
                --print(rect.origin.x,rect:getMaxX(),rect.origin.y,rect:getMaxY())
        		if cc.rectContainsPoint(rect, cc.p(x,y)) then
                    if NEW_GUIDE and GameData.guide.step < 48 then
                        if GameData.guide.step >= 37 then
                        else
                            g_guidelayer:ShowRabbitHouse(25)
                        end
                    end  
        			self.preChoose = i
        			break
        		end
            end
    	end
    	return true
    elseif event == "moved" then
    elseif event == "ended" then
    	if self.preChoose ~= nil then
            local towerIdx = self.towers[self.preChoose].towerIdx
            if GameData.myRabbit["r"..towerIdx].level == 3 
                    or GameData.myRabbit["r"..towerIdx].upgrading == true then
                return
            end
    		self:selectRabbit(self.preChoose)
    	end
	end
end

function RabbitList:selectRabbit(idx)
	if self.selectRabbitIdx ~= idx then
		if self.selectRabbitIdx ~= nil then
			self.towers[self.selectRabbitIdx]:setScale(1)
		end
	end
	self.towers[idx]:setScale(1.2)
	self.selectRabbitIdx = idx
	self.selectCallback(self.towers[idx].towerIdx)
end

return RabbitList