--
-- Author: KK
-- Date: 2014-09-16 16:00:02
--
--兔子家里的窝，单独放出来。


--单个兔子窝类
local RabbitNest = class("RabbitNest", function(params)
    return display.newLayer()
end)

function RabbitNest:ctor(params)
    --[[
    self = {
        self = node,
        label,
        timeLabel,
        rabbitIdx,
        rabbit,
        content,
        finishLabel
        menu,
        state,
    }
    params = {
        state = "upgrade",
        rabbitIdx = 12,
        timeSystem = 14124124,
        timeSec = 1234
    }
    --]]
    self.parent = params.parent
    self.idx = params.idx
    self.params = GameData.rabbitHouse["n"..self.idx]
    self.state = self.params.state
    self.rabbitIdx = self.params.rabbitIdx
    self.time = nil --选兔子时出现
    --标题
    self.label = cc.ui.UILabel.new({
        text = self.idx.."号窝",
        size = 40,
        --align = ui.TEXT_ALIGN_CENTER,
        x = -50,
        y = 300,
    })
    self:addChild(self.label)

    self:showNestContent()

    --对应按钮
    --self:showMenu()
end

function RabbitNest:showNestContent()
    if self.contentNode ~= nil then 
        self.contentNode:removeFromParent()
    end
    self.contentNode = display.newNode()
    self:addChild(self.contentNode)
    if self.state == "free" then
        self:showFree()
    elseif self.state == "lock" then
        self:showLock()
    elseif self.state == "selectRabbit" then
        self:showSelectRabbit()
    elseif self.state == "startUpgrade" then
        self:showStartUpgrade()
    elseif self.state == "upgrade" then
        self:showUpgrade()
    elseif self.state == "finish" then
        self:showFinish()
    elseif self.state == "timeInvalid" then
        self:showTimeInvalid()
    end
end

function RabbitNest:showFree()
    --内容
    self.content = cc.ui.UILabel.new({
        text = "空闲",
        size = 60,
        x = 0,
        y = 100,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self.contentNode:addChild(self.content)

    --选择
    self.menu = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "选择",
            color = display.COLOR_GREEN,
            align = ui.TEXT_ALIGN_CENTER,
            size = 40,
        }))
        :onButtonClicked(function()
            if NEW_GUIDE and GameData.guide.step < 48 then
                if GameData.guide.step >= 37 then
                else
                    g_guidelayer:ShowRabbitHouse(24)
                end
            end           
            self.parent:selectRabbitForNest(self.idx)        
        end)
        :pos(0, 20)
        :addTo(self.contentNode)  
end

function RabbitNest:showLock()
    --内容
    self.content = cc.ui.UILabel.new({
        text = "未开启",
        size = 60,
        x = 0,
        y = 100,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self.contentNode:addChild(self.content)

    --解锁按钮
    self.menu = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "解锁",
            size = 40,
            color = display.COLOR_GREEN,
        }))
        :onButtonClicked(function()
            self:unlockNest()        
        end)
        :align(ui.TEXT_ALIGN_CENTER)
        :pos(0, 20)
        :addTo(self.contentNode)
    if GameData.rabbitHouse["n"..self.idx-1].state == "lock" then
        self.menu:setButtonEnabled(false)
        self.menu:setColor(cc.c3b(0, 0, 0))
    end
end

function RabbitNest:showSelectRabbit()
    local level = GameData.myRabbit["r"..self.rabbitIdx].level
    self.time = ExcelUpgradeData[self.rabbitIdx][level].time
    local timeStr
    if self.time >= 60 then
        timeStr = (self.time/60).."小时"
    else
        timeStr = self.time.."分钟"
    end
    --几等级。
    self.levelLabel = cc.ui.UILabel.new({
        text = (level+1).."级",
        size = 15,
        x = 0,
        y = 200,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self.contentNode:addChild(self.levelLabel)

    --形象
    self.rabbit = display.newSprite("#"..TowersData[self.rabbitIdx].pic,0,150)
    self.contentNode:addChild(self.rabbit,1)
    --时间
    self.timeLabel = cc.ui.UILabel.new({
        text = timeStr,
        size = 20,
        x = 0,
        y = 250,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self.contentNode:addChild(self.timeLabel)

    --需要萝卜数量
    self.needCarrot = ExcelUpgradeData[self.rabbitIdx][level].carrot
    self.carratLabel = cc.ui.UILabel.new({
        text = "需要"..self.needCarrot.."萝卜",
        size = 15,
        x = 0,
        y = 80,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self.contentNode:addChild(self.carratLabel)


    --开始按钮
    self.menu = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "开始",
            size = 40,
            color = display.COLOR_GREEN,
        }))
        :onButtonClicked(function()
            if NEW_GUIDE and GameData.guide.step < 48 then
                if GameData.guide.step >= 37 then
                else
                    if g_guidelayer.step >= 31 then
                        g_guidelayer:ShowRabbitHouse(27)
                    else
                        g_guidelayer:GetMessage(26)
                    end
                end
            end   
            self:startUpgrade()       
        end)
        :align(ui.TEXT_ALIGN_CENTER)
        :pos(0, 20)
        :addTo(self.contentNode)

end

function RabbitNest:showStartUpgrade()
    self.timeSec = self.time*60
    self:saveNest()

    self:showUpgradeInfo()
end

function RabbitNest:showUpgrade()
    local deltaTime = kkFunc.getSystime() - self.params.timeSystem
    self.timeSec = self.params.timeSec - deltaTime

    if self.timeSec <= 0 then
        return self:finishUpgrade()
    end
    self:showUpgradeInfo()
end

function RabbitNest:showUpgradeInfo()
    local timeStr = kkFunc.getTimeLabelFromSecond(self.timeSec)
    --时间
    self.timeLabel = cc.ui.UILabel.new({
        text = timeStr,
        size = 20,
        align = ui.TEXT_ALIGN_CENTER,
        x = 0,
        y = 250,
    })

    self.contentNode:addChild(self.timeLabel)
    --形象
    self.rabbit = display.newSprite("#"..TowersData[self.rabbitIdx].pic,0,150)
    self.contentNode:addChild(self.rabbit)

    if self.timeSec <= 0 then
        return self:finishUpgrade()
    end

    local level = GameData.myRabbit["r"..self.rabbitIdx].level
    local alldiamond = ExcelUpgradeData[self.rabbitIdx][level].diamond
    local alltime = ExcelUpgradeData[self.rabbitIdx][level].time * 60
    self.needDiamond = math.floor(alldiamond * self.timeSec / alltime)
    --立即完成按钮
    self.menu2 = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "加速("..self.needDiamond.."钻石)",
            size = 40,
            color = display.COLOR_GREEN,
        }))
        :onButtonClicked(function()
            if NEW_GUIDE and GameData.guide.step < 48 then
                if GameData.guide.step >= 37 then
                else
                    g_guidelayer:ShowRabbitHouse(28)
                end
            end  
            self:quickFinish()      
        end)
        :align(ui.TEXT_ALIGN_CENTER)
        :pos(0, 40)
        :addTo(self.contentNode)
    --取消按钮
    self.menu = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "取消",
            size = 40,
            color = display.COLOR_GREEN,
        }))
        :onButtonClicked(function()
            self:cancelUpgrade()      
        end)
        :align(ui.TEXT_ALIGN_CENTER)
        :pos(0, 0)
        :addTo(self.contentNode)

    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt) 
        self:updateTimer(dt)
    end)
    self:scheduleUpdate()
end

function RabbitNest:showFinish()
    self.finishLabel = cc.ui.UILabel.new({
        text = "完成！",
        size = 20,
        x = 0,
        y = 250,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self.contentNode:addChild(self.finishLabel)
    --形象
    self.rabbit = display.newSprite("#"..TowersData[self.rabbitIdx].pic,0,150)
    self.contentNode:addChild(self.rabbit)
    --收获按钮
    self.menu = cc.ui.UIPushButton.new({})
        :setButtonLabel("normal", cc.ui.UILabel.new({
            UILabelType = 2,
            text = "收获",
            size = 40,
            color = display.COLOR_GREEN,
        }))
        :onButtonClicked(function()
            if NEW_GUIDE and GameData.guide.step < 48 then
                if GameData.guide.step >= 37 then
                else    
                    g_guidelayer:FinishUpdate()
                end
            end  
            self:gainRabbit()      
        end)
        :align(ui.TEXT_ALIGN_CENTER)
        :pos(0, 20)
        :addTo(self.contentNode)
end

function RabbitNest:showTimeInvalid()
    self.checkTimeLabel = cc.ui.UILabel.new({
        text = "计时器错误",
        size = 20,
        x = 0,
        y = 250,
    })
    :align(ui.TEXT_ALIGN_CENTER)
    self.contentNode:addChild(self.checkTimeLabel)
    --形象
    self.rabbit = display.newSprite("#"..TowersData[self.rabbitIdx].pic,0,150)
    self.contentNode:addChild(self.rabbit)
end

------------------------------动作---------------------------------
function RabbitNest:unlockNest()
    self.state = "unlock"
    self:saveNest()
    self.state = "free"
    self:showNestContent()
    if self.idx < 5 then
        self:getParent().nests[self.idx+1]:showNestContent()
    end
end

function RabbitNest:selectRabbit(idx)
    self.rabbitIdx = idx
    self.state = "selectRabbit"
    self:showNestContent()
end

function RabbitNest:returnFromSelect()
    self.state = "free"
    self:showNestContent()
end

--开始升级
function RabbitNest:startUpgrade()
    self.state = "startUpgrade"
    self:showNestContent()
    self.parent:startUpgrade()
end

--更新时刷新计时器
function RabbitNest:updateTimer(dt)
    local timeNow = self.timeSec - dt
    if math.floor(timeNow) < math.floor(self.timeSec) then
        local timeStr = kkFunc.getTimeLabelFromSecond(math.floor(timeNow))
        self.timeLabel:setString(timeStr)
    end
    self.timeSec = timeNow
    if self.timeSec <= 0 then
        if NEW_GUIDE and GameData.guide.step < 48 then
            if GameData.guide.step >= 37 then
            else
                g_guidelayer:ShowRabbitHouse(28)
            end
        end
        self:unscheduleUpdate()
        self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
        self:finishUpgrade()
    end
end

--快速完成
function RabbitNest:quickFinish()
    self:unscheduleUpdate()
    self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
    self.state = "finish"
    self:showNestContent()
    --只有快速完成需要记录数据。
    self:saveNest()
end

function RabbitNest:cancelUpgrade()
    self:unscheduleUpdate()
    self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
    self.state = "cancel"
    self:saveNest()
    self.state = "free"
    self.rabbitIdx = nil
    self:showNestContent()
end

--完成升级
function RabbitNest:finishUpgrade()
    self.state = "finish"
    self:showNestContent()
end

--收获兔子
function RabbitNest:gainRabbit()
    self.state = "gain"
    self:saveNest()

    self.state = "free"
    self:showNestContent()
end

--计时器错误
function RabbitNest:setInvalid()
    if self.state == "free" then
        self.checkTimeLabel = cc.ui.UILabel.new({
            text = "计时器错误",
            size = 20,
            x = 0,
            y = 250,
        })
        :align(ui.TEXT_ALIGN_CENTER)
        self.contentNode:addChild(self.checkTimeLabel)
        self.menu:setColor(cc.c3b(50,50,50))
        return
    end
    if self.state ~= "upgrade" and self.state ~= "finish" then return end

    self:unscheduleUpdate()
    self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)

    self.state = "timeInvalid"
    self:showNestContent()
end

--计时器修正完成
function RabbitNest:setValid()
    if self.state == "free" then
        self.checkTimeLabel:removeFromParent()
        self.menu:setColor(cc.c3b(255,255,255))
        return
    end
    if self.state ~= "timeInvalid" then return end
    self.state = "upgrade"
    self:showNestContent()
end

function RabbitNest:saveNest()
    if self.state == "startUpgrade" then
        GameData.rabbitHouse["n"..self.idx] = {
            state = "upgrade",
            rabbitIdx = self.rabbitIdx,
            timeSec = self.timeSec,
            timeSystem = kkFunc.getSystime(),
        }
        GameData.myRabbit["r"..self.rabbitIdx].upgrading = true
    elseif self.state == "cancel" then
        GameData.rabbitHouse["n"..self.idx] = {state = "free"}
        GameData.myRabbit["r"..self.rabbitIdx].upgrading = false
    elseif self.state == "finish" then
        GameData.rabbitHouse["n"..self.idx] = {
            state = "finish",
            rabbitIdx = self.rabbitIdx,
        }
    elseif self.state == "gain" then
        GameData.rabbitHouse["n"..self.idx] = {state = "free"}
        GameData.myRabbit["r"..self.rabbitIdx].level = GameData.myRabbit["r"..self.rabbitIdx].level + 1
        GameData.myRabbit["r"..self.rabbitIdx].upgrading = false
    elseif self.state == "unlock" then
        GameData.rabbitHouse["n"..self.idx] = {state = "free"}
    end
    GameState.save(GameData)
end

return RabbitNest
