--
-- Author: Wangzhihao
-- Date: 2014-10-20 12:34:36
--
local GiftBagLayer = import("..views.GiftBagLayer")

local lightStarData2 = {
    [1] = {
        name = "#starLeft.png",
        beginX = 104,
        beginY = 332,
        x = 202,
        y = 274,
    },
    [2] = {
        name = "#starMid.png",
        beginX = 300,
        beginY = 414,
        x = 302,
        y = 284,
    },
    [3] = {
        name = "#starRight.png",
        beginX = 502,
        beginY = 322,
        x = 400,
        y = 272,
    },
    [4] = {
        name = "#allStars.png",
        beginX = 539,
        beginY = 417,
        x = 469,
        y = 352,
    },
}
local lightStarData = {
    [1] = {
        name = "#starLeft.png",
        beginX = 65,
        beginY = 285,
        x = 165,
        y = 235,
    },
    [2] = {
        name = "#starMid.png",
        beginX = 263,
        beginY = 377,
        x = 263,
        y = 247,
    },
    [3] = {
        name = "#starRight.png",
        beginX = 463,
        beginY = 285,
        x = 363,
        y = 235,
    },
    [4] = {
        name = "#allStars.png",
        beginX = 500,
        beginY = 400,
        x = 430,
        y = 335,
    },
}
local ResultLayer = class("ResultLayer",function() 
	return  display.newLayer("ResultLayer") 
end)
function ResultLayer:ctor(level,isWin)
    --音乐
    SoundManager.stopMusic(true)

    self:setNodeEventEnabled(true)
    ResData.loadRes("UI_RESULT")
    self.isWin = isWin
    self.touchLayer = display.newLayer()
    self:addChild(self.touchLayer,5)
    self.touchLayer:setTouchSwallowEnabled(false)
    self.level = level 
    --成就
    AchievementData.checkGameRound()
    --记录完成的任务个数
    if isWin == true then
    	self:Success()
        --音效
        SoundManager.playSound(GAME_SOUND.Win)
    else
        self:Failure()
        --音效
        SoundManager.playSound(GAME_SOUND.Lose)
    end
    GameState.save(GameData)
    --音效
    SoundManager.playSound(GAME_SOUND.CarrotCount)
end

function ResultLayer:addParticle()
    local emitter1 = cc.ParticleSystemQuad:create("particle/particlestar.plist")
    --emitter1:setStartColor(cc.c4f(1,0,0,1))
    emitter1:setBlendAdditive(true)
    emitter1:setPosition(cc.p(display.cx,display.cy+150))
    emitter1:setEmissionRate(20)
    self:addChild(emitter1)
end

function ResultLayer:dealWithSuccessData()
    --获得几星
    self.starNum = nil
    if g_playScene.heartNum >= 10 then
        self.starNum = 3
    elseif g_playScene.heartNum < 7 then
        self.starNum = 1
    else
        self.starNum = 2
    end
    if g_playScene.task and self.starNum > GameData.levelTask[""..self.level].star then
        AchievementData.checkStarNum(self.starNum - GameData.levelTask[""..self.level].star)
        GameData.levelTask[""..self.level].star = self.starNum
    end

    if self.level > 410 then 
        self.giftmoney = 0
        return 
    end --test
    if self.level ~= 410 then
        if self.level >= GameData.openlevel then
            globalVar.levelOpenNew = true
            GameData.openlevel = LevelsData.getNextLevel(self.level)
        end
    end
    -- if GameData.energy.value < 999 then
    --     GameData.energy.value = GameData.energy.value - 1
    --     if GameData.energy.startTime == 0 or GameData.energy.value == 4 then
    --         GameData.energy.startTime = kkFunc.getSystime()
    --     else           
    --     end
    -- end

    --过关的钱
    if self.level == 100 then
        self.level = 101
    end
    self.giftmoney = ExcelPassReward[LevelsData.getRealLevel(self.level)][4-self.starNum]   
    if GameData.selectHero == 3 then --第三英雄被动技能，钱多20%
        self.giftmoney = math.floor(self.giftmoney*1.2)
    elseif GameData.selectHero == 4 then --第四英雄其中一个被动技能，钱多10%
        self.giftmoney = math.floor(self.giftmoney*1.1)
    end
    --GameData.carrot = GameData.carrot + self.giftmoney--暂时放到后面执行
    AchievementData.checkGetMoney(self.giftmoney)

    AchievementData.checklevelAchievement(LevelsData.getRealLevel(self.level))
    --DataEye
         --厦门
    -- if device.platform == "android" or device.platform == "ios" then
    --     DCCoin.gainInLevel("关卡过关奖励", "金币", self.giftmoney, GameData.carrot, "第"..LevelsData.getRealLevel(self.level).."关")
    -- end
         --厦门
end

function ResultLayer:resultBgActions()
    local grayBg = display.newColorLayer(cc.c4b(0,0,0,180))
    self:addChild(grayBg)
    grayBg:setScale(1.1)
    local bgY,levelY,lightY,roundLightY,roleY,levelX
    if VERSION_REDUCE then
        bgY = -20
        levelY = 197
        levelX = 0
        roleY = 15
        lightY = 20
        roundLightY = 0
        fontType = "fontEasy.ttf"
    else
        bgY = 30
        levelY = 234
        levelX = -15
        roleY = 65
        lightY = -50
        roundLightY = 50
        fontType = "fontCommon.TTF"
    end
    self.bg = display.newSprite("#resultBgPic.png",display.cx,display.cy+bgY)
    self:addChild(self.bg,2)   
    cc.ui.UILabel.new({
        UILabelType = 2,
        font = fontType,
        text = kkFunc.getVersionPrepareText("关卡数",LevelsData.getRealLevel(self.level)),
        size = 20,
        color = cc.c3b(255,255,255),
        x = self.bg:getContentSize().width/2+levelX,
        y = levelY,
    })
    :align(display.CENTER)
    :addTo(self.bg)
    self.bg:setScale(0)
    self.bg:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.ScaleTo:create(0.3,1.1),
        cc.ScaleTo:create(0.2,1),
    }))
    self.delay = self.delay + 0.5

    self.rolePic = display.newSprite("#resultWinHero"..g_playScene.hero.idx..".png",display.cx,display.cy-30)
    self:addChild(self.rolePic,1)
    --self.rolePic:setVisible(false)
    self.rolePic:setOpacity(0)
    if g_playScene.hero.idx == 3 then
        self.rolePic:setPosition(display.cx-15,display.cy-15)
    elseif g_playScene.hero.idx == 4 then
        self.rolePic:setPosition(display.cx-20,display.cy-30)
    end
    self.rolePic:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        --[[cc.CallFunc:create(function()
            self.rolePic:setVisible(true)
        end),]]
        cc.Spawn:create(
            cc.FadeIn:create(0.65),
            cc.EaseInOut:create(cc.MoveBy:create(0.2, cc.p(0,180)),0.65)
        ),
        --cc.EaseInOut:create(cc.MoveBy:create(0.2, cc.p(0,180)),0.65),
        cc.CallFunc:create(function()
            self:addParticle()
        end)        
    }))
    self.delay = self.delay + 0.2

    --角色背光
    self.roleLight = display.newSprite("#resultpurpleLight.png",display.cx,display.cy+lightY)
    self:addChild(self.roleLight)
    if VERSION_REDUCE then
        self.roleLight:setScale(2)
    end
    self.roleLight:setVisible(false)
    self.roleLight:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.CallFunc:create(function()
            self.roleLight:setVisible(true)
        end)
    }))
    --转圈的光
    self.roundLight = display.newSprite("#resultroundLight.png",display.cx,display.cy-roundLightY)
    self.roundLight:setScale(2.2)
    self:addChild(self.roundLight,-1)
    self.roundLight:runAction(cc.RepeatForever:create(cc.RotateBy:create(5,360)))
    self.roundLight:setVisible(false)
    self.roundLight:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.CallFunc:create(function()
            self.roundLight:setVisible(true)
        end)
    }))
end


function ResultLayer:starActions()
    if not VERSION_REDUCE then
        if self.starNum == 3 then
            self.starNum = self.starNum + 1
        end
    end
    self.lightStar = {}
    for i = 1, self.starNum do
        local lightStar
        if VERSION_REDUCE then
            lightStar = lightStarData[i]
        else
            lightStar = lightStarData2[i]
        end
        self.lightStar[i] = display.newSprite(lightStar.name,lightStar.beginX,lightStar.beginY)
        self.bg:addChild(self.lightStar[i],10)
        self.lightStar[i]:setOpacity(0)
        if self.lightStar[i] ~= nil then
            --[[self.lightStar[i]:runAction(transition.sequence({
                cc.DelayTime:create(self.delay+0.38*i),
                cc.ScaleTo:create(0.01,5),
                cc.Spawn:create(
                    cc.MoveTo:create(0.3,cc.p(lightStarData[i].x,lightStarData[i].y)),
                    cc.EaseExponentialIn:create(cc.ScaleTo:create(0.3,0.9))
                ),
                cc.CallFunc:create(function()
                    self.bg:runAction(transition.sequence({
                        cc.MoveBy:create(0.05,cc.p(0,-5)),
                        cc.MoveBy:create(0.05,cc.p(0,5)),
                    }))
                end)
            }))]]
            self.lightStar[i]:runAction(transition.sequence({
                cc.DelayTime:create(self.delay+0.35*i),
                cc.Spawn:create(
                    cc.MoveTo:create(0.1,cc.p(lightStar.x,lightStar.y)),
                    cc.FadeIn:create(0.1)
                ),
                cc.CallFunc:create(function()
                    local emitter2 = cc.ParticleSystemQuad:create("particle/resultStarParticle.plist")
                    emitter2:setBlendAdditive(true)
                    emitter2:setPosition(lightStar.x,lightStar.y+30)
                    self.bg:addChild(emitter2)
                    self.bg:runAction(transition.sequence({
                        cc.MoveBy:create(0.05,cc.p(0,-10)),
                        cc.MoveBy:create(0.05,cc.p(0,10)),
                    }))
                    --音效
                    SoundManager.playSound(GAME_SOUND.Star)
                end),
                cc.Spawn:create(
                    cc.MoveBy:create(0.1,cc.p(-20*(2-i),10)),
                    cc.ScaleTo:create(0.1,1.1)
                ),
                cc.Spawn:create(
                    cc.MoveBy:create(0.1,cc.p(20*(2-i),-10)),
                    cc.ScaleTo:create(0.1,0.9)
                )
            }))
        end
    end
    self.delay = self.delay + self.starNum*0.35
end

function ResultLayer:taskActions()
    if not g_playScene.task then return end
    self.GetTaskMoneyRecord = 0
    self.task = g_playScene.task.tasks
    self.taskbg = {} 
    local finishNum = 0 --本次新完成的任务数
    for i = 1 , #self.task do
        local task = self.task[i]
        if task.type == 1 or task.type == 2 or task.type == 6 or task.type == 10 or task.type == 11 then--炮塔
            self.taskbg[i] = display.newSprite("#taskTowerIcon"..task.towerIdx..".png")
        elseif task.type == 8 then--所有炮塔
            self.taskbg[i] = display.newSprite("#taskTowerIcon1.png")
        elseif task.type == 7 or task.type == 14 then--英雄
            self.taskbg[i] = display.newSprite("#taskHeroIcon"..g_playScene.hero.idx..".png")
        elseif task.type == 3 or task.type == 5 or task.type == 9 or task.type ==  12 or task.type ==  13 or task.type == 15 then--道具
            self.taskbg[i] = display.newSprite("#taskThingIcon.png")
        elseif task.type == 4 then--金钱
            self.taskbg[i] = display.newSprite("#taskMoneyIcon.png")
        end
        --self.taskbg[i] = display.newSprite("#"..TaskTypeData[self.task[i].type].pic2)
        self.taskbg[i]:setScale(0.5)
        self.taskbg[i]:setColor(cc.c3b(128,128,128))
        self.taskbg[i]:setPosition(180+(i-1)*55,120)
        self.bg:addChild(self.taskbg[i])

        if self.task[i].complete then
            if GameData.levelTask[""..self.level][""..i] then
                self.taskbg[i]:setColor(cc.c3b(255,255,255))
            else
                finishNum = finishNum + 1
                self.taskbg[i]:runAction(transition.sequence({
                    cc.DelayTime:create(self.delay + 0.3*finishNum),
                    cc.CallFunc:create(function()
                        self.taskbg[i]:setColor(cc.c3b(255,255,255))
                    end),                    
                }))
                local taskMoney = ExcelTaskReward[LevelsData.getRealLevel(self.level)][i]
                if GameData.selectHero == 3 then --第三英雄被动技能，钱多20%
                    taskMoney = math.floor(taskMoney*1.2)
                elseif GameData.selectHero == 4 then --第四英雄其中一个被动技能，钱多10%
                    taskMoney = math.floor(taskMoney*1.1)
                end
                GameData.carrot = GameData.carrot + taskMoney
                self.GetTaskMoneyRecord = self.GetTaskMoneyRecord + taskMoney
                --DataEye
                     --厦门
                -- if device.platform == "android" or device.platform == "ios" then
                --     DCCoin.gainInLevel("关卡过关任务奖励", "金币", self.GetTaskMoneyRecord, GameData.carrot, "第"..LevelsData.getRealLevel(self.level).."关")
                -- end
                     --厦门
            end
        end            
    end
    self.delay = self.delay + 0.3*finishNum+0.3
end

function ResultLayer:taskActionsNotOverseas()
    if not g_playScene.task then return end
    self.GetTaskMoneyRecord = 0
    self.task = g_playScene.task.tasks
    self.taskbg = {} 
    local finishNum = 0 --本次新完成的任务数
    for i = 1 , #self.task do
        if i ~= 4 then
            self.taskbg[i] = display.newSprite("#tasksBg.png",self.bg:getContentSize().width/2-15+(i-2)*180,85)
            self.bg:addChild(self.taskbg[i])
        end
        local task = self.task[i]
        local taskPic
        local taskX = 87
        local taskY = 157
        local taskScale = 1
        if task.type == 1 or task.type == 2 or task.type == 6 or task.type == 10 or task.type == 11 then--炮塔
            local taskPic = display.newSprite("#taskTowerIcon"..task.towerIdx..".png")
            taskPic:setScale(taskScale)
            taskPic:setPosition(taskX,taskY)
            self.taskbg[i]:addChild(taskPic)
        elseif task.type == 8 then--所有炮塔
            local taskPic = display.newSprite("#taskTowerIcon1.png")
            taskPic:setScale(taskScale)
            taskPic:setPosition(taskX,taskY)
            self.taskbg[i]:addChild(taskPic)
        elseif task.type == 7 or task.type == 14 then--英雄
            local taskPic = display.newSprite("#taskHeroIcon"..g_playScene.hero.idx..".png")
            taskPic:setScale(taskScale)
            taskPic:setPosition(taskX,taskY)
            self.taskbg[i]:addChild(taskPic)
        elseif task.type == 3 or task.type == 5 or task.type == 9 or task.type ==  12 or task.type ==  13 then--道具
            local taskPic = display.newSprite("#taskThingIcon.png")
            taskPic:setScale(taskScale)
            taskPic:setPosition(taskX,taskY)
            self.taskbg[i]:addChild(taskPic)
        elseif task.type == 4 then--金钱
            local taskPic = display.newSprite("#taskMoneyIcon.png")
            taskPic:setScale(taskScale)
            taskPic:setPosition(taskX,taskY)
            self.taskbg[i]:addChild(taskPic)
        elseif task.type == 15 and task.complete then
            self.handrance = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",
                text = "障碍全清",
                size = 28,
                color = cc.c3b(0,255,0),
                x = self.bg:getContentSize().width/2-15,
                y = 192,
            })
            :align(display.CENTER)
            self.bg:addChild(self.handrance)
        end
        --任务字显示
        self.taskData = TaskData[self.level]
        if i ~= 4 then
            local fontType
            if VERSION_REDUCE then
                fontType = "fontEasy.ttf"
            else
                fontType = "fontCommon.TTF"
            end
            local levelTask = cc.ui.UILabel.new({
                UILabelType = 2,
                font = fontType,
                text = g_playScene.task:getTaskText(self.taskData[i]),
                color = cc.c3b(255,255,255),
                dimensions = cc.size(120, 100),
                size = 18,
                x = 27,
                y = 118,
            }):align(display.LEFT_TOP)
            self.taskbg[i]:addChild(levelTask)
        end
        --  
        if i ~= 4 then--4为障碍全清
            if GameData.levelTask[""..self.level][""..i] then
                local hasFinish = display.newSprite("#hasFinishTask.png",self.taskbg[i]:getContentSize().width-20,50)
                self.taskbg[i]:addChild(hasFinish)
            end
        end
        local taskMoney = ExcelTaskReward[LevelsData.getRealLevel(self.level)][i]
        if GameData.selectHero == 3 then --第三英雄被动技能，钱多20%
            taskMoney = math.floor(taskMoney*1.2)
        elseif GameData.selectHero == 4 then --第四英雄其中一个被动技能，钱多10%
            taskMoney = math.floor(taskMoney*1.1)
        end
        if not GameData.levelTask[""..self.level]["gift"..i] and GameData.levelTask[""..self.level][""..i] then
            finishNum = finishNum + 1
            self:performWithDelay(function()
                local posTarget
                if i == 4 then
                    posTarget = self.handrance
                else
                    posTarget = self.taskbg[i]
                end
                kkFunc.ObtainEffect(self,self:convertToWorldSpace(cc.p(posTarget:getPositionX(),posTarget:getPositionY())),
                    self:convertToWorldSpace(cc.p(180,display.height-50)),0.5,nil,function ()
                        self.moneyLabel:setString(""..GameData.carrot)
                        GameData.levelTask[""..self.level]["gift"..i] = true
                    end
                )
            end, self.delay+0.1)  
            GameData.carrot = GameData.carrot + taskMoney  
            --self.GetTaskMoneyRecord = self.GetTaskMoneyRecord + taskMoney
        end
        --DataEye
             --厦门
        -- if device.platform == "android" or device.platform == "ios" then
        --     DCCoin.gainInLevel("关卡过关任务奖励", "金币", self.GetTaskMoneyRecord, GameData.carrot, "第"..LevelsData.getRealLevel(self.level).."关")
        -- end  
             --厦门         
    end
    self.delay = self.delay+ 0.67
end

function ResultLayer:moneyActions()
    if self.moneyBg == nil then
        self.moneyBg = display.newSprite("#resultMoneyBg.png",260, 65)
        self.bg:addChild(self.moneyBg)
        local fontType
        if VERSION_REDUCE then
            fontType = "fontEasy.ttf"
        else
            fontType = "fontCommon.TTF"
        end
        cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = kkFunc.getVersionPrepareText("结算胜利"),
            size = 20,
            color = cc.c3b(255,255,255),
            x = 130,
            y = 35,
        })
            :align(display.CENTER)
            :addTo(self.moneyBg)
        self.moneyLabel = cc.ui.UILabel.new({
            UILabelType = 2,
            font = fontType,
            text = ""..self.giftmoney,
            size = 20,
            color = cc.c3b(255,255,255),
            x = 211,
            y = 35,
        })
            :align(display.CENTER)
            :addTo(self.moneyBg)
        self.moneyBg:setVisible(false)
        self.moneyBg:runAction(transition.sequence({
            cc.DelayTime:create(self.delay),
            cc.CallFunc:create(function()
                self.moneyBg:setVisible(true)
            end)
        }))
        self.delay = self.delay + 0.3
    else
        self:performWithDelay(function()
            self.moneyLabel:setString(""..(self.giftmoney+self.GetTaskMoneyRecord))    
        end, self.delay)
        self.delay = self.delay + 0.3
    end
end
function ResultLayer:moneyActionsNotOverseas()
    if self.moneyBg == nil then
        self.moneyBg = display.newSprite("#resultMoneyBg.png",130, display.height-90)
        self:addChild(self.moneyBg)

        self.moneyLabel = cc.ui.UILabel.new({
                UILabelType = 2,
                font = "fontCommon.TTF",
                text = ""..GameData.carrot,
                size = 27,
                color = cc.c3b(255,255,255),
                x = 150,
                y = 35,
            })
            :align(display.CENTER)
            :addTo(self.moneyBg)
        self.moneyBg:runAction(transition.sequence({
            cc.DelayTime:create(self.delay),
            cc.CallFunc:create(function()
                self.moneyBg:setVisible(true)
            end)
        }))
        self.delay = self.delay + 0.3
    else
        local levelY = 380
        self:performWithDelay(function()
            GameData.carrot = GameData.carrot + self.giftmoney
            kkFunc.ObtainEffect(self,cc.p(display.cx,display.cy+20),
                self:convertToWorldSpace(cc.p(180,display.height-50)),0.5,nil,
                function ()
                    self.moneyLabel:setString(""..GameData.carrot)
                end
            )   
        end, self.delay)
        self.delay = self.delay + 0.3
    end
end
function ResultLayer:buttonActions()
    if VERSION_REDUCE then
        self.againButton = cc.ui.UIPushButton.new({
            normal = "#resultAgain.png",
        })
            :onButtonPressed(function()
                self.againButton:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.againButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                g_playScene:Restart()
            end)
            :pos(display.cx - 150, display.cy - 130)
            :addTo(self)
        self.continueButton = cc.ui.UIPushButton.new({
            normal = "#resultContinue.png",
        })
            :onButtonPressed(function()
                self.continueButton:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.continueButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                app:level({success = self.isWin})
            end)
            :pos(display.cx + 150, display.cy - 130)
            :addTo(self)
    else
        local leftPic,rightPic
        if self.isWin then
            leftPic = "#returnMapLevel.png" --返回按钮
            rightPic = "#resultContinue.png" --进入下一关按钮
        else
            leftPic = "#resultAgain.png" -- 不变
            if self:isPopSDK() then
                rightPic = "#resultHeroMaxLevel.png"--一键满级按钮
            else
                rightPic = "#comeToUpdate.png" --前往升级按钮
            end
        end
        self.againButton = cc.ui.UIPushButton.new({
            normal = leftPic,
        })
            :onButtonPressed(function()
                self.againButton:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.againButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                if self.isWin then
                    app:level({success = self.isWin})
                else
                    g_playScene:Restart()
                end
            end)
            :pos(display.cx - 150, display.cy - 130)
            :addTo(self)
        self.continueButton = cc.ui.UIPushButton.new({
            normal = rightPic,
        })
            :onButtonPressed(function()
                self.continueButton:setScale(1.05)
                --音效
                SoundManager.playSound(GAME_SOUND.Button2)
            end)
            :onButtonRelease(function()
                self.continueButton:setScale(1)
            end)
            :onButtonClicked(function(event)
                if (NEW_GUIDE and GameData.guide.teachLevel == true and GameData.guide.level1 == false)
                    or (NEW_GUIDE and GameData.guide.level1 == true and GameData.guide.herohouse == false)
                    or (NEW_GUIDE and GameData.guide.herohouse == true and GameData.guide.level2 == false)
                    or (NEW_GUIDE and GameData.guide.level2 == true and GameData.guide.level3 == false) 
                    or globalVar.levelOpenNew == false then
                    app:level({success = self.isWin})
                else
                    if self.isWin then
                        app:level({success = self.isWin,isNext = true})     
                    else
                        if self:isPopSDK() then
                            self:popSDK()
                        else
                            app:heroHouse()
                        end
                    end
                end
            end)
            :pos(display.cx + 150, display.cy - 130)
            :addTo(self)
        if not self.isWin then
            self.popLevelMapBtn = cc.ui.UIPushButton.new({
                normal = "#buttonCancel.png",
                disabled = "#buttonCancel.png",
                pressed = "#buttonCancel.png",
                })
                :onButtonPressed(function()
                    self.popLevelMapBtn:setScale(1.1)
                    --音效
                    SoundManager.playSound(GAME_SOUND.Button2)
                end)
                :onButtonRelease(function()
                    self.popLevelMapBtn:setScale(1)
                end)
                :onButtonClicked(function()
                    app:level({success = self.isWin,isNext = false})
                end)
                :pos(self.bg:getContentSize().width-15, self.bg:getContentSize().height/2+80)
                :addTo(self.bg)
            --加点
            if not self:isPopSDK() then
                if GameData.skillPoints.value >= 5 then --bbbbbb
                    if GameData.heros["h"..GameData.selectHero].level ~= HeroData[GameData.selectHero].maxLevel then
                        self.cuePoint = display.newSprite("#achievementTipPoint.png",58,22)
                        self.cuePoint:setScale(0.7)
                        self.continueButton:addChild(self.cuePoint)
                    end
                end 
            end
        end
    end
    --现在按钮动作
    local btnSubY = -100
    if not VERSION_REDUCE and self.isWin then
        btnSubY = -150
    end
    self.againButton:setOpacity(0)
    self.continueButton:setOpacity(0)
    transition.execute(self.againButton, transition.sequence({
            cc.Spawn:create(
                cc.FadeIn:create(0.1),
                cc.MoveBy:create(0.1,cc.p(0,btnSubY))
            ),
            cc.CallFunc:create(function()
                kkFunc.bubbleButton(self.againButton,true)
            end)
        }) , {delay = self.delay})--
    transition.execute(self.continueButton, transition.sequence({
            cc.Spawn:create(
                cc.FadeIn:create(0.1),
                cc.MoveBy:create(0.1,cc.p(0,btnSubY))
            ),
            cc.CallFunc:create(function()
                kkFunc.bubbleButton(self.continueButton,true)
            end)
        }) , {delay = self.delay+0.2})
end
function ResultLayer:isPopSDK()
    local dataEyeParamsSwitch = "true"--在模拟器上正常打开
    local firstPopLevel = 3
    local mustPopLevel = 11
         --厦门
    -- if device.platform == "android" then
    --     if MI_SERVICE then
    --         dataEyeParamsSwitch = DCConfigParams.getParamString("PopSdkSwitch_MI", "false")
    --     else
    --         dataEyeParamsSwitch = DCConfigParams.getParamString("PopSdkSwitch", "false")
    --     end
    --     firstPopLevel = DCConfigParams.getParamNumber("MaxLevelFirstPopLevel", 3)
    --     mustPopLevel = DCConfigParams.getParamNumber("MaxLevelMustPopLevel", 11)
    -- end  
         --厦门
    if dataEyeParamsSwitch == "true" then--dataeye参数开关
        if GameData.heros["h"..GameData.selectHero].level < HeroData[GameData.selectHero].maxLevel then
            if (LevelsData.getRealLevel(self.level) >= firstPopLevel and LevelsData.getRealLevel(self.level) < mustPopLevel and self.percent)
                or LevelsData.getRealLevel(self.level) >= mustPopLevel then
                return true
            else
                return false
            end
        else
            return false
        end
    end
    return false
end
function ResultLayer:popSDK()
    local function paycallback(result)
        if result == "success" then
            GameData.heros["h"..GameData.selectHero].level = HeroData[GameData.selectHero].maxLevel
            for i = 1,#HeroData[GameData.selectHero].skill do
                if GameData.heros["h"..GameData.selectHero].skill["s"..i] == 0 then   
                    GameData.heros["h"..GameData.selectHero].skill["s"..i] = 1     
                end
            end
            AchievementData.checkHeroUpgrade(GameData.selectHero)
            GameState.save(GameData)
            --DataEye
                 --厦门
            -- if device.platform == "android" or device.platform == "ios" then
            --     DCVirtualCurrency.paymentSuccess("","英雄满级",12,"CNY",CHANLE_NAME)
            -- end
                 --厦门
            kkFunc.popPaySuccessLayer(true)
        end
    end                      
    if TEST_DEMO then
        paycallback("success")
    else
        kkFunc.Pay(0,paycallback)
    end
end
function ResultLayer:Success()
    --DataEye
         --厦门
    -- if device.platform == "android" or device.platform == "ios" then
    --     local level = LevelsData.getRealLevel(self.level)
    --     if level < 10 then
    --         level = "0"..level
    --     end
    --     DCLevels.complete("第"..level.."关")
    -- end
         --厦门
    --数据处理
    self:dealWithSuccessData()
    --
    self.delay = 0 --统一延时计录。
    --结算背景动作
    self:resultBgActions()
    --星星动作
    self:starActions()

    --钱的处理
    if VERSION_REDUCE then
        self:moneyActions()
    else
        self:moneyActionsNotOverseas()
    end
    --任务处理
    if VERSION_REDUCE then
        self:taskActions()
    else
        self:taskActionsNotOverseas()
    end
    --钱的处理
    if VERSION_REDUCE then
        self:moneyActions()
    else
        self:moneyActionsNotOverseas()
    end

    --重来继续按钮
    self:buttonActions()

    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)

    --厦门 暗扣礼包
    -- if device.platform == "android" then
    --     local className = "org/cocos2dx/lua/PayTool"
    --     local method = 'getIndex'
    --     local args = nil
    --     local sig = "()I"
    --     local ok, t = luaj.callStaticMethod(className,method,args,sig)

    --     if t == 0 then
    --         self.newBag = GiftBagLayer.new(4)
    --         self:addChild(self.newBag,1000)

    --         self.newBag = GiftBagLayer.new(5)
    --         self:addChild(self.newBag,999)
    --     end
    -- else
    --         self.newBag = GiftBagLayer.new(4)
    --         self:addChild(self.newBag,1000)

    --         self.newBag = GiftBagLayer.new(5)
    --         self:addChild(self.newBag,999)
    -- end
    if ANKOU then
        self.newBag = GiftBagLayer.new(4)
        self:addChild(self.newBag,1000)

        self.newBag = GiftBagLayer.new(5)
        self:addChild(self.newBag,999)        
    end
end

function ResultLayer:resultFailBgActions()
    local grayBg = display.newColorLayer(cc.c4b(0,0,0,180))
    self:addChild(grayBg)
    grayBg:setScale(1.1)
    self.bg = display.newSprite("#resultFailPic.png",display.cx,display.cy-50)
    self:addChild(self.bg,2)
    local fontType
    if VERSION_REDUCE then
        fontType = "fontEasy.ttf"
    else
        fontType = "fontCommon.TTF"
    end
    cc.ui.UILabel.new({
        UILabelType = 2,
        font = fontType,
        text = kkFunc.getVersionPrepareText("关卡数",LevelsData.getRealLevel(self.level)),
        size = 20,
        color = cc.c3b(255,255,255),
        x = 265,
        y = 195,
    })
        :align(display.CENTER)
        :addTo(self.bg)
    self.bg:setScale(0)
    self.bg:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.ScaleTo:create(0.3,1.1),
        cc.ScaleTo:create(0.2,1),
    }))
    self.delay = self.delay + 0.5

    self.rolePic = display.newSprite("#resultFailHero"..g_playScene.hero.idx..".png",display.cx,display.cy-30)
    self:addChild(self.rolePic,1)
    self.rolePic:setVisible(false)
    if g_playScene.hero.idx == 1 then
        self.rolePic:setPosition(display.cx+30,display.cy-30)
    elseif g_playScene.hero.idx == 3 then
        self.rolePic:setPosition(display.cx-15,display.cy-30)
    elseif g_playScene.hero.idx == 4 then
        self.rolePic:setPosition(display.cx-20,display.cy-30)
    end
    self.rolePic:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.CallFunc:create(function()
            self.rolePic:setVisible(true)
        end),
        cc.EaseInOut:create(cc.MoveBy:create(0.2, cc.p(0,190)),0.65),        
    }))
    self.delay = self.delay + 0.2

    --角色背光
    self.roleLight = display.newSprite("#resultblueLight.png",display.cx,display.cy+20)
    self:addChild(self.roleLight)
    self.roleLight:setVisible(false)
    self.roleLight:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.CallFunc:create(function()
            self.roleLight:setVisible(true)
        end)
    }))
    self.delay = self.delay + 0.2
    self.tipBg = display.newScale9Sprite("#failTipBg.png",265,95,cc.size(225,80))
    self.bg:addChild(self.tipBg)
    self.tipBg:setOpacity(0)
    self.tiplight = display.newSprite("#failLight.png",20,53)
    self.tipBg:addChild(self.tiplight)
    self.tiplight:setScale(0.8)
    self.tiplight:setOpacity(0)
    if VERSION_REDUCE then
        self.tiplabel = cc.ui.UILabel.new({
            UILabelType = 2,
            text = kkFunc.getVersionPrepareText("结算失败"),
            size = 20,
            dimensions = cc.size(200, 150),
            font = "fontEasy.ttf",
            color = cc.c3b(255,255,255),
            x = 35,
            y = 68,
            }):align(display.LEFT_TOP)
    else
        self.tiplabel = cc.ui.UILabel.new({
            UILabelType = 2,
            font = "fontCommon.TTF",
            text = kkFunc.getVersionPrepareText("结算失败"),
            size = 22,
            color = cc.c3b(255,255,255),
            x = 10,
            y = 65,
            }):align(display.LEFT_TOP)
    end
    -- self.tiplabel = cc.ui.UILabel.new({
    --     text = kkFunc.getVersionPrepareText("结算失败"),
    --     size = 22,
    --     color = cc.c3b(255,255,255),
    --     x = 10,
    --     y = 65,
    --     }):align(display.LEFT_TOP)
    self.tipBg:addChild(self.tiplabel)
    self.tiplabel:setOpacity(0)
    self.tipBg:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.FadeIn:create(0.2)
    }))
    self.tiplabel:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.FadeIn:create(0.2)
    }))
    self.tiplight:runAction(transition.sequence({
        cc.DelayTime:create(self.delay),
        cc.FadeIn:create(0.2)
    }))
    self.delay = self.delay + 0.3
end

function ResultLayer:failTitleActions()
    self.failtitle = {}
    local titleSort = 0
    if VERSION_REDUCE then
        for i=1,2 do
            self.failtitle[i] = display.newSprite("#failEnglishTitle"..i..".png")
            if i == 1 then
                self.failtitle[i]:setPosition(150+(i-1)*75,250)
            else
                self.failtitle[i]:setPosition(300+(i-1)*75,250)
            end
            self.failtitle[i]:setScale(2.5)
            self.failtitle[i]:setOpacity(0)
            self.bg:addChild(self.failtitle[i])
            if i == 1 then
                titleSort = 2
            elseif i == 2 then
                titleSort = 3
            else
                titleSort = i
            end
            self.failtitle[i]:runAction(transition.sequence({
                cc.DelayTime:create(self.delay+0.25*titleSort),
                cc.Spawn:create(
                    cc.FadeIn:create(0.1),
                    cc.ScaleTo:create(0.1,1)
                ),
                cc.CallFunc:create(function()
                    self.bg:runAction(transition.sequence({
                        cc.MoveBy:create(0.05,cc.p(0,-10)),
                        cc.MoveBy:create(0.05,cc.p(0,10)),
                    }))
                end)
            }))
        end
    else
        for i=1,4 do
            self.failtitle[i] = display.newSprite("#failTitle"..i..".png")
            if i ==2 or i ==3 then
                self.failtitle[i]:setPosition(150+(i-1)*75,250)
            else
                self.failtitle[i]:setPosition(150+(i-1)*75,230)
            end
            self.failtitle[i]:setScale(2.5)
            self.failtitle[i]:setOpacity(0)
            self.bg:addChild(self.failtitle[i])
            if i == 3 then
                titleSort = 2
            elseif i == 2 then
                titleSort = 3
            else
                titleSort = i
            end        
            self.failtitle[i]:runAction(transition.sequence({
                cc.DelayTime:create(self.delay+0.25*titleSort),
                cc.Spawn:create(
                    cc.FadeIn:create(0.1),
                    cc.ScaleTo:create(0.1,1)
                ),
                cc.CallFunc:create(function()
                    self.bg:runAction(transition.sequence({
                        cc.MoveBy:create(0.05,cc.p(0,-10)),
                        cc.MoveBy:create(0.05,cc.p(0,10)),
                    }))
                end)
            }))
        end
    end
    self.delay = self.delay + 1.2
end
function ResultLayer:countPopMaxLevewlSdkPercent()
    local popPercent = 2
         --厦门
    -- if device.platform == "android" then
    --     popPercent = DCConfigParams.getParamNumber("MaxLevelPopPercent", 2)
    -- end
         --厦门
    local randomNum = math.random(0,100)
    if popPercent < 0 or popPercent > 100 then
        popPercent = 2
    end
    if randomNum <= popPercent then
        return true
    else
        return false
    end
end
function ResultLayer:Failure()
    if not VERSION_REDUCE then
        --一键满级SDK弹出频率
        self.percent = self:countPopMaxLevewlSdkPercent()
        --记录一下
        if g_playScene.mode == "attackCityMode" then
            GameData.failNumber["level"..self.level] =  GameData.failNumber["level"..self.level] + 1
            GameState.save(GameData)
        end
    end
    --DataEye
         --厦门
    -- if device.platform == "android" or device.platform == "ios" then
    --     local level = LevelsData.getRealLevel(self.level)
    --     if level < 10 then
    --         level = "0"..level
    --     end
    --     DCLevels.fail("第"..level.."关","守护点不足")
    -- end
         --厦门
    self.delay = 0 --统一延时计录。
    --结算背景动作
    self:resultFailBgActions()

    --标题处理
    self:failTitleActions()

    --重来继续按钮
    self:buttonActions()

    self.touchLayer:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self.touchLayer:setTouchEnabled(true)

    --厦门 暗扣礼包
    -- if device.platform == "android" then
    --     local className = "org/cocos2dx/lua/PayTool"
    --     local method = 'getIndex'
    --     local args = nil
    --     local sig = "()I"
    --     local ok, t = luaj.callStaticMethod(className,method,args,sig)

    --     if t == 0 then
    --         self.newBag = GiftBagLayer.new(4)
    --         self:addChild(self.newBag,1000)

    --         self.newBag = GiftBagLayer.new(5)
    --         self:addChild(self.newBag,999)
    --     end
    -- else
    --         self.newBag = GiftBagLayer.new(4)
    --         self:addChild(self.newBag,1000)

    --         self.newBag = GiftBagLayer.new(5)
    --         self:addChild(self.newBag,999)
    -- end
    if ANKOU then
        self.newBag = GiftBagLayer.new(4)
        self:addChild(self.newBag,1000)

        self.newBag = GiftBagLayer.new(5)
        self:addChild(self.newBag,999)        
    end    
end

function ResultLayer:refresh()
    if self.touchControl ~= nil then return end
    self.touchControl = true
    self.moneyLabel:stopAllActions()
    self:addParticle()
    --星星动作停止
    for i = 1, self.starNum do
        local lightStar
        if VERSION_REDUCE then
            lightStar = lightStarData[i]
        else
            lightStar = lightStarData2[i]
        end
        self.lightStar[i]:stopAllActions()
        self.lightStar[i]:setScale(0.9)
        self.lightStar[i]:setOpacity(255)
        self.lightStar[i]:setPosition(lightStar.x,lightStar.y)
    end
    --钱动作停止
    self.moneyBg:stopAllActions()
    self.moneyBg:setVisible(true)
    --任务动作停止
    if VERSION_REDUCE then
        for i =1,4 do
            if g_playScene.task and self.task[i].complete then
                self.taskbg[i]:stopAllActions()
                self.taskbg[i]:setColor(cc.c3b(255,255,255))
            end
        end
    end
    --按钮动作停止
    self.againButton:stopAllActions()
    self.continueButton:stopAllActions()
    if VERSION_REDUCE then
        self.againButton:setPosition(display.cx-150, display.cy-230)
        self.continueButton:setPosition(display.cx+150, display.cy-230)
        self.moneyLabel:setString(""..(self.giftmoney+self.GetTaskMoneyRecord))
    else
        self.againButton:setPosition(display.cx-150, display.cy-280)
        self.continueButton:setPosition(display.cx+150, display.cy-280)
        self.moneyLabel:setString(""..GameData.carrot)
    end
    
    self.againButton:setOpacity(255)
    self.continueButton:setOpacity(255)
    self.againButton:setScale(1)
    self.continueButton:setScale(1)
    if not VERSION_REDUCE then
        GameState.save(GameData)
    end
end

function ResultLayer:refresh2()
    if self.touchControl ~= nil then return end
    --TITLE动作停止
    if VERSION_REDUCE then
        for i=1,2 do
            self.failtitle[i]:stopAllActions()
            if i == 1 then
                self.failtitle[i]:setPosition(150+(i-1)*75,250)
            else
                self.failtitle[i]:setPosition(300+(i-1)*75,250)
            end
            self.failtitle[i]:setScale(1)
            self.failtitle[i]:setOpacity(255)
        end
    else
        for i=1,4 do
            self.failtitle[i]:stopAllActions()
            if i ==2 or i ==3 then
                self.failtitle[i]:setPosition(150+(i-1)*75,250)
            else
                self.failtitle[i]:setPosition(150+(i-1)*75,230)
            end
            self.failtitle[i]:setScale(1)
            self.failtitle[i]:setOpacity(255)
        end
    end
    --TIP动作停止
    self.touchControl = true
    self.tiplight:stopAllActions()
    self.tipBg:stopAllActions()
    self.tiplabel:stopAllActions()
    self.tiplight:setOpacity(255)
    self.tipBg:setOpacity(255)
    self.tiplabel:setOpacity(255)
    --按钮动作停止
    self.againButton:stopAllActions()
    self.continueButton:stopAllActions()
    self.againButton:setPosition(display.cx-150, display.cy-230)
    self.continueButton:setPosition(display.cx+150, display.cy-230)
    self.againButton:setOpacity(255)
    self.continueButton:setOpacity(255)
    self.againButton:setScale(1)
    self.continueButton:setScale(1)
end

function ResultLayer:onTouch(event, x, y)
    if event == "began" then
        if self.isWin == true then
            self:refresh()
        else
            self:refresh2()
        end
    end
end

function ResultLayer:onExit()
    ResData.removeRes("UI_RESULT")
end

return ResultLayer