--
-- Author: Wangzhihao
-- Date: 2015-01-07 11:17:57
--
local StarfishLayer = class("StarfishLayer", function()
    return display.newLayer()
end)
local STAR_MODE = nil
function StarfishLayer:ctor(mode)
	ResData.loadRes("UI_SEAWAVE")
	self:setNodeEventEnabled(true)
    g_playScene:changeSpeedNormal()
	self:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self:setTouchEnabled(true)    
    self:setTouchSwallowEnabled(true)
    self.touchStarfishNum = 0
    STAR_MODE = mode
    if STAR_MODE == 2 then
    	self:starfishOutTwo()
    else
	    self:starfishOut()
	end
    self:performWithDelay(function()
    	local lastStarfishNum = 0
    	for i=1,5 do
    		if self.starfish[i] ~= nil then
    			lastStarfishNum = lastStarfishNum + 1
	    		self.starfish[i]:runAction(transition.sequence({
	    			cc.DelayTime:create(0.5*(lastStarfishNum-1)),
					cc.Spawn:create(
						cc.MoveBy:create(0.5, cc.p(0,-self.starfish[i]:getPositionY()-250)),
						cc.RotateBy:create(0.5,360)
						),
					cc.CallFunc:create(function()
						self.starfish[i] = nil
			            self.touchStarfishNum = self.touchStarfishNum + 1
			            if self.touchStarfishNum == 5 then
    						g_playScene:changeSpeedUser()
			            	self:removeFromParent()
			            end
			        end),
				}))	
			end	
    	end		
	end, 10)
end
function StarfishLayer:starfishOut()
	self.starfish = {}
	local starfishX = {
		[1] = 100 - math.random(0,200),
		[2] = math.random(display.cx-100,display.cx+100),
		[3] = math.random(display.width-100,display.width+100),
		[4] = 200 - math.random(0,300),
		[5] = math.random(display.width-200,display.width+100),
	}
	local starfishY = {
		[1] = math.random(display.height+150,display.height+200),
		[2] = math.random(display.height+150,display.height+200),
		[3] = math.random(display.height+150,display.height+200),
		[4] = math.random(0,50)-200,
		[5] = math.random(0,50)-200,
	}
	local moveToX = {
		[1] = math.random(100,display.width/3),
		[2] = math.random(display.width/3,display.width*2/3),
		[3] = math.random(display.width*2/3,display.width-100),
		[4] = math.random(100,display.width/2),
		[5] = math.random(display.width/2,display.width-100),
	}
	local moveToY = {
		[1] = math.random(display.cy,display.height-80),
		[2] = math.random(display.cy,display.height-80),
		[3] = math.random(display.cy,display.height-80),
		[4] = math.random(100,display.cy-50),
		[5] = math.random(100,display.cy-50),
	}
	for i=1,5 do
		local idx = math.random(1,3)
		self.starfish[i] = display.newSprite("pic/starfish"..idx..".png",starfishX[i],starfishY[i])
		self:addChild(self.starfish[i])
		self.starfish[i]:runAction(transition.sequence({
			cc.DelayTime:create(0.1+0.7*(i-1)),
			cc.Spawn:create(
				cc.MoveTo:create(0.5, cc.p(moveToX[i],moveToY[i])),
				cc.RotateBy:create(0.5,360)
				),
			cc.ScaleTo:create(0.1,2),
        	cc.ScaleTo:create(0.05,1.5),
		}))		
	end
end
function StarfishLayer:starfishOutTwo()
	self.starfish = {}
	local sprite = display.newSprite("#seaWave1.png")
	sprite:setPosition(display.cx,display.cy)
	self:addChild(sprite,2)
	sprite:setScale(2)
	local frames = display.newFrames("seaWave%d.png", 1, 7)
    local animation = display.newAnimation(frames, 0.18)
    sprite:playAnimationOnce(animation,true)
    local moveToX = {
		[1] = math.random(100,display.width/3),
		[2] = math.random(display.width/3,display.width*2/3),
		[3] = math.random(display.width*2/3,display.width-100),
		[4] = math.random(100,display.width/2),
		[5] = math.random(display.width/2,display.width-100),
	}
	local moveToY = {
		[1] = math.random(display.cy,display.height-80),
		[2] = math.random(display.cy,display.height-80),
		[3] = math.random(display.cy,display.height-80),
		[4] = math.random(100,display.cy-50),
		[5] = math.random(100,display.cy-50),
	}
	for i=1,5 do
		self:performWithDelay(function()
			local idx = math.random(1,3)
			self.starfish[i] = display.newSprite("pic/starfish"..idx..".png",moveToX[i],moveToY[i])
			self:addChild(self.starfish[i])
		end,0.17)
	end
end
function StarfishLayer:onTouch(event,x,y)
	if event == "began" then		
		return true
	elseif event == "moved" then
	elseif event == "ended" then
		for i = 1,5 do
			if self.starfish[i] ~= nil then
	            local rect = cc.rect(self.starfish[i]:getPositionX()-110, self.starfish[i]:getPositionY()-110, 220, 220)
	            --local rect = self.heroBg[i]:getCascadeBoundingBox()
	            if cc.rectContainsPoint(rect, cc.p(x,y)) then
	            	self.starfish[i]:runAction(transition.sequence({
						cc.Spawn:create(
							cc.MoveBy:create(0.5, cc.p(0,-self.starfish[i]:getPositionY()-250)),
							cc.RotateBy:create(0.5,360)
							),
						cc.CallFunc:create(function()
							self.starfish[i] = nil
				            self.touchStarfishNum = self.touchStarfishNum + 1
				            if self.touchStarfishNum == 5 then
    							g_playScene:changeSpeedUser()
				            	self:removeFromParent()
				            end
				        end),
					}))
					return
	            end
	        end
        end
	end
end
function StarfishLayer:onExit()
    ResData.removeRes("UI_SEAWAVE")
end
return StarfishLayer