--
-- Author: Wangzhihao
-- Date: 2015-01-06 11:25:53
--
local StormLayer = class("StormLayer", function()
    return display.newLayer()
end)

function StormLayer:ctor()
    g_playScene:changeSpeedNormal()
	self:addNodeEventListener(cc.NODE_TOUCH_EVENT,function(event)
            return self:onTouch(event.name, event.x, event.y)
        end)
    self:setTouchEnabled(true)    
    self:setTouchSwallowEnabled(true)
	self.storm = display.newSprite("pic/sandStorm.png",0,display.cy)
	self.storm:setAnchorPoint(cc.p(1,0.5))
	self:addChild(self.storm)
	self.storm:setScale(2)
	self.speedX = (display.width+400)/5
    self.movedspeedX = 0
    self.beginTime = 0
	self.stop = false

	self.storm:runAction(transition.sequence({
		cc.MoveTo:create(2,cc.p(display.width+400,display.cy)),	
		cc.CallFunc:create(function()
			self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT,function(dt) 
		        self:update(dt) 
		    end)
			self:scheduleUpdate()
		end)
	}))	
	self:performWithDelay(function()
		self.storm:runAction(transition.sequence({
			cc.MoveTo:create(1.5,cc.p(0,display.cy)),	
			cc.CallFunc:create(function()
    			g_playScene:changeSpeedUser()
				self:removeFromParent()
			end)
		}))	 		
	end, 10)

    --提示语
    self.tip = g_playScene:getTip({type = "storm"})
    self:addChild(self.tip,1001)

    --提示手 首次显示
    self.tipFinger = g_playScene:getTipFinger({type = "storm"})
    if self.tipFinger then
        self:addChild(self.tipFinger,1001)
    end
end
function StormLayer:onTouch(event,x,y)
	if event == "began" then
		self.beginMoved = cc.p(x,y)
		self.beginTime = 0
		return true
	elseif event == "moved" then
	elseif event == "ended" then
		if x < self.beginMoved.x then
			self.movedspeedX = (x-self.beginMoved.x)/self.beginTime
			local num = math.abs(self.movedspeedX)/3000
			if math.abs(self.movedspeedX) > 3000 then
				self.movedspeedX = -3000
			end
			self.stop = false		
		end
	end
end

function StormLayer:update(dt)
	self.beginTime = self.beginTime + dt

	if self.stop then return end

	local px,py = self.storm:getPosition()

	self.movedspeedX = self.movedspeedX + 12000*dt
	if self.movedspeedX >= 0 then
		self.movedspeedX = 0
	end
	px = px + (self.speedX+self.movedspeedX) * dt
	self.storm:setPosition(px,py)

	if self.storm:getPositionX() >= display.width+400 then
		self.storm:setPositionX(display.width+400)
		self.stop = true
	elseif self.storm:getPositionX() < display.width/3 then
		self:back()
	end
end
function StormLayer:back()
    --移除提示
    self.tip:runAction(cc.FadeOut:create(1)) 
    --移除手
    if self.tipFinger then
        self.tipFinger:removeFromParent()
    end
	self:unscheduleUpdate()
    self:removeNodeEventListenersByEvent(cc.NODE_ENTER_FRAME_EVENT)
    self.storm:runAction(transition.sequence({
		cc.MoveTo:create(self.storm:getPositionX()/self.speedX,cc.p(0,display.cy)),	
		cc.CallFunc:create(function()
   			g_playScene:changeSpeedUser()
			self:removeFromParent()
		end)
	}))	
end

return StormLayer