--
-- Author: kk
-- Date: 2014-04-04 10:57:24
--

local MapInfo = import("..views.MapInfo")

TowerHorizontal = false
local BlockNum = 8
local BaseH = 65
local BaseW = 101
local TowerLayer = class("TowerLayer", function()
	local layer
    if TowerHorizontal then
	 	layer = display.newColorLayer(cc.c4b(100, 120, 140, 255))
    	--layer:setAnchorPoint(cc.p(0,0))
    	layer:setContentSize(cc.size(480, BaseH))
    else
    	layer = display.newNode()
    	layer:setContentSize(cc.size(BaseW, BaseH*BlockNum))
    end
    return layer
end)

function TowerLayer:ctor(towers, giftLevel)
	self.giftLevel = giftLevel
	self.preSelect = nil
	self.selectedTower = nil
	self.movedTower = nil
	if TowerHorizontal then
		self.rect = cc.rect(0,0,480,BaseH)
	else
		self.rect = cc.rect(0,0,BaseW*2, display.height)--不精确，较大
	end

	--可放置区用batchNode
	self.showBlankNode = display.newBatchNode("fight.png")
	self:addChild(self.showBlankNode)
	--捡到卡片有上限
	self.giftTowerNum = 0
	self.towerNum = 0
	self.tower = {}
	if not self.giftLevel then
		for i = 1, #towers do
			self:addTower(towers[i])
		end
	end
end

--不用。
function TowerLayer:initBrickBg()
	self.brickBg = display.newNode()
    local w = MapInfo.map:getMapSize().width
    local h = MapInfo.map:getMapSize().height
    local firstBlack = 1
    for i = 1, w do
    	firstBlack = 1 - firstBlack
    	local color = firstBlack
    	for j = 1, h do
    		color = 1 - color
    		local brick
    		if color == 1 then
    			brick = display.newColorLayer(cc.c4b(128,128,128,50))
    		else
    			brick = display.newColorLayer(cc.c4b(255,255,255,50))
    		end
    		brick:setPosition(cc.p((i-1.5)*MapInfo.tileSize,
    							(j-1.5)*MapInfo.tileSize))
    		brick:setContentSize(cc.size(MapInfo.tileSize,MapInfo.tileSize))
    		self.brickBg:addChild(brick)
    	end
    end
    local pt = MapInfo:getCenterOfTile(cc.p(0,h-1))
    self.brickBg:setPosition(pt)
	self:addChild(self.brickBg,-2)
    self.brickBg:setVisible(false)
end

function TowerLayer:getCardPosByIdx(idx)
	local x = BaseW*0.5
	local y = display.height-50-idx*BaseH
	return cc.p(x,y)
end

function TowerLayer:addTower(idx)
    if TowerHorizontal then
		local y = 40
		local x = (#self.tower+1)*90
		local sprite = display.newSprite("#"..TowersData[idx].showPic,x,y)
		sprite:setScale(1.2)
		self.tower[#self.tower+1] = {
			num = idx,
			cd = ExcelTowersData[idx].cd,
			enable = true,
			sprite = sprite
		}
		self:addChild(sprite, 10, 100+self.towerNum)
	else
		local card = display.newSprite()
		local p = self:getCardPosByIdx(#self.tower+1)
		card:setPosition(p)
		self:addChild(card, 9)
		local bg = display.newSprite("#towerCardBg.png")
		card:addChild(bg)
		local sprite = display.newSprite("#"..TowersData[idx].showPic)
		sprite:setAnchorPoint(cc.p(0.5,0.5))
		card:addChild(sprite)
		--非支线显示价格
		if not self.giftLevel then
			local money = cc.ui.UILabel.new({
				text = ExcelTowersData[idx].level[1].money,
				size = 15,
				color = display.COLOR_BLACK,
				x = -40,
				y = -20,
			})
			card:addChild(money)
		end
		self.tower[#self.tower+1] = {
			num = idx, 
			cd = ExcelTowersData[idx].cd,
			enable = true, 
			moneyEnable = true,
			sprite = card,
			rabbit = sprite,
		}

		if DEBUG_INFO then
			local idLabel = cc.ui.UILabel.new({
				text = "T"..idx,
				size = 15,
				color = display.COLOR_BLACK,
				x = 20,
				y = 15,
			})
			card:addChild(idLabel)
		end
	end
end

function TowerLayer:removeTowerCard(idx)
	local usedCard = self.tower[idx].sprite
	usedCard:removeFromParent()
	self.selectedTower = nil
	table.remove(self.tower, idx)
	for i = idx, #self.tower do
		local p = self:getCardPosByIdx(i)
		self.tower[i].sprite:runAction(cc.MoveTo:create(0.1, p))
	end
	self.giftTowerNum = self.giftTowerNum - 1
end

function TowerLayer:getObjRect(p, s)
	return cc.rect(p.x-s.width*0.5, p.y-s.height*0.5, s.width, s.height)
end

--等位置定好再写。
function TowerLayer:getTowerCardIdxByPos(x,y)

end

function TowerLayer:onTouch(event, x, y)
	if event == "began" then
        if NEW_GUIDE and GameData.guide.step < 48 then
            --隐藏指示
            if g_guidelayer then
                if  g_guidelayer.next:isVisible() then
                    g_guidelayer.next:setVisible(false)
                    g_guidelayer.clickMes:setVisible(false)
                    g_guidelayer.nextTwo:setVisible(true)
                    g_guidelayer.clickMesTwo:setVisible(true)
                else
                    g_guidelayer.next:setVisible(true)
                    g_guidelayer.clickMes:setVisible(true)
                    g_guidelayer.nextTwo:setVisible(false)
                    g_guidelayer.clickMesTwo:setVisible(false)
                end 
            end               
        end
		for i = 1, #self.tower do
			--[[
			local sx, sy = self.tower[i].sprite:getPosition()
			local size = self.tower[i].sprite:getContentSize()
			local rect = self:getObjRect(cc.p(sx,sy), size)
			--]]
			local rect = self.tower[i].sprite:getCascadeBoundingBox()
			--print(i,rect.origin.x,rect.origin.y, x, y)
			if cc.rectContainsPoint(rect, cc.p(x,y)) then
				if not self.tower[i].enable or not self.tower[i].moneyEnable then 
					return false
				end
				--选中再点就只去选。
				if i == self.selectedTower then
					self:selectTower(self.preSelect)
					self:ClearBlankArea()
					SoundManager.playSound(GAME_SOUND.TowerDeselect)
					return false
				end
				self.preSelect = i
				--按下就直接选中
				self:selectTower(self.preSelect)
				SoundManager.playSound(GAME_SOUND.TowerSelect)
				return true
			end
		end
		return false
	elseif event == "moved" then
		if self.preSelect == nil then return end
		--[[
		local sx, sy = self.tower[self.preSelect].sprite:getPosition()
		local size = self.tower[self.preSelect].sprite:getContentSize()
		local rect = self:getObjRect(cc.p(sx,sy), size)
		--]]
		local rect = self.tower[self.preSelect].sprite:getCascadeBoundingBox()
		if not cc.rectContainsPoint(rect, cc.p(x,y)) then
			--拖动时去选。
			--[[
			if self.selectedTower ~= nil then
				self:selectTower(self.selectedTower)
			end]]
			if self.movedTower == nil then
				self:addMovedTower()
			end
			self:snapMovedTower(x,y)
		else
			if self.movedTower ~= nil then
				self:clearMovedTower()
			end
		end
	elseif event == "ended" then
		if self.movedTower == nil then
			--self:selectTower(self.preSelect)
			return
		else
			self:clearMovedTower()
			--self:selectTower(self.selectedTower)
		end
	end

end

function TowerLayer:addMovedTower()
	--[[
	--拖动暂停
	self.oldPause = self:getParent().pause
	if not self.oldPause then
		self:getParent().pause = true
		self:suspendProgress()		
	end
	--]]
    local width = MapInfo.map:getTileSize().width
    local height = MapInfo.map:getTileSize().height
    self.banner1 = display.newPolygon({
    	[1] = {0,0},
    	[2] = {0,height},
    	[3] = {width*MapInfo.map:getMapSize().width, height},
    	[4] = {width*MapInfo.map:getMapSize().width,0}
    },
    {
		fillColor = cc.c4f(1,1,1,0.5),
        borderColor = cc.c4f(1,1,1,0.5)
    })
	g_fightLayer:addChild(self.banner1)
    self.banner2 = display.newPolygon({
    	[1] = {0,0},
    	[2] = {0,height*MapInfo.map:getMapSize().height},
    	[3] = {width, height*MapInfo.map:getMapSize().height},
    	[4] = {width,0}
    },
    {
		fillColor = cc.c4f(1,1,1,0.5),
        borderColor = cc.c4f(1,1,1,0.5)
    })
	g_fightLayer:addChild(self.banner2)

	if TowersData[self.tower[self.preSelect].num].blockTime ~= nil then
		self.movedTower = display.newSprite("#"..TowersData[self.tower[self.preSelect].num].pic)
		self.movedTower:setAnchorPoint(cc.p(0.5,0.2))
	else
		self.movedTower = display.newSprite("#"..TowersData[self.tower[self.preSelect].num].pic)
		self.movedTower:setAnchorPoint(cc.p(0.5,0.4))
	end
	self.movedTower:setOpacity(128)
	self.movedTower.towerIdx = self.tower[self.preSelect].num
	self.movedTower.leftRight = true
	g_fightLayer:addChild(self.movedTower)
end

function TowerLayer:clearMovedTower()
	--[[
	--拖动暂停
	if not self.oldPause then
		self:getParent().pause = false
		self:resumeProgress()
	end
	--]]
	self.movedTower:removeFromParent()
	self.movedTower = nil
	self.banner1:removeFromParent()
	self.banner2:removeFromParent()
end

function TowerLayer:snapMovedTower(x,y)
	local tilePt = MapInfo:getTilePositionInCCP(cc.p(x,y))
	--print(tilePt.x,tilePt.y)
	self.movedTower:setLocalZOrder(tilePt.y)
	local pt = MapInfo:getCenterOfTile(tilePt)
	self.movedTower:setPosition(pt)
    --self.movedTower:setVisible(false)
    self.banner1:setVisible(false)
    self.banner2:setVisible(false)
    self.movedTower:setColor(cc.c3b(255,0,0))

    self.movedTower.canBuild = false
    --在地图外
    if not MapInfo:isTilePtInMap(tilePt) then
    	return 
    end
	--已经有塔。
    local fort = self:getParent():getTileFort(tilePt)
    if fort ~= nil then
    	return
    end
    --能不能造塔
    local towerIdx = self.movedTower.towerIdx
    local canBuild,leftRight = self:getParent():canCreateFortOnTile(towerIdx, tilePt)
    if not canBuild then
    	return
    end

    --拦路兔
    if TowersData[towerIdx].blockTime ~= nil then
    	if self.movedTower.leftRight and not leftRight then
    		self.movedTower:setSpriteFrame(display.newSpriteFrame(TowersData[towerIdx].upDown.frame))
    		self.movedTower:setAnchorPoint(cc.p(0.5,0.3))
    		self.movedTower.leftRight = false
    		if self:getParent():getTileFort(cc.p(tilePt.x,tilePt.y-1)) ~= nil
    			or self:getParent():getTileFort(cc.p(tilePt.x,tilePt.y+1)) ~= nil then
    			return
    		end
    	elseif not self.movedTower.leftRight and leftRight then
    		self.movedTower:setSpriteFrame(display.newSpriteFrame(TowersData[towerIdx].leftRight.frame))
    		self.movedTower:setAnchorPoint(cc.p(0.5,0.2))
    		self.movedTower.leftRight = true
    		if self:getParent():getTileFort(cc.p(tilePt.x-1,tilePt.y)) ~= nil
    			or self:getParent():getTileFort(cc.p(tilePt.x+1,tilePt.y)) ~= nil then
    			return
    		end
    	end
    end

    self.movedTower.canBuild = true
    --self.movedTower:setVisible(true)
    self.banner1:setVisible(true)
    self.banner2:setVisible(true)
    self.movedTower:setColor(cc.c3b(255,255,255))

    local pt1 = MapInfo:getCenterOfTile(cc.p(0,tilePt.y))
    pt1.y = pt1.y - MapInfo.tileSize*0.5
    pt1.x = pt1.x - MapInfo.tileSize*0.5
    self.banner1:setPosition(pt1)
    local pt2 = MapInfo:getCenterOfTile(cc.p(tilePt.x,MapInfo.map:getMapSize().height-1))
    pt2.x = pt2.x - MapInfo.tileSize*0.5
    pt2.y = pt2.y - MapInfo.tileSize*0.5
    self.banner2:setPosition(pt2)

end

function TowerLayer:selectTower(idx)
	if self.selectedTower ~= nil then
		if idx ~= self.selectedTower then
			local x, y = self.tower[self.selectedTower].sprite:getPosition()
			self.tower[self.selectedTower].sprite:setPosition(cc.p(x-20,y))
			--self.tower[self.selectedTower].sprite:setScale(1)
			x, y = self.tower[idx].sprite:getPosition()
			self.tower[idx].sprite:setPosition(cc.p(x+20,y))
			--self.tower[idx].sprite:setScale(1.2)
			self.selectedTower = idx
			self:showBlankAreaOnce()
		else
			local x, y = self.tower[idx].sprite:getPosition()
			self.tower[idx].sprite:setPosition(cc.p(x-20,y))
			--self.tower[idx].sprite:setScale(1)
			self.selectedTower = nil
			--self:showBlankArea(false)
		end
	else
		local x, y = self.tower[idx].sprite:getPosition()
		self.tower[idx].sprite:setPosition(cc.p(x+20,y))
		--self.tower[idx].sprite:setScale(1.2)	
		self.selectedTower = idx
		--self:showBlankArea(true)
		self:showBlankAreaOnce()
	end
end

function TowerLayer:addBlankWhenThingRemove(tilePt)
	if self.blankArea == nil then return end
	--self:showBlankArea(false)
	--self:showBlankArea(true)
end

function TowerLayer:showBlankAreaBg()

end

function TowerLayer:showBlankAreaOnce()
	if self.blankArea ~= nil then
		for i = 1, #self.blankArea do
			if self.blankArea[i] ~= nil then
				self.blankArea[i]:removeFromParent()
			end
		end
		self.blankArea = nil
	end

	local road = TowersData[self.tower[self.selectedTower].num].onRoad
	self.blankArea = {}

	local c1,c2,r1,r2 = MapInfo:getMapForNumbers()
	for col = c1, c2 do
		for row = r1, r2 do
			local tilePt = cc.p(col,row)
			local fort = self:getParent():getTileFort(tilePt)
			local shouldShow = self:getParent():canCreateFortOnTile(self.tower[self.selectedTower].num,tilePt)
			--[[
			local shouldShow = false
			if not road and MapInfo:checkTileBlank(tilePt) 
					and self:getParent():getTileFort(tilePt) == nil then
				shouldShow = true
			elseif road and MapInfo:checkTileRoadValid(tilePt) 
					and self:getParent():getTileFort(tilePt) == nil then
				shouldShow = true
			end
			--]]
			if fort == nil and shouldShow then
				local pt = MapInfo:getCenterOfTile(tilePt)
				local blank = display.newSprite("#blankArea.png", pt.x, pt.y)
				self.blankArea[#self.blankArea+1] = blank
				self.showBlankNode:addChild(blank)
				blank:runAction(transition.sequence({
					cc.FadeIn:create(0.5),
					cc.DelayTime:create(0.5),
					cc.FadeOut:create(0.5),
					cc.CallFunc:create(function()
						blank:removeFromParent()
						self.blankArea[#self.blankArea] = nil
					end)
				}))
			end
        end
	end
end

function TowerLayer:ClearBlankArea()
	if self.blankArea ~= nil then
		for i = 1, #self.blankArea do
			self.blankArea[i]:removeFromParent()
		end
		self.blankArea = nil
	end
end

function TowerLayer:showBlankArea(b)
	if self.blankArea ~= nil then
		for i = 1, #self.blankArea do
			self.blankArea[i]:removeFromParent()
		end
		self.blankArea = nil
	end
	if not b then return end

	local road = TowersData[self.tower[self.selectedTower].num].onRoad
	self.blankArea = {}

	local c1,c2,r1,r2 = MapInfo:getMapForNumbers()
	for col = c1, c2 do
		for row = r1, r2 do
			local tilePt = cc.p(col,row)
			if not road and MapInfo:checkTileBlank(tilePt) 
					and self:getParent():getTileFort(tilePt) == nil then
				local pt = MapInfo:getCenterOfTile(tilePt)
				local blank = display.newSprite("#blankArea.png", pt.x, pt.y)
				self.blankArea[#self.blankArea+1] = blank
				self:addChild(blank)
				blank:runAction(cc.RepeatForever:create(cc.Blink:create(2, 1)))
			elseif road and MapInfo:checkTileRoadValid(tilePt) 
					and self:getParent():getTileFort(tilePt) == nil then
				local pt = MapInfo:getCenterOfTile(tilePt)
				local blank = display.newSprite("#blankArea.png", pt.x, pt.y)
				self.blankArea[#self.blankArea+1] = blank
				self:addChild(blank)
				blank:runAction(cc.RepeatForever:create(cc.Blink:create(2, 1)))
			end
        end
	end
end

function TowerLayer:createTower(idx)
	if not self.giftLevel then
		self:progressTower(idx)
	else
		self:removeTowerCard(idx)
	end
end

function TowerLayer:progressTower(idx)
	local proTo = cc.ProgressTo:create(self.tower[idx].cd, 100)
	--print(TowersData[self.tower[idx].num].showPic)
    self.tower[idx].progress = cc.ProgressTimer:create(display.newSprite("#"..TowersData[self.tower[idx].num].showPic))
    self.tower[idx].progress:setType(cc.PROGRESS_TIMER_TYPE_BAR)--kCCProgressTimerTypeRadial)
    self.tower[idx].progress:setMidpoint(cc.p(0.5,0))
    self.tower[idx].progress:setBarChangeRate(cc.p(0,1))
    local size = self.tower[idx].rabbit:getContentSize()
    self.tower[idx].progress:setPosition(cc.p(size.width*0.5,size.height*0.5))
    if not self.tower[idx].moneyEnable then
    	self.tower[idx].progress:setColor(cc.c3b(128,128,128))
    end
    if not self:getParent().pause then
	    local seq = transition.sequence({
			proTo,
	    	cc.CallFunc:create(function() 
    			if self.tower[idx].moneyEnable then
					self.tower[idx].rabbit:setColor(cc.c3b(255,255,255))
				else
					self.tower[idx].rabbit:setColor(cc.c3b(128,128,128))
				end
				self.tower[idx].enable = true
				self.tower[idx].progress:removeFromParent()
				self.tower[idx].progress = nil
			end)
	    })
	    self.tower[idx].progress:runAction(seq)
	end
    self.tower[idx].enable = false
	self.tower[idx].rabbit:setColor(cc.c3b(58,58,58))
	self.tower[idx].rabbit:addChild(self.tower[idx].progress,11)
end

function TowerLayer:suspendProgress()
	for i = 1, #self.tower do
		if self.tower[i].progress ~= nil then
			self.tower[i].progress:stopAllActions()
		end
	end
end

function TowerLayer:resume()
	if not self.giftLevel then
		self:resumeProgress()
	else

	end
end

function TowerLayer:resumeProgress()
	for i = 1, #self.tower do
		if self.tower[i].progress ~= nil then
			local pcent = self.tower[i].progress:getPercentage()
			local t = self.tower[i].cd*(100-pcent)/100
			local proTo = cc.ProgressTo:create(t, 100)
			local seq = transition.sequence({
				proTo,
    			cc.CallFunc:create(function() 
	    			if self.tower[i].moneyEnable then
						self.tower[i].rabbit:setColor(cc.c3b(255,255,255))
					else
						self.tower[i].rabbit:setColor(cc.c3b(128,128,128))
					end
					self.tower[i].enable = true
					self.tower[i].progress:removeFromParent()
					self.tower[i].progress = nil
				end)
    		})
    		self.tower[i].progress:runAction(seq)
		end
	end
end

function TowerLayer:changeMoney(money)
	if self.giftLevel then return end
	for i = 1, #self.tower do
		if ExcelTowersData[self.tower[i].num].level[1].money <= money then
			self.tower[i].moneyEnable = true
			if self.tower[i].enable then
				self.tower[i].rabbit:setColor(cc.c3b(255,255,255))
			else
    			self.tower[i].progress:setColor(cc.c3b(255,255,255))
			end
		else
			self.tower[i].moneyEnable = false
			if self.tower[i].enable then
				self.tower[i].rabbit:setColor(cc.c3b(128,128,128))
			else
    			self.tower[i].progress:setColor(cc.c3b(128,128,128))
			end
		end
	end
end

return TowerLayer
