--
-- Author: KK
-- Date: 2014-07-18 10:13:56
--

local WaveProgress = class("WaveProgress", function()
    return display.newNode()
end)

function WaveProgress:ctor(time, callback)
	self.callback = callback
	self.time = time

	self.progress = cc.ProgressTimer:create(display.newSprite("#money-2.png"))
    self.progress:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
	self.progress:setReverseDirection(true)
    self.progress:setPercentage(99.9)
	self:addChild(self.progress)

	local proTo = cc.ProgressTo:create(self.time, 0)
    local seq = transition.sequence({
    	proTo,
    	cc.CallFunc:create(function() 
    		self.callback()
    		self:getParent().waveProgress = nil
    		self:removeFromParent()
		end)
    })
	self.progress:runAction(seq)
end

function WaveProgress:suspend()
	self.progress:stopAllActions()
end

function WaveProgress:resume()
	local pcent = self.progress:getPercentage()
	local t = self.time*pcent/100
	local proTo = cc.ProgressTo:create(t, 0)
	local seq = transition.sequence({
		proTo,
		cc.CallFunc:create(function() 
    		self.callback()
    		self:getParent().waveProgress = nil
    		self:removeFromParent()
		end)
	})
	self.progress:runAction(seq)
end

function WaveProgress:onTouch(x,y)
	local rect = self.progress:getCascadeBoundingBox()
	if not cc.rectContainsPoint(rect, cc.p(x,y)) then
		return false
	end
	
	local pcent = self.progress:getPercentage()
	local t = self.time*pcent/100

	self.callback()
	self:getParent().waveProgress = nil
	self:removeFromParent()
	return true
end
return WaveProgress