--
-- Author: KK
-- Date: 2014-06-20 17:05:36
--

CCLuaLoadChunksFromZIP("res/framework_precompiled.zip")
require("config")
require("framework.init")

local path = device.writablePath.."upd/"
local list_filename = "flist.txt"
local curListFile = path..list_filename 

local function hex(s)
 	s=string.gsub(s,"(.)",function (x) return string.format("%02X",string.byte(x)) end)
 	return s
end

local function readFile(path)
    local file = io.open(path, "rb")
    if file then
        local content = file:read("*all")
        io.close(file)
        return content
    end
    return nil
end

local function removeFile(path)
    --CCLuaLog("removeFile: "..path)
    io.writefile(path, "")
    if device.platform == "windows" then
        --os.execute("del " .. string.gsub(path, '/', '\\'))
    else
        os.execute("rm " .. path)
    end
end

local function checkFile(fileName, cryptoCode)
    print("checkFile:", fileName)
    print("cryptoCode:", cryptoCode)

    if not io.exists(fileName) then
        return false
    end

    local data=readFile(fileName)
    if data==nil then
        return false
    end

    if cryptoCode==nil then
        return true
    end

    local ms = crypto.md5(hex(data))
    print("file cryptoCode:", ms)
    if ms==cryptoCode then
        return true
    end

    return false
end


local fileList = nil
if io.exists(curListFile) then
	fileList = dofile(curListFile)
end
if fileList==nil then
	fileList = {
		ver = "1.0.0",
		stage = {},
		remove = {},
	}
end

if fileList and fileList.stage then
    local checkOK = true
    for i,v in ipairs(fileList.stage) do
        if not checkFile(path..v.name, v.code) then
            CCLuaLog("----------------------------------------Check Files Error")
            checkOK = false
            break
        end
    end

    if checkOK then
        for i,v in ipairs(fileList.stage) do
            if v.act=="load" then
                CCLuaLoadChunksFromZIP(path..v.name)
            end
        end
        for i,v in ipairs(fileList.remove) do
            removeFile(path..v)
        end
    else
        removeFile(curListFile)
    end
end

require("appentry")